/*!
 * alphaTab v1.5.0 (, build 18)
 *
 * Copyright © 2025, Daniel Kuschny and Contributors, All rights reserved.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * Integrated Libraries:
 *
 * Library: TinySoundFont
 * License: MIT
 * Copyright: Copyright (C) 2017, 2018 Bernhard Schelling
 * URL: https://github.com/schellingb/TinySoundFont
 * Purpose: SoundFont loading and Audio Synthesis
 *
 * Library: SFZero
 * License: MIT
 * Copyright: Copyright (C) 2012 Steve Folta ()
 * URL: https://github.com/stevefolta/SFZero
 * Purpose: TinySoundFont is based on SFZEro
 *
 * Library: Haxe Standard Library
 * License: MIT
 * Copyright: Copyright (C)2005-2025 Haxe Foundation
 * URL: https://github.com/HaxeFoundation/haxe/tree/development/std
 * Purpose: XML Parser & Zip Inflate Algorithm
 *
 * Library: SharpZipLib
 * License: MIT
 * Copyright: Copyright © 2000-2018 SharpZipLib Contributors
 * URL: https://github.com/icsharpcode/SharpZipLib
 * Purpose: Zip Deflate Algorithm for writing compressed Zips
 *
 * Library: NVorbis
 * License: MIT
 * Copyright: Copyright (c) 2020 Andrew Ward
 * URL: https://github.com/NVorbis/NVorbis
 * Purpose: Vorbis Stream Decoding
 *
 * Library: libvorbis
 * License: BSD-3-Clause
 * Copyright: Copyright (c) 2002-2020 Xiph.org Foundation
 * URL: https://github.com/xiph/vorbis
 * Purpose: NVorbis adopted some code from libvorbis.
 *
 * @preserve
 * @license
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports):"function"==typeof define&&define.amd?define(["exports"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).alphaTab={})}(this,(function(e){"use strict";var t,s,i,a,r,n,o,h,l,c,d,u,p,g,m,f,y,b,S,_,w,B,k,T,N,x,v,P,F,C,E,D,M,L,A,I;void 0===Symbol.dispose&&(Symbol.dispose=Symbol("Symbol.dispose")),e.LayoutMode=void 0,(t=e.LayoutMode||(e.LayoutMode={}))[t.Page=0]="Page",t[t.Horizontal=1]="Horizontal",e.StaveProfile=void 0,(s=e.StaveProfile||(e.StaveProfile={}))[s.Default=0]="Default",s[s.ScoreTab=1]="ScoreTab",s[s.Score=2]="Score",s[s.Tab=3]="Tab",s[s.TabMixed=4]="TabMixed";class R{static getValue(e){return R._values||(R._values=new Map),e=e.toLowerCase().replaceAll(" ",""),R._values.has(e)?R._values.get(e):0}static isPiano(e){return e<=7||e>=16&&e<=23}static isGuitar(e){return e>=24&&e<=39||105===e||43===e}}R._values=new Map([["acousticgrandpiano",0],["brightacousticpiano",1],["electricgrandpiano",2],["honkytonkpiano",3],["electricpiano1",4],["electricpiano2",5],["harpsichord",6],["clavinet",7],["celesta",8],["glockenspiel",9],["musicbox",10],["vibraphone",11],["marimba",12],["xylophone",13],["tubularbells",14],["dulcimer",15],["drawbarorgan",16],["percussiveorgan",17],["rockorgan",18],["churchorgan",19],["reedorgan",20],["accordion",21],["harmonica",22],["tangoaccordion",23],["acousticguitarnylon",24],["acousticguitarsteel",25],["electricguitarjazz",26],["electricguitarclean",27],["electricguitarmuted",28],["overdrivenguitar",29],["distortionguitar",30],["guitarharmonics",31],["acousticbass",32],["electricbassfinger",33],["electricbasspick",34],["fretlessbass",35],["slapbass1",36],["slapbass2",37],["synthbass1",38],["synthbass2",39],["violin",40],["viola",41],["cello",42],["contrabass",43],["tremolostrings",44],["pizzicatostrings",45],["orchestralharp",46],["timpani",47],["stringensemble1",48],["stringensemble2",49],["synthstrings1",50],["synthstrings2",51],["choiraahs",52],["voiceoohs",53],["synthvoice",54],["orchestrahit",55],["trumpet",56],["trombone",57],["tuba",58],["mutedtrumpet",59],["frenchhorn",60],["brasssection",61],["synthbrass1",62],["synthbrass2",63],["sopranosax",64],["altosax",65],["tenorsax",66],["baritonesax",67],["oboe",68],["englishhorn",69],["bassoon",70],["clarinet",71],["piccolo",72],["flute",73],["recorder",74],["panflute",75],["blownbottle",76],["shakuhachi",77],["whistle",78],["ocarina",79],["lead1square",80],["lead2sawtooth",81],["lead3calliope",82],["lead4chiff",83],["lead5charang",84],["lead6voice",85],["lead7fifths",86],["lead8bassandlead",87],["pad1newage",88],["pad2warm",89],["pad3polysynth",90],["pad4choir",91],["pad5bowed",92],["pad6metallic",93],["pad7halo",94],["pad8sweep",95],["fx1rain",96],["fx2soundtrack",97],["fx3crystal",98],["fx4atmosphere",99],["fx5brightness",100],["fx6goblins",101],["fx7echoes",102],["fx8scifi",103],["sitar",104],["banjo",105],["shamisen",106],["koto",107],["kalimba",108],["bagpipe",109],["fiddle",110],["shanai",111],["tinklebell",112],["agogo",113],["steeldrums",114],["woodblock",115],["taikodrum",116],["melodictom",117],["synthdrum",118],["reversecymbal",119],["guitarfretnoise",120],["breathnoise",121],["seashore",122],["birdtweet",123],["telephonering",124],["helicopter",125],["applause",126],["gunshot",127]]),function(e){e[e.NoBrackets=0]="NoBrackets",e[e.GroupStaves=1]="GroupStaves",e[e.GroupSimilarInstruments=2]="GroupSimilarInstruments"}(i||(i={})),function(e){e[e.Hidden=0]="Hidden",e[e.FirstSystem=1]="FirstSystem",e[e.AllSystems=2]="AllSystems"}(a||(a={})),function(e){e[e.FullName=0]="FullName",e[e.ShortName=1]="ShortName"}(r||(r={})),function(e){e[e.Horizontal=0]="Horizontal",e[e.Vertical=1]="Vertical"}(n||(n={}));class O{constructor(){this.hideDynamics=!1,this.bracketExtendMode=i.GroupStaves,this.useSystemSignSeparator=!1,this.globalDisplayTuning=!0,this.perTrackDisplayTuning=null,this.globalDisplayChordDiagramsOnTop=!0,this.perTrackChordDiagramsOnTop=null,this.singleTrackTrackNamePolicy=a.FirstSystem,this.multiTrackTrackNamePolicy=a.FirstSystem,this.firstSystemTrackNameMode=r.ShortName,this.otherSystemsTrackNameMode=r.ShortName,this.firstSystemTrackNameOrientation=n.Vertical,this.otherSystemsTrackNameOrientation=n.Vertical,this.multiTrackMultiBarRest=!1,this.perTrackMultiBarRest=null}}class H{constructor(){this.masterBars=[],this.opening=null,this.closings=[],this.isClosed=!1}get openings(){const e=this.opening;return e?[e]:[]}get isOpened(){return!0===this.opening?.isRepeatStart}addMasterBar(e){null===this.opening&&(this.opening=e),this.masterBars.push(e),e.repeatGroup=this,e.isRepeatEnd&&(this.closings.push(e),this.isClosed=!0)}}class W{constructor(){this.colors=new Map}}!function(e){e[e.Neutral=0]="Neutral",e[e.C3=1]="C3",e[e.C4=2]="C4",e[e.F4=3]="F4",e[e.G2=4]="G2"}(o||(o={})),function(e){e[e._15ma=0]="_15ma",e[e._8va=1]="_8va",e[e.Regular=2]="Regular",e[e._8vb=3]="_8vb",e[e._15mb=4]="_15mb"}(h||(h={})),function(e){e[e.None=0]="None",e[e.Simple=1]="Simple",e[e.FirstOfDouble=2]="FirstOfDouble",e[e.SecondOfDouble=3]="SecondOfDouble"}(l||(l={})),function(e){e[e.Cb=-7]="Cb",e[e.Gb=-6]="Gb",e[e.Db=-5]="Db",e[e.Ab=-4]="Ab",e[e.Eb=-3]="Eb",e[e.Bb=-2]="Bb",e[e.F=-1]="F",e[e.C=0]="C",e[e.G=1]="G",e[e.D=2]="D",e[e.A=3]="A",e[e.E=4]="E",e[e.B=5]="B",e[e.FSharp=6]="FSharp",e[e.CSharp=7]="CSharp"}(c||(c={})),function(e){e[e.Major=0]="Major",e[e.Minor=1]="Minor"}(d||(d={})),function(e){e[e.Down=0]="Down",e[e.Hold=1]="Hold",e[e.Up=2]="Up"}(u||(u={}));class V{constructor(){this.ratioPosition=0,this.pedalType=u.Down,this.nextPedalMarker=null,this.previousPedalMarker=null}}!function(e){e[e.StandardNotationRepeats=0]="StandardNotationRepeats",e[e.GuitarTabsRepeats=1]="GuitarTabsRepeats",e[e.SlashRepeats=2]="SlashRepeats",e[e.NumberedRepeats=3]="NumberedRepeats",e[e.StandardNotationBarNumber=4]="StandardNotationBarNumber",e[e.GuitarTabsBarNumber=5]="GuitarTabsBarNumber",e[e.SlashBarNumber=6]="SlashBarNumber",e[e.NumberedBarNumber=7]="NumberedBarNumber",e[e.StandardNotationBarLines=8]="StandardNotationBarLines",e[e.GuitarTabsBarLines=9]="GuitarTabsBarLines",e[e.SlashBarLines=10]="SlashBarLines",e[e.NumberedBarLines=11]="NumberedBarLines",e[e.StandardNotationClef=12]="StandardNotationClef",e[e.GuitarTabsClef=13]="GuitarTabsClef",e[e.StandardNotationKeySignature=14]="StandardNotationKeySignature",e[e.NumberedKeySignature=15]="NumberedKeySignature",e[e.StandardNotationTimeSignature=16]="StandardNotationTimeSignature",e[e.GuitarTabsTimeSignature=17]="GuitarTabsTimeSignature",e[e.SlashTimeSignature=18]="SlashTimeSignature",e[e.NumberedTimeSignature=19]="NumberedTimeSignature",e[e.StandardNotationStaffLine=20]="StandardNotationStaffLine",e[e.GuitarTabsStaffLine=21]="GuitarTabsStaffLine",e[e.SlashStaffLine=22]="SlashStaffLine",e[e.NumberedStaffLine=23]="NumberedStaffLine"}(p||(p={}));class G extends W{}!function(e){e[e.Automatic=0]="Automatic",e[e.Dashed=1]="Dashed",e[e.Dotted=2]="Dotted",e[e.Heavy=3]="Heavy",e[e.HeavyHeavy=4]="HeavyHeavy",e[e.HeavyLight=5]="HeavyLight",e[e.LightHeavy=6]="LightHeavy",e[e.LightLight=7]="LightLight",e[e.None=8]="None",e[e.Regular=9]="Regular",e[e.Short=10]="Short",e[e.Tick=11]="Tick"}(g||(g={}));class z{constructor(){this.id=z._globalBarId++,this.index=0,this.nextBar=null,this.previousBar=null,this.clef=o.G2,this.clefOttava=h.Regular,this.voices=[],this.simileMark=l.None,this.isMultiVoice=!1,this.displayScale=1,this.displayWidth=-1,this.sustainPedals=[],this._isEmpty=!0,this._isRestOnly=!0,this.barLineLeft=g.Automatic,this.barLineRight=g.Automatic,this.keySignature=c.C,this.keySignatureType=d.Major}static resetIds(){z._globalBarId=0}get masterBar(){return this.staff.track.score.masterBars[this.index]}get isEmpty(){return this._isEmpty}get isRestOnly(){return this._isRestOnly}getActualBarLineLeft(e){return z.actualBarLine(this,!1,e)}getActualBarLineRight(){return z.actualBarLine(this,!0,!1)}static automaticToActualType(e,t,s){let i;return i=t?e.isRepeatEnd?g.LightHeavy:e.nextMasterBar?e.isFreeTime?g.Dashed:e.isDoubleBar?g.LightLight:g.Regular:g.LightHeavy:e.isRepeatStart?g.HeavyLight:s?g.Regular:g.None,i}static actualBarLine(e,t,s){const i=e.masterBar,a=t?e.barLineRight:e.barLineLeft;let r;return r=a===g.Automatic?z.automaticToActualType(i,t,s):a,r}addVoice(e){e.bar=this,e.index=this.voices.length,this.voices.push(e)}finish(e,t=null){this.isMultiVoice=!1,this._isEmpty=!0,this._isRestOnly=!0;for(let s=0,i=this.voices.length;s<i;s++){const i=this.voices[s];i.finish(e,t),s>0&&!i.isEmpty&&(this.isMultiVoice=!0),i.isEmpty||(this._isEmpty=!1),i.isRestOnly||(this._isRestOnly=!1)}const s=this.sustainPedals;if(s.length>0){let e=null;this.sustainPedals=[],this.previousBar&&this.previousBar.sustainPedals.length>0&&(e=this.previousBar.sustainPedals[this.previousBar.sustainPedals.length-1]);const t=null!==e&&e.pedalType!==u.Up;for(const i of s){if(e&&e.pedalType!==u.Up){if(e.bar===this&&i.ratioPosition<=e.ratioPosition)continue;e.nextPedalMarker=i,i.previousPedalMarker=e}t&&i.pedalType===u.Down&&(i.pedalType=u.Hold),i.bar=this,this.sustainPedals.push(i),e=i}}else if(this.previousBar&&this.previousBar.sustainPedals.length>0){const e=this.previousBar.sustainPedals[this.previousBar.sustainPedals.length-1];if(e.pedalType!==u.Up){const t=new V;t.ratioPosition=0,t.bar=this,t.pedalType=u.Hold,this.sustainPedals.push(t),e.nextPedalMarker=t,t.previousPedalMarker=e}}}calculateDuration(){let e=0;for(const t of this.voices){const s=t.calculateDuration();s>e&&(e=s)}return e}}z._globalBarId=0,function(e){e[e.PPP=0]="PPP",e[e.PP=1]="PP",e[e.P=2]="P",e[e.MP=3]="MP",e[e.MF=4]="MF",e[e.F=5]="F",e[e.FF=6]="FF",e[e.FFF=7]="FFF",e[e.PPPP=8]="PPPP",e[e.PPPPP=9]="PPPPP",e[e.PPPPPP=10]="PPPPPP",e[e.FFFF=11]="FFFF",e[e.FFFFF=12]="FFFFF",e[e.FFFFFF=13]="FFFFFF",e[e.SF=14]="SF",e[e.SFP=15]="SFP",e[e.SFPP=16]="SFPP",e[e.FP=17]="FP",e[e.RF=18]="RF",e[e.RFZ=19]="RFZ",e[e.SFZ=20]="SFZ",e[e.SFFZ=21]="SFFZ",e[e.FZ=22]="FZ",e[e.N=23]="N",e[e.PF=24]="PF",e[e.SFZP=25]="SFZP"}(m||(m={}));class U{static ticksToMillis(e,t){return e*(6e4/(t*U.QuarterTime))|0}static millisToTicks(e,t){return e/(6e4/(t*U.QuarterTime))|0}static toTicks(e){return U.valueToTicks(e)}static valueToTicks(e){let t=e;return t<0&&(t=1/-t),U.QuarterTime*(4/t)|0}static applyDot(e,t){return t?e+3*(e/4|0):e+(e/2|0)}static applyTuplet(e,t,s){return e*s/t|0}static removeTuplet(e,t,s){return e*t/s|0}static dynamicToVelocity(e,t=0){let s=1;switch(e){case m.PPP:s=U.MinVelocity+0*U.VelocityIncrement;break;case m.PP:s=U.MinVelocity+1*U.VelocityIncrement;break;case m.P:s=U.MinVelocity+2*U.VelocityIncrement;break;case m.MP:s=U.MinVelocity+3*U.VelocityIncrement;break;case m.MF:s=U.MinVelocity+4*U.VelocityIncrement;break;case m.F:s=U.MinVelocity+5*U.VelocityIncrement;break;case m.FF:s=U.MinVelocity+6*U.VelocityIncrement;break;case m.FFF:s=U.MinVelocity+7*U.VelocityIncrement;break;case m.PPPP:s=10;break;case m.PPPPP:s=5;break;case m.PPPPPP:s=3;break;case m.FFFF:s=U.MinVelocity+8*U.VelocityIncrement;break;case m.FFFFF:s=U.MinVelocity+9*U.VelocityIncrement;break;case m.FFFFFF:s=U.MinVelocity+10*U.VelocityIncrement;break;case m.SF:case m.SFP:case m.SFZP:case m.SFPP:case m.SFZ:case m.FZ:s=U.MinVelocity+6*U.VelocityIncrement;break;case m.FP:case m.RF:case m.RFZ:case m.SFFZ:s=U.MinVelocity+5*U.VelocityIncrement;break;case m.N:s=1;break;case m.PF:s=U.MinVelocity+(4.5*U.VelocityIncrement|0)}return s+=t*U.VelocityIncrement,Math.min(Math.max(s,1),127)}}U.QuarterTime=960,U.MinVelocity=15,U.VelocityIncrement=16,function(e){e[e.Tempo=0]="Tempo",e[e.Volume=1]="Volume",e[e.Instrument=2]="Instrument",e[e.Balance=3]="Balance"}(f||(f={}));class X{constructor(){this.isLinear=!1,this.type=f.Tempo,this.value=0,this.ratioPosition=0,this.text=""}static buildTempoAutomation(e,t,s,i){(i<1||i>5)&&(i=2);const a=new Float32Array([1,.5,1,1.5,2,3]),r=new X;return r.type=f.Tempo,r.isLinear=e,r.ratioPosition=t,r.value=s*a[i],r}static buildInstrumentAutomation(e,t,s){const i=new X;return i.type=f.Instrument,i.isLinear=e,i.ratioPosition=t,i.value=s,i}}class J{constructor(e=0,t=0){this.offset=e,this.value=t}}J.MaxPosition=60,J.MaxValue=12,function(e){e[e.Default=0]="Default",e[e.Gradual=1]="Gradual",e[e.Fast=2]="Fast"}(y||(y={})),function(e){e[e.None=0]="None",e[e.Custom=1]="Custom",e[e.Bend=2]="Bend",e[e.Release=3]="Release",e[e.BendRelease=4]="BendRelease",e[e.Hold=5]="Hold",e[e.Prebend=6]="Prebend",e[e.PrebendBend=7]="PrebendBend",e[e.PrebendRelease=8]="PrebendRelease"}(b||(b={})),function(e){e[e.None=0]="None",e[e.BrushUp=1]="BrushUp",e[e.BrushDown=2]="BrushDown",e[e.ArpeggioUp=3]="ArpeggioUp",e[e.ArpeggioDown=4]="ArpeggioDown"}(S||(S={})),function(e){e[e.None=0]="None",e[e.Crescendo=1]="Crescendo",e[e.Decrescendo=2]="Decrescendo"}(_||(_={})),function(e){e[e.QuadrupleWhole=-4]="QuadrupleWhole",e[e.DoubleWhole=-2]="DoubleWhole",e[e.Whole=1]="Whole",e[e.Half=2]="Half",e[e.Quarter=4]="Quarter",e[e.Eighth=8]="Eighth",e[e.Sixteenth=16]="Sixteenth",e[e.ThirtySecond=32]="ThirtySecond",e[e.SixtyFourth=64]="SixtyFourth",e[e.OneHundredTwentyEighth=128]="OneHundredTwentyEighth",e[e.TwoHundredFiftySixth=256]="TwoHundredFiftySixth"}(w||(w={})),function(e){e[e.None=0]="None",e[e.OnBeat=1]="OnBeat",e[e.BeforeBeat=2]="BeforeBeat",e[e.BendGrace=3]="BendGrace"}(B||(B={})),function(e){e[e.None=0]="None",e[e.Normal=1]="Normal",e[e.Heavy=2]="Heavy",e[e.Tenuto=3]="Tenuto"}(k||(k={})),function(e){e[e.Unknown=-2]="Unknown",e[e.NoOrDead=-1]="NoOrDead",e[e.Thumb=0]="Thumb",e[e.IndexFinger=1]="IndexFinger",e[e.MiddleFinger=2]="MiddleFinger",e[e.AnnularFinger=3]="AnnularFinger",e[e.LittleFinger=4]="LittleFinger"}(T||(T={})),function(e){e[e.None=0]="None",e[e.Natural=1]="Natural",e[e.Artificial=2]="Artificial",e[e.Pinch=3]="Pinch",e[e.Tap=4]="Tap",e[e.Semi=5]="Semi",e[e.Feedback=6]="Feedback"}(N||(N={})),function(e){e[e.Default=0]="Default",e[e.ForceNone=1]="ForceNone",e[e.ForceNatural=2]="ForceNatural",e[e.ForceSharp=3]="ForceSharp",e[e.ForceDoubleSharp=4]="ForceDoubleSharp",e[e.ForceFlat=5]="ForceFlat",e[e.ForceDoubleFlat=6]="ForceDoubleFlat"}(x||(x={})),function(e){e[e.None=0]="None",e[e.IntoFromBelow=1]="IntoFromBelow",e[e.IntoFromAbove=2]="IntoFromAbove"}(v||(v={})),function(e){e[e.None=0]="None",e[e.Shift=1]="Shift",e[e.Legato=2]="Legato",e[e.OutUp=3]="OutUp",e[e.OutDown=4]="OutDown",e[e.PickSlideDown=5]="PickSlideDown",e[e.PickSlideUp=6]="PickSlideUp"}(P||(P={})),function(e){e[e.None=0]="None",e[e.Slight=1]="Slight",e[e.Wide=2]="Wide"}(F||(F={})),e.TabRhythmMode=void 0,(C=e.TabRhythmMode||(e.TabRhythmMode={}))[C.Hidden=0]="Hidden",C[C.ShowWithBeams=1]="ShowWithBeams",C[C.ShowWithBars=2]="ShowWithBars",C[C.Automatic=3]="Automatic",e.FingeringMode=void 0,(E=e.FingeringMode||(e.FingeringMode={}))[E.ScoreDefault=0]="ScoreDefault",E[E.ScoreForcePiano=1]="ScoreForcePiano",E[E.SingleNoteEffectBand=2]="SingleNoteEffectBand",E[E.SingleNoteEffectBandForcePiano=3]="SingleNoteEffectBandForcePiano",e.NotationMode=void 0,(D=e.NotationMode||(e.NotationMode={}))[D.GuitarPro=0]="GuitarPro",D[D.SongBook=1]="SongBook",e.NotationElement=void 0,(M=e.NotationElement||(e.NotationElement={}))[M.ScoreTitle=0]="ScoreTitle",M[M.ScoreSubTitle=1]="ScoreSubTitle",M[M.ScoreArtist=2]="ScoreArtist",M[M.ScoreAlbum=3]="ScoreAlbum",M[M.ScoreWords=4]="ScoreWords",M[M.ScoreMusic=5]="ScoreMusic",M[M.ScoreWordsAndMusic=6]="ScoreWordsAndMusic",M[M.ScoreCopyright=7]="ScoreCopyright",M[M.GuitarTuning=8]="GuitarTuning",M[M.TrackNames=9]="TrackNames",M[M.ChordDiagrams=10]="ChordDiagrams",M[M.ParenthesisOnTiedBends=11]="ParenthesisOnTiedBends",M[M.TabNotesOnTiedBends=12]="TabNotesOnTiedBends",M[M.ZerosOnDiveWhammys=13]="ZerosOnDiveWhammys",M[M.EffectAlternateEndings=14]="EffectAlternateEndings",M[M.EffectCapo=15]="EffectCapo",M[M.EffectChordNames=16]="EffectChordNames",M[M.EffectCrescendo=17]="EffectCrescendo",M[M.EffectDynamics=18]="EffectDynamics",M[M.EffectFadeIn=19]="EffectFadeIn",M[M.EffectFermata=20]="EffectFermata",M[M.EffectFingering=21]="EffectFingering",M[M.EffectHarmonics=22]="EffectHarmonics",M[M.EffectLetRing=23]="EffectLetRing",M[M.EffectLyrics=24]="EffectLyrics",M[M.EffectMarker=25]="EffectMarker",M[M.EffectOttavia=26]="EffectOttavia",M[M.EffectPalmMute=27]="EffectPalmMute",M[M.EffectPickSlide=28]="EffectPickSlide",M[M.EffectPickStroke=29]="EffectPickStroke",M[M.EffectSlightBeatVibrato=30]="EffectSlightBeatVibrato",M[M.EffectSlightNoteVibrato=31]="EffectSlightNoteVibrato",M[M.EffectTap=32]="EffectTap",M[M.EffectTempo=33]="EffectTempo",M[M.EffectText=34]="EffectText",M[M.EffectTrill=35]="EffectTrill",M[M.EffectTripletFeel=36]="EffectTripletFeel",M[M.EffectWhammyBar=37]="EffectWhammyBar",M[M.EffectWideBeatVibrato=38]="EffectWideBeatVibrato",M[M.EffectWideNoteVibrato=39]="EffectWideNoteVibrato",M[M.EffectLeftHandTap=40]="EffectLeftHandTap",M[M.EffectFreeTime=41]="EffectFreeTime",M[M.EffectSustainPedal=42]="EffectSustainPedal",M[M.EffectGolpe=43]="EffectGolpe",M[M.EffectWahPedal=44]="EffectWahPedal",M[M.EffectBeatBarre=45]="EffectBeatBarre",M[M.EffectNoteOrnament=46]="EffectNoteOrnament",M[M.EffectRasgueado=47]="EffectRasgueado",M[M.EffectDirections=48]="EffectDirections",M[M.EffectBeatTimer=49]="EffectBeatTimer";class Y{constructor(){this.notationMode=e.NotationMode.GuitarPro,this.fingeringMode=e.FingeringMode.ScoreDefault,this.elements=new Map,this.rhythmMode=e.TabRhythmMode.Automatic,this.rhythmHeight=15,this.transpositionPitches=[],this.displayTranspositionPitches=[],this.smallGraceTabNotes=!0,this.extendBendArrowsOnTiedNotes=!0,this.extendLineEffectsToBeatEnd=!1,this.slurHeight=5}isNotationElementVisible(e){return this.elements.has(e)?this.elements.get(e):!Y.defaultElements.has(e)||Y.defaultElements.get(e)}}Y.defaultElements=new Map([[e.NotationElement.ZerosOnDiveWhammys,!1]]);class ${constructor(e){this._value=void 0,this._factory=e}get value(){return void 0===this._value&&(this._value=this._factory()),this._value}}e.LogLevel=void 0,(L=e.LogLevel||(e.LogLevel={}))[L.None=0]="None",L[L.Debug=1]="Debug",L[L.Info=2]="Info",L[L.Warning=3]="Warning",L[L.Error=4]="Error";class q{static format(e,t){return`[AlphaTab][${e}] ${t}`}debug(e,t,...s){console.debug(q.format(e,t),...s)}warning(e,t,...s){console.warn(q.format(e,t),...s)}info(e,t,...s){console.info(q.format(e,t),...s)}error(e,t,...s){console.error(q.format(e,t),...s)}}q.logLevel=e.LogLevel.Info;class j{static shouldLog(t){return j.logLevel!==e.LogLevel.None&&t>=j.logLevel}static debug(t,s,...i){j.shouldLog(e.LogLevel.Debug)&&j.log.debug(t,s,...i)}static warning(t,s,...i){j.shouldLog(e.LogLevel.Warning)&&j.log.warning(t,s,...i)}static info(t,s,...i){j.shouldLog(e.LogLevel.Info)&&j.log.info(t,s,...i)}static error(t,s,...i){j.shouldLog(e.LogLevel.Error)&&j.log.error(t,s,...i)}}j.logLevel=e.LogLevel.Info,j.log=new q,function(e){e[e.NoTripletFeel=0]="NoTripletFeel",e[e.Triplet16th=1]="Triplet16th",e[e.Triplet8th=2]="Triplet8th",e[e.Dotted16th=3]="Dotted16th",e[e.Dotted8th=4]="Dotted8th",e[e.Scottish16th=5]="Scottish16th",e[e.Scottish8th=6]="Scottish8th"}(A||(A={}));class K{constructor(){this.alternateEndings=0,this.nextMasterBar=null,this.previousMasterBar=null,this.index=0,this.isDoubleBar=!1,this.isRepeatStart=!1,this.repeatCount=0,this.timeSignatureNumerator=4,this.timeSignatureDenominator=4,this.timeSignatureCommon=!1,this.isFreeTime=!1,this.tripletFeel=A.NoTripletFeel,this.section=null,this.tempoAutomations=[],this.fermata=null,this.start=0,this.isAnacrusis=!1,this.displayScale=1,this.displayWidth=-1,this.directions=null}get keySignature(){return this.score.tracks[0].staves[0].bars[this.index].keySignature}set keySignature(e){this.score.tracks[0].staves[0].bars[this.index].keySignature=e}get keySignatureType(){return this.score.tracks[0].staves[0].bars[this.index].keySignatureType}set keySignatureType(e){this.score.tracks[0].staves[0].bars[this.index].keySignatureType=e}get isRepeatEnd(){return this.repeatCount>0}get isSectionStart(){return!!this.section}get tempoAutomation(){return this.tempoAutomations.length>0?this.tempoAutomations[0]:null}calculateDuration(e=!0){if(this.isAnacrusis&&e){let e=0;for(const t of this.score.tracks)for(const s of t.staves){const t=this.index<s.bars.length?s.bars[this.index].calculateDuration():0;t>e&&(e=t)}return e}return this.timeSignatureNumerator*U.valueToTicks(this.timeSignatureDenominator)}addFermata(e,t){let s=this.fermata;null===s&&(s=new Map,this.fermata=s),s.set(e,t)}addDirection(e){null==this.directions&&(this.directions=new Set),this.directions.add(e)}getFermata(e){const t=this.fermata;return null===t?null:t.has(e.playbackStart)?t.get(e.playbackStart):null}}K.MaxAlternateEndings=8;class Q{}Q.DefaultChannelCount=17,Q.MetronomeChannel=Q.DefaultChannelCount-1,Q.MetronomeKey=33,Q.AudioChannels=2,Q.MinVolume=0,Q.MinProgram=0,Q.MaxProgram=127,Q.MinPlaybackSpeed=.125,Q.MaxPlaybackSpeed=8,Q.PercussionChannel=9,Q.PercussionBank=128,Q.MaxPitchWheel=16384,Q.MaxPitchWheel20=4294967296,Q.DefaultPitchWheel=Q.MaxPitchWheel/2,Q.MicroBufferCount=32,Q.MicroBufferSize=64;class Z{constructor(){this.beats=[],this.id="empty",this.isComplete=!1}addBeat(e){e.graceIndex=this.beats.length,e.graceGroup=this,this.beats.push(e)}finish(){this.beats.length>0&&(this.id=`${this.beats[0].absoluteDisplayStart}_${this.beats[0].voice.index}`)}}!function(e){e[e.Glyphs=0]="Glyphs"}(I||(I={}));class ee extends W{}let te=class e{constructor(){this._isEmpty=!0,this._isRestOnly=!0,this.id=e._globalVoiceId++,this.index=0,this.beats=[]}static resetIds(){e._globalVoiceId=0}get isEmpty(){return this._isEmpty}forceNonEmpty(){this._isEmpty=!1}get isRestOnly(){return this._isRestOnly}insertBeat(e,t){t.nextBeat=e.nextBeat,t.nextBeat&&(t.nextBeat.previousBeat=t),t.previousBeat=e,t.voice=this,e.nextBeat=t,this.beats.splice(e.index+1,0,t)}addBeat(e){e.voice=this,e.index=this.beats.length,this.beats.push(e),e.isEmpty||(this._isEmpty=!1),e.isRest||(this._isRestOnly=!1)}chain(e,t=null){if(this.bar){if(e.index<this.beats.length-1)e.nextBeat=this.beats[e.index+1],e.nextBeat.previousBeat=e;else if(e.isLastOfVoice&&e.voice.bar.nextBar){const t=this.bar.nextBar.voices[this.index];t.beats.length>0?(e.nextBeat=t.beats[0],e.nextBeat.previousBeat=e):e.nextBeat.previousBeat=e}e.chain(t)}}addGraceBeat(e){if(0===this.beats.length)return void this.addBeat(e);const t=this.beats[this.beats.length-1];this.beats.splice(this.beats.length-1,1),this.addBeat(e),this.addBeat(t),this._isEmpty=!1,this._isRestOnly=!1}getBeatAtPlaybackStart(e){return this._beatLookup.has(e)?this._beatLookup.get(e):null}finish(e,t=null){this._isEmpty=!0,this._isRestOnly=!0,this._beatLookup=new Map;let s=null;for(let e=0;e<this.beats.length;e++){const i=this.beats[e];i.index=e,this.chain(i,t),i.graceType===B.None?(i.graceGroup=s,s&&(s.isComplete=!0),s=null):(s||(s=new Z),s.addBeat(i)),i.isEmpty||(this._isEmpty=!1),i.isRest||(this._isRestOnly=!1)}let i=0,a=0;for(let s=0;s<this.beats.length;s++){const r=this.beats[s];if(r.index=s,r.finish(e,t),r.graceType===B.None){if(r.graceGroup){const e=r.graceGroup.beats[0],t=r.graceGroup.beats[r.graceGroup.beats.length-1];if(e.graceType!==B.BendGrace){const s=t.playbackStart+t.playbackDuration-e.playbackStart;switch(e.graceType){case B.BeforeBeat:e.previousBeat?(e.previousBeat.playbackDuration-=s,a=e.previousBeat.voice===this?e.previousBeat.playbackStart+e.previousBeat.playbackDuration:-s):a=-s;for(const e of r.graceGroup.beats)this._beatLookup.delete(e.playbackStart),e.playbackStart=a,this._beatLookup.set(e.playbackStart,r),a+=e.playbackDuration;break;case B.OnBeat:r.playbackDuration-=s,a=t.voice===this?t.playbackStart+t.playbackDuration:-s}}}r.displayStart=i,r.playbackStart=a,r.fermata?this.bar.masterBar.addFermata(r.playbackStart,r.fermata):r.fermata=this.bar.masterBar.getFermata(r),this._beatLookup.set(r.playbackStart,r)}else r.displayStart=i,r.playbackStart=a;r.finishTuplet(),r.graceGroup&&r.graceGroup.finish(),i+=r.displayDuration,a+=r.playbackDuration}}calculateDuration(){if(this.isEmpty||0===this.beats.length)return 0;const e=this.beats[this.beats.length-1],t=this.beats[0];return e.playbackStart+e.playbackDuration-t.playbackStart}};te._globalVoiceId=0;class se{constructor(){this.note=null,this.tone=new ie,this.octave=0}get realValue(){return 12*this.octave+this.tone.noteValue}}class ie{constructor(e=0,t=x.Default){this.noteValue=e,this.accidentalMode=t}}class ae{static getIndex(e){return e<0?0:0|Math.log2(e)}static keySignatureIsFlat(e){return e<0}static keySignatureIsNatural(e){return 0===e}static keySignatureIsSharp(e){return e>0}static applyPitchOffsets(e,t){for(let s=0;s<t.tracks.length;s++){if(s<e.notation.displayTranspositionPitches.length)for(const i of t.tracks[s].staves)i.displayTranspositionPitch=-e.notation.displayTranspositionPitches[s];if(s<e.notation.transpositionPitches.length)for(const i of t.tracks[s].staves)i.transpositionPitch=-e.notation.transpositionPitches[s]}}static fingerToString(t,s,i,a){if(t.notation.fingeringMode===e.FingeringMode.ScoreForcePiano||t.notation.fingeringMode===e.FingeringMode.SingleNoteEffectBandForcePiano||R.isPiano(s.voice.bar.staff.track.playbackInfo.program))switch(i){case T.Unknown:case T.NoOrDead:return null;case T.Thumb:return"1";case T.IndexFinger:return"2";case T.MiddleFinger:return"3";case T.AnnularFinger:return"4";case T.LittleFinger:return"5";default:return null}if(a)switch(i){case T.Unknown:return null;case T.NoOrDead:return"0";case T.Thumb:return"t";case T.IndexFinger:return"1";case T.MiddleFinger:return"2";case T.AnnularFinger:return"3";case T.LittleFinger:return"4";default:return null}switch(i){case T.Unknown:case T.NoOrDead:return null;case T.Thumb:return"p";case T.IndexFinger:return"i";case T.MiddleFinger:return"m";case T.AnnularFinger:return"a";case T.LittleFinger:return"c";default:return null}}static isTuning(e){return!!ae.parseTuning(e)}static parseTuning(e){let t="",s="";for(let i=0;i<e.length;i++){const a=e.charCodeAt(i);if(a>=48&&a<=57){if(!t)return null;s+=String.fromCharCode(a)}else{if(!ae.TuningLetters.has(a))return null;t+=String.fromCharCode(a)}}if(!s||!t)return null;const i=new se;return i.octave=Number.parseInt(s)+1,i.note=t.toLowerCase(),i.tone=ae.getToneForText(i.note),i.tone.noteValue<0&&(i.octave--,i.tone.noteValue+=12),i}static getTuningForText(e){const t=ae.parseTuning(e);return t?t.realValue:-1}static getToneForText(e){const t=e.substring(0,1),s=e.substring(1);let i,a;switch(t.toLowerCase()){case"c":default:i=0;break;case"d":i=2;break;case"e":i=4;break;case"f":i=5;break;case"g":i=7;break;case"a":i=9;break;case"b":i=11}switch(a=ae.parseAccidentalMode(s),a){case x.Default:case x.ForceNone:case x.ForceNatural:break;case x.ForceSharp:i++;break;case x.ForceDoubleSharp:i+=2;break;case x.ForceFlat:i--;break;case x.ForceDoubleFlat:i-=2}return new ie(i,a)}static parseAccidentalMode(e){const t=e.toLowerCase();return ae.accidentalModeMapping.has(t)?ae.accidentalModeMapping.get(t):x.Default}static newGuid(){return`${Math.floor(65536*(1+Math.random())).toString(16).substring(1)+Math.floor(65536*(1+Math.random())).toString(16).substring(1)}-${Math.floor(65536*(1+Math.random())).toString(16).substring(1)}-${Math.floor(65536*(1+Math.random())).toString(16).substring(1)}-${Math.floor(65536*(1+Math.random())).toString(16).substring(1)}-${Math.floor(65536*(1+Math.random())).toString(16).substring(1)}${Math.floor(65536*(1+Math.random())).toString(16).substring(1)}${Math.floor(65536*(1+Math.random())).toString(16).substring(1)}`}static isAlmostEqualTo(e,t){return Math.abs(e-t)<1e-5}static toHexString(e,t=0){let s="";do{s=String.fromCharCode("0123456789ABCDEF".charCodeAt(15&e))+s,e>>=4}while(e>0);for(;s.length<t;)s=`0${s}`;return s}static getAlternateEndingsList(e){const t=[];for(let s=0;s<K.MaxAlternateEndings;s++)e&1<<s&&t.push(s);return t}static deltaFretToHarmonicValue(e){switch(e){case 2:return 2.4;case 3:return 3.2;case 4:case 5:case 7:case 9:case 12:case 16:case 17:case 19:case 24:return e;case 8:return 8.2;case 10:return 9.6;case 14:case 15:return 14.7;case 21:case 22:return 21.7;default:return 12}}static clamp(e,t,s){return e<=t?t:e>=s?s:e}static buildMultiBarRestInfo(e,t,s){if(!e)return null;const i=e[0].score.stylesheet;if(!(e.length>1?i.multiTrackMultiBarRest:!0===i.perTrackMultiBarRest?.has(e[0].index)))return null;const a=new Map,r=e[0].score;let n=t;for(;n<=s;){const i=n;let o=null;for(;n<=s;){const s=r.masterBars[n];if(s.alternateEndings||s.isRepeatStart&&s.index!==i||s.isFreeTime||s.isAnacrusis||null!==s.section||s.index!==i&&s.tempoAutomations.length>0||null!==s.fermata&&s.fermata.size>0||null!==s.directions&&s.directions.size>0)break;if(i>t&&s.previousMasterBar&&(s.timeSignatureCommon!==s.previousMasterBar.timeSignatureCommon||s.timeSignatureNumerator!==s.previousMasterBar.timeSignatureNumerator||s.timeSignatureDenominator!==s.previousMasterBar.timeSignatureDenominator||s.tripletFeel!==s.previousMasterBar.tripletFeel))break;let a=!0;for(const t of e){for(const e of t.staves){const t=e.bars[s.index];if(!t.isRestOnly){a=!1;break}if(t.index>0&&(t.keySignature!==t.previousBar.keySignature||t.keySignatureType!==t.previousBar.keySignatureType)){a=!1;break}}if(!a)break}if(!a)break;if(n++,s.index>i&&(null===o?o=[s.index]:o.push(s.index)),s.isRepeatEnd)break}o?a.set(i,o):n++}return a}static computeFirstDisplayedBarIndex(e,t){let s=t.display.startBar;return s--,s=Math.min(e.masterBars.length-1,Math.max(0,s)),s}static computeLastDisplayedBarIndex(e,t,s){let i=t.display.barCount;return i<0&&(i=e.masterBars.length),i=s+i-1,i=Math.min(e.masterBars.length-1,Math.max(0,i)),i}static getOrCreateHeaderFooterStyle(e,t){let s,i=e.style;if(e.style||(i=new Je,e.style=i),i.headerAndFooter.has(t))s=i.headerAndFooter.get(t);else{if(s=new Xe,Je.defaultHeaderAndFooter.has(t)){const e=Je.defaultHeaderAndFooter.get(t);s.template=e.template,s.textAlign=e.textAlign}i.headerAndFooter.set(t,s)}return s}static consolidate(e){if(0===e.masterBars.length){const t=new K;e.addMasterBar(t);const s=new X;s.isLinear=!1,s.type=f.Tempo,s.value=e.tempo,t.tempoAutomations.push(s);const i=new z;e.tracks[0].staves[0].addBar(i);const a=new te;i.addVoice(a);const r=new Ue;return r.isEmpty=!0,void a.addBeat(r)}const t=new Set([Q.PercussionChannel]);for(const s of e.tracks){if(1===s.staves.length&&s.staves[0].isPercussion)s.playbackInfo.primaryChannel=Q.PercussionChannel,s.playbackInfo.secondaryChannel=Q.PercussionChannel;else{if(s.playbackInfo.primaryChannel!==Q.PercussionChannel)for(;t.has(s.playbackInfo.primaryChannel);)s.playbackInfo.primaryChannel++;if(t.add(s.playbackInfo.primaryChannel),s.playbackInfo.secondaryChannel!==Q.PercussionChannel)for(;t.has(s.playbackInfo.secondaryChannel);)s.playbackInfo.secondaryChannel++;t.add(s.playbackInfo.secondaryChannel)}for(const t of s.staves){for(const e of t.bars)for(const t of e.voices)if(t.isEmpty&&0===t.beats.length){const e=new Ue;e.isEmpty=!0,t.addBeat(e)}const s=0===t.bars.length?1:t.bars[0].voices.length;for(;t.bars.length<e.masterBars.length;){const e=new z;t.addBar(e);const i=e.previousBar;i&&(e.clef=i.clef,e.clefOttava=i.clefOttava,e.keySignature=e.previousBar.keySignature,e.keySignatureType=e.previousBar.keySignatureType);for(let t=0;t<s;t++){const t=new te;e.addVoice(t);const s=new Ue;s.isEmpty=!0,t.addBeat(s)}}}}}}var re,ne,oe,he,le,ce,de,ue,pe,ge,me,fe,ye,be,Se,_e,we,Be,ke,Te,Ne,xe,ve,Pe,Fe,Ce,Ee;ae.TuningLetters=new Set([67,68,69,70,71,65,66,99,100,101,102,103,97,98,35]),ae.accidentalModeMapping=new Map([["default",x.Default],["d",x.Default],["forcenone",x.ForceNone],["-",x.ForceNone],["forcenatural",x.ForceNatural],["n",x.ForceNatural],["forcesharp",x.ForceSharp],["#",x.ForceSharp],["forcedoublesharp",x.ForceDoubleSharp],["##",x.ForceDoubleSharp],["x",x.ForceDoubleSharp],["forceflat",x.ForceFlat],["b",x.ForceFlat],["forcedoubleflat",x.ForceDoubleFlat],["bb",x.ForceDoubleFlat]]),function(e){e[e.None=0]="None",e[e.Up=1]="Up",e[e.Down=2]="Down"}(re||(re={})),function(e){e[e.None=-1]="None",e[e.Space=32]="Space",e[e.Brace=57344]="Brace",e[e.BracketTop=57347]="BracketTop",e[e.BracketBottom=57348]="BracketBottom",e[e.SystemDivider=57351]="SystemDivider",e[e.GClef=57424]="GClef",e[e.CClef=57436]="CClef",e[e.FClef=57442]="FClef",e[e.UnpitchedPercussionClef1=57449]="UnpitchedPercussionClef1",e[e.SixStringTabClef=57453]="SixStringTabClef",e[e.FourStringTabClef=57454]="FourStringTabClef",e[e.TimeSig0=57472]="TimeSig0",e[e.TimeSig1=57473]="TimeSig1",e[e.TimeSig2=57474]="TimeSig2",e[e.TimeSig3=57475]="TimeSig3",e[e.TimeSig4=57476]="TimeSig4",e[e.TimeSig5=57477]="TimeSig5",e[e.TimeSig6=57478]="TimeSig6",e[e.TimeSig7=57479]="TimeSig7",e[e.TimeSig8=57480]="TimeSig8",e[e.TimeSig9=57481]="TimeSig9",e[e.TimeSigCommon=57482]="TimeSigCommon",e[e.TimeSigCutCommon=57483]="TimeSigCutCommon",e[e.NoteheadDoubleWholeSquare=57505]="NoteheadDoubleWholeSquare",e[e.NoteheadDoubleWhole=57504]="NoteheadDoubleWhole",e[e.NoteheadWhole=57506]="NoteheadWhole",e[e.NoteheadHalf=57507]="NoteheadHalf",e[e.NoteheadBlack=57508]="NoteheadBlack",e[e.NoteheadNull=57509]="NoteheadNull",e[e.NoteheadXOrnate=57514]="NoteheadXOrnate",e[e.NoteheadPlusDoubleWhole=57516]="NoteheadPlusDoubleWhole",e[e.NoteheadPlusWhole=57517]="NoteheadPlusWhole",e[e.NoteheadPlusHalf=57518]="NoteheadPlusHalf",e[e.NoteheadPlusBlack=57519]="NoteheadPlusBlack",e[e.NoteheadSquareWhite=57528]="NoteheadSquareWhite",e[e.NoteheadSquareBlack=57529]="NoteheadSquareBlack",e[e.NoteheadTriangleUpDoubleWhole=57530]="NoteheadTriangleUpDoubleWhole",e[e.NoteheadTriangleUpWhole=57531]="NoteheadTriangleUpWhole",e[e.NoteheadTriangleUpHalf=57532]="NoteheadTriangleUpHalf",e[e.NoteheadTriangleUpBlack=57534]="NoteheadTriangleUpBlack",e[e.NoteheadTriangleRightWhite=57537]="NoteheadTriangleRightWhite",e[e.NoteheadTriangleRightBlack=57538]="NoteheadTriangleRightBlack",e[e.NoteheadTriangleDownDoubleWhole=57548]="NoteheadTriangleDownDoubleWhole",e[e.NoteheadTriangleDownWhole=57540]="NoteheadTriangleDownWhole",e[e.NoteheadTriangleDownHalf=57541]="NoteheadTriangleDownHalf",e[e.NoteheadTriangleDownBlack=57543]="NoteheadTriangleDownBlack",e[e.NoteheadDiamondDoubleWhole=57559]="NoteheadDiamondDoubleWhole",e[e.NoteheadDiamondWhole=57560]="NoteheadDiamondWhole",e[e.NoteheadDiamondHalf=57561]="NoteheadDiamondHalf",e[e.NoteheadDiamondBlack=57563]="NoteheadDiamondBlack",e[e.NoteheadDiamondBlackWide=57564]="NoteheadDiamondBlackWide",e[e.NoteheadDiamondWhite=57565]="NoteheadDiamondWhite",e[e.NoteheadDiamondWhiteWide=57566]="NoteheadDiamondWhiteWide",e[e.NoteheadCircleXDoubleWhole=57520]="NoteheadCircleXDoubleWhole",e[e.NoteheadCircleXWhole=57521]="NoteheadCircleXWhole",e[e.NoteheadCircleXHalf=57522]="NoteheadCircleXHalf",e[e.NoteheadCircleX=57523]="NoteheadCircleX",e[e.NoteheadXDoubleWhole=57510]="NoteheadXDoubleWhole",e[e.NoteheadXWhole=57511]="NoteheadXWhole",e[e.NoteheadXHalf=57512]="NoteheadXHalf",e[e.NoteheadXBlack=57513]="NoteheadXBlack",e[e.NoteheadParenthesis=57550]="NoteheadParenthesis",e[e.NoteheadSlashedBlack1=57551]="NoteheadSlashedBlack1",e[e.NoteheadSlashedBlack2=57552]="NoteheadSlashedBlack2",e[e.NoteheadSlashedHalf1=57553]="NoteheadSlashedHalf1",e[e.NoteheadSlashedHalf2=57554]="NoteheadSlashedHalf2",e[e.NoteheadSlashedWhole1=57555]="NoteheadSlashedWhole1",e[e.NoteheadSlashedWhole2=57556]="NoteheadSlashedWhole2",e[e.NoteheadSlashedDoubleWhole1=57557]="NoteheadSlashedDoubleWhole1",e[e.NoteheadSlashedDoubleWhole2=57558]="NoteheadSlashedDoubleWhole2",e[e.NoteheadCircledBlack=57572]="NoteheadCircledBlack",e[e.NoteheadCircledHalf=57573]="NoteheadCircledHalf",e[e.NoteheadCircledWhole=57574]="NoteheadCircledWhole",e[e.NoteheadCircledDoubleWhole=57575]="NoteheadCircledDoubleWhole",e[e.NoteheadCircleSlash=57591]="NoteheadCircleSlash",e[e.NoteheadHeavyX=57592]="NoteheadHeavyX",e[e.NoteheadHeavyXHat=57593]="NoteheadHeavyXHat",e[e.NoteheadSlashVerticalEnds=57600]="NoteheadSlashVerticalEnds",e[e.NoteheadSlashWhiteWhole=57602]="NoteheadSlashWhiteWhole",e[e.NoteheadSlashWhiteHalf=57603]="NoteheadSlashWhiteHalf",e[e.NoteheadRoundWhiteWithDot=57621]="NoteheadRoundWhiteWithDot",e[e.NoteheadSquareBlackLarge=57626]="NoteheadSquareBlackLarge",e[e.NoteheadSquareBlackWhite=57627]="NoteheadSquareBlackWhite",e[e.NoteheadClusterDoubleWhole3rd=57640]="NoteheadClusterDoubleWhole3rd",e[e.NoteheadClusterWhole3rd=57641]="NoteheadClusterWhole3rd",e[e.NoteheadClusterHalf3rd=57642]="NoteheadClusterHalf3rd",e[e.NoteheadClusterQuarter3rd=57643]="NoteheadClusterQuarter3rd",e[e.NoteShapeRoundWhite=57776]="NoteShapeRoundWhite",e[e.NoteShapeRoundBlack=57777]="NoteShapeRoundBlack",e[e.NoteShapeSquareWhite=57778]="NoteShapeSquareWhite",e[e.NoteShapeSquareBlack=57779]="NoteShapeSquareBlack",e[e.NoteShapeTriangleRightWhite=57780]="NoteShapeTriangleRightWhite",e[e.NoteShapeTriangleRightBlack=57781]="NoteShapeTriangleRightBlack",e[e.NoteShapeTriangleLeftWhite=57782]="NoteShapeTriangleLeftWhite",e[e.NoteShapeTriangleLeftBlack=57783]="NoteShapeTriangleLeftBlack",e[e.NoteShapeDiamondWhite=57784]="NoteShapeDiamondWhite",e[e.NoteShapeDiamondBlack=57785]="NoteShapeDiamondBlack",e[e.NoteShapeTriangleUpWhite=57786]="NoteShapeTriangleUpWhite",e[e.NoteShapeTriangleUpBlack=57787]="NoteShapeTriangleUpBlack",e[e.NoteShapeMoonWhite=57788]="NoteShapeMoonWhite",e[e.NoteShapeMoonBlack=57789]="NoteShapeMoonBlack",e[e.NoteShapeTriangleRoundWhite=57790]="NoteShapeTriangleRoundWhite",e[e.NoteShapeTriangleRoundBlack=57791]="NoteShapeTriangleRoundBlack",e[e.NoteQuarterUp=57813]="NoteQuarterUp",e[e.NoteEighthUp=57815]="NoteEighthUp",e[e.TextBlackNoteLongStem=57841]="TextBlackNoteLongStem",e[e.TextBlackNoteFrac8thLongStem=57843]="TextBlackNoteFrac8thLongStem",e[e.TextBlackNoteFrac16thLongStem=57845]="TextBlackNoteFrac16thLongStem",e[e.TextBlackNoteFrac32ndLongStem=57846]="TextBlackNoteFrac32ndLongStem",e[e.TextCont8thBeamLongStem=57848]="TextCont8thBeamLongStem",e[e.TextCont16thBeamLongStem=57850]="TextCont16thBeamLongStem",e[e.TextCont32ndBeamLongStem=57851]="TextCont32ndBeamLongStem",e[e.TextAugmentationDot=57852]="TextAugmentationDot",e[e.TextTupletBracketStartLongStem=57857]="TextTupletBracketStartLongStem",e[e.TextTuplet3LongStem=57858]="TextTuplet3LongStem",e[e.TextTupletBracketEndLongStem=57859]="TextTupletBracketEndLongStem",e[e.Tremolo3=57890]="Tremolo3",e[e.Tremolo2=57889]="Tremolo2",e[e.Tremolo1=57888]="Tremolo1",e[e.FlagEighthUp=57920]="FlagEighthUp",e[e.FlagEighthDown=57921]="FlagEighthDown",e[e.FlagSixteenthUp=57922]="FlagSixteenthUp",e[e.FlagSixteenthDown=57923]="FlagSixteenthDown",e[e.FlagThirtySecondUp=57924]="FlagThirtySecondUp",e[e.FlagThirtySecondDown=57925]="FlagThirtySecondDown",e[e.FlagSixtyFourthUp=57926]="FlagSixtyFourthUp",e[e.FlagSixtyFourthDown=57927]="FlagSixtyFourthDown",e[e.FlagOneHundredTwentyEighthUp=57928]="FlagOneHundredTwentyEighthUp",e[e.FlagOneHundredTwentyEighthDown=57929]="FlagOneHundredTwentyEighthDown",e[e.FlagTwoHundredFiftySixthUp=57930]="FlagTwoHundredFiftySixthUp",e[e.FlagTwoHundredFiftySixthDown=57931]="FlagTwoHundredFiftySixthDown",e[e.AccidentalFlat=57952]="AccidentalFlat",e[e.AccidentalNatural=57953]="AccidentalNatural",e[e.AccidentalSharp=57954]="AccidentalSharp",e[e.AccidentalDoubleSharp=57955]="AccidentalDoubleSharp",e[e.AccidentalDoubleFlat=57956]="AccidentalDoubleFlat",e[e.AccidentalQuarterToneFlatArrowUp=57968]="AccidentalQuarterToneFlatArrowUp",e[e.AccidentalQuarterToneSharpArrowUp=57972]="AccidentalQuarterToneSharpArrowUp",e[e.AccidentalQuarterToneNaturalArrowUp=57970]="AccidentalQuarterToneNaturalArrowUp",e[e.Segno=57415]="Segno",e[e.Coda=57416]="Coda",e[e.ArticAccentAbove=58528]="ArticAccentAbove",e[e.ArticAccentBelow=58529]="ArticAccentBelow",e[e.ArticStaccatoAbove=58530]="ArticStaccatoAbove",e[e.ArticStaccatoBelow=58531]="ArticStaccatoBelow",e[e.ArticTenutoAbove=58532]="ArticTenutoAbove",e[e.ArticTenutoBelow=58533]="ArticTenutoBelow",e[e.ArticMarcatoAbove=58540]="ArticMarcatoAbove",e[e.ArticMarcatoBelow=58541]="ArticMarcatoBelow",e[e.FermataAbove=58560]="FermataAbove",e[e.FermataShortAbove=58564]="FermataShortAbove",e[e.FermataLongAbove=58566]="FermataLongAbove",e[e.RestLonga=58593]="RestLonga",e[e.RestDoubleWhole=58594]="RestDoubleWhole",e[e.RestWhole=58595]="RestWhole",e[e.RestHalf=58596]="RestHalf",e[e.RestQuarter=58597]="RestQuarter",e[e.RestEighth=58598]="RestEighth",e[e.RestSixteenth=58599]="RestSixteenth",e[e.RestThirtySecond=58600]="RestThirtySecond",e[e.RestSixtyFourth=58601]="RestSixtyFourth",e[e.RestOneHundredTwentyEighth=58602]="RestOneHundredTwentyEighth",e[e.RestTwoHundredFiftySixth=58603]="RestTwoHundredFiftySixth",e[e.RestHBarLeft=58607]="RestHBarLeft",e[e.RestHBarMiddle=58608]="RestHBarMiddle",e[e.RestHBarRight=58609]="RestHBarRight",e[e.Repeat1Bar=58624]="Repeat1Bar",e[e.Repeat2Bars=58625]="Repeat2Bars",e[e.Ottava=58640]="Ottava",e[e.OttavaAlta=58641]="OttavaAlta",e[e.OttavaBassaVb=58652]="OttavaBassaVb",e[e.Quindicesima=58644]="Quindicesima",e[e.QuindicesimaAlta=58645]="QuindicesimaAlta",e[e.DynamicPPPPPP=58663]="DynamicPPPPPP",e[e.DynamicPPPPP=58664]="DynamicPPPPP",e[e.DynamicPPPP=58665]="DynamicPPPP",e[e.DynamicPPP=58666]="DynamicPPP",e[e.DynamicPP=58667]="DynamicPP",e[e.DynamicPiano=58656]="DynamicPiano",e[e.DynamicMP=58668]="DynamicMP",e[e.DynamicMF=58669]="DynamicMF",e[e.DynamicPF=58670]="DynamicPF",e[e.DynamicForte=58658]="DynamicForte",e[e.DynamicFF=58671]="DynamicFF",e[e.DynamicFFF=58672]="DynamicFFF",e[e.DynamicFFFF=58673]="DynamicFFFF",e[e.DynamicFFFFF=58674]="DynamicFFFFF",e[e.DynamicFFFFFF=58675]="DynamicFFFFFF",e[e.DynamicFortePiano=58676]="DynamicFortePiano",e[e.DynamicNiente=58662]="DynamicNiente",e[e.DynamicSforzando1=58678]="DynamicSforzando1",e[e.DynamicSforzandoPiano=58679]="DynamicSforzandoPiano",e[e.DynamicSforzandoPianissimo=58680]="DynamicSforzandoPianissimo",e[e.DynamicSforzato=58681]="DynamicSforzato",e[e.DynamicSforzatoPiano=58682]="DynamicSforzatoPiano",e[e.DynamicSforzatoFF=58683]="DynamicSforzatoFF",e[e.DynamicRinforzando1=58684]="DynamicRinforzando1",e[e.DynamicRinforzando2=58685]="DynamicRinforzando2",e[e.DynamicForzando=58677]="DynamicForzando",e[e.OrnamentTrill=58726]="OrnamentTrill",e[e.OrnamentTurn=58727]="OrnamentTurn",e[e.OrnamentTurnInverted=58728]="OrnamentTurnInverted",e[e.OrnamentShortTrill=58732]="OrnamentShortTrill",e[e.OrnamentMordent=58733]="OrnamentMordent",e[e.StringsDownBow=58896]="StringsDownBow",e[e.StringsUpBow=58898]="StringsUpBow",e[e.KeyboardPedalPed=58960]="KeyboardPedalPed",e[e.KeyboardPedalUp=58965]="KeyboardPedalUp",e[e.PictEdgeOfCymbal=59177]="PictEdgeOfCymbal",e[e.GuitarString0=59443]="GuitarString0",e[e.GuitarString1=59444]="GuitarString1",e[e.GuitarString2=59445]="GuitarString2",e[e.GuitarString3=59446]="GuitarString3",e[e.GuitarString4=59447]="GuitarString4",e[e.GuitarString5=59448]="GuitarString5",e[e.GuitarString6=59449]="GuitarString6",e[e.GuitarString7=59450]="GuitarString7",e[e.GuitarString8=59451]="GuitarString8",e[e.GuitarString9=59452]="GuitarString9",e[e.GuitarOpenPedal=59453]="GuitarOpenPedal",e[e.GuitarClosePedal=59455]="GuitarClosePedal",e[e.GuitarGolpe=59458]="GuitarGolpe",e[e.GuitarFadeIn=59459]="GuitarFadeIn",e[e.GuitarFadeOut=59460]="GuitarFadeOut",e[e.GuitarVolumeSwell=59461]="GuitarVolumeSwell",e[e.FretboardX=59481]="FretboardX",e[e.FretboardO=59482]="FretboardO",e[e.WiggleTrill=60068]="WiggleTrill",e[e.WiggleVibratoMediumFast=60126]="WiggleVibratoMediumFast",e[e.OctaveBaselineM=60565]="OctaveBaselineM",e[e.OctaveBaselineB=60563]="OctaveBaselineB"}(ne||(ne={})),function(e){e[e.Left=0]="Left",e[e.Center=1]="Center",e[e.Right=2]="Right"}(oe||(oe={})),function(e){e[e.Top=0]="Top",e[e.Middle=1]="Middle",e[e.Bottom=2]="Bottom"}(he||(he={}));class De{constructor(e,t){this.width=e,this.height=t}}class Me{constructor(e="",t=0,s=0,i=ne.None,a=ne.None,r=ne.None,n=ne.None,o=he.Middle){this.elementType=e,this.outputMidiNumber=s,this.staffLine=t,this.noteHeadDefault=i,this.noteHeadHalf=a!==ne.None?a:i,this.noteHeadWhole=r!==ne.None?r:i,this.techniqueSymbol=n,this.techniqueSymbolPlacement=o}getSymbol(e){switch(e){case w.Whole:return this.noteHeadWhole;case w.Half:return this.noteHeadHalf;default:return this.noteHeadDefault}}}class Le{static articulationFromElementVariation(e,t){return e<Le.gp6ElementAndVariationToArticulation.length?(t>=Le.gp6ElementAndVariationToArticulation.length&&(t=0),Le.gp6ElementAndVariationToArticulation[e][t]):38}static getArticulation(e){const t=e.percussionArticulation;if(t<0)return null;const s=e.beat.voice.bar.staff.track.percussionArticulations;return t<s.length?s[t]:Le.getArticulationByInputMidiNumber(t)}static getElementAndVariation(e){const t=Le.getArticulation(e);if(!t)return[-1,-1];for(let e=0;e<Le.gp6ElementAndVariationToArticulation.length;e++){const s=Le.gp6ElementAndVariationToArticulation[e];for(let i=0;i<s.length;i++){const a=Le.getArticulationByInputMidiNumber(s[i]);if(a?.outputMidiNumber===t.outputMidiNumber)return[e,i]}}return[-1,-1]}static getArticulationByInputMidiNumber(e){return Le.instrumentArticulations.has(e)?Le.instrumentArticulations.get(e):null}}Le.gp6ElementAndVariationToArticulation=[[35,35,35],[38,91,37],[99,100,99],[56,100,56],[102,103,102],[43,43,43],[45,45,45],[47,47,47],[48,48,48],[50,50,50],[42,92,46],[44,44,44],[57,98,57],[49,97,49],[55,95,55],[51,93,127],[52,96,52]],Le.instrumentArticulations=new Map([[38,new Me("snare",3,38,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[37,new Me("snare",3,37,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[91,new Me("snare",3,38,ne.NoteheadDiamondWhite,ne.NoteheadDiamondWhite,ne.NoteheadDiamondWhite)],[42,new Me("hiHat",-1,42,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[92,new Me("hiHat",-1,46,ne.NoteheadCircleSlash,ne.NoteheadCircleSlash,ne.NoteheadCircleSlash)],[46,new Me("hiHat",-1,46,ne.NoteheadCircleX,ne.NoteheadCircleX,ne.NoteheadCircleX)],[44,new Me("hiHat",9,44,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[35,new Me("kickDrum",8,35,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[36,new Me("kickDrum",7,36,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[50,new Me("tom",1,50,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[48,new Me("tom",2,48,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[47,new Me("tom",4,47,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[45,new Me("tom",5,45,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[43,new Me("tom",6,43,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[93,new Me("ride",0,51,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.PictEdgeOfCymbal,he.Bottom)],[51,new Me("ride",0,51,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[53,new Me("ride",0,53,ne.NoteheadDiamondWhite,ne.NoteheadDiamondWhite,ne.NoteheadDiamondWhite)],[94,new Me("ride",0,51,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.ArticStaccatoAbove,he.Top)],[55,new Me("splash",-2,55,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[95,new Me("splash",-2,55,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.ArticStaccatoAbove,he.Bottom)],[52,new Me("china",-3,52,ne.NoteheadHeavyXHat,ne.NoteheadHeavyXHat,ne.NoteheadHeavyXHat)],[96,new Me("china",-3,52,ne.NoteheadHeavyXHat,ne.NoteheadHeavyXHat,ne.NoteheadHeavyXHat)],[49,new Me("crash",-2,49,ne.NoteheadHeavyX,ne.NoteheadHeavyX,ne.NoteheadHeavyX)],[97,new Me("crash",-2,49,ne.NoteheadHeavyX,ne.NoteheadHeavyX,ne.NoteheadHeavyX,ne.ArticStaccatoAbove,he.Bottom)],[57,new Me("crash",-1,57,ne.NoteheadHeavyX,ne.NoteheadHeavyX,ne.NoteheadHeavyX)],[98,new Me("crash",-1,57,ne.NoteheadHeavyX,ne.NoteheadHeavyX,ne.NoteheadHeavyX,ne.ArticStaccatoAbove,he.Bottom)],[99,new Me("cowbell",1,56,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpHalf,ne.NoteheadTriangleUpWhole)],[100,new Me("cowbell",1,56,ne.NoteheadXBlack,ne.NoteheadXHalf,ne.NoteheadXWhole)],[56,new Me("cowbell",0,56,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpHalf,ne.NoteheadTriangleUpWhole)],[101,new Me("cowbell",0,56,ne.NoteheadXBlack,ne.NoteheadXHalf,ne.NoteheadXWhole)],[102,new Me("cowbell",-1,56,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpHalf,ne.NoteheadTriangleUpWhole)],[103,new Me("cowbell",-1,56,ne.NoteheadXBlack,ne.NoteheadXHalf,ne.NoteheadXWhole)],[77,new Me("woodblock",-9,77,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack)],[76,new Me("woodblock",-10,76,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack)],[60,new Me("bongo",-4,60,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[104,new Me("bongo",-5,60,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole,ne.NoteheadParenthesis,he.Middle)],[105,new Me("bongo",-6,60,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[61,new Me("bongo",-7,61,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[106,new Me("bongo",-8,61,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole,ne.NoteheadParenthesis,he.Middle)],[107,new Me("bongo",-16,61,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[66,new Me("timbale",10,66,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[65,new Me("timbale",9,65,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[68,new Me("agogo",12,68,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[67,new Me("agogo",11,67,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[64,new Me("conga",17,64,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[108,new Me("conga",16,64,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[109,new Me("conga",15,64,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole,ne.NoteheadParenthesis,he.Middle)],[63,new Me("conga",14,63,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[110,new Me("conga",13,63,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[62,new Me("conga",19,62,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole,ne.NoteheadParenthesis,he.Middle)],[72,new Me("whistle",-11,72,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[71,new Me("whistle",-17,71,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[73,new Me("guiro",38,73,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[74,new Me("guiro",37,74,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[86,new Me("surdo",36,86,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[87,new Me("surdo",35,87,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadParenthesis,he.Middle)],[54,new Me("tambourine",3,54,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack)],[111,new Me("tambourine",2,54,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack,ne.StringsUpBow,he.Bottom)],[112,new Me("tambourine",1,54,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack,ne.NoteheadTriangleUpBlack,ne.StringsDownBow,he.Bottom)],[113,new Me("tambourine",-7,54,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[79,new Me("cuica",30,79,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[78,new Me("cuica",29,78,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[58,new Me("vibraslap",28,58,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[81,new Me("triangle",27,81,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[80,new Me("triangle",26,80,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadParenthesis,he.Middle)],[114,new Me("grancassa",25,43,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[115,new Me("piatti",18,49,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[116,new Me("piatti",24,49,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[69,new Me("cabasa",23,69,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[117,new Me("cabasa",22,69,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole,ne.StringsUpBow,he.Bottom)],[85,new Me("castanets",21,85,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[75,new Me("claves",20,75,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[70,new Me("maraca",-12,70,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[118,new Me("maraca",-13,70,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole,ne.StringsUpBow,he.Bottom)],[119,new Me("maraca",-14,70,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[120,new Me("maraca",-15,70,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole,ne.StringsUpBow,he.Bottom)],[82,new Me("shaker",-23,54,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[122,new Me("shaker",-24,54,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole,ne.StringsUpBow,he.Bottom)],[84,new Me("bellTree",-18,53,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[123,new Me("bellTree",-19,53,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole,ne.StringsUpBow,he.Bottom)],[83,new Me("jingleBell",-20,53,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[124,new Me("unpitched",-21,62,ne.NoteheadNull,ne.NoteheadNull,ne.NoteheadNull,ne.GuitarGolpe,he.Top)],[125,new Me("unpitched",-22,62,ne.NoteheadNull,ne.NoteheadNull,ne.NoteheadNull,ne.GuitarGolpe,he.Bottom)],[39,new Me("handClap",3,39,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[40,new Me("snare",3,40,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[31,new Me("snare",3,40,ne.NoteheadSlashedBlack2,ne.NoteheadSlashedBlack2,ne.NoteheadSlashedBlack2)],[41,new Me("tom",5,41,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole)],[59,new Me("ride",2,59,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.PictEdgeOfCymbal,he.Bottom)],[126,new Me("ride",2,59,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[127,new Me("ride",2,59,ne.NoteheadDiamondWhite,ne.NoteheadDiamondWhite,ne.NoteheadDiamondWhite)],[29,new Me("ride",2,59,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.ArticStaccatoAbove,he.Top)],[30,new Me("crash",-3,49,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[33,new Me("snare",3,37,ne.NoteheadXBlack,ne.NoteheadXBlack,ne.NoteheadXBlack)],[34,new Me("snare",3,38,ne.NoteheadBlack,ne.NoteheadBlack,ne.NoteheadBlack)]]),Le.instrumentArticulationNames=new Map([["Ride (choke)",29],["Cymbal (hit)",30],["Snare (side stick)",31],["Snare (side stick) 2",33],["Snare (hit)",34],["Kick (hit)",35],["Kick (hit) 2",36],["Snare (side stick) 3",37],["Snare (hit) 2",38],["Hand Clap (hit)",39],["Snare (hit) 3",40],["Low Floor Tom (hit)",41],["Hi-Hat (closed)",42],["Very Low Tom (hit)",43],["Pedal Hi-Hat (hit)",44],["Low Tom (hit)",45],["Hi-Hat (open)",46],["Mid Tom (hit)",47],["High Tom (hit)",48],["Crash high (hit)",49],["High Floor Tom (hit)",50],["Ride (middle)",51],["China (hit)",52],["Ride (bell)",53],["Tambourine (hit)",54],["Splash (hit)",55],["Cowbell medium (hit)",56],["Crash medium (hit)",57],["Vibraslap (hit)",58],["Ride (edge)",59],["Hand (hit)",60],["Hand (hit)",61],["Conga high (mute)",62],["Conga high (hit)",63],["Conga low (hit)",64],["Timbale high (hit)",65],["Timbale low (hit)",66],["Agogo high (hit)",67],["Agogo tow (hit)",68],["Cabasa (hit)",69],["Left Maraca (hit)",70],["Whistle high (hit)",71],["Whistle low (hit)",72],["Guiro (hit)",73],["Guiro (scrap-return)",74],["Claves (hit)",75],["Woodblock high (hit)",76],["Woodblock low (hit)",77],["Cuica (mute)",78],["Cuica (open)",79],["Triangle (rnute)",80],["Triangle (hit)",81],["Shaker (hit)",82],["Tinkle Bell (hat)",83],["Jingle Bell (hit)",83],["Bell Tree (hit)",84],["Castanets (hit)",85],["Surdo (hit)",86],["Surdo (mute)",87],["Snare (rim shot)",91],["Hi-Hat (half)",92],["Ride (edge) 2",93],["Ride (choke) 2",94],["Splash (choke)",95],["China (choke)",96],["Crash high (choke)",97],["Crash medium (choke)",98],["Cowbell low (hit)",99],["Cowbell low (tip)",100],["Cowbell medium (tip)",101],["Cowbell high (hit)",102],["Cowbell high (tip)",103],["Hand (mute)",104],["Hand (slap)",105],["Hand (mute) 2",106],["Hand (slap) 2",107],["Conga low (slap)",108],["Conga low (mute)",109],["Conga high (slap)",110],["Tambourine (return)",111],["Tambourine (roll)",112],["Tambourine (hand)",113],["Grancassa (hit)",114],["Piatti (hat)",115],["Piatti (hand)",116],["Cabasa (return)",117],["Left Maraca (return)",118],["Right Maraca (hit)",119],["Right Maraca (return)",120],["Shaker (return)",122],["Bell Tee (return)",123],["Golpe (thumb)",124],["Golpe (finger)",125],["Ride (middle) 2",126],["Ride (bell) 2",127]]),function(e){e[e.None=0]="None",e[e.InvertedTurn=1]="InvertedTurn",e[e.Turn=2]="Turn",e[e.UpperMordent=3]="UpperMordent",e[e.LowerMordent=4]="LowerMordent"}(le||(le={}));class Ae{constructor(){this.tieDestinationNoteId=-1,this.tieOriginNoteId=-1,this.slurDestinationNoteId=-1,this.slurOriginNoteId=-1,this.hammerPullDestinationNoteId=-1,this.hammerPullOriginNoteId=-1,this.slideTargetNoteId=-1,this.slideOriginNoteId=-1}}!function(e){e[e.Effects=0]="Effects",e[e.StandardNotationNoteHead=1]="StandardNotationNoteHead",e[e.StandardNotationAccidentals=2]="StandardNotationAccidentals",e[e.StandardNotationEffects=3]="StandardNotationEffects",e[e.GuitarTabFretNumber=4]="GuitarTabFretNumber",e[e.GuitarTabEffects=5]="GuitarTabEffects",e[e.SlashNoteHead=6]="SlashNoteHead",e[e.SlashEffects=7]="SlashEffects",e[e.NumberedNumber=8]="NumberedNumber",e[e.NumberedAccidentals=9]="NumberedAccidentals",e[e.NumberedEffects=10]="NumberedEffects"}(ce||(ce={}));class Ie extends W{}class Re{constructor(){this.id=Re.GlobalNoteId++,this.index=0,this.accentuated=k.None,this.bendType=b.None,this.bendStyle=y.Default,this.bendOrigin=null,this.isContinuedBend=!1,this.bendPoints=null,this.maxBendPoint=null,this.fret=-1,this.string=-1,this.showStringNumber=!1,this.octave=-1,this.tone=-1,this.percussionArticulation=-1,this.isVisible=!0,this.isLeftHandTapped=!1,this.isHammerPullOrigin=!1,this.hammerPullOrigin=null,this.hammerPullDestination=null,this.isSlurDestination=!1,this.slurOrigin=null,this.slurDestination=null,this.harmonicType=N.None,this.harmonicValue=0,this.isGhost=!1,this.isLetRing=!1,this.letRingDestination=null,this.isPalmMute=!1,this.palmMuteDestination=null,this.isDead=!1,this.isStaccato=!1,this.slideInType=v.None,this.slideOutType=P.None,this.slideTarget=null,this.slideOrigin=null,this.vibrato=F.None,this.tieOrigin=null,this.tieDestination=null,this.isTieDestination=!1,this.leftHandFinger=T.Unknown,this.rightHandFinger=T.Unknown,this.trillValue=-1,this.trillSpeed=w.ThirtySecond,this.durationPercent=1,this.accidentalMode=x.Default,this.dynamics=m.F,this.isEffectSlurOrigin=!1,this.hasEffectSlur=!1,this.effectSlurOrigin=null,this.effectSlurDestination=null,this.ornament=le.None,this._noteIdBag=null}static resetIds(){Re.GlobalNoteId=0}get hasBend(){return null!==this.bendPoints&&this.bendType!==b.None}get isStringed(){return this.string>=0}get isPiano(){return!this.isStringed&&this.octave>=0&&this.tone>=0}get isPercussion(){return!this.isStringed&&this.percussionArticulation>=0}get element(){return this.isPercussion?Le.getElementAndVariation(this)[0]:-1}get variation(){return this.isPercussion?Le.getElementAndVariation(this)[1]:-1}get isHammerPullDestination(){return!!this.hammerPullOrigin}get isSlurOrigin(){return!!this.slurDestination}get isHarmonic(){return this.harmonicType!==N.None}get isTieOrigin(){return null!==this.tieDestination}get isFingering(){return this.leftHandFinger!==T.Unknown||this.rightHandFinger!==T.Unknown}get trillFret(){return this.trillValue-this.stringTuning}get isTrill(){return this.trillValue>=0}get isEffectSlurDestination(){return!!this.effectSlurOrigin}get stringTuning(){return this.beat.voice.bar.staff.capo+Re.getStringTuning(this.beat.voice.bar.staff,this.string)}static getStringTuning(e,t){return e.tuning.length>0?e.tuning[e.tuning.length-(t-1)-1]:0}get realValue(){return this.calculateRealValue(!0,!0)}get realValueWithoutHarmonic(){return this.calculateRealValue(!0,!1)}calculateRealValue(e,t){const s=e?this.beat.voice.bar.staff.transpositionPitch:0;if(t){let t=this.calculateRealValue(e,!1);return this.isStringed&&(this.harmonicType===N.Natural?t=this.harmonicPitch+this.stringTuning-s:t+=this.harmonicPitch),t}return this.isPercussion?this.percussionArticulation:this.isStringed?this.fret+this.stringTuning-s:this.isPiano?12*this.octave+this.tone-s:0}get harmonicPitch(){if(this.harmonicType===N.None||!this.isStringed)return 0;const e=this.harmonicValue;return ae.isAlmostEqualTo(e,2.4)?36:ae.isAlmostEqualTo(e,2.7)?34:e<3?0:e<=3.5?31:e<=4?28:e<=5?24:e<=6?34:e<=7?19:e<=8.5?36:e<=9?28:e<=10?34:e<=11?0:e<=12?12:e<14?0:e<=15?34:e<=16?28:e<=17?36:e<=18?0:e<=19?19:e<=21?0:e<=22?36:e<=24?24:0}get initialBendValue(){return this.hasBend?Math.floor(this.bendPoints[0].value/2):this.bendOrigin?Math.floor(this.bendOrigin.bendPoints[this.bendOrigin.bendPoints.length-1].value/2):this.isTieDestination&&this.tieOrigin.bendOrigin?Math.floor(this.tieOrigin.bendOrigin.bendPoints[this.tieOrigin.bendOrigin.bendPoints.length-1].value/2):this.beat.hasWhammyBar?Math.floor(this.beat.whammyBarPoints[0].value/2):this.beat.isContinuedWhammy?Math.floor(this.beat.previousBeat.whammyBarPoints[this.beat.previousBeat.whammyBarPoints.length-1].value/2):0}get displayValue(){return this.displayValueWithoutBend+this.initialBendValue}get displayValueWithoutBend(){let e=this.realValue;switch(this.harmonicType!==N.Natural&&this.harmonicType!==N.None&&(e-=this.harmonicPitch),this.beat.ottava){case h._15ma:e-=24;break;case h._8va:e-=12;break;case h.Regular:break;case h._8vb:e+=12;break;case h._15mb:e+=24}switch(this.beat.voice.bar.clefOttava){case h._15ma:e-=24;break;case h._8va:e-=12;break;case h.Regular:break;case h._8vb:e+=12;break;case h._15mb:e+=24}return e-this.beat.voice.bar.staff.displayTranspositionPitch}get hasQuarterToneOffset(){return this.hasBend?this.bendPoints[0].value%2!=0:this.bendOrigin?this.bendOrigin.bendPoints[this.bendOrigin.bendPoints.length-1].value%2!=0:this.beat.hasWhammyBar?this.beat.whammyBarPoints[0].value%2!=0:!!this.beat.isContinuedWhammy&&this.beat.previousBeat.whammyBarPoints[this.beat.previousBeat.whammyBarPoints.length-1].value%2!=0}addBendPoint(e){let t=this.bendPoints;null===t&&(t=[],this.bendPoints=t),t.push(e),(!this.maxBendPoint||e.value>this.maxBendPoint.value)&&(this.maxBendPoint=e),this.bendType===b.None&&(this.bendType=b.Custom)}finish(t,s=null){const i=new $((()=>Re.nextNoteOnSameLine(this))),a=t&&t.notation.notationMode===e.NotationMode.SongBook;if(this.isTieDestination&&(this.chain(s),a&&this.tieOrigin&&this.tieOrigin.isLetRing&&(this.isLetRing=!0)),this.isLetRing&&(i.value&&i.value.isLetRing?this.letRingDestination=i.value:this.letRingDestination=this,a&&this.isTieDestination&&!this.tieOrigin.hasBend&&(this.isVisible=!1)),this.isPalmMute&&(i.value&&i.value.isPalmMute?this.palmMuteDestination=i.value:this.palmMuteDestination=this),this.isHammerPullOrigin){const e=Re.findHammerPullDestination(this);e?(this.hammerPullDestination=e,e.hammerPullOrigin=this):this.isHammerPullOrigin=!1}switch(this.slideOutType){case P.Shift:case P.Legato:this.slideTarget||(this.slideTarget=i.value),this.slideTarget?this.slideTarget.slideOrigin=this:this.slideOutType=P.None}let r=null;this.isHammerPullOrigin&&this.hammerPullDestination?r=this.hammerPullDestination:this.slideOutType===P.Legato&&this.slideTarget&&(r=this.slideTarget),r&&(this.hasEffectSlur=!0,this.effectSlurOrigin&&this.beat.pickStroke===re.None?(this.effectSlurOrigin.effectSlurDestination=r,this.effectSlurOrigin.effectSlurDestination.effectSlurOrigin=this.effectSlurOrigin,this.effectSlurOrigin=null):(this.isEffectSlurOrigin=!0,this.effectSlurDestination=r,this.effectSlurDestination.effectSlurOrigin=this));const n=this.bendPoints,o=null!=n&&n.length>0;if(o){const e=this.isTieDestination&&this.tieOrigin.hasBend;this.isContinuedBend=e}else this.bendType=b.None;if(o&&this.bendType===b.Custom)if(4===n.length){const e=n[0],t=n[1],s=n[2],i=n[3];t.value===s.value?i.value>e.value?t.value>i.value?this.bendType=b.BendRelease:!this.isContinuedBend&&e.value>0?(this.bendType=b.PrebendBend,n.splice(2,1),n.splice(1,1)):(this.bendType=b.Bend,n.splice(2,1),n.splice(1,1)):i.value<e.value?this.isContinuedBend?(this.bendType=b.Release,n.splice(2,1),n.splice(1,1)):(this.bendType=b.PrebendRelease,n.splice(2,1),n.splice(1,1)):t.value>e.value?this.bendType=b.BendRelease:e.value>0&&!this.isContinuedBend?(this.bendType=b.Prebend,n.splice(2,1),n.splice(1,1)):(this.bendType=b.Hold,n.splice(2,1),n.splice(1,1)):j.warning("Model","Unsupported bend type detected, fallback to custom",null)}else if(2===n.length){const e=n[0],t=n[1];t.value>e.value?!this.isContinuedBend&&e.value>0?this.bendType=b.PrebendBend:this.bendType=b.Bend:t.value<e.value?this.isContinuedBend?this.bendType=b.Release:this.bendType=b.PrebendRelease:e.value>0&&!this.isContinuedBend?this.bendType=b.Prebend:this.bendType=b.Hold}this.initialBendValue>0&&(this.accidentalMode=x.Default)}static nextNoteOnSameLine(e){let t=e.beat.nextBeat;for(;t&&t.voice.bar.index<=e.beat.voice.bar.index+Re.MaxOffsetForSameLineSearch;){const s=t.getNoteOnString(e.string);if(s)return s;t=t.nextBeat}return null}static findHammerPullDestination(e){let t=e.beat.nextBeat;for(;t&&t.voice.bar.index<=e.beat.voice.bar.index+Re.MaxOffsetForSameLineSearch;){let s=t.getNoteOnString(e.string);if(s)return s;for(let i=e.string;i>0;i--)if(s=t.getNoteOnString(i),s){if(s.isLeftHandTapped)return s;break}for(let i=e.string;i<=e.beat.voice.bar.staff.tuning.length;i++)if(s=t.getNoteOnString(i),s){if(s.isLeftHandTapped)return s;break}t=t.nextBeat}return null}static findTieOrigin(e){let t=e.beat.previousBeat;for(;t&&t.voice.bar.index>=e.beat.voice.bar.index-Re.MaxOffsetForSameLineSearch;){if(e.isStringed){const s=t.getNoteOnString(e.string);if(s)return s}else if(-1===e.octave&&-1===e.tone){if(e.index<t.notes.length)return t.notes[e.index]}else{const s=t.getNoteWithRealValue(e.realValue);if(s)return s}t=t.previousBeat}return null}chain(e=null){if(null!==e)if(null!==this._noteIdBag){let t;e.has(Re.NoteIdLookupKey)?t=e.get(Re.NoteIdLookupKey):(t=new Map,e.set(Re.NoteIdLookupKey,t)),-1===this._noteIdBag.hammerPullDestinationNoteId&&-1===this._noteIdBag.tieDestinationNoteId&&-1===this._noteIdBag.slurDestinationNoteId&&-1===this._noteIdBag.slideTargetNoteId||t.set(this.id,this),-1!==this._noteIdBag.hammerPullOriginNoteId&&(this.hammerPullOrigin=t.get(this._noteIdBag.hammerPullOriginNoteId),this.hammerPullOrigin.hammerPullDestination=this),-1!==this._noteIdBag.tieOriginNoteId&&(this.tieOrigin=t.get(this._noteIdBag.tieOriginNoteId),this.tieOrigin.tieDestination=this),-1!==this._noteIdBag.slurOriginNoteId&&(this.slurOrigin=t.get(this._noteIdBag.slurOriginNoteId),this.slurOrigin.slurDestination=this),-1!==this._noteIdBag.slideOriginNoteId&&(this.slideOrigin=t.get(this._noteIdBag.slideOriginNoteId),this.slideOrigin.slideTarget=this),this._noteIdBag=null}else{if(!this.isTieDestination&&null===this.tieOrigin)return;const e=this.tieOrigin??Re.findTieOrigin(this);e?(e.tieDestination=this,this.tieOrigin=e,this.fret=e.fret,this.octave=e.octave,this.tone=e.tone,e.hasBend&&(this.bendOrigin=this.tieOrigin)):this.isTieDestination=!1}}toJson(e){null!==this.tieDestination&&e.set("tiedestinationnoteid",this.tieDestination.id),null!==this.tieOrigin&&e.set("tieoriginnoteid",this.tieOrigin.id),null!==this.slurDestination&&e.set("slurdestinationnoteid",this.slurDestination.id),null!==this.slurOrigin&&e.set("sluroriginnoteid",this.slurOrigin.id),null!==this.hammerPullOrigin&&e.set("hammerpulloriginnoteid",this.hammerPullOrigin.id),null!==this.hammerPullDestination&&e.set("hammerpulldestinationnoteid",this.hammerPullDestination.id),null!==this.slideTarget&&e.set("slidetargetnoteid",this.slideTarget.id),null!==this.slideOrigin&&e.set("slideoriginnoteid",this.slideOrigin.id)}setProperty(e,t){switch(e){case"tiedestinationnoteid":return null==this._noteIdBag&&(this._noteIdBag=new Ae),this._noteIdBag.tieDestinationNoteId=t,!0;case"tieoriginnoteid":return null==this._noteIdBag&&(this._noteIdBag=new Ae),this._noteIdBag.tieOriginNoteId=t,!0;case"slurdestinationnoteid":return null==this._noteIdBag&&(this._noteIdBag=new Ae),this._noteIdBag.slurDestinationNoteId=t,!0;case"sluroriginnoteid":return null==this._noteIdBag&&(this._noteIdBag=new Ae),this._noteIdBag.slurOriginNoteId=t,!0;case"hammerpulloriginnoteid":return null==this._noteIdBag&&(this._noteIdBag=new Ae),this._noteIdBag.hammerPullOriginNoteId=t,!0;case"hammerpulldestinationnoteid":return null==this._noteIdBag&&(this._noteIdBag=new Ae),this._noteIdBag.hammerPullDestinationNoteId=t,!0;case"slidetargetnoteid":return null==this._noteIdBag&&(this._noteIdBag=new Ae),this._noteIdBag.slideTargetNoteId=t,!0;case"slideoriginnoteid":return null==this._noteIdBag&&(this._noteIdBag=new Ae),this._noteIdBag.slideOriginNoteId=t,!0}return!1}}Re.GlobalNoteId=0,Re.MaxOffsetForSameLineSearch=3,Re.NoteIdLookupKey="NoteIdLookup";class Oe{constructor(e){this._isEqualLengthTuplet=!0,this.totalDuration=0,this.beats=[],this.isFull=!1,this.voice=e}check(e){if(0===this.beats.length)return this.beats.push(e),this.totalDuration+=e.playbackDuration,!0;if(e.graceType!==B.None)return!0;if(e.voice!==this.voice||this.isFull||e.tupletNumerator!==this.beats[0].tupletNumerator||e.tupletDenominator!==this.beats[0].tupletDenominator)return!1;if(e.playbackDuration!==this.beats[0].playbackDuration&&(this._isEqualLengthTuplet=!1),this.beats.push(e),this.totalDuration+=e.playbackDuration,this._isEqualLengthTuplet)this.beats.length===this.beats[0].tupletNumerator&&(this.isFull=!0);else{const e=this.beats[0].tupletNumerator/this.beats[0].tupletDenominator|0;for(const t of Oe.AllTicks)if(this.totalDuration===t*e){this.isFull=!0;break}}return!0}}Oe.HalfTicks=1920,Oe.QuarterTicks=960,Oe.EighthTicks=480,Oe.SixteenthTicks=240,Oe.ThirtySecondTicks=120,Oe.SixtyFourthTicks=60,Oe.OneHundredTwentyEighthTicks=30,Oe.TwoHundredFiftySixthTicks=15,Oe.AllTicks=[Oe.HalfTicks,Oe.QuarterTicks,Oe.EighthTicks,Oe.SixteenthTicks,Oe.ThirtySecondTicks,Oe.SixtyFourthTicks,Oe.OneHundredTwentyEighthTicks,Oe.TwoHundredFiftySixthTicks],function(e){e[e.None=0]="None",e[e.Custom=1]="Custom",e[e.Dive=2]="Dive",e[e.Dip=3]="Dip",e[e.Hold=4]="Hold",e[e.Predive=5]="Predive",e[e.PrediveDive=6]="PrediveDive"}(de||(de={}));class He{static clone(e){const t=new J;return t.offset=e.offset,t.value=e.value,t}}class We{static clone(e){const t=new Re;if(t.index=e.index,t.accentuated=e.accentuated,t.bendType=e.bendType,t.bendStyle=e.bendStyle,t.isContinuedBend=e.isContinuedBend,e.bendPoints){t.bendPoints=[];for(const s of e.bendPoints)t.addBendPoint(He.clone(s))}return t.fret=e.fret,t.string=e.string,t.showStringNumber=e.showStringNumber,t.octave=e.octave,t.tone=e.tone,t.percussionArticulation=e.percussionArticulation,t.isVisible=e.isVisible,t.isLeftHandTapped=e.isLeftHandTapped,t.isHammerPullOrigin=e.isHammerPullOrigin,t.isSlurDestination=e.isSlurDestination,t.harmonicType=e.harmonicType,t.harmonicValue=e.harmonicValue,t.isGhost=e.isGhost,t.isLetRing=e.isLetRing,t.isPalmMute=e.isPalmMute,t.isDead=e.isDead,t.isStaccato=e.isStaccato,t.slideInType=e.slideInType,t.slideOutType=e.slideOutType,t.vibrato=e.vibrato,t.isTieDestination=e.isTieDestination,t.leftHandFinger=e.leftHandFinger,t.rightHandFinger=e.rightHandFinger,t.trillValue=e.trillValue,t.trillSpeed=e.trillSpeed,t.durationPercent=e.durationPercent,t.accidentalMode=e.accidentalMode,t.dynamics=e.dynamics,t.ornament=e.ornament,t}}class Ve{static clone(e){const t=new X;return t.isLinear=e.isLinear,t.type=e.type,t.value=e.value,t.ratioPosition=e.ratioPosition,t.text=e.text,t}}class Ge{static clone(e){const t=new Ue;t.index=e.index,t.notes=[];for(const s of e.notes)t.addNote(We.clone(s));t.isEmpty=e.isEmpty,t.whammyStyle=e.whammyStyle,t.ottava=e.ottava,t.isLegatoOrigin=e.isLegatoOrigin,t.duration=e.duration,t.isLetRing=e.isLetRing,t.isPalmMute=e.isPalmMute,t.automations=[];for(const s of e.automations)t.automations.push(Ve.clone(s));if(t.dots=e.dots,t.fade=e.fade,t.lyrics=e.lyrics?e.lyrics.slice():null,t.pop=e.pop,t.slap=e.slap,t.tap=e.tap,t.text=e.text,t.slashed=e.slashed,t.deadSlapped=e.deadSlapped,t.brushType=e.brushType,t.brushDuration=e.brushDuration,t.tupletDenominator=e.tupletDenominator,t.tupletNumerator=e.tupletNumerator,t.isContinuedWhammy=e.isContinuedWhammy,t.whammyBarType=e.whammyBarType,e.whammyBarPoints){t.whammyBarPoints=[];for(const s of e.whammyBarPoints)t.addWhammyBarPoint(He.clone(s))}return t.vibrato=e.vibrato,t.chordId=e.chordId,t.graceType=e.graceType,t.pickStroke=e.pickStroke,t.tremoloSpeed=e.tremoloSpeed,t.crescendo=e.crescendo,t.displayStart=e.displayStart,t.playbackStart=e.playbackStart,t.displayDuration=e.displayDuration,t.playbackDuration=e.playbackDuration,t.overrideDisplayDuration=e.overrideDisplayDuration,t.golpe=e.golpe,t.dynamics=e.dynamics,t.invertBeamDirection=e.invertBeamDirection,t.preferredBeamDirection=e.preferredBeamDirection,t.isEffectSlurOrigin=e.isEffectSlurOrigin,t.beamingMode=e.beamingMode,t.wahPedal=e.wahPedal,t.barreFret=e.barreFret,t.barreShape=e.barreShape,t.rasgueado=e.rasgueado,t.showTimer=e.showTimer,t.timer=e.timer,t}}!function(e){e[e.None=0]="None",e[e.Thumb=1]="Thumb",e[e.Finger=2]="Finger"}(ue||(ue={})),function(e){e[e.None=0]="None",e[e.FadeIn=1]="FadeIn",e[e.FadeOut=2]="FadeOut",e[e.VolumeSwell=3]="VolumeSwell"}(pe||(pe={})),function(e){e[e.None=0]="None",e[e.Open=1]="Open",e[e.Closed=2]="Closed"}(ge||(ge={})),function(e){e[e.None=0]="None",e[e.Full=1]="Full",e[e.Half=2]="Half"}(me||(me={})),function(e){e[e.None=0]="None",e[e.Ii=1]="Ii",e[e.Mi=2]="Mi",e[e.MiiTriplet=3]="MiiTriplet",e[e.MiiAnapaest=4]="MiiAnapaest",e[e.PmpTriplet=5]="PmpTriplet",e[e.PmpAnapaest=6]="PmpAnapaest",e[e.PeiTriplet=7]="PeiTriplet",e[e.PeiAnapaest=8]="PeiAnapaest",e[e.PaiTriplet=9]="PaiTriplet",e[e.PaiAnapaest=10]="PaiAnapaest",e[e.AmiTriplet=11]="AmiTriplet",e[e.AmiAnapaest=12]="AmiAnapaest",e[e.Ppp=13]="Ppp",e[e.Amii=14]="Amii",e[e.Amip=15]="Amip",e[e.Eami=16]="Eami",e[e.Eamii=17]="Eamii",e[e.Peami=18]="Peami"}(fe||(fe={})),function(e){e[e.Auto=0]="Auto",e[e.ForceSplitToNext=1]="ForceSplitToNext",e[e.ForceMergeWithNext=2]="ForceMergeWithNext",e[e.ForceSplitOnSecondaryToNext=3]="ForceSplitOnSecondaryToNext"}(ye||(ye={})),function(e){e[e.Effects=0]="Effects",e[e.StandardNotationStem=1]="StandardNotationStem",e[e.StandardNotationFlags=2]="StandardNotationFlags",e[e.StandardNotationBeams=3]="StandardNotationBeams",e[e.StandardNotationTuplet=4]="StandardNotationTuplet",e[e.StandardNotationEffects=5]="StandardNotationEffects",e[e.StandardNotationRests=6]="StandardNotationRests",e[e.GuitarTabStem=7]="GuitarTabStem",e[e.GuitarTabFlags=8]="GuitarTabFlags",e[e.GuitarTabBeams=9]="GuitarTabBeams",e[e.GuitarTabTuplet=10]="GuitarTabTuplet",e[e.GuitarTabEffects=11]="GuitarTabEffects",e[e.GuitarTabRests=12]="GuitarTabRests",e[e.SlashStem=13]="SlashStem",e[e.SlashFlags=14]="SlashFlags",e[e.SlashBeams=15]="SlashBeams",e[e.SlashTuplet=16]="SlashTuplet",e[e.SlashRests=17]="SlashRests",e[e.SlashEffects=18]="SlashEffects",e[e.NumberedDuration=19]="NumberedDuration",e[e.NumberedEffects=20]="NumberedEffects",e[e.NumberedRests=21]="NumberedRests",e[e.NumberedTuplet=22]="NumberedTuplet"}(be||(be={}));class ze extends W{}class Ue{constructor(){this.id=Ue._globalBeatId++,this.index=0,this.previousBeat=null,this.nextBeat=null,this.notes=[],this.noteStringLookup=new Map,this.noteValueLookup=new Map,this.isEmpty=!1,this.whammyStyle=y.Default,this.ottava=h.Regular,this.fermata=null,this.isLegatoOrigin=!1,this.minNote=null,this.maxNote=null,this.maxStringNote=null,this.minStringNote=null,this.duration=w.Quarter,this.isLetRing=!1,this.isPalmMute=!1,this.automations=[],this.dots=0,this.fade=pe.None,this.lyrics=null,this.pop=!1,this.slap=!1,this.tap=!1,this.text=null,this.slashed=!1,this.deadSlapped=!1,this.brushType=S.None,this.brushDuration=0,this.tupletDenominator=-1,this.tupletNumerator=-1,this.tupletGroup=null,this.isContinuedWhammy=!1,this.whammyBarType=de.None,this.whammyBarPoints=null,this.maxWhammyPoint=null,this.minWhammyPoint=null,this.vibrato=F.None,this.chordId=null,this.graceType=B.None,this.graceGroup=null,this.graceIndex=-1,this.pickStroke=re.None,this.tremoloSpeed=null,this.crescendo=_.None,this.displayStart=0,this.playbackStart=0,this.displayDuration=0,this.playbackDuration=0,this.golpe=ue.None,this.dynamics=m.F,this.invertBeamDirection=!1,this.preferredBeamDirection=null,this.isEffectSlurOrigin=!1,this.effectSlurOrigin=null,this.effectSlurDestination=null,this.beamingMode=ye.Auto,this.wahPedal=ge.None,this.barreFret=-1,this.barreShape=me.None,this.rasgueado=fe.None,this.showTimer=!1,this.timer=null}static resetIds(){Ue._globalBeatId=0}get isLastOfVoice(){return this.index===this.voice.beats.length-1}get isLegatoDestination(){return!!this.previousBeat&&this.previousBeat.isLegatoOrigin}get isRest(){return this.isEmpty||!this.deadSlapped&&0===this.notes.length}get isFullBarRest(){return this.isRest&&1===this.voice.beats.length&&this.duration===w.Whole}get fadeIn(){return this.fade===pe.FadeIn}set fadeIn(e){this.fade=e?pe.FadeIn:pe.None}get hasRasgueado(){return this.rasgueado!==fe.None}get hasTuplet(){return!(-1===this.tupletDenominator&&-1===this.tupletNumerator||1===this.tupletDenominator&&1===this.tupletNumerator)}get hasWhammyBar(){return null!==this.whammyBarPoints&&this.whammyBarType!==de.None}get hasChord(){return!!this.chordId}get chord(){return this.chordId?this.voice.bar.staff.getChord(this.chordId):null}get isTremolo(){return!!this.tremoloSpeed}get displayEnd(){return this.displayStart+this.displayDuration}get absoluteDisplayStart(){return this.voice.bar.masterBar.start+this.displayStart}get absolutePlaybackStart(){return this.voice.bar.masterBar.start+this.playbackStart}get isEffectSlurDestination(){return!!this.effectSlurOrigin}get isBarre(){return this.barreShape!==me.None&&this.barreFret>=0}addWhammyBarPoint(e){let t=this.whammyBarPoints;null===t&&(t=[],this.whammyBarPoints=t),t.push(e),(!this.maxWhammyPoint||e.value>this.maxWhammyPoint.value)&&(this.maxWhammyPoint=e),(!this.minWhammyPoint||e.value<this.minWhammyPoint.value)&&(this.minWhammyPoint=e),this.whammyBarType===de.None&&(this.whammyBarType=de.Custom)}removeWhammyBarPoint(e){const t=this.whammyBarPoints;if(null===t||e<0||e>=t.length)return;t.splice(e,1);const s=t[e];if(s===this.maxWhammyPoint){this.maxWhammyPoint=null;for(const e of t)(!this.maxWhammyPoint||e.value>this.maxWhammyPoint.value)&&(this.maxWhammyPoint=e)}if(s===this.minWhammyPoint){this.minWhammyPoint=null;for(const e of t)(!this.minWhammyPoint||e.value<this.minWhammyPoint.value)&&(this.minWhammyPoint=e)}}addNote(e){e.beat=this,e.index=this.notes.length,this.notes.push(e),e.isStringed&&this.noteStringLookup.set(e.string,e)}removeNote(e){const t=this.notes.indexOf(e);t>=0&&(this.notes.splice(t,1),e.isStringed&&this.noteStringLookup.delete(e.string))}getAutomation(e){for(let t=0,s=this.automations.length;t<s;t++){const s=this.automations[t];if(s.type===e)return s}return null}getNoteOnString(e){return this.noteStringLookup.has(e)?this.noteStringLookup.get(e):null}calculateDuration(){if(void 0!==this.overrideDisplayDuration)return this.overrideDisplayDuration;if(this.isFullBarRest)return this.voice.bar.masterBar.calculateDuration();let e=U.toTicks(this.duration);return 2===this.dots?e=U.applyDot(e,!0):1===this.dots&&(e=U.applyDot(e,!1)),this.tupletDenominator>0&&this.tupletNumerator>=0&&(e=U.applyTuplet(e,this.tupletNumerator,this.tupletDenominator)),e}updateDurations(){const e=this.calculateDuration();switch(this.playbackDuration=e,this.graceType){case B.BeforeBeat:case B.OnBeat:switch(this.duration){case w.Sixteenth:this.playbackDuration=U.toTicks(w.SixtyFourth);break;case w.ThirtySecond:this.playbackDuration=U.toTicks(w.OneHundredTwentyEighth);break;default:this.playbackDuration=U.toTicks(w.ThirtySecond)}this.displayDuration=0;break;case B.BendGrace:this.playbackDuration/=2,this.displayDuration=0;break;default:this.displayDuration=e;const t=this.previousBeat;t&&t.graceType===B.BendGrace&&(this.playbackDuration=t.playbackDuration)}}finishTuplet(){const e=this.previousBeat;let t=e?e.tupletGroup:null;if((this.hasTuplet||this.graceType!==B.None&&t)&&(e&&t&&t.check(this)||(t=new Oe(this.voice),t.check(this)),this.tupletGroup=t),this.index>0){const e=this.voice.bar.masterBar.calculateDuration(),t=[];for(const s of this.automations)0===s.ratioPosition&&(s.ratioPosition=this.playbackStart/e),s.type!==f.Volume&&t.push(s);this.automations=t}}finish(t,s=null){switch(null===this.getAutomation(f.Instrument)&&0===this.index&&0===this.voice.index&&0===this.voice.bar.index&&0===this.voice.bar.staff.index&&this.automations.push(X.buildInstrumentAutomation(!1,0,this.voice.bar.staff.track.playbackInfo.program)),this.graceType){case B.OnBeat:case B.BeforeBeat:const e=this.graceGroup.beats.length;this.duration=1===e?w.Eighth:2===e?w.Sixteenth:w.ThirtySecond}const i=t?t.notation.notationMode:e.NotationMode.GuitarPro;let a="grad"===this.text||"grad."===this.text;a&&i===e.NotationMode.SongBook&&(this.text="");let r=!1;this.minNote=null,this.maxNote=null,this.minStringNote=null,this.maxStringNote=null;let n=0,o=!1;for(let h=0,l=this.notes.length;h<l;h++){const l=this.notes[h];if(l.dynamics=this.dynamics,l.finish(t,s),l.isLetRing&&(this.isLetRing=!0),l.isPalmMute&&(this.isPalmMute=!0),i===e.NotationMode.SongBook&&l.hasBend&&this.graceType!==B.BendGrace){if(!l.isTieOrigin)switch(l.bendType){case b.Bend:case b.PrebendRelease:case b.PrebendBend:r=!0}a||l.bendStyle===y.Gradual?(a=!0,l.bendStyle=y.Gradual,r=!1):l.bendStyle=y.Fast}l.isVisible&&(n++,(!this.minNote||l.realValue<this.minNote.realValue)&&(this.minNote=l),(!this.maxNote||l.realValue>this.maxNote.realValue)&&(this.maxNote=l),(!this.minStringNote||l.string<this.minStringNote.string)&&(this.minStringNote=l),(!this.maxStringNote||l.string>this.maxStringNote.string)&&(this.maxStringNote=l),l.hasEffectSlur&&(o=!0))}if(o&&(this.effectSlurOrigin?(this.effectSlurOrigin.effectSlurDestination=this.nextBeat,this.effectSlurOrigin.effectSlurDestination&&(this.effectSlurOrigin.effectSlurDestination.effectSlurOrigin=this.effectSlurOrigin),this.effectSlurOrigin=null):(this.isEffectSlurOrigin=!0,this.effectSlurDestination=this.nextBeat,this.effectSlurDestination&&(this.effectSlurDestination.effectSlurOrigin=this))),this.notes.length>0&&0===n&&(this.isEmpty=!0),this.isRest||this.isLetRing&&this.isPalmMute)this.isRest&&this.previousBeat&&t&&t.notation.notationMode===e.NotationMode.GuitarPro&&(this.previousBeat.isLetRing&&(this.isLetRing=!0),this.previousBeat.isPalmMute&&(this.isPalmMute=!0));else{let e=this.previousBeat;for(;e&&e.isRest;)this.isLetRing||(e.isLetRing=!1),this.isPalmMute||(e.isPalmMute=!1),e=e.previousBeat}const h=this.whammyBarPoints,l=null!==h&&h.length>0;if(l){const e=!!this.previousBeat&&this.previousBeat.hasWhammyBar;this.isContinuedWhammy=e}else this.whammyBarType=de.None;if(l&&this.whammyBarType===de.Custom&&(i===e.NotationMode.SongBook&&(this.whammyStyle=a?y.Gradual:y.Fast),4===h.length)){const t=h[0],s=h[1],a=h[2],r=h[3];s.value===a.value&&(t.value<s.value&&s.value<r.value||t.value>s.value&&s.value>r.value?(0===t.value||this.isContinuedWhammy?this.whammyBarType=de.Dive:this.whammyBarType=de.PrediveDive,h.splice(2,1),h.splice(1,1)):t.value>s.value&&s.value<r.value||t.value<s.value&&s.value>r.value?(this.whammyBarType=de.Dip,s.offset!==a.offset&&i!==e.NotationMode.SongBook||h.splice(2,1)):t.value===s.value&&s.value===r.value&&(0===t.value||this.isContinuedWhammy?this.whammyBarType=de.Hold:this.whammyBarType=de.Predive,h.splice(2,1),h.splice(1,1)))}if(this.updateDurations(),r){const e=Ge.clone(this);e.id=Ue._globalBeatId++,e.pickStroke=re.None;for(let t=0,s=e.notes.length;t<s;t++){const s=e.notes[t],i=this.notes[t];if(s.bendType=b.None,s.maxBendPoint=null,s.bendPoints=null,s.bendStyle=y.Default,s.id=Re.GlobalNoteId++,i.isTieOrigin&&(s.tieDestination=i.tieDestination,i.tieDestination.tieOrigin=s),i.isTieDestination&&(s.tieOrigin=i.tieOrigin?i.tieOrigin:null,i.tieOrigin.tieDestination=s),i.hasBend&&i.isTieOrigin){const e=Re.findTieOrigin(i);if(e&&e.hasBend){s.bendType=b.Hold;const e=i.bendPoints[i.bendPoints.length-1];s.addBendPoint(new J(0,e.value)),s.addBendPoint(new J(J.MaxPosition,e.value))}}s.isTieDestination=!0}this.graceType=B.BendGrace,this.graceGroup=new Z,this.graceGroup.addBeat(this),this.graceGroup.isComplete=!0,this.graceGroup.finish(),this.updateDurations(),this.voice.insertBeat(this,e),e.graceGroup=new Z,e.graceGroup.addBeat(this),e.graceGroup.isComplete=!0,e.graceGroup.finish()}}isBefore(e){return this.voice.bar.index<e.voice.bar.index||e.voice.bar.index===this.voice.bar.index&&this.index<e.index}isAfter(e){return this.voice.bar.index>e.voice.bar.index||e.voice.bar.index===this.voice.bar.index&&this.index>e.index}hasNoteOnString(e){return this.noteStringLookup.has(e)}getNoteWithRealValue(e){return this.noteValueLookup.has(e)?this.noteValueLookup.get(e):null}chain(e=null){for(const t of this.notes)this.noteValueLookup.set(t.realValue,t),t.chain(e)}}Ue._globalBeatId=0,function(e){e[e.Title=0]="Title",e[e.SubTitle=1]="SubTitle",e[e.Artist=2]="Artist",e[e.Album=3]="Album",e[e.Words=4]="Words",e[e.Music=5]="Music",e[e.WordsAndMusic=6]="WordsAndMusic",e[e.Transcriber=7]="Transcriber",e[e.Copyright=8]="Copyright",e[e.CopyrightSecondLine=9]="CopyrightSecondLine",e[e.ChordDiagramList=10]="ChordDiagramList"}(Se||(Se={}));class Xe{constructor(e="",t=void 0,s=oe.Left){this.template=e,this.isVisible=t,this.textAlign=s}buildText(e){let t=!1,s=!1;const i=this.template.replace(Xe.PlaceholderPattern,((i,a)=>{s=!0;let r="";switch(a){case"TITLE":r=e.title;break;case"SUBTITLE":r=e.subTitle;break;case"ARTIST":r=e.artist;break;case"ALBUM":r=e.album;break;case"WORDS":case"WORDSMUSIC":r=e.words;break;case"MUSIC":r=e.music;break;case"TABBER":r=e.tab;break;case"COPYRIGHT":r=e.copyright;break;default:r=""}return r&&(t=!0),r}));return s&&!t?"":i}}Xe.PlaceholderPattern=/%([^%]+)%/g;class Je extends W{constructor(){super(...arguments),this.headerAndFooter=new Map}}Je.defaultHeaderAndFooter=new Map([[Se.Title,new Xe("%TITLE%",void 0,oe.Center)],[Se.SubTitle,new Xe("%SUBTITLE%",void 0,oe.Center)],[Se.Artist,new Xe("%ARTIST%",void 0,oe.Center)],[Se.Album,new Xe("%ALBUM%",void 0,oe.Center)],[Se.Words,new Xe("Words by %WORDS%",void 0,oe.Left)],[Se.Music,new Xe("Music by %MUSIC%",void 0,oe.Right)],[Se.WordsAndMusic,new Xe("Words & Music by %MUSIC%",void 0,oe.Right)],[Se.Transcriber,new Xe("Tabbed by %TABBER%",!1,oe.Right)],[Se.Copyright,new Xe("%COPYRIGHT%",void 0,oe.Center)],[Se.CopyrightSecondLine,new Xe("All Rights Reserved - International Copyright Secured",!0,oe.Center)]]);class Ye{constructor(){this._currentRepeatGroup=null,this._openedRepeatGroups=[],this._properlyOpenedRepeatGroups=0,this.album="",this.artist="",this.copyright="",this.instructions="",this.music="",this.notices="",this.subTitle="",this.title="",this.words="",this.tab="",this.tempo=120,this.tempoLabel="",this.masterBars=[],this.tracks=[],this.defaultSystemsLayout=3,this.systemsLayout=[],this.stylesheet=new O}static resetIds(){z.resetIds(),Ue.resetIds(),te.resetIds(),Re.resetIds()}rebuildRepeatGroups(){this._currentRepeatGroup=null,this._openedRepeatGroups=[],this._properlyOpenedRepeatGroups=0;for(const e of this.masterBars)this.addMasterBarToRepeatGroups(e)}addMasterBar(e){e.score=this,e.index=this.masterBars.length,0!==this.masterBars.length&&(e.previousMasterBar=this.masterBars[this.masterBars.length-1],e.previousMasterBar.nextMasterBar=e,e.start=e.previousMasterBar.start+(e.previousMasterBar.isAnacrusis?0:e.previousMasterBar.calculateDuration())),this.addMasterBarToRepeatGroups(e),this.masterBars.push(e)}addMasterBarToRepeatGroups(e){e.isRepeatStart?(this._currentRepeatGroup?.isClosed&&(this._openedRepeatGroups.pop(),this._properlyOpenedRepeatGroups--),this._currentRepeatGroup=new H,this._openedRepeatGroups.push(this._currentRepeatGroup),this._properlyOpenedRepeatGroups++):this._currentRepeatGroup||(this._currentRepeatGroup=new H,this._openedRepeatGroups.push(this._currentRepeatGroup)),this._currentRepeatGroup.addMasterBar(e),e.isRepeatEnd&&this._properlyOpenedRepeatGroups>1&&(this._openedRepeatGroups.pop(),this._properlyOpenedRepeatGroups--,this._currentRepeatGroup=this._openedRepeatGroups.length>0?this._openedRepeatGroups[this._openedRepeatGroups.length-1]:null)}addTrack(e){e.score=this,e.index=this.tracks.length,this.tracks.push(e)}finish(e){const t=new Map;for(let s=0,i=this.tracks.length;s<i;s++)this.tracks[s].finish(e,t)}}class $e{init(e,t){this.data=e,this.settings=t,Ye.resetIds()}}e.AlphaTabErrorType=void 0,(_e=e.AlphaTabErrorType||(e.AlphaTabErrorType={}))[_e.General=0]="General",_e[_e.Format=1]="Format",_e[_e.AlphaTex=2]="AlphaTex";class qe extends Error{constructor(e,t="",s){super(t??"",{cause:s}),this.type=e,Object.setPrototypeOf(this,qe.prototype)}}class je extends qe{constructor(t=null,s){super(e.AlphaTabErrorType.Format,t??"Unsupported format",s),Object.setPrototypeOf(this,je.prototype)}}class Ke{constructor(){this.name="",this.firstFret=1,this.strings=[],this.barreFrets=[],this.showName=!0,this.showDiagram=!0,this.showFingering=!0}get uniqueId(){return[this.name,this.firstFret.toString(),this.strings.join(","),this.barreFrets.join(","),this.showDiagram.toString(),this.showFingering.toString(),this.showName.toString()].join("|")}}!function(e){e[e.IgnoreSpaces=0]="IgnoreSpaces",e[e.Begin=1]="Begin",e[e.Text=2]="Text",e[e.Comment=3]="Comment",e[e.Dash=4]="Dash"}(we||(we={}));class Qe{constructor(){this.startBar=0,this.text=""}finish(e=!1){this.chunks=[],this.parse(this.text,0,this.chunks,e)}parse(e,t,s,i){if(!e)return;let a=we.Begin,r=we.Begin,n=!1,o=0;for(;t<e.length;){const s=e.charCodeAt(t);switch(a){case we.IgnoreSpaces:switch(s){case Qe.CharCodeLF:case Qe.CharCodeCR:case Qe.CharCodeTab:break;case Qe.CharCodeSpace:if(!n){a=r;continue}break;default:n=!1,a=r;continue}break;case we.Begin:if(s!==Qe.CharCodeBrackedOpen){o=t,a=we.Text;continue}a=we.Comment;break;case we.Comment:if(s===Qe.CharCodeBrackedClose)a=we.Begin;break;case we.Text:switch(s){case Qe.CharCodeDash:a=we.Dash;break;case Qe.CharCodeCR:case Qe.CharCodeLF:case Qe.CharCodeSpace:const s=e.substr(o,t-o);this.addChunk(s,i),a=we.IgnoreSpaces,r=we.Begin}break;case we.Dash:if(s!==Qe.CharCodeDash){const s=e.substr(o,t-o);this.addChunk(s,i),n=!0,a=we.IgnoreSpaces,r=we.Begin;continue}}t+=1}a===we.Text&&t!==o&&this.addChunk(e.substr(o,t-o),i)}addChunk(e,t){e=this.prepareChunk(e),(!t||e.length>0&&"-"!==e)&&this.chunks.push(e)}prepareChunk(e){const t=e.split("+").join(" ");let s=t.length;for(;s>0&&"_"===t.charAt(s-1);)s--;return s!==t.length?t.substr(0,s):t}}Qe.CharCodeLF=10,Qe.CharCodeTab=9,Qe.CharCodeCR=13,Qe.CharCodeSpace=32,Qe.CharCodeBrackedClose=93,Qe.CharCodeBrackedOpen=91,Qe.CharCodeDash=45;class Ze{constructor(){this.marker="",this.text=""}}class et extends qe{constructor(t){super(e.AlphaTabErrorType.Format,t),Object.setPrototypeOf(this,et.prototype)}}class tt{constructor(e,t,s,i=255){this.raw=0,this.raw=(255&i)<<24|(255&e)<<16|(255&t)<<8|255&s,this.updateRgba()}updateRgba(){255===this.a?this.rgba=`#${ae.toHexString(this.r,2)}${ae.toHexString(this.g,2)}${ae.toHexString(this.b,2)}`:this.rgba=`rgba(${this.r},${this.g},${this.b},${this.a/255})`}get a(){return this.raw>>24&255}get r(){return this.raw>>16&255}get g(){return this.raw>>8&255}get b(){return 255&this.raw}static random(e=100){return new tt(255*Math.random()|0,255*Math.random()|0,255*Math.random()|0,e)}static fromJson(e){if(e instanceof tt)return e;switch(typeof e){case"number":{const t=new tt(0,0,0,0);return t.raw=e,t.updateRgba(),t}case"string":{const t=e;if(t.startsWith("#")){if(4===t.length)return new tt(17*Number.parseInt(t[1],16),17*Number.parseInt(t[2],16),17*Number.parseInt(t[3],16));if(5===t.length)return new tt(17*Number.parseInt(t[1],16),17*Number.parseInt(t[2],16),17*Number.parseInt(t[3],16),17*Number.parseInt(t[4],16));if(7===t.length)return new tt(Number.parseInt(t.substring(1,3),16),Number.parseInt(t.substring(3,5),16),Number.parseInt(t.substring(5,7),16));if(9===t.length)return new tt(Number.parseInt(t.substring(1,3),16),Number.parseInt(t.substring(3,5),16),Number.parseInt(t.substring(5,7),16),Number.parseInt(t.substring(7,9),16))}else if(t.startsWith("rgba")||t.startsWith("rgb")){const e=t.indexOf("("),s=t.lastIndexOf(")");if(-1===e||-1===s)throw new et("No values specified for rgb/rgba function");const i=t.substring(e+1,s).split(",");if(3===i.length)return new tt(Number.parseInt(i[0]),Number.parseInt(i[1]),Number.parseInt(i[2]));if(4===i.length)return new tt(Number.parseInt(i[0]),Number.parseInt(i[1]),Number.parseInt(i[2]),255*Number.parseFloat(i[3]))}return null}}throw new et("Unsupported format for color")}static toJson(e){return null===e?null:e.raw}}tt.BlackRgb="#000000";class st{constructor(){this.volume=15,this.balance=8,this.port=1,this.program=0,this.primaryChannel=0,this.secondaryChannel=0,this.isMute=!1,this.isSolo=!1}}class it{static getTextForTuning(e,t){const s=it.getTextPartsForTuning(e);return t?s.join(""):s[0]}static getTextPartsForTuning(e,t=-1){return[["C","Db","D","Eb","E","F","Gb","G","Ab","A","Bb","B"][e%12],((e/12|0)+t).toString()]}static getDefaultTuningFor(e){return it._defaultTunings.has(e)?it._defaultTunings.get(e):null}static getPresetsFor(e){switch(e){case 7:return it._sevenStrings;case 6:return it._sixStrings;case 5:return it._fiveStrings;case 4:return it._fourStrings}return[]}static initialize(){it._defaultTunings.set(7,new it("Guitar 7 strings",[64,59,55,50,45,40,35],!0)),it._sevenStrings.push(it._defaultTunings.get(7)),it._defaultTunings.set(6,new it("Guitar Standard Tuning",[64,59,55,50,45,40],!0)),it._sixStrings.push(it._defaultTunings.get(6)),it._sixStrings.push(new it("Guitar Tune down ½ step",[63,58,54,49,44,39],!1)),it._sixStrings.push(new it("Guitar Tune down 1 step",[62,57,53,48,43,38],!1)),it._sixStrings.push(new it("Guitar Tune down 2 step",[60,55,51,46,41,36],!1)),it._sixStrings.push(new it("Guitar Dropped D Tuning",[64,59,55,50,45,38],!1)),it._sixStrings.push(new it("Guitar Dropped D Tuning variant",[64,57,55,50,45,38],!1)),it._sixStrings.push(new it("Guitar Double Dropped D Tuning",[62,59,55,50,45,38],!1)),it._sixStrings.push(new it("Guitar Dropped E Tuning",[66,61,57,52,47,40],!1)),it._sixStrings.push(new it("Guitar Dropped C Tuning",[62,57,53,48,43,36],!1)),it._sixStrings.push(new it("Guitar Open C Tuning",[64,60,55,48,43,36],!1)),it._sixStrings.push(new it("Guitar Open Cm Tuning",[63,60,55,48,43,36],!1)),it._sixStrings.push(new it("Guitar Open C6 Tuning",[64,57,55,48,43,36],!1)),it._sixStrings.push(new it("Guitar Open Cmaj7 Tuning",[64,59,55,52,43,36],!1)),it._sixStrings.push(new it("Guitar Open D Tuning",[62,57,54,50,45,38],!1)),it._sixStrings.push(new it("Guitar Open Dm Tuning",[62,57,53,50,45,38],!1)),it._sixStrings.push(new it("Guitar Open D5 Tuning",[62,57,50,50,45,38],!1)),it._sixStrings.push(new it("Guitar Open D6 Tuning",[62,59,54,50,45,38],!1)),it._sixStrings.push(new it("Guitar Open Dsus4 Tuning",[62,57,55,50,45,38],!1)),it._sixStrings.push(new it("Guitar Open E Tuning",[64,59,56,52,47,40],!1)),it._sixStrings.push(new it("Guitar Open Em Tuning",[64,59,55,52,47,40],!1)),it._sixStrings.push(new it("Guitar Open Esus11 Tuning",[64,59,55,52,45,40],!1)),it._sixStrings.push(new it("Guitar Open F Tuning",[65,60,53,48,45,41],!1)),it._sixStrings.push(new it("Guitar Open G Tuning",[62,59,55,50,43,38],!1)),it._sixStrings.push(new it("Guitar Open Gm Tuning",[62,58,55,50,43,38],!1)),it._sixStrings.push(new it("Guitar Open G6 Tuning",[64,59,55,50,43,38],!1)),it._sixStrings.push(new it("Guitar Open Gsus4 Tuning",[62,60,55,50,43,38],!1)),it._sixStrings.push(new it("Guitar Open A Tuning",[64,61,57,52,45,40],!1)),it._sixStrings.push(new it("Guitar Open Am Tuning",[64,60,57,52,45,40],!1)),it._sixStrings.push(new it("Guitar Nashville Tuning",[64,59,67,62,57,52],!1)),it._sixStrings.push(new it("Bass 6 Strings Tuning",[48,43,38,33,28,23],!1)),it._sixStrings.push(new it("Lute or Vihuela Tuning",[64,59,54,50,45,40],!1)),it._defaultTunings.set(5,new it("Bass 5 Strings Tuning",[43,38,33,28,23],!0)),it._fiveStrings.push(it._defaultTunings.get(5)),it._fiveStrings.push(new it("Banjo Dropped C Tuning",[62,59,55,48,67],!1)),it._fiveStrings.push(new it("Banjo Open D Tuning",[62,57,54,50,69],!1)),it._fiveStrings.push(new it("Banjo Open G Tuning",[62,59,55,50,67],!1)),it._fiveStrings.push(new it("Banjo G Minor Tuning",[62,58,55,50,67],!1)),it._fiveStrings.push(new it("Banjo G Modal Tuning",[62,57,55,50,67],!1)),it._defaultTunings.set(4,new it("Bass Standard Tuning",[43,38,33,28],!0)),it._fourStrings.push(it._defaultTunings.get(4)),it._fourStrings.push(new it("Bass Tune down ½ step",[42,37,32,27],!1)),it._fourStrings.push(new it("Bass Tune down 1 step",[41,36,31,26],!1)),it._fourStrings.push(new it("Bass Tune down 2 step",[39,34,29,24],!1)),it._fourStrings.push(new it("Bass Dropped D Tuning",[43,38,33,26],!1)),it._fourStrings.push(new it("Ukulele C Tuning",[45,40,36,43],!1)),it._fourStrings.push(new it("Ukulele G Tuning",[52,47,43,38],!1)),it._fourStrings.push(new it("Mandolin Standard Tuning",[64,57,50,43],!1)),it._fourStrings.push(new it("Mandolin or Violin Tuning",[76,69,62,55],!1)),it._fourStrings.push(new it("Viola Tuning",[69,62,55,48],!1)),it._fourStrings.push(new it("Cello Tuning",[57,50,43,36],!1))}static findTuning(e){const t=it.getPresetsFor(e.length);for(let s=0,i=t.length;s<i;s++){const i=t[s];let a=!0;for(let t=0,s=e.length;t<s;t++)if(e[t]!==i.tunings[t]){a=!1;break}if(a)return i}return null}constructor(e="",t=null,s=!1){this.isStandard=s,this.name=e,this.tunings=t??[]}finish(){const e=it.findTuning(this.tunings);e&&(this.name=e.name,this.isStandard=e.isStandard),this.name=this.name.trim()}}it._sevenStrings=[],it._sixStrings=[],it._fiveStrings=[],it._fourStrings=[],it._defaultTunings=new Map,it.defaultAccidentals=["","#","","#","","","#","","#","","#",""],it.defaultSteps=["C","C","D","D","E","F","F","G","G","A","A","B"],it.initialize();class at{constructor(){this.index=0,this.bars=[],this.chords=null,this.capo=0,this.transpositionPitch=0,this.displayTranspositionPitch=0,this.stringTuning=new it("",[],!1),this.showSlash=!1,this.showNumbered=!1,this.showTablature=!0,this.showStandardNotation=!0,this.isPercussion=!1,this.standardNotationLineCount=at.DefaultStandardNotationLineCount}get tuning(){return this.stringTuning.tunings}get tuningName(){return this.stringTuning.name}get isStringed(){return this.stringTuning.tunings.length>0}finish(e,t=null){this.stringTuning.finish();for(let s=0,i=this.bars.length;s<i;s++)this.bars[s].finish(e,t)}addChord(e,t){t.staff=this;let s=this.chords;null===s&&(s=new Map,this.chords=s),s.set(e,t)}hasChord(e){return this.chords?.has(e)??!1}getChord(e){return this.chords?.get(e)??null}addBar(e){const t=this.bars;e.staff=this,e.index=t.length,t.length>0&&(e.previousBar=t[t.length-1],e.previousBar.nextBar=e),t.push(e)}}at.DefaultStandardNotationLineCount=5,function(e){e[e.TrackName=0]="TrackName",e[e.BracesAndBrackets=1]="BracesAndBrackets",e[e.SystemSeparator=2]="SystemSeparator",e[e.StringTuning=3]="StringTuning"}(Be||(Be={}));class rt extends W{}class nt{constructor(){this.index=0,this.staves=[],this.playbackInfo=new st,this.color=new tt(200,0,0,255),this.name="",this.isVisibleOnMultiTrack=!0,this.shortName="",this.defaultSystemsLayout=3,this.systemsLayout=[],this.percussionArticulations=[]}addLineBreaks(e){this.lineBreaks||(this.lineBreaks=new Set),this.lineBreaks.add(e)}ensureStaveCount(e){for(;this.staves.length<e;)this.addStaff(new at)}addStaff(e){e.index=this.staves.length,e.track=this,this.staves.push(e)}finish(e,t=null){this.shortName||(this.shortName=this.name,this.shortName.length>nt.ShortNameMaxLength&&(this.shortName=this.shortName.substr(0,nt.ShortNameMaxLength)));for(let s=0,i=this.staves.length;s<i;s++)this.staves[s].finish(e,t)}applyLyrics(e){for(const t of e)t.finish();const t=this.staves[0];for(let s=0;s<e.length;s++){const i=e[s];if(i.startBar>=0&&i.startBar<t.bars.length){let a=t.bars[i.startBar].voices[0].beats[0];for(let t=0;t<i.chunks.length&&a;t++){for(;a&&(a.isEmpty||a.isRest);)a=a.nextBeat;a&&(a.lyrics||(a.lyrics=new Array(e.length),a.lyrics.fill("")),a.lyrics[s]=i.chunks[t],a=a.nextBeat)}}}}}nt.ShortNameMaxLength=10;class ot{static float64ToBytes(e){return ot._dataView.setFloat64(0,e,!0),ot._conversionByteArray}static bytesToInt64LE(e){ot._conversionByteArray.set(e,0);const t=ot._dataView.getBigInt64(0,!0);return t<=Number.MAX_SAFE_INTEGER&&t>=Number.MIN_SAFE_INTEGER?Number(t):Number.MAX_SAFE_INTEGER}static bytesToFloat64LE(e){return ot._conversionByteArray.set(e,0),ot._dataView.getFloat64(0,!0)}static bytesToFloat32LE(e){return ot._conversionByteArray.set(e,0),ot._dataView.getFloat32(0,!0)}static float32BEToBytes(e){return ot._dataView.setFloat32(0,e,!1),ot._conversionByteArray.slice(0,4)}static uint16ToInt16(e){return ot._dataView.setUint16(0,e,!0),ot._dataView.getInt16(0,!0)}static int16ToUint32(e){return ot._dataView.setInt16(0,e,!0),ot._dataView.getUint32(0,!0)}static int32ToUint16(e){return ot._dataView.setInt32(0,e,!0),ot._dataView.getUint16(0,!0)}static int32ToInt16(e){return ot._dataView.setInt32(0,e,!0),ot._dataView.getInt16(0,!0)}static int32ToUint32(e){return ot._dataView.setInt32(0,e,!0),ot._dataView.getUint32(0,!0)}static uint8ToInt8(e){return ot._dataView.setUint8(0,e),ot._dataView.getInt8(0)}}ot._conversionBuffer=new ArrayBuffer(8),ot._conversionByteArray=new Uint8Array(ot._conversionBuffer),ot._dataView=new DataView(ot._conversionBuffer);class ht{static readInt32BE(e){return e.readByte()<<24|e.readByte()<<16|e.readByte()<<8|e.readByte()}static readFloat32BE(e){const t=new Uint8Array(4);return e.read(t,0,t.length),t.reverse(),ot.bytesToFloat32LE(t)}static readFloat64BE(e){const t=new Uint8Array(8);return e.read(t,0,t.length),t.reverse(),ot.bytesToFloat64LE(t)}static readInt32LE(e){const t=e.readByte(),s=e.readByte(),i=e.readByte();return e.readByte()<<24|i<<16|s<<8|t}static readInt64LE(e){const t=new Uint8Array(8);return e.read(t,0,t.length),ot.bytesToInt64LE(t)}static readUInt32LE(e){const t=e.readByte(),s=e.readByte(),i=e.readByte();return e.readByte()<<24|i<<16|s<<8|t}static decodeUInt32LE(e,t){const s=e[t],i=e[t+1],a=e[t+2];return e[t+3]<<24|a<<16|i<<8|s}static readUInt16LE(e){const t=e.readByte(),s=e.readByte();return ot.int32ToUint16(s<<8|t)}static readInt16LE(e){const t=e.readByte(),s=e.readByte();return ot.int32ToInt16(s<<8|t)}static readUInt32BE(e){const t=e.readByte(),s=e.readByte(),i=e.readByte(),a=e.readByte();return ot.int32ToUint32(t<<24|s<<16|i<<8|a)}static readUInt16BE(e){const t=e.readByte(),s=e.readByte();return ot.int32ToInt16(t<<8|s)}static readInt16BE(e){const t=e.readByte(),s=e.readByte();return ot.int32ToInt16(t<<8|s)}static readByteArray(e,t){const s=new Uint8Array(t);return e.read(s,0,t),s}static read8BitChars(e,t){const s=new Uint8Array(t);return e.read(s,0,s.length),ht.toString(s,"utf-8")}static read8BitString(e){let t="",s=e.readByte();for(;0!==s;)t+=String.fromCharCode(s),s=e.readByte();return t}static read8BitStringLength(e,t){let s="",i=-1;for(let a=0;a<t;a++){const t=e.readByte();0===t&&-1===i&&(i=a),s+=String.fromCharCode(t)}const a=s;return i>=0?a.substr(0,i):a}static readSInt8(e){const t=e.readByte();return-256*((255&t)>>7)+(255&t)}static readInt24(e,t){let s=e[t]|e[t+1]<<8|e[t+2]<<16;return 8388608&~s||(s|=255<<24),s}static readInt16(e,t){return ot.int32ToInt16(e[t]|e[t+1]<<8)}static toString(e,t){const s=ht.detectEncoding(e);s&&(t=s),t||(t="utf-8");return new TextDecoder(t).decode(e.buffer)}static detectEncoding(e){return e.length>2&&254===e[0]&&255===e[1]?"utf-16be":e.length>2&&255===e[0]&&254===e[1]?"utf-16le":e.length>4&&0===e[0]&&0===e[1]&&254===e[2]&&255===e[3]?"utf-32be":e.length>4&&255===e[0]&&254===e[1]&&0===e[2]&&0===e[3]?"utf-32le":null}static stringToBytes(e){return(new TextEncoder).encode(e)}static writeInt32BE(e,t){e.writeByte(t>>24&255),e.writeByte(t>>16&255),e.writeByte(t>>8&255),e.writeByte(255&t)}static writeInt32LE(e,t){e.writeByte(255&t),e.writeByte(t>>8&255),e.writeByte(t>>16&255),e.writeByte(t>>24&255)}static writeUInt16LE(e,t){e.writeByte(255&t),e.writeByte(t>>8&255)}static writeInt16LE(e,t){e.writeByte(255&t),e.writeByte(t>>8&255)}static writeInt16BE(e,t){e.writeByte(t>>8&255),e.writeByte(255&t)}static writeFloat32BE(e,t){const s=ot.float32BEToBytes(t);e.write(s,0,s.length)}}class lt{constructor(){this.length=0,this.position=0}get bytesWritten(){return this.position}getBuffer(){return this._buffer}static empty(){return lt.withCapacity(0)}static withCapacity(e){const t=new lt;return t._buffer=new Uint8Array(e),t}static fromBuffer(e){const t=new lt;return t._buffer=e,t.length=e.length,t}static fromString(e){const t=ht.stringToBytes(e);return lt.fromBuffer(t)}reset(){this.position=0}skip(e){this.position+=e}readByte(){return this.length-this.position<=0?-1:this._buffer[this.position++]}read(e,t,s){let i=this.length-this.position;return i>s&&(i=s),i<=0?0:(e.set(this._buffer.subarray(this.position,this.position+i),t),this.position+=i,i)}writeByte(e){const t=this.position+1;this.ensureCapacity(t),this._buffer[this.position]=255&e,t>this.length&&(this.length=t),this.position=t}write(e,t,s){const i=this.position+s;this.ensureCapacity(i);const a=Math.min(s,e.length-t);this._buffer.set(e.subarray(t,t+a),this.position),i>this.length&&(this.length=i),this.position=i}ensureCapacity(e){if(e>this._buffer.length){let t=e;t<256&&(t=256),t<2*this._buffer.length&&(t=2*this._buffer.length);const s=new Uint8Array(t);this.length>0&&s.set(this._buffer.subarray(0,0+this.length),0),this._buffer=s}}readAll(){return this.toArray()}toArray(){const e=new Uint8Array(this.length);return e.set(this._buffer.subarray(0,0+this.length),0),e}copyTo(e){e.write(this._buffer,0,this.length)}}!function(e){e[e.TargetFine=0]="TargetFine",e[e.TargetSegno=1]="TargetSegno",e[e.TargetSegnoSegno=2]="TargetSegnoSegno",e[e.TargetCoda=3]="TargetCoda",e[e.TargetDoubleCoda=4]="TargetDoubleCoda",e[e.JumpDaCapo=5]="JumpDaCapo",e[e.JumpDaCapoAlCoda=6]="JumpDaCapoAlCoda",e[e.JumpDaCapoAlDoubleCoda=7]="JumpDaCapoAlDoubleCoda",e[e.JumpDaCapoAlFine=8]="JumpDaCapoAlFine",e[e.JumpDalSegno=9]="JumpDalSegno",e[e.JumpDalSegnoAlCoda=10]="JumpDalSegnoAlCoda",e[e.JumpDalSegnoAlDoubleCoda=11]="JumpDalSegnoAlDoubleCoda",e[e.JumpDalSegnoAlFine=12]="JumpDalSegnoAlFine",e[e.JumpDalSegnoSegno=13]="JumpDalSegnoSegno",e[e.JumpDalSegnoSegnoAlCoda=14]="JumpDalSegnoSegnoAlCoda",e[e.JumpDalSegnoSegnoAlDoubleCoda=15]="JumpDalSegnoSegnoAlDoubleCoda",e[e.JumpDalSegnoSegnoAlFine=16]="JumpDalSegnoSegnoAlFine",e[e.JumpDaCoda=17]="JumpDaCoda",e[e.JumpDaDoubleCoda=18]="JumpDaDoubleCoda"}(ke||(ke={})),function(e){e[e.Short=0]="Short",e[e.Medium=1]="Medium",e[e.Long=2]="Long"}(Te||(Te={}));class ct{constructor(){this.type=Te.Short,this.length=0}}!function(e){e[e.Up=0]="Up",e[e.Down=1]="Down"}(Ne||(Ne={})),function(e){e[e.No=0]="No",e[e.Eof=1]="Eof",e[e.Number=2]="Number",e[e.DoubleDot=3]="DoubleDot",e[e.Dot=4]="Dot",e[e.String=5]="String",e[e.Tuning=6]="Tuning",e[e.LParensis=7]="LParensis",e[e.RParensis=8]="RParensis",e[e.LBrace=9]="LBrace",e[e.RBrace=10]="RBrace",e[e.Pipe=11]="Pipe",e[e.MetaCommand=12]="MetaCommand",e[e.Multiply=13]="Multiply",e[e.LowerThan=14]="LowerThan"}(xe||(xe={})),function(e){e[e.KnownStaffMeta=0]="KnownStaffMeta",e[e.UnknownStaffMeta=1]="UnknownStaffMeta",e[e.EndOfMetaDetected=2]="EndOfMetaDetected"}(ve||(ve={}));class dt extends qe{constructor(t,s,i,a,r,n,o,h=null){super(e.AlphaTabErrorType.AlphaTex,t),this.position=s,this.line=i,this.col=a,this.nonTerm=r??"",this.expected=n??xe.No,this.symbol=o??xe.No,this.symbolData=h,Object.setPrototypeOf(this,dt.prototype)}static symbolError(e,t,s,i,a,r,n=null){let o=`MalFormed AlphaTex: @${e} (line ${t}, col ${s}): Error on block ${i}`;return a!==r?(o+=`, expected a ${xe[a]} found a ${xe[r]}`,null!==n&&(o+=`: '${n}'`)):o+=`, invalid value: '${n}'`,new dt(o,e,t,s,i,a,r,n)}static errorMessage(e,t,s,i){return new dt(e=`MalFormed AlphaTex: @${t} (line ${s}, col ${i}): ${e}`,t,s,i,null,null,null,null)}}!function(e){e[e.Auto=0]="Auto",e[e.Explicit=1]="Explicit"}(Pe||(Pe={}));class ut extends $e{constructor(){super(...arguments),this._trackChannel=0,this._barIndex=0,this._voiceIndex=0,this._input="",this._ch=ut.Eof,this._curChPos=0,this._line=1,this._col=0,this._lastValidSpot=[0,1,0],this._sy=xe.No,this._syData="",this._allowNegatives=!1,this._allowFloat=!1,this._allowTuning=!1,this._currentDuration=w.QuadrupleWhole,this._currentDynamics=m.PPP,this._currentTuplet=0,this._staffHasExplicitDisplayTransposition=!1,this._staffHasExplicitTuning=!1,this._staffTuningApplied=!1,this._percussionArticulationNames=new Map,this._sustainPedalToBeat=new Map,this._slurs=new Map,this._articulationValueToIndex=new Map,this._accidentalMode=Pe.Explicit,this.logErrors=!1}get name(){return"AlphaTex"}initFromString(e,t){this.data=lt.empty(),this._input=e,this.settings=t,Ye.resetIds()}readScore(){try{if(this.data.length>0&&(this._input=ht.toString(this.data.readAll(),this.settings.importer.encoding)),this._allowTuning=!0,this._lyrics=new Map,this._sustainPedalToBeat=new Map,this.createDefaultScore(),this._curChPos=0,this._line=1,this._col=0,this.saveValidSpot(),this._currentDuration=w.Quarter,this._currentDynamics=m.F,this._currentTuplet=1,this._ch=this.nextChar(),this._sy=this.newSy(),this._sy===xe.LowerThan)throw new je("Unknown start sign '<' (meant to import as XML?)");if(this._sy!==xe.Eof){const e=this.metaData(),t=this.bars();if(!e&&!t)throw new je("No alphaTex data found")}ae.consolidate(this._score),this._score.finish(this.settings),this._score.rebuildRepeatGroups();for(const[e,t]of this._lyrics)this._score.tracks[e].applyLyrics(t);for(const[e,t]of this._sustainPedalToBeat){const s=t.voice.bar.masterBar.calculateDuration();e.ratioPosition=t.playbackStart/s}return this._score}catch(e){if(e instanceof dt)throw new je(e.message,e);throw e}}error(e,t,s=!0){let i,a=!1;s?(i=this._sy,i!==xe.String&&i!==xe.Number&&i!==xe.MetaCommand||(a=!0)):i=t;const r=dt.symbolError(this._lastValidSpot[0],this._lastValidSpot[1],this._lastValidSpot[2],e,t,i,a?this._syData:null);throw this.logErrors&&j.error(this.name,r.message),r}errorMessage(e){const t=dt.errorMessage(e,this._lastValidSpot[0],this._lastValidSpot[1],this._lastValidSpot[2]);throw this.logErrors&&j.error(this.name,t.message),t}createDefaultScore(){this._score=new Ye,this._score.tempo=120,this._score.tempoLabel="",this.newTrack()}newTrack(){this._currentTrack=new nt,this._currentTrack.ensureStaveCount(1),this._currentTrack.playbackInfo.program=25,this._currentTrack.playbackInfo.primaryChannel=this._trackChannel++,this._currentTrack.playbackInfo.secondaryChannel=this._trackChannel++;const e=this._currentTrack.staves[0];e.displayTranspositionPitch=0,e.stringTuning.tunings=it.getDefaultTuningFor(6).tunings,this._articulationValueToIndex.clear(),this.beginStaff(e),this._score.addTrack(this._currentTrack),this._lyrics.set(this._currentTrack.index,[]),this._currentDynamics=m.F}parseClefFromString(e){switch(e.toLowerCase()){case"g2":case"treble":default:return o.G2;case"f4":case"bass":return o.F4;case"c3":case"tenor":return o.C3;case"c4":case"alto":return o.C4;case"n":case"neutral":return o.Neutral}}parseClefFromInt(e){switch(e){case 43:default:return o.G2;case 65:return o.F4;case 48:return o.C3;case 60:return o.C4}}parseTripletFeelFromString(e){switch(e.toLowerCase()){case"no":case"none":default:return A.NoTripletFeel;case"t16":case"triplet-16th":return A.Triplet16th;case"t8":case"triplet-8th":return A.Triplet8th;case"d16":case"dotted-16th":return A.Dotted16th;case"d8":case"dotted-8th":return A.Dotted8th;case"s16":case"scottish-16th":return A.Scottish16th;case"s8":case"scottish-8th":return A.Scottish8th}}parseTripletFeelFromInt(e){switch(e){case 0:default:return A.NoTripletFeel;case 1:return A.Triplet16th;case 2:return A.Triplet8th;case 3:return A.Dotted16th;case 4:return A.Dotted8th;case 5:return A.Scottish16th;case 6:return A.Scottish8th}}parseKeySignature(e){switch(e.toLowerCase()){case"cb":case"cbmajor":case"abminor":return c.Cb;case"gb":case"gbmajor":case"ebminor":return c.Gb;case"db":case"dbmajor":case"bbminor":return c.Db;case"ab":case"abmajor":case"fminor":return c.Ab;case"eb":case"ebmajor":case"cminor":return c.Eb;case"bb":case"bbmajor":case"gminor":return c.Bb;case"f":case"fmajor":case"dminor":return c.F;case"c":case"cmajor":case"aminor":default:return c.C;case"g":case"gmajor":case"eminor":return c.G;case"d":case"dmajor":case"bminor":return c.D;case"a":case"amajor":case"f#minor":return c.A;case"e":case"emajor":case"c#minor":return c.E;case"b":case"bmajor":case"g#minor":return c.B;case"f#":case"f#major":case"d#minor":return c.FSharp;case"c#":case"c#major":case"a#minor":return c.CSharp}}parseKeySignatureType(e){return e.toLowerCase().endsWith("minor")?d.Minor:d.Major}nextChar(){return this._curChPos<this._input.length?(this._ch=this._input.charCodeAt(this._curChPos++),10===this._ch?(this._line++,this._col=0):this._col++):this._ch=ut.Eof,this._ch}saveValidSpot(){this._lastValidSpot=[this._curChPos,this._line,this._col]}newSy(){for(this.saveValidSpot(),this._sy=xe.No;this._sy===xe.No;)if(this._ch===ut.Eof)this._sy=xe.Eof;else if(ut.isWhiteSpace(this._ch))this._ch=this.nextChar(),this.saveValidSpot();else if(47===this._ch){if(this._ch=this.nextChar(),47===this._ch)for(;13!==this._ch&&10!==this._ch&&this._ch!==ut.Eof;)this._ch=this.nextChar();else if(42===this._ch)for(;this._ch!==ut.Eof;)if(42===this._ch){if(this._ch=this.nextChar(),47===this._ch){this._ch=this.nextChar();break}}else this._ch=this.nextChar();else this.error("comment",xe.String,!1);this.saveValidSpot()}else if(34===this._ch||39===this._ch){const e=this._ch;this._ch=this.nextChar();let t="";for(this._sy=xe.String;this._ch!==e&&this._ch!==ut.Eof;)92===this._ch?(this._ch=this.nextChar(),92===this._ch?t+="\\":this._ch===e?t+=String.fromCharCode(this._ch):82===this._ch||114===this._ch?t+="\r":78===this._ch||110===this._ch?t+="\n":84===this._ch||116===this._ch?t+="\t":this.errorMessage("Unsupported escape sequence")):t+=String.fromCharCode(this._ch),this._ch=this.nextChar();this._ch===ut.Eof&&this.errorMessage("String opened but never closed"),this._syData=t,this._ch=this.nextChar()}else if(45===this._ch)this._allowNegatives?this.readNumberOrName():(this._sy=xe.String,this._syData=this.readName());else if(46===this._ch)this._sy=xe.Dot,this._ch=this.nextChar();else if(58===this._ch)this._sy=xe.DoubleDot,this._ch=this.nextChar();else if(40===this._ch)this._sy=xe.LParensis,this._ch=this.nextChar();else if(92===this._ch)this._ch=this.nextChar(),this._sy=xe.MetaCommand,92===this._ch&&(this._ch=this.nextChar()),this._syData=this.readName();else if(41===this._ch)this._sy=xe.RParensis,this._ch=this.nextChar();else if(123===this._ch)this._sy=xe.LBrace,this._ch=this.nextChar();else if(125===this._ch)this._sy=xe.RBrace,this._ch=this.nextChar();else if(124===this._ch)this._sy=xe.Pipe,this._ch=this.nextChar();else if(42===this._ch)this._sy=xe.Multiply,this._ch=this.nextChar();else if(60===this._ch)this._sy=xe.LowerThan,this._ch=this.nextChar();else if(this.isDigit(this._ch))this.readNumberOrName();else if(ut.isNameLetter(this._ch)){const e=this.readName(),t=this._allowTuning?ae.parseTuning(e):null;t?(this._sy=xe.Tuning,this._syData=t):(this._sy=xe.String,this._syData=e)}else this.error("symbol",xe.String,!1);return this._sy}readNumberOrName(){let e="",t=!0;do{e+=String.fromCharCode(this._ch),this.isDigit(this._ch)||(t=!1),this._ch=this.nextChar()}while(this.isDigit(this._ch)||ut.isNameLetter(this._ch));t?(this._sy=xe.Number,this._syData=this._allowFloat?Number.parseFloat(e):Number.parseInt(e)):(this._sy=xe.String,this._syData=e)}static isNameLetter(e){return!ut.isTerminal(e)&&(33<=e&&e<=47||58<=e&&e<=126||128<=e)}static isTerminal(e){return 46===e||123===e||125===e||91===e||93===e||40===e||41===e||124===e||39===e||34===e||42===e||92===e}static isWhiteSpace(e){return 9===e||10===e||11===e||13===e||32===e}isDigit(e){return e>=48&&e<=57||this._allowNegatives&&45===e||this._allowFloat&&46===e}readName(){let e="";do{e+=String.fromCharCode(this._ch),this._ch=this.nextChar()}while(ut.isNameLetter(this._ch)||this.isDigit(this._ch));return e}metaData(){let e=!1,t=!1,s=!0;for(;this._sy===xe.MetaCommand&&s;){const i=this._syData.toLowerCase();switch(i){case"title":case"subtitle":case"artist":case"album":case"words":case"music":case"copyright":case"instructions":case"notices":case"tab":this._sy=this.newSy(),this._sy!==xe.String&&this.error(i,xe.String,!0);const a=this._syData;this._sy=this.newSy(),e=!0;let r=Se.ChordDiagramList;switch(i){case"title":this._score.title=a,r=Se.Title;break;case"subtitle":this._score.subTitle=a,r=Se.SubTitle;break;case"artist":this._score.artist=a,r=Se.Artist;break;case"album":this._score.album=a,r=Se.Album;break;case"words":this._score.words=a,r=Se.Words;break;case"music":this._score.music=a,r=Se.Music;break;case"copyright":this._score.copyright=a,r=Se.Copyright;break;case"instructions":this._score.instructions=a;break;case"notices":this._score.notices=a;break;case"tab":this._score.tab=a,r=Se.Transcriber}r!==Se.ChordDiagramList&&this.headerFooterStyle(r);break;case"copyright2":this._sy=this.newSy(),this._sy!==xe.String&&this.error(i,xe.String,!0),this.headerFooterStyle(Se.CopyrightSecondLine),e=!0;break;case"wordsandmusic":this._sy=this.newSy(),this._sy!==xe.String&&this.error(i,xe.String,!0),this.headerFooterStyle(Se.WordsAndMusic),e=!0;break;case"tempo":this._allowFloat=!0,this._sy=this.newSy(),this._allowFloat=!1,this._sy===xe.Number?this._score.tempo=this._syData:this.error("tempo",xe.Number,!0),this._sy=this.newSy(),this._sy===xe.String&&(this._score.tempoLabel=this._syData,this._sy=this.newSy()),e=!0;break;case"defaultsystemslayout":this._sy=this.newSy(),this._sy===xe.Number?(this._score.defaultSystemsLayout=this._syData,this._sy=this.newSy(),e=!0):this.error("default-systems-layout",xe.Number,!0);break;case"systemslayout":for(this._sy=this.newSy(),e=!0;this._sy===xe.Number;)this._score.systemsLayout.push(this._syData),this._sy=this.newSy();break;case"hidedynamics":this._score.stylesheet.hideDynamics=!0,this._sy=this.newSy(),e=!0;break;case"showdynamics":this._score.stylesheet.hideDynamics=!1,this._sy=this.newSy(),e=!0;break;case"bracketextendmode":this._sy=this.newSy(),this._sy!==xe.String&&this.error("bracketExtendMode",xe.String,!0),this._score.stylesheet.bracketExtendMode=this.parseBracketExtendMode(this._syData),this._sy=this.newSy(),e=!0;break;case"usesystemsignseparator":this._score.stylesheet.useSystemSignSeparator=!0,this._sy=this.newSy(),e=!0;break;case"multibarrest":this._score.stylesheet.multiTrackMultiBarRest=!0,this._sy=this.newSy(),e=!0;break;case"singletracktracknamepolicy":this._sy=this.newSy(),this._sy!==xe.String&&this.error("singleTrackTrackNamePolicy",xe.String,!0),this._score.stylesheet.singleTrackTrackNamePolicy=this.parseTrackNamePolicy(this._syData),this._sy=this.newSy(),e=!0;break;case"multitracktracknamepolicy":this._sy=this.newSy(),this._sy!==xe.String&&this.error("multiTrackTrackNamePolicy",xe.String,!0),this._score.stylesheet.multiTrackTrackNamePolicy=this.parseTrackNamePolicy(this._syData),this._sy=this.newSy(),e=!0;break;case"firstsystemtracknamemode":this._sy=this.newSy(),this._sy!==xe.String&&this.error("firstSystemTrackNameMode",xe.String,!0),this._score.stylesheet.firstSystemTrackNameMode=this.parseTrackNameMode(this._syData),this._sy=this.newSy(),e=!0;break;case"othersystemstracknamemode":this._sy=this.newSy(),this._sy!==xe.String&&this.error("otherSystemsTrackNameMode",xe.String,!0),this._score.stylesheet.otherSystemsTrackNameMode=this.parseTrackNameMode(this._syData),this._sy=this.newSy(),e=!0;break;case"firstsystemtracknameorientation":this._sy=this.newSy(),this._sy!==xe.String&&this.error("firstSystemTrackNameOrientation",xe.String,!0),this._score.stylesheet.firstSystemTrackNameOrientation=this.parseTrackNameOrientation(this._syData),this._sy=this.newSy(),e=!0;break;case"othersystemstracknameorientation":this._sy=this.newSy(),this._sy!==xe.String&&this.error("otherSystemsTrackNameOrientation",xe.String,!0),this._score.stylesheet.otherSystemsTrackNameOrientation=this.parseTrackNameOrientation(this._syData),this._sy=this.newSy(),e=!0;break;default:switch(this.handleStaffMeta()){case ve.KnownStaffMeta:t=!0;break;case ve.UnknownStaffMeta:e||t?this.error("metaDataTags",xe.String,!1):s=!1;break;case ve.EndOfMetaDetected:s=!1}}}return e?(this._sy!==xe.Dot&&this.error("song",xe.Dot,!0),this._sy=this.newSy()):this._sy===xe.Dot&&(this._sy=this.newSy(),e=!0),e||t}headerFooterStyle(e){const t=ae.getOrCreateHeaderFooterStyle(this._score,e);if(void 0===t.isVisible&&(t.isVisible=!0),this._sy===xe.String){const e=this._syData;e?t.template=e:t.isVisible=!1,this._sy=this.newSy()}if(this._sy===xe.String){switch(this._syData.toLowerCase()){case"left":t.textAlign=oe.Left;break;case"center":t.textAlign=oe.Center;break;case"right":t.textAlign=oe.Right}this._sy=this.newSy()}}parseTrackNamePolicy(e){switch(e.toLowerCase()){case"hidden":return a.Hidden;case"allsystems":return a.AllSystems;default:return a.FirstSystem}}parseTrackNameMode(e){return"fullname"===e.toLowerCase()?r.FullName:r.ShortName}parseTrackNameOrientation(e){return"horizontal"===e.toLowerCase()?n.Horizontal:n.Vertical}handleStaffMeta(){switch(this._syData.toLowerCase()){case"capo":return this._sy=this.newSy(),this._sy===xe.Number?this._currentStaff.capo=this._syData:this.error("capo",xe.Number,!0),this._sy=this.newSy(),ve.KnownStaffMeta;case"tuning":this._sy=this.newSy();const e=this._currentStaff.tuning.length;switch(this._staffHasExplicitTuning=!0,this._staffTuningApplied=!1,this._sy){case xe.String:const e=this._syData.toLowerCase();"piano"===e||"none"===e||"voice"===e?this.makeCurrentStaffPitched():this.error("tuning",xe.Tuning,!0),this._sy=this.newSy();break;case xe.Tuning:const t=[];do{const e=this._syData;t.push(e.realValue),this._sy=this.newSy()}while(this._sy===xe.Tuning);this._currentStaff.stringTuning.tunings=t;break;default:this.error("tuning",xe.Tuning,!0)}return this._sy===xe.String&&"hide"===this._syData.toLowerCase()&&(this._score.stylesheet.perTrackDisplayTuning||(this._score.stylesheet.perTrackDisplayTuning=new Map),this._score.stylesheet.perTrackDisplayTuning.set(this._currentTrack.index,!1),this._sy=this.newSy()),e!==this._currentStaff.tuning.length&&(this._currentStaff.chords?.size??0)>0&&this.errorMessage("Tuning must be defined before any chord"),ve.KnownStaffMeta;case"instrument":if(this._sy=this.newSy(),this._staffTuningApplied=!1,this._sy===xe.Number){const e=this._syData;e>=0&&e<=127?this._currentTrack.playbackInfo.program=this._syData:this.error("instrument",xe.Number,!1)}else if(this._sy===xe.String){const e=this._syData.toLowerCase();if("percussion"===e){for(const e of this._currentTrack.staves)this.applyPercussionStaff(e);this._currentTrack.playbackInfo.primaryChannel=Q.PercussionChannel,this._currentTrack.playbackInfo.secondaryChannel=Q.PercussionChannel}else this._currentTrack.playbackInfo.program=R.getValue(e)}else this.error("instrument",xe.Number,!0);return this._sy=this.newSy(),ve.KnownStaffMeta;case"lyrics":this._sy=this.newSy();const t=new Qe;return t.startBar=0,t.text="",this._sy===xe.Number&&(t.startBar=this._syData,this._sy=this.newSy()),this._sy===xe.String?(t.text=this._syData,this._sy=this.newSy()):this.error("lyrics",xe.String,!0),this._lyrics.get(this._currentTrack.index).push(t),ve.KnownStaffMeta;case"chord":this._sy=this.newSy();const s=new Ke;this.chordProperties(s),this._sy===xe.String?(s.name=this._syData,this._sy=this.newSy()):this.error("chord-name",xe.String,!0);for(let e=0;e<this._currentStaff.tuning.length;e++)this._sy===xe.Number?s.strings.push(this._syData):this._sy===xe.String&&"x"===this._syData.toLowerCase()&&s.strings.push(-1),this._sy=this.newSy();return this._currentStaff.addChord(this.getChordId(this._currentStaff,s.name),s),ve.KnownStaffMeta;case"articulation":this._sy=this.newSy();let i="";if(this._sy===xe.String?(i=this._syData,this._sy=this.newSy()):this.error("articulation-name",xe.String,!0),"defaults"===i){for(const[e,t]of Le.instrumentArticulationNames)this._percussionArticulationNames.set(e.toLowerCase(),t),this._percussionArticulationNames.set(ut.toArticulationId(e),t);return ve.KnownStaffMeta}let a=0;return this._sy===xe.Number?(a=this._syData,this._sy=this.newSy()):this.error("articulation-number",xe.Number,!0),Le.instrumentArticulations.has(a)||this.errorMessage(`Unknown articulation ${a}. Refer to https://www.alphatab.net/docs/alphatex/percussion for available ids`),this._percussionArticulationNames.set(i.toLowerCase(),a),ve.KnownStaffMeta;case"accidentals":return this.handleAccidentalMode(),ve.KnownStaffMeta;case"displaytranspose":return this._allowNegatives=!0,this._sy=this.newSy(),this._sy===xe.Number?(this._currentStaff.displayTranspositionPitch=-1*this._syData,this._staffHasExplicitDisplayTransposition=!0):this.error("displaytranspose",xe.Number,!0),this._allowNegatives=!1,this._sy=this.newSy(),ve.KnownStaffMeta;case"transpose":return this._allowNegatives=!0,this._sy=this.newSy(),this._sy===xe.Number?this._currentStaff.transpositionPitch=-1*this._syData:this.error("transpose",xe.Number,!0),this._allowNegatives=!1,this._sy=this.newSy(),ve.KnownStaffMeta;case"track":case"staff":return ve.EndOfMetaDetected;case"voice":return this._sy=this.newSy(),this.handleNewVoice()?ve.EndOfMetaDetected:ve.KnownStaffMeta;default:return ve.UnknownStaffMeta}}handleAccidentalMode(){switch(this._sy=this.newSy(),this._sy!==xe.String&&this.error("accidental-mode",xe.String,!0),this._syData){case"auto":this._accidentalMode=Pe.Auto;break;case"explicit":this._accidentalMode=Pe.Explicit}this._sy=this.newSy()}makeCurrentStaffPitched(){this._currentStaff.stringTuning.tunings=[],this._staffHasExplicitDisplayTransposition||(this._currentStaff.displayTranspositionPitch=0)}static toArticulationId(e){return e.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}applyPercussionStaff(e){e.isPercussion=!0,e.showTablature=!1}chordProperties(e){if(this._sy===xe.LBrace){for(this._sy=this.newSy();this._sy===xe.String;)switch(this._syData.toLowerCase()){case"firstfret":if(this._sy=this.newSy(),this._sy===xe.Number)e.firstFret=this._syData;else this.error("chord-firstfret",xe.Number,!0);this._sy=this.newSy();break;case"showdiagram":switch(this._sy=this.newSy(),this._sy){case xe.String:e.showDiagram="false"!==this._syData.toLowerCase();break;case xe.Number:e.showDiagram=0!==this._syData;break;default:this.error("chord-showdiagram",xe.String,!0)}this._sy=this.newSy();break;case"showfingering":switch(this._sy=this.newSy(),this._sy){case xe.String:e.showDiagram="false"!==this._syData.toLowerCase();break;case xe.Number:e.showFingering=0!==this._syData;break;default:this.error("chord-showfingering",xe.String,!0)}this._sy=this.newSy();break;case"showname":switch(this._sy=this.newSy(),this._sy){case xe.String:e.showName="false"!==this._syData.toLowerCase();break;case xe.Number:e.showName=0!==this._syData;break;default:this.error("chord-showname",xe.String,!0)}this._sy=this.newSy();break;case"barre":for(this._sy=this.newSy();this._sy===xe.Number;)e.barreFrets.push(this._syData),this._sy=this.newSy();break;default:this.error("chord-properties",xe.String,!1)}this._sy!==xe.RBrace&&this.error("chord-properties",xe.RBrace,!0),this._sy=this.newSy()}}bars(){const e=this.bar();for(;this._sy!==xe.Eof;)if(this._sy===xe.Pipe)this._sy=this.newSy(),this.bar();else{if(this._sy!==xe.MetaCommand)break;this.bar()}return e}trackStaffMeta(){if(this._sy!==xe.MetaCommand)return!1;if("track"===this._syData.toLowerCase()&&(this._staffHasExplicitDisplayTransposition=!1,this._staffHasExplicitTuning=!1,this._staffTuningApplied=!1,this._sy=this.newSy(),this._score.masterBars.length>0&&this.newTrack(),this._sy===xe.String&&(this._currentTrack.name=this._syData,this._sy=this.newSy()),this._sy===xe.String&&(this._currentTrack.shortName=this._syData,this._sy=this.newSy()),this.trackProperties()),this._sy===xe.MetaCommand&&"staff"===this._syData.toLowerCase()){if(this._staffHasExplicitDisplayTransposition=!1,this._staffHasExplicitTuning=!1,this._staffTuningApplied=!1,this._sy=this.newSy(),this._currentTrack.staves[0].bars.length>0){const e=this._currentStaff.isPercussion;this._currentTrack.ensureStaveCount(this._currentTrack.staves.length+1),this.beginStaff(this._currentTrack.staves[this._currentTrack.staves.length-1]),e&&this.applyPercussionStaff(this._currentStaff),this._currentDynamics=m.F}this.staffProperties()}return this._sy===xe.MetaCommand&&"voice"===this._syData.toLowerCase()&&(this._sy=this.newSy(),this.handleNewVoice()),!0}handleNewVoice(){if(0===this._voiceIndex&&(0===this._currentStaff.bars.length||1===this._currentStaff.bars.length&&this._currentStaff.bars[0].isEmpty))return!1;for(const e of this._currentStaff.bars){const t=new te;e.addVoice(t)}return this._voiceIndex++,this._barIndex=0,!0}beginStaff(e){this._currentStaff=e,this._slurs.clear(),this._barIndex=0,this._voiceIndex=0}trackProperties(){if(this._sy===xe.LBrace){for(this._sy=this.newSy();this._sy===xe.String;)switch(this._syData.toLowerCase()){case"color":this._sy=this.newSy(),this._sy!==xe.String&&this.error("track-color",xe.String,!0),this._currentTrack.color=tt.fromJson(this._syData),this._sy=this.newSy();break;case"defaultsystemslayout":this._sy=this.newSy(),this._sy===xe.Number?(this._currentTrack.defaultSystemsLayout=this._syData,this._sy=this.newSy()):this.error("default-systems-layout",xe.Number,!0);break;case"systemslayout":for(this._sy=this.newSy();this._sy===xe.Number;)this._currentTrack.systemsLayout.push(this._syData),this._sy=this.newSy();break;case"volume":this._sy=this.newSy(),this._sy!==xe.Number&&this.error("track-volume",xe.Number,!0),this._currentTrack.playbackInfo.volume=ae.clamp(this._syData,0,16),this._sy=this.newSy();break;case"balance":this._sy=this.newSy(),this._sy!==xe.Number&&this.error("track-balance",xe.Number,!0),this._currentTrack.playbackInfo.balance=ae.clamp(this._syData,0,16),this._sy=this.newSy();break;case"mute":this._sy=this.newSy(),this._currentTrack.playbackInfo.isMute=!0;break;case"solo":this._sy=this.newSy(),this._currentTrack.playbackInfo.isSolo=!0;break;case"multibarrest":this._sy=this.newSy(),this._score.stylesheet.perTrackMultiBarRest||(this._score.stylesheet.perTrackMultiBarRest=new Set),this._score.stylesheet.perTrackMultiBarRest.add(this._currentTrack.index);break;default:this.error("track-properties",xe.String,!1)}this._sy!==xe.RBrace&&this.error("track-properties",xe.RBrace,!0),this._sy=this.newSy()}}staffProperties(){if(this._sy!==xe.LBrace)return;this._sy=this.newSy();let e=!1,t=!1,s=!1,i=!1;for(;this._sy===xe.String;)switch(this._syData.toLowerCase()){case"score":e=!0,this._sy=this.newSy(),this._sy===xe.Number&&(this._currentStaff.standardNotationLineCount=this._syData,this._sy=this.newSy());break;case"tabs":t=!0,this._sy=this.newSy();break;case"slash":s=!0,this._sy=this.newSy();break;case"numbered":i=!0,this._sy=this.newSy();break;default:this.error("staff-properties",xe.String,!1)}(e||t||s||i)&&(this._currentStaff.showStandardNotation=e,this._currentStaff.showTablature=t,this._currentStaff.showSlash=s,this._currentStaff.showNumbered=i),this._sy!==xe.RBrace&&this.error("staff-properties",xe.RBrace,!0),this._sy=this.newSy()}bar(){const e=this.trackStaffMeta(),t=this.newBar(this._currentStaff);if(this._currentStaff.bars.length>this._score.masterBars.length){const e=new K;this._score.addMasterBar(e),e.index>0&&(e.timeSignatureDenominator=e.previousMasterBar.timeSignatureDenominator,e.timeSignatureNumerator=e.previousMasterBar.timeSignatureNumerator,e.tripletFeel=e.previousMasterBar.tripletFeel)}const s=this.barMeta(t),i=this._currentTrack.playbackInfo.program;this._staffTuningApplied||this._staffHasExplicitTuning||(this._currentStaff.stringTuning.tunings=[],15===i||i>=24&&i<=31?this._currentStaff.stringTuning.tunings=it.getDefaultTuningFor(6).tunings:i>=32&&i<=39?this._currentStaff.stringTuning.tunings=[43,38,33,28]:40===i||44===i||45===i||48===i||49===i||50===i||51===i?this._currentStaff.stringTuning.tunings=[52,57,50,43]:41===i?this._currentStaff.stringTuning.tunings=[57,50,43,36]:42===i?this._currentStaff.stringTuning.tunings=[45,38,31,24]:43===i?this._currentStaff.stringTuning.tunings=[43,38,33,28]:105===i?this._currentStaff.stringTuning.tunings=[50,47,43,38,55]:106===i?this._currentStaff.stringTuning.tunings=[57,52,45]:107===i?this._currentStaff.stringTuning.tunings=[52,45,38,31]:110===i&&(this._currentStaff.stringTuning.tunings=[64,57,50,43]),this._staffTuningApplied=!0),this._staffHasExplicitDisplayTransposition||(this._currentStaff.displayTranspositionPitch=i>=24&&i<=31||i>=32&&i<=39||43===i?-12:0);let a=!1;const r=t.voices[this._voiceIndex];if(!(this._sy===xe.MetaCommand&&("track"===this._syData.toLowerCase()||"staff"===this._syData.toLowerCase())))for(;this._sy!==xe.Pipe&&this._sy!==xe.Eof&&this.beat(r);)a=!0;if(0===r.beats.length){const e=new Ue;e.isEmpty=!0,r.addBeat(e)}return e||s||a}newBar(e){if(this._barIndex<e.bars.length){const t=e.bars[this._barIndex];return this._barIndex++,t}const t=0===e.bars.length?1:e.bars[0].voices.length,s=new z;e.addBar(s),s.previousBar&&(s.clef=s.previousBar.clef,s.clefOttava=s.previousBar.clefOttava,s.keySignature=s.previousBar.keySignature,s.keySignatureType=s.previousBar.keySignatureType),this._barIndex++;for(let e=0;e<t;e++){const e=new te;s.addVoice(e)}return s}beat(e){this.beatDuration();const t=new Ue;if(e.addBeat(t),this._allowTuning=!this._currentStaff.isPercussion,this._sy===xe.LParensis){for(this._sy=this.newSy(),this.note(t);this._sy!==xe.RParensis&&this._sy!==xe.Eof&&(this._allowTuning=!this._currentStaff.isPercussion,this.note(t)););this._sy!==xe.RParensis&&this.error("note-list",xe.RParensis,!0),this._sy=this.newSy()}else if(this._sy===xe.String&&"r"===this._syData.toLowerCase())this._sy=this.newSy();else if(!this.note(t))return e.beats.splice(e.beats.length-1,1),!1;this._sy===xe.Dot&&(this._allowNegatives=!0,this._sy=this.newSy(),this._allowNegatives=!1,this._sy!==xe.Number&&this.error("duration",xe.Number,!0),this._currentDuration=this.parseDuration(this._syData),this._sy=this.newSy()),t.duration=this._currentDuration,t.dynamics=this._currentDynamics,1===this._currentTuplet||t.hasTuplet||ut.applyTuplet(t,this._currentTuplet);let s=1;this._sy===xe.Multiply&&(this._sy=this.newSy(),this._sy!==xe.Number?this.error("multiplier",xe.Number,!0):s=this._syData,this._sy=this.newSy()),this.beatEffects(t);for(let i=0;i<s-1;i++)e.addBeat(Ge.clone(t));return!0}beatDuration(){if(this._sy===xe.DoubleDot&&(this._allowNegatives=!0,this._sy=this.newSy(),this._allowNegatives=!1,this._sy!==xe.Number&&this.error("duration",xe.Number,!0),this._currentDuration=this.parseDuration(this._syData),this._currentTuplet=1,this._sy=this.newSy(),this._sy===xe.LBrace)){for(this._sy=this.newSy();this._sy===xe.String;){if("tu"===this._syData.toLowerCase())this._sy=this.newSy(),this._sy!==xe.Number&&this.error("duration-tuplet",xe.Number,!0),this._currentTuplet=this._syData,this._sy=this.newSy();else this.error("beat-duration",xe.String,!1)}this._sy!==xe.RBrace&&this.error("beat-duration",xe.RBrace,!0),this._sy=this.newSy()}}beatEffects(e){if(this._sy===xe.LBrace){for(this._sy=this.newSy();this._sy===xe.String;)this.applyBeatEffect(e)||this.error("beat-effects",xe.String,!1);this._sy!==xe.RBrace&&this.error("beat-effects",xe.RBrace,!0),this._sy=this.newSy()}}applyBeatEffect(e){const t=this._syData.toLowerCase();if("f"===t)e.fade=pe.FadeIn;else if("fo"===t)e.fade=pe.FadeOut;else if("vs"===t)e.fade=pe.VolumeSwell;else if("v"===t)e.vibrato=F.Slight;else if("vw"===t)e.vibrato=F.Wide;else if("s"===t)e.slap=!0;else if("p"===t)e.pop=!0;else if("tt"===t)e.tap=!0;else if("txt"===t){if(this._sy=this.newSy(),this._sy!==xe.String)return this.error("beat-text",xe.String,!0),!1;e.text=this._syData}else if("dd"===t)e.dots=2;else if("d"===t)e.dots=1;else if("su"===t)e.pickStroke=re.Up;else if("sd"===t)e.pickStroke=re.Down;else{if("tu"===t){if(this._sy=this.newSy(),this._sy!==xe.Number)return this.error("tuplet",xe.Number,!0),!1;const t=this._syData;if(this._sy=this.newSy(),this._sy===xe.Number){const s=this._syData;this._sy=this.newSy(),e.tupletNumerator=t,e.tupletDenominator=s}else ut.applyTuplet(e,t);return!0}if("tb"===t||"tbe"===t){this._sy=this.newSy();const s="tbe"===t;for(this._sy===xe.String&&(e.whammyBarType=this.parseWhammyType(this._syData),this._sy=this.newSy()),this._sy===xe.String&&(e.whammyStyle=this.parseBendStyle(this._syData),this._sy=this.newSy()),this._sy!==xe.LParensis&&this.error("tremolobar-effect",xe.LParensis,!0),this._allowNegatives=!0,this._allowFloat=!0,this._sy=this.newSy();this._sy!==xe.RParensis&&this._sy!==xe.Eof;){let t=0,i=0;s?(this._sy!==xe.Number&&this.error("tremolobar-effect",xe.Number,!0),t=this._syData,this._sy=this.newSy(),this._sy!==xe.Number&&this.error("tremolobar-effect",xe.Number,!0),i=this._syData):(this._sy!==xe.Number&&this.error("tremolobar-effect",xe.Number,!0),t=0,i=this._syData),e.addWhammyBarPoint(new J(t,i)),this._sy=this.newSy()}if(null!=e.whammyBarPoints){for(;e.whammyBarPoints.length>60;)e.removeWhammyBarPoint(e.whammyBarPoints.length-1);if(s)e.whammyBarPoints.sort(((e,t)=>e.offset-t.offset));else{const t=e.whammyBarPoints.length,s=60/t|0;let i=0;for(;i<t;)e.whammyBarPoints[i].offset=Math.min(60,i*s),i++}}this._allowNegatives=!1,this._allowFloat=!1,this._sy!==xe.RParensis&&this.error("tremolobar-effect",xe.RParensis,!0)}else{if("bu"===t||"bd"===t||"au"===t||"ad"===t){switch(t){case"bu":e.brushType=S.BrushUp;break;case"bd":e.brushType=S.BrushDown;break;case"au":e.brushType=S.ArpeggioUp;break;case"ad":e.brushType=S.ArpeggioDown}return this._sy=this.newSy(),this._sy===xe.Number?(e.brushDuration=this._syData,this._sy=this.newSy(),!0):(e.updateDurations(),"bu"===t||"bd"===t?e.brushDuration=e.playbackDuration/4/e.notes.length:"au"!==t&&"ad"!==t||(e.brushDuration=e.playbackDuration/e.notes.length),!0)}if("ch"===t){this._sy=this.newSy();const t=this._syData,s=this.getChordId(this._currentStaff,t);if(!this._currentStaff.hasChord(s)){const e=new Ke;e.showDiagram=!1,e.name=t,this._currentStaff.addChord(s,e)}e.chordId=s}else{if("gr"===t)return this._sy=this.newSy(),"ob"===this._syData.toLowerCase()?(e.graceType=B.OnBeat,this._sy=this.newSy()):"b"===this._syData.toLowerCase()?(e.graceType=B.BendGrace,this._sy=this.newSy()):e.graceType=B.BeforeBeat,!0;if("dy"===t){this._sy=this.newSy();const t=this._syData.toUpperCase();switch(t){case"PPP":case"PP":case"P":case"MP":case"MF":case"F":case"FF":case"FFF":case"PPPP":case"PPPPP":case"PPPPPP":case"FFFF":case"FFFFF":case"FFFFFF":case"SF":case"SFP":case"SFPP":case"FP":case"RF":case"RFZ":case"SFZ":case"SFFZ":case"FZ":case"N":case"PF":case"SFZP":e.dynamics=m[t]}this._currentDynamics=e.dynamics}else if("cre"===t)e.crescendo=_.Crescendo;else if("dec"===t)e.crescendo=_.Decrescendo;else{if("tempo"===t){const t=this.readTempoAutomation();return e.automations.push(t),e.voice.bar.masterBar.tempoAutomations.push(t),!0}if("tp"===t){if(this._sy=this.newSy(),e.tremoloSpeed=w.Eighth,this._sy===xe.Number){switch(this._syData){case 8:default:e.tremoloSpeed=w.Eighth;break;case 16:e.tremoloSpeed=w.Sixteenth;break;case 32:e.tremoloSpeed=w.ThirtySecond}this._sy=this.newSy()}return!0}if("spd"===t){const t=new V;return t.pedalType=u.Down,t.ratioPosition=e.voice.bar.sustainPedals.length,this._sustainPedalToBeat.set(t,e),e.voice.bar.sustainPedals.push(t),this._sy=this.newSy(),!0}if("spu"===t){const t=new V;return t.pedalType=u.Up,t.ratioPosition=e.voice.bar.sustainPedals.length,this._sustainPedalToBeat.set(t,e),e.voice.bar.sustainPedals.push(t),this._sy=this.newSy(),!0}if("spe"===t){const t=new V;return t.pedalType=u.Up,t.ratioPosition=1,e.voice.bar.sustainPedals.push(t),this._sy=this.newSy(),!0}if("slashed"===t)return e.slashed=!0,this._sy=this.newSy(),!0;if("ds"===t)return e.deadSlapped=!0,this._sy=this.newSy(),!0;if("glpf"===t)return this._sy=this.newSy(),e.golpe=ue.Finger,!0;if("glpt"===t)return this._sy=this.newSy(),e.golpe=ue.Thumb,!0;if("waho"===t)return this._sy=this.newSy(),e.wahPedal=ge.Open,!0;if("wahc"===t)return this._sy=this.newSy(),e.wahPedal=ge.Closed,!0;if("barre"===t){if(this._sy=this.newSy(),this._sy!==xe.Number&&this.error("beat-barre",xe.Number,!0),e.barreFret=this._syData,e.barreShape=me.Full,this._sy=this.newSy(),this._sy===xe.String)switch(this._syData.toLowerCase()){case"full":e.barreShape=me.Full,this._sy=this.newSy();break;case"half":e.barreShape=me.Half,this._sy=this.newSy()}return!0}if("rasg"===t){switch(this._sy=this.newSy(),this._sy!==xe.String&&this.error("rasgueado",xe.String,!0),this._syData.toLowerCase()){case"ii":e.rasgueado=fe.Ii;break;case"mi":e.rasgueado=fe.Mi;break;case"miitriplet":e.rasgueado=fe.MiiTriplet;break;case"miianapaest":e.rasgueado=fe.MiiAnapaest;break;case"pmptriplet":e.rasgueado=fe.PmpTriplet;break;case"pmpanapaest":e.rasgueado=fe.PmpAnapaest;break;case"peitriplet":e.rasgueado=fe.PeiTriplet;break;case"peianapaest":e.rasgueado=fe.PeiAnapaest;break;case"paitriplet":e.rasgueado=fe.PaiTriplet;break;case"paianapaest":e.rasgueado=fe.PaiAnapaest;break;case"amitriplet":e.rasgueado=fe.AmiTriplet;break;case"amianapaest":e.rasgueado=fe.AmiAnapaest;break;case"ppp":e.rasgueado=fe.Ppp;break;case"amii":e.rasgueado=fe.Amii;break;case"amip":e.rasgueado=fe.Amip;break;case"eami":e.rasgueado=fe.Eami;break;case"eamii":e.rasgueado=fe.Eamii;break;case"peami":e.rasgueado=fe.Peami}return this._sy=this.newSy(),!0}if("ot"===t)this._sy=this.newSy(),this._sy!==xe.String&&this.error("beat-ottava",xe.String,!0),e.ottava=this.parseClefOttavaFromString(this._syData);else if("legatoorigin"===t)e.isLegatoOrigin=!0;else{if("instrument"!==t){if("fermata"===t){this._sy=this.newSy(),this._sy!==xe.String&&this.error("fermata",xe.Number,!0);const t=new ct;return t.type=this.parseFermataFromString(this._syData),this._allowFloat=!0,this._sy=this.newSy(),this._sy===xe.Number&&(t.length=this._syData,this._sy=this.newSy()),this._allowFloat=!1,e.fermata=t,!0}if("beam"===t){switch(this._sy=this.newSy(),this._sy!==xe.String&&this.error("beam",xe.Number,!0),this._syData.toLowerCase()){case"invert":e.invertBeamDirection=!0;break;case"up":e.preferredBeamDirection=Ne.Up;break;case"down":e.preferredBeamDirection=Ne.Down;break;case"auto":e.beamingMode=ye.Auto;break;case"split":e.beamingMode=ye.ForceSplitToNext;break;case"merge":e.beamingMode=ye.ForceMergeWithNext;break;case"splitsecondary":e.beamingMode=ye.ForceSplitOnSecondaryToNext}return this._sy=this.newSy(),!0}return"timer"===t&&(e.showTimer=!0,this._sy=this.newSy(),!0)}{this._sy=this.newSy();let t=0;this._sy===xe.Number?t=this._syData:this._sy===xe.String?t=R.getValue(this._syData):this.error("instrument-change",xe.Number,!0);const s=new X;s.isLinear=!1,s.type=f.Instrument,s.value=t,e.automations.push(s)}}}}}}return this._sy=this.newSy(),!0}parseBracketExtendMode(e){switch(e.toLowerCase()){case"nobrackets":return i.NoBrackets;case"groupstaves":default:return i.GroupStaves;case"groupsimilarinstruments":return i.GroupSimilarInstruments}}parseFermataFromString(e){switch(e.toLowerCase()){case"short":return Te.Short;case"medium":default:return Te.Medium;case"long":return Te.Long}}parseClefOttavaFromString(e){switch(e.toLowerCase()){case"15ma":return h._15ma;case"8va":return h._8va;case"regular":default:return h.Regular;case"8vb":return h._8vb;case"15mb":return h._15mb}}getChordId(e,t){return t.toLowerCase()+e.index+e.track.index}static applyTuplet(e,t){switch(t){case 3:e.tupletNumerator=3,e.tupletDenominator=2;break;case 5:e.tupletNumerator=5,e.tupletDenominator=4;break;case 6:e.tupletNumerator=6,e.tupletDenominator=4;break;case 7:e.tupletNumerator=7,e.tupletDenominator=4;break;case 9:e.tupletNumerator=9,e.tupletDenominator=8;break;case 10:e.tupletNumerator=10,e.tupletDenominator=8;break;case 11:e.tupletNumerator=11,e.tupletDenominator=8;break;case 12:e.tupletNumerator=12,e.tupletDenominator=8;break;default:e.tupletNumerator=1,e.tupletDenominator=1}}isNoteText(e){return"x"===e||"-"===e||"r"===e}note(e){let t=!1,s=!1,i=-1,a=-1,r=-1,n=x.Default;switch(this._sy){case xe.Number:i=this._syData,this._currentStaff.isPercussion&&!Le.instrumentArticulations.has(i)&&this.errorMessage(`Unknown percussion articulation ${i}`);break;case xe.String:if(this._currentStaff.isPercussion){const e=this._syData.toLowerCase();this._percussionArticulationNames.has(e)?i=this._percussionArticulationNames.get(e):this.errorMessage(`Unknown percussion articulation '${this._syData}'`)}else t="x"===this._syData,s="-"===this._syData,s||t?i=0:this.error("note-fret",xe.Number,!0);break;case xe.Tuning:0===e.index&&0===e.voice.index&&0===e.voice.bar.index&&this.makeCurrentStaffPitched();const o=this._syData;a=o.octave,r=o.tone.noteValue,this._accidentalMode===Pe.Explicit&&(n=o.tone.accidentalMode);break;default:return!1}this._sy=this.newSy();const o=-1===a&&this._currentStaff.tuning.length>0&&!this._currentStaff.isPercussion;let h=-1;o&&(this._sy!==xe.Dot&&this.error("note",xe.Dot,!0),this._sy=this.newSy(),this._sy!==xe.Number&&this.error("note-string",xe.Number,!0),h=this._syData,(h<1||h>this._currentStaff.tuning.length)&&this.error("note-string",xe.Number,!1),this._sy=this.newSy());const l=new Re;if(o)l.string=this._currentStaff.tuning.length-(h-1),l.isDead=t,l.isTieDestination=s,s||(l.fret=i);else if(this._currentStaff.isPercussion){const e=i;let t=0;if(this._articulationValueToIndex.has(e))t=this._articulationValueToIndex.get(e);else{t=this._currentTrack.percussionArticulations.length;const s=Le.getArticulationByInputMidiNumber(e);null===s&&this.errorMessage(`Unknown articulation value ${e}`),this._currentTrack.percussionArticulations.push(s),this._articulationValueToIndex.set(e,t)}l.percussionArticulation=t}else l.octave=a,l.tone=r,l.accidentalMode=n,l.isTieDestination=s;return e.addNote(l),this.noteEffects(l),!0}noteEffects(e){if(this._sy===xe.LBrace){for(this._sy=this.newSy();this._sy===xe.String;){const t=this._syData.toLowerCase();if("b"===t||"be"===t){this._sy=this.newSy();const s="be"===t;for(this._sy===xe.String&&(e.bendType=this.parseBendType(this._syData),this._sy=this.newSy()),this._sy===xe.String&&(e.bendStyle=this.parseBendStyle(this._syData),this._sy=this.newSy()),this._sy!==xe.LParensis&&this.error("bend-effect",xe.LParensis,!0),this._sy=this.newSy();this._sy!==xe.RParensis&&this._sy!==xe.Eof;){let t=0,i=0;s?(this._sy!==xe.Number&&this.error("bend-effect-value",xe.Number,!0),t=this._syData,this._sy=this.newSy(),this._sy!==xe.Number&&this.error("bend-effect-value",xe.Number,!0),i=this._syData):(this._sy!==xe.Number&&this.error("bend-effect-value",xe.Number,!0),i=this._syData),e.addBendPoint(new J(t,i)),this._sy=this.newSy()}const i=e.bendPoints;if(null!=i){for(;i.length>60;)i.splice(i.length-1,1);if(s)i.sort(((e,t)=>e.offset-t.offset));else{const e=i.length,t=60/(e-1)|0;let s=0;for(;s<e;)i[s].offset=Math.min(60,s*t),s++}}this._sy!==xe.RParensis&&this.error("bend-effect",xe.RParensis,!0),this._sy=this.newSy()}else if("nh"===t)e.harmonicType=N.Natural,e.harmonicValue=ae.deltaFretToHarmonicValue(e.fret),this._sy=this.newSy();else if("ah"===t)e.harmonicType=N.Artificial,e.harmonicValue=this.harmonicValue(e.harmonicValue);else if("th"===t)e.harmonicType=N.Tap,e.harmonicValue=this.harmonicValue(e.harmonicValue);else if("ph"===t)e.harmonicType=N.Pinch,e.harmonicValue=this.harmonicValue(e.harmonicValue);else if("sh"===t)e.harmonicType=N.Semi,e.harmonicValue=this.harmonicValue(e.harmonicValue);else if("fh"===t)e.harmonicType=N.Feedback,e.harmonicValue=this.harmonicValue(e.harmonicValue);else if("tr"===t){this._sy=this.newSy(),this._sy!==xe.Number&&this.error("trill-effect",xe.Number,!0);const t=this._syData;this._sy=this.newSy();let s=w.Sixteenth;if(this._sy===xe.Number){switch(this._syData){case 16:default:s=w.Sixteenth;break;case 32:s=w.ThirtySecond;break;case 64:s=w.SixtyFourth}this._sy=this.newSy()}e.trillValue=t+e.stringTuning,e.trillSpeed=s}else if("v"===t)this._sy=this.newSy(),e.vibrato=F.Slight;else if("sl"===t)this._sy=this.newSy(),e.slideOutType=P.Legato;else if("ss"===t)this._sy=this.newSy(),e.slideOutType=P.Shift;else if("sib"===t)this._sy=this.newSy(),e.slideInType=v.IntoFromBelow;else if("sia"===t)this._sy=this.newSy(),e.slideInType=v.IntoFromAbove;else if("sou"===t)this._sy=this.newSy(),e.slideOutType=P.OutUp;else if("sod"===t)this._sy=this.newSy(),e.slideOutType=P.OutDown;else if("psd"===t)this._sy=this.newSy(),e.slideOutType=P.PickSlideDown;else if("psu"===t)this._sy=this.newSy(),e.slideOutType=P.PickSlideUp;else if("h"===t)this._sy=this.newSy(),e.isHammerPullOrigin=!0;else if("lht"===t)this._sy=this.newSy(),e.isLeftHandTapped=!0;else if("g"===t)this._sy=this.newSy(),e.isGhost=!0;else if("ac"===t)this._sy=this.newSy(),e.accentuated=k.Normal;else if("hac"===t)this._sy=this.newSy(),e.accentuated=k.Heavy;else if("ten"===t)this._sy=this.newSy(),e.accentuated=k.Tenuto;else if("pm"===t)this._sy=this.newSy(),e.isPalmMute=!0;else if("st"===t)this._sy=this.newSy(),e.isStaccato=!0;else if("lr"===t)this._sy=this.newSy(),e.isLetRing=!0;else if("x"===t)this._sy=this.newSy(),e.fret=0,e.isDead=!0;else if("-"===t||"t"===t)this._sy=this.newSy(),e.isTieDestination=!0;else if("lf"===t){this._sy=this.newSy();let t=T.Thumb;this._sy===xe.Number&&(t=this.toFinger(this._syData),this._sy=this.newSy()),e.leftHandFinger=t}else if("rf"===t){this._sy=this.newSy();let t=T.Thumb;this._sy===xe.Number&&(t=this.toFinger(this._syData),this._sy=this.newSy()),e.rightHandFinger=t}else if("acc"===t)this._sy=this.newSy(),this._sy!==xe.String&&this.error("note-accidental",xe.String,!0),e.accidentalMode=ae.parseAccidentalMode(this._syData),this._sy=this.newSy();else if("turn"===t)this._sy=this.newSy(),e.ornament=le.Turn;else if("iturn"===t)this._sy=this.newSy(),e.ornament=le.InvertedTurn;else if("umordent"===t)this._sy=this.newSy(),e.ornament=le.UpperMordent;else if("lmordent"===t)this._sy=this.newSy(),e.ornament=le.LowerMordent;else if("string"===t)this._sy=this.newSy(),e.showStringNumber=!0;else if("hide"===t)this._sy=this.newSy(),e.isVisible=!1;else if("slur"===t){this._sy=this.newSy(),this._sy!==xe.String&&this.error("slur",xe.String,!0);const t=this._syData;if(this._slurs.has(t)){const s=this._slurs.get(t);s.slurDestination=e,e.slurOrigin=s,e.isSlurDestination=!0}else this._slurs.set(t,e);this._sy=this.newSy()}else this.applyBeatEffect(e.beat)||this.error(t,xe.String,!1)}this._sy!==xe.RBrace&&this.error("note-effect",xe.RBrace,!1),this._sy=this.newSy()}}harmonicValue(e){return this._allowNegatives=!0,this._allowFloat=!0,this._sy=this.newSy(),this._sy===xe.Number&&(e=this._syData,this._sy=this.newSy()),this._allowNegatives=!1,this._allowFloat=!1,e}toFinger(e){switch(e){case 1:return T.Thumb;case 2:return T.IndexFinger;case 3:return T.MiddleFinger;case 4:return T.AnnularFinger;case 5:return T.LittleFinger}return T.Thumb}parseDuration(e){switch(e){case-4:return w.QuadrupleWhole;case-2:return w.DoubleWhole;case 1:return w.Whole;case 2:return w.Half;case 4:return w.Quarter;case 8:return w.Eighth;case 16:return w.Sixteenth;case 32:return w.ThirtySecond;case 64:return w.SixtyFourth;case 128:return w.OneHundredTwentyEighth;case 256:return w.TwoHundredFiftySixth;default:return w.Quarter}}parseBendStyle(e){switch(e.toLowerCase()){case"gradual":return y.Gradual;case"fast":return y.Fast;default:return y.Default}}parseBendType(e){switch(e.toLowerCase()){case"none":return b.None;case"custom":default:return b.Custom;case"bend":return b.Bend;case"release":return b.Release;case"bendrelease":return b.BendRelease;case"hold":return b.Hold;case"prebend":return b.Prebend;case"prebendbend":return b.PrebendBend;case"prebendrelease":return b.PrebendRelease}}barMeta(e){let t=!1;const s=e.masterBar;let i=!1;for(;!i&&this._sy===xe.MetaCommand;){t=!0;const a=this._syData.toLowerCase();if("ts"===a)this._sy=this.newSy(),this._sy===xe.String?"common"===this._syData.toLowerCase()?(s.timeSignatureCommon=!0,s.timeSignatureNumerator=4,s.timeSignatureDenominator=4,this._sy=this.newSy()):this.error("timesignature-numerator",xe.String,!0):(this._sy!==xe.Number&&this.error("timesignature-numerator",xe.Number,!0),s.timeSignatureNumerator=this._syData,this._sy=this.newSy(),this._sy!==xe.Number&&this.error("timesignature-denominator",xe.Number,!0),s.timeSignatureDenominator=this._syData,this._sy=this.newSy());else if("ft"===a)s.isFreeTime=!0,this._sy=this.newSy();else if("ro"===a)s.isRepeatStart=!0,this._sy=this.newSy();else if("rc"===a)this._sy=this.newSy(),this._sy!==xe.Number&&this.error("repeatclose",xe.Number,!0),this._syData>2048&&this.error("repeatclose",xe.Number,!1),s.repeatCount=this._syData,this._sy=this.newSy();else if("ae"===a)if(this._sy=this.newSy(),this._sy===xe.LParensis){for(this._sy=this.newSy(),this._sy!==xe.Number&&this.error("alternateending",xe.Number,!0),this.applyAlternateEnding(s);this._sy===xe.Number;)this.applyAlternateEnding(s);this._sy!==xe.RParensis&&this.error("alternateending-list",xe.RParensis,!0),this._sy=this.newSy()}else this._sy!==xe.Number&&this.error("alternateending",xe.Number,!0),this.applyAlternateEnding(s);else if("ks"===a)this._sy=this.newSy(),this._sy!==xe.String&&this.error("keysignature",xe.String,!0),e.keySignature=this.parseKeySignature(this._syData),e.keySignatureType=this.parseKeySignatureType(this._syData),this._sy=this.newSy();else if("clef"===a){switch(this._sy=this.newSy(),this._sy){case xe.String:e.clef=this.parseClefFromString(this._syData);break;case xe.Number:e.clef=this.parseClefFromInt(this._syData);break;case xe.Tuning:const t=this._syData;e.clef=this.parseClefFromInt(t.realValue);break;default:this.error("clef",xe.String,!0)}this._sy=this.newSy()}else if("tempo"===a){const e=this.readTempoAutomation();s.tempoAutomations.push(e)}else if("section"===a){this._sy=this.newSy(),this._sy!==xe.String&&this.error("section",xe.String,!0);let e=this._syData;this._sy=this.newSy();let t="";this._sy!==xe.String||this.isNoteText(this._syData.toLowerCase())||(t=e,e=this._syData,this._sy=this.newSy());const i=new Ze;i.marker=t,i.text=e,s.section=i}else if("tf"===a){switch(this._allowTuning=!1,this._sy=this.newSy(),this._allowTuning=!0,this._sy){case xe.String:s.tripletFeel=this.parseTripletFeelFromString(this._syData);break;case xe.Number:s.tripletFeel=this.parseTripletFeelFromInt(this._syData);break;default:this.error("triplet-feel",xe.String,!0)}this._sy=this.newSy()}else if("ac"===a)s.isAnacrusis=!0,this._sy=this.newSy();else if("db"===a)s.isDoubleBar=!0,e.barLineRight=g.LightLight,this._sy=this.newSy();else if("barlineleft"===a)this._sy=this.newSy(),this._sy!==xe.String&&this.error("barlineleft",xe.String,!0),e.barLineLeft=this.parseBarLineStyle(this._syData),this._sy=this.newSy();else if("barlineright"===a)this._sy=this.newSy(),this._sy!==xe.String&&this.error("barlineright",xe.String,!0),e.barLineRight=this.parseBarLineStyle(this._syData),this._sy=this.newSy();else if("accidentals"===a)this.handleAccidentalMode();else if("jump"===a)this.handleDirections(s);else if("ottava"===a)this._sy=this.newSy(),this._sy!==xe.String&&this.error("ottava",xe.String,!0),e.clefOttava=this.parseClefOttavaFromString(this._syData),this._sy=this.newSy();else if("simile"===a)this._sy=this.newSy(),this._sy!==xe.String&&this.error("simile",xe.String,!0),e.simileMark=this.parseSimileMarkFromString(this._syData),this._sy=this.newSy();else if("scale"===a)this._allowFloat=!0,this._sy=this.newSy(),this._allowFloat=!1,this._sy!==xe.Number&&this.error("scale",xe.Number,!0),s.displayScale=this._syData,e.displayScale=this._syData,this._sy=this.newSy();else if("width"===a)this._sy=this.newSy(),this._sy!==xe.Number&&this.error("width",xe.Number,!0),s.displayWidth=this._syData,e.displayWidth=this._syData,this._sy=this.newSy();else if(0===e.index)switch(this.handleStaffMeta()){case ve.KnownStaffMeta:break;case ve.UnknownStaffMeta:this.error("measure-effects",xe.String,!1);break;case ve.EndOfMetaDetected:i=!0}else if(this.handleStaffMeta()===ve.EndOfMetaDetected)i=!0;else this.error("measure-effects",xe.String,!1)}if(0===s.index&&0===s.tempoAutomations.length){const e=new X;e.isLinear=!1,e.type=f.Tempo,e.value=this._score.tempo,e.text=this._score.tempoLabel,s.tempoAutomations.push(e)}return t}parseBarLineStyle(e){switch(e.toLowerCase()){case"automatic":return g.Automatic;case"dashed":return g.Dashed;case"dotted":return g.Dotted;case"heavy":return g.Heavy;case"heavyheavy":return g.HeavyHeavy;case"heavylight":return g.HeavyLight;case"lightheavy":return g.LightHeavy;case"lightlight":return g.LightLight;case"none":return g.None;case"regular":return g.Regular;case"short":return g.Short;case"tick":return g.Tick}return g.Automatic}parseSimileMarkFromString(e){switch(e.toLowerCase()){case"none":default:return l.None;case"simple":return l.Simple;case"firstofdouble":return l.FirstOfDouble;case"secondofdouble":return l.SecondOfDouble}}handleDirections(e){switch(this._sy=this.newSy(),this._sy!==xe.String&&this.error("direction",xe.String,!0),this._syData.toLowerCase()){case"fine":e.addDirection(ke.TargetFine);break;case"segno":e.addDirection(ke.TargetSegno);break;case"segnosegno":e.addDirection(ke.TargetSegnoSegno);break;case"coda":e.addDirection(ke.TargetCoda);break;case"doublecoda":e.addDirection(ke.TargetDoubleCoda);break;case"dacapo":e.addDirection(ke.JumpDaCapo);break;case"dacapoalcoda":e.addDirection(ke.JumpDaCapoAlCoda);break;case"dacapoaldoublecoda":e.addDirection(ke.JumpDaCapoAlDoubleCoda);break;case"dacapoalfine":e.addDirection(ke.JumpDaCapoAlFine);break;case"dalsegno":e.addDirection(ke.JumpDalSegno);break;case"dalsegnoalcoda":e.addDirection(ke.JumpDalSegnoAlCoda);break;case"dalsegnoaldoublecoda":e.addDirection(ke.JumpDalSegnoAlDoubleCoda);break;case"dalsegnoalfine":e.addDirection(ke.JumpDalSegnoAlFine);break;case"dalsegnosegno":e.addDirection(ke.JumpDalSegnoSegno);break;case"dalsegnosegnoalcoda":e.addDirection(ke.JumpDalSegnoSegnoAlCoda);break;case"dalsegnosegnoaldoublecoda":e.addDirection(ke.JumpDalSegnoSegnoAlDoubleCoda);break;case"dalsegnosegnoalfine":e.addDirection(ke.JumpDalSegnoSegnoAlFine);break;case"dacoda":e.addDirection(ke.JumpDaCoda);break;case"dadoublecoda":e.addDirection(ke.JumpDaDoubleCoda);break;default:return void this.errorMessage(`Unexpected direction value: '${this._syData}'`)}this._sy=this.newSy()}readTempoAutomation(){this._allowFloat=!0,this._sy=this.newSy(),this._allowFloat=!1,this._sy!==xe.Number&&this.error("tempo",xe.Number,!0);const e=new X;return e.isLinear=!1,e.type=f.Tempo,e.value=this._syData,this._sy=this.newSy(),this._sy===xe.String&&(e.text=this._syData,this._sy=this.newSy()),e}applyAlternateEnding(e){const t=this._syData;t<1&&this.error("alternateending",xe.Number,!0),e.alternateEndings|=1<<t-1,this._sy=this.newSy()}parseWhammyType(e){switch(e.toLowerCase()){case"none":return de.None;case"custom":default:return de.Custom;case"dive":return de.Dive;case"dip":return de.Dip;case"hold":return de.Hold;case"predive":return de.Predive;case"predivedive":return de.PrediveDive}}}ut.Eof=0;class pt extends $e{constructor(){super(...arguments),this._versionNumber=0,this._globalTripletFeel=A.NoTripletFeel,this._lyricsTrack=0,this._lyrics=[],this._barCount=0,this._trackCount=0,this._playbackInfos=[],this._doubleBars=new Set,this._keySignatures=new Map,this._beatTextChunksByTrack=new Map,this._directionLookup=new Map}get name(){return"Guitar Pro 3-5"}readScore(){if(this._directionLookup.clear(),this.readVersion(),this._score=new Ye,this.readScoreInformation(),this._versionNumber<500&&(this._globalTripletFeel=gt.gpReadBool(this.data)?A.Triplet8th:A.NoTripletFeel),this._versionNumber>=400&&this.readLyrics(),this._versionNumber>=510&&this.data.skip(19),this._versionNumber>=500&&(this.readPageSetup(),this._score.tempoLabel=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding)),this._score.tempo=ht.readInt32LE(this.data),this._versionNumber>=510&&gt.gpReadBool(this.data),ht.readInt32LE(this.data),this._versionNumber>=400&&this.data.readByte(),this.readPlaybackInfos(),this._versionNumber>=500&&(this.readDirection(ke.TargetCoda),this.readDirection(ke.TargetDoubleCoda),this.readDirection(ke.TargetSegno),this.readDirection(ke.TargetSegnoSegno),this.readDirection(ke.TargetFine),this.readDirection(ke.JumpDaCapo),this.readDirection(ke.JumpDaCapoAlCoda),this.readDirection(ke.JumpDaCapoAlDoubleCoda),this.readDirection(ke.JumpDaCapoAlFine),this.readDirection(ke.JumpDalSegno),this.readDirection(ke.JumpDalSegnoAlCoda),this.readDirection(ke.JumpDalSegnoAlDoubleCoda),this.readDirection(ke.JumpDalSegnoAlFine),this.readDirection(ke.JumpDalSegnoSegno),this.readDirection(ke.JumpDalSegnoSegnoAlCoda),this.readDirection(ke.JumpDalSegnoSegnoAlDoubleCoda),this.readDirection(ke.JumpDalSegnoSegnoAlFine),this.readDirection(ke.JumpDaCoda),this.readDirection(ke.JumpDaDoubleCoda),this.data.skip(4)),this._barCount=ht.readInt32LE(this.data),this._trackCount=ht.readInt32LE(this.data),this.readMasterBars(),this.readTracks(),this.readBars(),this._score.masterBars.length>0){const e=X.buildTempoAutomation(!1,0,this._score.tempo,2);e.text=this._score.tempoLabel,this._score.masterBars[0].tempoAutomations.push(e)}return ae.consolidate(this._score),this._score.finish(this.settings),this._lyrics&&this._lyricsTrack>=0&&this._score.tracks[this._lyricsTrack].applyLyrics(this._lyrics),this._score}readDirection(e){let t,s=ht.readInt16LE(this.data);-1!==s&&(s--,this._directionLookup.has(s)?t=this._directionLookup.get(s):(t=[],this._directionLookup.set(s,t)),t.push(e))}readVersion(){let e=gt.gpReadStringByteLength(this.data,30,this.settings.importer.encoding);if(!e.startsWith(pt.VersionString))throw new je("Unsupported format");e=e.substr(pt.VersionString.length+1);const t=e.indexOf(String.fromCharCode(46));this._versionNumber=100*Number.parseInt(e.substr(0,t))+Number.parseInt(e.substr(t+1)),j.debug(this.name,`Guitar Pro version ${e} detected`)}readScoreInformation(){this._score.title=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding),this._score.subTitle=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding),this._score.artist=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding),this._score.album=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding),this._score.words=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding),this._score.music=this._versionNumber>=500?gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding):this._score.words,this._score.copyright=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding),this._score.tab=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding),this._score.instructions=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding);const e=ht.readInt32LE(this.data);let t="";for(let s=0;s<e;s++)s>0&&(t+="\r\n"),t+=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding)?.toString();this._score.notices=t}readLyrics(){this._lyrics=[],this._lyricsTrack=ht.readInt32LE(this.data)-1;for(let e=0;e<5;e++){const e=new Qe;e.startBar=ht.readInt32LE(this.data)-1,e.text=gt.gpReadStringInt(this.data,this.settings.importer.encoding),this._lyrics.push(e)}}readPageSetup(){this.data.skip(28);const e=ht.readInt16LE(this.data);ae.getOrCreateHeaderFooterStyle(this._score,Se.Title).isVisible=!!(1&e),ae.getOrCreateHeaderFooterStyle(this._score,Se.Title).template=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),ae.getOrCreateHeaderFooterStyle(this._score,Se.SubTitle).isVisible=!!(2&e),ae.getOrCreateHeaderFooterStyle(this._score,Se.SubTitle).template=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),ae.getOrCreateHeaderFooterStyle(this._score,Se.Artist).isVisible=!!(4&e),ae.getOrCreateHeaderFooterStyle(this._score,Se.Artist).template=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),ae.getOrCreateHeaderFooterStyle(this._score,Se.Album).isVisible=!!(8&e),ae.getOrCreateHeaderFooterStyle(this._score,Se.Album).template=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),ae.getOrCreateHeaderFooterStyle(this._score,Se.Words).isVisible=!!(16&e),ae.getOrCreateHeaderFooterStyle(this._score,Se.Words).template=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),ae.getOrCreateHeaderFooterStyle(this._score,Se.Music).isVisible=!!(32&e),ae.getOrCreateHeaderFooterStyle(this._score,Se.Music).template=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),ae.getOrCreateHeaderFooterStyle(this._score,Se.WordsAndMusic).isVisible=!!(64&e),ae.getOrCreateHeaderFooterStyle(this._score,Se.WordsAndMusic).template=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),ae.getOrCreateHeaderFooterStyle(this._score,Se.Copyright).isVisible=!!(128&e),ae.getOrCreateHeaderFooterStyle(this._score,Se.Copyright).template=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),ae.getOrCreateHeaderFooterStyle(this._score,Se.CopyrightSecondLine).isVisible=!!(128&e),ae.getOrCreateHeaderFooterStyle(this._score,Se.CopyrightSecondLine).template=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),gt.gpReadStringIntByte(this.data,this.settings.importer.encoding)}readPlaybackInfos(){this._playbackInfos=[];let e=0;for(let t=0;t<64;t++){const t=new st;t.primaryChannel=e++,t.secondaryChannel=e++,t.program=ht.readInt32LE(this.data),t.volume=this.data.readByte(),t.balance=this.data.readByte(),this.data.skip(6),this._playbackInfos.push(t)}}readMasterBars(){for(let e=0;e<this._barCount;e++)this.readMasterBar()}readMasterBar(){let e=null;this._score.masterBars.length>0&&(e=this._score.masterBars[this._score.masterBars.length-1]);const t=new K,s=this.data.readByte();if(1&s?t.timeSignatureNumerator=this.data.readByte():e&&(t.timeSignatureNumerator=e.timeSignatureNumerator),2&s?t.timeSignatureDenominator=this.data.readByte():e&&(t.timeSignatureDenominator=e.timeSignatureDenominator),t.isRepeatStart=!!(4&s),8&s&&(t.repeatCount=this.data.readByte()+(this._versionNumber>=500?0:1)),16&s&&this._versionNumber<500){let s=e,i=0;for(;s&&(!s.isRepeatEnd||s===e)&&!s.isRepeatStart;)i|=s.alternateEndings,s=s.previousMasterBar;let a=0;const r=this.data.readByte();for(let e=0;e<8;e++){const t=1<<e;r>e&&!(i&t)&&(a|=t)}t.alternateEndings=a}if(32&s){const e=new Ze;e.text=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),e.marker="",gt.gpReadColor(this.data,!1),t.section=e}if(64&s&&this._keySignatures.set(this._score.masterBars.length,[ht.readSInt8(this.data),this.data.readByte()]),this._versionNumber>=500&&3&s&&this.data.skip(4),this._versionNumber>=500&&(t.alternateEndings=this.data.readByte()),this._versionNumber>=500){switch(this.data.readByte()){case 1:t.tripletFeel=A.Triplet8th;break;case 2:t.tripletFeel=A.Triplet16th}this.data.readByte()}else t.tripletFeel=this._globalTripletFeel;const i=!!(128&s);t.isDoubleBar=i;const a=this._score.masterBars.length;if(this._directionLookup.has(a))for(const e of this._directionLookup.get(a))t.addDirection(e);this._score.addMasterBar(t),i&&this._doubleBars.add(t.index)}readTracks(){for(let e=0;e<this._trackCount;e++)this.readTrack()}readTrack(){const e=new nt;e.ensureStaveCount(1),this._score.addTrack(e);const t=e.staves[0],s=this.data.readByte();e.name=gt.gpReadStringByteLength(this.data,40,this.settings.importer.encoding),1&s&&(t.isPercussion=!0),this._versionNumber>=500&&(e.isVisibleOnMultiTrack=!!(8&s)),null===this._score.stylesheet.perTrackDisplayTuning&&(this._score.stylesheet.perTrackDisplayTuning=new Map),this._score.stylesheet.perTrackDisplayTuning.set(e.index,!!(128&s));const i=ht.readInt32LE(this.data),a=[];for(let e=0;e<7;e++){const t=ht.readInt32LE(this.data);i>e&&a.push(t)}t.stringTuning.tunings=a;const r=ht.readInt32LE(this.data),n=ht.readInt32LE(this.data)-1,o=ht.readInt32LE(this.data)-1;if(this.data.skip(4),n>=0&&n<this._playbackInfos.length){const i=this._playbackInfos[n];i.port=r,i.isSolo=!!(16&s),i.isMute=!!(32&s),i.secondaryChannel=o,R.isGuitar(i.program)&&(t.displayTranspositionPitch=-12),e.playbackInfo=i}if(t.capo=ht.readInt32LE(this.data),e.color=gt.gpReadColor(this.data,!1),this._versionNumber>=500){const s=this.data.readByte();t.showTablature=!!(1&s),t.showStandardNotation=!!(2&s);const i=!!(100&s);null===this._score.stylesheet.perTrackChordDiagramsOnTop&&(this._score.stylesheet.perTrackChordDiagramsOnTop=new Map),this._score.stylesheet.perTrackChordDiagramsOnTop.set(e.index,i),this.data.readByte(),this.data.skip(43)}this._versionNumber>=510&&(this.data.skip(4),gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),gt.gpReadStringIntByte(this.data,this.settings.importer.encoding))}readBars(){for(let e=0;e<this._barCount;e++)for(let e=0;e<this._trackCount;e++)this.readBar(this._score.tracks[e])}readBar(e){const t=new z,s=e.staves[0];if(s.isPercussion&&(t.clef=o.Neutral),s.addBar(t),this._keySignatures.has(t.index)){const e=this._keySignatures.get(t.index);t.keySignature=e[0],t.keySignatureType=e[1]}else t.index>0&&(t.keySignature=t.previousBar.keySignature,t.keySignatureType=t.previousBar.keySignatureType);this._doubleBars.has(t.index)&&(t.barLineRight=g.LightLight);let i=1;this._versionNumber>=500&&(this.data.readByte(),i=2);for(let s=0;s<i;s++)this.readVoice(e,t)}readVoice(e,t){const s=ht.readInt32LE(this.data);if(0===s)return;const i=new te;t.addVoice(i);for(let a=0;a<s;a++)this.readBeat(e,t,i)}readBeat(e,t,s){const i=new Ue,a=this.data.readByte();if(1&a&&(i.dots=1),64&a){const e=this.data.readByte();i.isEmpty=!(2&e)}s.addBeat(i);switch(ht.readSInt8(this.data)){case-2:i.duration=w.Whole;break;case-1:i.duration=w.Half;break;case 0:i.duration=w.Quarter;break;case 1:i.duration=w.Eighth;break;case 2:i.duration=w.Sixteenth;break;case 3:i.duration=w.ThirtySecond;break;case 4:i.duration=w.SixtyFourth;break;default:i.duration=w.Quarter}if(32&a)switch(i.tupletNumerator=ht.readInt32LE(this.data),i.tupletNumerator){case 1:i.tupletDenominator=1;break;case 3:i.tupletDenominator=2;break;case 5:case 6:case 7:i.tupletDenominator=4;break;case 9:case 10:case 11:case 12:case 13:i.tupletDenominator=8;break;case 2:case 4:case 8:break;default:i.tupletNumerator=1,i.tupletDenominator=1}2&a&&this.readChord(i);const r=this.settings.importer.beatTextAsLyrics&&e.index!==this._lyricsTrack;if(4&a){const t=gt.gpReadStringIntUnused(this.data,this.settings.importer.encoding);if(r){const s=new Qe;s.text=t.trim(),s.finish(!0);const i=[];for(let e=s.chunks.length-1;e>=0;e--)i.push(s.chunks[e]);this._beatTextChunksByTrack.set(e.index,i)}else i.text=t}let n=N.None;8&a&&(n=this.readBeatEffects(i)),16&a&&this.readMixTableChange(i);const o=this.data.readByte();for(let a=6;a>=0;a--)if(o&1<<a&&6-a<t.staff.tuning.length){const r=this.readNote(e,t,s,i,6-a);n!==N.None&&(r.harmonicType=n,r.harmonicType===N.Natural&&(r.harmonicValue=ae.deltaFretToHarmonicValue(r.fret)))}if(this._versionNumber>=500){const e=ht.readInt16LE(this.data);if(1&e&&i.index>0&&(s.beats[i.index-1].beamingMode=ye.ForceSplitToNext),2&e&&(i.preferredBeamDirection=Ne.Down),4&e&&i.index>0&&(s.beats[i.index-1].beamingMode=ye.ForceMergeWithNext),8&e&&(i.preferredBeamDirection=Ne.Up),16&e&&(i.ottava=h._8va),32&e&&(i.ottava=h._8vb),64&e&&(i.ottava=h._15ma),256&e&&(i.ottava=h._15mb),2048&e){const e=0!==this.data.readByte();i.index>0&&e&&(s.beats[i.index-1].beamingMode=ye.ForceSplitOnSecondaryToNext)}}r&&!i.isRest&&this._beatTextChunksByTrack.has(e.index)&&this._beatTextChunksByTrack.get(e.index).length>0&&(i.lyrics=[this._beatTextChunksByTrack.get(e.index).pop()])}readChord(e){const t=new Ke,s=ae.newGuid();if(this._versionNumber>=500){this.data.skip(17),t.name=gt.gpReadStringByteLength(this.data,21,this.settings.importer.encoding),this.data.skip(4),t.firstFret=ht.readInt32LE(this.data);for(let s=0;s<7;s++){const i=ht.readInt32LE(this.data);s<e.voice.bar.staff.tuning.length&&t.strings.push(i)}const s=this.data.readByte(),i=new Uint8Array(5);this.data.read(i,0,i.length);for(let e=0;e<s;e++)t.barreFrets.push(i[e]);this.data.skip(26)}else if(0!==this.data.readByte())if(this._versionNumber>=400){this.data.skip(16),t.name=gt.gpReadStringByteLength(this.data,21,this.settings.importer.encoding),this.data.skip(4),t.firstFret=ht.readInt32LE(this.data);for(let s=0;s<7;s++){const i=ht.readInt32LE(this.data);s<e.voice.bar.staff.tuning.length&&t.strings.push(i)}const s=this.data.readByte(),i=new Uint8Array(5);this.data.read(i,0,i.length);for(let e=0;e<s;e++)t.barreFrets.push(i[e]);this.data.skip(26)}else{this.data.skip(25),t.name=gt.gpReadStringByteLength(this.data,34,this.settings.importer.encoding),t.firstFret=ht.readInt32LE(this.data);for(let s=0;s<6;s++){const i=ht.readInt32LE(this.data);s<e.voice.bar.staff.tuning.length&&t.strings.push(i)}this.data.skip(36)}else{const s=this._versionNumber>=406?7:6;if(t.name=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),t.firstFret=ht.readInt32LE(this.data),t.firstFret>0)for(let i=0;i<s;i++){const s=ht.readInt32LE(this.data);i<e.voice.bar.staff.tuning.length&&t.strings.push(s)}}t.name&&(e.chordId=s,e.voice.bar.staff.addChord(e.chordId,t))}readBeatEffects(e){const t=this.data.readByte();let s=0;if(this._versionNumber>=400&&(s=this.data.readByte()),16&t&&(e.fade=pe.FadeIn),(this._versionNumber<400&&1&t||2&t)&&(e.vibrato=F.Slight),1&s&&(e.rasgueado=fe.Ii),32&t&&this._versionNumber>=400){switch(ht.readSInt8(this.data)){case 1:e.tap=!0;break;case 2:e.slap=!0;break;case 3:e.pop=!0}}else if(32&t){switch(ht.readSInt8(this.data)){case 1:e.tap=!0;break;case 2:e.slap=!0;break;case 3:e.pop=!0}this.data.skip(4)}if(4&s&&this.readTremoloBarEffect(e),64&t){let t=0,s=0;this._versionNumber<500?(s=this.data.readByte(),t=this.data.readByte()):(t=this.data.readByte(),s=this.data.readByte()),t>0?(e.brushType=S.BrushUp,e.brushDuration=pt.toStrokeValue(t)):s>0&&(e.brushType=S.BrushDown,e.brushDuration=pt.toStrokeValue(s))}if(2&s)switch(ht.readSInt8(this.data)){case 0:e.pickStroke=re.None;break;case 1:e.pickStroke=re.Up;break;case 2:e.pickStroke=re.Down}if(this._versionNumber<400){if(4&t)return N.Natural;if(8&t)return N.Artificial}return N.None}readTremoloBarEffect(e){this.data.readByte(),ht.readInt32LE(this.data);const t=ht.readInt32LE(this.data);if(t>0)for(let s=0;s<t;s++){const t=new J(0,0);t.offset=ht.readInt32LE(this.data),t.value=ht.readInt32LE(this.data)/pt.BendStep|0,gt.gpReadBool(this.data),e.addWhammyBarPoint(t)}}static toStrokeValue(e){switch(e){case 1:case 2:return 30;case 3:return 60;case 4:return 120;case 5:return 240;case 6:return 480;default:return 0}}readMixTableChange(e){const t=new mt;t.instrument=ht.readSInt8(this.data),this._versionNumber>=500&&this.data.skip(16),t.volume=ht.readSInt8(this.data),t.balance=ht.readSInt8(this.data);const s=ht.readSInt8(this.data),i=ht.readSInt8(this.data),a=ht.readSInt8(this.data),r=ht.readSInt8(this.data);if(this._versionNumber>=500&&(t.tempoName=gt.gpReadStringIntByte(this.data,this.settings.importer.encoding)),t.tempo=ht.readInt32LE(this.data),t.volume>=0&&this.data.readByte(),t.balance>=0&&this.data.readByte(),s>=0&&this.data.readByte(),i>=0&&this.data.readByte(),a>=0&&this.data.readByte(),r>=0&&this.data.readByte(),t.tempo>=0&&(t.duration=ht.readSInt8(this.data),this._versionNumber>=510&&this.data.readByte()),this._versionNumber>=400&&this.data.readByte(),this._versionNumber>=500){const t=ht.readSInt8(this.data);t>=100?e.wahPedal=ge.Closed:t>=0&&(e.wahPedal=ge.Open)}if(this._versionNumber>=510&&(gt.gpReadStringIntByte(this.data,this.settings.importer.encoding),gt.gpReadStringIntByte(this.data,this.settings.importer.encoding)),t.volume>=0){const s=new X;s.isLinear=!0,s.type=f.Volume,s.value=t.volume,e.automations.push(s)}if(t.balance>=0){const s=new X;s.isLinear=!0,s.type=f.Balance,s.value=t.balance,e.automations.push(s)}if(t.instrument>=0){const s=new X;s.isLinear=!0,s.type=f.Instrument,s.value=t.instrument,e.automations.push(s)}if(t.tempo>=0){const s=new X;s.isLinear=!0,s.type=f.Tempo,s.value=t.tempo,e.automations.push(s),e.voice.bar.masterBar.tempoAutomations.push(s)}}readNote(e,t,s,i,a){const r=new Re;r.string=t.staff.tuning.length-a;const n=this.data.readByte();if(2&n?r.accentuated=k.Heavy:64&n&&(r.accentuated=k.Normal),r.isGhost=!!(4&n),32&n){const e=this.data.readByte();3===e?r.isDead=!0:2===e&&(r.isTieDestination=!0)}if(1&n&&this._versionNumber<500&&(this.data.readByte(),this.data.readByte()),16&n){const e=ht.readSInt8(this.data);r.dynamics=this.toDynamicValue(e),i.dynamics=r.dynamics}32&n&&(r.fret=ht.readSInt8(this.data)),128&n&&(r.leftHandFinger=ht.readSInt8(this.data),r.rightHandFinger=ht.readSInt8(this.data));let o=!1;if(this._versionNumber>=500){1&n&&(r.durationPercent=ht.readFloat64BE(this.data));o=!!(2&this.data.readByte())}if(i.addNote(r),8&n&&this.readNoteEffects(e,s,i,r),t.staff.isPercussion&&(r.percussionArticulation=r.fret,r.string=-1,r.fret=-1),o){const e=it.defaultAccidentals[r.realValueWithoutHarmonic%12];"#"===e?r.accidentalMode=x.ForceFlat:"b"===e&&(r.accidentalMode=x.ForceSharp)}return r}toDynamicValue(e){switch(e){case 1:return m.PPP;case 2:return m.PP;case 3:return m.P;case 4:return m.MP;case 5:return m.MF;case 6:default:return m.F;case 7:return m.FF;case 8:return m.FFF}}readNoteEffects(e,t,s,i){const a=this.data.readByte();let r=0;this._versionNumber>=400&&(r=this.data.readByte()),1&a&&this.readBend(i),16&a&&this.readGrace(t,i),4&r&&this.readTremoloPicking(s),8&r?this.readSlide(i):this._versionNumber<400&&4&a&&(i.slideOutType=P.Shift),16&r&&this.readArtificialHarmonic(i),32&r&&this.readTrill(i),i.isLetRing=!!(8&a),i.isHammerPullOrigin=!!(2&a),64&r&&(i.vibrato=F.Slight),i.isPalmMute=!!(2&r),i.isStaccato=!!(1&r)}readBend(e){this.data.readByte(),ht.readInt32LE(this.data);const t=ht.readInt32LE(this.data);if(t>0)for(let s=0;s<t;s++){const t=new J(0,0);t.offset=ht.readInt32LE(this.data),t.value=ht.readInt32LE(this.data)/pt.BendStep|0,gt.gpReadBool(this.data),e.addBendPoint(t)}}readGrace(e,t){const s=new Ue,i=new Re;i.string=t.string,i.fret=ht.readSInt8(this.data),s.duration=w.ThirtySecond,s.dynamics=this.toDynamicValue(ht.readSInt8(this.data));switch(ht.readSInt8(this.data)){case 0:case 2:break;case 1:i.slideOutType=P.Legato,i.slideTarget=t;break;case 3:i.isHammerPullOrigin=!0}if(i.dynamics=s.dynamics,this.data.skip(1),this._versionNumber<500)s.graceType=B.BeforeBeat;else{const e=this.data.readByte();i.isDead=!!(1&e),s.graceType=2&e?B.OnBeat:B.BeforeBeat}e.addGraceBeat(s),s.addNote(i)}readTremoloPicking(e){switch(this.data.readByte()){case 1:e.tremoloSpeed=w.Eighth;break;case 2:e.tremoloSpeed=w.Sixteenth;break;case 3:e.tremoloSpeed=w.ThirtySecond}}readSlide(e){if(this._versionNumber>=500){const t=ht.readSInt8(this.data);1&t?e.slideOutType=P.Shift:2&t?e.slideOutType=P.Legato:4&t?e.slideOutType=P.OutDown:8&t&&(e.slideOutType=P.OutUp),16&t?e.slideInType=v.IntoFromBelow:32&t&&(e.slideInType=v.IntoFromAbove)}else{switch(ht.readSInt8(this.data)){case 1:e.slideOutType=P.Shift;break;case 2:e.slideOutType=P.Legato;break;case 3:e.slideOutType=P.OutDown;break;case 4:e.slideOutType=P.OutUp;break;case-1:e.slideInType=v.IntoFromBelow;break;case-2:e.slideInType=v.IntoFromAbove}}}readArtificialHarmonic(e){const t=this.data.readByte();if(this._versionNumber>=500)switch(t){case 1:e.harmonicType=N.Natural,e.harmonicValue=ae.deltaFretToHarmonicValue(e.fret);break;case 2:this.data.readByte(),this.data.readByte(),this.data.readByte(),e.harmonicType=N.Artificial;break;case 3:e.harmonicType=N.Tap,e.harmonicValue=ae.deltaFretToHarmonicValue(this.data.readByte());break;case 4:e.harmonicType=N.Pinch,e.harmonicValue=12;break;case 5:e.harmonicType=N.Semi,e.harmonicValue=12}else if(this._versionNumber>=400)switch(t){case 1:e.harmonicType=N.Natural;break;case 3:e.harmonicType=N.Tap;break;case 4:e.harmonicType=N.Pinch;break;case 5:e.harmonicType=N.Semi;break;case 15:case 17:case 22:e.harmonicType=N.Artificial}}readTrill(e){switch(e.trillValue=this.data.readByte()+e.stringTuning,this.data.readByte()){case 1:e.trillSpeed=w.Sixteenth;break;case 2:e.trillSpeed=w.ThirtySecond;break;case 3:e.trillSpeed=w.SixtyFourth}}}pt.VersionString="FICHIER GUITAR PRO ",pt.BendStep=25;class gt{static gpReadColor(e,t=!1){const s=e.readByte(),i=e.readByte(),a=e.readByte();let r=255;return t?r=e.readByte():e.skip(1),new tt(s,i,a,r)}static gpReadBool(e){return 0!==e.readByte()}static gpReadStringIntUnused(e,t){return e.skip(4),gt.gpReadString(e,e.readByte(),t)}static gpReadStringInt(e,t){return gt.gpReadString(e,ht.readInt32LE(e),t)}static gpReadStringIntByte(e,t){const s=ht.readInt32LE(e)-1;return e.readByte(),gt.gpReadString(e,s,t)}static gpReadString(e,t,s){const i=new Uint8Array(t);return e.read(i,0,i.length),ht.toString(i,s)}static gpWriteString(e,t){const s=ht.stringToBytes(t);e.writeByte(t.length),e.write(s,0,s.length)}static gpReadStringByteLength(e,t,s){const i=e.readByte(),a=gt.gpReadString(e,i,s);return i<t&&e.skip(t-i),a}}class mt{constructor(){this.volume=-1,this.balance=-1,this.instrument=-1,this.tempoName="",this.tempo=-1,this.duration=-1}}class ft{constructor(){this.x=0,this.y=0,this.w=0,this.h=0}scaleWith(e){this.x*=e,this.y*=e,this.w*=e,this.h*=e}}!function(e){e[e.Boolean=0]="Boolean",e[e.Integer=1]="Integer",e[e.Float=2]="Float",e[e.String=3]="String",e[e.Point=4]="Point",e[e.Size=5]="Size",e[e.Rectangle=6]="Rectangle",e[e.Color=7]="Color"}(Fe||(Fe={}));class yt{constructor(e){this._types=new Map,this.raw=new Map,e&&this.read(e)}read(e){const t=lt.fromBuffer(e),s=ht.readInt32BE(t);for(let e=0;e<s;e++){const e=gt.gpReadString(t,t.readByte(),"utf-8"),s=t.readByte();switch(this._types.set(e,s),s){case Fe.Boolean:const s=1===t.readByte();this.addValue(e,s);break;case Fe.Integer:const i=ht.readInt32BE(t);this.addValue(e,i);break;case Fe.Float:const a=ht.readFloat32BE(t);this.addValue(e,a);break;case Fe.String:const r=gt.gpReadString(t,ht.readInt16BE(t),"utf-8");this.addValue(e,r);break;case Fe.Point:const n=ht.readInt32BE(t),o=ht.readInt32BE(t);this.addValue(e,new J(n,o));break;case Fe.Size:const h=ht.readInt32BE(t),l=ht.readInt32BE(t);this.addValue(e,new J(h,l));break;case Fe.Rectangle:const c=new ft;c.x=ht.readInt32BE(t),c.y=ht.readInt32BE(t),c.w=ht.readInt32BE(t),c.h=ht.readInt32BE(t),this.addValue(e,c);break;case Fe.Color:const d=gt.gpReadColor(t,!0);this.addValue(e,d)}}}apply(e){for(const[t,s]of this.raw)switch(t){case"StandardNotation/hideDynamics":e.stylesheet.hideDynamics=s;break;case"System/bracketExtendMode":e.stylesheet.bracketExtendMode=s;break;case"Global/useSystemSignSeparator":e.stylesheet.useSystemSignSeparator=s;break;case"Global/DisplayTuning":e.stylesheet.globalDisplayTuning=s;break;case"Global/DrawChords":e.stylesheet.globalDisplayChordDiagramsOnTop=s;break;case"System/showTrackNameSingle":s||(e.stylesheet.singleTrackTrackNamePolicy=a.Hidden);break;case"System/showTrackNameMulti":s||(e.stylesheet.multiTrackTrackNamePolicy=a.Hidden);break;case"System/trackNameModeSingle":if(e.stylesheet.singleTrackTrackNamePolicy!==a.Hidden)switch(s){case 0:case 1:e.stylesheet.singleTrackTrackNamePolicy=a.FirstSystem;break;case 2:e.stylesheet.singleTrackTrackNamePolicy=a.AllSystems}break;case"System/trackNameModeMulti":if(e.stylesheet.multiTrackTrackNamePolicy!==a.Hidden)switch(s){case 0:case 1:e.stylesheet.multiTrackTrackNamePolicy=a.FirstSystem;break;case 2:e.stylesheet.multiTrackTrackNamePolicy=a.AllSystems}break;case"System/shortTrackNameOnFirstSystem":e.stylesheet.firstSystemTrackNameMode=s?r.ShortName:r.FullName;break;case"System/shortTrackNameOnOtherSystems":e.stylesheet.otherSystemsTrackNameMode=s?r.ShortName:r.FullName;break;case"System/horizontalTrackNameOnFirstSystem":e.stylesheet.firstSystemTrackNameOrientation=s?n.Horizontal:n.Vertical;break;case"System/horizontalTrackNameOnOtherSystems":e.stylesheet.otherSystemsTrackNameOrientation=s?n.Horizontal:n.Vertical;break;case"Header/Title":ae.getOrCreateHeaderFooterStyle(e,Se.Title).template=s;break;case"Header/TitleAlignment":ae.getOrCreateHeaderFooterStyle(e,Se.Title).textAlign=this.toTextAlign(s);break;case"Header/drawTitle":ae.getOrCreateHeaderFooterStyle(e,Se.Title).isVisible=s;break;case"Header/Subtitle":ae.getOrCreateHeaderFooterStyle(e,Se.SubTitle).template=s;break;case"Header/SubtitleAlignment":ae.getOrCreateHeaderFooterStyle(e,Se.SubTitle).textAlign=this.toTextAlign(s);break;case"Header/drawSubtitle":ae.getOrCreateHeaderFooterStyle(e,Se.SubTitle).isVisible=s;break;case"Header/Artist":ae.getOrCreateHeaderFooterStyle(e,Se.Artist).template=s;break;case"Header/ArtistAlignment":ae.getOrCreateHeaderFooterStyle(e,Se.Artist).textAlign=this.toTextAlign(s);break;case"Header/drawArtist":ae.getOrCreateHeaderFooterStyle(e,Se.Artist).isVisible=s;break;case"Header/Album":ae.getOrCreateHeaderFooterStyle(e,Se.Album).template=s;break;case"Header/AlbumAlignment":ae.getOrCreateHeaderFooterStyle(e,Se.Album).textAlign=this.toTextAlign(s);break;case"Header/drawAlbum":ae.getOrCreateHeaderFooterStyle(e,Se.Album).isVisible=s;break;case"Header/Words":ae.getOrCreateHeaderFooterStyle(e,Se.Words).template=s;break;case"Header/WordsAlignment":ae.getOrCreateHeaderFooterStyle(e,Se.Words).textAlign=this.toTextAlign(s);break;case"Header/drawWords":ae.getOrCreateHeaderFooterStyle(e,Se.Words).isVisible=s;break;case"Header/Music":ae.getOrCreateHeaderFooterStyle(e,Se.Music).template=s;break;case"Header/MusicAlignment":ae.getOrCreateHeaderFooterStyle(e,Se.Music).textAlign=this.toTextAlign(s);break;case"Header/drawMusic":ae.getOrCreateHeaderFooterStyle(e,Se.Music).isVisible=s;break;case"Header/WordsAndMusic":ae.getOrCreateHeaderFooterStyle(e,Se.WordsAndMusic).template=s;break;case"Header/WordsAndMusicAlignment":ae.getOrCreateHeaderFooterStyle(e,Se.WordsAndMusic).textAlign=this.toTextAlign(s);break;case"Header/drawWordsAndMusic":ae.getOrCreateHeaderFooterStyle(e,Se.WordsAndMusic).isVisible=s;break;case"Header/Tabber":ae.getOrCreateHeaderFooterStyle(e,Se.Transcriber).template=s;break;case"Header/TabberAlignment":ae.getOrCreateHeaderFooterStyle(e,Se.Transcriber).textAlign=this.toTextAlign(s);break;case"Header/drawTabber":ae.getOrCreateHeaderFooterStyle(e,Se.Transcriber).isVisible=s;break;case"Footer/Copyright":ae.getOrCreateHeaderFooterStyle(e,Se.Copyright).template=s;break;case"Footer/CopyrightAlignment":ae.getOrCreateHeaderFooterStyle(e,Se.Copyright).textAlign=this.toTextAlign(s);break;case"Footer/drawCopyright":ae.getOrCreateHeaderFooterStyle(e,Se.Copyright).isVisible=s;break;case"Footer/Copyright2":ae.getOrCreateHeaderFooterStyle(e,Se.CopyrightSecondLine).template=s;break;case"Footer/Copyright2Alignment":ae.getOrCreateHeaderFooterStyle(e,Se.CopyrightSecondLine).textAlign=this.toTextAlign(s);break;case"Footer/drawCopyright2":ae.getOrCreateHeaderFooterStyle(e,Se.CopyrightSecondLine).isVisible=s}}toTextAlign(e){switch(e){case 0:return oe.Left;case 1:return oe.Center;case 2:return oe.Right}return oe.Left}addValue(e,t,s){this.raw.set(e,t),void 0!==s&&this._types.set(e,s)}writeTo(e){ht.writeInt32BE(e,this.raw.size);for(const[t,s]of this.raw){const i=this.getDataType(t,s);switch(gt.gpWriteString(e,t),e.writeByte(i),i){case Fe.Boolean:e.writeByte(s?1:0);break;case Fe.Integer:ht.writeInt32BE(e,s);break;case Fe.Float:ht.writeFloat32BE(e,s);break;case Fe.String:const t=ht.stringToBytes(s);ht.writeInt16BE(e,t.length),e.write(t,0,t.length);break;case Fe.Point:case Fe.Size:ht.writeInt32BE(e,s.offset),ht.writeInt32BE(e,s.value);break;case Fe.Rectangle:ht.writeInt32BE(e,s.x),ht.writeInt32BE(e,s.y),ht.writeInt32BE(e,s.w),ht.writeInt32BE(e,s.h);break;case Fe.Color:e.writeByte(s.r),e.writeByte(s.g),e.writeByte(s.b),e.writeByte(s.a)}}}getDataType(t,s){if(this._types.has(t))return this._types.get(t);const i=typeof s;switch(typeof s){case"string":return Fe.String;case"number":return s===(0|s)?Fe.Integer:Fe.Float;case"object":if(s instanceof J)return Fe.Point;if(s instanceof ft)return Fe.Rectangle;if(s instanceof tt)return Fe.Color}throw new qe(e.AlphaTabErrorType.General,`Unknown value type in BinaryStylesheet: ${i}`)}static writeForScore(e){const t=new yt;switch(t.addValue("StandardNotation/hideDynamics",e.stylesheet.hideDynamics,Fe.Boolean),t.addValue("System/bracketExtendMode",e.stylesheet.bracketExtendMode,Fe.Integer),t.addValue("Global/useSystemSignSeparator",e.stylesheet.useSystemSignSeparator,Fe.Boolean),t.addValue("Global/DisplayTuning",e.stylesheet.globalDisplayTuning,Fe.Boolean),t.addValue("Global/DrawChords",e.stylesheet.globalDisplayChordDiagramsOnTop,Fe.Boolean),e.stylesheet.singleTrackTrackNamePolicy){case a.Hidden:t.addValue("System/showTrackNameSingle",!1,Fe.Boolean);break;case a.FirstSystem:t.addValue("System/trackNameModeSingle",0,Fe.Integer);break;case a.AllSystems:t.addValue("System/trackNameModeSingle",2,Fe.Integer)}switch(e.stylesheet.multiTrackTrackNamePolicy){case a.Hidden:t.addValue("System/trackNameModeMulti",!1,Fe.Boolean);break;case a.FirstSystem:t.addValue("System/trackNameModeMulti",0,Fe.Integer);break;case a.AllSystems:t.addValue("System/trackNameModeMulti",2,Fe.Integer)}switch(e.stylesheet.firstSystemTrackNameMode){case r.FullName:t.addValue("System/shortTrackNameOnFirstSystem",!1,Fe.Boolean);break;case r.ShortName:t.addValue("System/shortTrackNameOnFirstSystem",!0,Fe.Boolean)}switch(e.stylesheet.otherSystemsTrackNameMode){case r.FullName:t.addValue("System/shortTrackNameOnOtherSystems",!1,Fe.Boolean);break;case r.ShortName:t.addValue("System/shortTrackNameOnOtherSystems",!0,Fe.Boolean)}switch(e.stylesheet.firstSystemTrackNameOrientation){case n.Horizontal:t.addValue("System/horizontalTrackNameOnFirstSystem",!0,Fe.Boolean);break;case n.Vertical:t.addValue("System/horizontalTrackNameOnFirstSystem",!1,Fe.Boolean)}switch(e.stylesheet.otherSystemsTrackNameOrientation){case n.Horizontal:t.addValue("System/horizontalTrackNameOnOtherSystems",!0,Fe.Boolean);break;case n.Vertical:t.addValue("System/horizontalTrackNameOnOtherSystems",!1,Fe.Boolean)}const s=e.style;if(s)for(const[e,i]of s.headerAndFooter)switch(e){case Se.Title:yt.addHeaderAndFooter(t,i,"Header/","Title");break;case Se.SubTitle:yt.addHeaderAndFooter(t,i,"Header/","Subtitle");break;case Se.Artist:yt.addHeaderAndFooter(t,i,"Header/","Artist");break;case Se.Album:yt.addHeaderAndFooter(t,i,"Header/","Album");break;case Se.Words:yt.addHeaderAndFooter(t,i,"Header/","Words");break;case Se.Music:yt.addHeaderAndFooter(t,i,"Header/","Music");break;case Se.WordsAndMusic:yt.addHeaderAndFooter(t,i,"Header/","WordsAndMusic");break;case Se.Transcriber:yt.addHeaderAndFooter(t,i,"Header/","Tabber");break;case Se.Copyright:yt.addHeaderAndFooter(t,i,"Footer/","Copyright");break;case Se.CopyrightSecondLine:yt.addHeaderAndFooter(t,i,"Footer/","Copyright2")}const i=lt.withCapacity(128);return t.writeTo(i),i.toArray()}static addHeaderAndFooter(e,t,s,i){void 0!==t.template&&e.addValue(`${s}${i}`,t.template,Fe.String),e.addValue(`${s}${i}Alignment`,t.textAlign,Fe.Integer),void 0!==t.isVisible&&e.addValue(`${s}draw${i}`,t.isVisible,Fe.Boolean)}}!function(e){e[e.None=0]="None",e[e.Element=1]="Element",e[e.Text=2]="Text",e[e.CDATA=3]="CDATA",e[e.Document=4]="Document",e[e.DocumentType=5]="DocumentType"}(Ce||(Ce={}));class bt{constructor(){this.nodeType=Ce.None,this.localName=null,this.value=null,this.childNodes=[],this.attributes=new Map,this.firstChild=null,this.firstElement=null}*childElements(){for(const e of this.childNodes)e.nodeType===Ce.Element&&(yield e)}addChild(e){this.childNodes.push(e),this.firstChild=e,e.nodeType!==Ce.Element&&e.nodeType!==Ce.CDATA||(this.firstElement=e)}getAttribute(e,t=""){return this.attributes.has(e)?this.attributes.get(e):t}getElementsByTagName(e,t=!1){const s=[];return this.searchElementsByTagName(this.childNodes,s,e,t),s}searchElementsByTagName(e,t,s,i=!1){for(const a of e)a&&a.nodeType===Ce.Element&&a.localName===s&&t.push(a),i&&this.searchElementsByTagName(a.childNodes,t,s,!0)}findChildElement(e){for(const t of this.childNodes)if(t&&t.nodeType===Ce.Element&&t.localName===e)return t;return null}addElement(e){const t=new bt;return t.nodeType=Ce.Element,t.localName=e,this.addChild(t),t}get innerText(){if(this.nodeType===Ce.Element||this.nodeType===Ce.Document){if(this.firstElement&&this.firstElement.nodeType===Ce.CDATA)return this.firstElement.innerText;let e="";for(const t of this.childNodes)e+=t.innerText?.toString();return e.trim()}return this.value??""}set innerText(e){const t=new bt;t.nodeType=Ce.Text,t.value=e,this.childNodes=[t]}setCData(e){const t=new bt;t.nodeType=Ce.CDATA,t.value=e,this.childNodes=[t]}}class St extends qe{constructor(t,s,i){super(e.AlphaTabErrorType.Format,t),this.pos=0,this.xml=s,this.pos=i,Object.setPrototypeOf(this,St.prototype)}}!function(e){e[e.IgnoreSpaces=0]="IgnoreSpaces",e[e.Begin=1]="Begin",e[e.BeginNode=2]="BeginNode",e[e.TagName=3]="TagName",e[e.Body=4]="Body",e[e.AttribName=5]="AttribName",e[e.Equals=6]="Equals",e[e.AttvalBegin=7]="AttvalBegin",e[e.AttribVal=8]="AttribVal",e[e.Childs=9]="Childs",e[e.Close=10]="Close",e[e.WaitEnd=11]="WaitEnd",e[e.WaitEndRet=12]="WaitEndRet",e[e.Pcdata=13]="Pcdata",e[e.Header=14]="Header",e[e.Comment=15]="Comment",e[e.Doctype=16]="Doctype",e[e.Cdata=17]="Cdata",e[e.Escape=18]="Escape"}(Ee||(Ee={}));class _t{static parse(e,t,s){let i=e.charCodeAt(t),a=Ee.Begin,r=Ee.Begin,n=0,o="",h=Ee.Begin,l=null,c=null,d=0,u=0;for(;t<e.length;){switch(i=e.charCodeAt(t),a){case Ee.IgnoreSpaces:switch(i){case _t.CharCodeLF:case _t.CharCodeCR:case _t.CharCodeTab:case _t.CharCodeSpace:break;default:a=r;continue}break;case Ee.Begin:if(i!==_t.CharCodeLowerThan){n=t,a=Ee.Pcdata;continue}a=Ee.IgnoreSpaces,r=Ee.BeginNode;break;case Ee.Pcdata:if(i===_t.CharCodeLowerThan){o+=e.substr(n,t-n);const i=new bt;i.nodeType=Ce.Text,i.value=o,o="",s.addChild(i),a=Ee.IgnoreSpaces,r=Ee.BeginNode}else i===_t.CharCodeAmp&&(o+=e.substr(n,t-n),a=Ee.Escape,h=Ee.Pcdata,n=t+1);break;case Ee.Cdata:if(i===_t.CharCodeBrackedClose&&e.charCodeAt(t+1)===_t.CharCodeBrackedClose&&e.charCodeAt(t+2)===_t.CharCodeGreaterThan){const i=new bt;i.nodeType=Ce.CDATA,i.value=e.substr(n,t-n),s.addChild(i),t+=2,a=Ee.Begin}break;case Ee.BeginNode:switch(i){case _t.CharCodeExclamation:if(e.charCodeAt(t+1)===_t.CharCodeBrackedOpen){if(t+=2,"CDATA["!==e.substr(t,6).toUpperCase())throw new St("Expected <![CDATA[",e,t);t+=5,a=Ee.Cdata,n=t+1}else if(e.charCodeAt(t+1)===_t.CharCodeUpperD||e.charCodeAt(t+1)===_t.CharCodeLowerD){if("OCTYPE"!==e.substr(t+2,6).toUpperCase())throw new St("Expected <!DOCTYPE",e,t);t+=8,a=Ee.Doctype,n=t+1}else{if(e.charCodeAt(t+1)!==_t.CharCodeMinus||e.charCodeAt(t+2)!==_t.CharCodeMinus)throw new St("Expected \x3c!--",e,t);t+=2,a=Ee.Comment,n=t+1}break;case _t.CharCodeQuestion:a=Ee.Header,n=t;break;case _t.CharCodeSlash:if(!s)throw new St("Expected node name",e,t);n=t+1,a=Ee.IgnoreSpaces,r=Ee.Close;break;default:a=Ee.TagName,n=t;continue}break;case Ee.TagName:if(!_t.isValidChar(i)){if(t===n)throw new St("Expected node name",e,t);l=new bt,l.nodeType=Ce.Element,l.localName=e.substr(n,t-n),s.addChild(l),a=Ee.IgnoreSpaces,r=Ee.Body;continue}break;case Ee.Body:switch(i){case _t.CharCodeSlash:a=Ee.WaitEnd;break;case _t.CharCodeGreaterThan:a=Ee.Childs;break;default:a=Ee.AttribName,n=t;continue}break;case Ee.AttribName:if(!_t.isValidChar(i)){if(n===t)throw new St("Expected attribute name",e,t);if(c=e.substr(n,t-n),l.attributes.has(c))throw new St(`Duplicate attribute [${c}]`,e,t);a=Ee.IgnoreSpaces,r=Ee.Equals;continue}break;case Ee.Equals:if(i!==_t.CharCodeEquals)throw new St("Expected =",e,t);a=Ee.IgnoreSpaces,r=Ee.AttvalBegin;break;case Ee.AttvalBegin:switch(i){case _t.CharCodeDoubleQuote:case _t.CharCodeSingleQuote:o="",a=Ee.AttribVal,n=t+1,u=i}break;case Ee.AttribVal:if(i===_t.CharCodeAmp)o+=e.substr(n,t-n),a=Ee.Escape,h=Ee.AttribVal,n=t+1;else if(i===u){o+=e.substr(n,t-n);const s=o;o="",l.attributes.set(c,s),a=Ee.IgnoreSpaces,r=Ee.Body}break;case Ee.Childs:n=t=_t.parse(e,t,l),a=Ee.Begin;break;case Ee.WaitEnd:if(i!==_t.CharCodeGreaterThan)throw new St("Expected >",e,t);a=Ee.Begin;break;case Ee.WaitEndRet:if(i===_t.CharCodeGreaterThan)return t;throw new St("Expected >",e,t);case Ee.Close:if(!_t.isValidChar(i)){if(n===t)throw new St("Expected node name",e,t);if(e.substr(n,t-n)!==s.localName)throw new St(`Expected </${s.localName}>`,e,t);a=Ee.IgnoreSpaces,r=Ee.WaitEndRet;continue}break;case Ee.Comment:i===_t.CharCodeMinus&&e.charCodeAt(t+1)===_t.CharCodeMinus&&e.charCodeAt(t+2)===_t.CharCodeGreaterThan&&(t+=2,a=Ee.Begin);break;case Ee.Doctype:if(i===_t.CharCodeBrackedOpen)d++;else if(i===_t.CharCodeBrackedClose)d--;else if(i===_t.CharCodeGreaterThan&&0===d){const i=new bt;i.nodeType=Ce.DocumentType,i.value=e.substr(n,t-n),s.addChild(i),a=Ee.Begin}break;case Ee.Header:i===_t.CharCodeQuestion&&e.charCodeAt(t+1)===_t.CharCodeGreaterThan&&(t++,a=Ee.Begin);break;case Ee.Escape:if(i===_t.CharCodeSemi){const s=e.substr(n,t-n);if(s.charCodeAt(0)===_t.CharCodeSharp){const e=s.charCodeAt(1)===_t.CharCodeLowerX?Number.parseInt(`0${s.substr(1,s.length-1)}`):Number.parseInt(s.substr(1,s.length-1));o+=String.fromCharCode(e)}else _t.Escapes.has(s)?o+=_t.Escapes.get(s):o+=`&${s};`?.toString();n=t+1,a=h}else _t.isValidChar(i)||i===_t.CharCodeSharp||(o+="&",o+=e.substr(n,t-n),n=--t+1,a=h)}t++}if(a===Ee.Begin&&(n=t,a=Ee.Pcdata),a===Ee.Pcdata){if(t!==n){o+=e.substr(n,t-n);const i=new bt;i.nodeType=Ce.Text,i.value=o,s.addChild(i)}return t}if(a===Ee.Escape&&h===Ee.Pcdata){o+="&",o+=e.substr(n,t-n);const i=new bt;return i.nodeType=Ce.Text,i.value=o,s.addChild(i),t}throw new St("Unexpected end",e,t)}static isValidChar(e){return e>=_t.CharCodeLowerA&&e<=_t.CharCodeLowerZ||e>=_t.CharCodeUpperA&&e<=_t.CharCodeUpperZ||e>=_t.CharCode0&&e<=_t.CharCode9||e===_t.CharCodeColon||e===_t.CharCodeDot||e===_t.CharCodeUnderscore||e===_t.CharCodeMinus}}_t.CharCodeLF=10,_t.CharCodeTab=9,_t.CharCodeCR=13,_t.CharCodeSpace=32,_t.CharCodeLowerThan=60,_t.CharCodeAmp=38,_t.CharCodeBrackedClose=93,_t.CharCodeBrackedOpen=91,_t.CharCodeGreaterThan=62,_t.CharCodeExclamation=33,_t.CharCodeUpperD=68,_t.CharCodeLowerD=100,_t.CharCodeMinus=45,_t.CharCodeQuestion=63,_t.CharCodeSlash=47,_t.CharCodeEquals=61,_t.CharCodeDoubleQuote=34,_t.CharCodeSingleQuote=39,_t.CharCodeSharp=35,_t.CharCodeLowerX=120,_t.CharCodeLowerA=97,_t.CharCodeLowerZ=122,_t.CharCodeUpperA=65,_t.CharCodeUpperZ=90,_t.CharCode0=48,_t.CharCode9=57,_t.CharCodeColon=58,_t.CharCodeDot=46,_t.CharCodeUnderscore=95,_t.CharCodeSemi=59,_t.Escapes=new Map([["lt","<"],["gt",">"],["amp","&"],["quot",'"'],["apos","'"]]);class wt{static write(e,t,s){const i=new wt(t,s);return i.writeNode(e),i.toString()}constructor(e,t){this._result=[],this._indention=e,this._xmlHeader=t,this._currentIndention="",this._isStartOfLine=!0}writeNode(e){switch(e.nodeType){case Ce.None:break;case Ce.Element:this._result.length>0&&this.writeLine(),this.write(`<${e.localName}`);for(const[t,s]of e.attributes)this.write(` ${t}="`),this.writeAttributeValue(s),this.write('"');if(0===e.childNodes.length)this.write("/>");else{if(this.write(">"),1!==e.childNodes.length||e.firstElement){this.indent();for(const t of e.childNodes)t.nodeType===Ce.Element&&this.writeNode(t);this.unindend(),this.writeLine()}else this.writeNode(e.childNodes[0]);this.write(`</${e.localName}>`)}break;case Ce.Text:e.value&&this.write(e.value);break;case Ce.CDATA:null!==e.value&&this.write(`<![CDATA[${e.value}]]>`);break;case Ce.Document:this._xmlHeader&&this.write('<?xml version="1.0" encoding="utf-8"?>');for(const t of e.childNodes)this.writeNode(t);break;case Ce.DocumentType:this.write(`<!DOCTYPE ${e.value}>`)}}unindend(){this._currentIndention=this._currentIndention.substr(0,this._currentIndention.length-this._indention.length)}indent(){this._currentIndention+=this._indention}writeAttributeValue(e){for(let t=0;t<e.length;t++){const s=e.charAt(t);switch(s){case"<":this._result.push("&lt;");break;case">":this._result.push("&gt;");break;case"&":this._result.push("&amp;");break;case"'":this._result.push("&apos;");break;case'"':this._result.push("&quot;");break;default:this._result.push(s)}}}write(e){this._isStartOfLine&&this._result.push(this._currentIndention),this._result.push(e),this._isStartOfLine=!1}writeLine(e=null){e&&this.write(e),this._indention.length>0&&!this._isStartOfLine&&(this._result.push("\n"),this._isStartOfLine=!0)}toString(){return this._result.join("").trimRight()}}class Bt extends bt{constructor(){super(),this.nodeType=Ce.Document}parse(e){_t.parse(e,0,this)}toString(){return this.toFormattedString()}toFormattedString(e="",t=!1){return wt.write(this,e,t)}}class kt{constructor(){this.id="",this.dots=0,this.tupletDenominator=-1,this.tupletNumerator=-1,this.value=w.Quarter}}class Tt{constructor(){this.name="",this.path="",this.role="",this.program=0}get uniqueId(){return`${this.path};${this.name};${this.role}`}}class Nt{constructor(){this._hasAnacrusis=!1,this._skipApplyLyrics=!1,this._doubleBars=new Set,this._keySignatures=new Map}parseXml(e,t){this._masterTrackAutomations=new Map,this._automationsPerTrackIdAndBarIndex=new Map,this._sustainPedalsPerTrackIdAndBarIndex=new Map,this._tracksMapping=[],this._tracksById=new Map,this._masterBars=[],this._barsOfMasterBar=[],this._voicesOfBar=new Map,this._barsById=new Map,this._voiceById=new Map,this._beatsOfVoice=new Map,this._beatById=new Map,this._rhythmOfBeat=new Map,this._rhythmById=new Map,this._notesOfBeat=new Map,this._noteById=new Map,this._tappedNotes=new Map,this._lyricsByTrack=new Map,this._soundsByTrack=new Map,this._skipApplyLyrics=!1;const s=new Bt;try{s.parse(e)}catch(e){throw new je("Could not parse XML",e)}if(this.parseDom(s),this.buildModel(),ae.consolidate(this.score),this.score.finish(t),!this._skipApplyLyrics&&this._lyricsByTrack.size>0)for(const[e,t]of this._lyricsByTrack){this._tracksById.get(e).applyLyrics(t)}}parseDom(e){const t=e.firstElement;if(t){if("GPIF"!==t.localName)throw new je("Root node of XML was not GPIF");this.score=new Ye;for(const e of t.childElements())switch(e.localName){case"Score":this.parseScoreNode(e);break;case"MasterTrack":this.parseMasterTrackNode(e);break;case"Tracks":this.parseTracksNode(e);break;case"MasterBars":this.parseMasterBarsNode(e);break;case"Bars":this.parseBars(e);break;case"Voices":this.parseVoices(e);break;case"Beats":this.parseBeats(e);break;case"Notes":this.parseNotes(e);break;case"Rhythms":this.parseRhythms(e)}}}parseScoreNode(e){for(const t of e.childElements())switch(t.localName){case"Title":this.score.title=t.innerText;break;case"SubTitle":this.score.subTitle=t.innerText;break;case"Artist":this.score.artist=t.innerText;break;case"Album":this.score.album=t.innerText;break;case"Words":this.score.words=t.innerText;break;case"Music":this.score.music=t.innerText;break;case"WordsAndMusic":const e=t.innerText;""!==e&&(e&&!this.score.words&&(this.score.words=e),e&&!this.score.music&&(this.score.music=e));break;case"Copyright":this.score.copyright=t.innerText;break;case"Tabber":this.score.tab=t.innerText;break;case"Instructions":this.score.instructions=t.innerText;break;case"Notices":this.score.notices=t.innerText;break;case"ScoreSystemsDefaultLayout":this.score.defaultSystemsLayout=Nt.parseIntSafe(t.innerText,4);break;case"ScoreSystemsLayout":this.score.systemsLayout=Nt.splitSafe(t.innerText).map((e=>Nt.parseIntSafe(e,4)))}}static parseIntSafe(e,t){if(!e)return t;const s=Number.parseInt(e);return Number.isNaN(s)?t:s}static parseFloatSafe(e,t){if(!e)return t;const s=Number.parseFloat(e);return Number.isNaN(s)?t:s}static splitSafe(e,t=" "){return e?e.split(t).map((e=>e.trim())).filter((e=>e.length>0)):[]}parseMasterTrackNode(e){for(const t of e.childElements())switch(t.localName){case"Automations":this.parseAutomations(t,this._masterTrackAutomations,null,null);break;case"Tracks":this._tracksMapping=Nt.splitSafe(t.innerText);break;case"Anacrusis":this._hasAnacrusis=!0}}parseAutomations(e,t,s,i){for(const a of e.childElements())if("Automation"===a.localName)this.parseAutomation(a,t,s,i)}parseAutomation(e,t,s,i){let a=null,r=!1,n=-1,o=0,h=0,l=null,c=0,d=null;for(const t of e.childElements())switch(t.localName){case"Type":a=t.innerText;break;case"Linear":r="true"===t.innerText.toLowerCase();break;case"Bar":n=Nt.parseIntSafe(t.innerText,0);break;case"Position":o=Nt.parseFloatSafe(t.innerText,0);break;case"Value":if(t.firstElement&&t.firstElement.nodeType===Ce.CDATA)l=t.innerText;else{const e=Nt.splitSafe(t.innerText);1===e.length?(h=Nt.parseFloatSafe(e[0],0),c=1):(h=Nt.parseFloatSafe(e[0],0),c=Nt.parseIntSafe(e[1],0))}break;case"Text":d=t.innerText}if(!a)return;let p=null;switch(a){case"Tempo":p=X.buildTempoAutomation(r,o,h,c);break;case"Sound":l&&s&&s.has(l)&&(p=X.buildInstrumentAutomation(r,o,s.get(l).program));break;case"SustainPedal":if(i){let e;i.has(n)?e=i.get(n):(e=[],i.set(n,e));const t=new V;switch(t.ratioPosition=o,c){case 1:t.pedalType=u.Down;break;case 3:t.pedalType=u.Up}e.push(t)}}p&&(d&&(p.text=d),n>=0&&(t.has(n)||t.set(n,[]),t.get(n).push(p)))}parseTracksNode(e){for(const t of e.childElements())if("Track"===t.localName)this.parseTrack(t)}parseTrack(e){this._articulationByName=new Map;const t=new nt;t.ensureStaveCount(1);t.staves[0].showStandardNotation=!0;const s=e.getAttribute("id");for(const i of e.childElements())switch(i.localName){case"Name":t.name=i.innerText;break;case"Color":const e=Nt.splitSafe(i.innerText);if(e.length>=3){const s=Nt.parseIntSafe(e[0],0),i=Nt.parseIntSafe(e[1],0),a=Nt.parseIntSafe(e[2],0);t.color=new tt(s,i,a,255)}break;case"Instrument":const a=i.getAttribute("ref");(a.endsWith("-gs")||a.endsWith("GrandStaff"))&&(t.ensureStaveCount(2),t.staves[1].showStandardNotation=!0);break;case"InstrumentSet":this.parseInstrumentSet(t,i);break;case"NotationPatch":this.parseNotationPatch(t,i);break;case"ShortName":t.shortName=i.innerText;break;case"SystemsDefautLayout":t.defaultSystemsLayout=Nt.parseIntSafe(i.innerText,4);break;case"SystemsLayout":t.systemsLayout=Nt.splitSafe(i.innerText).map((e=>Nt.parseIntSafe(e,4)));break;case"Lyrics":this.parseLyrics(s,i);break;case"Properties":this.parseTrackProperties(t,i);break;case"GeneralMidi":case"MidiConnection":case"MIDISettings":this.parseGeneralMidi(t,i);break;case"Sounds":this.parseSounds(s,t,i);break;case"PlaybackState":const r=i.innerText;t.playbackInfo.isSolo="Solo"===r,t.playbackInfo.isMute="Mute"===r;break;case"PartSounding":this.parsePartSounding(t,i);break;case"Staves":this.parseStaves(t,i);break;case"Transpose":this.parseTranspose(t,i);break;case"RSE":this.parseRSE(t,i);break;case"Automations":this.parseTrackAutomations(s,i)}this._tracksById.set(s,t)}parseTrackAutomations(e,t){const s=new Map;this._automationsPerTrackIdAndBarIndex.set(e,s);const i=new Map;this._sustainPedalsPerTrackIdAndBarIndex.set(e,i),this.parseAutomations(t,s,this._soundsByTrack.get(e),i)}parseNotationPatch(e,t){for(const s of t.childElements())switch(s.localName){case"LineCount":const t=Nt.parseIntSafe(s.innerText,5);for(const s of e.staves)s.standardNotationLineCount=t;break;case"Elements":this.parseElements(e,s)}}parseInstrumentSet(e,t){for(const s of t.childElements())switch(s.localName){case"Type":if("drumKit"===s.innerText)for(const t of e.staves)t.isPercussion=!0;break;case"Elements":this.parseElements(e,s);break;case"LineCount":const t=Nt.parseIntSafe(s.innerText,5);for(const s of e.staves)s.standardNotationLineCount=t}}parseElements(e,t){for(const s of t.childElements())if("Element"===s.localName)this.parseElement(e,s)}parseElement(e,t){const s=t.findChildElement("Type")?.innerText??"";for(const i of t.childElements())switch(i.localName){case"Name":case"Articulations":this.parseArticulations(e,i,s)}}parseArticulations(e,t,s){for(const i of t.childElements())if("Articulation"===i.localName)this.parseArticulation(e,i,s)}parseArticulation(e,t,s){const i=new Me;i.outputMidiNumber=-1,i.elementType=s;let a="";for(const e of t.childElements()){const t=e.innerText;switch(e.localName){case"Name":a=e.innerText;break;case"OutputMidiNumber":i.outputMidiNumber=Nt.parseIntSafe(t,0);break;case"TechniqueSymbol":i.techniqueSymbol=this.parseTechniqueSymbol(t);break;case"TechniquePlacement":switch(t){case"outside":case"above":i.techniqueSymbolPlacement=he.Bottom;break;case"inside":i.techniqueSymbolPlacement=he.Middle;break;case"below":i.techniqueSymbolPlacement=he.Top}break;case"Noteheads":const s=Nt.splitSafe(t);s.length>=1&&(i.noteHeadDefault=this.parseNoteHead(s[0])),s.length>=2&&(i.noteHeadHalf=this.parseNoteHead(s[1])),s.length>=3&&(i.noteHeadWhole=this.parseNoteHead(s[2])),i.noteHeadHalf===ne.None&&(i.noteHeadHalf=i.noteHeadDefault),i.noteHeadWhole===ne.None&&(i.noteHeadWhole=i.noteHeadDefault);break;case"StaffLine":i.staffLine=Nt.parseIntSafe(t,0)}}-1!==i.outputMidiNumber?(e.percussionArticulations.push(i),a.length>0&&this._articulationByName.set(a,i)):a.length>0&&this._articulationByName.has(a)&&(this._articulationByName.get(a).staffLine=i.staffLine)}parseTechniqueSymbol(e){switch(e){case"pictEdgeOfCymbal":return ne.PictEdgeOfCymbal;case"articStaccatoAbove":return ne.ArticStaccatoAbove;case"noteheadParenthesis":return ne.NoteheadParenthesis;case"stringsUpBow":return ne.StringsUpBow;case"stringsDownBow":return ne.StringsDownBow;case"guitarGolpe":return ne.GuitarGolpe;default:return ne.None}}parseNoteHead(e){switch(e){case"noteheadDoubleWholeSquare":return ne.NoteheadDoubleWholeSquare;case"noteheadDoubleWhole":return ne.NoteheadDoubleWhole;case"noteheadWhole":return ne.NoteheadWhole;case"noteheadHalf":return ne.NoteheadHalf;case"noteheadBlack":return ne.NoteheadBlack;case"noteheadNull":return ne.NoteheadNull;case"noteheadXOrnate":return ne.NoteheadXOrnate;case"noteheadTriangleUpWhole":return ne.NoteheadTriangleUpWhole;case"noteheadTriangleUpHalf":return ne.NoteheadTriangleUpHalf;case"noteheadTriangleUpBlack":return ne.NoteheadTriangleUpBlack;case"noteheadDiamondBlackWide":return ne.NoteheadDiamondBlackWide;case"noteheadDiamondWhite":return ne.NoteheadDiamondWhite;case"noteheadDiamondWhiteWide":return ne.NoteheadDiamondWhiteWide;case"noteheadCircleX":return ne.NoteheadCircleX;case"noteheadXWhole":return ne.NoteheadXWhole;case"noteheadXHalf":return ne.NoteheadXHalf;case"noteheadXBlack":return ne.NoteheadXBlack;case"noteheadParenthesis":return ne.NoteheadParenthesis;case"noteheadSlashedBlack2":return ne.NoteheadSlashedBlack2;case"noteheadCircleSlash":return ne.NoteheadCircleSlash;case"noteheadHeavyX":return ne.NoteheadHeavyX;case"noteheadHeavyXHat":return ne.NoteheadHeavyXHat;default:return j.warning("GPIF","Unknown notehead symbol",e),ne.None}}parseStaves(e,t){let s=0;for(const i of t.childElements())if("Staff"===i.localName){e.ensureStaveCount(s+1);const t=e.staves[s];this.parseStaff(t,i),s++}}parseStaff(e,t){for(const s of t.childElements())if("Properties"===s.localName)this.parseStaffProperties(e,s)}parseStaffProperties(e,t){for(const s of t.childElements())if("Property"===s.localName)this.parseStaffProperty(e,s)}parseStaffProperty(e,t){switch(t.getAttribute("name")){case"Tuning":for(const s of t.childElements())switch(s.localName){case"Pitches":const i=Nt.splitSafe(t.findChildElement("Pitches")?.innerText),a=new Array(i.length);for(let e=0;e<a.length;e++)a[a.length-1-e]=Nt.parseIntSafe(i[e],0);e.stringTuning.tunings=a;break;case"Label":e.stringTuning.name=s.innerText}e.isPercussion||(e.showTablature=!0);break;case"DiagramCollection":case"ChordCollection":this.parseDiagramCollectionForStaff(e,t);break;case"CapoFret":const s=Nt.parseIntSafe(t.findChildElement("Fret")?.innerText,0);e.capo=s}}parseLyrics(e,t){const s=[];for(const e of t.childElements())if("Line"===e.localName)s.push(this.parseLyricsLine(e));this._lyricsByTrack.set(e,s)}parseLyricsLine(e){const t=new Qe;for(const s of e.childElements())switch(s.localName){case"Offset":t.startBar=Nt.parseIntSafe(s.innerText,0);break;case"Text":t.text=s.innerText}return t}parseDiagramCollectionForTrack(e,t){const s=t.findChildElement("Items");if(s)for(const t of s.childElements())if("Item"===t.localName)this.parseDiagramItemForTrack(e,t)}parseDiagramCollectionForStaff(e,t){const s=t.findChildElement("Items");if(s)for(const t of s.childElements())if("Item"===t.localName)this.parseDiagramItemForStaff(e,t)}parseDiagramItemForTrack(e,t){const s=new Ke,i=t.getAttribute("id");for(const t of e.staves)t.addChord(i,s);this.parseDiagramItemForChord(s,t)}parseDiagramItemForStaff(e,t){const s=new Ke,i=t.getAttribute("id");e.addChord(i,s),this.parseDiagramItemForChord(s,t)}parseDiagramItemForChord(e,t){e.name=t.getAttribute("name");const s=t.findChildElement("Diagram");if(!s)return e.showDiagram=!1,void(e.showFingering=!1);const i=Nt.parseIntSafe(s.getAttribute("stringCount"),6),a=Nt.parseIntSafe(s.getAttribute("baseFret"),0);e.firstFret=a+1;for(let t=0;t<i;t++)e.strings.push(-1);for(const t of s.childElements())switch(t.localName){case"Fret":const s=Nt.parseIntSafe(t.getAttribute("string"),0);e.strings[i-s-1]=a+Nt.parseIntSafe(t.getAttribute("fret"),0);break;case"Fingering":const r=new Map;for(const s of t.childElements())if("Position"===s.localName){let t=T.Unknown;const i=a+Nt.parseIntSafe(s.getAttribute("fret"),0);switch(s.getAttribute("finger")){case"Index":t=T.IndexFinger;break;case"Middle":t=T.MiddleFinger;break;case"Rank":t=T.AnnularFinger;break;case"Pinky":t=T.LittleFinger;break;case"Thumb":t=T.Thumb}t!==T.Unknown&&(r.has(t)?e.barreFrets.push(i):r.set(t,!0))}break;case"Property":switch(t.getAttribute("name")){case"ShowName":e.showName="true"===t.getAttribute("value");break;case"ShowDiagram":e.showDiagram="true"===t.getAttribute("value");break;case"ShowFingering":e.showFingering="true"===t.getAttribute("value")}}}parseTrackProperties(e,t){for(const s of t.childElements())if("Property"===s.localName)this.parseTrackProperty(e,s)}parseTrackProperty(e,t){switch(t.getAttribute("name")){case"Tuning":const s=Nt.splitSafe(t.findChildElement("Pitches")?.innerText),i=new Array(s.length);for(let e=0;e<i.length;e++)i[i.length-1-e]=Nt.parseIntSafe(s[e],0);for(const t of e.staves)t.stringTuning.tunings=i,t.showStandardNotation=!0,t.showTablature=!0;break;case"DiagramCollection":case"ChordCollection":this.parseDiagramCollectionForTrack(e,t);break;case"CapoFret":const a=Nt.parseIntSafe(t.findChildElement("Fret")?.innerText,0);for(const t of e.staves)t.capo=a}}parseGeneralMidi(e,t){for(const s of t.childElements())switch(s.localName){case"Program":e.playbackInfo.program=Nt.parseIntSafe(s.innerText,0);break;case"Port":e.playbackInfo.port=Nt.parseIntSafe(s.innerText,0);break;case"PrimaryChannel":e.playbackInfo.primaryChannel=Nt.parseIntSafe(s.innerText,0);break;case"SecondaryChannel":e.playbackInfo.secondaryChannel=Nt.parseIntSafe(s.innerText,0)}if("Percussion"===t.getAttribute("table"))for(const t of e.staves)t.isPercussion=!0}parseSounds(e,t,s){for(const i of s.childElements())if("Sound"===i.localName)this.parseSound(e,t,i)}parseSound(e,t,s){const i=new Tt;for(const e of s.childElements())switch(e.localName){case"Name":i.name=e.innerText;break;case"Path":i.path=e.innerText;break;case"Role":i.role=e.innerText;break;case"MIDI":this.parseSoundMidi(i,e)}"Factory"!==i.role&&0!==t.playbackInfo.program||(t.playbackInfo.program=i.program),this._soundsByTrack.has(e)||this._soundsByTrack.set(e,new Map),this._soundsByTrack.get(e).set(i.uniqueId,i)}parseSoundMidi(e,t){for(const s of t.childElements())if("Program"===s.localName)e.program=Nt.parseIntSafe(s.innerText,0)}parsePartSounding(e,t){for(const s of t.childElements())if("TranspositionPitch"===s.localName)for(const t of e.staves)t.displayTranspositionPitch=Nt.parseIntSafe(s.innerText,0)}parseTranspose(e,t){let s=0,i=0;for(const e of t.childElements())switch(e.localName){case"Chromatic":i=Nt.parseIntSafe(e.innerText,0);break;case"Octave":s=Nt.parseIntSafe(e.innerText,0)}for(const t of e.staves)t.displayTranspositionPitch=12*s+i}parseRSE(e,t){for(const s of t.childElements())if("ChannelStrip"===s.localName)this.parseChannelStrip(e,s)}parseChannelStrip(e,t){for(const s of t.childElements())if("Parameters"===s.localName)this.parseChannelStripParameters(e,s)}parseChannelStripParameters(e,t){if(t.firstChild&&t.firstChild.value){const s=Nt.splitSafe(t.firstChild.value);s.length>=12&&(e.playbackInfo.balance=Math.floor(16*Nt.parseFloatSafe(s[11],.5)),e.playbackInfo.volume=Math.floor(16*Nt.parseFloatSafe(s[12],.9)))}}parseMasterBarsNode(e){for(const t of e.childElements())if("MasterBar"===t.localName)this.parseMasterBar(t)}parseMasterBar(e){const t=new K;0===this._masterBars.length&&this._hasAnacrusis&&(t.isAnacrusis=!0);for(const s of e.childElements())switch(s.localName){case"Time":const e=s.innerText.split("/");t.timeSignatureNumerator=Nt.parseIntSafe(e[0],4),t.timeSignatureDenominator=Nt.parseIntSafe(e[1],4);break;case"FreeTime":t.isFreeTime=!0;break;case"DoubleBar":t.isDoubleBar=!0,this._doubleBars.add(t);break;case"Section":t.section=new Ze,t.section.marker=s.findChildElement("Letter")?.innerText??"",t.section.text=s.findChildElement("Text")?.innerText??"";break;case"Repeat":"true"===s.getAttribute("start").toLowerCase()&&(t.isRepeatStart=!0),"true"===s.getAttribute("end").toLowerCase()&&s.getAttribute("count")&&(t.repeatCount=Nt.parseIntSafe(s.getAttribute("count"),1));break;case"AlternateEndings":const i=Nt.splitSafe(s.innerText);let a=0;for(let e=0;e<i.length;e++)a|=1<<-1+Nt.parseIntSafe(i[e],0);t.alternateEndings=a;break;case"Bars":this._barsOfMasterBar.push(Nt.splitSafe(s.innerText));break;case"TripletFeel":switch(s.innerText){case"NoTripletFeel":t.tripletFeel=A.NoTripletFeel;break;case"Triplet8th":t.tripletFeel=A.Triplet8th;break;case"Triplet16th":t.tripletFeel=A.Triplet16th;break;case"Dotted8th":t.tripletFeel=A.Dotted8th;break;case"Dotted16th":t.tripletFeel=A.Dotted16th;break;case"Scottish8th":t.tripletFeel=A.Scottish8th;break;case"Scottish16th":t.tripletFeel=A.Scottish16th}break;case"Key":const r=Nt.parseIntSafe(s.findChildElement("AccidentalCount")?.innerText,0),n=s.findChildElement("Mode");let o=d.Major;if(n)switch(n.innerText.toLowerCase()){case"major":o=d.Major;break;case"minor":o=d.Minor}this._keySignatures.set(this._masterBars.length,[r,o]);break;case"Fermatas":this.parseFermatas(t,s);break;case"XProperties":this.parseMasterBarXProperties(t,s);break;case"Directions":this.parseDirections(t,s)}this._masterBars.push(t)}parseDirections(e,t){for(const s of t.childElements())switch(s.localName){case"Target":switch(s.innerText){case"Coda":e.addDirection(ke.TargetCoda);break;case"DoubleCoda":e.addDirection(ke.TargetDoubleCoda);break;case"Segno":e.addDirection(ke.TargetSegno);break;case"SegnoSegno":e.addDirection(ke.TargetSegnoSegno);break;case"Fine":e.addDirection(ke.TargetFine)}break;case"Jump":switch(s.innerText){case"DaCapo":e.addDirection(ke.JumpDaCapo);break;case"DaCapoAlCoda":e.addDirection(ke.JumpDaCapoAlCoda);break;case"DaCapoAlDoubleCoda":e.addDirection(ke.JumpDaCapoAlDoubleCoda);break;case"DaCapoAlFine":e.addDirection(ke.JumpDaCapoAlFine);break;case"DaSegno":e.addDirection(ke.JumpDalSegno);break;case"DaSegnoAlCoda":e.addDirection(ke.JumpDalSegnoAlCoda);break;case"DaSegnoAlDoubleCoda":e.addDirection(ke.JumpDalSegnoAlDoubleCoda);break;case"DaSegnoAlFine":e.addDirection(ke.JumpDalSegnoAlFine);break;case"DaSegnoSegno":e.addDirection(ke.JumpDalSegnoSegno);break;case"DaSegnoSegnoAlCoda":e.addDirection(ke.JumpDalSegnoSegnoAlCoda);break;case"DaSegnoSegnoAlDoubleCoda":e.addDirection(ke.JumpDalSegnoSegnoAlDoubleCoda);break;case"DaSegnoSegnoAlFine":e.addDirection(ke.JumpDalSegnoSegnoAlFine);break;case"DaCoda":e.addDirection(ke.JumpDaCoda);break;case"DaDoubleCoda":e.addDirection(ke.JumpDaDoubleCoda)}}}parseFermatas(e,t){for(const s of t.childElements())if("Fermata"===s.localName)this.parseFermata(e,s)}parseFermata(e,t){let s=0;const i=new ct;for(const e of t.childElements())switch(e.localName){case"Type":switch(e.innerText){case"Short":i.type=Te.Short;break;case"Medium":i.type=Te.Medium;break;case"Long":i.type=Te.Long}break;case"Length":i.length=Nt.parseFloatSafe(e.innerText,0);break;case"Offset":const t=e.innerText.split("/");if(2===t.length){s=Nt.parseIntSafe(t[0],4)/Nt.parseIntSafe(t[1],4)*U.QuarterTime|0}}e.addFermata(s,i)}parseBars(e){for(const t of e.childElements())if("Bar"===t.localName)this.parseBar(t)}parseBar(e){const t=new z,s=e.getAttribute("id");for(const i of e.childElements())switch(i.localName){case"Voices":this._voicesOfBar.set(s,Nt.splitSafe(i.innerText));break;case"Clef":switch(i.innerText){case"Neutral":t.clef=o.Neutral;break;case"G2":t.clef=o.G2;break;case"F4":t.clef=o.F4;break;case"C4":t.clef=o.C4;break;case"C3":t.clef=o.C3}break;case"Ottavia":switch(i.innerText){case"8va":t.clefOttava=h._8va;break;case"15ma":t.clefOttava=h._15ma;break;case"8vb":t.clefOttava=h._8vb;break;case"15mb":t.clefOttava=h._15mb}break;case"SimileMark":switch(i.innerText){case"Simple":t.simileMark=l.Simple;break;case"FirstOfDouble":t.simileMark=l.FirstOfDouble;break;case"SecondOfDouble":t.simileMark=l.SecondOfDouble}break;case"XProperties":this.parseBarXProperties(i,t)}this._barsById.set(s,t)}parseVoices(e){for(const t of e.childElements())if("Voice"===t.localName)this.parseVoice(t)}parseVoice(e){const t=new te,s=e.getAttribute("id");for(const t of e.childElements())if("Beats"===t.localName)this._beatsOfVoice.set(s,Nt.splitSafe(t.innerText));this._voiceById.set(s,t)}parseBeats(e){for(const t of e.childElements())if("Beat"===t.localName)this.parseBeat(t)}parseBeat(e){const t=new Ue,s=e.getAttribute("id");for(const i of e.childElements())switch(i.localName){case"Notes":this._notesOfBeat.set(s,Nt.splitSafe(i.innerText));break;case"Rhythm":this._rhythmOfBeat.set(s,i.getAttribute("ref"));break;case"Fadding":switch(i.innerText){case"FadeIn":t.fade=pe.FadeIn;break;case"FadeOut":t.fade=pe.FadeOut;break;case"VolumeSwell":t.fade=pe.VolumeSwell}break;case"Tremolo":switch(i.innerText){case"1/2":t.tremoloSpeed=w.Eighth;break;case"1/4":t.tremoloSpeed=w.Sixteenth;break;case"1/8":t.tremoloSpeed=w.ThirtySecond}break;case"Chord":t.chordId=i.innerText;break;case"Hairpin":switch(i.innerText){case"Crescendo":t.crescendo=_.Crescendo;break;case"Decrescendo":t.crescendo=_.Decrescendo}break;case"Arpeggio":"Up"===i.innerText?t.brushType=S.ArpeggioUp:t.brushType=S.ArpeggioDown;break;case"Properties":this.parseBeatProperties(i,t);break;case"XProperties":this.parseBeatXProperties(i,t);break;case"FreeText":t.text=i.innerText;break;case"TransposedPitchStemOrientation":switch(i.innerText){case"Upward":t.preferredBeamDirection=Ne.Up;break;case"Downward":t.preferredBeamDirection=Ne.Down}break;case"Dynamic":switch(i.innerText){case"PPP":t.dynamics=m.PPP;break;case"PP":t.dynamics=m.PP;break;case"P":t.dynamics=m.P;break;case"MP":t.dynamics=m.MP;break;case"MF":t.dynamics=m.MF;break;case"F":t.dynamics=m.F;break;case"FF":t.dynamics=m.FF;break;case"FFF":t.dynamics=m.FFF}break;case"GraceNotes":switch(i.innerText){case"OnBeat":t.graceType=B.OnBeat;break;case"BeforeBeat":t.graceType=B.BeforeBeat}break;case"Legato":"true"===i.getAttribute("origin")&&(t.isLegatoOrigin=!0);break;case"Whammy":const e=new J(0,0);e.value=this.toBendValue(Nt.parseFloatSafe(i.getAttribute("originValue"),0)),e.offset=this.toBendOffset(Nt.parseFloatSafe(i.getAttribute("originOffset"),0)),t.addWhammyBarPoint(e);const a=new J(0,0);a.value=this.toBendValue(Nt.parseFloatSafe(i.getAttribute("middleValue"),0)),a.offset=this.toBendOffset(Nt.parseFloatSafe(i.getAttribute("middleOffset1"),0)),t.addWhammyBarPoint(a);const r=new J(0,0);r.value=this.toBendValue(Nt.parseFloatSafe(i.getAttribute("middleValue"),0)),r.offset=this.toBendOffset(Nt.parseFloatSafe(i.getAttribute("middleOffset2"),0)),t.addWhammyBarPoint(r);const n=new J(0,0);n.value=this.toBendValue(Nt.parseFloatSafe(i.getAttribute("destinationValue"),0)),n.offset=this.toBendOffset(Nt.parseFloatSafe(i.getAttribute("destinationOffset"),0)),t.addWhammyBarPoint(n);break;case"Ottavia":switch(i.innerText){case"8va":t.ottava=h._8va;break;case"8vb":t.ottava=h._8vb;break;case"15ma":t.ottava=h._15ma;break;case"15mb":t.ottava=h._15mb}break;case"Lyrics":t.lyrics=this.parseBeatLyrics(i),this._skipApplyLyrics=!0;break;case"Slashed":t.slashed=!0;break;case"DeadSlapped":t.deadSlapped=!0;break;case"Golpe":switch(i.innerText){case"Finger":t.golpe=ue.Finger;break;case"Thumb":t.golpe=ue.Thumb}break;case"Wah":switch(i.innerText){case"Open":t.wahPedal=ge.Open;break;case"Closed":t.wahPedal=ge.Closed}break;case"UserTransposedPitchStemOrientation":switch(i.innerText){case"Downward":t.preferredBeamDirection=Ne.Down;break;case"Upward":t.preferredBeamDirection=Ne.Up}break;case"Timer":t.showTimer=!0,t.timer=Nt.parseIntSafe(i.innerText,-1),t.timer<0&&(t.timer=null)}this._beatById.set(s,t)}parseBeatLyrics(e){const t=[];for(const s of e.childElements())if("Line"===s.localName)t.push(s.innerText);return t}parseBeatXProperties(e,t){for(const s of e.childElements())if("XProperty"===s.localName){let e=0;switch(s.getAttribute("id")){case"1124204546":switch(e=Nt.parseIntSafe(s.findChildElement("Int")?.innerText,0),e){case 1:t.beamingMode=ye.ForceMergeWithNext;break;case 2:t.beamingMode=ye.ForceSplitToNext}break;case"1124204552":if(e=Nt.parseIntSafe(s.findChildElement("Int")?.innerText,0),1===e)t.beamingMode!==ye.ForceSplitToNext&&(t.beamingMode=ye.ForceSplitOnSecondaryToNext);break;case"1124204545":e=Nt.parseIntSafe(s.findChildElement("Int")?.innerText,0),t.invertBeamDirection=1===e;break;case"687935489":e=Nt.parseIntSafe(s.findChildElement("Int")?.innerText,0),t.brushDuration=e}}}parseBarXProperties(e,t){for(const s of e.childElements())if("XProperty"===s.localName){if("1124139520"===s.getAttribute("id")){const e=s.findChildElement("Double")??s.findChildElement("Float");t.displayScale=Nt.parseFloatSafe(e?.innerText,1)}}}parseMasterBarXProperties(e,t){for(const s of t.childElements())if("XProperty"===s.localName){if("1124073984"===s.getAttribute("id"))e.displayScale=Nt.parseFloatSafe(s.findChildElement("Double")?.innerText,1)}}parseBeatProperties(e,t){let s=!1,i=null,a=null,r=null,n=null,o=null;for(const h of e.childElements())if("Property"===h.localName){switch(h.getAttribute("name")){case"Brush":"Up"===h.findChildElement("Direction")?.innerText?t.brushType=S.BrushUp:t.brushType=S.BrushDown;break;case"PickStroke":"Up"===h.findChildElement("Direction")?.innerText?t.pickStroke=re.Up:t.pickStroke=re.Down;break;case"Slapped":h.findChildElement("Enable")&&(t.slap=!0);break;case"Popped":h.findChildElement("Enable")&&(t.pop=!0);break;case"VibratoWTremBar":switch(h.findChildElement("Strength")?.innerText){case"Wide":t.vibrato=F.Wide;break;case"Slight":t.vibrato=F.Slight}break;case"WhammyBar":s=!0;break;case"WhammyBarExtend":break;case"WhammyBarOriginValue":i||(i=new J(0,0)),i.value=this.toBendValue(Nt.parseFloatSafe(h.findChildElement("Float")?.innerText,0));break;case"WhammyBarOriginOffset":i||(i=new J(0,0)),i.offset=this.toBendOffset(Nt.parseFloatSafe(h.findChildElement("Float")?.innerText,0));break;case"WhammyBarMiddleValue":a=this.toBendValue(Nt.parseFloatSafe(h.findChildElement("Float")?.innerText,0));break;case"WhammyBarMiddleOffset1":r=this.toBendOffset(Nt.parseFloatSafe(h.findChildElement("Float")?.innerText,0));break;case"WhammyBarMiddleOffset2":n=this.toBendOffset(Nt.parseFloatSafe(h.findChildElement("Float")?.innerText,0));break;case"WhammyBarDestinationValue":o||(o=new J(J.MaxPosition,0)),o.value=this.toBendValue(Nt.parseFloatSafe(h.findChildElement("Float")?.innerText,0));break;case"WhammyBarDestinationOffset":o||(o=new J(0,0)),o.offset=this.toBendOffset(Nt.parseFloatSafe(h.findChildElement("Float")?.innerText,0));break;case"BarreFret":t.barreFret=Nt.parseIntSafe(h.findChildElement("Fret")?.innerText,0);break;case"BarreString":switch(h.findChildElement("String")?.innerText){case"0":t.barreShape=me.Full;break;case"1":t.barreShape=me.Half}break;case"Rasgueado":switch(h.findChildElement("Rasgueado")?.innerText){case"ii_1":t.rasgueado=fe.Ii;break;case"mi_1":t.rasgueado=fe.Mi;break;case"mii_1":t.rasgueado=fe.MiiTriplet;break;case"mii_2":t.rasgueado=fe.MiiAnapaest;break;case"pmp_1":t.rasgueado=fe.PmpTriplet;break;case"pmp_2":t.rasgueado=fe.PmpAnapaest;break;case"pei_1":t.rasgueado=fe.PeiTriplet;break;case"pei_2":t.rasgueado=fe.PeiAnapaest;break;case"pai_1":t.rasgueado=fe.PaiTriplet;break;case"pai_2":t.rasgueado=fe.PaiAnapaest;break;case"ami_1":t.rasgueado=fe.AmiTriplet;break;case"ami_2":t.rasgueado=fe.AmiAnapaest;break;case"ppp_1":t.rasgueado=fe.Ppp;break;case"amii_1":t.rasgueado=fe.Amii;break;case"amip_1":t.rasgueado=fe.Amip;break;case"eami_1":t.rasgueado=fe.Eami;break;case"eamii_1":t.rasgueado=fe.Eamii;break;case"peami_1":t.rasgueado=fe.Peami}}}s&&(i||(i=new J(0,0)),o||(o=new J(J.MaxPosition,0)),t.addWhammyBarPoint(i),r&&a&&t.addWhammyBarPoint(new J(r,a)),n&&a&&t.addWhammyBarPoint(new J(n,a)),r||n||!a||t.addWhammyBarPoint(new J(J.MaxPosition/2|0,a)),t.addWhammyBarPoint(o))}parseNotes(e){for(const t of e.childElements())if("Note"===t.localName)this.parseNote(t)}parseNote(e){const t=new Re,s=e.getAttribute("id");for(const i of e.childElements())switch(i.localName){case"Properties":this.parseNoteProperties(i,t,s);break;case"AntiAccent":"normal"===i.innerText.toLowerCase()&&(t.isGhost=!0);break;case"LetRing":t.isLetRing=!0;break;case"Trill":t.trillValue=Nt.parseIntSafe(i.innerText,-1),t.trillSpeed=w.Sixteenth;break;case"Accent":const e=Nt.parseIntSafe(i.innerText,0);1&e&&(t.isStaccato=!0),4&e&&(t.accentuated=k.Heavy),8&e&&(t.accentuated=k.Normal),16&e&&(t.accentuated=k.Tenuto);break;case"Tie":"true"===i.getAttribute("destination").toLowerCase()&&(t.isTieDestination=!0);break;case"Vibrato":switch(i.innerText){case"Slight":t.vibrato=F.Slight;break;case"Wide":t.vibrato=F.Wide}break;case"LeftFingering":switch(i.innerText){case"P":t.leftHandFinger=T.Thumb;break;case"I":t.leftHandFinger=T.IndexFinger;break;case"M":t.leftHandFinger=T.MiddleFinger;break;case"A":t.leftHandFinger=T.AnnularFinger;break;case"C":t.leftHandFinger=T.LittleFinger}break;case"RightFingering":switch(i.innerText){case"P":t.rightHandFinger=T.Thumb;break;case"I":t.rightHandFinger=T.IndexFinger;break;case"M":t.rightHandFinger=T.MiddleFinger;break;case"A":t.rightHandFinger=T.AnnularFinger;break;case"C":t.rightHandFinger=T.LittleFinger}break;case"InstrumentArticulation":t.percussionArticulation=Nt.parseIntSafe(i.innerText,0);break;case"Ornament":switch(i.innerText){case"Turn":t.ornament=le.Turn;break;case"InvertedTurn":t.ornament=le.InvertedTurn;break;case"UpperMordent":t.ornament=le.UpperMordent;break;case"LowerMordent":t.ornament=le.LowerMordent}}this._noteById.set(s,t)}parseNoteProperties(e,t,s){let i=!1,a=null,r=null,n=null,o=null,h=null,l=-1,c=-1;for(const d of e.childElements())if("Property"===d.localName){switch(d.getAttribute("name")){case"ShowStringNumber":d.findChildElement("Enable")&&(t.showStringNumber=!0);break;case"String":t.string=Nt.parseIntSafe(d.findChildElement("String")?.innerText,0)+1;break;case"Fret":t.fret=Nt.parseIntSafe(d.findChildElement("Fret")?.innerText,0);break;case"Element":l=Nt.parseIntSafe(d.findChildElement("Element")?.innerText,0);break;case"Variation":c=Nt.parseIntSafe(d.findChildElement("Variation")?.innerText,0);break;case"Tapped":this._tappedNotes.set(s,!0);break;case"HarmonicType":const e=d.findChildElement("HType");if(e)switch(e.innerText){case"NoHarmonic":t.harmonicType=N.None;break;case"Natural":t.harmonicType=N.Natural;break;case"Artificial":t.harmonicType=N.Artificial;break;case"Pinch":t.harmonicType=N.Pinch;break;case"Tap":t.harmonicType=N.Tap;break;case"Semi":t.harmonicType=N.Semi;break;case"Feedback":t.harmonicType=N.Feedback}break;case"HarmonicFret":const u=d.findChildElement("HFret");u&&(t.harmonicValue=Nt.parseFloatSafe(u.innerText,0));break;case"Muted":d.findChildElement("Enable")&&(t.isDead=!0);break;case"PalmMuted":d.findChildElement("Enable")&&(t.isPalmMute=!0);break;case"Octave":t.octave=Nt.parseIntSafe(d.findChildElement("Number")?.innerText,0),-1===t.tone&&(t.tone=0);break;case"Tone":t.tone=Nt.parseIntSafe(d.findChildElement("Step")?.innerText,0);break;case"ConcertPitch":this.parseConcertPitch(d,t);break;case"Bended":i=!0;break;case"BendOriginValue":a||(a=new J(0,0)),a.value=this.toBendValue(Nt.parseFloatSafe(d.findChildElement("Float")?.innerText,0));break;case"BendOriginOffset":a||(a=new J(0,0)),a.offset=this.toBendOffset(Nt.parseFloatSafe(d.findChildElement("Float")?.innerText,0));break;case"BendMiddleValue":r=this.toBendValue(Nt.parseFloatSafe(d.findChildElement("Float")?.innerText,0));break;case"BendMiddleOffset1":n=this.toBendOffset(Nt.parseFloatSafe(d.findChildElement("Float")?.innerText,0));break;case"BendMiddleOffset2":o=this.toBendOffset(Nt.parseFloatSafe(d.findChildElement("Float")?.innerText,0));break;case"BendDestinationValue":h||(h=new J(J.MaxPosition,0)),h.value=this.toBendValue(Nt.parseFloatSafe(d.findChildElement("Float")?.innerText,0));break;case"BendDestinationOffset":h||(h=new J(0,0)),h.offset=this.toBendOffset(Nt.parseFloatSafe(d.findChildElement("Float")?.innerText,0));break;case"HopoOrigin":d.findChildElement("Enable")&&(t.isHammerPullOrigin=!0);break;case"HopoDestination":break;case"LeftHandTapped":t.isLeftHandTapped=!0;break;case"Slide":const p=Nt.parseIntSafe(d.findChildElement("Flags")?.innerText,0);1&p?t.slideOutType=P.Shift:2&p?t.slideOutType=P.Legato:4&p?t.slideOutType=P.OutDown:8&p&&(t.slideOutType=P.OutUp),16&p?t.slideInType=v.IntoFromBelow:32&p&&(t.slideInType=v.IntoFromAbove),64&p?t.slideOutType=P.PickSlideDown:128&p&&(t.slideOutType=P.PickSlideUp)}}i&&(a||(a=new J(0,0)),h||(h=new J(J.MaxPosition,0)),t.addBendPoint(a),n&&r&&t.addBendPoint(new J(n,r)),o&&r&&t.addBendPoint(new J(o,r)),n||o||!r||t.addBendPoint(new J(J.MaxPosition/2|0,r)),t.addBendPoint(h)),-1!==l&&-1!==c&&(t.percussionArticulation=Le.articulationFromElementVariation(l,c))}parseConcertPitch(e,t){const s=e.findChildElement("Pitch");if(s)for(const e of s.childElements())if("Accidental"===e.localName)switch(e.innerText){case"x":t.accidentalMode=x.ForceDoubleSharp;break;case"#":t.accidentalMode=x.ForceSharp;break;case"b":t.accidentalMode=x.ForceFlat;break;case"bb":t.accidentalMode=x.ForceDoubleFlat}}toBendValue(e){return e*Nt.BendPointValueFactor|0}toBendOffset(e){return e*Nt.BendPointPositionFactor}parseRhythms(e){for(const t of e.childElements())if("Rhythm"===t.localName)this.parseRhythm(t)}parseRhythm(e){const t=new kt,s=e.getAttribute("id");t.id=s;for(const s of e.childElements())switch(s.localName){case"NoteValue":switch(s.innerText){case"Long":t.value=w.QuadrupleWhole;break;case"DoubleWhole":t.value=w.DoubleWhole;break;case"Whole":t.value=w.Whole;break;case"Half":t.value=w.Half;break;case"Quarter":t.value=w.Quarter;break;case"Eighth":t.value=w.Eighth;break;case"16th":t.value=w.Sixteenth;break;case"32nd":t.value=w.ThirtySecond;break;case"64th":t.value=w.SixtyFourth;break;case"128th":t.value=w.OneHundredTwentyEighth;break;case"256th":t.value=w.TwoHundredFiftySixth}break;case"PrimaryTuplet":t.tupletNumerator=Nt.parseIntSafe(s.getAttribute("num"),-1),t.tupletDenominator=Nt.parseIntSafe(s.getAttribute("den"),-1);break;case"AugmentationDot":t.dots=Nt.parseIntSafe(s.getAttribute("count"),0)}this._rhythmById.set(s,t)}buildModel(){for(let e=0,t=this._masterBars.length;e<t;e++){const t=this._masterBars[e];this.score.addMasterBar(t)}const e=this._masterBars[this._masterBars.length-1];this._doubleBars.has(e)&&(this._doubleBars.delete(e),e.isDoubleBar=!1);for(const e of this._tracksMapping){if(!e)continue;const t=this._tracksById.get(e);this.score.addTrack(t)}let t;for(const e of this._barsOfMasterBar){let s=0;t=[c.C,d.Major];for(let i=0,a=0;i<e.length&&a<this.score.tracks.length;i++){const r=e[i];if(r!==Nt.InvalidId){const e=this._barsById.get(r),i=this.score.tracks[a],n=i.staves[s];n.addBar(e);const o=n.bars.length-1;if(this._keySignatures.has(o)&&(t=this._keySignatures.get(o)),e.keySignature=t[0],e.keySignatureType=t[1],this._doubleBars.has(e.masterBar)&&(e.barLineRight=g.LightLight),this._voicesOfBar.has(r))for(const t of this._voicesOfBar.get(r))if(t!==Nt.InvalidId){const s=this._voiceById.get(t);if(e.addVoice(s),this._beatsOfVoice.has(t))for(const e of this._beatsOfVoice.get(t))if(e!==Nt.InvalidId){const t=Ge.clone(this._beatById.get(e));s.addBeat(t);const i=this._rhythmOfBeat.get(e),a=this._rhythmById.get(i);if(t.duration=a.value,t.dots=a.dots,t.tupletNumerator=a.tupletNumerator,t.tupletDenominator=a.tupletDenominator,this._notesOfBeat.has(e))for(const s of this._notesOfBeat.get(e))if(s!==Nt.InvalidId){const e=We.clone(this._noteById.get(s));n.isPercussion?(e.fret=-1,e.string=-1):e.percussionArticulation=-1,t.addNote(e),this._tappedNotes.has(s)&&(t.tap=!0)}}}else{const t=new te;e.addVoice(t);const s=new Ue;s.isEmpty=!0,s.duration=w.Quarter,t.addBeat(s)}s===i.staves.length-1?(a++,s=0,t=[c.C,d.Major]):(s++,t=[c.C,d.Major])}else a++}}for(const e of this._tracksMapping){if(!e)continue;const t=this._tracksById.get(e);let s=!1;for(const e of t.staves)if(e.isPercussion){s=!0;break}if(s||(t.percussionArticulations=[]),this._automationsPerTrackIdAndBarIndex.has(e)){const s=this._automationsPerTrackIdAndBarIndex.get(e);for(const[e,i]of s)if(t.staves.length>0&&e<t.staves[0].bars.length){const s=t.staves[0].bars[e];if(s.voices.length>0&&s.voices[0].beats.length>0){const e=s.voices[0].beats[0];for(const t of i)e.automations.push(t)}}}if(this._sustainPedalsPerTrackIdAndBarIndex.has(e)){const s=this._sustainPedalsPerTrackIdAndBarIndex.get(e);for(const[e,i]of s)if(t.staves.length>0&&e<t.staves[0].bars.length){t.staves[0].bars[e].sustainPedals=i}}}for(const[e,t]of this._masterTrackAutomations){const s=this.score.masterBars[e];for(let i=0,a=t.length;i<a;i++){const a=t[i];a.type===f.Tempo&&(0===e&&(this.score.tempo=0|a.value,a.text&&(this.score.tempoLabel=a.text)),s.tempoAutomations.push(a))}}}}Nt.InvalidId="-1",Nt.BendPointPositionFactor=J.MaxPosition/100,Nt.BendPointValueFactor=.04;class xt{constructor(){this.isMultiRest=!1,this.trackViewGroups=[]}}class vt{constructor(){this.showNumbered=!1,this.showSlash=!1,this.showStandardNotation=!1,this.showTablature=!1}}class Pt{apply(e){if(this.scoreViews.length>0){let t=0;e.stylesheet.multiTrackMultiBarRest=this.scoreViews[0].isMultiRest;for(const s of this.scoreViews[0].trackViewGroups){if(t<e.tracks.length){const i=e.tracks[t];for(const e of i.staves)e.showTablature=s.showTablature,e.showStandardNotation=s.showStandardNotation,e.showSlash=s.showSlash,e.showNumbered=s.showNumbered}t++}for(let s=1;s<this.scoreViews.length;s++)this.scoreViews[s].isMultiRest&&(e.stylesheet.perTrackMultiBarRest||(e.stylesheet.perTrackMultiBarRest=new Set),t=s-1,e.stylesheet.perTrackMultiBarRest.add(t))}}constructor(e){this.scoreViews=[];const t=lt.fromBuffer(e),s=ht.readInt32BE(t);for(let e=0;e<s;e++){const e=new xt;this.scoreViews.push(e),e.isMultiRest=gt.gpReadBool(t);const s=ht.readInt32BE(t);for(let i=0;i<s;i++){let s=t.readByte();0===s&&(s=1);const i=new vt;i.showStandardNotation=!!(1&s),i.showTablature=!!(2&s),i.showSlash=!!(4&s),i.showNumbered=!!(8&s),e.trackViewGroups.push(i)}}}static writeForScore(e){const t=lt.withCapacity(128),s=[new xt];s[0].isMultiRest=e.stylesheet.multiTrackMultiBarRest;for(const t of e.tracks){const i=new vt;i.showStandardNotation=t.staves[0].showStandardNotation,i.showTablature=t.staves[0].showTablature,i.showSlash=t.staves[0].showSlash,i.showNumbered=t.staves[0].showNumbered,s[0].trackViewGroups.push(i);const a=new xt;a.isMultiRest=!0===e.stylesheet.perTrackMultiBarRest?.has(t.index),a.trackViewGroups.push(i),s.push(a)}ht.writeInt32BE(t,s.length);for(const e of s){t.writeByte(e.isMultiRest?1:0),ht.writeInt32BE(t,e.trackViewGroups.length);for(const s of e.trackViewGroups){let e=0;s.showStandardNotation&&(e|=1),s.showTablature&&(e|=2),s.showSlash&&(e|=4),s.showNumbered&&(e|=8),t.writeByte(e)}}return ht.writeInt32BE(t,1),t.toArray()}}let Ft=class{};class Ct extends Ft{constructor(e){super(),this.n=e}}class Et extends Ft{constructor(e,t){super(),this.left=e,this.right=t}}class Dt extends Ft{constructor(e,t){super(),this.n=e,this.table=t}}class Mt{static make(e,t,s,i){const a=[],r=[];if(i>32)throw new et("Invalid huffman");for(let e=0;e<i;e++)a.push(0),r.push(0);for(let r=0;r<s;r++){const s=e[r+t];if(s>=i)throw new et("Invalid huffman");a[s]++}let n=0;for(let e=1;e<i-1;e++)n=n+a[e]<<1,r[e]=n;const o=new Map;for(let i=0;i<s;i++){const s=e[i+t];if(0!==s){const e=r[s-1];r[s-1]=e+1,o.set(e<<5|s,i)}}return Mt.treeCompress(new Et(Mt.treeMake(o,i,0,1),Mt.treeMake(o,i,1,1)))}static treeMake(e,t,s,i){if(i>t)throw new et("Invalid huffman");const a=s<<5|i;return e.has(a)?new Ct(e.get(a)):(s<<=1,i+=1,new Et(Mt.treeMake(e,t,s,i),Mt.treeMake(e,t,1|s,i)))}static treeCompress(e){const t=Mt.treeDepth(e);if(0===t)return e;if(1===t){if(e instanceof Et)return new Et(Mt.treeCompress(e.left),Mt.treeCompress(e.right));throw new et("assert")}const s=1<<t,i=[];for(let e=0;e<s;e++)i.push(new Ct(-1));return Mt.treeWalk(i,0,0,t,e),new Dt(t,i)}static treeWalk(e,t,s,i,a){a instanceof Et&&i>0?(Mt.treeWalk(e,t,s+1,i-1,a.left),Mt.treeWalk(e,t|1<<s,s+1,i-1,a.right)):e[t]=Mt.treeCompress(a)}static treeDepth(e){if(e instanceof Ct)return 0;if(e instanceof Dt)throw new et("assert");if(e instanceof Et){const t=Mt.treeDepth(e.left),s=Mt.treeDepth(e.right);return 1+(t<s?t:s)}return 0}}var Lt,At,It,Rt,Ot,Ht,Wt,Vt,Gt,zt,Ut,Xt,Jt,Yt,$t,qt,jt,Kt,Qt,Zt,es,ts,ss,is,as,rs,ns,os,hs;!function(e){e[e.Head=0]="Head",e[e.Block=1]="Block",e[e.CData=2]="CData",e[e.Flat=3]="Flat",e[e.Crc=4]="Crc",e[e.Dist=5]="Dist",e[e.DistOne=6]="DistOne",e[e.Done=7]="Done"}(Lt||(Lt={}));class ls{constructor(){this.buffer=new Uint8Array(ls.BufferSize),this.pos=0}slide(){const e=new Uint8Array(ls.BufferSize);this.pos-=ls.Size,e.set(this.buffer.subarray(ls.Size,ls.Size+this.pos),0),this.buffer=e}addBytes(e,t,s){this.pos+s>ls.BufferSize&&this.slide(),this.buffer.set(e.subarray(t,t+s),this.pos),this.pos+=s}addByte(e){this.pos===ls.BufferSize&&this.slide(),this.buffer[this.pos]=e,this.pos++}getLastChar(){return this.buffer[this.pos-1]}available(){return this.pos}}ls.Size=32768,ls.BufferSize=65536;class cs{static buildFixedHuffman(){const e=[];for(let t=0;t<288;t++)e.push(t<=143?8:t<=255?9:t<=279?7:8);return Mt.make(e,0,288,10)}constructor(e){this._nbits=0,this._bits=0,this._state=Lt.Block,this._isFinal=!1,this._huffman=cs._fixedHuffman,this._huffdist=null,this._len=0,this._dist=0,this._needed=0,this._output=null,this._outpos=0,this._lengths=[],this._window=new ls,this._input=e;for(let e=0;e<19;e++)this._lengths.push(-1)}readBytes(e,t,s){if(this._needed=s,this._outpos=t,this._output=e,s>0)for(;this.inflateLoop(););return s-this._needed}inflateLoop(){switch(this._state){case Lt.Head:const e=this._input.readByte();if(8!==(15&e))throw new et("Invalid data");const t=this._input.readByte(),s=!!(32&t);if(((e<<8)+t)%31!=0)throw new et("Invalid data");if(s)throw new et("Unsupported dictionary");return this._state=Lt.Block,!0;case Lt.Crc:return this._state=Lt.Done,!0;case Lt.Done:return!1;case Lt.Block:switch(this._isFinal=this.getBit(),this.getBits(2)){case 0:this._len=ht.readUInt16LE(this._input);if(ht.readUInt16LE(this._input)!==65535-this._len)throw new et("Invalid data");this._state=Lt.Flat;const e=this.inflateLoop();return this.resetBits(),e;case 1:return this._huffman=cs._fixedHuffman,this._huffdist=null,this._state=Lt.CData,!0;case 2:const t=this.getBits(5)+257,s=this.getBits(5)+1,i=this.getBits(4)+4;for(let e=0;e<i;e++)this._lengths[cs.CodeLengthsPos[e]]=this.getBits(3);for(let e=i;e<19;e++)this._lengths[cs.CodeLengthsPos[e]]=0;this._huffman=Mt.make(this._lengths,0,19,8);const a=[];for(let e=0;e<t+s;e++)a.push(0);return this.inflateLengths(a,t+s),this._huffdist=Mt.make(a,t,s,16),this._huffman=Mt.make(a,0,t,16),this._state=Lt.CData,!0;default:throw new et("Invalid data")}case Lt.Flat:{const e=this._len<this._needed?this._len:this._needed,t=ht.readByteArray(this._input,e);return this._len-=e,this.addBytes(t,0,e),0===this._len&&(this._state=this._isFinal?Lt.Crc:Lt.Block),this._needed>0}case Lt.DistOne:{const e=this._len<this._needed?this._len:this._needed;return this.addDistOne(e),this._len-=e,0===this._len&&(this._state=Lt.CData),this._needed>0}case Lt.Dist:for(;this._len>0&&this._needed>0;){const e=this._len<this._dist?this._len:this._dist,t=this._needed<e?this._needed:e;this.addDist(this._dist,t),this._len-=t}return 0===this._len&&(this._state=Lt.CData),this._needed>0;case Lt.CData:let i=this.applyHuffman(this._huffman);if(i<256)return this.addByte(i),this._needed>0;if(256===i)return this._state=this._isFinal?Lt.Crc:Lt.Block,!0;i=i-257&255;let a=cs.LenExtraBitsTbl[i];if(-1===a)throw new et("Invalid data");this._len=cs.LenBaseValTbl[i]+this.getBits(a);const r=this._huffdist,n=r?this.applyHuffman(r):this.getRevBits(5);if(a=cs.DistExtraBitsTbl[n],-1===a)throw new et("Invalid data");if(this._dist=cs.DistBaseValTbl[n]+this.getBits(a),this._dist>this._window.available())throw new et("Invalid data");return this._state=1===this._dist?Lt.DistOne:Lt.Dist,!0}return!1}addDistOne(e){const t=this._window.getLastChar();for(let s=0;s<e;s++)this.addByte(t)}addByte(e){this._window.addByte(e),this._output[this._outpos]=e,this._needed--,this._outpos++}addDist(e,t){this.addBytes(this._window.buffer,this._window.pos-e,t)}getBit(){0===this._nbits&&(this._nbits=8,this._bits=this._input.readByte());const e=!(1&~this._bits);return this._nbits--,this._bits=this._bits>>1,e}getBits(e){for(;this._nbits<e;)this._bits=this._bits|this._input.readByte()<<this._nbits,this._nbits+=8;const t=this._bits&(1<<e)-1;return this._nbits-=e,this._bits=this._bits>>e,t}getRevBits(e){return 0===e?0:this.getBit()?1<<e-1|this.getRevBits(e-1):this.getRevBits(e-1)}resetBits(){this._bits=0,this._nbits=0}addBytes(e,t,s){this._window.addBytes(e,t,s),this._output.set(e.subarray(t,t+s),this._outpos),this._needed-=s,this._outpos+=s}inflateLengths(e,t){let s=0,i=0;for(;s<t;){const a=this.applyHuffman(this._huffman);switch(a){case 0:case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 9:case 10:case 11:case 12:case 13:case 14:case 15:i=a,e[s]=a,s++;break;case 16:const r=s+3+this.getBits(2);if(r>t)throw new et("Invalid data");for(;s<r;)e[s]=i,s++;break;case 17:if(s+=3+this.getBits(3),s>t)throw new et("Invalid data");break;case 18:if(s+=11+this.getBits(7),s>t)throw new et("Invalid data");break;default:throw new et("Invalid data")}}}applyHuffman(e){if(e instanceof Ct)return e.n;if(e instanceof Et)return this.applyHuffman(this.getBit()?e.right:e.left);if(e instanceof Dt)return this.applyHuffman(e.table[this.getBits(e.n)]);throw new et("Invalid data")}}cs.LenExtraBitsTbl=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0,-1,-1],cs.LenBaseValTbl=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258],cs.DistExtraBitsTbl=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13,-1,-1],cs.DistBaseValTbl=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577],cs.CodeLengthsPos=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],cs._fixedHuffman=cs.buildFixedHuffman();class ds{constructor(e,t){this.fullName=e;const s=e.lastIndexOf("/");this.fileName=-1===s||s===e.length-1?this.fullName:e.substr(s+1),this.data=t}}ds.OptionalDataDescriptorSignature=134695760,ds.CompressionMethodDeflate=8,ds.LocalFileHeaderSignature=67324752,ds.CentralFileHeaderSignature=33639248,ds.EndOfCentralDirSignature=101010256;class us{constructor(e){this._readable=e}read(){const e=[];for(;;){const t=this.readEntry();if(!t)break;e.push(t)}return e}readEntry(){const e=this._readable;if(ht.readInt32LE(e)!==ds.LocalFileHeaderSignature)return null;ht.readUInt16LE(e);const t=ht.readUInt16LE(e),s=ht.readUInt16LE(e),i=0!==s;if(i&&s!==ds.CompressionMethodDeflate)return null;ht.readInt16LE(this._readable),ht.readInt16LE(this._readable),ht.readInt32LE(e),ht.readInt32LE(e);const a=ht.readInt32LE(e),r=ht.readInt16LE(e),n=ht.readInt16LE(e),o=ht.toString(ht.readByteArray(e,r),"utf-8");let h;if(e.skip(n),i){const e=lt.empty(),t=new cs(this._readable),s=new Uint8Array(65536);for(;;){const i=t.readBytes(s,0,s.length);if(e.write(s,0,i),i<s.length)break}h=e.toArray()}else h=ht.readByteArray(this._readable,a);if(8&t){ht.readInt32LE(this._readable)===ds.OptionalDataDescriptorSignature&&ht.readInt32LE(this._readable),ht.readInt32LE(this._readable),ht.readInt32LE(this._readable)}return new ds(o,h)}}class ps{constructor(){this.trackViewGroups=[]}}class gs{constructor(){this.isVisible=!1}}!function(e){e[e.PageVertical=0]="PageVertical",e[e.PageGrid=1]="PageGrid",e[e.PageParchment=2]="PageParchment",e[e.ScreenVertical=3]="ScreenVertical",e[e.ScreenHorizontal=4]="ScreenHorizontal",e[e.PageHorizontal=5]="PageHorizontal"}(At||(At={}));class ms{constructor(e,t){this.zoomLevel=4,this.view=At.PageVertical,this.muiltiVoiceCursor=!1,this.scoreViews=[];const s=lt.fromBuffer(t);this.zoomLevel=ht.readInt32BE(s),this.view=s.readByte(),this.muiltiVoiceCursor=0!==s.readByte();const i=e.scoreViews.length;for(let t=0;t<i;t++){const i=new ps;this.scoreViews.push(i);const a=e.scoreViews[t];for(let e=0;e<a.trackViewGroups.length;e++){const e=new gs;e.isVisible=0!==s.readByte(),i.trackViewGroups.push(e)}}}apply(e){if(this.scoreViews.length>0){let t=0;for(const s of this.scoreViews[0].trackViewGroups){if(t<e.tracks.length){e.tracks[t].isVisibleOnMultiTrack=s.isVisible}t++}}}static writeForScore(e){const t=lt.withCapacity(128);ht.writeInt32BE(t,4),t.writeByte(0);const s=e.tracks.length>0&&e.tracks[0].staves[0].bars[0].isMultiVoice;t.writeByte(s?255:0);for(const s of e.tracks)t.writeByte(s.isVisibleOnMultiTrack?255:0);for(const s of e.tracks)t.writeByte(255);return t.toArray()}}class fs extends $e{get name(){return"Guitar Pro 7-8"}readScore(){j.debug(this.name,"Loading ZIP entries");const e=new us(this.data);let t;try{t=e.read()}catch(e){throw new je("No Zip archive",e)}j.debug(this.name,"Zip entries loaded");let s=null,i=null,a=null,r=null;for(const e of t)switch(e.fileName){case"score.gpif":s=ht.toString(e.data,this.settings.importer.encoding);break;case"BinaryStylesheet":i=e.data;break;case"PartConfiguration":a=e.data;break;case"LayoutConfiguration":r=e.data}if(!s)throw new je("No score.gpif found in zip archive");j.debug(this.name,"Start Parsing score.gpif");const n=new Nt;n.parseXml(s,this.settings),j.debug(this.name,"score.gpif parsed");const o=n.score;if(i){j.debug(this.name,"Start Parsing BinaryStylesheet");new yt(i).apply(o),j.debug(this.name,"BinaryStylesheet parsed")}let h=null;if(a&&(j.debug(this.name,"Start Parsing Part Configuration"),h=new Pt(a),h.apply(o),j.debug(this.name,"Part Configuration parsed")),r&&null!=h){j.debug(this.name,"Start Parsing Layout Configuration");new ms(h,r).apply(o),j.debug(this.name,"Layout Configuration parsed")}return o}}class ys extends qe{constructor(){super(e.AlphaTabErrorType.Format,"Unexpected end of data within reader"),Object.setPrototypeOf(this,ys.prototype)}}class bs{constructor(e){this._currentByte=0,this._position=bs.ByteSize,this._source=e}readByte(){return this.readBits(8)}readBytes(e){const t=new Uint8Array(e);for(let s=0;s<e;s++)t[s]=255&this.readByte();return t}readBits(e){let t=0,s=e-1;for(;s>=0;)t|=this.readBit()<<s,s--;return t}readBitsReversed(e){let t=0;for(let s=0;s<e;s++)t|=this.readBit()<<s;return t}readBit(){if(this._position>=8){if(this._currentByte=this._source.readByte(),-1===this._currentByte)throw new ys;this._position=0}const e=this._currentByte>>bs.ByteSize-this._position-1&1;return this._position++,e}readAll(){const e=lt.empty();try{for(;;)e.writeByte(255&this.readByte())}catch(e){if(!(e instanceof ys))throw e}return e.toArray()}}bs.ByteSize=8;class Ss{constructor(){this.fileName="",this.fileSize=0,this.data=null}}class _s{constructor(){this.files=[],this.files=[],this.fileFilter=e=>!0}load(e){const t=new bs(e);this.readBlock(t)}readHeader(e){return this.getString(e.readBytes(4),0,4)}decompress(e,t=!1){const s=lt.empty();let i;const a=this.getInteger(e.readBytes(4),0);try{for(;s.length<a;){if(1===e.readBits(1)){const t=e.readBits(4),a=e.readBitsReversed(t),r=e.readBitsReversed(t),n=s.length-a,o=Math.min(a,r);i=s.getBuffer(),s.write(i,n,o)}else{const t=e.readBitsReversed(2);for(let i=0;i<t;i++)s.writeByte(e.readByte())}}}catch(e){if(!(e instanceof ys))throw e}i=s.getBuffer();const r=t?4:0,n=s.length-r,o=new Uint8Array(n),h=n;return o.set(i.subarray(r,r+h),0),o}readBlock(e){const t=this.readHeader(e);if("BCFZ"===t)this.readUncompressedBlock(this.decompress(e,!0));else{if("BCFS"!==t)throw new je("Unsupported format");this.readUncompressedBlock(e.readAll())}}readUncompressedBlock(e){const t=4096;let s=t;for(;s+3<e.length;){if(2===this.getInteger(e,s)){const i=new Ss;i.fileName=this.getString(e,s+4,127),i.fileSize=this.getInteger(e,s+140);const a=!this.fileFilter||this.fileFilter(i.fileName);a&&this.files.push(i);const r=s+148;let n=0,o=0;const h=a?lt.withCapacity(i.fileSize):null;for(;n=this.getInteger(e,r+4*o++),0!==n;)s=n*t,a&&h.write(e,s,t);if(a){i.data=new Uint8Array(Math.min(i.fileSize,h.length));const e=h.toArray();i.data.set(e.subarray(0,0+i.data.length),0)}}s+=t}}getString(e,t,s){let i="";for(let a=0;a<s;a++){const s=255&e[t+a];if(0===s)break;i+=String.fromCharCode(s)}return i}getInteger(e,t){return e[t+3]<<24|e[t+2]<<16|e[t+1]<<8|e[t]}}_s.HeaderBcFs="BCFS",_s.HeaderBcFz="BCFZ";class ws extends $e{get name(){return"Guitar Pro 6"}readScore(){j.debug(this.name,"Loading GPX filesystem");const e=new _s;e.fileFilter=e=>e.endsWith("score.gpif")||e.endsWith("BinaryStylesheet")||e.endsWith("PartConfiguration")||e.endsWith("LayoutConfiguration"),e.load(this.data),j.debug(this.name,"GPX filesystem loaded");let t=null,s=null,i=null,a=null;for(const r of e.files)switch(r.fileName){case"score.gpif":t=ht.toString(r.data,this.settings.importer.encoding);break;case"BinaryStylesheet":s=r.data;break;case"PartConfiguration":i=r.data;break;case"LayoutConfiguration":a=r.data}if(!t)throw new je("No score.gpif found in GPX");j.debug(this.name,"Start Parsing score.gpif");const r=new Nt;r.parseXml(t,this.settings),j.debug(this.name,"score.gpif parsed");const n=r.score;if(s){j.debug(this.name,"Start Parsing BinaryStylesheet");new yt(s).apply(n),j.debug(this.name,"BinaryStylesheet parsed")}let o=null;if(i&&(j.debug(this.name,"Start Parsing Part Configuration"),o=new Pt(i),o.apply(n),j.debug(this.name,"Part Configuration parsed")),a&&null!=o){j.debug(this.name,"Start Parsing Layout Configuration");new ms(o,a).apply(n),j.debug(this.name,"Layout Configuration parsed")}return n}}!function(e){e[e.None=0]="None",e[e.Natural=1]="Natural",e[e.Sharp=2]="Sharp",e[e.Flat=3]="Flat",e[e.NaturalQuarterNoteUp=4]="NaturalQuarterNoteUp",e[e.SharpQuarterNoteUp=5]="SharpQuarterNoteUp",e[e.FlatQuarterNoteUp=6]="FlatQuarterNoteUp",e[e.DoubleSharp=7]="DoubleSharp",e[e.DoubleFlat=8]="DoubleFlat"}(It||(It={}));class Bs{constructor(){this.maxLine=-1e3,this.minLine=-1e3}}class ks{constructor(e){this._registeredAccidentals=new Map,this._appliedScoreLines=new Map,this._appliedScoreLinesByValue=new Map,this._notesByValue=new Map,this._beatLines=new Map,this.maxLineBeat=null,this.minLineBeat=null,this.maxLine=-1e3,this.minLine=-1e3,this._barRenderer=e,this._bar=e.bar}static getPercussionLine(e,t){return t<e.staff.track.percussionArticulations.length?e.staff.track.percussionArticulations[t].staffLine:Le.getArticulationByInputMidiNumber(t)?.staffLine??0}static getNoteValue(e){if(e.isPercussion)return e.percussionArticulation;let t=e.displayValue;switch(e.accidentalMode){case x.ForceDoubleFlat:t+=2;break;case x.ForceDoubleSharp:t-=2;break;case x.ForceFlat:t+=1;break;case x.ForceSharp:t-=1}return t}applyAccidental(e){const t=ks.getNoteValue(e),s=e.hasQuarterToneOffset;return this.getAccidental(t,s,e.beat,!1,e)}applyAccidentalForValue(e,t,s,i){return this.getAccidental(t,s,e,i,null)}static computeLineWithoutAccidentals(e,t){let s=0;const i=ks.getNoteValue(t);return s=t.isPercussion?ks.getPercussionLine(e,i):ks.calculateNoteSteps(e.keySignature,e.clef,i),s}static computeAccidental(e,t,s,i,a=null){const r=e+7,n=s%12,o=r<7?It.Flat:It.Sharp,h=ks.KeySignatureLookup[r][n],l=ks.AccidentalNotes[n];let c=It.None;if(i)switch(c=l?o:It.Natural,c){case It.Natural:c=It.NaturalQuarterNoteUp;break;case It.Sharp:c=It.SharpQuarterNoteUp;break;case It.Flat:c=It.FlatQuarterNoteUp}else{switch(t){case x.ForceSharp:c=It.Sharp;break;case x.ForceDoubleSharp:c=It.DoubleSharp;break;case x.ForceFlat:c=It.Flat;break;case x.ForceDoubleFlat:c=It.DoubleFlat;break;default:l?c=o:h&&(c=It.Natural)}c!==It.None?null!=a?a===c&&(c=It.None):h&&c===o&&(c=It.None):null!==a&&(c=a===It.Natural?It.None:It.Natural)}return c}getAccidental(e,t,s,i,a=null){let r=0,n=It.None;if(null!=a?a.isPercussion:this._bar.staff.isPercussion)r=ks.getPercussionLine(this._bar,e);else{const s=a?a.accidentalMode:x.Default;r=ks.calculateNoteSteps(this._bar.keySignature,this._bar.clef,e);const i=this._registeredAccidentals.has(r)?this._registeredAccidentals.get(r):null;n=ks.computeAccidental(this._bar.keySignature,s,e,t,i);let o=!1;switch(n){case It.NaturalQuarterNoteUp:case It.SharpQuarterNoteUp:case It.FlatQuarterNoteUp:break;default:if(a&&a.isTieDestination&&0===a.beat.index){const e=this._barRenderer.scoreRenderer.layout?.getRendererForBar(this._barRenderer.staff.staffId,a.tieOrigin.beat.voice.bar);if(e&&e.staff===this._barRenderer.staff){e.accidentalHelper.getNoteLine(a.tieOrigin)===r&&(o=!0)}}o?n=It.None:n!==It.None&&this._registeredAccidentals.set(r,n)}}return a?(this._appliedScoreLines.set(a.id,r),this._notesByValue.set(e,a)):this._appliedScoreLinesByValue.set(e,r),(-1e3===this.minLine||this.minLine<r)&&(this.minLine=r,this.minLineBeat=s),(-1e3===this.maxLine||this.maxLine>r)&&(this.maxLine=r,this.maxLineBeat=s),i||this.registerLine(s,r),n}registerLine(e,t){let s;this._beatLines.has(e.id)?s=this._beatLines.get(e.id):(s=new Bs,this._beatLines.set(e.id,s)),(-1e3===s.minLine||t<s.minLine)&&(s.minLine=t),(-1e3===s.minLine||t>s.maxLine)&&(s.maxLine=t)}getMaxLine(e){return this._beatLines.has(e.id)?this._beatLines.get(e.id).maxLine:0}getMinLine(e){return this._beatLines.has(e.id)?this._beatLines.get(e.id).minLine:0}static calculateNoteSteps(e,t,s){const i=e,a=t,r=s%12,n=(s/12|0)-1;let o=ks.OctaveSteps[a];o-=n*ks.StepsPerOctave;return o-=(ae.keySignatureIsSharp(i)||ae.keySignatureIsNatural(i)?ks.SharpNoteSteps:ks.FlatNoteSteps)[r],o}getNoteLine(e){return this._appliedScoreLines.get(e.id)}getNoteLineForValue(e,t=!1){return this._appliedScoreLinesByValue.has(e)?this._appliedScoreLinesByValue.get(e):t&&this._notesByValue.has(e)?this.getNoteLine(this._notesByValue.get(e)):0}}ks.KeySignatureLookup=[[!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0],[!0,!0,!0,!0,!0,!1,!0,!0,!0,!0,!0,!0],[!1,!0,!0,!0,!0,!1,!0,!0,!0,!0,!0,!0],[!1,!0,!0,!0,!0,!1,!1,!1,!0,!0,!0,!0],[!1,!1,!1,!0,!0,!1,!1,!1,!0,!0,!0,!0],[!1,!1,!1,!0,!0,!1,!1,!1,!1,!1,!0,!0],[!1,!1,!1,!1,!1,!1,!1,!1,!1,!1,!0,!0],[!1,!1,!1,!1,!1,!1,!1,!1,!1,!1,!1,!1],[!1,!1,!1,!1,!1,!0,!0,!1,!1,!1,!1,!1],[!0,!0,!1,!1,!1,!0,!0,!1,!1,!1,!1,!1],[!0,!0,!1,!1,!1,!0,!0,!0,!0,!1,!1,!1],[!0,!0,!0,!0,!1,!0,!0,!0,!0,!1,!1,!1],[!0,!0,!0,!0,!1,!0,!0,!0,!0,!0,!0,!1],[!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!1],[!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0]],ks.AccidentalNotes=[!1,!0,!1,!0,!1,!1,!0,!1,!0,!1,!0,!1],ks.StepsPerOctave=7,ks.OctaveSteps=[38,32,30,26,38],ks.SharpNoteSteps=[0,0,1,1,2,3,3,4,4,5,5,6],ks.FlatNoteSteps=[0,1,1,2,2,3,4,4,5,5,6,6];class Ts{constructor(){this.currentDynamics=m.F,this.slideOrigins=new Map,this.transpose=0,this.isExplicitlyBeamed=!1,this.tieStarts=new Set,this.tieStartIds=new Map,this.slideOrigins=new Map,this.slurStarts=new Map}}class Ns extends Me{constructor(){super(...arguments),this.outputMidiChannel=-1,this.outputMidiProgram=-1,this.outputVolume=-1,this.outputBalance=-1}}class xs{constructor(e){this.instruments=new Map,this._instrumentIdToArticulationIndex=new Map,this._lyricsLine=0,this._lyricsLines=new Map,this.track=e}getLyricLine(e){if(this._lyricsLines.has(e))return this._lyricsLines.get(e);const t=this._lyricsLine;return this._lyricsLines.set(e,t),this._lyricsLine++,t}getOrCreateArticulation(e,t){const s=12*t.octave+t.tone,i=`${e}_${s}`;if(this._instrumentIdToArticulationIndex.has(i))return this._instrumentIdToArticulationIndex.get(i);let a;a=this.instruments.has(e)?this.instruments.get(e):xs.defaultNoteArticulation;const r=this.track.percussionArticulations.length,n=t.beat.voice.bar;let o;o=0===s?4:ks.calculateNoteSteps(n.keySignature,n.clef,s);const h=o-(9-(2*t.beat.voice.bar.staff.standardNotationLineCount-1)),l=new Me(a.elementType,h,a.outputMidiNumber,a.noteHeadDefault,a.noteHeadHalf,a.noteHeadWhole,a.techniqueSymbol,a.techniqueSymbolPlacement);return this._instrumentIdToArticulationIndex.set(i,r),this.track.percussionArticulations.push(l),r}}xs.defaultNoteArticulation=new Me("Default",0,0,ne.NoteheadBlack,ne.NoteheadHalf,ne.NoteheadWhole);class vs extends $e{constructor(){super(...arguments),this._idToTrackInfo=new Map,this._indexToTrackInfo=new Map,this._staffToContext=new Map,this._divisionsPerQuarterNote=1,this._currentDynamics=m.F,this._musicalPosition=0,this._lastBeat=null,this._nextMasterBarRepeatEnding=0,this._nextBeatAutomations=null,this._nextBeatChord=null,this._nextBeatCrescendo=null,this._nextBeatLetRing=!1,this._nextBeatPalmMute=!1,this._nextBeatOttavia=null,this._nextBeatText=null,this._simileMarkAllStaves=null,this._simileMarkPerStaff=null,this._isBeatSlash=!1,this._keyAllStaves=null,this._currentTrillStep=-1}get name(){return"MusicXML"}readScore(){const e=this.extractMusicXml(),t=new Bt;try{t.parse(e)}catch(e){throw new je("Unsupported format",e)}return this._score=new Ye,this._score.tempo=120,this._score.stylesheet.hideDynamics=!0,this.parseDom(t),ae.consolidate(this._score),this._score.finish(this.settings),this._score.rebuildRepeatGroups(),this._score}extractMusicXml(){const e=new us(this.data);let t;try{t=e.read()}catch(e){t=[]}if(0===t.length)return this.data.reset(),ht.toString(this.data.readAll(),this.settings.importer.encoding);const s=t.find((e=>"META-INF/container.xml"===e.fullName));if(!s)throw new je("No compressed MusicXML");const i=new Bt;try{i.parse(ht.toString(s.data,this.settings.importer.encoding))}catch(e){throw new je("Malformed container.xml, could not parse as XML",e)}const a=i.firstElement;if(!a||"container"!==a.localName)throw new je("Malformed container.xml, root element not 'container'");const r=a.findChildElement("rootfiles");if(!r)throw new je("Malformed container.xml, 'container/rootfiles' not found");let n="";for(const e of r.childElements())if("rootfile"===e.localName){n=e.getAttribute("full-path");break}if(!n)throw new je("Unsupported compressed MusicXML, missing rootfile");const o=t.find((e=>e.fullName===n));if(!o)throw new je(`Malformed container.xml, '${n}' not contained in zip`);return ht.toString(o.data,this.settings.importer.encoding)}parseDom(e){const t=e.firstElement;if(!t)throw new je("Unsupported format");switch(t.localName){case"score-partwise":this.parsePartwise(t);break;case"score-timewise":this.parseTimewise(t);break;default:throw new je("Unsupported format")}}parsePartwise(e){for(const t of e.childElements())switch(t.localName){case"credit":this.parseCredit(t);break;case"identification":this.parseIdentification(t);break;case"movement-title":this.parseMovementTitle(t);break;case"part":this.parsePartwisePart(t);break;case"part-list":this.parsePartList(t);break;case"work":this.parseWork(t)}}parseTimewise(e){let t=0;for(const s of e.childElements())switch(s.localName){case"credit":this.parseCredit(s);break;case"identification":this.parseIdentification(s);break;case"movement-title":this.parseMovementTitle(s);break;case"part-list":this.parsePartList(s);break;case"work":this.parseWork(s);break;case"measure":this.parseTimewiseMeasure(s,t),t++}}parseCredit(e){if("1"!==e.getAttribute("page","1"))return;const t=[];let s=null,i="";for(const a of e.childElements())switch(a.localName){case"credit-type":t.push(a.innerText);break;case"credit-words":null===s&&(s=a),i+=a.innerText}if(t.length>0)for(const e of t)switch(e){case"title":this._score.title=vs.sanitizeDisplay(i);break;case"subtitle":this._score.subTitle=vs.sanitizeDisplay(i);break;case"composer":case"arranger":this._score.artist=vs.sanitizeDisplay(i);break;case"lyricist":this._score.words=vs.sanitizeDisplay(i);break;case"rights":this._score.copyright=vs.sanitizeDisplay(i)}else if(s){const e=s.getAttribute("font-size","0"),t=s.getAttribute("font-size","top"),a=s.getAttribute("halign","left");if("top"===t){if(i.includes("copyright")||i.includes("Copyright")||i.includes("©")||i.includes("(c)")||i.includes("(C)"))return void(this._score.copyright=vs.sanitizeDisplay(i));if("center"===a||"center"===e){if(0===this._score.title.length)return void(this._score.title=vs.sanitizeDisplay(i));if(0===this._score.subTitle.length)return void(this._score.subTitle=vs.sanitizeDisplay(i));if(0===this._score.album.length)return void(this._score.album=vs.sanitizeDisplay(i))}else if(("right"===a||"right"===e)&&0===this._score.music.length)return void(this._score.music=vs.sanitizeDisplay(i));if(0===this._score.artist.length)return void(this._score.artist=vs.sanitizeDisplay(i));if(0===this._score.words.length)return void(this._score.words=vs.sanitizeDisplay(i))}}}static sanitizeDisplay(e){return e.replaceAll("\r","").replaceAll("\n"," ").replaceAll("\t","  ").replaceAll(" "," ")}parseIdentification(e){for(const t of e.childElements())switch(t.localName){case"creator":if(t.attributes.has("type"))switch(t.attributes.get("type")){case"composer":this._score.artist=vs.sanitizeDisplay(t.innerText);break;case"lyricist":this._score.words=vs.sanitizeDisplay(t.innerText);break;case"arranger":this._score.music=vs.sanitizeDisplay(t.innerText)}else this._score.artist=vs.sanitizeDisplay(t.innerText);break;case"rights":this._score.copyright.length>0&&(this._score.copyright+=", "),this._score.copyright+=t.innerText,t.attributes.has("type")&&(this._score.copyright+=` (${t.attributes.get("type")})`);break;case"encoding":this.parseEncoding(t)}}parseEncoding(e){for(const t of e.childElements())switch(t.localName){case"encoder":this._score.tab.length>0&&(this._score.tab+=", "),this._score.tab+=t.innerText,t.attributes.has("type")&&(this._score.tab+=` (${t.attributes.get("type")})`);break;case"encoding-description":this._score.notices+=vs.sanitizeDisplay(t.innerText)}}parseMovementTitle(e){0===this._score.title.length?this._score.title=vs.sanitizeDisplay(e.innerText):this._score.subTitle=vs.sanitizeDisplay(e.innerText)}parsePartList(e){for(const t of e.childElements())if("score-part"===t.localName)this.parseScorePart(t)}parseScorePart(e){const t=new nt;t.ensureStaveCount(1),this._score.addTrack(t);const s=e.attributes.get("id"),i=new xs(t);this._idToTrackInfo.set(s,i),this._indexToTrackInfo.set(t.index,i);for(const s of e.childElements())switch(s.localName){case"part-name":t.name=vs.sanitizeDisplay(s.innerText);break;case"part-name-display":t.name=this.parsePartDisplayAsText(s);break;case"part-abbreviation":t.shortName=vs.sanitizeDisplay(s.innerText);break;case"part-abbreviation-display":t.shortName=this.parsePartDisplayAsText(s);break;case"score-instrument":this.parseScoreInstrument(s,i);break;case"midi-device":s.attributes.has("port")&&(t.playbackInfo.port=Number.parseInt(s.attributes.get("port"),10));break;case"midi-instrument":this.parseScorePartMidiInstrument(s,i)}i.firstArticulation&&(i.firstArticulation.outputMidiProgram>=0&&(t.playbackInfo.program=i.firstArticulation.outputMidiProgram),i.firstArticulation.outputBalance>=0&&(t.playbackInfo.balance=i.firstArticulation.outputBalance),i.firstArticulation.outputVolume>=0&&(t.playbackInfo.volume=i.firstArticulation.outputVolume),i.firstArticulation.outputMidiChannel>=0&&(t.playbackInfo.primaryChannel=i.firstArticulation.outputMidiChannel,t.playbackInfo.secondaryChannel=i.firstArticulation.outputMidiChannel))}parseScoreInstrument(e,t){const s=new Ns;t.firstArticulation||(t.firstArticulation=s),t.instruments.set(e.getAttribute("id",""),s)}parseScorePartMidiInstrument(e,t){const s=e.getAttribute("id","");if(!t.instruments.has(s))return;const i=t.instruments.get(s);for(const t of e.childElements())switch(t.localName){case"midi-channel":i.outputMidiChannel=Number.parseInt(t.innerText)-1;break;case"midi-program":i.outputMidiProgram=Number.parseInt(t.innerText)-1;break;case"midi-unpitched":i.outputMidiNumber=Number.parseInt(t.innerText)-1;break;case"volume":i.outputVolume=vs.interpolatePercent(Number.parseFloat(t.innerText));break;case"pan":i.outputBalance=vs.interpolatePan(Number.parseFloat(t.innerText))}}static interpolatePercent(e){return 0|vs.interpolate(0,100,0,16,e)}static interpolatePan(e){return 0|vs.interpolate(-90,90,0,16,e)}static interpolate(e,t,s,i,a){return s+(i-s)*((a-e)/(t-e))}parsePartDisplayAsText(e){let t="";for(const s of e.childElements())switch(s.localName){case"display-text":t+=s.innerText;break;case"accidental-text":switch(s.innerText){case"sharp":t+="♯";break;case"natural":t+="♮";break;case"flat":t+="♭";break;case"double-sharp":t+="𝄪";break;case"sharp-sharp":t+="♯♯";break;case"flat-flat":t+="𝄫";break;case"natural-sharp":t+="♮♯";break;case"natural-flat":t+="♮♭";break;case"sharp-down":t+="𝄱";break;case"sharp-up":t+="𝄰";break;case"natural-down":t+="𝄯";break;case"natural-up":t+="𝄮";break;case"flat-down":t+="𝄭";break;case"flat-up":t+="𝄬";break;case"arrow-down":t+="↓";break;case"arrow-up":t+="↑";break;case"triple-sharp":t+="♯𝄪";break;case"triple-flat":t+="𝄬𝄬𝄬";break;case"sharp-1":t+="♯¹";break;case"sharp-2":t+="♯²";break;case"sharp-3":t+="♯³";break;case"sharp-4":t+="♯⁴";break;case"sharp-5":t+="♯⁵";break;case"flat-1":t+="♭¹";break;case"flat-2":t+="♭²";break;case"flat-3":t+="♭³";break;case"flat-4":t+="♭⁴";break;case"flat-5":t+="♭⁵"}}return vs.sanitizeDisplay(t)}parseWork(e){for(const t of e.childElements())if("work-title"===t.localName)this._score.title=vs.sanitizeDisplay(t.innerText)}parsePartwisePart(e){const t=e.attributes.get("id");if(!t||!this._idToTrackInfo.has(t))return;const s=this._idToTrackInfo.get(t).track;let i=0;for(const t of e.childElements())if("measure"===t.localName)this.parsePartwiseMeasure(t,s,i),i++}parsePartwiseMeasure(e,t,s){const i=this.getOrCreateMasterBar(e,s);this.parsePartMeasure(e,i,t)}parseTimewiseMeasure(e,t){const s=this.getOrCreateMasterBar(e,t);for(const t of e.childElements())if("part"===t.localName)this.parseTimewisePart(t,s)}getOrCreateMasterBar(e,t){const s="yes"===e.attributes.get("implicit");for(;this._score.masterBars.length<=t;){const e=new K;s&&(e.isAnacrusis=!0),this._score.addMasterBar(e),e.index>0&&(e.timeSignatureDenominator=e.previousMasterBar.timeSignatureDenominator,e.timeSignatureNumerator=e.previousMasterBar.timeSignatureNumerator,e.tripletFeel=e.previousMasterBar.tripletFeel)}return this._score.masterBars[t]}parseTimewisePart(e,t){const s=e.attributes.get("id");if(!s||!this._idToTrackInfo.has(s))return;const i=this._idToTrackInfo.get(s).track;this.parsePartMeasure(e,t,i)}parsePartMeasure(e,t,s){this._musicalPosition=0,this._lastBeat=null,t.alternateEndings=this._nextMasterBarRepeatEnding;const i=[];for(const a of e.childElements())switch(a.localName){case"note":this.parseNote(a,t,s);break;case"backup":this.parseBackup(a);break;case"forward":this.parseForward(a);break;case"direction":this.parseDirection(a,t,s);break;case"attributes":this.parseAttributes(a,t,s);break;case"harmony":this.parseHarmony(a,s);break;case"print":this.parsePrint(a,t,s);break;case"sound":this.parseSound(a,t,s);break;case"barline":i.push(a)}for(const e of i)this.parseBarLine(e,t,s);this.applySimileMarks(t,s);const a=this.getOrCreateStaff(s,0);this.getOrCreateBar(a,t),this._keyAllStaves=null}parsePrint(e,t,s){("yes"===e.getAttribute("new-system","no")||"yes"===e.getAttribute("new-page","no"))&&s.addLineBreaks(t.index)}applySimileMarks(e,t){if(null!==this._simileMarkAllStaves){for(const s of t.staves){const t=this.getOrCreateBar(s,e);t.simileMark=this._simileMarkAllStaves,t.simileMark!==l.None&&this.clearBar(t)}this._simileMarkAllStaves===l.FirstOfDouble?this._simileMarkAllStaves=l.SecondOfDouble:this._simileMarkAllStaves=null}if(null!==this._simileMarkPerStaff){const s=Array.from(this._simileMarkPerStaff.keys());for(const i of s){const s=this.getOrCreateStaff(t,i),a=this.getOrCreateBar(s,e);a.simileMark=this._simileMarkPerStaff.get(i),a.simileMark!==l.None&&this.clearBar(a),a.simileMark===l.FirstOfDouble?this._simileMarkPerStaff.set(i,l.SecondOfDouble):this._simileMarkPerStaff.delete(i)}0===this._simileMarkPerStaff.size&&(this._simileMarkPerStaff=null)}}clearBar(e){for(const t of e.voices){const e=new Ue;e.isEmpty=!0,t.addBeat(e)}}parseBarLine(e,t,s){for(const i of e.childElements())switch(i.localName){case"bar-style":this.parseBarStyle(i,t,s,e.getAttribute("location","right"));break;case"ending":this.parseEnding(i,t);break;case"repeat":this.parseRepeat(i,t)}}parseRepeat(e,t){const s=e.getAttribute("direction");let i=Number.parseInt(e.getAttribute("times"));(i<0||Number.isNaN(i))&&(i=2),"backward"===s?t.repeatCount=i:"forward"===s&&(t.isRepeatStart=!0)}parseEnding(e,t){const s=e.getAttribute("number").split(",").map((e=>Number.parseInt(e)));let i=0;for(const e of s)i|=1<<e-1&255;switch(t.alternateEndings=i,e.getAttribute("type","")){case"start":this._nextMasterBarRepeatEnding=this._nextMasterBarRepeatEnding|i;break;case"stop":case"discontinue":this._nextMasterBarRepeatEnding=this._nextMasterBarRepeatEnding&~i}}parseBarStyle(e,t,s,i){let a=g.Automatic;switch(e.innerText){case"dashed":a=g.Dashed;break;case"dotted":a=g.Dotted;break;case"heavy":a=g.Heavy;break;case"heavy-heavy":a=g.HeavyHeavy;break;case"heavy-light":a=g.HeavyLight;break;case"light-heavy":a=g.LightHeavy;break;case"light-light":a=g.LightLight;break;case"none":a=g.None;break;case"regular":a=g.Regular;break;case"short":a=g.Short;break;case"tick":a=g.Tick}for(const e of s.staves){const s=this.getOrCreateBar(e,t);switch(i){case"left":s.barLineLeft=a;break;case"right":s.barLineRight=a}}}parseSound(e,t,s){for(const s of e.childElements())switch(s.localName){case"midi-instrument":this.parseSoundMidiInstrument(s,t);break;case"swing":this.parseSwing(s,t)}if(e.attributes.has("coda")&&t.addDirection(ke.TargetCoda),e.attributes.has("tocoda")&&t.addDirection(ke.JumpDaCoda),e.attributes.has("dacapo")&&t.addDirection(ke.JumpDaCapo),e.attributes.has("dalsegno")&&t.addDirection(ke.JumpDalSegno),e.attributes.has("fine")&&t.addDirection(ke.TargetFine),e.attributes.has("segno")&&t.addDirection(ke.TargetSegno),e.attributes.has("pan")){this._nextBeatAutomations||(this._nextBeatAutomations=[]);const t=new X;t.type=f.Balance,t.value=vs.interpolatePan(Number.parseFloat(e.attributes.get("pan"))),this._nextBeatAutomations.push(t)}if(e.attributes.has("tempo")){this._nextBeatAutomations||(this._nextBeatAutomations=[]);const t=new X;t.type=f.Tempo,t.value=vs.interpolatePercent(Number.parseFloat(e.attributes.get("tempo"))),this._nextBeatAutomations.push(t)}}parseSwing(e,t){let s=0,i=0,a=null;for(const r of e.childElements())switch(r.localName){case"straight":return void(t.tripletFeel=A.NoTripletFeel);case"first":s=Number.parseInt(r.innerText);break;case"second":i=Number.parseInt(r.innerText);break;case"swing-type":a=this.parseBeatDuration(r)}a||(a=w.Eighth),a===w.Eighth?2===s&&1===i?t.tripletFeel=A.Triplet8th:3===s&&1===i?t.tripletFeel=A.Dotted8th:1===s&&3===i&&(t.tripletFeel=A.Scottish8th):a===w.Sixteenth&&(2===s&&1===i?t.tripletFeel=A.Triplet16th:3===s&&1===i?t.tripletFeel=A.Dotted16th:1===s&&3===i&&(t.tripletFeel=A.Scottish16th))}parseSoundMidiInstrument(e,t){let s;for(const t of e.childElements())switch(t.localName){case"midi-program":this._nextBeatAutomations||(this._nextBeatAutomations=[]),s=new X,s.type=f.Instrument,s.value=Number.parseInt(t.innerText)-1,this._nextBeatAutomations.push(s);break;case"volume":this._nextBeatAutomations||(this._nextBeatAutomations=[]),s=new X,s.type=f.Volume,s.value=vs.interpolatePercent(Number.parseFloat(t.innerText)),this._nextBeatAutomations.push(s);break;case"pan":this._nextBeatAutomations||(this._nextBeatAutomations=[]),s=new X,s.type=f.Balance,s.value=vs.interpolatePan(Number.parseFloat(t.innerText)),this._nextBeatAutomations.push(s)}}parseHarmony(e,t){const s=new Ke;let i=!1,a="";for(const t of e.childElements())switch(t.localName){case"root":s.name=this.parseHarmonyRoot(t);break;case"kind":s.name=s.name+this.parseHarmonyKind(t),"yes"===t.getAttribute("parentheses-degrees","no")&&(i=!0);break;case"frame":this.parseHarmonyFrame(t,s);break;case"degree":a+=this.parseDegree(t)}a&&(s.name+=i?`(${a})`:a),null===this._nextBeatChord&&(this._nextBeatChord=s)}parseDegree(e){let t="",s="",i="";for(const a of e.childElements())switch(a.localName){case"degree-value":t=a.innerText;break;case"degree-alter":switch(a.innerText){case"-1":s="♭";break;case"1":s="♯"}break;case"degree-type":i+=a.getAttribute("text","")}return`${i}${s}${t}`}parseHarmonyRoot(e){let t="",s="";for(const i of e.childElements())switch(i.localName){case"root-step":t=i.innerText;break;case"root-alter":switch(Number.parseFloat(i.innerText)){case-2:s="bb";break;case-1:s="b";break;case 0:s="";break;case 1:s="#";break;case 2:s="##"}}return t+s}parseHarmonyKind(e){const t=e.getAttribute("text");let s="";if(t)s=t;else{const t=e.innerText;switch(t){case"major":s="";break;case"minor":s="m";break;case"augmented":s="+";break;case"diminished":s="○";break;case"dominant":s="7";break;case"major-seventh":s="7M";break;case"minor-seventh":s="m7";break;case"diminished-seventh":s="○7";break;case"augmented-seventh":s="+7";break;case"half-diminished":s="⍉";break;case"major-minor":s="mMaj";break;case"major-sixth":s="maj6";break;case"minor-sixth":s="m6";break;case"dominant-ninth":s="9";break;case"major-ninth":s="maj9";break;case"minor-ninth":s="m9";break;case"dominant-11th":s="11";break;case"major-11th":s="maj11";break;case"minor-11th":s="m11";break;case"dominant-13th":s="13";break;case"major-13th":s="maj13";break;case"minor-13th":s="m13";break;case"suspended-second":s="sus2";break;case"suspended-fourth":s="sus4";break;case"Neapolitan":s="♭II";break;case"Italian":s="It⁺⁶";break;case"French":case"German":s="Fr⁺⁶";break;default:s=t}}return s}parseHarmonyFrame(e,t){for(const s of e.childElements())switch(s.localName){case"frame-strings":const e=Number.parseInt(s.innerText);t.strings=new Array(e);for(let s=0;s<e;s++)t.strings[s]=-1;break;case"first-fret":t.firstFret=Number.parseInt(s.innerText);break;case"frame-note":let i=null,a=null;for(const e of s.childElements())switch(e.localName){case"string":i=Number.parseInt(e.innerText);break;case"fret":a=Number.parseInt(e.innerText),i&&a>=0&&(t.strings[i-1]=a);break;case"barre":i&&a&&"start"===e.getAttribute("type")&&t.barreFrets.push(a)}}}parseAttributes(e,t,s){let i,a,r;if(null==this._lastBeat)for(const n of e.childElements())switch(n.localName){case"divisions":this._divisionsPerQuarterNote=Number.parseFloat(n.innerText);break;case"key":this.parseKey(n,t,s);break;case"time":this.parseTime(n,t);break;case"staves":s.ensureStaveCount(Number.parseInt(n.innerText));break;case"clef":i=Number.parseInt(n.getAttribute("number","1"))-1,a=this.getOrCreateStaff(s,i),r=this.getOrCreateBar(a,t),this.parseClef(n,r);break;case"staff-details":i=Number.parseInt(n.getAttribute("number","1"))-1,a=this.getOrCreateStaff(s,i),this.parseStaffDetails(n,a);break;case"transpose":this.parseTranspose(n,s);break;case"measure-style":this.parseMeasureStyle(n,s,!1)}else for(const t of e.childElements())switch(t.localName){case"divisions":this._divisionsPerQuarterNote=Number.parseFloat(t.innerText);break;case"measure-style":this.parseMeasureStyle(t,s,!0)}}parseMeasureStyle(e,t,s){for(const t of e.childElements())switch(t.localName){case"measure-repeat":if(!s){let s=null;switch(t.getAttribute("type")){case"start":switch(Number.parseInt(t.getAttribute("slashes","1"))){case 1:s=l.Simple;break;case 2:s=l.FirstOfDouble}break;case"stop":s=null}if(e.attributes.has("number")){this._simileMarkPerStaff=this._simileMarkPerStaff??new Map;const t=Number.parseInt(e.attributes.get("number"))-1;null==s?this._simileMarkPerStaff.delete(t):this._simileMarkPerStaff.set(t,s)}else this._simileMarkAllStaves=s}break;case"slash":switch(t.getAttribute("type")){case"start":this._isBeatSlash=!0;break;case"stop":this._isBeatSlash=!1}}}parseTranspose(e,t){let s=0;for(const t of e.childElements())switch(t.localName){case"chromatic":s+=Number.parseFloat(t.innerText);break;case"octave-change":s+=12*Number.parseFloat(t.innerText)}if(e.attributes.has("number")){const i=this.getOrCreateStaff(t,Number.parseInt(e.attributes.get("number"))-1);this.getStaffContext(i).transpose=s,i.displayTranspositionPitch=s}else for(const e of t.staves)this.getStaffContext(e).transpose=s,e.displayTranspositionPitch=s}parseStaffDetails(e,t){for(const s of e.childElements())switch(s.localName){case"staff-lines":t.standardNotationLineCount=Number.parseInt(s.innerText);break;case"staff-tuning":this.parseStaffTuning(s,t);break;case"capo":t.capo=Number.parseInt(s.innerText)}}parseStaffTuning(e,t){0===t.stringTuning.tunings.length&&(t.showTablature=!0,t.showStandardNotation=!1,t.stringTuning.tunings=new Array(t.standardNotationLineCount).fill(0));const s=Number.parseInt(e.getAttribute("line"));let i="C",a="",r=0;for(const t of e.childElements())switch(t.localName){case"tuning-step":i=t.innerText;break;case"tuning-alter":r=Number.parseFloat(t.innerText);break;case"tuning-octave":a=t.innerText}const n=ae.getTuningForText(i+a)+r;t.tuning[t.tuning.length-s]=n}parseClef(e,t){let s="s",i=0;for(const a of e.childElements())switch(a.localName){case"sign":s=a.innerText.toLowerCase();break;case"line":i=Number.parseInt(a.innerText);break;case"clef-octave-change":switch(Number.parseInt(a.innerText)){case-2:t.clefOttava=h._15mb;break;case-1:t.clefOttava=h._8vb;break;case 1:t.clefOttava=h._8va;break;case 2:t.clefOttava=h._15mb}}switch(s){case"g":default:t.clef=o.G2;break;case"f":t.clef=o.F4;break;case"c":t.clef=3===i?o.C3:o.C4;break;case"percussion":t.clef=o.Neutral,t.staff.isPercussion=!0;break;case"tab":t.clef=o.G2,t.staff.showTablature=!0}}parseTime(e,t){let s=!1,i=!1;for(const a of e.childElements()){const e=a.innerText;switch(a.localName){case"beats":s||(-1===e.indexOf("+")?t.timeSignatureNumerator=Number.parseInt(e):t.timeSignatureNumerator=e.split("+").map((e=>Number.parseInt(e))).reduce(((e,t)=>t+e),0),s=!0);break;case"beat-type":i||(-1===e.indexOf("+")?t.timeSignatureDenominator=Number.parseInt(e):t.timeSignatureDenominator=e.split("+").map((e=>Number.parseInt(e))).reduce(((e,t)=>t+e),0),i=!0)}}switch(e.getAttribute("symbol","")){case"common":case"cut":t.timeSignatureCommon=!0}}parseKey(e,t,s){let i,a,r=-c.C,n="";for(const t of e.childElements())switch(t.localName){case"fifths":r=Number.parseInt(t.innerText);break;case"mode":n=t.innerText}if(i=-7<=r&&r<=7?r:c.C,a="minor"===n?d.Minor:d.Major,e.attributes.has("number")){const r=this.getOrCreateStaff(s,Number.parseInt(e.attributes.get("number"))-1),n=this.getOrCreateBar(r,t);n.keySignature=i,n.keySignatureType=a}else{this._keyAllStaves=[i,a];for(const e of s.staves)e.bars.length>t.index&&(e.bars[t.index].keySignature=i,e.bars[t.index].keySignatureType=a)}}parseDirection(e,t,s){const i=[];let a=null,r=-1,n=-1;for(const t of e.childElements())switch(t.localName){case"direction-type":i.push(t.firstElement);break;case"offset":a=Number.parseFloat(t.innerText);break;case"voice":break;case"staff":r=Number.parseInt(t.innerText)-1;break;case"sound":t.attributes.has("tempo")&&(n=Number.parseFloat(t.attributes.get("tempo")))}let o=null;o=r>=0?this.getOrCreateStaff(s,r):null!==this._lastBeat?this._lastBeat.voice.bar.staff:this.getOrCreateStaff(s,0);const h=o?this.getOrCreateBar(o,t):null,l=()=>{let e=this._musicalPosition;null!==a&&(e+=a);return e/t.calculateDuration(!1)};if(n>0){const e=new X;e.type=f.Tempo,e.value=n,e.ratioPosition=l(),this.hasSameTempo(t,e)||(t.tempoAutomations.push(e),0===t.index&&(t.score.tempo=e.value))}let c="";for(const e of i)switch(e.localName){case"rehearsal":t.section=new Ze,t.section.marker=e.innerText;break;case"segno":t.addDirection(ke.TargetSegno);break;case"coda":t.addDirection(ke.TargetCoda);break;case"words":c=e.innerText;break;case"wedge":switch(e.getAttribute("type")){case"crescendo":this._nextBeatCrescendo=_.Crescendo;break;case"diminuendo":this._nextBeatCrescendo=_.Decrescendo;break;case"stop":this._nextBeatCrescendo=null}break;case"dynamics":const s=this.parseDynamics(e);null!==s&&(this._currentDynamics=s,this._score.stylesheet.hideDynamics=!1);break;case"dashes":const i=e.getAttribute("type","start");switch(c){case"LetRing":this._nextBeatLetRing="start"===i||"continue"===i;break;case"P.M.":this._nextBeatPalmMute="start"===i||"continue"===i}c="";break;case"pedal":const a=this.parsePedal(e);if(a&&h){a.ratioPosition=l();const e=h.sustainPedals.length>0&&h.sustainPedals[h.sustainPedals.length-1].pedalType!==u.Up;(a.pedalType!==u.Up||e)&&h.sustainPedals.push(a)}break;case"metronome":this.parseMetronome(e,t,l());break;case"octave-shift":this._nextBeatOttavia=this.parseOctaveShift(e)}c&&(this._nextBeatText=c)}parseOctaveShift(e){const t=e.getAttribute("type");switch(Number.parseInt(e.getAttribute("size","8"))){case 15:switch(t){case"up":return h._15mb;case"down":return h._15ma;case"stop":return h.Regular;case"continue":return this._nextBeatOttavia}break;case 8:switch(t){case"up":return h._8vb;case"down":return h._8va;case"stop":return h.Regular;case"continue":return this._nextBeatOttavia}}return null}parseMetronome(e,t,s){let i=null,a=-1;for(const t of e.childElements())switch(t.localName){case"beat-unit":i=this.parseBeatDuration(t);break;case"per-minute":a=Number.parseFloat(t.innerText)}if(null!==i&&a>0){const e=new X;e.type=f.Tempo,e.value=a*(i/4)|0,e.ratioPosition=s,this.hasSameTempo(t,e)||(t.tempoAutomations.push(e),0===t.index&&(t.score.tempo=e.value))}}hasSameTempo(e,t){for(const s of e.tempoAutomations)if(t.ratioPosition===s.ratioPosition&&t.value===s.value)return!0;return!1}parsePedal(e){const t=new V;switch(e.getAttribute("type")){case"start":t.pedalType=u.Down;break;case"stop":t.pedalType=u.Up;break;case"continue":t.pedalType=u.Hold;break;default:return null}return t}parseDynamics(e){for(const t of e.childElements()){const e=t.localName.toUpperCase();switch(e){case"PPP":case"PP":case"P":case"MP":case"MF":case"F":case"FF":case"FFF":case"PPPP":case"PPPPP":case"PPPPPP":case"FFFF":case"FFFFF":case"FFFFFF":case"SF":case"SFP":case"SFPP":case"FP":case"RF":case"RFZ":case"SFZ":case"SFFZ":case"FZ":case"N":case"PF":case"SFZP":return m[e]}}return null}parseForward(e){for(const t of e.childElements())if("duration"===t.localName)this._musicalPosition+=this.musicXmlDivisionsToAlphaTabTicks(Number.parseFloat(t.innerText))}parseBackup(e){for(const t of e.childElements())if("duration"===t.localName){if(this._lastBeat){let e=this._musicalPosition;e-=this.musicXmlDivisionsToAlphaTabTicks(Number.parseFloat(t.innerText)),e<0&&(e=0),this._musicalPosition=e}}}getOrCreateStaff(e,t){for(;e.staves.length<=t;){const t=new at;e.addStaff(t),this._score.masterBars.length>0&&this.getOrCreateBar(t,this._score.masterBars[this._score.masterBars.length-1])}return e.staves[t]}getOrCreateBar(e,t){const s=0===e.bars.length?1:e.bars[0].voices.length;for(;e.bars.length<=t.index;){const t=new z;e.addBar(t),t.previousBar&&(t.clef=t.previousBar.clef,t.clefOttava=t.previousBar.clefOttava,t.keySignature=t.previousBar.keySignature,t.keySignatureType=t.previousBar.keySignatureType),null!=this._keyAllStaves&&(t.keySignature=this._keyAllStaves[0],t.keySignatureType=this._keyAllStaves[1]);for(let e=0;e<s;e++){const e=new te;t.addVoice(e)}}return e.bars[t.index]}getOrCreateVoice(e,t){let s=!1;for(;e.voices.length<=t;)e.addVoice(new te),s=!0;if(s)for(const s of e.staff.bars)for(;s.voices.length<=t;)s.addVoice(new te);return e.voices[t]}parseNote(e,t,s){let i=null,a=B.None,r=0,n=null,o=!1,h=0,l=0,c=-1,d=null,u=0,p=-1,g=-1,m=null,f=null,y=!1,b=null;const S="no"!==e.getAttribute("print-object","yes"),_=()=>{if(null!==i)return;o&&!this._lastBeat&&(j.warning("MusicXML","Malformed MusicXML, <chord /> cannot be set on the first note of a measure"),o=!1),o&&!f&&(j.warning("MusicXML","Cannot mix <chord /> and <rest />"),o=!1);const e=this.getOrCreateStaff(s,h);if(o)return i=this._lastBeat,void i.addNote(f);const _=this.getOrCreateBar(e,t),k=this.getOrCreateVoice(_,l),T=0===k.beats.length?0:k.beats[k.beats.length-1].displayEnd;let N=this._musicalPosition-T;if(N>0){if(this._lastBeat&&this._lastBeat.beamingMode===ye.ForceMergeWithNext&&this._lastBeat.voice.bar.staff.index!==h&&k.beats.length>0&&k.beats[k.beats.length-1].beamingMode===ye.ForceMergeWithNext){const e=k.beats[k.beats.length-1].duration;for(;N>0;){const t=this.createRestForGap(N,e);if(null===t)break;this.insertBeatToVoice(t,k),N-=t.playbackDuration}}if(N>0){const e=new Ue;e.dynamics=this._currentDynamics,e.isEmpty=!0,e.duration=w.TwoHundredFiftySixth,e.overrideDisplayDuration=N,e.updateDurations(),this.insertBeatToVoice(e,k)}}else N<0&&j.error("MusicXML","Unsupported forward/backup detected. Cannot fill new beats into already filled area of voice");c<0&&null!==d&&(c=U.toTicks(d),u>0&&(c=U.applyDot(c,2===u)));const x=new Ue;i=x,null===n?x.beamingMode=this.getStaffContext(e).isExplicitlyBeamed?ye.ForceSplitToNext:ye.Auto:(x.beamingMode=n,this.getStaffContext(e).isExplicitlyBeamed=!0),x.isEmpty=!1,x.dynamics=this._currentDynamics,this._isBeatSlash&&(x.slashed=!0);const v=this._nextBeatAutomations;if(this._nextBeatAutomations=null,null!==v)for(const e of v)x.automations.push(e);const P=this._nextBeatChord;this._nextBeatChord=null,null!==P&&(x.chordId=P.uniqueId,k.bar.staff.hasChord(P.uniqueId)||k.bar.staff.addChord(x.chordId,P));const F=this._nextBeatCrescendo;null!==F&&(x.crescendo=F);const C=this._nextBeatOttavia;if(null!==C&&(x.ottava=C),x.isLetRing=this._nextBeatLetRing,x.isPalmMute=this._nextBeatPalmMute,this._nextBeatText&&(x.text=this._nextBeatText,this._nextBeatText=null),null!==f&&x.addNote(f),this.insertBeatToVoice(x,k),null!==f){f.isVisible=S;const e=this._indexToTrackInfo.get(s.index);null!==b?f.percussionArticulation=e.getOrCreateArticulation(b,f):y||(f.percussionArticulation=e.getOrCreateArticulation("",f))}a!==B.None?(x.graceType=a,this.applyBeatDurationFromTicks(x,r,null,!1)):(x.tupletNumerator=p,x.tupletDenominator=g,x.dots=u,x.preferredBeamDirection=m,this.applyBeatDurationFromTicks(x,c,d,!0)),this._musicalPosition=x.displayEnd,this._lastBeat=x};for(const t of e.childElements())switch(t.localName){case"grace":const e=Number.parseFloat(t.getAttribute("make-time","-1"));e>=0?(r=this.musicXmlDivisionsToAlphaTabTicks(e),a=B.BeforeBeat):a=B.OnBeat,"yes"===t.getAttribute("slash")&&(a=B.BeforeBeat);break;case"chord":o=!0;break;case"cue":return;case"pitch":f=this.parsePitch(t),y=!0;break;case"unpitched":f=this.parseUnpitched(t,s);break;case"rest":f=null,null===d&&(d=w.Whole);break;case"duration":c=this.parseDuration(t);break;case"instrument":b=t.getAttribute("id","");break;case"voice":l=Number.parseInt(t.innerText),Number.isNaN(l)?(j.warning("MusicXML","Voices need to be specified as numbers"),l=0):l-=1;break;case"type":d=this.parseBeatDuration(t);break;case"dot":u++;break;case"accidental":null===f?j.warning("MusicXML","Malformed MusicXML, missing pitch or unpitched for note"):this.parseAccidental(t,f);break;case"time-modification":for(const e of t.childElements())switch(e.localName){case"actual-notes":p=Number.parseInt(e.innerText);break;case"normal-notes":g=Number.parseInt(e.innerText)}break;case"stem":m=this.parseStem(t);break;case"notehead":null===f?j.warning("MusicXML","Malformed MusicXML, missing pitch or unpitched for note"):this.parseNoteHead(t,f,d??w.Quarter,m??this.estimateBeamDirection(f));break;case"staff":h=Number.parseInt(t.innerText)-1;break;case"beam":if("1"===t.getAttribute("number","1"))switch(t.innerText){case"begin":case"continue":n=ye.ForceMergeWithNext;break;case"end":n=ye.ForceSplitToNext}break;case"notations":_(),this.parseNotations(t,f,i);break;case"lyric":_(),this.parseLyric(t,i,s);break;case"play":this.parsePlay(t,f)}if(y){const e=this.getOrCreateStaff(s,h),t=this.getStaffContext(e).transpose;if(0!==t){const e=12*f.octave+f.tone+t;f.octave=e/12|0,f.tone=e-12*f.octave}}_()}parsePlay(e,t){for(const s of e.childElements())if("mute"===s.localName)t&&"palm"===s.innerText&&(t.isPalmMute=!0)}estimateBeamDirection(e){return e.calculateRealValue(!1,!1)<vs.B4Value?Ne.Down:Ne.Up}parseNoteHead(e,t,s,i){"yes"===e.getAttribute("parentheses","no")&&(t.isGhost=!0);const a=e.getAttribute("filled","");let r;switch("yes"===a?r=!0:"no"===a&&(r=!1),t.style=new Ie,e.innerText){case"arrow down":t.style.noteHeadCenterOnStem=!0,this.applyNoteHead(t,s,r,ne.NoteheadTriangleDownDoubleWhole,ne.NoteheadTriangleDownWhole,ne.NoteheadTriangleDownHalf,ne.NoteheadTriangleDownBlack);break;case"arrow up":t.style.noteHeadCenterOnStem=!0,this.applyNoteHead(t,s,r,ne.NoteheadTriangleUpDoubleWhole,ne.NoteheadTriangleUpWhole,ne.NoteheadTriangleUpHalf,ne.NoteheadTriangleUpBlack);break;case"back slashed":this.applyNoteHead(t,s,r,ne.NoteheadSlashedDoubleWhole2,ne.NoteheadSlashedWhole2,ne.NoteheadSlashedHalf2,ne.NoteheadSlashedBlack2);break;case"circle dot":t.style.noteHead=ne.NoteheadRoundWhiteWithDot;break;case"circle-x":this.applyNoteHead(t,s,r,ne.NoteheadCircleXDoubleWhole,ne.NoteheadCircleXWhole,ne.NoteheadCircleXHalf,ne.NoteheadCircleX);break;case"circled":this.applyNoteHead(t,s,r,ne.NoteheadCircledDoubleWhole,ne.NoteheadCircledWhole,ne.NoteheadCircledHalf,ne.NoteheadCircledBlack);break;case"cluster":this.applyNoteHead(t,s,r,ne.NoteheadClusterDoubleWhole3rd,ne.NoteheadClusterWhole3rd,ne.NoteheadClusterHalf3rd,ne.NoteheadClusterQuarter3rd);break;case"cross":this.applyNoteHead(t,s,r,ne.NoteheadPlusDoubleWhole,ne.NoteheadPlusWhole,ne.NoteheadPlusHalf,ne.NoteheadPlusBlack);break;case"diamond":this.applyNoteHead(t,s,r,ne.NoteheadDiamondDoubleWhole,ne.NoteheadDiamondWhole,ne.NoteheadDiamondHalf,ne.NoteheadDiamondBlack);break;case"do":this.applyNoteHead(t,s,r,ne.NoteShapeTriangleUpWhite,ne.NoteShapeTriangleUpWhite,ne.NoteShapeTriangleUpWhite,ne.NoteShapeTriangleUpBlack);break;case"fa":i===Ne.Up?this.applyNoteHead(t,s,r,ne.NoteShapeTriangleRightWhite,ne.NoteShapeTriangleRightWhite,ne.NoteShapeTriangleRightWhite,ne.NoteShapeTriangleRightBlack):this.applyNoteHead(t,s,r,ne.NoteShapeTriangleLeftWhite,ne.NoteShapeTriangleLeftWhite,ne.NoteShapeTriangleLeftWhite,ne.NoteShapeTriangleLeftBlack);break;case"fa up":this.applyNoteHead(t,s,r,ne.NoteShapeTriangleLeftWhite,ne.NoteShapeTriangleLeftWhite,ne.NoteShapeTriangleLeftWhite,ne.NoteShapeTriangleLeftBlack);break;case"inverted triangle":this.applyNoteHead(t,s,r,ne.NoteheadTriangleDownDoubleWhole,ne.NoteheadTriangleDownWhole,ne.NoteheadTriangleDownHalf,ne.NoteheadTriangleDownBlack);break;case"la":case"square":this.applyNoteHead(t,s,r,ne.NoteShapeSquareWhite,ne.NoteShapeSquareWhite,ne.NoteShapeSquareWhite,ne.NoteShapeSquareBlack);break;case"left triangle":this.applyNoteHead(t,s,r,ne.NoteheadTriangleRightWhite,ne.NoteheadTriangleRightWhite,ne.NoteheadTriangleRightWhite,ne.NoteheadTriangleRightBlack);break;case"mi":this.applyNoteHead(t,s,r,ne.NoteShapeDiamondWhite,ne.NoteShapeDiamondWhite,ne.NoteShapeDiamondWhite,ne.NoteShapeDiamondBlack);break;case"none":t.style.noteHead=ne.NoteheadNull;break;case"normal":this.applyNoteHead(t,s,r,ne.NoteheadDoubleWhole,ne.NoteheadWhole,ne.NoteheadHalf,ne.NoteheadBlack);break;case"re":this.applyNoteHead(t,s,r,ne.NoteShapeMoonWhite,ne.NoteShapeMoonWhite,ne.NoteShapeMoonWhite,ne.NoteShapeMoonBlack);break;case"rectangle":this.applyNoteHead(t,s,r,ne.NoteheadSquareWhite,ne.NoteheadSquareWhite,ne.NoteheadSquareWhite,ne.NoteheadSquareBlack);break;case"slash":this.applyNoteHead(t,s,r,ne.NoteheadSlashWhiteWhole,ne.NoteheadSlashWhiteWhole,ne.NoteheadSlashWhiteHalf,ne.NoteheadSlashVerticalEnds);break;case"slashed":this.applyNoteHead(t,s,r,ne.NoteheadSlashedDoubleWhole1,ne.NoteheadSlashedWhole1,ne.NoteheadSlashedHalf1,ne.NoteheadSlashedBlack1);break;case"so":this.applyNoteHead(t,s,r,ne.NoteShapeRoundWhite,ne.NoteShapeRoundWhite,ne.NoteShapeRoundWhite,ne.NoteShapeRoundBlack);break;case"ti":this.applyNoteHead(t,s,r,ne.NoteShapeTriangleRoundWhite,ne.NoteShapeTriangleRoundWhite,ne.NoteShapeTriangleRoundWhite,ne.NoteShapeTriangleRoundBlack);break;case"triangle":this.applyNoteHead(t,s,r,ne.NoteheadTriangleUpDoubleWhole,ne.NoteheadTriangleUpWhole,ne.NoteheadTriangleUpHalf,ne.NoteheadTriangleUpBlack);break;case"x":this.applyNoteHead(t,s,r,ne.NoteheadXDoubleWhole,ne.NoteheadXWhole,ne.NoteheadXHalf,ne.NoteheadXBlack)}}createRestForGap(e,t){let s=U.toTicks(t);for(;s>e;){if(t===w.TwoHundredFiftySixth)return null;t*=2,s=U.toTicks(t)}const i=new Ue;return i.dynamics=this._currentDynamics,i.isEmpty=!1,i.duration=t,i.overrideDisplayDuration=s,i.updateDurations(),i}insertBeatToVoice(e,t){if(t.beats.length>0){const s=t.beats[t.beats.length-1];s.nextBeat=e,e.previousBeat=s;let i=s;for(;null!==i&&i.graceType!==B.None;)i=i.index>0?i.previousBeat:null;null!==i&&(e.displayStart=i.displayEnd)}t.addBeat(e)}musicXmlDivisionsToAlphaTabTicks(e){return e*U.QuarterTime/this._divisionsPerQuarterNote}parseBeatDuration(e){switch(e.innerText){case"1024th":case"512th":case"256th":return w.TwoHundredFiftySixth;case"128th":return w.OneHundredTwentyEighth;case"64th":return w.SixtyFourth;case"32nd":return w.ThirtySecond;case"16th":return w.Sixteenth;case"eighth":return w.Eighth;case"quarter":return w.Quarter;case"half":return w.Half;case"whole":return w.Whole;case"breve":return w.DoubleWhole;case"long":return w.QuadrupleWhole}return null}applyBeatDurationFromTicks(e,t,s,i){if(!s)for(let e=0;e<vs.allDurations.length;e++){if(!(t>=vs.allDurationTicks[e]))break;s=vs.allDurations[e]}e.duration=s??w.Sixteenth,i&&(e.overrideDisplayDuration=t),e.updateDurations()}parseLyric(e,t,s){const i=this._indexToTrackInfo.get(s.index).getLyricLine(e.getAttribute("number",""));for(null===t.lyrics&&(t.lyrics=[]);t.lyrics.length<=i;)t.lyrics.push("");for(const s of e.childElements())switch(s.localName){case"text":t.lyrics[i]?t.lyrics[i]+=` ${s.innerText}`:t.lyrics[i]=s.innerText;break;case"elision":t.lyrics[i]+=s.innerText}}parseNotations(e,t,s){for(const i of e.childElements())switch(i.localName){case"tied":t&&this.parseTied(i,t,s.voice.bar.staff);break;case"slur":t&&this.parseSlur(i,t);break;case"glissando":t&&this.parseGlissando(i,t);break;case"slide":t&&this.parseSlide(i,t);break;case"ornaments":t&&this.parseOrnaments(i,t);break;case"technical":this.parseTechnical(i,t,s);break;case"articulations":t&&this.parseArticulations(i,t);break;case"dynamics":const e=this.parseDynamics(i);null!==e&&(s.dynamics=e,this._currentDynamics=e);break;case"fermata":this.parseFermata(i,s);break;case"arpeggiate":this.parseArpeggiate(i,s)}}getStaffContext(e){if(!this._staffToContext.has(e)){const t=new Ts;return this._staffToContext.set(e,t),t}return this._staffToContext.get(e)}parseGlissando(e,t){const s=e.getAttribute("type"),i=e.getAttribute("number","1"),a=this.getStaffContext(t.beat.voice.bar.staff);switch(s){case"start":a.slideOrigins.set(i,t);break;case"stop":if(a.slideOrigins.has(i)){const e=a.slideOrigins.get(i);e.slideTarget=t,t.slideOrigin=e,e.slideOutType=P.Shift}}}parseSlur(e,t){const s=e.getAttribute("number","1"),i=this.getStaffContext(t.beat.voice.bar.staff);switch(e.getAttribute("type")){case"start":i.slurStarts.set(s,t);break;case"stop":if(i.slurStarts.has(s)){t.isSlurDestination=!0;const e=i.slurStarts.get(s);e.slurDestination=t,t.slurOrigin=e,i.slurStarts.delete(s)}}}parseArpeggiate(e,t){switch(e.getAttribute("direction","down")){case"down":t.brushType=S.ArpeggioDown;break;case"up":t.brushType=S.ArpeggioUp}}parseFermata(e,t){let s;switch(e.innerText){case"normal":default:s=Te.Medium;break;case"angled":s=Te.Short;break;case"square":s=Te.Long}t.fermata=new ct,t.fermata.type=s}parseArticulations(e,t){for(const s of e.childElements())switch(s.localName){case"accent":t.accentuated=k.Normal;break;case"strong-accent":t.accentuated=k.Heavy;break;case"staccato":t.isStaccato=!0;break;case"tenuto":t.accentuated=k.Tenuto}}parseTechnical(e,t,s){const i=[];for(const a of e.childElements())switch(a.localName){case"up-bow":s.pickStroke=re.Up;break;case"down-bow":s.pickStroke=re.Down;break;case"harmonic":break;case"fingering":t&&(t.leftHandFinger=this.parseFingering(a));break;case"pluck":t&&(t.rightHandFinger=this.parseFingering(a));break;case"fret":t&&(t.fret=Number.parseInt(a.innerText));break;case"string":t&&(t.string=s.voice.bar.staff.tuning.length-Number.parseInt(a.innerText)+1);break;case"hammer-on":case"pull-off":t&&(t.isHammerPullOrigin=!0);break;case"bend":i.push(a);break;case"tap":s.tap=!0;break;case"smear":t&&(t.vibrato=F.Slight);break;case"golpe":switch(a.getAttribute("placement","above")){case"above":s.golpe=ue.Finger;break;case"below":s.golpe=ue.Thumb}}t&&i.length>0&&this.parseBends(i,t)}parseBends(e,t){const s=J.MaxPosition/e.length;let i=0,a=0,r=!0;for(const n of e){const e=n.findChildElement("bend-alter");if(e){const o=Math.round(2*Math.abs(Number.parseFloat(e.innerText)));n.findChildElement("pre-bend")?r?(i+=o,t.addBendPoint(new J(a,i)),a+=s,t.addBendPoint(new J(a,i)),r=!1):a+=s:n.findChildElement("release")?(r&&(i+=o),t.addBendPoint(new J(a,i)),a+=s,i-=o,t.addBendPoint(new J(a,i)),r=!1):(t.addBendPoint(new J(a,i)),i+=o,a+=s,t.addBendPoint(new J(a,i)),r=!1)}}}parseFingering(e){switch(e.innerText){case"0":return T.NoOrDead;case"1":case"p":case"t":return T.Thumb;case"2":case"i":return T.IndexFinger;case"3":case"m":return T.MiddleFinger;case"4":case"a":return T.AnnularFinger;case"5":case"c":return T.LittleFinger}return T.Unknown}parseOrnaments(e,t){let s=-1;for(const i of e.childElements())switch(i.localName){case"trill-mark":s=Number.parseInt(i.getAttribute("trill-step","2")),t.isStringed?t.trillValue=t.stringTuning+s:t.isPercussion||(t.trillValue=t.calculateRealValue(!1,!1)+s);break;case"turn":t.ornament=le.Turn;break;case"inverted-turn":t.ornament=le.InvertedTurn;break;case"wavy-line":s>0?"start"===i.getAttribute("type")&&(this._currentTrillStep=s):this._currentTrillStep>0?"stop"===i.getAttribute("type")?this._currentTrillStep=-1:t.isStringed?t.trillValue=t.stringTuning+this._currentTrillStep:t.isPercussion||(t.trillValue=t.calculateRealValue(!1,!1)+this._currentTrillStep):t.vibrato=F.Slight;break;case"mordent":t.ornament=le.LowerMordent;break;case"inverted-mordent":t.ornament=le.UpperMordent;break;case"tremolo":switch(i.innerText){case"1":t.beat.tremoloSpeed=w.Eighth;break;case"2":t.beat.tremoloSpeed=w.Sixteenth;break;case"3":t.beat.tremoloSpeed=w.ThirtySecond}}}parseSlide(e,t){const s=e.getAttribute("type"),i=e.getAttribute("number","1"),a=this.getStaffContext(t.beat.voice.bar.staff);switch(s){case"start":a.slideOrigins.set(i,t);break;case"stop":if(a.slideOrigins.has(i)){const e=a.slideOrigins.get(i);e.slideTarget=t,t.slideOrigin=e,e.slideOutType=P.Shift}}}parseTied(e,t,s){const i=e.getAttribute("type"),a=e.getAttribute("number",""),r=this.getStaffContext(s);if("start"===i){if(a){if(r.tieStartIds.has(a)){const e=r.tieStartIds.get(a);r.tieStarts.delete(e)}r.tieStartIds.set(a,t)}r.tieStarts.add(t)}else if("stop"===i&&!t.isTieDestination){let e=null;if(a){if(!r.tieStartIds.has(a))return;e=r.tieStartIds.get(a),r.tieStartIds.delete(a),r.tieStarts.delete(t)}else{const s=this.calculatePitchedNoteValue(t);for(const t of r.tieStarts)if(this.calculatePitchedNoteValue(t)===s){e=t,r.tieStarts.delete(e);break}}if(!e)return;t.isTieDestination=!0,t.tieOrigin=e}}parseStem(e){switch(e.innerText){case"down":return Ne.Down;case"up":return Ne.Up;default:return null}}parseAccidental(e,t){switch(e.innerText){case"sharp":t.accidentalMode=x.ForceSharp;break;case"natural":t.accidentalMode=x.ForceNatural;break;case"flat":t.accidentalMode=x.ForceFlat;break;case"double-sharp":t.accidentalMode=x.ForceDoubleSharp;break;case"flat-flat":t.accidentalMode=x.ForceDoubleFlat}}calculatePitchedNoteValue(e){return 12*e.octave+e.tone}parseDuration(e){return this.musicXmlDivisionsToAlphaTabTicks(Number.parseFloat(e.innerText))}parseUnpitched(e,t){let s="",i=0;for(const t of e.childElements())switch(t.localName){case"display-step":s=t.innerText;break;case"display-octave":i=Number.parseInt(t.innerText)+1}const a=new Re;if(""===s)a.octave=0,a.tone=0;else{const e=12*i+ae.getToneForText(s).noteValue;a.octave=e/12|0,a.tone=e-12*a.octave}return a}parsePitch(e){let t="",s=0,i=0;for(const a of e.childElements())switch(a.localName){case"step":t=a.innerText;break;case"alter":s=Number.parseFloat(a.innerText),Number.isNaN(s)&&(s=0);break;case"octave":i=Number.parseInt(a.innerText)+1}s|=0;const a=12*i+ae.getToneForText(t).noteValue+s,r=new Re;return r.octave=a/12|0,r.tone=a-12*r.octave,r}applyNoteHead(e,t,s,i,a,r,n){if(void 0===s)switch(t){case w.QuadrupleWhole:case w.DoubleWhole:e.style.noteHead=i;break;case w.Whole:e.style.noteHead=a;break;case w.Half:e.style.noteHead=r;break;default:e.style.noteHead=n}else if(!0===s)e.style.noteHead=n;else switch(t){case w.QuadrupleWhole:case w.DoubleWhole:e.style.noteHead=i;break;case w.Whole:e.style.noteHead=a;break;case w.Half:default:e.style.noteHead=r}}}vs.B4Value=71,vs.allDurations=[w.TwoHundredFiftySixth,w.OneHundredTwentyEighth,w.SixtyFourth,w.ThirtySecond,w.Sixteenth,w.Eighth,w.Quarter,w.Half,w.Whole,w.DoubleWhole,w.QuadrupleWhole],vs.allDurationTicks=vs.allDurations.map((e=>U.toTicks(e))),function(e){e[e.SingleTrackMultiChannel=0]="SingleTrackMultiChannel",e[e.MultiTrack=1]="MultiTrack"}(Rt||(Rt={}));class Ps{constructor(){this.events=[]}addEvent(e){if(0===this.events.length||e.tick>=this.events[this.events.length-1].tick)this.events.push(e);else{let t=this.events.length;for(;t>0;){if(!(this.events[t-1].tick>e.tick))break;t--}this.events.splice(t,0,e)}}writeTo(e){const t=lt.empty();let s=0;for(const e of this.events){const i=e.tick-s;Fs.writeVariableInt(t,i),e.writeTo(t),s=e.tick}const i=new Uint8Array([77,84,114,107]);e.write(i,0,i.length);const a=t.toArray();ht.writeInt32BE(e,a.length),e.write(a,0,a.length)}}class Fs{constructor(){this.format=Rt.SingleTrackMultiChannel,this.division=U.QuarterTime,this.tracks=[]}get events(){if(1===this.tracks.length)return this.tracks[0].events;const e=[];for(const e of this.tracks)this.events.push(...e.events);return e.sort(((e,t)=>e.tick-t.tick)),e}ensureTracks(e){for(;this.tracks.length<e;)this.tracks.push(new Ps)}addEvent(e){this.format===Rt.SingleTrackMultiChannel?(this.ensureTracks(1),this.tracks[0].addEvent(e)):(this.ensureTracks(e.track+1),this.tracks[e.track].addEvent(e))}toBinary(){const e=lt.empty();return this.writeTo(e),e.toArray()}writeTo(e){const t=new Uint8Array([77,84,104,100]);e.write(t,0,t.length),ht.writeInt32BE(e,6),ht.writeInt16BE(e,this.format),ht.writeInt16BE(e,this.tracks.length),ht.writeInt16BE(e,this.division);for(const t of this.tracks)t.writeTo(e)}static writeVariableInt(e,t){const s=new Uint8Array(4);let i=0;do{s[i++]=127&t,t>>=7}while(t>0);for(;i>0;)i--,i>0?e.writeByte(128|s[i]):e.writeByte(s[i])}}!function(e){e[e.TimeSignature=88]="TimeSignature",e[e.NoteOn=128]="NoteOn",e[e.NoteOff=144]="NoteOff",e[e.ControlChange=176]="ControlChange",e[e.ProgramChange=192]="ProgramChange",e[e.TempoChange=81]="TempoChange",e[e.PitchBend=224]="PitchBend",e[e.PerNotePitchBend=96]="PerNotePitchBend",e[e.EndOfTrack=47]="EndOfTrack",e[e.AlphaTabRest=241]="AlphaTabRest",e[e.AlphaTabMetronome=242]="AlphaTabMetronome",e[e.SystemExclusive=240]="SystemExclusive",e[e.SystemExclusive2=247]="SystemExclusive2",e[e.Meta=255]="Meta"}(Ot||(Ot={}));class Cs{constructor(e,t,s){this.track=e,this.tick=t,this.type=s}get command(){return this.type}get message(){return 0}get data1(){return 0}get data2(){return 0}}class Es extends Cs{constructor(e,t,s,i,a,r){super(e,t,Ot.TimeSignature),this.track=e,this.tick=t,this.numerator=s,this.denominatorIndex=i,this.midiClocksPerMetronomeClick=a,this.thirtySecondNodesInQuarter=r}writeTo(e){e.writeByte(255),e.writeByte(88),Fs.writeVariableInt(e,4),e.writeByte(255&this.numerator),e.writeByte(255&this.denominatorIndex),e.writeByte(255&this.midiClocksPerMetronomeClick),e.writeByte(255&this.thirtySecondNodesInQuarter)}}class Ds extends Cs{writeTo(e){e.writeByte(240);const t=lt.withCapacity(16);t.writeByte(Ds.AlphaTabManufacturerId),this.writeEventData(t),t.writeByte(247),Fs.writeVariableInt(e,t.length),t.copyTo(e)}}Ds.AlphaTabManufacturerId=125,Ds.MetronomeEventId=0,Ds.RestEventId=1;class Ms extends Ds{constructor(e,t,s,i,a){super(e,t,Ot.AlphaTabMetronome),this.isMetronome=!0,this.metronomeNumerator=s,this.metronomeDurationInMilliseconds=a,this.metronomeDurationInTicks=i}writeEventData(e){e.writeByte(Ds.MetronomeEventId),e.writeByte(this.metronomeNumerator),ht.writeInt32LE(e,this.metronomeDurationInTicks),ht.writeInt32LE(e,this.metronomeDurationInMilliseconds)}}class Ls extends Ds{constructor(e,t,s){super(e,t,Ot.AlphaTabRest),this.channel=s}writeEventData(e){e.writeByte(Ds.RestEventId),e.writeByte(this.channel)}}class As extends Cs{constructor(e,t,s,i,a,r){super(e,t,s),this.channel=i,this.noteKey=a,this.noteVelocity=r}get data1(){return this.noteKey}get data2(){return this.noteVelocity}}class Is extends As{constructor(e,t,s,i,a){super(e,t,Ot.NoteOn,s,i,a)}writeTo(e){e.writeByte(15&this.channel|144),e.writeByte(255&this.noteKey),e.writeByte(255&this.noteVelocity)}}class Rs extends As{constructor(e,t,s,i,a){super(e,t,Ot.NoteOff,s,i,a)}writeTo(e){e.writeByte(15&this.channel|128),e.writeByte(255&this.noteKey),e.writeByte(255&this.noteVelocity)}}class Os extends Cs{constructor(e,t,s,i,a){super(e,t,Ot.ControlChange),this.channel=s,this.controller=i,this.value=a}writeTo(e){e.writeByte(15&this.channel|176),e.writeByte(255&this.controller),e.writeByte(255&this.value)}get data1(){return this.controller}get data2(){return this.value}}class Hs extends Cs{constructor(e,t,s,i){super(e,t,Ot.ProgramChange),this.channel=s,this.program=i}writeTo(e){e.writeByte(15&this.channel|192),e.writeByte(255&this.program)}get data1(){return this.program}}class Ws extends Cs{constructor(e,t){super(0,e,Ot.TempoChange),this.microSecondsPerQuarterNote=t}writeTo(e){e.writeByte(255),e.writeByte(81),e.writeByte(3),e.writeByte(this.microSecondsPerQuarterNote>>16&255),e.writeByte(this.microSecondsPerQuarterNote>>8&255),e.writeByte(255&this.microSecondsPerQuarterNote)}}class Vs extends Cs{constructor(e,t,s,i){super(e,t,Ot.PitchBend),this.channel=s,this.value=i}writeTo(e){e.writeByte(15&this.channel|224),e.writeByte(127&this.value),e.writeByte(this.value>>7&127)}get data1(){return 127&this.value}get data2(){return this.value>>7&127}}class Gs extends Cs{constructor(e,t,s,i,a){super(e,t,Ot.PerNotePitchBend),this.channel=s,this.noteKey=i,this.value=a}writeTo(t){throw new qe(e.AlphaTabErrorType.General,"Note Bend (Midi2.0) events cannot be exported to SMF1.0")}}class zs extends Cs{constructor(e,t){super(e,t,Ot.EndOfTrack)}writeTo(e){e.writeByte(255),e.writeByte(47),e.writeByte(0)}}class Us{constructor(e,t){this.time=0,this.eventIndex=e,this.event=t,this.isMetronome=this.event.type===Ot.AlphaTabMetronome}static newMetronomeEvent(e,t,s,i,a){const r=new Ms(0,t,s,i,a);return new Us(e,r)}}class Xs{constructor(e,t,s){this.bpm=e,this.ticks=t,this.time=s}}class Js{constructor(){this.tempoChanges=[],this.firstProgramEventPerChannel=new Map,this.firstTimeSignatureNumerator=0,this.firstTimeSignatureDenominator=0,this.synthData=[],this.division=U.QuarterTime,this.eventIndex=0,this.currentTime=0,this.playbackRange=null,this.playbackRangeStartTime=0,this.playbackRangeEndTime=0,this.endTick=0,this.endTime=0}}class Ys{get isPlayingMain(){return this._currentState===this._mainState}get isPlayingOneTimeMidi(){return this._currentState===this._oneTimeState}get isPlayingCountIn(){return this._currentState===this._countInState}constructor(e){this._oneTimeState=null,this._countInState=null,this.isLooping=!1,this.playbackSpeed=1,this.instrumentPrograms=new Set,this.percussionKeys=new Set,this._synthesizer=e,this._mainState=new Js,this._currentState=this._mainState}get mainPlaybackRange(){return this._mainState.playbackRange}set mainPlaybackRange(e){this._mainState.playbackRange=e,e&&(this._mainState.playbackRangeStartTime=this.tickPositionToTimePositionWithSpeed(this._mainState,e.startTick,1),this._mainState.playbackRangeEndTime=this.tickPositionToTimePositionWithSpeed(this._mainState,e.endTick,1))}get currentTime(){return this._currentState.currentTime/this.playbackSpeed}get currentEndTick(){return this._currentState.endTick}get currentEndTime(){return this._currentState.endTime/this.playbackSpeed}mainSeek(e){if(e*=this.playbackSpeed,this.mainPlaybackRange&&(e<this._mainState.playbackRangeStartTime?e=this._mainState.playbackRangeStartTime:e>this._mainState.playbackRangeEndTime&&(e=this._mainState.playbackRangeEndTime)),e>this._mainState.currentTime)this.mainSilentProcess(e-this._mainState.currentTime);else if(e<this._mainState.currentTime){if(this._mainState.currentTime=0,this._mainState.eventIndex=0,this.isPlayingMain){const e=this._synthesizer.metronomeVolume;this._synthesizer.noteOffAll(!0),this._synthesizer.resetSoft(),this._synthesizer.setupMetronomeChannel(e)}this.mainSilentProcess(e)}}mainSilentProcess(e){if(e<=0)return;const t=Date.now(),s=this._mainState.currentTime+e;if(this.isPlayingMain)for(;this._mainState.currentTime<s;)this.fillMidiEventQueueLimited(s-this._mainState.currentTime)&&this._synthesizer.synthesizeSilent(Q.MicroBufferSize);this._mainState.currentTime=s;const i=Date.now()-t;j.debug("Sequencer",`Silent seek finished in ${i}ms (main)`)}loadOneTimeMidi(e){this._oneTimeState=this.createStateFromFile(e),this._currentState=this._oneTimeState}loadMidi(e){this.instrumentPrograms.clear(),this.percussionKeys.clear(),this._mainState=this.createStateFromFile(e),this._currentState=this._mainState}createStateFromFile(e){const t=new Js;this.percussionKeys.add(Q.MetronomeKey),t.tempoChanges=[],t.division=e.division,t.eventIndex=0,t.currentTime=0,t.synthData=[];let s=120,i=0,a=0,r=0,n=0,o=0,h=0,l=0,c=0;for(const d of e.events){const u=new Us(t.synthData.length,d);t.synthData.push(u);const p=d.tick-c;if(i+=p,a+=p*(6e4/(s*e.division)),u.time=a,c=d.tick,n>0)for(;h<i;){const e=Us.newMetronomeEvent(t.synthData.length,h,Math.floor(h/n)%r,n,o);t.synthData.push(e),e.time=l,h+=n,l+=o}if(d.type===Ot.TempoChange){s=6e7/d.microSecondsPerQuarterNote,t.tempoChanges.push(new Xs(s,i,a)),o=n*(6e4/(s*e.division))}else if(d.type===Ot.TimeSignature){const i=d,a=Math.pow(2,i.denominatorIndex);r=i.numerator,n=t.division*(4/a)|0,o=n*(6e4/(s*e.division)),0===t.firstTimeSignatureDenominator&&(t.firstTimeSignatureNumerator=i.numerator,t.firstTimeSignatureDenominator=a)}else if(d.type===Ot.ProgramChange){const e=d,s=e.channel;t.firstProgramEventPerChannel.has(s)||t.firstProgramEventPerChannel.set(s,u);s===Q.PercussionChannel||this.instrumentPrograms.add(e.program)}else if(d.type===Ot.NoteOn){const e=d;e.channel===Q.PercussionChannel&&this.percussionKeys.add(e.noteKey)}}return t.synthData.sort(((e,t)=>e.time>t.time?1:e.time<t.time?-1:e.eventIndex-t.eventIndex)),t.endTime=a,t.endTick=i,t}fillMidiEventQueue(){return this.fillMidiEventQueueLimited(-1)}fillMidiEventQueueLimited(e){let t=Q.MicroBufferSize/this._synthesizer.outSampleRate*1e3*this.playbackSpeed,s=this.internalEndTime;e>0&&(e<t&&(t=e),s=Math.min(this.internalEndTime,this._currentState.currentTime+e));let i=!1;for(this._currentState.currentTime+=t;this._currentState.eventIndex<this._currentState.synthData.length&&this._currentState.synthData[this._currentState.eventIndex].time<this._currentState.currentTime&&this._currentState.currentTime<s;)this._synthesizer.dispatchEvent(this._currentState.synthData[this._currentState.eventIndex]),this._currentState.eventIndex++,i=!0;return i}mainTickPositionToTimePosition(e){return this.tickPositionToTimePositionWithSpeed(this._mainState,e,this.playbackSpeed)}mainTimePositionToTickPosition(e){return this.timePositionToTickPositionWithSpeed(this._mainState,e,this.playbackSpeed)}currentTimePositionToTickPosition(e){return this.timePositionToTickPositionWithSpeed(this._currentState,e,this.playbackSpeed)}tickPositionToTimePositionWithSpeed(e,t,s){let i=0,a=120,r=0;for(const s of e.tempoChanges){if(t<s.ticks)break;i=s.time,a=s.bpm,r=s.ticks}return i+=(t-=r)*(6e4/(a*e.division)),i/s}timePositionToTickPositionWithSpeed(e,t,s){t*=s;let i=0,a=120,r=0;for(const s of e.tempoChanges){if(t<s.time)break;i=s.ticks,a=s.bpm,r=s.time}return i+=(t-=r)/(6e4/(a*e.division))|0,i+1}get internalEndTime(){return this.isPlayingMain&&this.mainPlaybackRange?this._currentState.playbackRangeEndTime:this._currentState.endTime}get isFinished(){return this._currentState.currentTime>=this.internalEndTime}stop(){this.isPlayingMain&&this.mainPlaybackRange?this._currentState.currentTime=this.mainPlaybackRange.startTick:this._currentState.currentTime=0,this._currentState.eventIndex=0}resetOneTimeMidi(){this._oneTimeState=null,this._currentState=this._mainState}resetCountIn(){this._countInState=null,this._currentState=this._mainState}startCountIn(){this.generateCountInMidi(),this._currentState=this._countInState,this.stop(),this._synthesizer.noteOffAll(!0)}generateCountInMidi(){const e=new Js;e.division=this._mainState.division;let t=120,s=4,i=4;0===this._mainState.eventIndex?(t=this._mainState.tempoChanges[0].bpm,s=this._mainState.firstTimeSignatureNumerator,i=this._mainState.firstTimeSignatureDenominator):(t=this._synthesizer.currentTempo,s=this._synthesizer.timeSignatureNumerator,i=this._synthesizer.timeSignatureDenominator),e.tempoChanges.push(new Xs(t,0,0));const a=e.division*(4/i)|0,r=a*(6e4/(t*this._mainState.division));let n=0,o=0;for(let t=0;t<s;t++){const s=Us.newMetronomeEvent(e.synthData.length,n,t,a,r);e.synthData.push(s),s.time=o,n+=a,o+=r}e.synthData.sort(((e,t)=>e.time>t.time?1:e.time<t.time?-1:e.eventIndex-t.eventIndex)),e.endTime=o,e.endTick=n,this._countInState=e}}!function(e){e[e.Paused=0]="Paused",e[e.Playing=1]="Playing"}(Ht||(Ht={}));class $s{constructor(e,t){this.state=e,this.stopped=t}}class qs{constructor(e,t,s,i,a){this.currentTime=e,this.endTime=t,this.currentTick=s,this.endTick=i,this.isSeek=a}}class js{constructor(){this.id="",this.size=0}static load(e,t,s){if(e&&js.HeaderSize>e.size)return!1;if(s.position+js.HeaderSize>=s.length)return!1;if(t.id=ht.read8BitStringLength(s,4),t.id.charCodeAt(0)<=32||t.id.charCodeAt(0)>=122)return!1;if(t.size=ht.readUInt32LE(s),e&&js.HeaderSize+t.size>e.size)return!1;e&&(e.size-=js.HeaderSize+t.size);const i="RIFF"===t.id,a="LIST"===t.id;return(!i||!e)&&(!i&&!a||(t.id=ht.read8BitStringLength(s,4),!(t.id.charCodeAt(0)<=32||t.id.charCodeAt(0)>=122)&&(t.size-=4,!0)))}}js.HeaderSize=8;class Ks{constructor(e,t,s,i){this.packetData=e,this.isBeginningOfStream=t,this.isEndOfStream=s,this.granulePosition=s?i:null}addData(e){const t=this.packetData,s=new Uint8Array(t.length+e.length);s.set(t,0),s.set(e,t.length)}}!function(e){e[e.ContinuesPacket=1]="ContinuesPacket",e[e.BeginningOfStream=2]="BeginningOfStream",e[e.EndOfStream=4]="EndOfStream"}(Wt||(Wt={}));class Qs{constructor(e){this._readable=e}read(){const e=[];for(;this.findAndReadPage(e););return e}findAndReadPage(e){return!!this.seekPageHeader()&&this.readPage(e)}seekPageHeader(){for(let e=0;e<65536;e++){if(1399285583===ht.readInt32LE(this._readable))return!0;this._readable.position-=3}return!1}readPage(t){const s=this._readable.readByte();if(-1===s||0!==s)return!1;const i=this._readable.readByte(),a=ht.readInt64LE(this._readable);this._readable.skip(4),this._readable.skip(4),this._readable.skip(4);const r=this._readable.readByte();if(-1===r)return!1;const n=[];let o=0;for(let e=0;e<r;e++){const e=this._readable.readByte();o===n.length&&n.push(0),n[o]+=e,e<255&&o++}for(let s=0;s<n.length;s++){const r=new Uint8Array(n[s]);if(this._readable.read(r,0,r.length)!==r.length)return!1;if(i&Wt.ContinuesPacket){if(0===t.length)throw new qe(e.AlphaTabErrorType.Format,"OGG: Continuation page without any previous packets");t[t.length-1].addData(r)}else{const e=new Ks(r,!!(i&Wt.BeginningOfStream)&&0===s,!!(i&Wt.EndOfStream)&&s===n.length-1,a);t.push(e)}}return!0}}class Zs{constructor(){this.audioChannels=0,this.audioSampleRate=0,this.samples=new Float32Array(0),this.bitrateMaximum=0,this.bitrateNominal=0,this.bitrateMinimum=0,this.blocksize0=0,this.blocksize1=0}}class ei{constructor(){this.value=0,this.bitsRead=0}}class ti{constructor(e){this._bitBucket=0n,this._bitCount=0n,this._overflowBits=0n,this._source=e}readByte(){return this.readBits(ti.ByteSize)}readBit(){return 1===this.readBits(1)}readBytes(e){const t=new Uint8Array(e);for(let s=0;s<e;s++)t[s]=255&this.readByte();return t}readBits(e){if(0===e)return 0;const t=this.tryPeekBits(e);return this.skipBits(e),t.value}tryPeekBits(t){if(t<0||t>32)throw new qe(e.AlphaTabErrorType.General,"IO: Cannot read more than 32 bits in one go");if(0===t)return new ei;const s=new ei;for(;this._bitCount<t;){const e=BigInt(this._source.readByte());if(-1n===e)return s.bitsRead=Number(this._bitCount),s.value=Number(this._bitBucket),this._bitBucket=0n,this._bitCount=0n,s;this._bitBucket=(0xffn&e)<<this._bitCount|this._bitBucket,this._bitCount+=8n,this._bitCount>32&&(this._overflowBits=e>>40n-this._bitCount&0xffn)}let i=this._bitBucket;return t<64&&(i&=(1n<<BigInt(t))-1n),s.value=Number(i),s.bitsRead=t,s}skipBits(e){let t=BigInt(e);if(0===e);else if(this._bitCount>t){if(this._bitBucket=e>31?0n:this._bitBucket>>t,this._bitCount>32){const s=this._bitCount-32n;this._bitBucket=this._bitBucket|this._overflowBits<<this._bitCount-t-s,s>e&&(this._overflowBits=this._overflowBits>>t&0xffn)}this._bitCount-=t}else if(this._bitCount===t)this._bitBucket=0n,this._bitCount=0n;else{for(t-=this._bitCount,this._bitCount=0n,this._bitBucket=0n;t>8;){if(-1===this._source.readByte()){t=0n;break}t-=8n}if(t>0){const e=BigInt(this._source.readByte());-1n===e||(this._bitBucket=e>>t,this._bitCount=8n-t)}}}}ti.ByteSize=8;class si{constructor(){this.codebooks=[],this.timeDomainTransforms=[],this.floors=[],this.residues=[],this.mappings=[],this.modes=[]}}class ii{static ilog(e){let t=0;for(;e>0;)++t,e>>=1;return t}static bitReverse(e,t=32){let s=BigInt(e);s=(s&BigInt(2863311530))>>1n|(s&BigInt(1431655765))<<1n,s=(s&BigInt(3435973836))>>2n|(s&BigInt(858993459))<<2n,s=(s&BigInt(4042322160))>>4n|(s&BigInt(252645135))<<4n,s=(s&BigInt(4278255360))>>8n|(s&BigInt(16711935))<<8n,s=(s>>16n|s<<16n)>>32n-BigInt(t);return Number(BigInt.asUintN(32,s))}static convertFromVorbisFloat32(e){const t=BigInt(e);let s=t&BigInt(2097151);const i=t&BigInt(2147483648),a=(t&BigInt(2145386496))>>21n;return 0n!==i&&(s=-s),Number(s)*Math.pow(2,Number(a)-788)}}class ai{constructor(e){this._data=e}get(e){return this._data[e]}}class ri{get(e){return e}}ri.instance=new ri;class ni{constructor(t,s){this._maxBits=0,this._overflowList=null,this._prefixList=null,this._prefixBitLength=0,this.dimensions=0,this.entries=0,this.mapType=0;if(5653314!==t.readBits(24))throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Book header had invalid signature!");this.dimensions=t.readBits(16),this.entries=t.readBits(24),this._lengths=new Int32Array(this.entries),this.initTree(t,s),this.initLookupTable(t)}get(e,t){return this._lookupTable[e*this.dimensions+t]}decodeScalar(e){let t=e.tryPeekBits(this._prefixBitLength);if(0===t.bitsRead)return-1;let s=this._prefixList[t.value];if(null!=s)return e.skipBits(s.length),s.value;if(t=e.tryPeekBits(this._maxBits),null!==this._overflowList)for(let i=0;i<this._overflowList.length;i++){s=this._overflowList[i];const a=t.value&s.mask;if(s.bits===a)return e.skipBits(s.length),s.value}return-1}initTree(t,s){let i,a,r=0;if(t.readBit()){let e=t.readBits(5)+1;for(let s=0;s<this.entries;){let i=t.readBits(ii.ilog(this.entries-s));for(;--i>=0;)this._lengths[s++]=e;++e}r=0,i=!1,a=e}else{a=-1,i=t.readBit();for(let e=0;e<this.entries;e++)!i||t.readBit()?(this._lengths[e]=t.readBits(5)+1,++r):this._lengths[e]=-1,this._lengths[e]>a&&(a=this._lengths[e])}if(this._maxBits=a,a>-1){let t,a=null;i&&r>=this.entries>>2&&(a=new Int32Array(this.entries),a.set(this._lengths.subarray(0,this.entries),0),i=!1),t=i?r:0;let n=null,o=null;if(i?0!==t&&(a=new Int32Array(t),o=new Int32Array(t),n=new Int32Array(t)):o=new Int32Array(this.entries),!this.computeCodewords(i,o,a,this._lengths,this.entries,n))throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Failed to compute codewords");const h=null==n?ri.instance:new ai(n);s.generateTable(h,a??this._lengths,o),this._prefixList=s.prefixTree,this._prefixBitLength=s.tableBits,this._overflowList=s.overflowList}}computeCodewords(e,t,s,i,a,r){const n=new Uint32Array(32);let o=0,h=0;for(o=0;o<a&&!(i[o]>0);++o);if(o===a)return!0;this.addEntry(e,t,s,0,o,h++,i[o],r);for(let e=1;e<=i[o];++e)n[e]=1<<32-e;for(let l=o+1;l<a;++l){let a=i[l];if(a<=0)continue;for(;a>0&&0===n[a];)--a;if(0===a)return!1;const o=n[a];if(n[a]=0,this.addEntry(e,t,s,ii.bitReverse(o),l,h++,i[l],r),a!==i[l])for(let e=i[l];e>a;--e)n[e]=o+(1<<32-e)}return!0}addEntry(e,t,s,i,a,r,n,o){e?(t[r]=i,s[r]=n,o[r]=a):t[a]=i}initLookupTable(e){if(this.mapType=e.readBits(4),0===this.mapType)return;const t=ii.convertFromVorbisFloat32(e.readBits(32)),s=ii.convertFromVorbisFloat32(e.readBits(32)),i=e.readBits(4)+1,a=e.readBit();let r=this.entries*this.dimensions;const n=new Float32Array(r);1===this.mapType&&(r=this.lookup1Values());const o=new Uint32Array(r);for(let t=0;t<r;t++)o[t]=e.readBits(i);if(1===this.mapType)for(let e=0;e<this.entries;e++){let i=0,h=1;for(let l=0;l<this.dimensions;l++){const c=o[e/h%r|0]*s+t+i;n[e*this.dimensions+l]=c,a&&(i=c),h*=r}}else for(let e=0;e<this.entries;e++){let i=0,r=e*this.dimensions;for(let h=0;h<this.dimensions;h++){const l=o[r]*s+t+i;n[e*this.dimensions+h]=l,a&&(i=l),++r}}this._lookupTable=n}lookup1Values(){let e=Math.floor(Math.exp(Math.log(this.entries)/this.dimensions));return Math.floor(Math.pow(e+1,this.dimensions))<=this.entries&&++e,e}}class oi{constructor(){this.value=0,this.length=0,this.bits=0,this.mask=0}}class hi{constructor(){this.tableBits=0,this.prefixTree=[],this.overflowList=null}generateTable(e,t,s){const i=new Array(t.length);let a=0;for(let r=0;r<i.length;r++){const n=new oi;n.value=e.get(r),n.length=t[r]<=0?99999:t[r],n.bits=s[r],n.mask=(1<<t[r])-1,i[r]=n,t[r]>0&&a<t[r]&&(a=t[r])}i.sort(((e,t)=>{const s=e.length-t.length;return 0===s?e.bits-t.bits:s}));const r=a>hi.MAX_TABLE_BITS?hi.MAX_TABLE_BITS:a,n=[];let o=null;for(let e=0;e<i.length&&i[e].length<99999;e++){const t=i[e].length;if(t>r)for(o=[];e<i.length&&i[e].length<99999;e++)o.push(i[e]);else{const s=1<<r-t,a=i[e];for(let e=0;e<s;e++){const s=e<<t|a.bits;for(;n.length<=s;)n.push(null);n[s]=a}}}for(;n.length<1<<r;)n.push(null);this.tableBits=r,this.prefixTree=n,this.overflowList=o}}hi.MAX_TABLE_BITS=10;class li{constructor(e){e.readBits(16)}}class ci{get executeChannel(){return(this.forceEnergy||this.amp>0)&&!this.forceNoEnergy}constructor(e){this.amp=0,this.forceEnergy=!1,this.forceNoEnergy=!1,this.coeff=e}}class di{constructor(t,s,i,a){if(this._order=t.readBits(8),this._rate=t.readBits(16),this._bark_map_size=t.readBits(16),this._ampBits=t.readBits(6),this._ampOfs=t.readBits(8),this._books=new Array(t.readBits(4)+1),this._order<1||this._rate<1||this._bark_map_size<1||0===this._books.length)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid Floor0 Data");this._ampDiv=(1<<this._ampBits)-1;for(let s=0;s<this._books.length;s++){const i=t.readBits(8);if(i<0||i>=a.length)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid Floor0 Data");const r=a[i];if(0===r.mapType||r.dimensions<1)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid Floor0 Data");this._books[s]=r}this._bookBits=ii.ilog(this._books.length),this._barkMaps=new Map([[s,this.synthesizeBarkCurve(s/2)],[i,this.synthesizeBarkCurve(i/2)]]),this._wMap=new Map([[s,this.synthesizeWDelMap(s/2)],[i,this.synthesizeWDelMap(i/2)]])}synthesizeBarkCurve(e){const t=this._bark_map_size/di.toBARK(this._rate/2),s=new Int32Array(e+1);for(let i=0;i<e-1;i++)s[i]=Math.min(this._bark_map_size-1,Math.floor(di.toBARK(this._rate/2/e*i)*t));return s[e]=-1,s}static toBARK(e){return 13.1*Math.atan(74e-5*e)+2.24*Math.atan(1.85e-8*e*e)+1e-4*e}synthesizeWDelMap(e){const t=Math.PI/this._bark_map_size,s=new Float32Array(e);for(let i=0;i<e;i++)s[i]=2*Math.cos(t*i);return s}unpack(e,t,s){const i=new ci(new Float32Array(this._order+1));if(i.amp=e.readBits(this._ampBits),i.amp>0){i.amp=i.amp/this._ampDiv*this._ampOfs;const t=e.readBits(this._bookBits);if(t>=this._books.length)return i.amp=0,i;const s=this._books[t];for(let t=0;t<this._order;){const a=s.decodeScalar(e);if(-1===a)return i.amp=0,i;for(let e=0;t<this._order&&e<s.dimensions;e++,t++)i.coeff[t]=s.get(a,e)}let a=0;for(let e=0;e<this._order;){for(let t=0;e<this._order&&t<s.dimensions;e++,t++)i.coeff[e]+=a;a=i.coeff[e-1]}}return i}apply(e,t,s){const i=e,a=t/2;if(i.amp>0){const e=this._barkMaps.get(t),r=this._wMap.get(t);let n=0;for(n=0;n<this._order;n++)i.coeff[n]=2*Math.cos(i.coeff[n]);for(n=0;n<a;){let t=0;const a=e[n];let o=.5,h=.5;const l=r[a];for(t=1;t<this._order;t+=2)h*=l-i.coeff[t-1],o*=l-i.coeff[t];for(t===this._order?(h*=l-i.coeff[t-1],o*=o*(4-l*l),h*=h):(o*=o*(2-l),h*=h*(2+l)),h=i.amp/Math.sqrt(o+h)-this._ampOfs,h=Math.exp(.11512925*h),s[n]*=h;e[++n]===a;)s[n]*=h}}else s.fill(0,0,a)}}class ui{constructor(){this.posts=new Int32Array(64),this.postCount=0,this.forceEnergy=!1,this.forceNoEnergy=!1}get executeChannel(){return(this.forceEnergy||this.postCount>0)&&!this.forceNoEnergy}}class pi{constructor(t,s){let i=-1;this._partitionClass=new Int32Array(t.readBits(5));for(let e=0;e<this._partitionClass.length;e++)this._partitionClass[e]=t.readBits(4),this._partitionClass[e]>i&&(i=this._partitionClass[e]);++i,this._classDimensions=new Int32Array(i),this._classSubclasses=new Int32Array(i),this._classMasterbooks=new Array(i),this._classMasterBookIndex=new Int32Array(i),this._subclassBooks=new Array(i),this._subclassBookIndex=new Array(i);for(let e=0;e<i;e++){this._classDimensions[e]=t.readBits(3)+1,this._classSubclasses[e]=t.readBits(2),this._classSubclasses[e]>0&&(this._classMasterBookIndex[e]=t.readBits(8),this._classMasterbooks[e]=s[this._classMasterBookIndex[e]]),this._subclassBooks[e]=new Array(1<<this._classSubclasses[e]),this._subclassBookIndex[e]=new Int32Array(this._subclassBooks[e].length);for(let i=0;i<this._subclassBooks[e].length;i++){const a=t.readBits(8)-1;a>=0&&(this._subclassBooks[e][i]=s[a]),this._subclassBookIndex[e][i]=a}}this._multiplier=t.readBits(2),this._range=pi._rangeLookup[this._multiplier],this._yBits=pi._yBitsLookup[this._multiplier],++this._multiplier;const a=t.readBits(4),r=[];r.push(0),r.push(1<<a);for(let e=0;e<this._partitionClass.length;e++){const s=this._partitionClass[e];for(let e=0;e<this._classDimensions[s];e++)r.push(t.readBits(a))}this._xList=new Int32Array(r),this._lNeigh=new Int32Array(r.length),this._hNeigh=new Int32Array(r.length),this._sortIdx=new Int32Array(r.length),this._sortIdx[0]=0,this._sortIdx[1]=1;for(let e=2;e<this._lNeigh.length;e++){this._lNeigh[e]=0,this._hNeigh[e]=1,this._sortIdx[e]=e;for(let t=2;t<e;t++){const s=this._xList[t];s<this._xList[e]?s>this._xList[this._lNeigh[e]]&&(this._lNeigh[e]=t):s<this._xList[this._hNeigh[e]]&&(this._hNeigh[e]=t)}}for(let t=0;t<this._sortIdx.length-1;t++)for(let s=t+1;s<this._sortIdx.length;s++){if(this._xList[t]===this._xList[s])throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid Floor1 Data");if(this._xList[this._sortIdx[t]]>this._xList[this._sortIdx[s]]){const e=this._sortIdx[t];this._sortIdx[t]=this._sortIdx[s],this._sortIdx[s]=e}}}unpack(e,t,s){const i=new ui;if(e.readBit()){let t=2;i.posts[0]=e.readBits(this._yBits),i.posts[1]=e.readBits(this._yBits);for(let s=0;s<this._partitionClass.length;s++){const a=this._partitionClass[s],r=this._classDimensions[a],n=this._classSubclasses[a],o=(1<<n)-1;let h=0;if(n>0&&(h=this._classMasterbooks[a].decodeScalar(e),-1===h)){t=0;break}for(let l=0;l<r;l++){const r=this._subclassBooks[a][h&o];if(h>>=n,null!=r&&(i.posts[t]=r.decodeScalar(e),-1===i.posts[t])){t=0,s=this._partitionClass.length;break}++t}}i.postCount=t}return i}apply(e,t,s){const i=e,a=t/2;if(i.postCount>0){const e=this.unwrapPosts(i);let t=0,r=i.posts[0]*this._multiplier;for(let n=1;n<i.postCount;n++){const o=this._sortIdx[n];if(e[o]){const e=this._xList[o],n=i.posts[o]*this._multiplier;t<a&&this.renderLineMulti(t,r,Math.min(e,a),n,s),t=e,r=n}if(t>=a)break}t<a&&this.renderLineMulti(t,r,a,r,s)}else s.fill(0,0,a)}unwrapPosts(e){const t=new Array(64);t.fill(!1),t[0]=!0,t[1]=!0;const s=new Int32Array(64);s[0]=e.posts[0],s[1]=e.posts[1];for(let i=2;i<e.postCount;i++){const a=this._lNeigh[i],r=this._hNeigh[i],n=this.renderPoint(this._xList[a],s[a],this._xList[r],s[r],this._xList[i]),o=e.posts[i],h=this._range-n,l=n;let c;c=h<l?2*h:2*l,0!==o?(t[a]=!0,t[r]=!0,t[i]=!0,s[i]=o>=c?h>l?o-l+n:n-o+h-1:o%2==1?n-(o+1)/2:n+o/2):(t[i]=!1,s[i]=n)}for(let t=0;t<e.postCount;t++)e.posts[t]=s[t];return t}renderPoint(e,t,s,i,a){const r=i-t,n=s-e,o=Math.abs(r)*(a-e)/n|0;return r<0?t-o:t+o}renderLineMulti(e,t,s,i,a){const r=i-t,n=s-e;let o=Math.abs(r);const h=1-2*(r>>31&1),l=r/n|0;let c=e,d=t,u=-n;for(a[e]*=pi.inverse_dB_table[t],o-=Math.abs(l)*n;++c<s;)d+=l,u+=o,u>=0&&(u-=n,d+=h),a[c]*=pi.inverse_dB_table[d]}}pi._rangeLookup=[256,128,86,64],pi._yBitsLookup=[8,7,7,6],pi.inverse_dB_table=new Float32Array([1.0649863e-7,1.1341951e-7,1.2079015e-7,1.2863978e-7,1.3699951e-7,1.4590251e-7,1.5538408e-7,1.6548181e-7,1.7623575e-7,1.8768855e-7,1.9988561e-7,2.128753e-7,2.2670913e-7,2.4144197e-7,2.5713223e-7,2.7384213e-7,2.9163793e-7,3.1059021e-7,3.3077411e-7,3.5226968e-7,3.7516214e-7,3.9954229e-7,4.255068e-7,4.5315863e-7,4.8260743e-7,5.1396998e-7,5.4737065e-7,5.8294187e-7,6.2082472e-7,6.6116941e-7,7.0413592e-7,7.4989464e-7,7.9862701e-7,8.505263e-7,9.0579828e-7,9.6466216e-7,10273513e-13,10941144e-13,11652161e-13,12409384e-13,13215816e-13,14074654e-13,14989305e-13,15963394e-13,17000785e-13,18105592e-13,19282195e-13,20535261e-13,21869758e-13,23290978e-13,24804557e-13,26416497e-13,2813319e-12,29961443e-13,31908506e-13,33982101e-13,36190449e-13,38542308e-13,41047004e-13,4371447e-12,46555282e-13,49580707e-13,5280274e-12,5623416e-12,59888572e-13,63780469e-13,67925283e-13,72339451e-13,77040476e-13,82047e-10,87378876e-13,93057248e-13,99104632e-13,10554501e-12,11240392e-12,11970856e-12,12748789e-12,13577278e-12,14459606e-12,15399272e-12,16400004e-12,17465768e-12,18600792e-12,19809576e-12,21096914e-12,22467911e-12,23928002e-12,25482978e-12,27139006e-12,28902651e-12,30780908e-12,32781225e-12,34911534e-12,37180282e-12,39596466e-12,42169667e-12,4491009e-11,47828601e-12,50936773e-12,54246931e-12,57772202e-12,61526565e-12,65524908e-12,69783085e-12,74317983e-12,79147585e-12,8429104e-11,89768747e-12,95602426e-12,.00010181521,.00010843174,.00011547824,.00012298267,.00013097477,.00013948625,.00014855085,.00015820453,.00016848555,.00017943469,.00019109536,.00020351382,.00021673929,.00023082423,.00024582449,.00026179955,.00027881276,.00029693158,.00031622787,.00033677814,.00035866388,.00038197188,.00040679456,.00043323036,.00046138411,.00049136745,.00052329927,.00055730621,.00059352311,.00063209358,.00067317058,716917e-9,.0007635063,.00081312324,.00086596457,.00092223983,.00098217216,.0010459992,.0011139742,.0011863665,.0012634633,.0013455702,.0014330129,.0015261382,.0016253153,.0017309374,.0018434235,.0019632195,.0020908006,.0022266726,.0023713743,.0025254795,.0026895994,.0028643847,.0030505286,.0032487691,.0034598925,.0036847358,.0039241906,.0041792066,.004450795,.0047400328,.0050480668,.0053761186,.0057254891,.0060975636,.0064938176,.0069158225,.0073652516,.0078438871,.0083536271,.0088964928,.009474637,.010090352,.01074608,.011444421,.012188144,.012980198,.013823725,.014722068,.015678791,.016697687,.017782797,.018938423,.020169149,.021479854,.022875735,.02436233,.025945531,.027631618,.029427276,.031339626,.033376252,.035545228,.037855157,.040315199,.042935108,.045725273,.048696758,.051861348,.055231591,.05882085,.062643361,.066714279,.071049749,.075666962,.080584227,.085821044,.091398179,.097337747,.1036633,.11039993,.11757434,.12521498,.13335215,.14201813,.15124727,.16107617,.1715438,.18269168,.19456402,.20720788,.22067342,.23501402,.25028656,.26655159,.28387361,.30232132,.32196786,.34289114,.36517414,.38890521,.41417847,.44109412,.4697589,.50028648,.53279791,.56742212,.6042964,.64356699,.68538959,.72993007,.77736504,.8278826,.88168307,.9389798,1]);class gi{constructor(t,s,i,a){const r=t.readBits(16);switch(r){case 0:this.floor=new di(t,s,i,a);break;case 1:this.floor=new pi(t,a);break;default:throw new qe(e.AlphaTabErrorType.Format,`Vorbis: Invalid Floor type: ${r}`)}}apply(e,t,s){this.floor.apply(e,t,s)}unpack(e,t,s){return this.floor.unpack(e,t,s)}}class mi{constructor(t,s,i){this._begin=t.readBits(24),this._end=t.readBits(24),this._partitionSize=t.readBits(24)+1,this._classifications=t.readBits(6)+1,this._classBook=i[t.readBits(8)],this._cascade=new Int32Array(this._classifications);let a=0;for(let e=0;e<this._classifications;e++){const s=t.readBits(3);t.readBit()?this._cascade[e]=t.readBits(5)<<3|s:this._cascade[e]=s,a+=mi.icount(this._cascade[e])}const r=new Int32Array(a);for(let s=0;s<a;s++)if(r[s]=t.readBits(8),0===i[r[s]].mapType)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid Residue 0");const n=this._classBook.entries;let o=this._classBook.dimensions,h=1;for(;o>0;){if(h*=this._classifications,h>n)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid Residue 0");--o}this._books=new Array(this._classifications),a=0;let l,c=0;for(let e=0;e<this._classifications;e++)if(l=ii.ilog(this._cascade[e]),this._books[e]=new Array(l),l>0){c=Math.max(c,l);for(let t=0;t<l;t++)(this._cascade[e]&1<<t)>0&&(this._books[e][t]=i[r[a++]])}this._maxStages=c,this._decodeMap=new Array(h);for(let e=0;e<h;e++){let t=e,s=h/this._classifications|0;this._decodeMap[e]=new Int32Array(this._classBook.dimensions);for(let i=0;i<this._classBook.dimensions;i++){const a=t/s|0;t-=a*s,s=s/this._classifications|0,this._decodeMap[e][i]=a}}this._channels=s}static icount(e){let t=0;for(;0!==e;)t+=1&e,e>>=1;return t}decode(e,t,s,i){const a=(this._end<s/2?this._end:s/2)-this._begin;if(a>0&&-1!==t.indexOf(!1)){const t=a/this._partitionSize,s=(t+this._classBook.dimensions-1)/this._classBook.dimensions|0,r=[];for(let e=0;e<this._channels;e++)r.push(new Array(s));for(let s=0;s<this._maxStages;s++)for(let a=0,n=0;a<t;n++){if(0===s)for(let i=0;i<this._channels;i++){const o=this._classBook.decodeScalar(e);if(!(o>=0&&o<this._decodeMap.length)){a=t,s=this._maxStages;break}r[i][n]=this._decodeMap[o]}for(let o=0;a<t&&o<this._classBook.dimensions;o++,a++){const h=this._begin+a*this._partitionSize;for(let l=0;l<this._channels;l++){const c=r[l][n][o];if(this._cascade[c]&1<<s){const r=this._books[c][s];if(r&&this.writeVectors(r,e,i,l,h,this._partitionSize)){a=t,s=this._maxStages;break}}}}}}}writeVectors(e,t,s,i,a,r){const n=s[i],o=r/e.dimensions,h=new Int32Array(o);for(let s=0;s<o;s++)if(h[s]=e.decodeScalar(t),-1===h[s])return!0;for(let t=0;t<e.dimensions;t++)for(let s=0;s<o;s++,a++)n[a]+=e.get(h[s],t);return!1}}class fi extends mi{writeVectors(e,t,s,i,a,r){const n=s[i];for(let s=0;s<r;){const i=e.decodeScalar(t);if(-1===i)return!0;for(let t=0;t<e.dimensions;s++,t++)n[a+s]+=e.get(i,t)}return!1}}class yi extends mi{constructor(e,t,s){super(e,1,s),this._realChannels=t}decode(e,t,s,i){super.decode(e,t,s*this._realChannels,i)}writeVectors(e,t,s,i,a,r){let n=0;a/=this._realChannels;for(let i=0;i<r;){const r=e.decodeScalar(t);if(-1===r)return!0;for(let t=0;t<e.dimensions;t++,i++)s[n][a]+=e.get(r,t),++n===this._realChannels&&(n=0,a++)}return!1}}class bi{constructor(t,s,i){const a=t.readBits(16);switch(a){case 0:this.residue=new mi(t,s,i);break;case 1:this.residue=new fi(t,s,i);break;case 2:this.residue=new yi(t,s,i);break;default:throw new qe(e.AlphaTabErrorType.Format,`Vorbis: Invalid Residue type: ${a}`)}}decode(e,t,s,i){this.residue.decode(e,t,s,i)}}class Si{constructor(t,s,i,a,r){if(0!==t.readBits(16))throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid mapping type!");let n=1;t.readBit()&&(n+=t.readBits(4));let o=0;t.readBit()&&(o=t.readBits(8)+1);const h=ii.ilog(s-1);this._couplingAngle=new Int32Array(o),this._couplingMangitude=new Int32Array(o);for(let i=0;i<o;i++){const a=t.readBits(h),r=t.readBits(h);if(a===r||a>s-1||r>s-1)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid magnitude or angle in mapping header!");this._couplingAngle[i]=r,this._couplingMangitude[i]=a}if(0!==t.readBits(2))throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Reserved bits not 0 in mapping header.");const l=new Int32Array(s);if(n>1)for(let i=0;i<s;i++)if(l[i]=t.readBits(4),l[i]>n)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid channel mux submap index in mapping header!");this._submapFloor=new Array(n),this._submapResidue=new Array(n);for(let s=0;s<n;s++){t.skipBits(8);const r=t.readBits(8);if(r>=i.length)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid floor number in mapping header!");const n=t.readBits(8);if(n>=a.length)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Invalid residue number in mapping header!");this._submapFloor[s]=i[r],this._submapResidue[s]=a[n]}this._channelFloor=new Array(s),this._channelResidue=new Array(s);for(let e=0;e<s;e++)this._channelFloor[e]=this._submapFloor[l[e]],this._channelResidue[e]=this._submapResidue[l[e]];this._mdct=r}decodePacket(e,t,s){const i=t>>1,a=new Array(this._channelFloor.length),r=new Array(this._channelFloor.length);r.fill(!1);for(let n=0;n<this._channelFloor.length;n++)a[n]=this._channelFloor[n].unpack(e,t,n),r[n]=!a[n].executeChannel,s[n].fill(0,0,i);for(let e=0;e<this._couplingAngle.length;e++)(a[this._couplingAngle[e]].executeChannel||a[this._couplingMangitude[e]].executeChannel)&&(a[this._couplingAngle[e]].forceEnergy=!0,a[this._couplingMangitude[e]].forceEnergy=!0);for(let i=0;i<this._submapFloor.length;i++){for(let e=0;e<this._channelFloor.length;e++)this._submapFloor[i]===this._channelFloor[e]&&this._submapResidue[i]===this._channelResidue[e]||(a[e].forceNoEnergy=!0);this._submapResidue[i].decode(e,r,t,s)}for(let e=this._couplingAngle.length-1;e>=0;e--)if(a[this._couplingAngle[e]].executeChannel||a[this._couplingMangitude[e]].executeChannel){const t=s[this._couplingMangitude[e]],a=s[this._couplingAngle[e]];for(let e=0;e<i;e++){let s,i;const r=t[e],n=a[e];r>0?n>0?(s=r,i=r-n):(i=r,s=r+n):n>0?(s=r,i=r+n):(i=r,s=r-n),t[e]=s,a[e]=i}}for(let e=0;e<this._channelFloor.length;e++)a[e].executeChannel?(this._channelFloor[e].apply(a[e],t,s[e]),this._mdct.reverse(s[e],t)):s[e].fill(0,i,2*i)}}class _i{constructor(){this.packetStartIndex=0,this.packetTotalLength=0,this.packetValidLength=0}}class wi{constructor(){this.overlapInfo=new _i,this.windowIndex=0}}class Bi{constructor(e=null){this.samplePosition=null,this.samplePosition=e}}class ki{constructor(t,s,i,a,r){if(this._overlapInfo=null,this._channels=s,this._blockFlag=t.readBit(),0!==t.readBits(32))throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Mode header had invalid window or transform type!");const n=t.readBits(8);if(n>=r.length)throw new qe(e.AlphaTabErrorType.Format,"Vorbis: Mode header had invalid mapping index!");this._mapping=r[n],this._blockFlag?(this._blockSize=a,this._windows=[ki.calcWindow(i,a,i),ki.calcWindow(a,a,i),ki.calcWindow(i,a,a),ki.calcWindow(a,a,a)],this._overlapInfo=[ki.calcOverlap(i,a,i),ki.calcOverlap(a,a,i),ki.calcOverlap(i,a,a),ki.calcOverlap(a,a,a)]):(this._blockSize=i,this._windows=[ki.calcWindow(i,i,i)])}decode(e,t){const s=this.getPacketInfo(e);this._mapping.decodePacket(e,this._blockSize,t);const i=this._windows[s.windowIndex];for(let e=0;e<this._blockSize;e++)for(let s=0;s<this._channels;s++)t[s][e]*=i[e];return s.overlapInfo}getPacketInfo(e){const t=new wi;if(this._blockFlag){const s=e.readBit(),i=e.readBit();t.windowIndex=(s?1:0)+(i?2:0);const a=this._overlapInfo[t.windowIndex];t.overlapInfo.packetStartIndex=a.packetStartIndex,t.overlapInfo.packetValidLength=a.packetValidLength,t.overlapInfo.packetTotalLength=a.packetTotalLength}else t.windowIndex=0,t.overlapInfo.packetStartIndex=0,t.overlapInfo.packetValidLength=this._blockSize/2,t.overlapInfo.packetTotalLength=this._blockSize;return t}static calcWindow(e,t,s){const i=new Float32Array(t),a=e/2,r=s/2,n=t/4-a/2,o=t-t/4-r/2;for(let e=0;e<a;e++){let t=Math.sin((e+.5)/a*ki.M_PI2);t*=t,i[n+e]=Math.sin(t*ki.M_PI2)}for(let e=n+a;e<o;e++)i[e]=1;for(let e=0;e<r;e++){let t=Math.sin((r-e-.5)/r*ki.M_PI2);t*=t,i[o+e]=Math.sin(t*ki.M_PI2)}return i}static calcOverlap(e,t,s){const i=s/4,a=t/4-e/4,r=t/4*3+i,n=r-2*i,o=new _i;return o.packetStartIndex=a,o.packetValidLength=n,o.packetTotalLength=r,o}}ki.M_PI2=1.57079632695;class Ti{constructor(e){this._n=e,this._n2=e>>1,this._n4=this._n2>>1,this._n8=this._n4>>1,this._ld=ii.ilog(e)-1,this._a=new Float32Array(this._n2),this._b=new Float32Array(this._n2),this._c=new Float32Array(this._n4);let t=0,s=0;for(;t<this._n4;++t,s+=2)this._a[s]=Math.cos(4*t*Ti.M_PI/e),this._a[s+1]=-Math.sin(4*t*Ti.M_PI/e),this._b[s]=.5*Math.cos((s+1)*Ti.M_PI/e/2),this._b[s+1]=.5*Math.sin((s+1)*Ti.M_PI/e/2);for(t=0,s=0;t<this._n8;++t,s+=2)this._c[s]=Math.cos(2*(s+1)*Ti.M_PI/e),this._c[s+1]=-Math.sin(2*(s+1)*Ti.M_PI/e);this._bitrev=new Uint16Array(this._n8);for(let e=0;e<this._n8;++e)this._bitrev[e]=ot.int32ToUint16(ii.bitReverse(e,this._ld-3)<<2)}calcReverse(e){let t,s;const i=new Float32Array(this._n2);{let t=this._n2-2,s=0,a=0;const r=this._n2;for(;a!==r;)i[t+1]=e[a]*this._a[s]-e[a+2]*this._a[s+1],i[t]=e[a]*this._a[s+1]+e[a+2]*this._a[s],t-=2,s+=2,a+=4;for(a=this._n2-3;t>=0;)i[t+1]=-e[a+2]*this._a[s]- -e[a]*this._a[s+1],i[t]=-e[a+2]*this._a[s+1]+-e[a]*this._a[s],t-=2,s+=2,a-=4}t=e,s=i;{let e=this._n2-8,i=this._n4,a=0,r=this._n4,n=0;for(;e>=0;){let o,h;h=s[i+1]-s[a+1],o=s[i]-s[a],t[r+1]=s[i+1]+s[a+1],t[r]=s[i]+s[a],t[n+1]=h*this._a[e+4]-o*this._a[e+5],t[n]=o*this._a[e+4]+h*this._a[e+5],h=s[i+3]-s[a+3],o=s[i+2]-s[a+2],t[r+3]=s[i+3]+s[a+3],t[r+2]=s[i+2]+s[a+2],t[n+3]=h*this._a[e]-o*this._a[e+1],t[n+2]=o*this._a[e]+h*this._a[e+1],e-=8,r+=4,n+=4,i+=4,a+=4}}this.step3_iter0_loop(this._n>>4,t,this._n2-1-0*this._n4,-this._n8),this.step3_iter0_loop(this._n>>4,t,this._n2-1-1*this._n4,-this._n8),this.step3_inner_r_loop(this._n>>5,t,this._n2-1-0*this._n8,-(this._n>>4),16),this.step3_inner_r_loop(this._n>>5,t,this._n2-1-1*this._n8,-(this._n>>4),16),this.step3_inner_r_loop(this._n>>5,t,this._n2-1-2*this._n8,-(this._n>>4),16),this.step3_inner_r_loop(this._n>>5,t,this._n2-1-3*this._n8,-(this._n>>4),16);let a=2;for(;a<this._ld-3>>1;++a){const e=this._n>>a+2,s=e>>1,i=1<<a+1;for(let r=0;r<i;++r)this.step3_inner_r_loop(this._n>>a+4,t,this._n2-1-e*r,-s,1<<a+3)}for(;a<this._ld-6;++a){const e=this._n>>a+2,s=1<<a+3,i=e>>1,r=this._n>>a+6,n=1<<a+1;let o=this._n2-1,h=0;for(let a=r;a>0;--a)this.step3_inner_s_loop(n,t,o,-i,h,s,e),h+=4*s,o-=8}this.step3_inner_s_loop_ld654(this._n>>5,t,this._n2-1,this._n);{let e=0,i=this._n4-4,a=this._n2-4;for(;i>=0;){let r;r=this._bitrev[e],s[a+3]=t[r],s[a+2]=t[r+1],s[i+3]=t[r+2],s[i+2]=t[r+3],r=this._bitrev[e+1],s[a+1]=t[r],s[a]=t[r+1],s[i+1]=t[r+2],s[i]=t[r+3],i-=4,a-=4,e+=2}}{let e=0,t=0,i=this._n2-4;for(;t<i;){let a,r,n,o,h,l;a=s[t]-s[i+2],r=s[t+1]+s[i+3],n=this._c[e+1]*a+this._c[e]*r,o=this._c[e+1]*r-this._c[e]*a,h=s[t]+s[i+2],l=s[t+1]-s[i+3],s[t]=h+n,s[t+1]=l+o,s[i+2]=h-n,s[i+3]=o-l,a=s[t+2]-s[i],r=s[t+3]+s[i+1],n=this._c[e+3]*a+this._c[e+2]*r,o=this._c[e+3]*r-this._c[e+2]*a,h=s[t+2]+s[i],l=s[t+3]-s[i+1],s[t+2]=h+n,s[t+3]=l+o,s[i]=h-n,s[i+1]=o-l,e+=4,t+=4,i-=4}}{let t=this._n2-8,s=this._n2-8,a=0,r=this._n2-4,n=this._n2,o=this._n-4;for(;s>=0;){let h,l,c,d;d=i[s+6]*this._b[t+7]-i[s+7]*this._b[t+6],c=-i[s+6]*this._b[t+6]-i[s+7]*this._b[t+7],e[a]=d,e[r+3]=-d,e[n]=c,e[o+3]=c,l=i[s+4]*this._b[t+5]-i[s+5]*this._b[t+4],h=-i[s+4]*this._b[t+4]-i[s+5]*this._b[t+5],e[a+1]=l,e[r+2]=-l,e[n+1]=h,e[o+2]=h,d=i[s+2]*this._b[t+3]-i[s+3]*this._b[t+2],c=-i[s+2]*this._b[t+2]-i[s+3]*this._b[t+3],e[a+2]=d,e[r+1]=-d,e[n+2]=c,e[o+1]=c,l=i[s]*this._b[t+1]-i[s+1]*this._b[t],h=-i[s]*this._b[t]-i[s+1]*this._b[t+1],e[a+3]=l,e[r]=-l,e[n+3]=h,e[o]=h,t-=8,s-=8,a+=4,n+=4,r-=4,o-=4}}}step3_inner_r_loop(e,t,s,i,a){let r,n,o=s,h=o+i,l=0;for(let s=e>>2;s>0;--s)r=t[o]-t[h],n=t[o-1]-t[h-1],t[o]+=t[h],t[o-1]+=t[h-1],t[h]=r*this._a[l]-n*this._a[l+1],t[h-1]=n*this._a[l]+r*this._a[l+1],l+=a,r=t[o-2]-t[h-2],n=t[o-3]-t[h-3],t[o-2]+=t[h-2],t[o-3]+=t[h-3],t[h-2]=r*this._a[l]-n*this._a[l+1],t[h-3]=n*this._a[l]+r*this._a[l+1],l+=a,r=t[o-4]-t[h-4],n=t[o-5]-t[h-5],t[o-4]+=t[h-4],t[o-5]+=t[h-5],t[h-4]=r*this._a[l]-n*this._a[l+1],t[h-5]=n*this._a[l]+r*this._a[l+1],l+=a,r=t[o-6]-t[h-6],n=t[o-7]-t[h-7],t[o-6]+=t[h-6],t[o-7]+=t[h-7],t[h-6]=r*this._a[l]-n*this._a[l+1],t[h-7]=n*this._a[l]+r*this._a[l+1],l+=a,o-=8,h-=8}step3_iter0_loop(e,t,s,i){let a=s,r=a+i,n=0;for(let s=e>>2;s>0;--s){let e,s;e=t[a]-t[r],s=t[a-1]-t[r-1],t[a]+=t[r],t[a-1]+=t[r-1],t[r]=e*this._a[n]-s*this._a[n+1],t[r-1]=s*this._a[n]+e*this._a[n+1],n+=8,e=t[a-2]-t[r-2],s=t[a-3]-t[r-3],t[a-2]+=t[r-2],t[a-3]+=t[r-3],t[r-2]=e*this._a[n]-s*this._a[n+1],t[r-3]=s*this._a[n]+e*this._a[n+1],n+=8,e=t[a-4]-t[r-4],s=t[a-5]-t[r-5],t[a-4]+=t[r-4],t[a-5]+=t[r-5],t[r-4]=e*this._a[n]-s*this._a[n+1],t[r-5]=s*this._a[n]+e*this._a[n+1],n+=8,e=t[a-6]-t[r-6],s=t[a-7]-t[r-7],t[a-6]+=t[r-6],t[a-7]+=t[r-7],t[r-6]=e*this._a[n]-s*this._a[n+1],t[r-7]=s*this._a[n]+e*this._a[n+1],n+=8,a-=8,r-=8}}step3_inner_s_loop(e,t,s,i,a,r,n){const o=this._a[a],h=this._a[a+1],l=this._a[a+r],c=this._a[a+r+1],d=this._a[a+2*r],u=this._a[a+2*r+1],p=this._a[a+3*r],g=this._a[a+3*r+1];let m,f,y=s,b=y+i;for(let s=e;s>0;--s)m=t[y]-t[b],f=t[y-1]-t[b-1],t[y]+=t[b],t[y-1]+=t[b-1],t[b]=m*o-f*h,t[b-1]=f*o+m*h,m=t[y-2]-t[b-2],f=t[y-3]-t[b-3],t[y-2]+=t[b-2],t[y-3]+=t[b-3],t[b-2]=m*l-f*c,t[b-3]=f*l+m*c,m=t[y-4]-t[b-4],f=t[y-5]-t[b-5],t[y-4]+=t[b-4],t[y-5]+=t[b-5],t[b-4]=m*d-f*u,t[b-5]=f*d+m*u,m=t[y-6]-t[b-6],f=t[y-7]-t[b-7],t[y-6]+=t[b-6],t[y-7]+=t[b-7],t[b-6]=m*p-f*g,t[b-7]=f*p+m*g,y-=n,b-=n}step3_inner_s_loop_ld654(e,t,s,i){const a=i>>3,r=this._a[a];let n=s;const o=n-16*e;for(;n>o;){let e,s;e=t[n]-t[n-8],s=t[n-1]-t[n-9],t[n]+=t[n-8],t[n-1]+=t[n-9],t[n-8]=e,t[n-9]=s,e=t[n-2]-t[n-10],s=t[n-3]-t[n-11],t[n-2]+=t[n-10],t[n-3]+=t[n-11],t[n-10]=(e+s)*r,t[n-11]=(s-e)*r,e=t[n-12]-t[n-4],s=t[n-5]-t[n-13],t[n-4]+=t[n-12],t[n-5]+=t[n-13],t[n-12]=s,t[n-13]=e,e=t[n-14]-t[n-6],s=t[n-7]-t[n-15],t[n-6]+=t[n-14],t[n-7]+=t[n-15],t[n-14]=(e+s)*r,t[n-15]=(e-s)*r,this.iter_54(t,n),this.iter_54(t,n-8),n-=16}}iter_54(e,t){const s=e[t]-e[t-4],i=e[t]+e[t-4],a=e[t-2]+e[t-6],r=e[t-2]-e[t-6];e[t]=i+a,e[t-2]=i-a;const n=e[t-3]-e[t-7];e[t-4]=s+n,e[t-6]=s-n;const o=e[t-1]-e[t-5],h=e[t-1]+e[t-5],l=e[t-3]+e[t-7];e[t-1]=h+l,e[t-3]=h-l,e[t-5]=o-r,e[t-7]=o+r}}Ti.M_PI=3.141592653589793;class Ni{constructor(){this._setupCache=new Map}reverse(e,t){let s;this._setupCache.has(t)?s=this._setupCache.get(t):(s=new Ti(t),this._setupCache.set(t,s)),s.calcReverse(e)}}class xi{constructor(e,t,s){this._packetIndex=0,this._stream=e,this._setup=t,this._packets=s,this._currentPosition=0,this._prevPacketBuf=null,this._prevPacketStart=0,this._prevPacketEnd=0,this._prevPacketStop=0,this._nextPacketBuf=null,this._eosFound=!1,this._hasPosition=!1,this._modeFieldBits=ii.ilog(t.modes.length-1)}decode(){let e=new Float32Array(this._packets[this._packets.length-1].granulePosition*this._stream.audioChannels);const t=new Float32Array(.2*this._stream.audioSampleRate*this._stream.audioChannels);let s=0,i=0;for(;s=this.read(t,0,t.length),0!==s;){if(i+s>=e.length){const s=new Float32Array(e.length+t.length);s.set(e,0),e=s}e.set(t.subarray(0,s),i),i+=s}return e.subarray(0,i)}read(e,t,s){if(0===s)return 0;let i=t;const a=t+s;for(;i<a;){if(this._prevPacketStart===this._prevPacketEnd){if(this._eosFound){this._nextPacketBuf=null,this._prevPacketBuf=null;break}const e=this.readNextPacket((i-t)/this._stream.audioChannels);null===e&&(this._prevPacketEnd=this._prevPacketStop),null===e||null===e.samplePosition||this._hasPosition||(this._hasPosition=!0,this._currentPosition=e.samplePosition-(this._prevPacketEnd-this._prevPacketStart)-(i-t)/this._stream.audioChannels)}const s=Math.min((a-i)/this._stream.audioChannels,this._prevPacketEnd-this._prevPacketStart);s>0&&(i+=this.copyBuffer(e,i,s))}return s=i-t,this._currentPosition+=s/this._stream.audioChannels,s}copyBuffer(e,t,s){let i=t;for(;s>0;this._prevPacketStart++,s--)for(let t=0;t<this._stream.audioChannels;t++)e[i++]=this._prevPacketBuf[t][this._prevPacketStart];return i-t}readNextPacket(e){const t=this.decodeNextPacket();if(this._eosFound=this._eosFound||t.isEndOfStream,null==t.curPacket)return null;if(null!==t.samplePosition&&t.isEndOfStream){const s=this._currentPosition+e+t.validLen-t.startIndex,i=t.samplePosition-s;i<0&&(t.validLen+=i,t.validLen<0&&(t.validLen=0))}return this._prevPacketEnd>0?(xi.overlapBuffers(this._prevPacketBuf,t.curPacket,this._prevPacketStart,this._prevPacketStop,t.startIndex,this._stream.audioChannels),this._prevPacketStart=t.startIndex):null==this._prevPacketBuf&&(this._prevPacketStart=t.validLen),this._nextPacketBuf=this._prevPacketBuf,this._prevPacketEnd=t.validLen,this._prevPacketStop=t.totalLen,this._prevPacketBuf=t.curPacket,new Bi(t.samplePosition)}static overlapBuffers(e,t,s,i,a,r){for(;s<i;s++,a++)for(let i=0;i<r;i++)t[i][a]+=e[i][s]}decodeNextPacket(){const e=new vi;let t=null;if(this._packetIndex>=this._packets.length)e.isEndOfStream=!0;else{t=this._packets[this._packetIndex++];const s=new ti(lt.fromBuffer(t.packetData));if(e.isEndOfStream=t.isEndOfStream,!s.readBit()){const i=this._setup.modes[s.readBits(this._modeFieldBits)];if(null==this._nextPacketBuf){this._nextPacketBuf=new Array(this._stream.audioChannels);for(let e=0;e<this._stream.audioChannels;e++)this._nextPacketBuf[e]=new Float32Array(this._stream.blocksize1)}const a=i.decode(s,this._nextPacketBuf);return e.startIndex=a.packetStartIndex,e.validLen=a.packetValidLength,e.totalLen=a.packetTotalLength,e.samplePosition=t.granulePosition,e.curPacket=this._nextPacketBuf,e}}return e}}class vi{constructor(){this.curPacket=null,this.startIndex=0,this.validLen=0,this.totalLen=0,this.isEndOfStream=!1,this.samplePosition=null}}!function(e){e[e.IdentificationHeader=1]="IdentificationHeader",e[e.Comment=3]="Comment",e[e.SetupHeader=5]="SetupHeader"}(Vt||(Vt={}));class Pi{constructor(e){this._packetIndex=-1,this._packets=e}read(){let e;for(;;){if(e=this.nextPacket(),null==e)return null;if(e.isBeginningOfStream){const t=this.readStream(e);if(null!=t)return t}}}nextPacket(){return this._packetIndex++,this._packetIndex<this._packets.length?this._packets[this._packetIndex]:null}readStream(e){const t=new Zs;if(!this.readIdentificationHeader(t,e))return null;if(!this.readComments(this.nextPacket()))return null;const s=new si;if(!this.readSetupHeader(t,s,this.nextPacket()))return null;const i=[];let a;for(;a=this.nextPacket(),null!=a&&(i.push(a),!a.isEndOfStream););const r=new xi(t,s,i);return t.samples=r.decode(),t}comonHeaderDecode(e,t){const s=new Uint8Array(7);if(t.read(s,0,s.length),s[0]!==e)return!1;for(let e=0;e<Pi.VorbisHeaderMarker.length;e++)if(s[1+e]!==Pi.VorbisHeaderMarker[e])return!1;return!0}comonHeaderDecodeBit(e,t){const s=t.readBytes(7);if(s[0]!==e)return!1;for(let e=0;e<Pi.VorbisHeaderMarker.length;e++)if(s[1+e]!==Pi.VorbisHeaderMarker[e])return!1;return!0}readIdentificationHeader(e,t){const s=lt.fromBuffer(t.packetData);if(!this.comonHeaderDecode(Vt.IdentificationHeader,s))return!1;if(0!==ht.readUInt32LE(s))return!1;if(e.audioChannels=s.readByte(),e.audioSampleRate=ht.readUInt32LE(s),e.audioChannels<=0||e.audioSampleRate<=0)return!1;e.bitrateMaximum=ht.readInt32LE(s),e.bitrateNominal=ht.readInt32LE(s),e.bitrateMinimum=ht.readInt32LE(s);const i=s.readByte();if(e.blocksize0=1<<(15&i),e.blocksize1=1<<(i>>4),e.blocksize0>e.blocksize1||!Pi.isAllowedBlockSize(e.blocksize0)||!Pi.isAllowedBlockSize(e.blocksize0))return!1;return 0!==s.readByte()}static isAllowedBlockSize(e){switch(e){case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:return!0;default:return!1}}readComments(e){if(null==e)return!1;const t=lt.fromBuffer(e.packetData);if(!this.comonHeaderDecode(Vt.Comment,t))return!1;const s=ht.readUInt32LE(t);t.skip(s);const i=ht.readUInt32LE(t);for(let e=0;e<i;e++){const e=ht.readUInt32LE(t);t.skip(e)}return 0!==t.readByte()}readSetupHeader(e,t,s){if(null==s)return!1;const i=new ti(lt.fromBuffer(s.packetData)),a=new Ni,r=new hi;if(!this.comonHeaderDecodeBit(Vt.SetupHeader,i))return!1;let n=i.readByte()+1;for(let e=0;e<n;e++)t.codebooks.push(new ni(i,r));n=i.readBits(6)+1;for(let e=0;e<n;e++)t.timeDomainTransforms.push(new li(i));n=i.readBits(6)+1;for(let s=0;s<n;s++)t.floors.push(new gi(i,e.blocksize0,e.blocksize1,t.codebooks));n=i.readBits(6)+1;for(let s=0;s<n;s++)t.residues.push(new bi(i,e.audioChannels,t.codebooks));n=i.readBits(6)+1;for(let s=0;s<n;s++)t.mappings.push(new Si(i,e.audioChannels,t.floors,t.residues,a));n=i.readBits(6)+1;for(let s=0;s<n;s++)t.modes.push(new ki(i,e.audioChannels,e.blocksize0,e.blocksize1,t.mappings));return!!i.readBit()}}Pi.VorbisHeaderMarker=new Uint8Array(["v".charCodeAt(0),"o".charCodeAt(0),"r".charCodeAt(0),"b".charCodeAt(0),"i".charCodeAt(0),"s".charCodeAt(0)]);class Fi{constructor(e){this.streams=[];const t=new Qs(e).read(),s=new Pi(t);for(;;){const e=s.read();if(null==e)break;this.streams.push(e)}}}class Ci{constructor(){this.phdrs=[],this.pbags=[],this.pmods=[],this.pgens=[],this.insts=[],this.ibags=[],this.imods=[],this.igens=[],this.sHdrs=[],this.sampleData=new Uint8Array(0),this._sampleCache=new Map}decodeSamples(e,t,s){const i=`${e}_${t}_${s}`;if(!this._sampleCache.has(i)){let a;const r=this.sampleData.slice(e,t);if(s){a=new Fi(lt.fromBuffer(r)).streams[0].samples}else{const e=new DataView(r.buffer,r.byteOffset,r.length);a=new Float32Array(r.length/2);for(let t=0;t<a.length;t++)a[t]=e.getInt16(2*t,!0)/32767}return this._sampleCache.set(i,a),a}return this._sampleCache.get(i)}load(e){const t=new js,s=new js;if(!js.load(null,t,e)||"sfbk"!==t.id)throw new et("Soundfont is not a valid Soundfont2 file");for(;js.load(t,s,e);){const t=new js;if("pdta"===s.id)for(;js.load(s,t,e);)switch(t.id){case"phdr":for(let s=0,i=t.size/Ri.SizeInFile|0;s<i;s++)this.phdrs.push(new Ri(e));break;case"pbag":for(let s=0,i=t.size/Ai.SizeInFile|0;s<i;s++)this.pbags.push(new Ai(e));break;case"pmod":for(let s=0,i=t.size/Oi.SizeInFile|0;s<i;s++)this.pmods.push(new Oi(e));break;case"pgen":for(let s=0,i=t.size/Ii.SizeInFile|0;s<i;s++)this.pgens.push(new Ii(e));break;case"inst":for(let s=0,i=t.size/Li.SizeInFile|0;s<i;s++)this.insts.push(new Li(e));break;case"ibag":for(let s=0,i=t.size/Ei.SizeInFile|0;s<i;s++)this.ibags.push(new Ei(e));break;case"imod":for(let s=0,i=t.size/Di.SizeInFile|0;s<i;s++)this.imods.push(new Di(e));break;case"igen":for(let s=0,i=t.size/Mi.SizeInFile|0;s<i;s++)this.igens.push(new Mi(e));break;case"shdr":for(let s=0,i=t.size/Hi.SizeInFile|0;s<i;s++)this.sHdrs.push(new Hi(e));break;default:e.position+=t.size}else if("sdta"===s.id)for(;js.load(s,t,e);)if("smpl"===t.id)this.sampleData=new Uint8Array(t.size),e.read(this.sampleData,0,t.size);else e.position+=t.size;else e.position+=s.size}}}class Ei{constructor(e){this.instGenNdx=ht.readUInt16LE(e),this.instModNdx=ht.readUInt16LE(e)}}Ei.SizeInFile=4;class Di{constructor(e){this.modSrcOper=ht.readUInt16LE(e),this.modDestOper=ht.readUInt16LE(e),this.modAmount=ht.readInt16LE(e),this.modAmtSrcOper=ht.readUInt16LE(e),this.modTransOper=ht.readUInt16LE(e)}}Di.SizeInFile=10;class Mi{constructor(e){this.genOper=ht.readUInt16LE(e),this.genAmount=new Wi(e)}}Mi.SizeInFile=4;class Li{constructor(e){this.instName=ht.read8BitStringLength(e,20),this.instBagNdx=ht.readUInt16LE(e)}}Li.SizeInFile=22;class Ai{constructor(e){this.genNdx=ht.readUInt16LE(e),this.modNdx=ht.readUInt16LE(e)}}Ai.SizeInFile=4;class Ii{constructor(e){this.genOper=ht.readUInt16LE(e),this.genAmount=new Wi(e)}}Ii.SizeInFile=4,Ii.GenInstrument=41,Ii.GenKeyRange=43,Ii.GenVelRange=44,Ii.GenSampleId=53;class Ri{constructor(e){this.presetName=ht.read8BitStringLength(e,20),this.preset=ht.readUInt16LE(e),this.bank=ht.readUInt16LE(e),this.presetBagNdx=ht.readUInt16LE(e),this.library=ht.readUInt32LE(e),this.genre=ht.readUInt32LE(e),this.morphology=ht.readUInt32LE(e)}}Ri.SizeInFile=38;class Oi{constructor(e){this.modSrcOper=ht.readUInt16LE(e),this.modDestOper=ht.readUInt16LE(e),this.modAmount=ht.readUInt16LE(e),this.modAmtSrcOper=ht.readUInt16LE(e),this.modTransOper=ht.readUInt16LE(e)}}Oi.SizeInFile=10;class Hi{constructor(e){this.sampleName=ht.read8BitStringLength(e,20),this.start=ht.readUInt32LE(e),this.end=ht.readUInt32LE(e),this.startLoop=ht.readUInt32LE(e),this.endLoop=ht.readUInt32LE(e),this.sampleRate=ht.readUInt32LE(e),this.originalPitch=e.readByte(),this.pitchCorrection=ht.readSInt8(e),this.sampleLink=ht.readUInt16LE(e),this.sampleType=ht.readUInt16LE(e)}}Hi.SizeInFile=46;class Wi{get shortAmount(){return ot.uint16ToInt16(this.wordAmount)}get lowByteAmount(){return 255&this.wordAmount}get highByteAmount(){return(65280&this.wordAmount)>>8&255}constructor(e){this.wordAmount=ht.readUInt16LE(e)}}class Vi{constructor(){this.presetIndex=0,this.bank=0,this.pitchWheel=0,this.perNotePitchWheel=new Map,this.midiPan=0,this.midiVolume=0,this.midiExpression=0,this.midiRpn=0,this.midiData=0,this.panOffset=0,this.gainDb=0,this.pitchRange=0,this.tuning=0,this.mixVolume=0,this.mute=!1,this.solo=!1}}class Gi{constructor(){this.activeChannel=0,this.channelList=[]}setupVoice(e,t){const s=this.channelList[this.activeChannel],i=t.region.pan+s.panOffset;t.playingChannel=this.activeChannel,t.mixVolume=s.mixVolume,t.noteGainDb+=s.gainDb,t.updatePitchRatio(s,e.outSampleRate),i<=-.5?(t.panFactorLeft=1,t.panFactorRight=0):i>=.5?(t.panFactorLeft=0,t.panFactorRight=1):(t.panFactorLeft=Math.sqrt(.5-i),t.panFactorRight=Math.sqrt(.5+i))}}!function(e){e[e.None=0]="None",e[e.Continuous=1]="Continuous",e[e.Sustain=2]="Sustain"}(Gt||(Gt={})),function(e){e[e.StereoInterleaved=0]="StereoInterleaved",e[e.StereoUnweaved=1]="StereoUnweaved",e[e.Mono=2]="Mono"}(zt||(zt={}));class zi{constructor(){this.name="",this.presetNumber=0,this.bank=0,this.regions=null}}class Ui{static timecents2Secs(e){return Math.pow(2,e/1200)}static decibelsToGain(e){return e>-100?Math.pow(10,.05*e):0}static gainToDecibels(e){return e<=1e-5?-100:20*Math.log10(e)}static cents2Hertz(e){return 8.176*Math.pow(2,e/1200)}}class Xi{constructor(e){this.delay=0,this.attack=0,this.hold=0,this.decay=0,this.sustain=0,this.release=0,this.keynumToHold=0,this.keynumToDecay=0,e&&(this.delay=e.delay,this.attack=e.attack,this.hold=e.hold,this.decay=e.decay,this.sustain=e.sustain,this.release=e.release,this.keynumToHold=e.keynumToHold,this.keynumToDecay=e.keynumToDecay)}clear(){this.delay=0,this.attack=0,this.hold=0,this.decay=0,this.sustain=0,this.release=0,this.keynumToHold=0,this.keynumToDecay=0}envToSecs(e){this.delay=this.delay<-11950?0:Ui.timecents2Secs(this.delay),this.attack=this.attack<-11950?0:Ui.timecents2Secs(this.attack),this.release=this.release<-11950?0:Ui.timecents2Secs(this.release),0===this.keynumToHold&&(this.hold=this.hold<-11950?0:Ui.timecents2Secs(this.hold)),0===this.keynumToDecay&&(this.decay=this.decay<-11950?0:Ui.timecents2Secs(this.decay)),this.sustain<0?this.sustain=0:this.sustain=e?Ui.decibelsToGain(-this.sustain/10):1-this.sustain/1e3}}!function(e){e[e.StartAddrsOffset=0]="StartAddrsOffset",e[e.EndAddrsOffset=1]="EndAddrsOffset",e[e.StartloopAddrsOffset=2]="StartloopAddrsOffset",e[e.EndloopAddrsOffset=3]="EndloopAddrsOffset",e[e.StartAddrsCoarseOffset=4]="StartAddrsCoarseOffset",e[e.ModLfoToPitch=5]="ModLfoToPitch",e[e.VibLfoToPitch=6]="VibLfoToPitch",e[e.ModEnvToPitch=7]="ModEnvToPitch",e[e.InitialFilterFc=8]="InitialFilterFc",e[e.InitialFilterQ=9]="InitialFilterQ",e[e.ModLfoToFilterFc=10]="ModLfoToFilterFc",e[e.ModEnvToFilterFc=11]="ModEnvToFilterFc",e[e.EndAddrsCoarseOffset=12]="EndAddrsCoarseOffset",e[e.ModLfoToVolume=13]="ModLfoToVolume",e[e.Unused1=14]="Unused1",e[e.ChorusEffectsSend=15]="ChorusEffectsSend",e[e.ReverbEffectsSend=16]="ReverbEffectsSend",e[e.Pan=17]="Pan",e[e.Unused2=18]="Unused2",e[e.Unused3=19]="Unused3",e[e.Unused4=20]="Unused4",e[e.DelayModLFO=21]="DelayModLFO",e[e.FreqModLFO=22]="FreqModLFO",e[e.DelayVibLFO=23]="DelayVibLFO",e[e.FreqVibLFO=24]="FreqVibLFO",e[e.DelayModEnv=25]="DelayModEnv",e[e.AttackModEnv=26]="AttackModEnv",e[e.HoldModEnv=27]="HoldModEnv",e[e.DecayModEnv=28]="DecayModEnv",e[e.SustainModEnv=29]="SustainModEnv",e[e.ReleaseModEnv=30]="ReleaseModEnv",e[e.KeynumToModEnvHold=31]="KeynumToModEnvHold",e[e.KeynumToModEnvDecay=32]="KeynumToModEnvDecay",e[e.DelayVolEnv=33]="DelayVolEnv",e[e.AttackVolEnv=34]="AttackVolEnv",e[e.HoldVolEnv=35]="HoldVolEnv",e[e.DecayVolEnv=36]="DecayVolEnv",e[e.SustainVolEnv=37]="SustainVolEnv",e[e.ReleaseVolEnv=38]="ReleaseVolEnv",e[e.KeynumToVolEnvHold=39]="KeynumToVolEnvHold",e[e.KeynumToVolEnvDecay=40]="KeynumToVolEnvDecay",e[e.Instrument=41]="Instrument",e[e.Reserved1=42]="Reserved1",e[e.KeyRange=43]="KeyRange",e[e.VelRange=44]="VelRange",e[e.StartloopAddrsCoarseOffset=45]="StartloopAddrsCoarseOffset",e[e.Keynum=46]="Keynum",e[e.Velocity=47]="Velocity",e[e.InitialAttenuation=48]="InitialAttenuation",e[e.Reserved2=49]="Reserved2",e[e.EndloopAddrsCoarseOffset=50]="EndloopAddrsCoarseOffset",e[e.CoarseTune=51]="CoarseTune",e[e.FineTune=52]="FineTune",e[e.SampleID=53]="SampleID",e[e.SampleModes=54]="SampleModes",e[e.Reserved3=55]="Reserved3",e[e.ScaleTuning=56]="ScaleTuning",e[e.ExclusiveClass=57]="ExclusiveClass",e[e.OverridingRootKey=58]="OverridingRootKey",e[e.Unused5=59]="Unused5",e[e.EndOper=60]="EndOper"}(Ut||(Ut={}));class Ji{constructor(e){this.loopMode=Gt.None,this.samples=Ji.NoSamples,this.sampleRate=0,this.loKey=0,this.hiKey=0,this.loVel=0,this.hiVel=0,this.group=0,this.offset=0,this.end=0,this.loopStart=0,this.loopEnd=0,this.transpose=0,this.tune=0,this.pitchKeyCenter=0,this.pitchKeyTrack=0,this.attenuation=0,this.pan=0,this.ampEnv=new Xi,this.modEnv=new Xi,this.initialFilterQ=0,this.initialFilterFc=0,this.modEnvToPitch=0,this.modEnvToFilterFc=0,this.modLfoToFilterFc=0,this.modLfoToVolume=0,this.delayModLFO=0,this.freqModLFO=0,this.modLfoToPitch=0,this.delayVibLFO=0,this.freqVibLFO=0,this.vibLfoToPitch=0,e&&(this.loopMode=e.loopMode,this.samples=e.samples,this.sampleRate=e.sampleRate,this.loKey=e.loKey,this.hiKey=e.hiKey,this.loVel=e.loVel,this.hiVel=e.hiVel,this.group=e.group,this.offset=e.offset,this.end=e.end,this.loopStart=e.loopStart,this.loopEnd=e.loopEnd,this.transpose=e.transpose,this.tune=e.tune,this.pitchKeyCenter=e.pitchKeyCenter,this.pitchKeyTrack=e.pitchKeyTrack,this.attenuation=e.attenuation,this.pan=e.pan,this.ampEnv=new Xi(e.ampEnv),this.modEnv=new Xi(e.modEnv),this.initialFilterQ=e.initialFilterQ,this.initialFilterFc=e.initialFilterFc,this.modEnvToPitch=e.modEnvToPitch,this.modEnvToFilterFc=e.modEnvToFilterFc,this.modLfoToFilterFc=e.modLfoToFilterFc,this.modLfoToVolume=e.modLfoToVolume,this.delayModLFO=e.delayModLFO,this.freqModLFO=e.freqModLFO,this.modLfoToPitch=e.modLfoToPitch,this.delayVibLFO=e.delayVibLFO,this.freqVibLFO=e.freqVibLFO,this.vibLfoToPitch=e.vibLfoToPitch)}clear(e){this.loopMode=Gt.None,this.samples=Ji.NoSamples,this.sampleRate=0,this.loKey=0,this.hiKey=0,this.loVel=0,this.hiVel=0,this.group=0,this.offset=0,this.end=0,this.loopStart=0,this.loopEnd=0,this.transpose=0,this.tune=0,this.pitchKeyCenter=0,this.pitchKeyTrack=0,this.attenuation=0,this.pan=0,this.ampEnv.clear(),this.modEnv.clear(),this.initialFilterQ=0,this.initialFilterFc=0,this.modEnvToPitch=0,this.modEnvToFilterFc=0,this.modLfoToFilterFc=0,this.modLfoToVolume=0,this.delayModLFO=0,this.freqModLFO=0,this.modLfoToPitch=0,this.delayVibLFO=0,this.freqVibLFO=0,this.vibLfoToPitch=0,this.hiKey=127,this.hiVel=127,this.pitchKeyCenter=60,e||(this.pitchKeyTrack=100,this.pitchKeyCenter=-1,this.ampEnv.delay=-12e3,this.ampEnv.attack=-12e3,this.ampEnv.hold=-12e3,this.ampEnv.decay=-12e3,this.ampEnv.release=-12e3,this.modEnv.delay=-12e3,this.modEnv.attack=-12e3,this.modEnv.hold=-12e3,this.modEnv.decay=-12e3,this.modEnv.release=-12e3,this.initialFilterFc=13500,this.delayModLFO=-12e3,this.delayVibLFO=-12e3)}operator(e,t){switch(e){case Ut.StartAddrsOffset:this.offset+=ot.int16ToUint32(t.shortAmount);break;case Ut.EndAddrsOffset:this.end+=ot.int16ToUint32(t.shortAmount);break;case Ut.StartloopAddrsOffset:this.loopStart+=ot.int16ToUint32(t.shortAmount);break;case Ut.EndloopAddrsOffset:this.loopEnd+=ot.int16ToUint32(t.shortAmount);break;case Ut.StartAddrsCoarseOffset:this.offset+=32768*ot.int16ToUint32(t.shortAmount);break;case Ut.ModLfoToPitch:this.modLfoToPitch=t.shortAmount;break;case Ut.VibLfoToPitch:this.vibLfoToPitch=t.shortAmount;break;case Ut.ModEnvToPitch:this.modEnvToPitch=t.shortAmount;break;case Ut.InitialFilterFc:this.initialFilterFc=t.shortAmount;break;case Ut.InitialFilterQ:this.initialFilterQ=t.shortAmount;break;case Ut.ModLfoToFilterFc:this.modLfoToFilterFc=t.shortAmount;break;case Ut.ModEnvToFilterFc:this.modEnvToFilterFc=t.shortAmount;break;case Ut.EndAddrsCoarseOffset:this.end+=32768*ot.int16ToUint32(t.shortAmount);break;case Ut.ModLfoToVolume:this.modLfoToVolume=t.shortAmount;break;case Ut.Pan:this.pan=t.shortAmount/1e3;break;case Ut.DelayModLFO:this.delayModLFO=t.shortAmount;break;case Ut.FreqModLFO:this.freqModLFO=t.shortAmount;break;case Ut.DelayVibLFO:this.delayVibLFO=t.shortAmount;break;case Ut.FreqVibLFO:this.freqVibLFO=t.shortAmount;break;case Ut.DelayModEnv:this.modEnv.delay=t.shortAmount;break;case Ut.AttackModEnv:this.modEnv.attack=t.shortAmount;break;case Ut.HoldModEnv:this.modEnv.hold=t.shortAmount;break;case Ut.DecayModEnv:this.modEnv.decay=t.shortAmount;break;case Ut.SustainModEnv:this.modEnv.sustain=t.shortAmount;break;case Ut.ReleaseModEnv:this.modEnv.release=t.shortAmount;break;case Ut.KeynumToModEnvHold:this.modEnv.keynumToHold=t.shortAmount;break;case Ut.KeynumToModEnvDecay:this.modEnv.keynumToDecay=t.shortAmount;break;case Ut.DelayVolEnv:this.ampEnv.delay=t.shortAmount;break;case Ut.AttackVolEnv:this.ampEnv.attack=t.shortAmount;break;case Ut.HoldVolEnv:this.ampEnv.hold=t.shortAmount;break;case Ut.DecayVolEnv:this.ampEnv.decay=t.shortAmount;break;case Ut.SustainVolEnv:this.ampEnv.sustain=t.shortAmount;break;case Ut.ReleaseVolEnv:this.ampEnv.release=t.shortAmount;break;case Ut.KeynumToVolEnvHold:this.ampEnv.keynumToHold=t.shortAmount;break;case Ut.KeynumToVolEnvDecay:this.ampEnv.keynumToDecay=t.shortAmount;break;case Ut.KeyRange:this.loKey=t.lowByteAmount,this.hiKey=t.highByteAmount;break;case Ut.VelRange:this.loVel=t.lowByteAmount,this.hiVel=t.highByteAmount;break;case Ut.StartloopAddrsCoarseOffset:this.loopStart+=32768*ot.int16ToUint32(t.shortAmount);break;case Ut.InitialAttenuation:this.attenuation+=.1*t.shortAmount;break;case Ut.EndloopAddrsCoarseOffset:this.loopEnd+=32768*ot.int16ToUint32(t.shortAmount);break;case Ut.CoarseTune:this.transpose+=t.shortAmount;break;case Ut.FineTune:this.tune+=t.shortAmount;break;case Ut.SampleModes:this.loopMode=3&~t.wordAmount?1==(3&t.wordAmount)?Gt.Continuous:Gt.None:Gt.Sustain;break;case Ut.ScaleTuning:this.pitchKeyTrack=t.shortAmount;break;case Ut.ExclusiveClass:this.group=t.wordAmount;break;case Ut.OverridingRootKey:this.pitchKeyCenter=t.shortAmount}}}Ji.NoSamples=new Float32Array(0),function(e){e[e.None=0]="None",e[e.Delay=1]="Delay",e[e.Attack=2]="Attack",e[e.Hold=3]="Hold",e[e.Decay=4]="Decay",e[e.Sustain=5]="Sustain",e[e.Release=6]="Release",e[e.Done=7]="Done"}(Xt||(Xt={}));class Yi{constructor(){this.level=0,this.slope=0,this.samplesUntilNextSegment=0,this.segment=Xt.None,this.midiVelocity=0,this.parameters=null,this.segmentIsExponential=!1,this.isAmpEnv=!1}nextSegment(e,t){if(this.parameters)for(;;)switch(e){case Xt.None:if(this.samplesUntilNextSegment=this.parameters.delay*t|0,this.samplesUntilNextSegment>0)return this.segment=Xt.Delay,this.segmentIsExponential=!1,this.level=0,void(this.slope=0);e=Xt.Delay;break;case Xt.Delay:if(this.samplesUntilNextSegment=this.parameters.attack*t|0,this.samplesUntilNextSegment>0)return this.isAmpEnv||(this.samplesUntilNextSegment=this.parameters.attack*((145-this.midiVelocity)/144)*t|0),this.segment=Xt.Attack,this.segmentIsExponential=!1,this.level=0,void(this.slope=1/this.samplesUntilNextSegment);e=Xt.Attack;break;case Xt.Attack:if(this.samplesUntilNextSegment=this.parameters.hold*t|0,this.samplesUntilNextSegment>0)return this.segment=Xt.Hold,this.segmentIsExponential=!1,this.level=1,void(this.slope=0);e=Xt.Hold;break;case Xt.Hold:if(this.samplesUntilNextSegment=this.parameters.decay*t|0,this.samplesUntilNextSegment>0){if(this.segment=Xt.Decay,this.level=1,this.isAmpEnv){const e=-9.226/this.samplesUntilNextSegment;this.slope=Math.exp(e),this.segmentIsExponential=!0,this.parameters.sustain>0&&(this.samplesUntilNextSegment=Math.log(this.parameters.sustain)/e|0)}else this.slope=-1/this.samplesUntilNextSegment,this.samplesUntilNextSegment=this.parameters.decay*(1-this.parameters.sustain)*t|0,this.segmentIsExponential=!1;return}e=Xt.Decay;break;case Xt.Decay:return this.segment=Xt.Sustain,this.level=this.parameters.sustain,this.slope=0,this.samplesUntilNextSegment=2147483647,void(this.segmentIsExponential=!1);case Xt.Sustain:if(this.segment=Xt.Release,this.samplesUntilNextSegment=(this.parameters.release<=0?Yi.FastReleaseTime:this.parameters.release)*t|0,this.isAmpEnv){const e=-9.226/this.samplesUntilNextSegment;this.slope=Math.exp(e),this.segmentIsExponential=!0}else this.slope=-this.level/this.samplesUntilNextSegment,this.segmentIsExponential=!1;return;default:return this.segment=Xt.Done,this.segmentIsExponential=!1,this.level=0,this.slope=0,void(this.samplesUntilNextSegment=134217727)}}setup(e,t,s,i,a){this.parameters=new Xi(e),this.parameters.keynumToHold>0&&(this.parameters.hold+=this.parameters.keynumToHold*(60-t),this.parameters.hold=this.parameters.hold<-1e4?0:Ui.timecents2Secs(this.parameters.hold)),this.parameters.keynumToDecay>0&&(this.parameters.decay+=this.parameters.keynumToDecay*(60-t),this.parameters.decay=this.parameters.decay<-1e4?0:Ui.timecents2Secs(this.parameters.decay)),this.midiVelocity=0|s,this.isAmpEnv=i,this.nextSegment(Xt.None,a)}process(e,t){this.slope>0&&(this.segmentIsExponential?this.level*=Math.pow(this.slope,e):this.level+=this.slope*e),this.samplesUntilNextSegment-=e,this.samplesUntilNextSegment<=0&&this.nextSegment(this.segment,t)}}Yi.FastReleaseTime=.01;class $i{constructor(){this.samplesUntil=0,this.level=0,this.delta=0}setup(e,t,s){this.samplesUntil=e*s|0,this.delta=4*Ui.cents2Hertz(t)/s,this.level=0}process(e){this.samplesUntil>e?this.samplesUntil-=e:(this.level+=this.delta*e,this.level>1?(this.delta=-this.delta,this.level=2-this.level):this.level<-1&&(this.delta=-this.delta,this.level=-2-this.level))}}class qi{constructor(e){this.qInv=0,this.a0=0,this.a1=0,this.b1=0,this.b2=0,this.z1=0,this.z2=0,this.active=!1,e&&(this.qInv=e.qInv,this.a0=e.a0,this.a1=e.a1,this.b1=e.b1,this.b2=e.b2,this.z1=e.z1,this.z2=e.z2,this.active=e.active)}setup(e){const t=Math.tan(Math.PI*e),s=t*t,i=1/(1+t*this.qInv+s);this.a0=s*i,this.a1=2*this.a0,this.b1=2*(s-1)*i,this.b2=(1-t*this.qInv+s)*i}process(e){const t=e*this.a0+this.z1;return this.z1=e*this.a1+this.z2-this.b1*t,this.z2=e*this.a0-this.b2*t,t}}class ji{constructor(){this.playingPreset=0,this.playingKey=0,this.playingChannel=0,this.region=null,this.pitchInputTimecents=0,this.pitchOutputFactor=0,this.sourceSamplePosition=0,this.noteGainDb=0,this.panFactorLeft=0,this.panFactorRight=0,this.playIndex=0,this.loopStart=0,this.loopEnd=0,this.ampEnv=new Yi,this.modEnv=new Yi,this.lowPass=new qi,this.modLfo=new $i,this.vibLfo=new $i,this.mixVolume=0,this.mute=!1}updatePitchRatio(e,t){let s=e.pitchWheel;e.perNotePitchWheel.has(this.playingKey)&&(s+=e.perNotePitchWheel.get(this.playingKey)-8192);const i=8192===s?e.tuning:s/16383*e.pitchRange*2-e.pitchRange+e.tuning;this.calcPitchRatio(i,t)}calcPitchRatio(e,t){if(!this.region)return;const s=this.playingKey+this.region.transpose+this.region.tune/100;let i=this.region.pitchKeyCenter+(s-this.region.pitchKeyCenter)*(this.region.pitchKeyTrack/100);0!==e&&(i+=e),this.pitchInputTimecents=100*i,this.pitchOutputFactor=this.region.sampleRate/(Ui.timecents2Secs(100*this.region.pitchKeyCenter)*t)}end(e){this.region&&(this.ampEnv.nextSegment(Xt.Sustain,e),this.modEnv.nextSegment(Xt.Sustain,e),this.region.loopMode===Gt.Sustain&&(this.loopEnd=this.loopStart))}endQuick(e){this.ampEnv.parameters.release=0,this.ampEnv.nextSegment(Xt.Sustain,e),this.modEnv.parameters.release=0,this.modEnv.nextSegment(Xt.Sustain,e)}render(e,t,s,i,a){if(!this.region)return;const r=this.region,n=r.samples;let o=0,h=e.outputMode===zt.StereoUnweaved?i:-1;const l=0!==r.modEnvToPitch||0!==r.modEnvToFilterFc,c=this.modLfo.delta>0&&(0!==r.modLfoToPitch||0!==r.modLfoToFilterFc||0!==r.modLfoToVolume),d=this.vibLfo.delta>0&&0!==r.vibLfoToPitch,u=this.loopStart<this.loopEnd,p=this.loopStart,g=this.loopEnd,m=r.end,f=g+1;let y=this.sourceSamplePosition;const b=new qi(this.lowPass),S=0!==r.modLfoToFilterFc||0!==r.modEnvToFilterFc;let _=0,w=0,B=0,k=0;const T=0!==r.modLfoToPitch||0!==r.modEnvToPitch||0!==r.vibLfoToPitch;let N=0,x=0,v=0,P=0;const F=0!==r.modLfoToVolume;let C=0,E=0;for(S?(_=e.outSampleRate,w=r.initialFilterFc,B=r.modLfoToFilterFc,k=r.modEnvToFilterFc):(_=0,w=0,B=0,k=0),T?(N=0,x=r.modLfoToPitch,v=r.vibLfoToPitch,P=r.modEnvToPitch):(N=Ui.timecents2Secs(this.pitchInputTimecents)*this.pitchOutputFactor,x=0,v=0,P=0),F?E=.1*r.modLfoToVolume:(C=Ui.decibelsToGain(this.noteGainDb),E=0);i>0;){let r,D,M=0,L=i>ji.RenderEffectSampleBlock?ji.RenderEffectSampleBlock:i;if(i-=L,S){const e=w+this.modLfo.level*B+this.modEnv.level*k;b.active=e<=13500,b.active&&b.setup(Ui.cents2Hertz(e)/_)}switch(T&&(N=Ui.timecents2Secs(this.pitchInputTimecents+(this.modLfo.level*x+this.vibLfo.level*v+this.modEnv.level*P))*this.pitchOutputFactor),F&&(C=Ui.decibelsToGain(this.noteGainDb+this.modLfo.level*E)),r=C*this.ampEnv.level,a?r=0:r*=this.mixVolume,this.ampEnv.process(L,e.outSampleRate),l&&this.modEnv.process(L,e.outSampleRate),c&&this.modLfo.process(L),d&&this.vibLfo.process(L),e.outputMode){case zt.StereoInterleaved:for(D=r*this.panFactorLeft,M=r*this.panFactorRight;L-- >0&&y<m;){const e=0|y,i=e>=g&&u?p:e+1,a=y-e;let r=n[e]*(1-a)+n[i]*a;b.active&&(r=b.process(r)),t[s+o]+=r*D,o++,t[s+o]+=r*M,o++,y+=N,y>=f&&u&&(y-=g-p+1)}break;case zt.StereoUnweaved:for(D=r*this.panFactorLeft,M=r*this.panFactorRight;L-- >0&&y<m;){const e=0|y,i=e>=g&&u?p:e+1,a=y-e;let r=n[e]*(1-a)+n[i]*a;b.active&&(r=b.process(r)),t[s+o]+=r*D,o++,t[s+h]+=r*M,h++,y+=N,y>=f&&u&&(y-=g-p+1)}break;case zt.Mono:for(;L-- >0&&y<m;){const e=0|y,i=e>=g&&u?p:e+1,a=y-e;let h=n[e]*(1-a)+n[i]*a;b.active&&(h=b.process(h)),t[s+o]=h*r,o++,y+=N,y>=f&&u&&(y-=g-p+1)}}if(y>=m||this.ampEnv.segment===Xt.Done)return void this.kill()}this.sourceSamplePosition=y,(b.active||S)&&(this.lowPass=b)}kill(){this.playingPreset=-1}}ji.RenderEffectSampleBlock=Q.MicroBufferSize;class Ki{constructor(){this._items=[],this._position=0,this.isEmpty=!0}clear(){this._items=[],this._position=0,this.isEmpty=!0}enqueue(e){this.isEmpty=!1,this._items.push(e)}peek(){return this._items[this._position]}dequeue(){const e=this._items[this._position];return this._position++,this._position>=this._items.length/2&&(this._items=this._items.slice(this._position),this._position=0),this.isEmpty=0===this._items.length,e}toArray(){const e=this._items.slice(this._position);return e.reverse(),e}}!function(e){e[e.BankSelectCoarse=0]="BankSelectCoarse",e[e.ModulationCoarse=1]="ModulationCoarse",e[e.DataEntryCoarse=6]="DataEntryCoarse",e[e.VolumeCoarse=7]="VolumeCoarse",e[e.PanCoarse=10]="PanCoarse",e[e.ExpressionControllerCoarse=11]="ExpressionControllerCoarse",e[e.BankSelectFine=32]="BankSelectFine",e[e.ModulationFine=33]="ModulationFine",e[e.DataEntryFine=38]="DataEntryFine",e[e.VolumeFine=39]="VolumeFine",e[e.PanFine=42]="PanFine",e[e.ExpressionControllerFine=43]="ExpressionControllerFine",e[e.HoldPedal=64]="HoldPedal",e[e.LegatoPedal=68]="LegatoPedal",e[e.NonRegisteredParameterFine=98]="NonRegisteredParameterFine",e[e.NonRegisteredParameterCourse=99]="NonRegisteredParameterCourse",e[e.RegisteredParameterFine=100]="RegisteredParameterFine",e[e.RegisteredParameterCourse=101]="RegisteredParameterCourse",e[e.AllSoundOff=120]="AllSoundOff",e[e.ResetControllers=121]="ResetControllers",e[e.AllNotesOff=123]="AllNotesOff"}(Jt||(Jt={}));class Qi{constructor(e){this._midiEventQueue=new Ki,this._mutedChannels=new Map,this._soloChannels=new Map,this._isAnySolo=!1,this._transpositionPitches=new Map,this._liveTranspositionPitches=new Map,this.currentTempo=0,this.timeSignatureNumerator=0,this.timeSignatureDenominator=0,this.presets=null,this._voices=[],this._channels=null,this._voicePlayIndex=0,this.outputMode=zt.StereoInterleaved,this.outSampleRate=0,this.globalGainDb=0,this.outSampleRate=e}synthesize(e,t,s){return this.fillWorkingBuffer(e,t,s)}synthesizeSilent(e){this.fillWorkingBuffer(null,0,e)}channelGetMixVolume(e){return this._channels&&e<this._channels.channelList.length?this._channels.channelList[e].mixVolume:1}channelSetMixVolume(e,t){const s=this.channelInit(e);for(const s of this._voices)s.playingChannel===e&&-1!==s.playingPreset&&(s.mixVolume=t);s.mixVolume=t}channelSetMute(e,t){t?this._mutedChannels.set(e,!0):this._mutedChannels.delete(e)}channelSetSolo(e,t){t?this._soloChannels.set(e,!0):this._soloChannels.delete(e),this._isAnySolo=this._soloChannels.size>0}resetChannelStates(){this._mutedChannels=new Map,this._soloChannels=new Map,this._liveTranspositionPitches=new Map,this.applyTranspositionPitches(new Map),this._isAnySolo=!1}setChannelTranspositionPitch(e,t){let s=0;this._liveTranspositionPitches.has(e)&&(s=this._liveTranspositionPitches.get(e)),0===t?this._liveTranspositionPitches.delete(e):this._liveTranspositionPitches.set(e,t);for(const i of this._voices)if(i.playingChannel===e&&9!==i.playingChannel){let e=0;e-=s,e+=t,i.playingKey+=e,this._channels&&i.updatePitchRatio(this._channels.channelList[i.playingChannel],this.outSampleRate)}}applyTranspositionPitches(e){const t=this._transpositionPitches;for(const s of this._voices)if(s.playingChannel>=0&&9!==s.playingChannel){let i=0;t.has(s.playingChannel)&&(i-=t.get(s.playingChannel)),e.has(s.playingChannel)&&(i+=e.get(s.playingChannel)),s.playingKey+=i,this._channels&&s.updatePitchRatio(this._channels.channelList[s.playingChannel],this.outSampleRate)}this._transpositionPitches=e}dispatchEvent(e){this._midiEventQueue.enqueue(e)}fillWorkingBuffer(e,t,s){const i=this._isAnySolo,a=[];for(;!this._midiEventQueue.isEmpty;){const e=this._midiEventQueue.dequeue();e.isMetronome&&this.metronomeVolume>0?(this.channelNoteOff(Q.MetronomeChannel,Q.MetronomeKey),this.channelNoteOn(Q.MetronomeChannel,Q.MetronomeKey,95/127)):e.event&&this.processMidiMessage(e.event),a.push(e)}for(const a of this._voices)if(-1!==a.playingPreset){const r=a.playingChannel,n=this._mutedChannels.has(r)||i&&r!==Q.MetronomeChannel&&!this._soloChannels.has(r);e?a.render(this,e,t,s,n):a.kill()}return a}processMidiMessage(e){j.debug("Midi",`Processing Midi message ${Ot[e.type]}/${e.tick}`);switch(e.type){case Ot.TimeSignature:const t=e;this.timeSignatureNumerator=t.numerator,this.timeSignatureDenominator=Math.pow(2,t.denominatorIndex);break;case Ot.NoteOn:const s=e;this.channelNoteOn(s.channel,s.noteKey,s.noteVelocity/127);break;case Ot.NoteOff:const i=e;this.channelNoteOff(i.channel,i.noteKey);break;case Ot.ControlChange:const a=e;this.channelMidiControl(a.channel,a.controller,a.value);break;case Ot.ProgramChange:const r=e;this.channelSetPresetNumber(r.channel,r.program,9===r.channel);break;case Ot.TempoChange:const n=e;this.currentTempo=6e7/n.microSecondsPerQuarterNote;break;case Ot.PitchBend:const o=e;this.channelSetPitchWheel(o.channel,o.value);break;case Ot.PerNotePitchBend:const h=e;let l=h.value;l=l*Q.MaxPitchWheel/Q.MaxPitchWheel20,this.channelSetPerNotePitchWheel(h.channel,h.noteKey,l)}}get metronomeVolume(){return this.channelGetMixVolume(Q.MetronomeChannel)}set metronomeVolume(e){this.setupMetronomeChannel(e)}setupMetronomeChannel(e){this.channelSetMixVolume(Q.MetronomeChannel,e),e>0&&(this.channelSetVolume(Q.MetronomeChannel,1),this.channelSetPresetNumber(Q.MetronomeChannel,0,!0))}get masterVolume(){return Ui.decibelsToGain(this.globalGainDb)}set masterVolume(e){const t=Ui.gainToDecibels(e),s=t-this.globalGainDb;if(0!==s){for(const e of this._voices)-1!==e.playingPreset&&(e.noteGainDb+=s);this.globalGainDb=t}}resetSoft(){for(const e of this._voices)-1!==e.playingPreset&&(e.ampEnv.segment<Xt.Release||0!==e.ampEnv.parameters.release)&&e.endQuick(this.outSampleRate);if(this._channels)for(const e of this._channels.channelList)e.presetIndex=0,e.bank=0,e.pitchWheel=8192,e.midiPan=8192,e.perNotePitchWheel.clear(),e.midiVolume=16383,e.midiExpression=16383,e.midiRpn=65535,e.midiData=0,e.panOffset=0,e.gainDb=0,e.pitchRange=2,e.tuning=0}get presetCount(){return this.presets?.length??0}reset(){for(const e of this._voices)-1!==e.playingPreset&&(e.ampEnv.segment<Xt.Release||0!==e.ampEnv.parameters.release)&&e.endQuick(this.outSampleRate);this._channels=null}setOutput(e,t,s){this.outputMode=e,this.outSampleRate=t>=1?t:44100,this.globalGainDb=s}noteOn(e,t,s){if(!this.presets)return;const i=127*s|0;if(e<0||e>=this.presets.length)return;if(s<=0)return void this.noteOff(e,t);const a=this._voicePlayIndex++;for(const r of this.presets[e].regions){if(t<r.loKey||t>r.hiKey||i<r.loVel||i>r.hiVel)continue;let n=null;if(0!==r.group)for(const t of this._voices)t.playingPreset===e&&t.region.group===r.group?t.endQuick(this.outSampleRate):-1!==t.playingPreset||n||(n=t);else for(const e of this._voices)-1===e.playingPreset&&(n=e);if(!n){for(let e=0;e<4;e++){const e=new ji;e.playingPreset=-1,this._voices.push(e)}n=this._voices[this._voices.length-4]}n.region=r,n.playingPreset=e,n.playingKey=t,n.playIndex=a,n.noteGainDb=this.globalGainDb-r.attenuation-Ui.gainToDecibels(1/s),this._channels?this._channels.setupVoice(this,n):(n.calcPitchRatio(0,this.outSampleRate),n.panFactorLeft=Math.sqrt(.5-r.pan),n.panFactorRight=Math.sqrt(.5+r.pan)),n.sourceSamplePosition=r.offset;const o=r.loopMode!==Gt.None&&r.loopStart<r.loopEnd;n.loopStart=o?r.loopStart:0,n.loopEnd=o?r.loopEnd:0,n.ampEnv.setup(r.ampEnv,t,i,!0,this.outSampleRate),n.modEnv.setup(r.modEnv,t,i,!1,this.outSampleRate);const h=r.initialFilterQ/10;n.lowPass.qInv=1/Math.pow(10,h/20),n.lowPass.z1=0,n.lowPass.z2=0,n.lowPass.active=r.initialFilterFc<=13500,n.lowPass.active&&n.lowPass.setup(Ui.cents2Hertz(r.initialFilterFc)/this.outSampleRate),n.modLfo.setup(r.delayModLFO,r.freqModLFO,this.outSampleRate),n.vibLfo.setup(r.delayVibLFO,r.freqVibLFO,this.outSampleRate)}}bankNoteOn(e,t,s,i){const a=this.getPresetIndex(e,t);return-1!==a&&(this.noteOn(a,s,i),!0)}noteOff(e,t){let s=null,i=null;const a=[];for(const r of this._voices)r.playingPreset!==e||r.playingKey!==t||r.ampEnv.segment>=Xt.Release||(!s||r.playIndex<s.playIndex?(s=r,i=r,a.push(r)):r.playIndex===s.playIndex&&(i=r,a.push(r)));if(s)for(const r of a)r!==s&&r!==i&&(r.playIndex!==s.playIndex||r.playingPreset!==e||r.playingKey!==t||r.ampEnv.segment>=Xt.Release)||r.end(this.outSampleRate)}bankNoteOff(e,t,s){const i=this.getPresetIndex(e,t);return-1!==i&&(this.noteOff(i,s),!0)}noteOffAll(e){for(const t of this._voices)-1!==t.playingPreset&&(e?t.endQuick(this.outSampleRate):t.ampEnv.segment<Xt.Release&&t.end(this.outSampleRate))}get activeVoiceCount(){let e=0;for(const t of this._voices)-1!==t.playingPreset&&e++;return e}channelInit(e){if(this._channels&&e<this._channels.channelList.length)return this._channels.channelList[e];this._channels||(this._channels=new Gi);for(let t=this._channels.channelList.length;t<=e;t++){const e=new Vi;e.presetIndex=0,e.bank=0,e.pitchWheel=8192,e.midiPan=8192,e.midiVolume=16383,e.midiExpression=16383,e.midiRpn=65535,e.midiData=0,e.panOffset=0,e.gainDb=0,e.pitchRange=2,e.tuning=0,e.mixVolume=1,this._channels.channelList.push(e)}return this._channels.channelList[e]}getPresetIndex(e,t){if(!this.presets)return-1;for(let s=this.presets.length-1;s>=0;s--){const i=this.presets[s];if(i.presetNumber===t&&i.bank===e)return s}return-1}getPresetName(e){return this.presets?e<0||e>=this.presets.length?null:this.presets[e].name:null}bankGetPresetName(e,t){return this.getPresetName(this.getPresetIndex(e,t))}channelNoteOn(e,t,s){!this._channels||e>this._channels.channelList.length||(this._transpositionPitches.has(e)&&(t+=this._transpositionPitches.get(e)),this._liveTranspositionPitches.has(e)&&(t+=this._liveTranspositionPitches.get(e)),this._channels.activeChannel=e,this.noteOn(this._channels.channelList[e].presetIndex,t,s))}channelNoteOff(e,t){this._transpositionPitches.has(e)&&(t+=this._transpositionPitches.get(e)),this._liveTranspositionPitches.has(e)&&(t+=this._liveTranspositionPitches.get(e));const s=[];let i=null,a=null;for(const r of this._voices)-1===r.playingPreset||r.playingChannel!==e||r.playingKey!==t||r.ampEnv.segment>=Xt.Release||(!i||r.playIndex<i.playIndex?(i=r,a=r,s.push(r)):r.playIndex===i.playIndex&&(a=r,s.push(r)));if(this.channelInit(e).perNotePitchWheel.delete(t),i)for(const r of s)r!==i&&r!==a&&(r.playIndex!==i.playIndex||-1===r.playingPreset||r.playingChannel!==e||r.playingKey!==t||r.ampEnv.segment>=Xt.Release)||r.end(this.outSampleRate)}channelNoteOffAll(e){this.channelInit(e).perNotePitchWheel.clear();for(const t of this._voices)-1!==t.playingPreset&&t.playingChannel===e&&t.ampEnv.segment<Xt.Release&&t.end(this.outSampleRate)}channelSoundsOffAll(e){this.channelInit(e).perNotePitchWheel.clear();for(const t of this._voices)-1!==t.playingPreset&&t.playingChannel===e&&(t.ampEnv.segment<Xt.Release||0===t.ampEnv.parameters.release)&&t.endQuick(this.outSampleRate)}channelSetPresetIndex(e,t){this.channelInit(e).presetIndex=ot.int32ToUint16(t)}channelSetPresetNumber(e,t,s=!1){const i=this.channelInit(e);let a=0;return s?(a=this.getPresetIndex(128|32767&i.bank,t),-1===a&&(a=this.getPresetIndex(128,t)),-1===a&&(a=this.getPresetIndex(128,0)),-1===a&&(a=this.getPresetIndex(2047&i.bank,t))):a=this.getPresetIndex(2047&i.bank,t),i.presetIndex=a,-1!==a}channelSetBank(e,t){this.channelInit(e).bank=ot.int32ToUint16(t)}channelSetBankPreset(e,t,s){const i=this.channelInit(e),a=this.getPresetIndex(t,s);return-1!==a&&(i.presetIndex=ot.int32ToUint16(a),i.bank=ot.int32ToUint16(t),!0)}channelSetPan(e,t){for(const s of this._voices)if(s.playingChannel===e&&-1!==s.playingPreset){const e=s.region.pan+t-.5;e<=-.5?(s.panFactorLeft=1,s.panFactorRight=0):e>=.5?(s.panFactorLeft=0,s.panFactorRight=1):(s.panFactorLeft=Math.sqrt(.5-e),s.panFactorRight=Math.sqrt(.5+e))}this.channelInit(e).panOffset=t-.5}channelSetVolume(e,t){const s=this.channelInit(e),i=Ui.gainToDecibels(t),a=i-s.gainDb;if(0!==a){for(const t of this._voices)t.playingChannel===e&&-1!==t.playingPreset&&(t.noteGainDb+=a);s.gainDb=i}}channelSetPitchWheel(e,t){const s=this.channelInit(e);s.pitchWheel!==t&&(s.pitchWheel=ot.int32ToUint16(t),this.channelApplyPitch(e,s))}channelSetPerNotePitchWheel(e,t,s){this._transpositionPitches.has(e)&&(t+=this._transpositionPitches.get(e)),this._liveTranspositionPitches.has(e)&&(t+=this._liveTranspositionPitches.get(e));const i=this.channelInit(e);i.perNotePitchWheel.has(t)&&i.perNotePitchWheel.get(t)===s||(i.perNotePitchWheel.set(t,s),this.channelApplyPitch(e,i,t))}channelApplyPitch(e,t,s=-1){for(const i of this._voices)i.playingChannel!==e||-1===i.playingPreset||-1!==s&&i.playingKey!==s||i.updatePitchRatio(t,this.outSampleRate)}channelSetPitchRange(e,t){const s=this.channelInit(e);s.pitchRange!==t&&(s.pitchRange=t,8192!==s.pitchWheel&&this.channelApplyPitch(e,s))}channelSetTuning(e,t){const s=this.channelInit(e);s.tuning!==t&&(s.tuning=t,this.channelApplyPitch(e,s))}channelMidiControl(e,t,s){const i=this.channelInit(e);switch(t){case Jt.DataEntryFine:return i.midiData=ot.int32ToUint16(16256&i.midiData|s),void(0===i.midiRpn?this.channelSetPitchRange(e,(i.midiData>>7)+.01*(127&i.midiData)):1===i.midiRpn?this.channelSetTuning(e,(0|i.tuning)+(i.midiData-8192)/8192):2===i.midiRpn&&this.channelSetTuning(e,s-64+(i.tuning-(0|i.tuning))));case Jt.VolumeCoarse:return i.midiVolume=ot.int32ToUint16(127&i.midiVolume|s<<7),void this.channelSetVolume(e,Math.pow(i.midiVolume/16383*(i.midiExpression/16383),3));case Jt.VolumeFine:return i.midiVolume=ot.int32ToUint16(16256&i.midiVolume|s),void this.channelSetVolume(e,Math.pow(i.midiVolume/16383*(i.midiExpression/16383),3));case Jt.ExpressionControllerCoarse:return i.midiExpression=ot.int32ToUint16(127&i.midiExpression|s<<7),void this.channelSetVolume(e,Math.pow(i.midiVolume/16383*(i.midiExpression/16383),3));case Jt.ExpressionControllerFine:return i.midiExpression=ot.int32ToUint16(16256&i.midiExpression|s),void this.channelSetVolume(e,Math.pow(i.midiVolume/16383*(i.midiExpression/16383),3));case Jt.PanCoarse:return i.midiPan=ot.int32ToUint16(127&i.midiPan|s<<7),void this.channelSetPan(e,i.midiPan/16383);case Jt.PanFine:return i.midiPan=ot.int32ToUint16(16256&i.midiPan|s),void this.channelSetPan(e,i.midiPan/16383);case Jt.DataEntryCoarse:return i.midiData=ot.int32ToUint16(127&i.midiData|s<<7),void(0===i.midiRpn?this.channelSetPitchRange(e,(i.midiData>>7)+.01*(127&i.midiData)):1===i.midiRpn?this.channelSetTuning(e,(0|i.tuning)+(i.midiData-8192)/8192):2===i.midiRpn&&t===Jt.DataEntryCoarse&&this.channelSetTuning(e,s-64+(i.tuning-(0|i.tuning))));case Jt.BankSelectCoarse:return void(i.bank=ot.int32ToUint16(32768|s));case Jt.BankSelectFine:return void(i.bank=ot.int32ToUint16((32768&i.bank?(127&i.bank)<<7:0)|s));case Jt.RegisteredParameterCourse:return void(i.midiRpn=ot.int32ToUint16(127&(65535===i.midiRpn?0:i.midiRpn)|s<<7));case Jt.RegisteredParameterFine:return void(i.midiRpn=ot.int32ToUint16(16256&(65535===i.midiRpn?0:i.midiRpn)|s));case Jt.NonRegisteredParameterFine:case Jt.NonRegisteredParameterCourse:return void(i.midiRpn=65535);case Jt.AllSoundOff:return void this.channelSoundsOffAll(e);case Jt.AllNotesOff:return void this.channelNoteOffAll(e);case Jt.ResetControllers:return i.midiVolume=16383,i.midiExpression=16383,i.midiPan=8192,i.bank=0,this.channelSetVolume(e,1),this.channelSetPan(e,.5),void this.channelSetPitchRange(e,2)}}channelGetPresetIndex(e){return this._channels&&e<this._channels.channelList.length?this._channels.channelList[e].presetIndex:0}channelGetPresetBank(e){return this._channels&&e<this._channels.channelList.length?32767&this._channels.channelList[e].bank:0}channelGetPan(e){return this._channels&&e<this._channels.channelList.length?this._channels.channelList[e].panOffset-.5:.5}channelGetVolume(e){return this._channels&&e<this._channels.channelList.length?Ui.decibelsToGain(this._channels.channelList[e].gainDb):1}channelGetPitchWheel(e){return this._channels&&e<this._channels.channelList.length?this._channels.channelList[e].pitchWheel:8192}channelGetPitchRange(e){return this._channels&&e<this._channels.channelList.length?this._channels.channelList[e].pitchRange:2}channelGetTuning(e){return this._channels&&e<this._channels.channelList.length?this._channels.channelList[e].tuning:0}resetPresets(){this.presets=[]}loadPresets(e,t,s,i){const a=[];for(let i=0;i<e.phdrs.length-1;i++){const r=e.phdrs[i];let n=0;const o=new zi;a.push(o),o.name=r.presetName,o.bank=r.bank,o.presetNumber=r.preset;let h=0;for(let t=r.presetBagNdx;t<e.phdrs[i+1].presetBagNdx;t++){let s=0,i=127,a=0,r=127;for(let n=e.pbags[t].genNdx;n<e.pbags[t+1].genNdx;n++){const t=e.pgens[n];if(t.genOper===Ii.GenKeyRange){s=t.genAmount.lowByteAmount,i=t.genAmount.highByteAmount;continue}if(t.genOper===Ii.GenVelRange){a=t.genAmount.lowByteAmount,r=t.genAmount.highByteAmount;continue}if(t.genOper!==Ii.GenInstrument)continue;if(t.genAmount.wordAmount>=e.insts.length)continue;for(let n=e.insts[t.genAmount.wordAmount].instBagNdx;n<e.insts[t.genAmount.wordAmount+1].instBagNdx;n++){let t=0,o=127,l=0,c=127;for(let d=e.ibags[n].instGenNdx;d<e.ibags[n+1].instGenNdx;d++){const n=e.igens[d];n.genOper!==Ii.GenKeyRange?n.genOper!==Ii.GenVelRange?53===n.genOper&&o>=s&&t<=i&&c>=a&&l<=r&&h++:(l=n.genAmount.lowByteAmount,c=n.genAmount.highByteAmount):(t=n.genAmount.lowByteAmount,o=n.genAmount.highByteAmount)}}}}o.regions=new Array(h);let l=new Ji;l.clear(!0);for(let a=r.presetBagNdx;a<e.phdrs[i+1].presetBagNdx;a++){const i=e.pbags[a],h=new Ji(l);let c=!1;for(let l=i.genNdx;l<e.pbags[a+1].genNdx;l++){const i=e.pgens[l];if(i.genOper===Ii.GenInstrument){const a=i.genAmount.wordAmount;if(a>=e.insts.length)continue;let l=new Ji;l.clear(!1);const d=e.insts[a];for(let i=d.instBagNdx;i<e.insts[a+1].instBagNdx;i++){const a=e.ibags[i],c=new Ji(l);let u=!1;for(let l=a.instGenNdx;l<e.ibags[i+1].instGenNdx;l++){const i=e.igens[l];if(i.genOper===Ii.GenSampleId){if(c.hiKey<h.loKey||c.loKey>h.hiKey)continue;if(c.hiVel<h.loVel||c.loVel>h.hiVel)continue;h.loKey>c.loKey&&(c.loKey=h.loKey),h.hiKey<c.hiKey&&(c.hiKey=h.hiKey),h.loVel>c.loVel&&(c.loVel=h.loVel),h.hiVel<c.hiVel&&(c.hiVel=h.hiVel),c.offset+=h.offset,c.end+=h.end,c.loopStart+=h.loopStart,c.loopEnd+=h.loopEnd,c.transpose+=h.transpose,c.tune+=h.tune,c.pitchKeyTrack+=h.pitchKeyTrack,c.attenuation+=h.attenuation,c.pan+=h.pan,c.ampEnv.delay+=h.ampEnv.delay,c.ampEnv.attack+=h.ampEnv.attack,c.ampEnv.hold+=h.ampEnv.hold,c.ampEnv.decay+=h.ampEnv.decay,c.ampEnv.sustain+=h.ampEnv.sustain,c.ampEnv.release+=h.ampEnv.release,c.modEnv.delay+=h.modEnv.delay,c.modEnv.attack+=h.modEnv.attack,c.modEnv.hold+=h.modEnv.hold,c.modEnv.decay+=h.modEnv.decay,c.modEnv.sustain+=h.modEnv.sustain,c.modEnv.release+=h.modEnv.release,c.initialFilterQ+=h.initialFilterQ,c.initialFilterFc+=h.initialFilterFc,c.modEnvToPitch+=h.modEnvToPitch,c.modEnvToFilterFc+=h.modEnvToFilterFc,c.delayModLFO+=h.delayModLFO,c.freqModLFO+=h.freqModLFO,c.modLfoToPitch+=h.modLfoToPitch,c.modLfoToFilterFc+=h.modLfoToFilterFc,c.modLfoToVolume+=h.modLfoToVolume,c.delayVibLFO+=h.delayVibLFO,c.freqVibLFO+=h.freqVibLFO,c.vibLfoToPitch+=h.vibLfoToPitch,c.ampEnv.envToSecs(!0),c.modEnv.envToSecs(!1),c.delayModLFO=c.delayModLFO<-11950?0:Ui.timecents2Secs(c.delayModLFO),c.delayVibLFO=c.delayVibLFO<-11950?0:Ui.timecents2Secs(c.delayVibLFO),c.pan<-.5?c.pan=-.5:c.pan>.5&&(c.pan=.5),(c.initialFilterQ<1500||c.initialFilterQ>13500)&&(c.initialFilterQ=0);const a=e.sHdrs[i.genAmount.wordAmount];c.offset+=a.start,c.end+=a.end,c.loopStart+=a.startLoop,c.loopEnd+=a.endLoop,a.endLoop>0&&(c.loopEnd-=1),-1===c.pitchKeyCenter&&(c.pitchKeyCenter=a.originalPitch),c.tune+=a.pitchCorrection,c.sampleRate=a.sampleRate;const l=r.bank===Q.PercussionBank;if(l&&Qi.setContainsRange(s,c.loKey,c.hiKey)||!l&&t.has(r.preset))if(1&a.sampleType){j.debug("AlphaSynth",`Loading of used sample ${a.sampleName} for preset ${r.presetName} (bank ${o.bank} program ${o.presetNumber})`);!!(16&a.sampleType)?c.samples=e.decodeSamples(a.start,a.end,!0):(c.samples=e.decodeSamples(2*c.offset,2*c.end,!1),c.loopStart>0&&(c.loopStart-=c.offset),c.loopEnd>0&&(c.loopEnd-=c.offset)),c.offset=0,c.end=c.samples.length-1}else j.warning("AlphaSynth",`Skipping load of unsupported sample ${a.sampleName} for preset ${r.presetName}, sample type ${a.sampleType} is not supported (bank ${o.bank} program ${o.presetNumber})`),c.samples=new Float32Array(0);else j.debug("AlphaSynth",`Skipping load of unused sample ${a.sampleName} for preset ${r.presetName} (bank ${o.bank} program ${o.presetNumber})`),c.samples=new Float32Array(0);o.regions[n]=new Ji(c),n++,u=!0}else c.operator(i.genOper,i.genAmount)}a!==e.ibags[d.instBagNdx]||u||(l=new Ji(c))}c=!0}else h.operator(i.genOper,i.genAmount)}i!==e.pbags[r.presetBagNdx]||c||(l=h)}}if(i&&this.presets)for(const e of a)this.presets.push(e);else this.presets=a}static setContainsRange(e,t,s){for(let i=t;i<=s;i++)if(e.has(i))return!0;return!1}hasSamplesForProgram(e){const t=this.presets;if(!t)return!1;for(const s of t)if(s.presetNumber===e)for(const e of s.regions)if(e.samples.length>0)return!0;return!1}hasSamplesForPercussion(e){const t=this.presets;if(!t)return!1;for(const s of t)if(s.bank===Q.PercussionBank)for(const t of s.regions)if(t.loKey>=e&&t.hiKey<=e&&t.samples.length>0)return!0;return!1}}class Zi{constructor(){this._listeners=[]}on(e){this._listeners.push(e)}off(e){this._listeners=this._listeners.filter((t=>t!==e))}trigger(){for(const e of this._listeners)e()}}class ea{constructor(){this._listeners=[]}on(e){this._listeners.push(e)}off(e){this._listeners=this._listeners.filter((t=>t!==e))}trigger(e){for(const t of this._listeners)t(e)}}class ta{constructor(e){this.events=e}}class sa{constructor(e){this.playbackRange=e}}class ia{get output(){return this._output}get isReadyForPlayback(){return this.isReady&&this._isSoundFontLoaded&&this._isMidiLoaded}get logLevel(){return j.logLevel}set logLevel(e){j.logLevel=e}get masterVolume(){return this._synthesizer.masterVolume}set masterVolume(e){e=Math.max(e,Q.MinVolume),this._synthesizer.masterVolume=e}get metronomeVolume(){return this._metronomeVolume}set metronomeVolume(e){e=Math.max(e,Q.MinVolume),this._metronomeVolume=e,this._synthesizer.metronomeVolume=e}get countInVolume(){return this._countInVolume}set countInVolume(e){e=Math.max(e,Q.MinVolume),this._countInVolume=e}get midiEventsPlayedFilter(){return Array.from(this._midiEventsPlayedFilter)}set midiEventsPlayedFilter(e){this._midiEventsPlayedFilter=new Set(e)}get playbackSpeed(){return this._sequencer.playbackSpeed}set playbackSpeed(e){e=ae.clamp(e,Q.MinPlaybackSpeed,Q.MaxPlaybackSpeed);const t=this._sequencer.playbackSpeed;this._sequencer.playbackSpeed=e,this.timePosition=this.timePosition*(t/e)}get tickPosition(){return this._tickPosition}set tickPosition(e){this.timePosition=this._sequencer.mainTickPositionToTimePosition(e)}get timePosition(){return this._timePosition}set timePosition(e){j.debug("AlphaSynth",`Seeking to position ${e}ms (main)`),this._sequencer.mainSeek(e),this.updateTimePosition(e,!0),this._sequencer.isPlayingMain&&(this._notPlayedSamples=0,this.output.resetSamples())}get playbackRange(){return this._sequencer.mainPlaybackRange}set playbackRange(e){this._sequencer.mainPlaybackRange=e,e&&(this.tickPosition=e.startTick),this.playbackRangeChanged.trigger(new sa(e))}get isLooping(){return this._sequencer.isLooping}set isLooping(e){this._sequencer.isLooping=e}destroy(){j.debug("AlphaSynth","Destroying player"),this.stop(),this.output.destroy()}constructor(e,t){this._isSoundFontLoaded=!1,this._isMidiLoaded=!1,this._tickPosition=0,this._timePosition=0,this._metronomeVolume=0,this._countInVolume=0,this._playedEventsQueue=new Ki,this._midiEventsPlayedFilter=new Set,this._notPlayedSamples=0,this._synthStopping=!1,this.isReady=!1,this.state=Ht.Paused,this._loadedSoundFonts=[],this.ready=new Zi,this.readyForPlayback=new Zi,this.finished=new Zi,this.soundFontLoaded=new Zi,this.soundFontLoadFailed=new ea,this.midiLoaded=new ea,this.midiLoadFailed=new ea,this.stateChanged=new ea,this.positionChanged=new ea,this.midiEventsPlayed=new ea,this.playbackRangeChanged=new ea,j.debug("AlphaSynth","Initializing player"),this.state=Ht.Paused,j.debug("AlphaSynth","Creating output"),this._output=e,j.debug("AlphaSynth","Creating synthesizer"),this._synthesizer=new Qi(this.output.sampleRate),this._sequencer=new Ys(this._synthesizer),j.debug("AlphaSynth","Opening output"),this.output.ready.on((()=>{this.isReady=!0,this.ready.trigger(),this.checkReadyForPlayback()})),this.output.sampleRequest.on((()=>{if(this.state===Ht.Playing&&(!this._sequencer.isFinished||this._synthesizer.activeVoiceCount>0)){let e=new Float32Array(Q.MicroBufferSize*Q.MicroBufferCount*Q.AudioChannels),t=0;for(let s=0;s<Q.MicroBufferCount;s++){this._sequencer.fillMidiEventQueue();const s=this._synthesizer.synthesize(e,t,Q.MicroBufferSize);t+=Q.MicroBufferSize*Q.AudioChannels;for(const e of s)this._midiEventsPlayedFilter.has(e.event.type)&&this._playedEventsQueue.enqueue(e);if(this._sequencer.isFinished)break}t<e.length&&(e=e.subarray(0,t)),this._notPlayedSamples+=e.length,this.output.addSamples(e)}else{const e=new Float32Array(0);this.output.addSamples(e)}})),this.output.samplesPlayed.on(this.onSamplesPlayed.bind(this)),this.output.open(t)}play(){return!(this.state!==Ht.Paused||!this._isMidiLoaded)&&(this.output.activate(),this.playInternal(),this._countInVolume>0&&(j.debug("AlphaSynth","Starting countin"),this._sequencer.startCountIn(),this._synthesizer.setupMetronomeChannel(this._countInVolume),this.updateTimePosition(0,!0)),this.output.play(),!0)}playInternal(){this._sequencer.isPlayingOneTimeMidi&&(j.debug("AlphaSynth","Cancelling one time midi"),this.stopOneTimeMidi()),j.debug("AlphaSynth","Starting playback"),this._synthesizer.setupMetronomeChannel(this.metronomeVolume),this._synthStopping=!1,this.state=Ht.Playing,this.stateChanged.trigger(new $s(this.state,!1))}pause(){this.state!==Ht.Paused&&this._isMidiLoaded&&(j.debug("AlphaSynth","Pausing playback"),this.state=Ht.Paused,this.stateChanged.trigger(new $s(this.state,!1)),this.output.pause(),this._synthesizer.noteOffAll(!1))}playPause(){this.state===Ht.Paused&&this._isMidiLoaded?this.play():this.pause()}stop(){this._isMidiLoaded&&(j.debug("AlphaSynth","Stopping playback"),this.state=Ht.Paused,this.output.pause(),this._notPlayedSamples=0,this._sequencer.stop(),this._synthesizer.noteOffAll(!0),this.tickPosition=this._sequencer.mainPlaybackRange?this._sequencer.mainPlaybackRange.startTick:0,this.stateChanged.trigger(new $s(this.state,!0)))}playOneTimeMidiFile(e){this._sequencer.isPlayingOneTimeMidi?this.stopOneTimeMidi():this.pause(),this._sequencer.loadOneTimeMidi(e),this._synthesizer.noteOffAll(!0),this.updateTimePosition(0,!0),this._notPlayedSamples=0,this.output.resetSamples(),this.output.play()}resetSoundFonts(){this.stop(),this._synthesizer.resetPresets(),this._loadedSoundFonts=[],this._isSoundFontLoaded=!1,this.soundFontLoaded.trigger()}loadSoundFont(e,t){this.pause();const s=lt.fromBuffer(e);try{j.debug("AlphaSynth","Loading soundfont from bytes");const e=new Ci;e.load(s),t||(this._loadedSoundFonts=[]),this._loadedSoundFonts.push(e),this._isSoundFontLoaded=!0,this.soundFontLoaded.trigger(),j.debug("AlphaSynth","soundFont successfully loaded"),this.checkReadyForPlayback()}catch(e){j.error("AlphaSynth",`Could not load soundfont from bytes ${e}`),this.soundFontLoadFailed.trigger(e)}}checkReadyForPlayback(){if(this.isReadyForPlayback){this._synthesizer.setupMetronomeChannel(this.metronomeVolume);const e=this._sequencer.instrumentPrograms,t=this._sequencer.percussionKeys;let s=!1;for(const i of this._loadedSoundFonts)this._synthesizer.loadPresets(i,e,t,s),s=!0;this.readyForPlayback.trigger()}}loadMidiFile(e){this.stop();try{j.debug("AlphaSynth","Loading midi from model"),this._sequencer.loadMidi(e),this._isMidiLoaded=!0,this.midiLoaded.trigger(new qs(0,this._sequencer.currentEndTime,0,this._sequencer.currentEndTick,!1)),j.debug("AlphaSynth","Midi successfully loaded"),this.checkReadyForPlayback(),this.tickPosition=0}catch(e){j.error("AlphaSynth",`Could not load midi from model ${e}`),this.midiLoadFailed.trigger(e)}}applyTranspositionPitches(e){this._synthesizer.applyTranspositionPitches(e)}setChannelTranspositionPitch(e,t){this._synthesizer.setChannelTranspositionPitch(e,t)}setChannelMute(e,t){this._synthesizer.channelSetMute(e,t)}resetChannelStates(){this._synthesizer.resetChannelStates()}setChannelSolo(e,t){this._synthesizer.channelSetSolo(e,t)}setChannelVolume(e,t){t=Math.max(t,Q.MinVolume),this._synthesizer.channelSetMixVolume(e,t)}onSamplesPlayed(e){if(0===e)return;const t=e/this._synthesizer.outSampleRate*1e3;this._notPlayedSamples-=e*Q.AudioChannels,this.updateTimePosition(this._timePosition+t,!1),this.checkForFinish()}checkForFinish(){let e=0,t=0;this.playbackRange&&this._sequencer.isPlayingMain?(e=this.playbackRange.startTick,t=this.playbackRange.endTick):t=this._sequencer.currentEndTick,this._tickPosition>=t&&this._notPlayedSamples<=0&&(this._notPlayedSamples=0,this._sequencer.isPlayingCountIn?(j.debug("AlphaSynth","Finished playback (count-in)"),this._sequencer.resetCountIn(),this.timePosition=this._sequencer.currentTime,this.playInternal(),this.output.resetSamples()):this._sequencer.isPlayingOneTimeMidi?(j.debug("AlphaSynth","Finished playback (one time)"),this.output.resetSamples(),this.state=Ht.Paused,this.stopOneTimeMidi()):this.isLooping?(j.debug("AlphaSynth","Finished playback (main looping)"),this.finished.trigger(),this.tickPosition=e,this._synthStopping=!1):this._synthesizer.activeVoiceCount>0?this._synthStopping||(this._synthesizer.noteOffAll(!0),this._synthStopping=!0):(this._synthStopping=!1,j.debug("AlphaSynth","Finished playback (main)"),this.finished.trigger(),this.stop()))}stopOneTimeMidi(){this.output.pause(),this._synthesizer.noteOffAll(!0),this._sequencer.resetOneTimeMidi(),this.timePosition=this._sequencer.currentTime}updateTimePosition(e,t){let s=e;this._timePosition=s;let i=this._sequencer.currentTimePositionToTickPosition(s);this._tickPosition=i;const a=this._sequencer.currentEndTime,r=this._sequencer.currentEndTick;s>a&&(s=a,i=r);const n=this._sequencer.isPlayingMain?"main":this._sequencer.isPlayingCountIn?"count-in":"one-time";if(j.debug("AlphaSynth",`Position changed: (time: ${s}/${a}, tick: ${i}/${r}, Active Voices: ${this._synthesizer.activeVoiceCount} (${n})`),this._sequencer.isPlayingMain&&this.positionChanged.trigger(new qs(s,a,i,r,t)),t)this._playedEventsQueue.clear();else{const e=new Ki;for(;!this._playedEventsQueue.isEmpty&&this._playedEventsQueue.peek().time<s;){const t=this._playedEventsQueue.dequeue();e.enqueue(t.event)}e.isEmpty||this.midiEventsPlayed.trigger(new ta(e.toArray()))}}hasSamplesForProgram(e){return this._synthesizer.hasSamplesForProgram(e)}hasSamplesForPercussion(e){return this._synthesizer.hasSamplesForPercussion(e)}}class aa{static parseEnum(t,s){switch(typeof t){case"string":const e=Number.parseInt(t);return Number.isNaN(e)?s[Object.keys(s).find((e=>e.toLowerCase()===t.toLowerCase()))]:e;case"number":return t;case"undefined":case"object":return}throw new qe(e.AlphaTabErrorType.Format,`Could not parse enum value '${t}'`)}static forEach(e,t){if(e instanceof Map)e.forEach(t);else if("object"==typeof e)for(const s in e)t(e[s],s)}static getValue(e,t){return e instanceof Map?e.get(t):"object"==typeof e?e[t]:null}}class ra{constructor(e,t,s){this.text=e,this.startPos=t,this.endPos=s}}class na{constructor(e){this.style="normal",this.variant="normal",this.weight="normal",this.stretch="normal",this.lineHeight="normal",this.size="1rem",this.families=[],this.parseOnlyFamilies=!1,this._currentTokenIndex=-1,this._input="",this._currentToken=null,this._input=e,this._tokens=this.splitToTokens(e)}splitToTokens(e){const t=[];let s=0;for(;s<e.length;){let i=s;for(;i<e.length&&" "!==e.charAt(i);)i++;i>s&&t.push(new ra(e.substring(s,i),s,i)),s=i+1}return t}parse(){if(this.reset(),1===this._tokens.length)switch(this._currentToken?.text){case"caption":case"icon":case"menu":case"message-box":case"small-caption":case"status-bar":case"inherit":return}this.parseOnlyFamilies||(this.fontStyleVariantWeight(),this.fontSizeLineHeight()),this.fontFamily()}static parseFamilies(e){const t=new na(e);return t.parseOnlyFamilies=!0,t.parse(),t.families}fontFamily(){if(!this._currentToken){if(this.parseOnlyFamilies)return;throw new Error("Missing font list")}const e=this._input.substr(this._currentToken.startPos).trim();let t=0;for(;t<e.length;){const s=e.charAt(t);if(" "===s||","===s)t++;else if('"'===s||"'"===s){const i=this.findEndOfQuote(e,t+1,s);this.families.push(e.substring(t+1,i).split(`\\${s}`).join(s)),t=i+1}else{const s=this.findEndOfQuote(e,t+1,",");this.families.push(e.substring(t,s).trim()),t=s+1}}}findEndOfQuote(e,t,s){let i=!1;for(;t<e.length;){const a=e.charAt(t);if(!i&&a===s)return t;i=!i&&"\\"===a,t+=1}return e.length}fontSizeLineHeight(){if(!this._currentToken)throw new Error("Missing font size");const e=this._currentToken.text.split("/");if(e.length>=3)throw new Error(`Invalid font size '${this._currentToken}' specified`);if(this.nextToken(),e.length>=2)if("/"===e[1]){if(!this._currentToken)throw new Error("Missing line-height after font size");this.lineHeight=this._currentToken.text,this.nextToken()}else this.size=e[0],this.lineHeight=e[1];else{if(!(e.length>=1))throw new Error("Missing font size");if(this.size=e[0],this._currentToken&&0===this._currentToken.text.indexOf("/"))if("/"===this._currentToken.text){if(this.nextToken(),!this._currentToken)throw new Error("Missing line-height after font size");this.lineHeight=this._currentToken.text,this.nextToken()}else this.lineHeight=this._currentToken.text.substr(1),this.nextToken()}}nextToken(){this._currentTokenIndex++,this._currentTokenIndex<this._tokens.length?this._currentToken=this._tokens[this._currentTokenIndex]:this._currentToken=null}fontStyleVariantWeight(){let e=!1,t=!1,s=!1,i=3;const a=[];for(;;){if(!this._currentToken)return;const r=this._currentToken.text;switch(r){case"normal":case"inherit":a.push(r),i--,this.nextToken();break;case"italic":case"oblique":this.style=r,e=!0,i--,this.nextToken();break;case"small-caps":this.variant=r,t=!0,i--,this.nextToken();break;case"bold":case"bolder":case"lighter":case"100":case"200":case"300":case"400":case"500":case"600":case"700":case"800":case"900":this.weight=r,s=!0,i--,this.nextToken();break;default:return}if(0===i)break}for(;a.length>0;){const i=a.pop();s?t?e||(this.style=i):this.variant=i:this.weight=i}}reset(){this._currentTokenIndex=-1,this.nextToken()}static quoteFont(e){if(-1===e.indexOf(" "))return e;return`"${e.replaceAll('"','\\"')}"`}}!function(e){e[e.Plain=0]="Plain",e[e.Italic=1]="Italic"}(Yt||(Yt={})),function(e){e[e.Regular=0]="Regular",e[e.Bold=1]="Bold"}($t||($t={}));class oa{reset(){this._cssScale=0,this._css=this.toCssString()}get family(){return this._families[0]}set family(e){this.families=na.parseFamilies(e)}get families(){return this._families}set families(e){this._families=e,this.reset()}get size(){return this._size}set size(e){this._size=e,this.reset()}get style(){return this._style}set style(e){this._style=e,this.reset()}get weight(){return this._weight}set weight(e){this._weight=e,this.reset()}get isBold(){return this.weight===$t.Bold}get isItalic(){return this.style===Yt.Italic}constructor(e,t,s=Yt.Plain,i=$t.Regular){this._cssScale=0,this._families=na.parseFamilies(e),this._size=t,this._style=s,this._weight=i,this._css=this.toCssString()}withSize(e){return oa.withFamilyList(this._families,e,this._style,this._weight)}static withFamilyList(e,t,s=Yt.Plain,i=$t.Regular){const a=new oa("",t,s,i);return a.families=e,a}toCssString(e=1){if(!(this._css&&Math.abs(e-this._cssScale)<.01)){let t="";this.isBold&&(t+="bold "),this.isItalic&&(t+="italic "),t+=this.size*e,t+="px ",t+=this.families.map((e=>na.quoteFont(e))).join(", "),this._css=t,this._cssScale=e}return this._css}static fromJson(e){if(e instanceof oa)return e;switch(typeof e){case"undefined":default:return null;case"object":{const t=e,s=t.get("families"),i=t.get("size"),a=aa.parseEnum(t.get("style"),Yt),r=aa.parseEnum(t.get("weight"),$t);return oa.withFamilyList(s,i,a,r)}case"string":{const t=new na(e);t.parse();const s=t.families,i=t.size.toLowerCase();let a=0;switch(i){case"xx-small":a=7;break;case"x-small":a=10;break;case"small":case"smaller":a=13;break;case"medium":a=16;break;case"large":case"larger":a=18;break;case"x-large":a=24;break;case"xx-large":a=32;break;default:try{a=i.endsWith("em")?16*Number.parseFloat(i.substr(0,i.length-2)):i.endsWith("pt")?16*Number.parseFloat(i.substr(0,i.length-2))/12:i.endsWith("px")?Number.parseFloat(i.substr(0,i.length-2)):12}catch(e){a=12}}let r=Yt.Plain;"italic"===t.style&&(r=Yt.Italic);let n=$t.Regular;switch(t.weight.toLowerCase()){case"normal":case"lighter":break;default:n=$t.Bold}return oa.withFamilyList(s,a,r,n)}}}static toJson(e){const t=new Map;return t.set("families",e.families),t.set("size",e.size),t.set("style",e.style),t.set("weight",e.weight),t}}class ha{constructor(){this.copyrightFont=new oa(ha.sansFont,12,Yt.Plain,$t.Bold),this.titleFont=new oa(ha.serifFont,32,Yt.Plain),this.subTitleFont=new oa(ha.serifFont,20,Yt.Plain),this.wordsFont=new oa(ha.serifFont,15,Yt.Plain),this.effectFont=new oa(ha.serifFont,12,Yt.Italic),this.timerFont=new oa(ha.serifFont,12,Yt.Plain),this.directionsFont=new oa(ha.serifFont,14,Yt.Plain),this.fretboardNumberFont=new oa(ha.sansFont,11,Yt.Plain),this.numberedNotationFont=new oa(ha.sansFont,16,Yt.Plain),this.numberedNotationGraceFont=new oa(ha.sansFont,14,Yt.Plain),this.tablatureFont=new oa(ha.sansFont,13,Yt.Plain),this.graceFont=new oa(ha.sansFont,11,Yt.Plain),this.staffLineColor=new tt(165,165,165,255),this.barSeparatorColor=new tt(34,34,17,255),this.barNumberFont=new oa(ha.sansFont,11,Yt.Plain),this.barNumberColor=new tt(200,0,0,255),this.fingeringFont=new oa(ha.serifFont,14,Yt.Plain),this.inlineFingeringFont=new oa(ha.serifFont,12,Yt.Plain),this.markerFont=new oa(ha.serifFont,14,Yt.Plain,$t.Bold),this.mainGlyphColor=new tt(0,0,0,255),this.secondaryGlyphColor=new tt(0,0,0,100),this.scoreInfoColor=new tt(0,0,0,255)}getFontForElement(e){switch(e){case Se.Title:return this.titleFont;case Se.SubTitle:case Se.Artist:case Se.Album:return this.subTitleFont;case Se.Words:case Se.Music:case Se.WordsAndMusic:case Se.Transcriber:return this.wordsFont;case Se.Copyright:case Se.CopyrightSecondLine:return this.copyrightFont}return this.wordsFont}}ha.sansFont="Arial, sans-serif",ha.serifFont="Georgia, serif",e.SystemsLayoutMode=void 0,(qt=e.SystemsLayoutMode||(e.SystemsLayoutMode={}))[qt.Automatic=0]="Automatic",qt[qt.UseModelLayout=1]="UseModelLayout";class la{constructor(){this.scale=1,this.stretchForce=1,this.layoutMode=e.LayoutMode.Page,this.staveProfile=e.StaveProfile.Default,this.barsPerRow=-1,this.startBar=1,this.barCount=-1,this.barCountPerPartial=10,this.justifyLastSystem=!1,this.resources=new ha,this.padding=[35,35],this.firstSystemPaddingTop=5,this.systemPaddingTop=10,this.systemPaddingBottom=20,this.lastSystemPaddingBottom=0,this.systemLabelPaddingLeft=0,this.systemLabelPaddingRight=3,this.accoladeBarPaddingRight=3,this.notationStaffPaddingTop=5,this.notationStaffPaddingBottom=5,this.effectStaffPaddingTop=0,this.effectStaffPaddingBottom=0,this.firstStaffPaddingLeft=6,this.staffPaddingLeft=2,this.systemsLayoutMode=e.SystemsLayoutMode.Automatic}}class ca{constructor(){this.encoding="utf-8",this.mergePartGroupsInMusicXml=!1,this.beatTextAsLyrics=!1}}e.ScrollMode=void 0,(jt=e.ScrollMode||(e.ScrollMode={}))[jt.Off=0]="Off",jt[jt.Continuous=1]="Continuous",jt[jt.OffScreen=2]="OffScreen";class da{constructor(){this.noteWideLength=240,this.noteWideAmplitude=1,this.noteSlightLength=360,this.noteSlightAmplitude=.5,this.beatWideLength=480,this.beatWideAmplitude=2,this.beatSlightLength=480,this.beatSlightAmplitude=2}}class ua{constructor(){this.simpleSlidePitchOffset=6,this.simpleSlideDurationRatio=.25,this.shiftSlideDurationRatio=.5}}e.PlayerOutputMode=void 0,(Kt=e.PlayerOutputMode||(e.PlayerOutputMode={}))[Kt.WebAudioAudioWorklets=0]="WebAudioAudioWorklets",Kt[Kt.WebAudioScriptProcessor=1]="WebAudioScriptProcessor";class pa{constructor(){this.soundFont=null,this.scrollElement="html,body",this.outputMode=e.PlayerOutputMode.WebAudioAudioWorklets,this.enablePlayer=!1,this.enableCursor=!0,this.enableAnimatedBeatCursor=!0,this.enableElementHighlighting=!0,this.enableUserInteraction=!0,this.scrollOffsetX=0,this.scrollOffsetY=0,this.scrollMode=e.ScrollMode.Continuous,this.scrollSpeed=300,this.nativeBrowserSmoothScroll=!0,this.songBookBendDuration=75,this.songBookDipDuration=150,this.vibrato=new da,this.slide=new ua,this.playTripletFeel=!0,this.bufferTimeInMilliseconds=500}}class ga{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>ga.setProperty(e,s.toLowerCase(),t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("scriptfile",e.scriptFile),t.set("fontdirectory",e.fontDirectory),t.set("file",e.file),t.set("tex",e.tex),t.set("tracks",e.tracks),t.set("enablelazyloading",e.enableLazyLoading),t.set("engine",e.engine),t.set("loglevel",e.logLevel),t.set("useworkers",e.useWorkers),t.set("includenotebounds",e.includeNoteBounds),t}static setProperty(t,s,i){switch(s){case"scriptfile":return t.scriptFile=i,!0;case"fontdirectory":return t.fontDirectory=i,!0;case"file":return t.file=i,!0;case"tex":return t.tex=i,!0;case"tracks":return t.tracks=i,!0;case"enablelazyloading":return t.enableLazyLoading=i,!0;case"engine":return t.engine=i,!0;case"loglevel":return t.logLevel=aa.parseEnum(i,e.LogLevel),!0;case"useworkers":return t.useWorkers=i,!0;case"includenotebounds":return t.includeNoteBounds=i,!0}return!1}}class ma{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>ma.setProperty(e,s.toLowerCase(),t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("copyrightfont",oa.toJson(e.copyrightFont)),t.set("titlefont",oa.toJson(e.titleFont)),t.set("subtitlefont",oa.toJson(e.subTitleFont)),t.set("wordsfont",oa.toJson(e.wordsFont)),t.set("effectfont",oa.toJson(e.effectFont)),t.set("timerfont",oa.toJson(e.timerFont)),t.set("directionsfont",oa.toJson(e.directionsFont)),t.set("fretboardnumberfont",oa.toJson(e.fretboardNumberFont)),t.set("numberednotationfont",oa.toJson(e.numberedNotationFont)),t.set("numberednotationgracefont",oa.toJson(e.numberedNotationGraceFont)),t.set("tablaturefont",oa.toJson(e.tablatureFont)),t.set("gracefont",oa.toJson(e.graceFont)),t.set("stafflinecolor",tt.toJson(e.staffLineColor)),t.set("barseparatorcolor",tt.toJson(e.barSeparatorColor)),t.set("barnumberfont",oa.toJson(e.barNumberFont)),t.set("barnumbercolor",tt.toJson(e.barNumberColor)),t.set("fingeringfont",oa.toJson(e.fingeringFont)),t.set("inlinefingeringfont",oa.toJson(e.inlineFingeringFont)),t.set("markerfont",oa.toJson(e.markerFont)),t.set("mainglyphcolor",tt.toJson(e.mainGlyphColor)),t.set("secondaryglyphcolor",tt.toJson(e.secondaryGlyphColor)),t.set("scoreinfocolor",tt.toJson(e.scoreInfoColor)),t}static setProperty(e,t,s){switch(t){case"copyrightfont":return e.copyrightFont=oa.fromJson(s),!0;case"titlefont":return e.titleFont=oa.fromJson(s),!0;case"subtitlefont":return e.subTitleFont=oa.fromJson(s),!0;case"wordsfont":return e.wordsFont=oa.fromJson(s),!0;case"effectfont":return e.effectFont=oa.fromJson(s),!0;case"timerfont":return e.timerFont=oa.fromJson(s),!0;case"directionsfont":return e.directionsFont=oa.fromJson(s),!0;case"fretboardnumberfont":return e.fretboardNumberFont=oa.fromJson(s),!0;case"numberednotationfont":return e.numberedNotationFont=oa.fromJson(s),!0;case"numberednotationgracefont":return e.numberedNotationGraceFont=oa.fromJson(s),!0;case"tablaturefont":return e.tablatureFont=oa.fromJson(s),!0;case"gracefont":return e.graceFont=oa.fromJson(s),!0;case"stafflinecolor":return e.staffLineColor=tt.fromJson(s),!0;case"barseparatorcolor":return e.barSeparatorColor=tt.fromJson(s),!0;case"barnumberfont":return e.barNumberFont=oa.fromJson(s),!0;case"barnumbercolor":return e.barNumberColor=tt.fromJson(s),!0;case"fingeringfont":return e.fingeringFont=oa.fromJson(s),!0;case"inlinefingeringfont":return e.inlineFingeringFont=oa.fromJson(s),!0;case"markerfont":return e.markerFont=oa.fromJson(s),!0;case"mainglyphcolor":return e.mainGlyphColor=tt.fromJson(s),!0;case"secondaryglyphcolor":return e.secondaryGlyphColor=tt.fromJson(s),!0;case"scoreinfocolor":return e.scoreInfoColor=tt.fromJson(s),!0}return!1}}class fa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>fa.setProperty(e,s.toLowerCase(),t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("scale",e.scale),t.set("stretchforce",e.stretchForce),t.set("layoutmode",e.layoutMode),t.set("staveprofile",e.staveProfile),t.set("barsperrow",e.barsPerRow),t.set("startbar",e.startBar),t.set("barcount",e.barCount),t.set("barcountperpartial",e.barCountPerPartial),t.set("justifylastsystem",e.justifyLastSystem),t.set("resources",ma.toJson(e.resources)),t.set("padding",e.padding),t.set("firstsystempaddingtop",e.firstSystemPaddingTop),t.set("systempaddingtop",e.systemPaddingTop),t.set("systempaddingbottom",e.systemPaddingBottom),t.set("lastsystempaddingbottom",e.lastSystemPaddingBottom),t.set("systemlabelpaddingleft",e.systemLabelPaddingLeft),t.set("systemlabelpaddingright",e.systemLabelPaddingRight),t.set("accoladebarpaddingright",e.accoladeBarPaddingRight),t.set("notationstaffpaddingtop",e.notationStaffPaddingTop),t.set("notationstaffpaddingbottom",e.notationStaffPaddingBottom),t.set("effectstaffpaddingtop",e.effectStaffPaddingTop),t.set("effectstaffpaddingbottom",e.effectStaffPaddingBottom),t.set("firststaffpaddingleft",e.firstStaffPaddingLeft),t.set("staffpaddingleft",e.staffPaddingLeft),t.set("systemslayoutmode",e.systemsLayoutMode),t}static setProperty(t,s,i){switch(s){case"scale":return t.scale=i,!0;case"stretchforce":return t.stretchForce=i,!0;case"layoutmode":return t.layoutMode=aa.parseEnum(i,e.LayoutMode),!0;case"staveprofile":return t.staveProfile=aa.parseEnum(i,e.StaveProfile),!0;case"barsperrow":return t.barsPerRow=i,!0;case"startbar":return t.startBar=i,!0;case"barcount":return t.barCount=i,!0;case"barcountperpartial":return t.barCountPerPartial=i,!0;case"justifylastsystem":return t.justifyLastSystem=i,!0;case"padding":return t.padding=i,!0;case"firstsystempaddingtop":return t.firstSystemPaddingTop=i,!0;case"systempaddingtop":return t.systemPaddingTop=i,!0;case"systempaddingbottom":return t.systemPaddingBottom=i,!0;case"lastsystempaddingbottom":return t.lastSystemPaddingBottom=i,!0;case"systemlabelpaddingleft":return t.systemLabelPaddingLeft=i,!0;case"systemlabelpaddingright":return t.systemLabelPaddingRight=i,!0;case"accoladebarpaddingright":return t.accoladeBarPaddingRight=i,!0;case"notationstaffpaddingtop":return t.notationStaffPaddingTop=i,!0;case"notationstaffpaddingbottom":return t.notationStaffPaddingBottom=i,!0;case"effectstaffpaddingtop":return t.effectStaffPaddingTop=i,!0;case"effectstaffpaddingbottom":return t.effectStaffPaddingBottom=i,!0;case"firststaffpaddingleft":return t.firstStaffPaddingLeft=i,!0;case"staffpaddingleft":return t.staffPaddingLeft=i,!0;case"systemslayoutmode":return t.systemsLayoutMode=aa.parseEnum(i,e.SystemsLayoutMode),!0}if(["resources"].indexOf(s)>=0)return ma.fromJson(t.resources,i),!0;for(const e of["resources"])if(0===s.indexOf(e)&&ma.setProperty(t.resources,s.substring(e.length),i))return!0;return!1}}class ya{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>ya.setProperty(e,s.toLowerCase(),t)))}static toJson(e){if(!e)return null;const t=new Map;t.set("notationmode",e.notationMode),t.set("fingeringmode",e.fingeringMode);{const s=new Map;t.set("elements",s);for(const[t,i]of e.elements)s.set(t.toString(),i)}return t.set("rhythmmode",e.rhythmMode),t.set("rhythmheight",e.rhythmHeight),t.set("transpositionpitches",e.transpositionPitches),t.set("displaytranspositionpitches",e.displayTranspositionPitches),t.set("smallgracetabnotes",e.smallGraceTabNotes),t.set("extendbendarrowsontiednotes",e.extendBendArrowsOnTiedNotes),t.set("extendlineeffectstobeatend",e.extendLineEffectsToBeatEnd),t.set("slurheight",e.slurHeight),t}static setProperty(t,s,i){switch(s){case"notationmode":return t.notationMode=aa.parseEnum(i,e.NotationMode),!0;case"fingeringmode":return t.fingeringMode=aa.parseEnum(i,e.FingeringMode),!0;case"elements":return t.elements=new Map,aa.forEach(i,((s,i)=>{t.elements.set(aa.parseEnum(i,e.NotationElement),s)})),!0;case"rhythmmode":return t.rhythmMode=aa.parseEnum(i,e.TabRhythmMode),!0;case"rhythmheight":return t.rhythmHeight=i,!0;case"transpositionpitches":return t.transpositionPitches=i,!0;case"displaytranspositionpitches":return t.displayTranspositionPitches=i,!0;case"smallgracetabnotes":return t.smallGraceTabNotes=i,!0;case"extendbendarrowsontiednotes":return t.extendBendArrowsOnTiedNotes=i,!0;case"extendlineeffectstobeatend":return t.extendLineEffectsToBeatEnd=i,!0;case"slurheight":return t.slurHeight=i,!0}return!1}}class ba{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>ba.setProperty(e,s.toLowerCase(),t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("encoding",e.encoding),t.set("mergepartgroupsinmusicxml",e.mergePartGroupsInMusicXml),t.set("beattextaslyrics",e.beatTextAsLyrics),t}static setProperty(e,t,s){switch(t){case"encoding":return e.encoding=s,!0;case"mergepartgroupsinmusicxml":return e.mergePartGroupsInMusicXml=s,!0;case"beattextaslyrics":return e.beatTextAsLyrics=s,!0}return!1}}class Sa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Sa.setProperty(e,s.toLowerCase(),t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("notewidelength",e.noteWideLength),t.set("notewideamplitude",e.noteWideAmplitude),t.set("noteslightlength",e.noteSlightLength),t.set("noteslightamplitude",e.noteSlightAmplitude),t.set("beatwidelength",e.beatWideLength),t.set("beatwideamplitude",e.beatWideAmplitude),t.set("beatslightlength",e.beatSlightLength),t.set("beatslightamplitude",e.beatSlightAmplitude),t}static setProperty(e,t,s){switch(t){case"notewidelength":return e.noteWideLength=s,!0;case"notewideamplitude":return e.noteWideAmplitude=s,!0;case"noteslightlength":return e.noteSlightLength=s,!0;case"noteslightamplitude":return e.noteSlightAmplitude=s,!0;case"beatwidelength":return e.beatWideLength=s,!0;case"beatwideamplitude":return e.beatWideAmplitude=s,!0;case"beatslightlength":return e.beatSlightLength=s,!0;case"beatslightamplitude":return e.beatSlightAmplitude=s,!0}return!1}}class _a{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>_a.setProperty(e,s.toLowerCase(),t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("simpleslidepitchoffset",e.simpleSlidePitchOffset),t.set("simpleslidedurationratio",e.simpleSlideDurationRatio),t.set("shiftslidedurationratio",e.shiftSlideDurationRatio),t}static setProperty(e,t,s){switch(t){case"simpleslidepitchoffset":return e.simpleSlidePitchOffset=s,!0;case"simpleslidedurationratio":return e.simpleSlideDurationRatio=s,!0;case"shiftslidedurationratio":return e.shiftSlideDurationRatio=s,!0}return!1}}class wa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>wa.setProperty(e,s.toLowerCase(),t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("soundfont",e.soundFont),t.set("outputmode",e.outputMode),t.set("enableplayer",e.enablePlayer),t.set("enablecursor",e.enableCursor),t.set("enableanimatedbeatcursor",e.enableAnimatedBeatCursor),t.set("enableelementhighlighting",e.enableElementHighlighting),t.set("enableuserinteraction",e.enableUserInteraction),t.set("scrolloffsetx",e.scrollOffsetX),t.set("scrolloffsety",e.scrollOffsetY),t.set("scrollmode",e.scrollMode),t.set("scrollspeed",e.scrollSpeed),t.set("nativebrowsersmoothscroll",e.nativeBrowserSmoothScroll),t.set("songbookbendduration",e.songBookBendDuration),t.set("songbookdipduration",e.songBookDipDuration),t.set("vibrato",Sa.toJson(e.vibrato)),t.set("slide",_a.toJson(e.slide)),t.set("playtripletfeel",e.playTripletFeel),t.set("buffertimeinmilliseconds",e.bufferTimeInMilliseconds),t}static setProperty(t,s,i){switch(s){case"soundfont":return t.soundFont=i,!0;case"scrollelement":return t.scrollElement=i,!0;case"outputmode":return t.outputMode=aa.parseEnum(i,e.PlayerOutputMode),!0;case"enableplayer":return t.enablePlayer=i,!0;case"enablecursor":return t.enableCursor=i,!0;case"enableanimatedbeatcursor":return t.enableAnimatedBeatCursor=i,!0;case"enableelementhighlighting":return t.enableElementHighlighting=i,!0;case"enableuserinteraction":return t.enableUserInteraction=i,!0;case"scrolloffsetx":return t.scrollOffsetX=i,!0;case"scrolloffsety":return t.scrollOffsetY=i,!0;case"scrollmode":return t.scrollMode=aa.parseEnum(i,e.ScrollMode),!0;case"scrollspeed":return t.scrollSpeed=i,!0;case"nativebrowsersmoothscroll":return t.nativeBrowserSmoothScroll=i,!0;case"songbookbendduration":return t.songBookBendDuration=i,!0;case"songbookdipduration":return t.songBookDipDuration=i,!0;case"playtripletfeel":return t.playTripletFeel=i,!0;case"buffertimeinmilliseconds":return t.bufferTimeInMilliseconds=i,!0}if(["vibrato"].indexOf(s)>=0)return Sa.fromJson(t.vibrato,i),!0;for(const e of["vibrato"])if(0===s.indexOf(e)&&Sa.setProperty(t.vibrato,s.substring(e.length),i))return!0;if(["slide"].indexOf(s)>=0)return _a.fromJson(t.slide,i),!0;for(const e of["slide"])if(0===s.indexOf(e)&&_a.setProperty(t.slide,s.substring(e.length),i))return!0;return!1}}class Ba{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ba.setProperty(e,s.toLowerCase(),t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("core",ga.toJson(e.core)),t.set("display",fa.toJson(e.display)),t.set("notation",ya.toJson(e.notation)),t.set("importer",ba.toJson(e.importer)),t.set("player",wa.toJson(e.player)),t}static setProperty(e,t,s){if(["core",""].indexOf(t)>=0)return ga.fromJson(e.core,s),!0;for(const i of["core",""])if(0===t.indexOf(i)&&ga.setProperty(e.core,t.substring(i.length),s))return!0;if(["display",""].indexOf(t)>=0)return fa.fromJson(e.display,s),!0;for(const i of["display",""])if(0===t.indexOf(i)&&fa.setProperty(e.display,t.substring(i.length),s))return!0;if(["notation"].indexOf(t)>=0)return ya.fromJson(e.notation,s),!0;for(const i of["notation"])if(0===t.indexOf(i)&&ya.setProperty(e.notation,t.substring(i.length),s))return!0;if(["importer"].indexOf(t)>=0)return ba.fromJson(e.importer,s),!0;for(const i of["importer"])if(0===t.indexOf(i)&&ba.setProperty(e.importer,t.substring(i.length),s))return!0;if(["player"].indexOf(t)>=0)return wa.fromJson(e.player,s),!0;for(const i of["player"])if(0===t.indexOf(i)&&wa.setProperty(e.player,t.substring(i.length),s))return!0;return!1}}class ka{constructor(){this.core=new oc,this.display=new la,this.notation=new Y,this.importer=new ca,this.player=new pa}setSongBookModeSettings(){this.notation.notationMode=e.NotationMode.SongBook,this.notation.smallGraceTabNotes=!1,this.notation.fingeringMode=e.FingeringMode.SingleNoteEffectBand,this.notation.extendBendArrowsOnTiedNotes=!1,this.notation.elements.set(e.NotationElement.ParenthesisOnTiedBends,!1),this.notation.elements.set(e.NotationElement.TabNotesOnTiedBends,!1),this.notation.elements.set(e.NotationElement.ZerosOnDiveWhammys,!0)}static get songBook(){const e=new ka;return e.setSongBookModeSettings(),e}fillFromJson(e){Ba.fromJson(this,e)}}class Ta{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ta.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("marker",e.marker),t.set("text",e.text),t}static setProperty(e,t,s){switch(t){case"marker":return e.marker=s,!0;case"text":return e.text=s,!0}return!1}}class Na{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Na.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("islinear",e.isLinear),t.set("type",e.type),t.set("value",e.value),t.set("ratioposition",e.ratioPosition),t.set("text",e.text),t}static setProperty(e,t,s){switch(t){case"islinear":return e.isLinear=s,!0;case"type":return e.type=aa.parseEnum(s,f),!0;case"value":return e.value=s,!0;case"ratioposition":return e.ratioPosition=s,!0;case"text":return e.text=s,!0}return!1}}class xa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>xa.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("type",e.type),t.set("length",e.length),t}static setProperty(e,t,s){switch(t){case"type":return e.type=aa.parseEnum(s,Te),!0;case"length":return e.length=s,!0}return!1}}class va{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>va.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;if(t.set("alternateendings",e.alternateEndings),t.set("isdoublebar",e.isDoubleBar),t.set("isrepeatstart",e.isRepeatStart),t.set("repeatcount",e.repeatCount),t.set("timesignaturenumerator",e.timeSignatureNumerator),t.set("timesignaturedenominator",e.timeSignatureDenominator),t.set("timesignaturecommon",e.timeSignatureCommon),t.set("isfreetime",e.isFreeTime),t.set("tripletfeel",e.tripletFeel),e.section&&t.set("section",Ta.toJson(e.section)),t.set("tempoautomations",e.tempoAutomations.map((e=>Na.toJson(e)))),null!==e.fermata){const s=new Map;t.set("fermata",s);for(const[t,i]of e.fermata)s.set(t.toString(),xa.toJson(i))}if(t.set("start",e.start),t.set("isanacrusis",e.isAnacrusis),t.set("displayscale",e.displayScale),t.set("displaywidth",e.displayWidth),null!==e.directions){const s=[];t.set("directions",s);for(const t of e.directions)s.push(t)}return t}static setProperty(e,t,s){switch(t){case"alternateendings":return e.alternateEndings=s,!0;case"isdoublebar":return e.isDoubleBar=s,!0;case"isrepeatstart":return e.isRepeatStart=s,!0;case"repeatcount":return e.repeatCount=s,!0;case"timesignaturenumerator":return e.timeSignatureNumerator=s,!0;case"timesignaturedenominator":return e.timeSignatureDenominator=s,!0;case"timesignaturecommon":return e.timeSignatureCommon=s,!0;case"isfreetime":return e.isFreeTime=s,!0;case"tripletfeel":return e.tripletFeel=aa.parseEnum(s,A),!0;case"section":return s?(e.section=new Ze,Ta.fromJson(e.section,s)):e.section=null,!0;case"tempoautomations":e.tempoAutomations=[];for(const t of s){const s=new X;Na.fromJson(s,t),e.tempoAutomations.push(s)}return!0;case"fermata":return e.fermata=new Map,aa.forEach(s,((t,s)=>{const i=new ct;xa.fromJson(i,t),e.addFermata(Number.parseInt(s),i)})),!0;case"start":return e.start=s,!0;case"isanacrusis":return e.isAnacrusis=s,!0;case"displayscale":return e.displayScale=s,!0;case"displaywidth":return e.displayWidth=s,!0;case"directions":for(const t of s)e.addDirection(aa.parseEnum(t,ke));return!0}return!1}}class Pa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Pa.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("offset",e.offset),t.set("value",e.value),t}static setProperty(e,t,s){switch(t){case"offset":return e.offset=s,!0;case"value":return e.value=s,!0}return!1}}class Fa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Fa.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;t.set("notehead",e.noteHead),t.set("noteheadcenteronstem",e.noteHeadCenterOnStem);{const s=new Map;t.set("colors",s);for(const[t,i]of e.colors)s.set(t.toString(),tt.toJson(i))}return t}static setProperty(e,t,s){switch(t){case"notehead":return e.noteHead=aa.parseEnum(s,ne),!0;case"noteheadcenteronstem":return e.noteHeadCenterOnStem=s,!0;case"colors":return e.colors=new Map,aa.forEach(s,((t,s)=>{e.colors.set(aa.parseEnum(s,ce),tt.fromJson(t))})),!0}return!1}}class Ca{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ca.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("id",e.id),t.set("accentuated",e.accentuated),t.set("bendtype",e.bendType),t.set("bendstyle",e.bendStyle),t.set("iscontinuedbend",e.isContinuedBend),null!==e.bendPoints&&t.set("bendpoints",e.bendPoints?.map((e=>Pa.toJson(e)))),t.set("fret",e.fret),t.set("string",e.string),t.set("showstringnumber",e.showStringNumber),t.set("octave",e.octave),t.set("tone",e.tone),t.set("percussionarticulation",e.percussionArticulation),t.set("isvisible",e.isVisible),t.set("islefthandtapped",e.isLeftHandTapped),t.set("ishammerpullorigin",e.isHammerPullOrigin),t.set("isslurdestination",e.isSlurDestination),t.set("harmonictype",e.harmonicType),t.set("harmonicvalue",e.harmonicValue),t.set("isghost",e.isGhost),t.set("isletring",e.isLetRing),t.set("ispalmmute",e.isPalmMute),t.set("isdead",e.isDead),t.set("isstaccato",e.isStaccato),t.set("slideintype",e.slideInType),t.set("slideouttype",e.slideOutType),t.set("vibrato",e.vibrato),t.set("istiedestination",e.isTieDestination),t.set("lefthandfinger",e.leftHandFinger),t.set("righthandfinger",e.rightHandFinger),t.set("trillvalue",e.trillValue),t.set("trillspeed",e.trillSpeed),t.set("durationpercent",e.durationPercent),t.set("accidentalmode",e.accidentalMode),t.set("dynamics",e.dynamics),t.set("ornament",e.ornament),e.style&&t.set("style",Fa.toJson(e.style)),e.toJson(t),t}static setProperty(e,t,s){switch(t){case"id":return e.id=s,!0;case"accentuated":return e.accentuated=aa.parseEnum(s,k),!0;case"bendtype":return e.bendType=aa.parseEnum(s,b),!0;case"bendstyle":return e.bendStyle=aa.parseEnum(s,y),!0;case"iscontinuedbend":return e.isContinuedBend=s,!0;case"bendpoints":if(s){e.bendPoints=[];for(const t of s){const s=new J;Pa.fromJson(s,t),e.addBendPoint(s)}}return!0;case"fret":return e.fret=s,!0;case"string":return e.string=s,!0;case"showstringnumber":return e.showStringNumber=s,!0;case"octave":return e.octave=s,!0;case"tone":return e.tone=s,!0;case"percussionarticulation":return e.percussionArticulation=s,!0;case"isvisible":return e.isVisible=s,!0;case"islefthandtapped":return e.isLeftHandTapped=s,!0;case"ishammerpullorigin":return e.isHammerPullOrigin=s,!0;case"isslurdestination":return e.isSlurDestination=s,!0;case"harmonictype":return e.harmonicType=aa.parseEnum(s,N),!0;case"harmonicvalue":return e.harmonicValue=s,!0;case"isghost":return e.isGhost=s,!0;case"isletring":return e.isLetRing=s,!0;case"ispalmmute":return e.isPalmMute=s,!0;case"isdead":return e.isDead=s,!0;case"isstaccato":return e.isStaccato=s,!0;case"slideintype":return e.slideInType=aa.parseEnum(s,v),!0;case"slideouttype":return e.slideOutType=aa.parseEnum(s,P),!0;case"vibrato":return e.vibrato=aa.parseEnum(s,F),!0;case"istiedestination":return e.isTieDestination=s,!0;case"lefthandfinger":return e.leftHandFinger=aa.parseEnum(s,T),!0;case"righthandfinger":return e.rightHandFinger=aa.parseEnum(s,T),!0;case"trillvalue":return e.trillValue=s,!0;case"trillspeed":return e.trillSpeed=aa.parseEnum(s,w),!0;case"durationpercent":return e.durationPercent=s,!0;case"accidentalmode":return e.accidentalMode=aa.parseEnum(s,x),!0;case"dynamics":return e.dynamics=aa.parseEnum(s,m),!0;case"ornament":return e.ornament=aa.parseEnum(s,le),!0;case"style":return s?(e.style=new Ie,Fa.fromJson(e.style,s)):e.style=void 0,!0}return e.setProperty(t,s)}}class Ea{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ea.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;{const s=new Map;t.set("colors",s);for(const[t,i]of e.colors)s.set(t.toString(),tt.toJson(i))}return t}static setProperty(e,t,s){return"colors"===t&&(e.colors=new Map,aa.forEach(s,((t,s)=>{e.colors.set(aa.parseEnum(s,be),tt.fromJson(t))})),!0)}}class Da{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Da.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("id",e.id),t.set("notes",e.notes.map((e=>Ca.toJson(e)))),t.set("isempty",e.isEmpty),t.set("whammystyle",e.whammyStyle),t.set("ottava",e.ottava),t.set("islegatoorigin",e.isLegatoOrigin),t.set("duration",e.duration),t.set("automations",e.automations.map((e=>Na.toJson(e)))),t.set("dots",e.dots),t.set("fade",e.fade),t.set("lyrics",e.lyrics),t.set("pop",e.pop),t.set("slap",e.slap),t.set("tap",e.tap),t.set("text",e.text),t.set("slashed",e.slashed),t.set("deadslapped",e.deadSlapped),t.set("brushtype",e.brushType),t.set("brushduration",e.brushDuration),t.set("tupletdenominator",e.tupletDenominator),t.set("tupletnumerator",e.tupletNumerator),t.set("iscontinuedwhammy",e.isContinuedWhammy),t.set("whammybartype",e.whammyBarType),null!==e.whammyBarPoints&&t.set("whammybarpoints",e.whammyBarPoints?.map((e=>Pa.toJson(e)))),t.set("vibrato",e.vibrato),t.set("chordid",e.chordId),t.set("gracetype",e.graceType),t.set("pickstroke",e.pickStroke),t.set("tremolospeed",e.tremoloSpeed),t.set("crescendo",e.crescendo),t.set("displaystart",e.displayStart),t.set("playbackstart",e.playbackStart),t.set("displayduration",e.displayDuration),t.set("playbackduration",e.playbackDuration),t.set("overridedisplayduration",e.overrideDisplayDuration),t.set("golpe",e.golpe),t.set("dynamics",e.dynamics),t.set("invertbeamdirection",e.invertBeamDirection),t.set("preferredbeamdirection",e.preferredBeamDirection),t.set("beamingmode",e.beamingMode),t.set("wahpedal",e.wahPedal),t.set("barrefret",e.barreFret),t.set("barreshape",e.barreShape),t.set("rasgueado",e.rasgueado),t.set("showtimer",e.showTimer),t.set("timer",e.timer),e.style&&t.set("style",Ea.toJson(e.style)),t}static setProperty(e,t,s){switch(t){case"id":return e.id=s,!0;case"notes":e.notes=[];for(const t of s){const s=new Re;Ca.fromJson(s,t),e.addNote(s)}return!0;case"isempty":return e.isEmpty=s,!0;case"whammystyle":return e.whammyStyle=aa.parseEnum(s,y),!0;case"ottava":return e.ottava=aa.parseEnum(s,h),!0;case"islegatoorigin":return e.isLegatoOrigin=s,!0;case"duration":return e.duration=aa.parseEnum(s,w),!0;case"automations":e.automations=[];for(const t of s){const s=new X;Na.fromJson(s,t),e.automations.push(s)}return!0;case"dots":return e.dots=s,!0;case"fade":return e.fade=aa.parseEnum(s,pe),!0;case"lyrics":return e.lyrics=s,!0;case"pop":return e.pop=s,!0;case"slap":return e.slap=s,!0;case"tap":return e.tap=s,!0;case"text":return e.text=s,!0;case"slashed":return e.slashed=s,!0;case"deadslapped":return e.deadSlapped=s,!0;case"brushtype":return e.brushType=aa.parseEnum(s,S),!0;case"brushduration":return e.brushDuration=s,!0;case"tupletdenominator":return e.tupletDenominator=s,!0;case"tupletnumerator":return e.tupletNumerator=s,!0;case"iscontinuedwhammy":return e.isContinuedWhammy=s,!0;case"whammybartype":return e.whammyBarType=aa.parseEnum(s,de),!0;case"whammybarpoints":if(s){e.whammyBarPoints=[];for(const t of s){const s=new J;Pa.fromJson(s,t),e.addWhammyBarPoint(s)}}return!0;case"vibrato":return e.vibrato=aa.parseEnum(s,F),!0;case"chordid":return e.chordId=s,!0;case"gracetype":return e.graceType=aa.parseEnum(s,B),!0;case"pickstroke":return e.pickStroke=aa.parseEnum(s,re),!0;case"tremolospeed":return e.tremoloSpeed=aa.parseEnum(s,w)??null,!0;case"crescendo":return e.crescendo=aa.parseEnum(s,_),!0;case"displaystart":return e.displayStart=s,!0;case"playbackstart":return e.playbackStart=s,!0;case"displayduration":return e.displayDuration=s,!0;case"playbackduration":return e.playbackDuration=s,!0;case"overridedisplayduration":return e.overrideDisplayDuration=s,!0;case"golpe":return e.golpe=aa.parseEnum(s,ue),!0;case"dynamics":return e.dynamics=aa.parseEnum(s,m),!0;case"invertbeamdirection":return e.invertBeamDirection=s,!0;case"preferredbeamdirection":return e.preferredBeamDirection=aa.parseEnum(s,Ne)??null,!0;case"beamingmode":return e.beamingMode=aa.parseEnum(s,ye),!0;case"wahpedal":return e.wahPedal=aa.parseEnum(s,ge),!0;case"barrefret":return e.barreFret=s,!0;case"barreshape":return e.barreShape=aa.parseEnum(s,me),!0;case"rasgueado":return e.rasgueado=aa.parseEnum(s,fe),!0;case"showtimer":return e.showTimer=s,!0;case"timer":return e.timer=s,!0;case"style":return s?(e.style=new ze,Ea.fromJson(e.style,s)):e.style=void 0,!0}return!1}}class Ma{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ma.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;{const s=new Map;t.set("colors",s);for(const[t,i]of e.colors)s.set(t.toString(),tt.toJson(i))}return t}static setProperty(e,t,s){return"colors"===t&&(e.colors=new Map,aa.forEach(s,((t,s)=>{e.colors.set(aa.parseEnum(s,I),tt.fromJson(t))})),!0)}}class La{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>La.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("id",e.id),t.set("beats",e.beats.map((e=>Da.toJson(e)))),e.style&&t.set("style",Ma.toJson(e.style)),t}static setProperty(e,t,s){switch(t){case"id":return e.id=s,!0;case"beats":e.beats=[];for(const t of s){const s=new Ue;Da.fromJson(s,t),e.addBeat(s)}return!0;case"style":return s?(e.style=new ee,Ma.fromJson(e.style,s)):e.style=void 0,!0}return!1}}class Aa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Aa.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("ratioposition",e.ratioPosition),t.set("pedaltype",e.pedalType),t}static setProperty(e,t,s){switch(t){case"ratioposition":return e.ratioPosition=s,!0;case"pedaltype":return e.pedalType=aa.parseEnum(s,u),!0}return!1}}class Ia{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ia.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;{const s=new Map;t.set("colors",s);for(const[t,i]of e.colors)s.set(t.toString(),tt.toJson(i))}return t}static setProperty(e,t,s){return"colors"===t&&(e.colors=new Map,aa.forEach(s,((t,s)=>{e.colors.set(aa.parseEnum(s,p),tt.fromJson(t))})),!0)}}class Ra{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ra.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("id",e.id),t.set("clef",e.clef),t.set("clefottava",e.clefOttava),t.set("voices",e.voices.map((e=>La.toJson(e)))),t.set("similemark",e.simileMark),t.set("displayscale",e.displayScale),t.set("displaywidth",e.displayWidth),t.set("sustainpedals",e.sustainPedals.map((e=>Aa.toJson(e)))),t.set("barlineleft",e.barLineLeft),t.set("barlineright",e.barLineRight),t.set("keysignature",e.keySignature),t.set("keysignaturetype",e.keySignatureType),e.style&&t.set("style",Ia.toJson(e.style)),t}static setProperty(e,t,s){switch(t){case"id":return e.id=s,!0;case"clef":return e.clef=aa.parseEnum(s,o),!0;case"clefottava":return e.clefOttava=aa.parseEnum(s,h),!0;case"voices":e.voices=[];for(const t of s){const s=new te;La.fromJson(s,t),e.addVoice(s)}return!0;case"similemark":return e.simileMark=aa.parseEnum(s,l),!0;case"displayscale":return e.displayScale=s,!0;case"displaywidth":return e.displayWidth=s,!0;case"sustainpedals":e.sustainPedals=[];for(const t of s){const s=new V;Aa.fromJson(s,t),e.sustainPedals.push(s)}return!0;case"barlineleft":return e.barLineLeft=aa.parseEnum(s,g),!0;case"barlineright":return e.barLineRight=aa.parseEnum(s,g),!0;case"keysignature":return e.keySignature=aa.parseEnum(s,c),!0;case"keysignaturetype":return e.keySignatureType=aa.parseEnum(s,d),!0;case"style":return s?(e.style=new G,Ia.fromJson(e.style,s)):e.style=void 0,!0}return!1}}class Oa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Oa.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("name",e.name),t.set("firstfret",e.firstFret),t.set("strings",e.strings),t.set("barrefrets",e.barreFrets),t.set("showname",e.showName),t.set("showdiagram",e.showDiagram),t.set("showfingering",e.showFingering),t}static setProperty(e,t,s){switch(t){case"name":return e.name=s,!0;case"firstfret":return e.firstFret=s,!0;case"strings":return e.strings=s,!0;case"barrefrets":return e.barreFrets=s,!0;case"showname":return e.showName=s,!0;case"showdiagram":return e.showDiagram=s,!0;case"showfingering":return e.showFingering=s,!0}return!1}}class Ha{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ha.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("isstandard",e.isStandard),t.set("name",e.name),t.set("tunings",e.tunings),t}static setProperty(e,t,s){switch(t){case"isstandard":return e.isStandard=s,!0;case"name":return e.name=s,!0;case"tunings":return e.tunings=s,!0}return!1}}class Wa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Wa.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;if(t.set("bars",e.bars.map((e=>Ra.toJson(e)))),null!==e.chords){const s=new Map;t.set("chords",s);for(const[t,i]of e.chords)s.set(t.toString(),Oa.toJson(i))}return t.set("capo",e.capo),t.set("transpositionpitch",e.transpositionPitch),t.set("displaytranspositionpitch",e.displayTranspositionPitch),t.set("stringtuning",Ha.toJson(e.stringTuning)),t.set("showslash",e.showSlash),t.set("shownumbered",e.showNumbered),t.set("showtablature",e.showTablature),t.set("showstandardnotation",e.showStandardNotation),t.set("ispercussion",e.isPercussion),t.set("standardnotationlinecount",e.standardNotationLineCount),t}static setProperty(e,t,s){switch(t){case"bars":e.bars=[];for(const t of s){const s=new z;Ra.fromJson(s,t),e.addBar(s)}return!0;case"chords":return e.chords=new Map,aa.forEach(s,((t,s)=>{const i=new Ke;Oa.fromJson(i,t),e.addChord(s,i)})),!0;case"capo":return e.capo=s,!0;case"transpositionpitch":return e.transpositionPitch=s,!0;case"displaytranspositionpitch":return e.displayTranspositionPitch=s,!0;case"stringtuning":return Ha.fromJson(e.stringTuning,s),!0;case"showslash":return e.showSlash=s,!0;case"shownumbered":return e.showNumbered=s,!0;case"showtablature":return e.showTablature=s,!0;case"showstandardnotation":return e.showStandardNotation=s,!0;case"ispercussion":return e.isPercussion=s,!0;case"standardnotationlinecount":return e.standardNotationLineCount=s,!0}return!1}}class Va{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Va.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("volume",e.volume),t.set("balance",e.balance),t.set("port",e.port),t.set("program",e.program),t.set("primarychannel",e.primaryChannel),t.set("secondarychannel",e.secondaryChannel),t.set("ismute",e.isMute),t.set("issolo",e.isSolo),t}static setProperty(e,t,s){switch(t){case"volume":return e.volume=s,!0;case"balance":return e.balance=s,!0;case"port":return e.port=s,!0;case"program":return e.program=s,!0;case"primarychannel":return e.primaryChannel=s,!0;case"secondarychannel":return e.secondaryChannel=s,!0;case"ismute":return e.isMute=s,!0;case"issolo":return e.isSolo=s,!0}return!1}}class Ga{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ga.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("elementtype",e.elementType),t.set("staffline",e.staffLine),t.set("noteheaddefault",e.noteHeadDefault),t.set("noteheadhalf",e.noteHeadHalf),t.set("noteheadwhole",e.noteHeadWhole),t.set("techniquesymbol",e.techniqueSymbol),t.set("techniquesymbolplacement",e.techniqueSymbolPlacement),t.set("outputmidinumber",e.outputMidiNumber),t}static setProperty(e,t,s){switch(t){case"elementtype":return e.elementType=s,!0;case"staffline":return e.staffLine=s,!0;case"noteheaddefault":return e.noteHeadDefault=aa.parseEnum(s,ne),!0;case"noteheadhalf":return e.noteHeadHalf=aa.parseEnum(s,ne),!0;case"noteheadwhole":return e.noteHeadWhole=aa.parseEnum(s,ne),!0;case"techniquesymbol":return e.techniqueSymbol=aa.parseEnum(s,ne),!0;case"techniquesymbolplacement":return e.techniqueSymbolPlacement=aa.parseEnum(s,he),!0;case"outputmidinumber":return e.outputMidiNumber=s,!0}return!1}}class za{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>za.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;{const s=new Map;t.set("colors",s);for(const[t,i]of e.colors)s.set(t.toString(),tt.toJson(i))}return t}static setProperty(e,t,s){return"colors"===t&&(e.colors=new Map,aa.forEach(s,((t,s)=>{e.colors.set(aa.parseEnum(s,Be),tt.fromJson(t))})),!0)}}class Ua{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ua.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;if(t.set("staves",e.staves.map((e=>Wa.toJson(e)))),t.set("playbackinfo",Va.toJson(e.playbackInfo)),t.set("color",tt.toJson(e.color)),t.set("name",e.name),t.set("isvisibleonmultitrack",e.isVisibleOnMultiTrack),t.set("shortname",e.shortName),t.set("defaultsystemslayout",e.defaultSystemsLayout),t.set("systemslayout",e.systemsLayout),void 0!==e.lineBreaks){const s=[];t.set("linebreaks",s);for(const t of e.lineBreaks)s.push(t)}return t.set("percussionarticulations",e.percussionArticulations.map((e=>Ga.toJson(e)))),e.style&&t.set("style",za.toJson(e.style)),t}static setProperty(e,t,s){switch(t){case"staves":e.staves=[];for(const t of s){const s=new at;Wa.fromJson(s,t),e.addStaff(s)}return!0;case"playbackinfo":return Va.fromJson(e.playbackInfo,s),!0;case"color":return e.color=tt.fromJson(s),!0;case"name":return e.name=s,!0;case"isvisibleonmultitrack":return e.isVisibleOnMultiTrack=s,!0;case"shortname":return e.shortName=s,!0;case"defaultsystemslayout":return e.defaultSystemsLayout=s,!0;case"systemslayout":return e.systemsLayout=s,!0;case"linebreaks":for(const t of s)e.addLineBreaks(t);return!0;case"percussionarticulations":e.percussionArticulations=[];for(const t of s){const s=new Me;Ga.fromJson(s,t),e.percussionArticulations.push(s)}return!0;case"style":return s?(e.style=new rt,za.fromJson(e.style,s)):e.style=void 0,!0}return!1}}class Xa{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Xa.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;if(t.set("hidedynamics",e.hideDynamics),t.set("bracketextendmode",e.bracketExtendMode),t.set("usesystemsignseparator",e.useSystemSignSeparator),t.set("globaldisplaytuning",e.globalDisplayTuning),null!==e.perTrackDisplayTuning){const s=new Map;t.set("pertrackdisplaytuning",s);for(const[t,i]of e.perTrackDisplayTuning)s.set(t.toString(),i)}if(t.set("globaldisplaychorddiagramsontop",e.globalDisplayChordDiagramsOnTop),null!==e.perTrackChordDiagramsOnTop){const s=new Map;t.set("pertrackchorddiagramsontop",s);for(const[t,i]of e.perTrackChordDiagramsOnTop)s.set(t.toString(),i)}if(t.set("singletracktracknamepolicy",e.singleTrackTrackNamePolicy),t.set("multitracktracknamepolicy",e.multiTrackTrackNamePolicy),t.set("firstsystemtracknamemode",e.firstSystemTrackNameMode),t.set("othersystemstracknamemode",e.otherSystemsTrackNameMode),t.set("firstsystemtracknameorientation",e.firstSystemTrackNameOrientation),t.set("othersystemstracknameorientation",e.otherSystemsTrackNameOrientation),t.set("multitrackmultibarrest",e.multiTrackMultiBarRest),null!==e.perTrackMultiBarRest){const s=[];t.set("pertrackmultibarrest",s);for(const t of e.perTrackMultiBarRest)s.push(t)}return t}static setProperty(e,t,s){switch(t){case"hidedynamics":return e.hideDynamics=s,!0;case"bracketextendmode":return e.bracketExtendMode=aa.parseEnum(s,i),!0;case"usesystemsignseparator":return e.useSystemSignSeparator=s,!0;case"globaldisplaytuning":return e.globalDisplayTuning=s,!0;case"pertrackdisplaytuning":return e.perTrackDisplayTuning=new Map,aa.forEach(s,((t,s)=>{e.perTrackDisplayTuning.set(Number.parseInt(s),t)})),!0;case"globaldisplaychorddiagramsontop":return e.globalDisplayChordDiagramsOnTop=s,!0;case"pertrackchorddiagramsontop":return e.perTrackChordDiagramsOnTop=new Map,aa.forEach(s,((t,s)=>{e.perTrackChordDiagramsOnTop.set(Number.parseInt(s),t)})),!0;case"singletracktracknamepolicy":return e.singleTrackTrackNamePolicy=aa.parseEnum(s,a),!0;case"multitracktracknamepolicy":return e.multiTrackTrackNamePolicy=aa.parseEnum(s,a),!0;case"firstsystemtracknamemode":return e.firstSystemTrackNameMode=aa.parseEnum(s,r),!0;case"othersystemstracknamemode":return e.otherSystemsTrackNameMode=aa.parseEnum(s,r),!0;case"firstsystemtracknameorientation":return e.firstSystemTrackNameOrientation=aa.parseEnum(s,n),!0;case"othersystemstracknameorientation":return e.otherSystemsTrackNameOrientation=aa.parseEnum(s,n),!0;case"multitrackmultibarrest":return e.multiTrackMultiBarRest=s,!0;case"pertrackmultibarrest":return e.perTrackMultiBarRest=new Set(s),!0}return!1}}class Ja{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ja.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("template",e.template),t.set("isvisible",e.isVisible),t.set("textalign",e.textAlign),t}static setProperty(e,t,s){switch(t){case"template":return e.template=s,!0;case"isvisible":return e.isVisible=s,!0;case"textalign":return e.textAlign=aa.parseEnum(s,oe),!0}return!1}}class Ya{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>Ya.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;{const s=new Map;t.set("headerandfooter",s);for(const[t,i]of e.headerAndFooter)s.set(t.toString(),Ja.toJson(i))}{const s=new Map;t.set("colors",s);for(const[t,i]of e.colors)s.set(t.toString(),tt.toJson(i))}return t}static setProperty(e,t,s){switch(t){case"headerandfooter":return e.headerAndFooter=new Map,aa.forEach(s,((t,s)=>{const i=new Xe;Ja.fromJson(i,t),e.headerAndFooter.set(aa.parseEnum(s,Se),i)})),!0;case"colors":return e.colors=new Map,aa.forEach(s,((t,s)=>{e.colors.set(aa.parseEnum(s,Se),tt.fromJson(t))})),!0}return!1}}class $a{static fromJson(e,t){t&&aa.forEach(t,((t,s)=>$a.setProperty(e,s,t)))}static toJson(e){if(!e)return null;const t=new Map;return t.set("album",e.album),t.set("artist",e.artist),t.set("copyright",e.copyright),t.set("instructions",e.instructions),t.set("music",e.music),t.set("notices",e.notices),t.set("subtitle",e.subTitle),t.set("title",e.title),t.set("words",e.words),t.set("tab",e.tab),t.set("tempo",e.tempo),t.set("tempolabel",e.tempoLabel),t.set("masterbars",e.masterBars.map((e=>va.toJson(e)))),t.set("tracks",e.tracks.map((e=>Ua.toJson(e)))),t.set("defaultsystemslayout",e.defaultSystemsLayout),t.set("systemslayout",e.systemsLayout),t.set("stylesheet",Xa.toJson(e.stylesheet)),e.style&&t.set("style",Ya.toJson(e.style)),t}static setProperty(e,t,s){switch(t){case"album":return e.album=s,!0;case"artist":return e.artist=s,!0;case"copyright":return e.copyright=s,!0;case"instructions":return e.instructions=s,!0;case"music":return e.music=s,!0;case"notices":return e.notices=s,!0;case"subtitle":return e.subTitle=s,!0;case"title":return e.title=s,!0;case"words":return e.words=s,!0;case"tab":return e.tab=s,!0;case"tempo":return e.tempo=s,!0;case"tempolabel":return e.tempoLabel=s,!0;case"masterbars":e.masterBars=[];for(const t of s){const s=new K;va.fromJson(s,t),e.addMasterBar(s)}return!0;case"tracks":e.tracks=[];for(const t of s){const s=new nt;Ua.fromJson(s,t),e.addTrack(s)}return!0;case"defaultsystemslayout":return e.defaultSystemsLayout=s,!0;case"systemslayout":return e.systemsLayout=s,!0;case"stylesheet":return Xa.fromJson(e.stylesheet,s),!0;case"style":return s?(e.style=new Je,Ya.fromJson(e.style,s)):e.style=void 0,!0}return!1}}class qa{static jsonReplacer(e,t){if(t instanceof Map){if("fromEntries"in Object)return Object.fromEntries(t);const e={};for(const[s,i]of t)e[s]=i;return e}return ArrayBuffer.isView(t)?Array.apply([],[t]):t}static scoreToJson(e){const t=qa.scoreToJsObject(e);return JSON.stringify(t,qa.jsonReplacer)}static jsonToScore(e,t){return qa.jsObjectToScore(JSON.parse(e),t)}static scoreToJsObject(e){return $a.toJson(e)}static jsObjectToScore(e,t){const s=new Ye;return $a.fromJson(s,e),s.finish(t??new ka),s}static settingsToJson(e){const t=qa.settingsToJsObject(e);return JSON.stringify(t,qa.jsonReplacer)}static jsonToSettings(e){return qa.jsObjectToSettings(JSON.parse(e))}static settingsToJsObject(e){return Ba.toJson(e)}static jsObjectToSettings(e){const t=new ka;return Ba.fromJson(t,e),t}static jsObjectToMidiFile(e){const t=new Fs;return aa.forEach(e,((e,s)=>{switch(s){case"division":t.division=e;break;case"tracks":for(const s of e){const e=qa.jsObjectToMidiTrack(s);t.tracks.push(e)}}})),t}static jsObjectToMidiTrack(e){const t=new Ps;return aa.forEach(e,((e,s)=>{if("events"===s)for(const s of e){const e=qa.jsObjectToMidiEvent(s);t.events.push(e)}})),t}static jsObjectToMidiEvent(t){const s=aa.getValue(t,"track"),i=aa.getValue(t,"tick"),a=aa.getValue(t,"type");switch(a){case Ot.TimeSignature:return new Es(s,i,aa.getValue(t,"numerator"),aa.getValue(t,"denominatorIndex"),aa.getValue(t,"midiClocksPerMetronomeClick"),aa.getValue(t,"thirdySecondNodesInQuarter"));case Ot.AlphaTabRest:return new Ls(s,i,aa.getValue(t,"channel"));case Ot.AlphaTabMetronome:return new Ms(s,i,aa.getValue(t,"metronomeNumerator"),aa.getValue(t,"metronomeDurationInTicks"),aa.getValue(t,"metronomeDurationInMilliseconds"));case Ot.NoteOn:return new Is(s,i,aa.getValue(t,"channel"),aa.getValue(t,"noteKey"),aa.getValue(t,"noteVelocity"));case Ot.NoteOff:return new Rs(s,i,aa.getValue(t,"channel"),aa.getValue(t,"noteKey"),aa.getValue(t,"noteVelocity"));case Ot.ControlChange:return new Os(s,i,aa.getValue(t,"channel"),aa.getValue(t,"controller"),aa.getValue(t,"value"));case Ot.ProgramChange:return new Hs(s,i,aa.getValue(t,"channel"),aa.getValue(t,"program"));case Ot.TempoChange:return new Ws(i,aa.getValue(t,"microSecondsPerQuarterNote"));case Ot.PitchBend:return new Vs(s,i,aa.getValue(t,"channel"),aa.getValue(t,"value"));case Ot.PerNotePitchBend:return new Gs(s,i,aa.getValue(t,"channel"),aa.getValue(t,"noteKey"),aa.getValue(t,"value"));case Ot.EndOfTrack:return new zs(s,i)}throw new qe(e.AlphaTabErrorType.Format,`Unknown Midi Event type: ${a}`)}static midiFileToJsObject(e){const t=new Map;t.set("division",e.division);const s=[];for(const t of e.tracks)s.push(qa.midiTrackToJsObject(t));return t.set("tracks",s),t}static midiTrackToJsObject(e){const t=new Map,s=[];for(const t of e.events)s.push(qa.midiEventToJsObject(t));return t.set("events",s),t}static midiEventToJsObject(e){const t=new Map;switch(t.set("track",e.track),t.set("tick",e.tick),t.set("type",e.type),e.type){case Ot.TimeSignature:t.set("numerator",e.numerator),t.set("denominatorIndex",e.denominatorIndex),t.set("midiClocksPerMetronomeClick",e.midiClocksPerMetronomeClick),t.set("thirdySecondNodesInQuarter",e.thirtySecondNodesInQuarter);break;case Ot.AlphaTabRest:t.set("channel",e.channel);break;case Ot.AlphaTabMetronome:t.set("metronomeNumerator",e.metronomeNumerator),t.set("metronomeDurationInMilliseconds",e.metronomeDurationInMilliseconds),t.set("metronomeDurationInTicks",e.metronomeDurationInTicks);break;case Ot.NoteOn:case Ot.NoteOff:t.set("channel",e.channel),t.set("noteKey",e.noteKey),t.set("noteVelocity",e.noteVelocity);break;case Ot.ControlChange:t.set("channel",e.channel),t.set("controller",e.controller),t.set("value",e.value);break;case Ot.ProgramChange:t.set("channel",e.channel),t.set("program",e.program);break;case Ot.TempoChange:t.set("microSecondsPerQuarterNote",e.microSecondsPerQuarterNote);break;case Ot.PitchBend:t.set("channel",e.channel),t.set("value",e.value);break;case Ot.PerNotePitchBend:t.set("channel",e.channel),t.set("noteKey",e.noteKey),t.set("value",e.value);case Ot.EndOfTrack:}return t}}class ja{constructor(){this.ready=new Zi,this.samplesPlayed=new ea,this.sampleRequest=new Zi}get sampleRate(){return ja.preferredSampleRate}open(){j.debug("AlphaSynth","Initializing synth worker"),this._worker=nc.globalThis,this._worker.addEventListener("message",this.handleMessage.bind(this)),this.ready.trigger()}destroy(){this._worker.postMessage({cmd:"alphaSynth.output.destroy"})}handleMessage(e){const t=e.data;switch(t.cmd){case ja.CmdOutputSampleRequest:this.sampleRequest.trigger();break;case ja.CmdOutputSamplesPlayed:this.samplesPlayed.trigger(t.samples)}}addSamples(e){this._worker.postMessage({cmd:"alphaSynth.output.addSamples",samples:e})}play(){this._worker.postMessage({cmd:"alphaSynth.output.play"})}pause(){this._worker.postMessage({cmd:"alphaSynth.output.pause"})}resetSamples(){this._worker.postMessage({cmd:"alphaSynth.output.resetSamples"})}activate(){}async enumerateOutputDevices(){return[]}async setOutputDevice(e){}async getOutputDevice(){return null}}ja.CmdOutputPrefix="alphaSynth.output.",ja.CmdOutputAddSamples=`${ja.CmdOutputPrefix}addSamples`,ja.CmdOutputPlay=`${ja.CmdOutputPrefix}play`,ja.CmdOutputPause=`${ja.CmdOutputPrefix}pause`,ja.CmdOutputResetSamples=`${ja.CmdOutputPrefix}resetSamples`,ja.CmdOutputStop=`${ja.CmdOutputPrefix}stop`,ja.CmdOutputSampleRequest=`${ja.CmdOutputPrefix}sampleRequest`,ja.CmdOutputSamplesPlayed=`${ja.CmdOutputPrefix}samplesPlayed`,ja.preferredSampleRate=0;class Ka{constructor(e,t){this._main=e,this._main.addEventListener("message",this.handleMessage.bind(this)),this._player=new ia(new ja,t),this._player.positionChanged.on(this.onPositionChanged.bind(this)),this._player.stateChanged.on(this.onPlayerStateChanged.bind(this)),this._player.finished.on(this.onFinished.bind(this)),this._player.soundFontLoaded.on(this.onSoundFontLoaded.bind(this)),this._player.soundFontLoadFailed.on(this.onSoundFontLoadFailed.bind(this)),this._player.soundFontLoadFailed.on(this.onSoundFontLoadFailed.bind(this)),this._player.midiLoaded.on(this.onMidiLoaded.bind(this)),this._player.midiLoadFailed.on(this.onMidiLoadFailed.bind(this)),this._player.readyForPlayback.on(this.onReadyForPlayback.bind(this)),this._player.midiEventsPlayed.on(this.onMidiEventsPlayed.bind(this)),this._player.playbackRangeChanged.on(this.onPlaybackRangeChanged.bind(this)),this._main.postMessage({cmd:"alphaSynth.ready"})}static init(){const e=nc.globalThis;e.addEventListener("message",(t=>{const s=t.data;if("alphaSynth.initialize"===s.cmd)ja.preferredSampleRate=s.sampleRate,j.logLevel=s.logLevel,nc.globalThis.alphaSynthWebWorker=new Ka(e,s.bufferTimeInMilliseconds)}))}handleMessage(e){const t=e.data;switch(t.cmd){case"alphaSynth.setLogLevel":j.logLevel=t.value;break;case"alphaSynth.setMasterVolume":this._player.masterVolume=t.value;break;case"alphaSynth.setMetronomeVolume":this._player.metronomeVolume=t.value;break;case"alphaSynth.setPlaybackSpeed":this._player.playbackSpeed=t.value;break;case"alphaSynth.setTickPosition":this._player.tickPosition=t.value;break;case"alphaSynth.setTimePosition":this._player.timePosition=t.value;break;case"alphaSynth.setPlaybackRange":this._player.playbackRange=t.value;break;case"alphaSynth.setIsLooping":this._player.isLooping=t.value;break;case"alphaSynth.setCountInVolume":this._player.countInVolume=t.value;break;case"alphaSynth.setMidiEventsPlayedFilter":this._player.midiEventsPlayedFilter=t.value;break;case"alphaSynth.play":this._player.play();break;case"alphaSynth.pause":this._player.pause();break;case"alphaSynth.playPause":this._player.playPause();break;case"alphaSynth.stop":this._player.stop();break;case"alphaSynth.playOneTimeMidiFile":this._player.playOneTimeMidiFile(qa.jsObjectToMidiFile(t.midi));break;case"alphaSynth.loadSoundFontBytes":this._player.loadSoundFont(t.data,t.append);break;case"alphaSynth.resetSoundFonts":this._player.resetSoundFonts();break;case"alphaSynth.loadMidi":this._player.loadMidiFile(qa.jsObjectToMidiFile(t.midi));break;case"alphaSynth.setChannelMute":this._player.setChannelMute(t.channel,t.mute);break;case"alphaSynth.setChannelTranspositionPitch":this._player.setChannelTranspositionPitch(t.channel,t.semitones);break;case"alphaSynth.setChannelSolo":this._player.setChannelSolo(t.channel,t.solo);break;case"alphaSynth.setChannelVolume":this._player.setChannelVolume(t.channel,t.volume);break;case"alphaSynth.resetChannelStates":this._player.resetChannelStates();break;case"alphaSynth.destroy":this._player.destroy(),this._main.postMessage({cmd:"alphaSynth.destroyed"});break;case"alphaSynth.applyTranspositionPitches":this._player.applyTranspositionPitches(new Map(JSON.parse(t.transpositionPitches)))}}onPositionChanged(e){this._main.postMessage({cmd:"alphaSynth.positionChanged",currentTime:e.currentTime,endTime:e.endTime,currentTick:e.currentTick,endTick:e.endTick,isSeek:e.isSeek})}onPlayerStateChanged(e){this._main.postMessage({cmd:"alphaSynth.playerStateChanged",state:e.state,stopped:e.stopped})}onFinished(){this._main.postMessage({cmd:"alphaSynth.finished"})}onSoundFontLoaded(){this._main.postMessage({cmd:"alphaSynth.soundFontLoaded"})}onSoundFontLoadFailed(e){this._main.postMessage({cmd:"alphaSynth.soundFontLoadFailed",error:this.serializeException(e)})}serializeException(e){const t=JSON.parse(JSON.stringify(e));return e.message&&(t.message=e.message),e.stack&&(t.stack=e.stack),e.constructor&&e.constructor.name&&(t.type=e.constructor.name),t}onMidiLoaded(e){this._main.postMessage({cmd:"alphaSynth.midiLoaded",currentTime:e.currentTime,endTime:e.endTime,currentTick:e.currentTick,endTick:e.endTick,isSeek:e.isSeek})}onMidiLoadFailed(e){this._main.postMessage({cmd:"alphaSynth.midiLoaded",error:this.serializeException(e)})}onReadyForPlayback(){this._main.postMessage({cmd:"alphaSynth.readyForPlayback"})}onMidiEventsPlayed(e){this._main.postMessage({cmd:"alphaSynth.midiEventsPlayed",events:e.events.map(qa.midiEventToJsObject)})}onPlaybackRangeChanged(e){this._main.postMessage({cmd:"alphaSynth.playbackRangeChanged",playbackRange:e.playbackRange})}}e.WebPlatform=void 0,(Qt=e.WebPlatform||(e.WebPlatform={}))[Qt.Browser=0]="Browser",Qt[Qt.NodeJs=1]="NodeJs",Qt[Qt.BrowserModule=2]="BrowserModule";class Qa{constructor(e,t){this.characterWidths=e,this.fontSizeToHeight=t}}class Za{static generateFontLookup(t){if(!Za.FontSizeLookupTables.has(t))if(nc.isRunningInWorker||nc.webPlatform===e.WebPlatform.NodeJs){const e=new Qa(new Uint8Array([8]),1.2);Za.FontSizeLookupTables.set(t,e)}else{const e=document.createElement("canvas").getContext("2d"),s=11;e.font=`${s}px ${t}`;const i=[];let a="";for(let t=Za.ControlChars;t<255;t++){const s=String.fromCharCode(t);a+=s;const r=e.measureText(s);i.push(r.width)}const r=e.measureText(`${a}ÄÖÜÁÈ`),n=0-Math.abs(r.fontBoundingBoxAscent),o=0+Math.abs(r.fontBoundingBoxDescent)-n,h=new Qa(new Uint8Array(i),o/s);Za.FontSizeLookupTables.set(t,h)}}static measureString(e,t,s,i,a){let r;let n=t[0];for(let e=0;e<t.length;e++)if(Za.FontSizeLookupTables.has(t[e])){n=t[e];break}Za.FontSizeLookupTables.has(n)||Za.generateFontLookup(n),r=Za.FontSizeLookupTables.get(n);let o=1;i===Yt.Italic&&(o*=1.1),a===$t.Bold&&(o*=1.1);let h=0;for(let t=0;t<e.length;t++){const i=Math.min(r.characterWidths.length-1,e.charCodeAt(t)-Za.ControlChars);i>=0&&(h+=r.characterWidths[i]*s/11)}return o*=1.07,new De(h*o,s*r.fontSizeToHeight)}}Za.FontSizeLookupTables=new Map,Za.ControlChars=32;class er{constructor(){this.id=ae.newGuid(),this.x=0,this.y=0,this.width=0,this.height=0,this.totalWidth=0,this.totalHeight=0,this.firstMasterBarIndex=-1,this.lastMasterBarIndex=-1,this.renderResult=null}}class tr{constructor(){this.beats=[]}addBeat(e){e.barBounds=this,this.beats.push(e),this.masterBarBounds.addBeat(e)}findBeatAtPos(e){let t=null;for(const s of this.beats)if(!t||s.realBounds.x<e)t=s;else if(s.realBounds.x>e)break;return t}finish(e=1){this.realBounds.scaleWith(e),this.visualBounds.scaleWith(e),this.beats.sort(((e,t)=>e.realBounds.x-t.realBounds.x));for(const t of this.beats)t.finish(e)}}class sr{constructor(){this.onNotesX=0,this.notes=null}addNote(e){this.notes||(this.notes=[]),e.beatBounds=this,this.notes.push(e)}findNoteAtPos(e,t){const s=this.notes;if(!s)return null;for(const i of s){const s=i.noteHeadBounds.y+i.noteHeadBounds.h,a=i.noteHeadBounds.x+i.noteHeadBounds.w;if(i.noteHeadBounds.x<=e&&i.noteHeadBounds.y<=t&&e<=a&&t<=s)return i.note}return null}finish(e=1){if(this.realBounds.scaleWith(e),this.visualBounds.scaleWith(e),this.onNotesX*=e,this.notes)for(const t of this.notes)t.finish(e)}}class ir{constructor(){this.index=0,this.isFirstOfLine=!1,this.bars=[],this.staffSystemBounds=null}get staveGroupBounds(){return this.staffSystemBounds}addBar(e){e.masterBarBounds=this,this.bars.push(e)}findBeatAtPos(e,t){let s=null;for(const t of this.bars){const i=t.findBeatAtPos(e);if(i&&(!s||s.realBounds.x<i.realBounds.x)){const t=Math.abs(i.realBounds.x-e);(!s||t<1e7)&&(s=i)}}return s?s.beat:null}finish(e=1){this.realBounds.scaleWith(e),this.visualBounds.scaleWith(e),this.lineAlignedBounds.scaleWith(e),this.bars.sort(((e,t)=>e.realBounds.y<t.realBounds.y?-1:e.realBounds.y>t.realBounds.y?1:e.realBounds.x<t.realBounds.x?-1:e.realBounds.x>t.realBounds.x?1:0));for(const t of this.bars)t.finish(e)}addBeat(e){this.staffSystemBounds.boundsLookup.addBeat(e)}}class ar{finish(e=1){this.noteHeadBounds.scaleWith(e)}}class rr{constructor(){this.index=0,this.bars=[]}finish(e=1){this.realBounds.scaleWith(e),this.visualBounds.scaleWith(e);for(const t of this.bars)t.finish(e)}addBar(e){this.boundsLookup.addMasterBar(e),e.staffSystemBounds=this,this.bars.push(e)}findBarAtPos(e){let t=null;for(const s of this.bars)if(!t||s.realBounds.x<e)t=s;else if(e>s.realBounds.x+s.realBounds.w)break;return t}}class nr{constructor(){this._beatLookup=new Map,this._masterBarLookup=new Map,this._currentStaffSystem=null,this.staffSystems=[],this.isFinished=!1}toJson(){const e={},t=[];e.staffSystems=t;for(const e of this.staffSystems){const s={};s.visualBounds=this.boundsToJson(e.visualBounds),s.realBounds=this.boundsToJson(e.realBounds),s.bars=[];for(const t of e.bars){const e={};e.lineAlignedBounds=this.boundsToJson(t.lineAlignedBounds),e.visualBounds=this.boundsToJson(t.visualBounds),e.realBounds=this.boundsToJson(t.realBounds),e.index=t.index,e.bars=[];for(const s of t.bars){const t={};t.visualBounds=this.boundsToJson(s.visualBounds),t.realBounds=this.boundsToJson(s.realBounds),t.beats=[];for(const e of s.beats){const s={};s.visualBounds=this.boundsToJson(e.visualBounds),s.realBounds=this.boundsToJson(e.realBounds),s.onNotesX=e.onNotesX;const i=s;if(i.beatIndex=e.beat.index,i.voiceIndex=e.beat.voice.index,i.barIndex=e.beat.voice.bar.index,i.staffIndex=e.beat.voice.bar.staff.index,i.trackIndex=e.beat.voice.bar.staff.track.index,e.notes){const t=[];s.notes=t;for(const s of e.notes){const e={};e.index=s.note.index,e.noteHeadBounds=this.boundsToJson(s.noteHeadBounds),t.push(e)}}t.beats.push(s)}e.bars.push(t)}s.bars.push(e)}t.push(s)}return e}static fromJson(e,t){const s=new nr,i=e.staffSystems;for(const e of i){const i=new rr;i.visualBounds=nr.boundsFromJson(e.visualBounds),i.realBounds=nr.boundsFromJson(e.realBounds),s.addStaffSystem(i);for(const s of e.bars){const e=new ir;e.index=s.index,e.isFirstOfLine=s.isFirstOfLine,e.lineAlignedBounds=nr.boundsFromJson(s.lineAlignedBounds),e.visualBounds=nr.boundsFromJson(s.visualBounds),e.realBounds=nr.boundsFromJson(s.realBounds),i.addBar(e);for(const i of s.bars){const s=new tr;s.visualBounds=nr.boundsFromJson(i.visualBounds),s.realBounds=nr.boundsFromJson(i.realBounds),e.addBar(s);for(const e of i.beats){const i=new sr;i.visualBounds=nr.boundsFromJson(e.visualBounds),i.realBounds=nr.boundsFromJson(e.realBounds),i.onNotesX=e.onNotesX;const a=e;if(i.beat=t.tracks[a.trackIndex].staves[a.staffIndex].bars[a.barIndex].voices[a.voiceIndex].beats[a.beatIndex],e.notes){i.notes=[];for(const t of e.notes){const e=new ar,s=t;e.note=i.beat.notes[s.index],e.noteHeadBounds=nr.boundsFromJson(t.noteHeadBounds),i.addNote(e)}}s.addBeat(i)}}}}return s}static boundsFromJson(e){const t=new ft;return t.x=e.x,t.y=e.y,t.w=e.w,t.h=e.h,t}boundsToJson(e){const t={};return t.x=e.x,t.y=e.y,t.w=e.w,t.h=e.h,t}finish(e=1){for(const t of this.staffSystems)t.finish(e);this.isFinished=!0}addStaffSystem(e){e.index=this.staffSystems.length,e.boundsLookup=this,this.staffSystems.push(e),this._currentStaffSystem=e}addMasterBar(e){e.staffSystemBounds?this._masterBarLookup.set(e.index,e):(e.staffSystemBounds=this._currentStaffSystem,this._masterBarLookup.set(e.index,e),this._currentStaffSystem.addBar(e))}addBeat(e){this._beatLookup.has(e.beat.id)||this._beatLookup.set(e.beat.id,[]),this._beatLookup.get(e.beat.id)?.push(e)}findMasterBarByIndex(e){return this._masterBarLookup.has(e)?this._masterBarLookup.get(e):null}findMasterBar(e){const t=e.index;return this._masterBarLookup.has(t)?this._masterBarLookup.get(t):null}findBeat(e){const t=this.findBeats(e);return t?t[0]:null}findBeats(e){const t=e.id;return this._beatLookup.has(t)?this._beatLookup.get(t):null}getBeatAtPos(e,t){let s=0,i=this.staffSystems.length-1,a=-1;for(;s<=i;){const e=(i+s)/2|0,r=this.staffSystems[e];if(t>=r.realBounds.y&&t<=r.realBounds.y+r.realBounds.h){a=e;break}t<r.realBounds.y?i=e-1:s=e+1}if(-1===a)return null;const r=this.staffSystems[a].findBarAtPos(e);return r?r.findBeatAtPos(e,t):null}getNoteAtPos(e,t,s){const i=this.findBeats(e);if(i)for(const e of i){const i=e.findNoteAtPos(t,s);if(i)return i}return null}}class or{constructor(t){this._currentLayoutMode=e.LayoutMode.Page,this._currentRenderEngine=null,this._renderedTracks=null,this.canvas=null,this.score=null,this.tracks=null,this.layout=null,this.boundsLookup=null,this.width=0,this.preRender=new ea,this.renderFinished=new ea,this.partialRenderFinished=new ea,this.partialLayoutFinished=new ea,this.postRenderFinished=new Zi,this.error=new ea,this.settings=t,this.recreateCanvas(),this.recreateLayout()}destroy(){this.score=null,this.canvas?.destroy(),this.canvas=null,this.layout=null,this.boundsLookup=null,this.tracks=null}recreateCanvas(){return this._currentRenderEngine!==this.settings.core.engine&&(this.canvas?.destroy(),this.canvas=nc.getRenderEngineFactory(this.settings.core.engine).createCanvas(),this._currentRenderEngine=this.settings.core.engine,!0)}recreateLayout(){return(!this.layout||this._currentLayoutMode!==this.settings.display.layoutMode)&&(this.layout=nc.getLayoutEngineFactory(this.settings.display.layoutMode).createLayout(this),this._currentLayoutMode=this.settings.display.layoutMode,!0)}renderScore(e,t){try{this.score=e;let s=null;if(null!=e&&null!=t){if(t){s=[];for(const i of t)i>=0&&i<e.tracks.length&&s.push(e.tracks[i])}else s=e.tracks.slice(0);0===s.length&&e.tracks.length>0&&s.push(e.tracks[0])}this.tracks=s,this.render()}catch(e){this.error.trigger(e)}}renderTracks(e){0===e.length?this.score=null:this.score=e[0].score,this.tracks=e,this.render()}updateSettings(e){this.settings=e}renderResult(e){try{const t=this.layout;t?(j.debug("Rendering",`Request render of lazy partial ${e}`),t.renderLazyPartial(e)):j.warning("Rendering",`Request render of lazy partial ${e} ignored, no layout exists`)}catch(e){this.error.trigger(e)}}render(){if(0!==this.width)if(this.boundsLookup=new nr,this.recreateCanvas(),this.canvas.lineWidth=1,this.canvas.settings=this.settings,this.tracks&&0!==this.tracks.length&&this.score){j.debug("Rendering",`Rendering ${this.tracks.length} tracks`);for(let e=0;e<this.tracks.length;e++){const t=this.tracks[e];j.debug("Rendering",`Track ${e}: ${t.name}`)}this.preRender.trigger(!1),this.recreateLayout(),this.layoutAndRender(),j.debug("Rendering","Rendering finished")}else j.debug("Rendering","Clearing rendered tracks because no score or tracks are set"),this.preRender.trigger(!1),this._renderedTracks=null,this.onRenderFinished(),this.postRenderFinished.trigger(),j.debug("Rendering","Clearing finished");else j.warning("Rendering","AlphaTab skipped rendering because of width=0 (element invisible)",null)}resizeRender(){this.recreateLayout()||this.recreateCanvas()||this._renderedTracks!==this.tracks||!this.tracks?(j.debug("Rendering","Starting full rerendering due to layout or canvas change",null),this.render()):this.layout.supportsResize?(j.debug("Rendering","Starting optimized rerendering for resize"),this.boundsLookup=new nr,this.preRender.trigger(!0),this.canvas.settings=this.settings,this.layout.resize(),this.onRenderFinished(),this.postRenderFinished.trigger()):j.debug("Rendering","Current layout does not support dynamic resizing, nothing was done",null),j.debug("Rendering","Resize finished")}layoutAndRender(){j.debug("Rendering",`Rendering at scale ${this.settings.display.scale} with layout ${this.layout.name}`,null),this.layout.layoutAndRender(),this._renderedTracks=this.tracks,this.onRenderFinished(),this.postRenderFinished.trigger()}onRenderFinished(){this.boundsLookup?.finish(this.settings.display.scale);const e=new er;e.totalHeight=this.layout.height,e.totalWidth=this.layout.width,e.renderResult=this.canvas.onRenderFinished(),this.renderFinished.trigger(e)}}class hr{constructor(e){this._main=e,this._main.addEventListener("message",this.handleMessage.bind(this),!1)}static init(){nc.globalThis.alphaTabWebWorker=new hr(nc.globalThis)}handleMessage(e){const t=e.data;switch(t?t.cmd:""){case"alphaTab.initialize":const e=qa.jsObjectToSettings(t.settings);j.logLevel=e.core.logLevel,this._renderer=new or(e),this._renderer.partialRenderFinished.on((e=>{this._main.postMessage({cmd:"alphaTab.partialRenderFinished",result:e})})),this._renderer.partialLayoutFinished.on((e=>{this._main.postMessage({cmd:"alphaTab.partialLayoutFinished",result:e})})),this._renderer.renderFinished.on((e=>{this._main.postMessage({cmd:"alphaTab.renderFinished",result:e})})),this._renderer.postRenderFinished.on((()=>{this._main.postMessage({cmd:"alphaTab.postRenderFinished",boundsLookup:this._renderer.boundsLookup?.toJson()??null})})),this._renderer.preRender.on((e=>{this._main.postMessage({cmd:"alphaTab.preRender",resize:e})})),this._renderer.error.on(this.error.bind(this));break;case"alphaTab.invalidate":this._renderer.render();break;case"alphaTab.resizeRender":this._renderer.resizeRender();break;case"alphaTab.renderResult":this._renderer.renderResult(t.resultId);break;case"alphaTab.setWidth":this._renderer.width=t.width;break;case"alphaTab.renderScore":this.updateFontSizes(t.fontSizes);const s=null==t.score?null:qa.jsObjectToScore(t.score,this._renderer.settings);this.renderMultiple(s,t.trackIndexes);break;case"alphaTab.updateSettings":this.updateSettings(t.settings)}}updateFontSizes(e){if(!(e instanceof Map)){const t=e;e=new Map;for(const s in t)e.set(s,t[s])}if(e){Za.FontSizeLookupTables||(Za.FontSizeLookupTables=new Map);for(const[t,s]of e)Za.FontSizeLookupTables.set(t,s)}}updateSettings(e){Ba.fromJson(this._renderer.settings,e)}renderMultiple(e,t){try{this._renderer.renderScore(e,t)}catch(e){this.error(e)}}error(e){j.error("Worker","An unexpected error occurred in worker",e),this._main.postMessage({cmd:"alphaTab.error",error:e})}}class lr{constructor(){this._canvas=null,this._color=new tt(0,0,0,255),this._font=new oa("Arial",10,Yt.Plain),this._lineWidth=0;const e=document.createElement("span");e.classList.add("at"),document.body.appendChild(e);const t=window.getComputedStyle(e);let s=t.fontFamily;(s.startsWith('"')||s.startsWith("'"))&&(s=s.substr(1,s.length-2)),this._musicFont=new oa(s,Number.parseFloat(t.fontSize),Yt.Plain),this._measureCanvas=document.createElement("canvas"),this._measureCanvas.width=10,this._measureCanvas.height=10,this._measureCanvas.style.width="10px",this._measureCanvas.style.height="10px",this._measureContext=this._measureCanvas.getContext("2d"),this._measureContext.textBaseline="hanging"}destroy(){}onRenderFinished(){return null}beginRender(e,t){const s=this.settings.display.scale;this._canvas=document.createElement("canvas"),this._canvas.width=e*nc.HighDpiFactor|0,this._canvas.height=t*nc.HighDpiFactor|0,this._canvas.style.width=`${e}px`,this._canvas.style.height=`${t}px`,this._context=this._canvas.getContext("2d"),this._context.textBaseline="hanging",this._context.scale(nc.HighDpiFactor*s,nc.HighDpiFactor*s),this._context.lineWidth=this._lineWidth}endRender(){const e=this._canvas;return this._canvas=null,e}get color(){return this._color}set color(e){this._color.rgba!==e.rgba&&(this._color=e,this._context.strokeStyle=e.rgba,this._context.fillStyle=e.rgba)}get lineWidth(){return this._lineWidth}set lineWidth(e){this._lineWidth=e,this._context&&(this._context.lineWidth=e)}fillRect(e,t,s,i){s>0&&this._context.fillRect(0|e,0|t,s,i)}strokeRect(e,t,s,i){const a=this.lineWidth%2==0?0:.5;this._context.strokeRect((0|e)+a,(0|t)+a,s,i)}beginPath(){this._context.beginPath()}closePath(){this._context.closePath()}moveTo(e,t){this._context.moveTo(e,t)}lineTo(e,t){this._context.lineTo(e,t)}quadraticCurveTo(e,t,s,i){this._context.quadraticCurveTo(e,t,s,i)}bezierCurveTo(e,t,s,i,a,r){this._context.bezierCurveTo(e,t,s,i,a,r)}fillCircle(e,t,s){this._context.beginPath(),this._context.arc(e,t,s,0,2*Math.PI,!0),this.fill()}strokeCircle(e,t,s){this._context.beginPath(),this._context.arc(e,t,s,0,2*Math.PI,!0),this.stroke()}fill(){this._context.fill(),this._context.beginPath()}stroke(){this._context.stroke(),this._context.beginPath()}get font(){return this._font}set font(e){this._font=e,this._context&&(this._context.font=e.toCssString(1)),this._measureContext.font=e.toCssString(1)}get textAlign(){switch(this._context.textAlign){case"left":default:return oe.Left;case"center":return oe.Center;case"right":return oe.Right}}set textAlign(e){switch(e){case oe.Left:this._context.textAlign="left";break;case oe.Center:this._context.textAlign="center";break;case oe.Right:this._context.textAlign="right"}}get textBaseline(){switch(this._context.textBaseline){case"hanging":default:return he.Top;case"middle":return he.Middle;case"bottom":return he.Bottom}}set textBaseline(e){switch(e){case he.Top:this._context.textBaseline="hanging";break;case he.Middle:this._context.textBaseline="middle";break;case he.Bottom:this._context.textBaseline="bottom"}}beginGroup(e){}endGroup(){}fillText(e,t,s){this._context.fillText(e,t,s)}measureText(e){const t=this._measureContext.measureText(e);return new De(t.width,t.actualBoundingBoxDescent+t.actualBoundingBoxAscent)}fillMusicFontSymbol(e,t,s,i,a=!1){i!==ne.None&&this.fillMusicFontSymbolText(e,t,s,String.fromCharCode(i),a)}fillMusicFontSymbols(e,t,s,i,a=!1){let r="";for(const e of i)e!==ne.None&&(r+=String.fromCharCode(e));this.fillMusicFontSymbolText(e,t,s,r,a)}fillMusicFontSymbolText(e,t,s,i,a){const r=this._context.textAlign,n=this._context.textBaseline,o=this._context.font;this._context.font=this._musicFont.toCssString(s),this._context.textBaseline="middle",this._context.textAlign=a?"center":"left",this._context.fillText(i,e,t),this._context.textBaseline=n,this._context.font=o,this._context.textAlign=r}beginRotate(e,t,s){this._context.save(),this._context.translate(e,t),this._context.rotate(s*Math.PI/180)}endRotate(){this._context.restore()}}class cr{constructor(e,t=!1){this._midiFile=e,this._smf1Mode=t}addTimeSignature(e,t,s){let i=0,a=s;for(;a>>=1,a>0;)i++;this._midiFile.addEvent(new Es(0,e,t,i,48,8))}addRest(e,t,s){this._smf1Mode||this._midiFile.addEvent(new Ls(e,t,s))}addNote(e,t,s,i,a,r){this._midiFile.addEvent(new Is(e,t,r,cr.fixValue(i),cr.fixValue(a))),this._midiFile.addEvent(new Rs(e,t+s,r,cr.fixValue(i),cr.fixValue(a)))}static fixValue(e){return e>127?127:e<0?0:e}addControlChange(e,t,s,i,a){this._midiFile.addEvent(new Os(e,t,s,i,cr.fixValue(a)))}addProgramChange(e,t,s,i){this._midiFile.addEvent(new Hs(e,t,s,i))}addTempo(e,t){const s=6e7/t|0;this._midiFile.addEvent(new Ws(e,s))}addBend(e,t,s,i){i=i>=Q.MaxPitchWheel?Q.MaxPitchWheel:Math.floor(i),this._midiFile.addEvent(new Vs(e,t,s,i))}addNoteBend(e,t,s,i,a){this._smf1Mode?this.addBend(e,t,s,a):(a=a*Q.MaxPitchWheel20/Q.MaxPitchWheel,this._midiFile.addEvent(new Gs(e,t,s,i,a)))}finishTrack(e,t){this._midiFile.format!==Rt.MultiTrack&&0!==e||this._midiFile.addEvent(new zs(e,t))}}class dr{constructor(e,t){this.closingIndex=0,this.group=e,this.opening=t,e.closings=e.closings.sort(((e,t)=>e.index-t.index)),this.iterations=e.closings.map((e=>0))}}!function(e){e[e.PlayingNormally=0]="PlayingNormally",e[e.DirectionJumped=1]="DirectionJumped",e[e.DirectionJumpedAlCoda=2]="DirectionJumpedAlCoda",e[e.DirectionJumpedAlDoubleCoda=3]="DirectionJumpedAlDoubleCoda",e[e.DirectionJumpedAlFine=4]="DirectionJumpedAlFine"}(Zt||(Zt={}));class ur{get finished(){return this.index>=this._score.masterBars.length}constructor(e){this._repeatStack=[],this._groupsOnStack=new Set,this._previousAlternateEndings=0,this._state=Zt.PlayingNormally,this.shouldPlay=!0,this.index=0,this.currentTick=0,this._score=e}processCurrent(){const e=this._score.masterBars[this.index];if(this._state===Zt.PlayingNormally){let t=e.alternateEndings;if(0===t&&(t=this._previousAlternateEndings),e===e.repeatGroup.opening&&e.repeatGroup.isClosed&&!this._groupsOnStack.has(e.repeatGroup)){const s=new dr(e.repeatGroup,e);this._repeatStack.push(s),this._groupsOnStack.add(e.repeatGroup),this._previousAlternateEndings=0,t=e.alternateEndings}if(0===this._repeatStack.length||0===t)this.shouldPlay=!0;else{const e=this._repeatStack[this._repeatStack.length-1],s=e.iterations[e.closingIndex];this._previousAlternateEndings=t,this.shouldPlay=!!(t&1<<s)}}else this.shouldPlay=!0;this.shouldPlay&&(this.currentTick+=e.calculateDuration())}moveNext(){this.moveNextWithDirections()||this.moveNextWithNormalRepeats()}resetRepeats(){this._groupsOnStack.clear(),this._previousAlternateEndings=0,this._repeatStack=[]}handleDaCapo(e,t,s){return!!e.has(t)&&(this.index=0,this._state=s,this.resetRepeats(),!0)}handleDalSegno(e,t,s,i){if(e.has(t)){const e=this.findJumpTarget(i,this.index,!0);return-1!==e&&(this.index=e,this._state=s,this.resetRepeats(),!0)}return!1}handleDaCoda(e,t,s){if(e.has(t)){const e=this.findJumpTarget(s,this.index,!1);return-1===e?(this.index++,!0):(this.index=e,this._state=Zt.PlayingNormally,!0)}return!1}moveNextWithDirections(){const e=this._score.masterBars[this.index],t=null!==e.directions&&e.directions.size>0;if(this._state===Zt.PlayingNormally&&!t)return!1;if(!t)return this.index++,!0;switch(this._state){case Zt.PlayingNormally:return!!(this.handleDaCapo(e.directions,ke.JumpDaCapo,Zt.DirectionJumped)||this.handleDaCapo(e.directions,ke.JumpDaCapoAlCoda,Zt.DirectionJumpedAlCoda)||this.handleDaCapo(e.directions,ke.JumpDaCapoAlDoubleCoda,Zt.DirectionJumpedAlDoubleCoda)||this.handleDaCapo(e.directions,ke.JumpDaCapoAlFine,Zt.DirectionJumpedAlFine))||(!!(this.handleDalSegno(e.directions,ke.JumpDalSegno,Zt.DirectionJumped,ke.TargetSegno)||this.handleDalSegno(e.directions,ke.JumpDalSegnoAlCoda,Zt.DirectionJumpedAlCoda,ke.TargetSegno)||this.handleDalSegno(e.directions,ke.JumpDalSegnoAlDoubleCoda,Zt.DirectionJumpedAlDoubleCoda,ke.TargetSegno)||this.handleDalSegno(e.directions,ke.JumpDalSegnoAlFine,Zt.DirectionJumpedAlFine,ke.TargetSegno))||!!(this.handleDalSegno(e.directions,ke.JumpDalSegnoSegno,Zt.DirectionJumped,ke.TargetSegnoSegno)||this.handleDalSegno(e.directions,ke.JumpDalSegnoSegnoAlCoda,Zt.DirectionJumpedAlCoda,ke.TargetSegnoSegno)||this.handleDalSegno(e.directions,ke.JumpDalSegnoSegnoAlDoubleCoda,Zt.DirectionJumpedAlDoubleCoda,ke.TargetSegnoSegno)||this.handleDalSegno(e.directions,ke.JumpDalSegnoSegnoAlFine,Zt.DirectionJumpedAlFine,ke.TargetSegnoSegno)));case Zt.DirectionJumped:return this.index++,!0;case Zt.DirectionJumpedAlCoda:return this.handleDaCoda(e.directions,ke.JumpDaCoda,ke.TargetCoda)||this.index++,!0;case Zt.DirectionJumpedAlDoubleCoda:return this.handleDaCoda(e.directions,ke.JumpDaDoubleCoda,ke.TargetDoubleCoda)||this.index++,!0;case Zt.DirectionJumpedAlFine:return e.directions.has(ke.TargetFine)?(this.index=this._score.masterBars.length,!0):(this.index++,!0)}return!0}findJumpTarget(e,t,s){let i;return s?(i=this.findJumpTargetBackwards(e,t),-1===i&&(i=this.findJumpTargetForwards(e,t)),i):(i=this.findJumpTargetForwards(e,t),-1===i&&(i=this.findJumpTargetBackwards(e,t)),i)}findJumpTargetForwards(e,t){let s=t;for(;s<this._score.masterBars.length;){const t=this._score.masterBars[s].directions;if(t&&t.has(e))return s;s++}return-1}findJumpTargetBackwards(e,t){let s=t;for(;s>=0;){const t=this._score.masterBars[s].directions;if(t&&t.has(e))return s;s--}return-1}moveNextWithNormalRepeats(){const e=this._score.masterBars[this.index].repeatCount-1;if(this._repeatStack.length>0&&e>0){const t=this._repeatStack[this._repeatStack.length-1];if(t.iterations[t.closingIndex]<e){this.index=t.opening.index,t.iterations[t.closingIndex]++;for(let e=0;e<t.closingIndex;e++)t.iterations[e]=0;t.closingIndex=0,this._previousAlternateEndings=0}else t.closingIndex<t.group.closings.length-1?(t.closingIndex++,this.index++):(this._repeatStack.pop(),this._groupsOnStack.delete(t.group),this.index++)}else this.index++}}class pr{constructor(e,t){this.beat=e,this.playbackStart=t}}class gr{get duration(){return this.end-this.start}constructor(e,t){this._highlightedBeats=new Map,this.highlightedBeats=[],this.nextBeat=null,this.previousBeat=null,this.start=e,this.end=t}highlightBeat(e,t){e.isEmpty&&!e.voice.isEmpty||this._highlightedBeats.has(e.id)||(this._highlightedBeats.set(e.id,!0),this.highlightedBeats.push(new pr(e,t)))}getVisibleBeatAtStart(e){for(const t of this.highlightedBeats)if(t.playbackStart===this.start&&e.has(t.beat.voice.bar.staff.track.index))return t.beat;return null}}class mr{constructor(e,t){this.tick=e,this.tempo=t}}class fr{constructor(){this.start=0,this.end=0,this.tempoChanges=[],this.firstBeat=null,this.lastBeat=null,this.nextMasterBar=null,this.previousMasterBar=null}get tempo(){return this.tempoChanges[0].tempo}insertAfter(e,t){null==this.firstBeat||null==e||null==this.lastBeat?(this.firstBeat=t,this.lastBeat=t):(t.nextBeat=e.nextBeat,t.previousBeat=e,e.nextBeat&&(e.nextBeat.previousBeat=t),e.nextBeat=t,e===this.lastBeat&&(this.lastBeat=t))}insertBefore(e,t){null==this.firstBeat||null==e||null==this.lastBeat?(this.firstBeat=t,this.lastBeat=t):(t.previousBeat=e.previousBeat,t.nextBeat=e,e.previousBeat&&(e.previousBeat.nextBeat=t),e.previousBeat=t,e===this.firstBeat&&(this.firstBeat=t))}addBeat(t,s,i,a){const r=i+a;if(null==this.firstBeat){const e=new gr(i,r);e.highlightBeat(t,s),this.insertAfter(this.firstBeat,e)}else if(i>=this.lastBeat.end){const e=new gr(this.lastBeat.end,r);e.highlightBeat(t,s),this.insertAfter(this.lastBeat,e)}else{let a=null;if(i<this.firstBeat.start)a=this.firstBeat;else{let t=this.firstBeat;for(;null!=t;){if(i>=t.start&&i<t.end){a=t;break}t=t.nextBeat}if(null===a)throw new qe(e.AlphaTabErrorType.General,"Error on building lookup, unknown variant")}if(i<a.start)if(r===a.start){const e=new gr(i,a.start);e.highlightBeat(t,s),this.insertBefore(this.firstBeat,e)}else if(r<a.end){const e=new gr(i,a.start);e.highlightBeat(t,s),this.insertBefore(a,e);const n=new gr(a.start,r);for(const e of a.highlightedBeats)n.highlightBeat(e.beat,e.playbackStart);n.highlightBeat(t,s),this.insertBefore(a,n),a.start=r}else if(r===a.end){const e=new gr(i,a.start);e.highlightBeat(t,s),a.highlightBeat(t,s),this.insertBefore(a,e)}else{const e=new gr(i,a.start);e.highlightBeat(t,s),a.highlightBeat(t,s),this.insertBefore(a,e),this.addBeat(t,s,a.end,r-a.end)}else if(i>a.start)if(r===a.end){const e=new gr(a.start,i);for(const t of a.highlightedBeats)e.highlightBeat(t.beat,t.playbackStart);a.start=i,a.highlightBeat(t,s),this.insertBefore(a,e)}else if(r<a.end){const e=new gr(a.start,i);this.insertBefore(a,e);const n=new gr(i,r);this.insertBefore(a,n);for(const t of a.highlightedBeats)e.highlightBeat(t.beat,t.playbackStart),n.highlightBeat(t.beat,t.playbackStart);n.highlightBeat(t,s),a.start=r}else{const e=new gr(a.start,i);for(const t of a.highlightedBeats)e.highlightBeat(t.beat,t.playbackStart);a.start=i,a.highlightBeat(t,s),this.insertBefore(a,e),this.addBeat(t,s,a.end,r-a.end)}else if(r===a.end)a.highlightBeat(t,s);else if(r<a.end){const e=new gr(a.start,r);for(const t of a.highlightedBeats)e.highlightBeat(t.beat,t.playbackStart);e.highlightBeat(t,s),a.start=r,this.insertBefore(a,e)}else a.highlightBeat(t,s),this.addBeat(t,s,a.end,r-a.end)}}}!function(e){e[e.Unknown=0]="Unknown",e[e.ToNextBext=1]="ToNextBext",e[e.ToEndOfBar=2]="ToEndOfBar"}(es||(es={}));class yr{get start(){return this.masterBar.start+this.beatLookup.start}get end(){return this.start+this.tickDuration}constructor(e){this.nextBeat=null,this.tickDuration=0,this.duration=0,this.cursorMode=es.Unknown,this.masterBar=e}calculateDuration(){if(1===this.masterBar.tempoChanges.length)this.duration=U.ticksToMillis(this.tickDuration,this.masterBar.tempoChanges[0].tempo);else{let e=0,t=this.start,s=this.masterBar.tempoChanges[0].tempo;const i=this.end;for(const a of this.masterBar.tempoChanges)if(a.tick<t)s=a.tempo;else{if(a.tick>i)break;e+=U.ticksToMillis(a.tick-t,s),s=a.tempo,t=a.tick}i>t&&(e+=U.ticksToMillis(i-t,s)),this.duration=e}}}class br{constructor(){this._currentMasterBar=null,this.masterBarLookup=new Map,this.masterBars=[],this.multiBarRestInfo=null}findBeat(e,t,s=null){let i=null;return s&&(i=this.findBeatFast(e,s,t)),i||(i=this.findBeatSlow(e,s,t,!1)),i}findBeatFast(e,t,s){if(s>=t.start&&s<t.end)return t;if(t.nextBeat&&s>=t.nextBeat.start&&s<t.nextBeat.end){const s=t.nextBeat;return this.fillNextBeat(s,e),s}return null}fillNextBeatMultiBarRest(e,t){const s=this.multiBarRestInfo.get(e.masterBar.masterBar.index);let i=e.masterBar;for(let e=0;e<s.length&&i;e++)i=i.nextMasterBar;i?i.nextMasterBar?(e.nextBeat=this.firstBeatInMasterBar(t,i.nextMasterBar,i.nextMasterBar.start,!0),e.nextBeat?(e.tickDuration=e.nextBeat.start-e.start,e.cursorMode=es.ToNextBext,e.nextBeat.masterBar.masterBar.index!==i.masterBar.index+1&&(e.nextBeat.masterBar.masterBar.index!==i.masterBar.index||e.nextBeat.beat.playbackStart<=e.beat.playbackStart)&&(e.cursorMode=es.ToEndOfBar)):(e.tickDuration=i.nextMasterBar.end-e.start,e.cursorMode=es.ToEndOfBar)):(e.tickDuration=i.end-e.start,e.cursorMode=es.ToEndOfBar):(j.warning("Synth","MultiBar Rest Info and the nextMasterBar are out of sync, this is an unexpected error. Please report it as bug.  (broken chain fill-next)"),e.tickDuration=(e.masterBar.end-e.masterBar.start)*(s.length+1),e.cursorMode=es.ToEndOfBar),e.calculateDuration()}fillNextBeat(e,t){this.isMultiBarRestResult(e)?this.fillNextBeatMultiBarRest(e,t):this.fillNextBeatDefault(e,t)}fillNextBeatDefault(e,t){e.nextBeat=this.findBeatInMasterBar(e.masterBar,e.beatLookup.nextBeat,e.end,t,!0),null==e.nextBeat&&(e.nextBeat=this.findBeatSlow(t,e,e.end,!0)),e.nextBeat?(e.tickDuration=e.nextBeat.start-e.start,e.cursorMode=es.ToNextBext,e.calculateDuration()):(e.tickDuration=e.masterBar.end-e.start,e.cursorMode=es.ToEndOfBar,e.calculateDuration()),e.nextBeat&&e.nextBeat.masterBar.masterBar.index!==e.masterBar.masterBar.index+1&&(e.nextBeat.masterBar.masterBar.index!==e.masterBar.masterBar.index||e.nextBeat.beat.playbackStart<=e.beat.playbackStart)&&(e.cursorMode=es.ToEndOfBar)}isMultiBarRestResult(e){return this.internalIsMultiBarRestResult(e.masterBar.masterBar.index,e.beat)}internalIsMultiBarRestResult(e,t){return this.multiBarRestInfo&&this.multiBarRestInfo.has(e)&&t.isRest&&t.voice.bar.isRestOnly}findBeatSlow(e,t,s,i){let a=null;return null!=t&&(t.masterBar.start<=s&&t.masterBar.end>s?a=t.masterBar:t.masterBar.nextMasterBar&&t.masterBar.nextMasterBar.start<=s&&t.masterBar.nextMasterBar.end>s&&(a=t.masterBar.nextMasterBar)),a||(a=this.findMasterBar(s)),a?this.firstBeatInMasterBar(e,a,s,i):null}firstBeatInMasterBar(e,t,s,i){let a=t;for(;a;){if(a.firstBeat){const t=this.findBeatInMasterBar(a,a.firstBeat,s,e,i);if(t)return t}a=a.nextMasterBar}return null}findBeatInMasterBar(e,t,s,i,a){if(!t)return null;let r=null,n=null;const o=s-e.start;for(;null!=t&&null==n;){if((t.start<=o||a&&o<0)&&o<t.end){if(r=t,n=t.getVisibleBeatAtStart(i),!n)if(a){let s=e;for(;null!=s&&null==n;){for(;null!=t;){if(n=t.getVisibleBeatAtStart(i),n){r=t,e=s;break}t=t.nextBeat}n&&r||(s=s.nextMasterBar,t=s?.firstBeat??null)}}else{let s=e;for(;null!=s&&null==n;){for(;null!=t;){if(n=t.getVisibleBeatAtStart(i),n){r=t,e=s;break}t=t.previousBeat}n&&r||(s=s.previousMasterBar,t=s?.firstBeat??null)}}}else if(t.end>o)break;t=t?.nextBeat??null}if(null==n)return null;return this.createResult(e,r,n,a,i)}createResult(e,t,s,i,a){const r=new yr(e);if(r.beat=s,r.beatLookup=t,r.tickDuration=t.end-t.start,i){if(this.isMultiBarRestResult(r)){const s=this.multiBarRestInfo.get(e.masterBar.index);let i=e;for(let e=0;e<s.length&&i;e++)i=i.nextMasterBar;i?i.nextMasterBar?r.tickDuration=i.nextMasterBar.start-t.start:r.tickDuration=i.end-t.start:j.warning("Synth","MultiBar Rest Info and the nextMasterBar are out of sync, this is an unexpected error. Please report it as bug.  (broken chain stretch-result)")}}else this.fillNextBeat(r,a);return r.calculateDuration(),r}findMasterBar(e){const t=this.masterBars;let s=0,i=t.length-1;for(;s<=i;){const a=(i+s)/2|0,r=t[a];if(e>=r.start&&e<r.end)return r;e<r.start?i=a-1:s=a+1}return null}getMasterBar(e){if(!this.masterBarLookup.has(e.index)){const t=new fr;return t.masterBar=e,t}return this.masterBarLookup.get(e.index)}getMasterBarStart(e){return this.masterBarLookup.has(e.index)?this.masterBarLookup.get(e.index).start:0}getBeatStart(e){return this.masterBarLookup.has(e.voice.bar.index)?this.masterBarLookup.get(e.voice.bar.index).start+e.playbackStart:0}addMasterBar(e){this.masterBars.push(e),this._currentMasterBar&&(e.previousMasterBar=this._currentMasterBar,this._currentMasterBar.nextMasterBar=e),this._currentMasterBar=e,this.masterBarLookup.has(e.masterBar.index)||this.masterBarLookup.set(e.masterBar.index,e)}addBeat(e,t,s){const i=this._currentMasterBar;if(i)if(t<0&&i.previousMasterBar){const a=i.previousMasterBar.end-i.previousMasterBar.start,r=a+t,n=r+s;if(i.previousMasterBar.addBeat(e,r,r,s),n>a){const a=s+t;i.addBeat(e,t,0,a)}}else i.addBeat(e,t,t,s)}}class Sr{constructor(){this.noteOnly=0,this.untilTieOrSlideEnd=0,this.letRingEnd=0}}class _r{constructor(){this.firstBeatDuration=0,this.secondBeatStartOffset=0,this.secondBeatDuration=0}}class wr{constructor(){this.durations=[],this.brushInfos=[]}}class Br{constructor(e,t,s){this._programsPerChannel=new Map,this._currentTime=0,this._calculatedBeatTimers=new Set,this.tickLookup=new br,this.applyTranspositionPitches=!0,this.transpositionPitches=new Map,this._currentTripletFeel=null,this.vibratoResolution=16,this._score=e,this._settings=t||new ka,this._handler=s}generate(){this.transpositionPitches.clear(),this._calculatedBeatTimers.clear(),this._currentTime=0;for(const e of this._score.tracks)this.generateTrack(e);j.debug("Midi","Begin midi generation");const e=new ur(this._score);let t=null,s=this._score.tempo;for(;!e.finished;){const i=e.index,a=this._score.masterBars[i],r=e.currentTick;if(e.processCurrent(),e.shouldPlay){this.generateMasterBar(a,t,r,s),a.tempoAutomations.length>0&&(s=a.tempoAutomations[0].value);for(const e of this._score.tracks)for(const t of e.staves)i<t.bars.length&&this.generateBar(t.bars[i],r,s);a.tempoAutomations.length>0&&(s=a.tempoAutomations[a.tempoAutomations.length-1].value)}e.moveNext(),t=a}for(const t of this._score.tracks)this._handler.finishTrack(t.index,e.currentTick);j.debug("Midi","Midi generation done")}generateTrack(e){this.generateChannel(e,e.playbackInfo.primaryChannel,e.playbackInfo),e.playbackInfo.primaryChannel!==e.playbackInfo.secondaryChannel&&this.generateChannel(e,e.playbackInfo.secondaryChannel,e.playbackInfo)}addProgramChange(e,t,s,i){this._programsPerChannel.has(s)&&this._programsPerChannel.get(s)===i||(this._handler.addProgramChange(e.index,t,s,i),this._programsPerChannel.set(s,i))}static buildTranspositionPitches(e,t){const s=new Map;for(const i of e.tracks){const e=i.index<t.notation.transpositionPitches.length?t.notation.transpositionPitches[i.index]:-i.staves[0].transpositionPitch;s.set(i.playbackInfo.primaryChannel,e),s.set(i.playbackInfo.secondaryChannel,e)}return s}generateChannel(e,t,s){const i=e.index<this._settings.notation.transpositionPitches.length?this._settings.notation.transpositionPitches[e.index]:-e.staves[0].transpositionPitch;this.transpositionPitches.set(t,i);const a=Br.toChannelShort(s.volume),r=Br.toChannelShort(s.balance);this._handler.addControlChange(e.index,0,t,Jt.VolumeCoarse,a),this._handler.addControlChange(e.index,0,t,Jt.PanCoarse,r),this._handler.addControlChange(e.index,0,t,Jt.ExpressionControllerCoarse,127),this._handler.addControlChange(e.index,0,t,Jt.RegisteredParameterFine,0),this._handler.addControlChange(e.index,0,t,Jt.RegisteredParameterCourse,0),this._handler.addControlChange(e.index,0,t,Jt.DataEntryFine,0),this._handler.addControlChange(e.index,0,t,Jt.DataEntryCoarse,Br.PitchBendRangeInSemitones),this.addProgramChange(e,0,t,s.program)}static toChannelShort(e){const t=Math.max(-32768,Math.min(32767,8*e-1));return Math.max(t,-1)+1}generateMasterBar(e,t,s,i){t&&t.timeSignatureDenominator===e.timeSignatureDenominator&&t.timeSignatureNumerator===e.timeSignatureNumerator||this._handler.addTimeSignature(s,e.timeSignatureNumerator,e.timeSignatureDenominator);const a=e.calculateDuration(),r=new fr;if(e.tempoAutomations.length>0){e.tempoAutomations[0].ratioPosition>0&&r.tempoChanges.push(new mr(s,i));for(const t of e.tempoAutomations){const e=s+a*t.ratioPosition;this._handler.addTempo(e,t.value),r.tempoChanges.push(new mr(e,t.value))}}else t?r.tempoChanges.push(new mr(s,i)):(this._handler.addTempo(s,e.score.tempo),r.tempoChanges.push(new mr(s,e.score.tempo)));r.masterBar=e,r.start=s,r.end=r.start+a,this.tickLookup.addMasterBar(r)}generateBar(e,t,s){const i=this.getPlaybackBar(e),a=this._currentTime;for(const r of i.voices)this._currentTime=a,this.generateVoice(r,t,e,s);const r=i.masterBar,n=r.calculateDuration(),o=r.tempoAutomations.slice();if(0===o.length)this._currentTime=a+U.ticksToMillis(n,s);else{this._currentTime=a;let e=t,i=s;const r=t+n;for(const t of o){const s=n*t.ratioPosition-e;s>0&&(this._currentTime+=U.ticksToMillis(s,i)),i=t.value,e+=s}const h=r-e;h>0&&(this._currentTime+=U.ticksToMillis(h,i))}i.id!==e.id&&this.tickLookup.addBeat(e.voices[0].beats[0],0,n)}getPlaybackBar(e){switch(e.simileMark){case l.Simple:e.previousBar&&(e=this.getPlaybackBar(e.previousBar));break;case l.FirstOfDouble:case l.SecondOfDouble:e.previousBar&&e.previousBar.previousBar&&(e=this.getPlaybackBar(e.previousBar.previousBar))}return e}generateVoice(e,t,s,i){if(e.isEmpty&&(!e.bar.isEmpty||0!==e.index))return;const a=s.masterBar.tempoAutomations.slice();let r=i;const n=s.masterBar.calculateDuration();for(const i of e.beats){const e=i.playbackStart/n;for(;a.length>0&&a[0].ratioPosition<=e;)r=a.shift().value;this.generateBeat(i,t,s,r)}}generateBeat(e,t,s,i){let a=e.playbackStart,r=e.playbackDuration;const n=e.voice.bar.masterBar.calculateDuration();e.voice.bar.isEmpty?r=n:e.voice.bar.masterBar.tripletFeel!==A.NoTripletFeel&&this._settings.player.playTripletFeel&&(this._currentTripletFeel?(a-=this._currentTripletFeel.secondBeatStartOffset,r=this._currentTripletFeel.secondBeatDuration,this._currentTripletFeel=null):(this._currentTripletFeel=Br.calculateTripletFeelInfo(a,r,e),this._currentTripletFeel&&(r=this._currentTripletFeel.firstBeatDuration))),e.showTimer&&!this._calculatedBeatTimers.has(e.id)&&(e.timer=this._currentTime,this._calculatedBeatTimers.add(e.id)),this._currentTime+=U.ticksToMillis(r,i),s===e.voice.bar&&this.tickLookup.addBeat(e,a,r);const o=e.voice.bar.staff.track;for(const s of e.automations)this.generateNonTempoAutomation(e,s,t);if(e.isRest)this._handler.addRest(o.index,t+a,o.playbackInfo.primaryChannel);else if(e.deadSlapped)this.generateDeadSlap(e,t+a);else{const s=this.getBrushInfo(e),n=this.getRasgueadoInfo(e,r);for(const o of e.notes)this.generateNote(o,t+a,r,i,s,n)}if(e.fade!==pe.None&&this.generateFade(e,t+a,r),e.vibrato!==F.None){let s=240,i=3;switch(e.vibrato){case F.Slight:s=this._settings.player.vibrato.beatSlightLength,i=this._settings.player.vibrato.beatSlightAmplitude;break;case F.Wide:s=this._settings.player.vibrato.beatWideLength,i=this._settings.player.vibrato.beatWideAmplitude}this.generateVibratorWithParams(t+a,e.playbackDuration,s,0,i,((t,s)=>{this._handler.addBend(e.voice.bar.staff.track.index,t,o.playbackInfo.secondaryChannel,s)}))}}static calculateTripletFeelInfo(e,t,s){let i;switch(s.voice.bar.masterBar.tripletFeel){case A.Triplet8th:case A.Dotted8th:case A.Scottish8th:i=w.Eighth;break;case A.Triplet16th:case A.Dotted16th:case A.Scottish16th:i=w.Sixteenth;break;default:return null}const a=U.toTicks(i);if(t!==a)return null;if(e%a!=0)return null;if(!s.nextBeat||s.nextBeat.voice!==s.voice||s.playbackDuration!==a)return null;const r=new _r;switch(s.voice.bar.masterBar.tripletFeel){case A.Triplet8th:r.firstBeatDuration=U.applyTuplet(U.toTicks(w.Quarter),3,2),r.secondBeatDuration=U.applyTuplet(U.toTicks(w.Eighth),3,2);break;case A.Dotted8th:r.firstBeatDuration=U.applyDot(U.toTicks(w.Eighth),!1),r.secondBeatDuration=U.toTicks(w.Sixteenth);break;case A.Scottish8th:r.firstBeatDuration=U.toTicks(w.Sixteenth),r.secondBeatDuration=U.applyDot(U.toTicks(w.Eighth),!1);break;case A.Triplet16th:r.firstBeatDuration=U.applyTuplet(U.toTicks(w.Eighth),3,2),r.secondBeatDuration=U.applyTuplet(U.toTicks(w.Sixteenth),3,2);break;case A.Dotted16th:r.firstBeatDuration=U.applyDot(U.toTicks(w.Sixteenth),!1),r.secondBeatDuration=U.toTicks(w.ThirtySecond);break;case A.Scottish16th:r.firstBeatDuration=U.toTicks(w.ThirtySecond),r.secondBeatDuration=U.applyDot(U.toTicks(w.Sixteenth),!1)}return r.secondBeatStartOffset=t-r.firstBeatDuration,r}generateDeadSlap(e,t){const s=U.toTicks(w.SixtyFourth),i=e.voice.bar.staff;if(i.tuning.length>0)for(const e of i.tuning)this._handler.addNote(i.track.index,t,s,e,U.dynamicToVelocity(m.F),i.track.playbackInfo.primaryChannel)}needsSecondaryChannel(e){return e.hasBend||e.beat.hasWhammyBar||e.beat.vibrato!==F.None}determineChannel(e,t){if(this.needsSecondaryChannel(t))return e.playbackInfo.secondaryChannel;let s=t;for(;s.isTieDestination;)if(s=s.tieOrigin,this.needsSecondaryChannel(s))return e.playbackInfo.secondaryChannel;for(s=t;s.isTieOrigin;)if(s=s.tieDestination,this.needsSecondaryChannel(s))return e.playbackInfo.secondaryChannel;return e.playbackInfo.primaryChannel}generateNote(e,t,s,i,a,r){const n=e.beat.voice.bar.staff.track,o=e.beat.voice.bar.staff;let h=e.calculateRealValue(this.applyTranspositionPitches,!0);if(e.isPercussion){const t=Le.getArticulation(e);t&&(h=t.outputMidiNumber)}const l=null==r&&e.isStringed&&e.string<=a.length?a[e.string-1]:0,c=t+l,d=this.getNoteDuration(e,s,i);d.untilTieOrSlideEnd-=l,d.noteOnly-=l,d.letRingEnd-=l;const u=Br.getNoteVelocity(e),p=this.determineChannel(n,e);let g=0;const m=Math.max(d.untilTieOrSlideEnd,d.letRingEnd);g=e.hasBend?Br.getPitchWheel(e.bendPoints[0].value):e.beat.hasWhammyBar?Br.getPitchWheel(e.beat.whammyBarPoints[0].value):e.isTieDestination||e.slideOrigin&&e.slideOrigin.slideOutType===P.Legato?-1:Br.getPitchWheel(0),g>=0&&this._handler.addNoteBend(n.index,c,p,h,g),e.beat.hasRasgueado?this.generateRasgueado(n,e,c,h,u,p,r):e.ornament===le.None?!e.isTrill||o.isPercussion?e.beat.isTremolo?this.generateTremoloPicking(e,c,d,h,u,p):(e.hasBend?this.generateBend(e,c,d,h,p,i):e.beat.hasWhammyBar&&0===e.index?this.generateWhammy(e.beat,c,d,p,i):e.slideInType!==v.None||e.slideOutType!==P.None?this.generateSlide(e,c,d,h,p,i):(e.vibrato!==F.None||e.isTieDestination&&e.tieOrigin.vibrato!==F.None)&&this.generateVibrato(e,c,d,h,p),e.isTieDestination||e.slideOrigin&&e.slideOrigin.slideOutType===P.Legato||this._handler.addNote(n.index,c,m,h,u,p)):this.generateTrill(e,c,d,h,u,p):this.generateOrnament(n,e,c,m,h,u,p)}generateOrnament(e,t,s,i,a,r,n){let o,h;const l=a%12,c=1/3;switch(t.ornament){case le.Turn:o=[a+Br.OrnamentKeysUp[l],a,a+Br.OrnamentKeysDown[l]],h=[U.toTicks(w.Sixteenth)*c,U.toTicks(w.Sixteenth)*c,U.toTicks(w.Sixteenth)*c];break;case le.InvertedTurn:o=[a+Br.OrnamentKeysDown[l],a,a+Br.OrnamentKeysUp[l]],h=[U.toTicks(w.Sixteenth)*c,U.toTicks(w.Sixteenth)*c,U.toTicks(w.Sixteenth)*c];break;case le.UpperMordent:o=[a,a+Br.OrnamentKeysUp[l]],h=[U.toTicks(w.ThirtySecond),U.toTicks(w.ThirtySecond)];break;case le.LowerMordent:o=[a,a+Br.OrnamentKeysDown[l]],h=[U.toTicks(w.ThirtySecond),U.toTicks(w.ThirtySecond)];break;default:return}let d=1;i<U.QuarterTime&&(d=i/U.QuarterTime),r-=U.VelocityIncrement;let u=0;for(let t=0;t<o.length;t++){const i=h[t]*d;this._handler.addNote(e.index,s,i,o[t],r,n),s+=i,u+=i}const p=i-u;this._handler.addNote(e.index,s,p,a,r,n)}getNoteDuration(t,s,i){const a=new Sr;if(a.noteOnly=s,a.untilTieOrSlideEnd=s,a.letRingEnd=s,t.isDead)return a.noteOnly=this.applyStaticDuration(Br.DefaultDurationDead,s,i),a.untilTieOrSlideEnd=a.noteOnly,a.letRingEnd=a.noteOnly,a;if(t.isPalmMute)return a.noteOnly=this.applyStaticDuration(Br.DefaultDurationPalmMute,s,i),a.untilTieOrSlideEnd=a.noteOnly,a.letRingEnd=a.noteOnly,a;if(t.isStaccato)return a.noteOnly=s/2|0,a.untilTieOrSlideEnd=a.noteOnly,a.letRingEnd=a.noteOnly,a;if(t.isTieOrigin){const e=t.tieDestination;if(e)if(t.isTieDestination){const t=this.getNoteDuration(e,e.beat.playbackDuration,i);a.untilTieOrSlideEnd=s+t.untilTieOrSlideEnd}else{const s=t.beat.absolutePlaybackStart,r=this.getNoteDuration(e,e.beat.playbackDuration,i),n=e.beat.absolutePlaybackStart+r.untilTieOrSlideEnd;a.untilTieOrSlideEnd=n-s}}else if(t.slideOutType===P.Legato){const e=t.slideTarget;if(e){const s=t.beat.absolutePlaybackStart,r=this.getNoteDuration(e,e.beat.playbackDuration,i),n=e.beat.absolutePlaybackStart+r.untilTieOrSlideEnd;a.untilTieOrSlideEnd=n-s}}if(t.isLetRing&&this._settings.notation.notationMode===e.NotationMode.GuitarPro){let e=t.beat,i=0;const r=t.beat.voice.bar.masterBar.calculateDuration();for(;e.nextBeat;){const s=e.nextBeat;if(s.isRest)break;if(t.isStringed&&s.hasNoteOnString(t.string))break;if(e=e.nextBeat,i=e.absolutePlaybackStart-t.beat.absolutePlaybackStart+e.playbackDuration,i>r){i=r;break}}e===t.beat?a.letRingEnd=s:a.letRingEnd=i}else a.letRingEnd=a.untilTieOrSlideEnd;return a}applyStaticDuration(e,t,s){const i=s*e/J.MaxPosition|0;return Math.min(i,t)}static getNoteVelocity(e){let t=0;switch(!e.beat.voice.bar.staff.isPercussion&&e.hammerPullOrigin&&t--,e.isGhost&&t--,e.accentuated){case k.Normal:t++;break;case k.Heavy:t+=2}return U.dynamicToVelocity(e.dynamics,t)}generateFade(e,t,s){const i=e.voice.bar.staff.track;switch(e.fade){case pe.FadeIn:this.generateFadeSteps(i,t,s,0,Br.toChannelShort(i.playbackInfo.volume));break;case pe.FadeOut:this.generateFadeSteps(i,t,s,Br.toChannelShort(i.playbackInfo.volume),0);break;case pe.VolumeSwell:const e=s/2|0;this.generateFadeSteps(i,t,e,0,Br.toChannelShort(i.playbackInfo.volume)),this.generateFadeSteps(i,t+e,e,Br.toChannelShort(i.playbackInfo.volume),0)}}generateFadeSteps(e,t,s,i,a){const r=(a-i)/(s=.8*s|0),n=s/120+1|0,o=t+s;for(let s=0;s<n;s++){const h=s===n-1,l=h?o:t+120*s,c=h?a:Math.round(i+(l-t)*r);this._handler.addControlChange(e.index,l,e.playbackInfo.primaryChannel,Jt.VolumeCoarse,c),this._handler.addControlChange(e.index,l,e.playbackInfo.secondaryChannel,Jt.VolumeCoarse,c)}}generateVibrato(e,t,s,i,a){let r=0,n=0;switch(e.vibrato!==F.None?e.vibrato:e.isTieDestination?e.tieOrigin.vibrato:F.Slight){case F.Slight:r=this._settings.player.vibrato.noteSlightLength,n=this._settings.player.vibrato.noteSlightAmplitude;break;case F.Wide:r=this._settings.player.vibrato.noteWideLength,n=this._settings.player.vibrato.noteWideAmplitude;break;default:return}const o=e.beat.voice.bar.staff.track;let h=0;if(e.isTieDestination&&e.tieOrigin.hasBend){const t=e.tieOrigin.bendPoints;h=t[t.length-1].value}this.generateVibratorWithParams(t,s.noteOnly,r,h,n,((e,t)=>{this._handler.addNoteBend(o.index,e,a,i,t)}))}generateVibratorWithParams(e,t,s,i,a,r){const n=this.vibratoResolution,o=s/2|0,h=e+t;for(;e<h;){let t=0;const l=e+s<h?s:h-e;for(;t<l;){const s=i+a*Math.sin(t*Math.PI/o);r(e+t|0,Br.getPitchWheel(s)),t+=n}e+=s}r(0|h,Br.getPitchWheel(i))}static getPitchWheel(e){return Q.DefaultPitchWheel+e/2*Br.PitchValuePerSemitone}generateSlide(e,t,s,i,a,r){const n=e.slideOutType===P.Legato?s.noteOnly:s.untilTieOrSlideEnd,o=[],h=e.beat.voice.bar.staff.track,l=this._settings.player.slide.simpleSlidePitchOffset,c=Math.floor(J.MaxPosition*this._settings.player.slide.simpleSlideDurationRatio),d=Math.floor(J.MaxPosition*this._settings.player.slide.shiftSlideDurationRatio);switch(e.slideInType){case v.IntoFromAbove:o.push(new J(0,l)),o.push(new J(c,0));break;case v.IntoFromBelow:o.push(new J(0,-l)),o.push(new J(c,0))}switch(e.slideOutType){case P.Legato:case P.Shift:o.push(new J(d,0));const t=2*(e.slideTarget.calculateRealValue(this.applyTranspositionPitches,!0)-e.calculateRealValue(this.applyTranspositionPitches,!0));o.push(new J(J.MaxPosition,t));break;case P.OutDown:o.push(new J(J.MaxPosition-c,0)),o.push(new J(J.MaxPosition,-l));break;case P.OutUp:o.push(new J(J.MaxPosition-c,0)),o.push(new J(J.MaxPosition,l))}this.generateWhammyOrBend(t,n,o,r,((e,t)=>{this._handler.addNoteBend(h.index,e,a,i,t)}))}generateBend(e,t,s,i,a,r){const n=e.bendPoints,o=e.beat.voice.bar.staff.track,h=(e,t)=>{this._handler.addNoteBend(o.index,e,a,i,t)};let l,c=null;if(e.isTieOrigin&&this._settings.notation.extendBendArrowsOnTiedNotes){let t=e;for(;t.isTieOrigin&&!t.tieDestination.hasBend&&t.tieDestination.vibrato===F.None;)t=t.tieDestination;l=t.beat.absolutePlaybackStart-e.beat.absolutePlaybackStart+this.getNoteDuration(t,t.beat.playbackDuration,r).noteOnly}else if(e.isTieOrigin&&e.beat.graceType!==B.None){switch(e.tieDestination.bendType){case b.Bend:case b.BendRelease:case b.PrebendBend:c=e.tieDestination.bendPoints[1].value;break;case b.Prebend:case b.PrebendRelease:c=e.tieDestination.bendPoints[0].value}l=Math.max(s.noteOnly,U.millisToTicks(this._settings.player.songBookBendDuration,r))}else l=s.noteOnly;n[0].value>0&&!e.isContinuedBend&&t>0&&t--;const d=Math.min(l,U.millisToTicks(this._settings.player.songBookBendDuration,r));let u=[];switch(e.bendType){case b.Custom:u=n;break;case b.Bend:case b.Release:switch(e.bendStyle){case y.Default:u=n;break;case y.Gradual:u.push(new J(0,e.bendPoints[0].value)),(!c||c<e.bendPoints[1].value)&&(c=e.bendPoints[1].value),u.push(new J(J.MaxPosition,c));break;case y.Fast:return(!c||c<e.bendPoints[1].value)&&(c=e.bendPoints[1].value),void(e.beat.graceType===B.BendGrace?this.generateSongBookWhammyOrBend(t,l,!0,[e.bendPoints[0].value,c],d,r,h):this.generateSongBookWhammyOrBend(t,l,!1,[e.bendPoints[0].value,c],d,r,h))}break;case b.BendRelease:switch(e.bendStyle){case y.Default:u=n;break;case y.Gradual:u.push(new J(0,e.bendPoints[0].value)),u.push(new J(J.MaxPosition/2|0,e.bendPoints[1].value)),u.push(new J(J.MaxPosition,e.bendPoints[2].value));break;case y.Fast:return void this.generateSongBookWhammyOrBend(t,l,!1,[e.bendPoints[0].value,e.bendPoints[1].value,e.bendPoints[2].value],d,r,h)}break;case b.Hold:case b.Prebend:u=n;break;case b.PrebendBend:switch(e.bendStyle){case y.Default:u=n;break;case y.Gradual:u.push(new J(0,e.bendPoints[0].value)),u.push(new J(J.MaxPosition,e.bendPoints[1].value));break;case y.Fast:return h(t,0|Br.getPitchWheel(e.bendPoints[0].value)),(!c||c<e.bendPoints[1].value)&&(c=e.bendPoints[1].value),void this.generateSongBookWhammyOrBend(t,l,!1,[e.bendPoints[0].value,c],d,r,h)}break;case b.PrebendRelease:switch(e.bendStyle){case y.Default:u=n;break;case y.Gradual:u.push(new J(0,e.bendPoints[0].value)),u.push(new J(J.MaxPosition,e.bendPoints[1].value));break;case y.Fast:return h(t,0|Br.getPitchWheel(e.bendPoints[0].value)),void this.generateSongBookWhammyOrBend(t,l,!1,[e.bendPoints[0].value,e.bendPoints[1].value],d,r,h)}}this.generateWhammyOrBend(t,l,u,r,h)}generateSongBookWhammyOrBend(e,t,s,i,a,r,n){const o=s?e:e+t-a,h=a/(i.length-1);for(let e=0;e<i.length-1;e++){const t=Br.getPitchWheel(i[e]),s=Br.getPitchWheel(i[e+1]),a=o+h*e;this.generateBendValues(a,h,t,s,r,n)}}generateWhammy(e,t,s,i,a){const r=e.whammyBarPoints,n=e.voice.bar.staff.track,o=s.noteOnly;r[0].value>0&&!e.isContinuedWhammy&&t--;const h=(e,t)=>{this._handler.addBend(n.index,e,i,t)};let l=[];switch(e.whammyBarType){case de.Custom:l=r;break;case de.Dive:switch(e.whammyStyle){case y.Default:l=r;break;case y.Gradual:l.push(new J(0,r[0].value)),l.push(new J(J.MaxPosition,r[1].value));break;case y.Fast:const e=Math.min(o,U.millisToTicks(this._settings.player.songBookBendDuration,a));return void this.generateSongBookWhammyOrBend(t,o,!1,[r[0].value,r[1].value],e,a,h)}break;case de.Dip:switch(e.whammyStyle){case y.Default:l=r;break;case y.Gradual:l.push(new J(0,r[0].value)),l.push(new J(J.MaxPosition/2|0,r[1].value)),l.push(new J(J.MaxPosition,r[2].value));break;case y.Fast:const e=Math.min(o,U.millisToTicks(this._settings.player.songBookDipDuration,a));return void this.generateSongBookWhammyOrBend(t,o,!0,[r[0].value,r[1].value,r[2].value],e,a,h)}break;case de.Hold:case de.Predive:l=r;break;case de.PrediveDive:switch(e.whammyStyle){case y.Default:l=r;break;case y.Gradual:l.push(new J(0,r[0].value)),l.push(new J(J.MaxPosition/2|0,r[0].value)),l.push(new J(J.MaxPosition,r[1].value));break;case y.Fast:const e=Br.getPitchWheel(r[0].value);this._handler.addBend(n.index,t,i,0|e);const s=Math.min(o,U.millisToTicks(this._settings.player.songBookBendDuration,a));return void this.generateSongBookWhammyOrBend(t,o,!1,[r[0].value,r[1].value],s,a,h)}}this.generateWhammyOrBend(t,o,l,a,h)}generateWhammyOrBend(e,t,s,i,a){const r=t/J.MaxPosition;for(let t=0;t<s.length-1;t++){const n=s[t],o=s[t+1],h=Br.getPitchWheel(n.value),l=Br.getPitchWheel(o.value),c=r*(o.offset-n.offset),d=e+r*n.offset;this.generateBendValues(d,c,h,l,i,a)}}generateBendValues(e,t,s,i,a,r){const n=U.ticksToMillis(t,a),o=Math.abs(i-s)/Br.PitchValuePerSemitone,h=Math.max(Br.MinBreakpointsPerSemitone*o,n/Br.MillisecondsPerBreakpoint),l=t/h,c=(i-s)/h,d=e+t;for(let t=0;t<h;t++)r(0|e,Math.round(s)),s+=c,e+=l;r(0|d,i)}generateRasgueado(e,t,s,i,a,r,n){let o=s;for(let s=0;s<n.durations.length;s++){const h=n.brushInfos[s],l=t.isStringed&&t.string<=h.length?h[t.string-1]:0,c=n.durations[s];this._handler.addNote(e.index,o+l,c-l,i,a,r),o+=c}}generateTrill(e,t,s,i,a,r){const n=e.beat.voice.bar.staff.track,o=e.stringTuning+e.trillFret;let h=U.toTicks(e.trillSpeed),l=!0,c=t;const d=t+s.untilTieOrSlideEnd;for(;c+10<d;)c+h>=d&&(h=d-c),this._handler.addNote(n.index,c,h,l?o:i,a,r),l=!l,c+=h}generateTremoloPicking(e,t,s,i,a,r){const n=e.beat.voice.bar.staff.track;let o=U.toTicks(e.beat.tremoloSpeed),h=t;const l=t+s.untilTieOrSlideEnd;for(;h+10<l;)h+o>=l&&(o=l-h),this._handler.addNote(n.index,h,o,i,a,r),h+=o}getRasgueadoInfo(e,t){if(!e.hasRasgueado)return null;const s=new wr,i=Br.RasgueadoDurations.get(e.rasgueado).reduce(((e,t)=>e+t),0);s.durations=Br.RasgueadoDurations.get(e.rasgueado).map((e=>t*e/i)),s.brushInfos=new Array(s.durations.length);const a=U.toTicks(w.Sixteenth);let r=0,n=0;for(const t of e.notes)t.isTieDestination||(r|=1<<t.string-1,n++);const o=Br.RasgueadoDirections.get(e.rasgueado);for(let t=0;t<s.durations.length;t++){const i=s.durations[t]*a/U.QuarterTime,h=new Int32Array(e.voice.bar.staff.tuning.length);s.brushInfos[t]=h;const l=o[t];l!==S.None&&this.fillBrushInfo(e,h,l===S.ArpeggioDown||l===S.BrushDown,r,n,i)}return s}getBrushInfo(e){const t=new Int32Array(e.voice.bar.staff.tuning.length);if(e.brushType){let s=0,i=0;for(const t of e.notes)t.isTieDestination||(s|=1<<t.string-1,i++);this.fillBrushInfo(e,t,e.brushType===S.ArpeggioDown||e.brushType===S.BrushDown,s,i,e.brushDuration)}return t}fillBrushInfo(e,t,s,i,a,r){if(e.notes.length>0){let n=0;const o=r/(a-1)|0;for(let a=0;a<e.voice.bar.staff.tuning.length;a++){const e=s?a:t.length-1-a;i&1<<e&&(t[e]=n,n+=o)}}return t}generateNonTempoAutomation(e,t,s){switch(t.type){case f.Instrument:this.addProgramChange(e.voice.bar.staff.track,e.playbackStart+s,e.voice.bar.staff.track.playbackInfo.primaryChannel,255&t.value),this.addProgramChange(e.voice.bar.staff.track,e.playbackStart+s,e.voice.bar.staff.track.playbackInfo.secondaryChannel,255&t.value);break;case f.Balance:const i=Br.toChannelShort(t.value);this._handler.addControlChange(e.voice.bar.staff.track.index,e.playbackStart+s,e.voice.bar.staff.track.playbackInfo.primaryChannel,Jt.PanCoarse,i),this._handler.addControlChange(e.voice.bar.staff.track.index,e.playbackStart+s,e.voice.bar.staff.track.playbackInfo.secondaryChannel,Jt.PanCoarse,i);break;case f.Volume:const a=Br.toChannelShort(t.value);this._handler.addControlChange(e.voice.bar.staff.track.index,e.playbackStart+s,e.voice.bar.staff.track.playbackInfo.primaryChannel,Jt.VolumeCoarse,a),this._handler.addControlChange(e.voice.bar.staff.track.index,e.playbackStart+s,e.voice.bar.staff.track.playbackInfo.secondaryChannel,Jt.VolumeCoarse,a)}}prepareSingleBeat(e){let t=-1,s=-1,i=e;for(;i&&(-1===t||-1===s);){for(const i of e.automations)switch(i.type){case f.Instrument:s=i.value;break;case f.Tempo:t=i.value}i=i.previousBeat}const a=e.voice.bar.staff.track,r=e.voice.bar.masterBar;-1===t&&(t=r.score.tempo);const n=e.playbackStart/r.calculateDuration();for(const e of r.tempoAutomations){if(!(e.ratioPosition<=n))break;t=e.value}-1===s&&(s=a.playbackInfo.program);const o=a.playbackInfo.volume;this.generateTrack(a),this._handler.addTimeSignature(0,r.timeSignatureNumerator,r.timeSignatureDenominator),this._handler.addTempo(0,t);const h=Br.toChannelShort(o);return this._handler.addControlChange(0,0,a.playbackInfo.primaryChannel,Jt.VolumeCoarse,h),this._handler.addControlChange(0,0,a.playbackInfo.secondaryChannel,Jt.VolumeCoarse,h),t}generateSingleBeat(e){const t=this.prepareSingleBeat(e);this.generateBeat(e,-e.playbackStart,e.voice.bar,t)}generateSingleNote(e){const t=this.prepareSingleBeat(e.beat);this.generateNote(e,0,e.beat.playbackDuration,t,new Int32Array(e.beat.voice.bar.staff.tuning.length),null)}}Br.DefaultDurationDead=30,Br.DefaultDurationPalmMute=80,Br.OrnamentKeysUp=[2,2,2,1,1,2,2,2,2,2,1,1],Br.OrnamentKeysDown=[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1],Br.PitchBendRangeInSemitones=16,Br.PitchValuePerSemitone=Q.DefaultPitchWheel/Br.PitchBendRangeInSemitones,Br.MinBreakpointsPerSemitone=6,Br.MillisecondsPerBreakpoint=150,Br.RasgueadoDirections=new Map([[fe.Ii,[S.BrushDown,S.BrushUp]],[fe.Mi,[S.BrushDown,S.BrushDown]],[fe.MiiTriplet,[S.BrushDown,S.BrushDown,S.BrushUp]],[fe.MiiAnapaest,[S.BrushDown,S.BrushDown,S.BrushUp]],[fe.PmpTriplet,[S.BrushUp,S.BrushDown,S.BrushDown]],[fe.PmpAnapaest,[S.BrushUp,S.BrushDown,S.BrushDown]],[fe.PeiTriplet,[S.BrushUp,S.BrushDown,S.BrushDown]],[fe.PeiAnapaest,[S.BrushUp,S.BrushDown,S.BrushDown]],[fe.PaiTriplet,[S.BrushUp,S.BrushDown,S.BrushDown]],[fe.PaiAnapaest,[S.BrushUp,S.BrushDown,S.BrushDown]],[fe.AmiTriplet,[S.BrushDown,S.BrushDown,S.BrushDown]],[fe.AmiAnapaest,[S.BrushDown,S.BrushDown,S.BrushDown]],[fe.Ppp,[S.None,S.BrushDown,S.BrushUp]],[fe.Amii,[S.BrushDown,S.BrushDown,S.BrushDown,S.BrushUp]],[fe.Amip,[S.BrushDown,S.BrushDown,S.BrushDown,S.BrushUp]],[fe.Eami,[S.BrushDown,S.BrushDown,S.BrushDown,S.BrushDown]],[fe.Eamii,[S.BrushDown,S.BrushDown,S.BrushDown,S.BrushDown,S.BrushUp]],[fe.Peami,[S.BrushDown,S.BrushDown,S.BrushDown,S.BrushDown,S.BrushUp]]]),Br.RasgueadoDurations=new Map([[fe.Ii,[U.toTicks(w.Eighth),U.toTicks(w.Eighth)]],[fe.Mi,[U.toTicks(w.Eighth),U.toTicks(w.Eighth)]],[fe.MiiTriplet,[U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3]],[fe.MiiAnapaest,[U.toTicks(w.Sixteenth),U.toTicks(w.Sixteenth),U.toTicks(w.Eighth)]],[fe.PmpTriplet,[U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3]],[fe.PmpAnapaest,[U.toTicks(w.Sixteenth)/3,U.toTicks(w.Sixteenth)/3,U.toTicks(w.Eighth)/3]],[fe.PeiTriplet,[U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3]],[fe.PeiAnapaest,[U.toTicks(w.Sixteenth),U.toTicks(w.Sixteenth),U.toTicks(w.Eighth)]],[fe.PaiTriplet,[U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3]],[fe.PaiAnapaest,[U.toTicks(w.Sixteenth),U.toTicks(w.Sixteenth),U.toTicks(w.Eighth)]],[fe.AmiTriplet,[U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3,U.toTicks(w.Eighth)/3]],[fe.AmiAnapaest,[U.toTicks(w.Sixteenth)/3,U.toTicks(w.Sixteenth)/3,U.toTicks(w.Eighth)/3]],[fe.Ppp,[U.toTicks(w.Sixteenth)/3,U.toTicks(w.Sixteenth)/3,U.toTicks(w.Eighth)/3]],[fe.Amii,[U.toTicks(w.Sixteenth)/3,U.toTicks(w.Sixteenth)/3,U.toTicks(w.Sixteenth)/3,U.toTicks(w.Eighth)]],[fe.Amip,[U.toTicks(w.Sixteenth)/3,U.toTicks(w.Sixteenth)/3,U.toTicks(w.Sixteenth)/3,U.toTicks(w.Eighth)]],[fe.Eami,[U.toTicks(w.Sixteenth),U.toTicks(w.Sixteenth),U.toTicks(w.Sixteenth),U.toTicks(w.Sixteenth)]],[fe.Eamii,[U.toTicks(w.Sixteenth)/5,U.toTicks(w.Sixteenth)/5,U.toTicks(w.Sixteenth)/5,U.toTicks(w.Sixteenth)/5,U.toTicks(w.Sixteenth)/5]],[fe.Peami,[U.toTicks(w.Sixteenth)/5,U.toTicks(w.Sixteenth)/5,U.toTicks(w.Sixteenth)/5,U.toTicks(w.Sixteenth)/5,U.toTicks(w.Sixteenth)/5]]]);class kr{constructor(){this.startTick=0,this.endTick=0}}class Tr{constructor(e,t){this.width=0,this.height=0,this.x=e,this.y=t}doLayout(){}paint(e,t,s){}}class Nr extends Tr{constructor(e=0,t=0){super(e,t),this.beat=null,this.nextGlyph=null,this.previousGlyph=null}}class xr{}xr.Widths=new Map([[ne.Brace,3],[ne.BracketTop,0],[ne.BracketBottom,0],[ne.SystemDivider,0],[ne.GClef,28],[ne.CClef,28],[ne.FClef,28],[ne.UnpitchedPercussionClef1,15],[ne.SixStringTabClef,28],[ne.FourStringTabClef,28],[ne.TimeSig0,14],[ne.TimeSig1,10],[ne.TimeSig2,14],[ne.TimeSig3,14],[ne.TimeSig4,14],[ne.TimeSig5,14],[ne.TimeSig6,14],[ne.TimeSig7,14],[ne.TimeSig8,14],[ne.TimeSig9,14],[ne.TimeSigCommon,14],[ne.TimeSigCutCommon,14],[ne.NoteheadDoubleWholeSquare,14],[ne.NoteheadDoubleWhole,14],[ne.NoteheadWhole,14],[ne.NoteheadHalf,9],[ne.NoteheadBlack,9],[ne.NoteheadNull,9],[ne.NoteheadXOrnate,9],[ne.NoteheadPlusDoubleWhole,16],[ne.NoteheadPlusWhole,10],[ne.NoteheadPlusHalf,10],[ne.NoteheadPlusBlack,10],[ne.NoteheadSquareWhite,11],[ne.NoteheadSquareBlack,11],[ne.NoteheadTriangleUpDoubleWhole,16],[ne.NoteheadTriangleUpWhole,11],[ne.NoteheadTriangleUpHalf,11],[ne.NoteheadTriangleUpBlack,11],[ne.NoteheadTriangleRightWhite,11],[ne.NoteheadTriangleRightBlack,11],[ne.NoteheadTriangleDownDoubleWhole,16],[ne.NoteheadTriangleDownWhole,11],[ne.NoteheadTriangleDownHalf,11],[ne.NoteheadTriangleDownBlack,11],[ne.NoteheadDiamondDoubleWhole,16],[ne.NoteheadDiamondWhole,9],[ne.NoteheadDiamondHalf,9],[ne.NoteheadDiamondBlack,9],[ne.NoteheadDiamondBlackWide,10],[ne.NoteheadDiamondWhite,9],[ne.NoteheadDiamondWhiteWide,9],[ne.NoteheadCircleXDoubleWhole,16],[ne.NoteheadCircleXWhole,9],[ne.NoteheadCircleXHalf,9],[ne.NoteheadCircleX,9],[ne.NoteheadXDoubleWhole,16],[ne.NoteheadXWhole,9],[ne.NoteheadXHalf,9],[ne.NoteheadXBlack,9],[ne.NoteheadParenthesis,9],[ne.NoteheadSlashedBlack1,9],[ne.NoteheadSlashedBlack2,9],[ne.NoteheadSlashedHalf1,9],[ne.NoteheadSlashedHalf2,9],[ne.NoteheadSlashedWhole1,9],[ne.NoteheadSlashedWhole2,9],[ne.NoteheadSlashedDoubleWhole1,16],[ne.NoteheadSlashedDoubleWhole2,16],[ne.NoteheadCircledBlack,9],[ne.NoteheadCircledHalf,9],[ne.NoteheadCircledWhole,9],[ne.NoteheadCircledDoubleWhole,16],[ne.NoteheadCircleSlash,9],[ne.NoteheadHeavyX,13],[ne.NoteheadHeavyXHat,13],[ne.NoteheadSlashVerticalEnds,12],[ne.NoteheadSlashWhiteWhole,32],[ne.NoteheadSlashWhiteHalf,25],[ne.NoteheadRoundWhiteWithDot,9],[ne.NoteheadSquareBlackLarge,9],[ne.NoteheadSquareBlackWhite,9],[ne.NoteheadClusterDoubleWhole3rd,16],[ne.NoteheadClusterWhole3rd,12],[ne.NoteheadClusterHalf3rd,12],[ne.NoteheadClusterQuarter3rd,12],[ne.NoteShapeRoundWhite,9],[ne.NoteShapeRoundBlack,9],[ne.NoteShapeSquareWhite,12],[ne.NoteShapeSquareBlack,12],[ne.NoteShapeTriangleRightWhite,12],[ne.NoteShapeTriangleRightBlack,12],[ne.NoteShapeTriangleLeftWhite,12],[ne.NoteShapeTriangleLeftBlack,12],[ne.NoteShapeDiamondWhite,9],[ne.NoteShapeDiamondBlack,9],[ne.NoteShapeTriangleUpWhite,12],[ne.NoteShapeTriangleUpBlack,12],[ne.NoteShapeMoonWhite,12],[ne.NoteShapeMoonBlack,12],[ne.NoteShapeTriangleRoundWhite,12],[ne.NoteShapeTriangleRoundBlack,12],[ne.NoteQuarterUp,10],[ne.NoteEighthUp,10],[ne.TextBlackNoteLongStem,0],[ne.TextBlackNoteFrac8thLongStem,0],[ne.TextBlackNoteFrac16thLongStem,0],[ne.TextBlackNoteFrac32ndLongStem,0],[ne.TextCont8thBeamLongStem,0],[ne.TextCont16thBeamLongStem,0],[ne.TextCont32ndBeamLongStem,0],[ne.TextAugmentationDot,0],[ne.TextTupletBracketStartLongStem,0],[ne.TextTuplet3LongStem,0],[ne.TextTupletBracketEndLongStem,0],[ne.Tremolo3,12],[ne.Tremolo2,12],[ne.Tremolo1,12],[ne.FlagEighthUp,0],[ne.FlagEighthDown,0],[ne.FlagSixteenthUp,0],[ne.FlagSixteenthDown,0],[ne.FlagThirtySecondUp,0],[ne.FlagThirtySecondDown,0],[ne.FlagSixtyFourthUp,0],[ne.FlagSixtyFourthDown,0],[ne.FlagOneHundredTwentyEighthUp,0],[ne.FlagOneHundredTwentyEighthDown,0],[ne.FlagTwoHundredFiftySixthUp,0],[ne.FlagTwoHundredFiftySixthDown,0],[ne.AccidentalFlat,8],[ne.AccidentalNatural,8],[ne.AccidentalSharp,8],[ne.AccidentalDoubleSharp,8],[ne.AccidentalDoubleFlat,18],[ne.AccidentalQuarterToneFlatArrowUp,8],[ne.AccidentalQuarterToneSharpArrowUp,8],[ne.AccidentalQuarterToneNaturalArrowUp,8],[ne.Segno,0],[ne.Coda,0],[ne.ArticAccentAbove,9],[ne.ArticAccentBelow,9],[ne.ArticStaccatoAbove,9],[ne.ArticStaccatoBelow,9],[ne.ArticTenutoAbove,9],[ne.ArticTenutoBelow,9],[ne.ArticMarcatoAbove,9],[ne.ArticMarcatoBelow,9],[ne.FermataAbove,23],[ne.FermataShortAbove,23],[ne.FermataLongAbove,23],[ne.RestLonga,9],[ne.RestDoubleWhole,9],[ne.RestWhole,9],[ne.RestHalf,9],[ne.RestQuarter,9],[ne.RestEighth,9],[ne.RestSixteenth,9],[ne.RestThirtySecond,12],[ne.RestSixtyFourth,14],[ne.RestOneHundredTwentyEighth,14],[ne.RestTwoHundredFiftySixth,14],[ne.RestHBarLeft,0],[ne.RestHBarMiddle,0],[ne.RestHBarRight,0],[ne.Repeat1Bar,0],[ne.Repeat2Bars,0],[ne.Ottava,0],[ne.OttavaAlta,32],[ne.OttavaBassaVb,29],[ne.Quindicesima,23],[ne.QuindicesimaAlta,46],[ne.DynamicPPPPPP,0],[ne.DynamicPPPPP,0],[ne.DynamicPPPP,0],[ne.DynamicPPP,0],[ne.DynamicPP,0],[ne.DynamicPiano,0],[ne.DynamicMP,0],[ne.DynamicMF,0],[ne.DynamicPF,0],[ne.DynamicForte,0],[ne.DynamicFF,0],[ne.DynamicFFF,0],[ne.DynamicFFFF,0],[ne.DynamicFFFFF,0],[ne.DynamicFFFFFF,0],[ne.DynamicFortePiano,0],[ne.DynamicNiente,0],[ne.DynamicSforzando1,0],[ne.DynamicSforzandoPiano,0],[ne.DynamicSforzandoPianissimo,0],[ne.DynamicSforzato,0],[ne.DynamicSforzatoPiano,0],[ne.DynamicSforzatoFF,0],[ne.DynamicRinforzando1,0],[ne.DynamicRinforzando2,0],[ne.DynamicForzando,0],[ne.OrnamentTrill,20],[ne.OrnamentTurn,26],[ne.OrnamentTurnInverted,26],[ne.OrnamentShortTrill,0],[ne.OrnamentMordent,26],[ne.StringsDownBow,9],[ne.StringsUpBow,9],[ne.KeyboardPedalPed,35],[ne.KeyboardPedalUp,16],[ne.PictEdgeOfCymbal,44],[ne.GuitarString0,20],[ne.GuitarString1,20],[ne.GuitarString2,20],[ne.GuitarString3,20],[ne.GuitarString4,20],[ne.GuitarString5,20],[ne.GuitarString6,20],[ne.GuitarString7,20],[ne.GuitarString8,20],[ne.GuitarString9,20],[ne.GuitarOpenPedal,11],[ne.GuitarClosePedal,11],[ne.GuitarGolpe,13.4],[ne.GuitarFadeIn,13],[ne.GuitarFadeOut,13],[ne.GuitarVolumeSwell,26],[ne.FretboardX,0],[ne.FretboardO,0],[ne.WiggleTrill,9],[ne.WiggleVibratoMediumFast,10],[ne.OctaveBaselineM,13],[ne.OctaveBaselineB,9]]),xr.Heights=new Map([[ne.Brace,34],[ne.BracketTop,0],[ne.BracketBottom,0],[ne.SystemDivider,0],[ne.GClef,0],[ne.CClef,0],[ne.FClef,0],[ne.UnpitchedPercussionClef1,0],[ne.SixStringTabClef,0],[ne.FourStringTabClef,0],[ne.TimeSig0,0],[ne.TimeSig1,0],[ne.TimeSig2,0],[ne.TimeSig3,0],[ne.TimeSig4,0],[ne.TimeSig5,0],[ne.TimeSig6,0],[ne.TimeSig7,0],[ne.TimeSig8,0],[ne.TimeSig9,0],[ne.TimeSigCommon,0],[ne.TimeSigCutCommon,0],[ne.NoteheadDoubleWholeSquare,8],[ne.NoteheadDoubleWhole,8],[ne.NoteheadWhole,8],[ne.NoteheadHalf,8],[ne.NoteheadBlack,8],[ne.NoteheadNull,8],[ne.NoteheadXOrnate,8],[ne.NoteheadPlusDoubleWhole,8],[ne.NoteheadPlusWhole,8],[ne.NoteheadPlusHalf,8],[ne.NoteheadPlusBlack,8],[ne.NoteheadSquareWhite,8],[ne.NoteheadSquareBlack,8],[ne.NoteheadTriangleUpDoubleWhole,8],[ne.NoteheadTriangleUpWhole,8],[ne.NoteheadTriangleUpHalf,8],[ne.NoteheadTriangleUpBlack,8],[ne.NoteheadTriangleRightWhite,8],[ne.NoteheadTriangleRightBlack,8],[ne.NoteheadTriangleDownDoubleWhole,8],[ne.NoteheadTriangleDownWhole,8],[ne.NoteheadTriangleDownHalf,8],[ne.NoteheadTriangleDownBlack,8],[ne.NoteheadDiamondDoubleWhole,8],[ne.NoteheadDiamondWhole,8],[ne.NoteheadDiamondHalf,8],[ne.NoteheadDiamondBlack,8],[ne.NoteheadDiamondBlackWide,9],[ne.NoteheadDiamondWhite,9],[ne.NoteheadDiamondWhiteWide,9],[ne.NoteheadCircleXDoubleWhole,8],[ne.NoteheadCircleXWhole,8],[ne.NoteheadCircleXHalf,8],[ne.NoteheadCircleX,8],[ne.NoteheadXDoubleWhole,8],[ne.NoteheadXWhole,8],[ne.NoteheadXHalf,8],[ne.NoteheadXBlack,8],[ne.NoteheadParenthesis,8],[ne.NoteheadSlashedBlack1,8],[ne.NoteheadSlashedBlack2,8],[ne.NoteheadSlashedHalf1,8],[ne.NoteheadSlashedHalf2,8],[ne.NoteheadSlashedWhole1,8],[ne.NoteheadSlashedWhole2,8],[ne.NoteheadSlashedDoubleWhole1,8],[ne.NoteheadSlashedDoubleWhole2,8],[ne.NoteheadCircledBlack,8],[ne.NoteheadCircledHalf,8],[ne.NoteheadCircledWhole,8],[ne.NoteheadCircledDoubleWhole,8],[ne.NoteheadCircleSlash,8],[ne.NoteheadHeavyX,8],[ne.NoteheadHeavyXHat,8],[ne.NoteheadSlashVerticalEnds,17],[ne.NoteheadSlashWhiteWhole,17],[ne.NoteheadSlashWhiteHalf,17],[ne.NoteheadRoundWhiteWithDot,8],[ne.NoteheadSquareBlackLarge,8],[ne.NoteheadSquareBlackWhite,8],[ne.NoteheadClusterDoubleWhole3rd,8],[ne.NoteheadClusterWhole3rd,8],[ne.NoteheadClusterHalf3rd,8],[ne.NoteheadClusterQuarter3rd,8],[ne.NoteShapeRoundWhite,8],[ne.NoteShapeRoundBlack,8],[ne.NoteShapeSquareWhite,8],[ne.NoteShapeSquareBlack,8],[ne.NoteShapeTriangleRightWhite,8],[ne.NoteShapeTriangleRightBlack,8],[ne.NoteShapeTriangleLeftWhite,8],[ne.NoteShapeTriangleLeftBlack,8],[ne.NoteShapeDiamondWhite,8],[ne.NoteShapeDiamondBlack,8],[ne.NoteShapeTriangleUpWhite,8],[ne.NoteShapeTriangleUpBlack,8],[ne.NoteShapeMoonWhite,8],[ne.NoteShapeMoonBlack,8],[ne.NoteShapeTriangleRoundWhite,8],[ne.NoteShapeTriangleRoundBlack,8],[ne.NoteQuarterUp,8],[ne.NoteEighthUp,8],[ne.TextBlackNoteLongStem,0],[ne.TextBlackNoteFrac8thLongStem,0],[ne.TextBlackNoteFrac16thLongStem,0],[ne.TextBlackNoteFrac32ndLongStem,0],[ne.TextCont8thBeamLongStem,0],[ne.TextCont16thBeamLongStem,0],[ne.TextCont32ndBeamLongStem,0],[ne.TextAugmentationDot,0],[ne.TextTupletBracketStartLongStem,0],[ne.TextTuplet3LongStem,0],[ne.TextTupletBracketEndLongStem,0],[ne.Tremolo3,0],[ne.Tremolo2,0],[ne.Tremolo1,0],[ne.FlagEighthUp,0],[ne.FlagEighthDown,0],[ne.FlagSixteenthUp,0],[ne.FlagSixteenthDown,0],[ne.FlagThirtySecondUp,0],[ne.FlagThirtySecondDown,0],[ne.FlagSixtyFourthUp,0],[ne.FlagSixtyFourthDown,0],[ne.FlagOneHundredTwentyEighthUp,0],[ne.FlagOneHundredTwentyEighthDown,0],[ne.FlagTwoHundredFiftySixthUp,0],[ne.FlagTwoHundredFiftySixthDown,0],[ne.AccidentalFlat,0],[ne.AccidentalNatural,0],[ne.AccidentalSharp,0],[ne.AccidentalDoubleSharp,0],[ne.AccidentalDoubleFlat,0],[ne.AccidentalQuarterToneFlatArrowUp,0],[ne.AccidentalQuarterToneSharpArrowUp,0],[ne.AccidentalQuarterToneNaturalArrowUp,0],[ne.Segno,0],[ne.Coda,0],[ne.ArticAccentAbove,9],[ne.ArticAccentBelow,9],[ne.ArticStaccatoAbove,9],[ne.ArticStaccatoBelow,9],[ne.ArticTenutoAbove,9],[ne.ArticTenutoBelow,9],[ne.ArticMarcatoAbove,9],[ne.ArticMarcatoBelow,9],[ne.FermataAbove,12],[ne.FermataShortAbove,12],[ne.FermataLongAbove,12],[ne.RestLonga,0],[ne.RestDoubleWhole,0],[ne.RestWhole,0],[ne.RestHalf,0],[ne.RestQuarter,0],[ne.RestEighth,0],[ne.RestSixteenth,0],[ne.RestThirtySecond,0],[ne.RestSixtyFourth,0],[ne.RestOneHundredTwentyEighth,0],[ne.RestTwoHundredFiftySixth,0],[ne.RestHBarLeft,0],[ne.RestHBarMiddle,0],[ne.RestHBarRight,0],[ne.Repeat1Bar,0],[ne.Repeat2Bars,0],[ne.Ottava,13],[ne.OttavaAlta,13],[ne.OttavaBassaVb,13],[ne.Quindicesima,13],[ne.QuindicesimaAlta,13],[ne.DynamicPPPPPP,28.4],[ne.DynamicPPPPP,28.4],[ne.DynamicPPPP,28.4],[ne.DynamicPPP,28.4],[ne.DynamicPP,28.4],[ne.DynamicPiano,28.4],[ne.DynamicMP,28.4],[ne.DynamicMF,28.4],[ne.DynamicPF,28.4],[ne.DynamicForte,28.4],[ne.DynamicFF,28.4],[ne.DynamicFFF,28.4],[ne.DynamicFFFF,28.4],[ne.DynamicFFFFF,28.4],[ne.DynamicFFFFFF,28.4],[ne.DynamicFortePiano,28.4],[ne.DynamicNiente,28.4],[ne.DynamicSforzando1,28.4],[ne.DynamicSforzandoPiano,28.4],[ne.DynamicSforzandoPianissimo,28.4],[ne.DynamicSforzato,28.4],[ne.DynamicSforzatoPiano,28.4],[ne.DynamicSforzatoFF,28.4],[ne.DynamicRinforzando1,28.4],[ne.DynamicRinforzando2,28.4],[ne.DynamicForzando,28.4],[ne.OrnamentTrill,24],[ne.OrnamentTurn,18],[ne.OrnamentTurnInverted,18],[ne.OrnamentShortTrill,18],[ne.OrnamentMordent,18],[ne.StringsDownBow,13/.75],[ne.StringsUpBow,13/.75],[ne.KeyboardPedalPed,19],[ne.KeyboardPedalUp,16],[ne.PictEdgeOfCymbal,30],[ne.GuitarString0,20],[ne.GuitarString1,20],[ne.GuitarString2,20],[ne.GuitarString3,20],[ne.GuitarString4,20],[ne.GuitarString5,20],[ne.GuitarString6,20],[ne.GuitarString7,20],[ne.GuitarString8,20],[ne.GuitarString9,20],[ne.GuitarOpenPedal,11],[ne.GuitarClosePedal,11],[ne.GuitarGolpe,13.4],[ne.GuitarFadeIn,13],[ne.GuitarFadeOut,13],[ne.GuitarVolumeSwell,13],[ne.FretboardX,0],[ne.FretboardO,0],[ne.WiggleTrill,6],[ne.WiggleVibratoMediumFast,10],[ne.OctaveBaselineM,0],[ne.OctaveBaselineB,0]]);class vr extends Nr{constructor(e,t,s,i){super(e,t),this.glyphScale=0,this.center=!1,this.glyphScale=s,this.symbol=i}doLayout(){this.width=xr.Widths.has(this.symbol)?xr.Widths.get(this.symbol)*this.glyphScale:0,this.height=xr.Heights.has(this.symbol)?xr.Heights.get(this.symbol)*this.glyphScale:0}paint(e,t,s){const i=s.color;this.colorOverride&&(s.color=this.colorOverride),s.fillMusicFontSymbol(e+this.x,t+this.y,this.glyphScale,this.symbol,this.center),s.color=i}}class Pr extends vr{constructor(e,t,s,i){super(e,t,i?Pr.GraceScale:1,Pr.getSymbol(s)),this.centerOnStem=!1,this._isGrace=i}paint(e,t,s){const i=this._isGrace?1:0;this.centerOnStem&&(this.center=!0),super.paint(e,t+i,s)}static getSymbol(e){switch(e){case w.QuadrupleWhole:return ne.NoteheadDoubleWholeSquare;case w.DoubleWhole:return ne.NoteheadDoubleWhole;case w.Whole:return ne.NoteheadWhole;case w.Half:return ne.NoteheadHalf;default:return ne.NoteheadBlack}}}Pr.GraceScale=.75;class Fr extends vr{constructor(e,t,s,i,a){super(e,t,a?Pr.GraceScale:1,Fr.getSymbol(s,i,a))}static getSymbol(e,t,s){if(s&&(e=w.Eighth),t===Ne.Up)switch(e){case w.Eighth:return ne.FlagEighthUp;case w.Sixteenth:return ne.FlagSixteenthUp;case w.ThirtySecond:return ne.FlagThirtySecondUp;case w.SixtyFourth:return ne.FlagSixtyFourthUp;case w.OneHundredTwentyEighth:return ne.FlagOneHundredTwentyEighthUp;case w.TwoHundredFiftySixth:return ne.FlagTwoHundredFiftySixthUp;default:return ne.FlagEighthUp}switch(e){case w.Eighth:return ne.FlagEighthDown;case w.Sixteenth:return ne.FlagSixteenthDown;case w.ThirtySecond:return ne.FlagThirtySecondDown;case w.SixtyFourth:return ne.FlagSixtyFourthDown;case w.OneHundredTwentyEighth:case w.TwoHundredFiftySixth:return ne.FlagOneHundredTwentyEighthDown;default:return ne.FlagEighthDown}}}Fr.FlagWidth=11;class Cr extends Tr{get onTimeX(){return this.onNotes.x+this.onNotes.centerX}constructor(e,t){super(0,0),this.ties=[],this.minWidth=0,this.beat=e,this.ties=[],this.voiceContainer=t}addTie(e){e.renderer=this.renderer,this.ties.push(e)}drawBeamHelperAsFlags(e){return e.hasFlag(!1,void 0)}registerLayoutingInfo(e){const t=this.preNotes.computedWidth+this.onNotes.centerX;let s=this.onNotes.computedWidth-this.onNotes.centerX;const i=this.renderer.helpers.getBeamingHelperForBeat(this.beat);this.beat.graceType!==B.None?1===this.beat.graceGroup.beats.length?s+=Fr.FlagWidth*Pr.GraceScale:this.beat.graceIndex<this.beat.graceGroup.beats.length-1?s+=7:s+=Cr.GraceBeatPadding:i&&this.drawBeamHelperAsFlags(i)&&(s+=Fr.FlagWidth);for(const e of this.ties)s+=e.width;e.addBeatSpring(this.beat,t,s)}applyLayoutingInfo(e){this.onNotes.updateBeamingHelper(),this.updateWidth()}doLayout(){this.preNotes.x=0,this.preNotes.renderer=this.renderer,this.preNotes.container=this,this.preNotes.doLayout(),this.onNotes.x=this.preNotes.x+this.preNotes.width,this.onNotes.renderer=this.renderer,this.onNotes.container=this,this.onNotes.doLayout();let e=this.beat.notes.length-1;for(;e>=0;)this.createTies(this.beat.notes[e--]);this.renderer.registerTies(this.ties),this.updateWidth()}updateWidth(){if(this.minWidth=this.preNotes.width+this.onNotes.width,!this.beat.isRest)if(1===this.onNotes.beamingHelper.beats.length)this.beat.duration>=w.Eighth&&(this.minWidth+=20);else switch(this.beat.duration){case w.OneHundredTwentyEighth:case w.TwoHundredFiftySixth:this.minWidth+=10}let e=0;for(const t of this.ties)t.width>e&&(e=t.width);this.minWidth+=e,this.width=this.minWidth}scaleToWidth(e){this.onNotes.updateBeamingHelper(),this.width=e}createTies(e){}static getGroupId(e){return`b${e.id}`}paint(e,t,s){if(this.preNotes.isEmpty&&this.onNotes.isEmpty&&0===this.ties.length)return;s.beginGroup(Cr.getGroupId(this.beat)),this.preNotes.paint(e+this.x,t+this.y,s),this.onNotes.paint(e+this.x,t+this.y,s);const i=e-this.voiceContainer.x-this.renderer.x,a=t-this.voiceContainer.y-this.renderer.y;for(let e=0,t=this.ties.length;e<t;e++){const t=this.ties[e];t.renderer=this.renderer,t.paint(i,a,s)}s.endGroup()}buildBoundingsLookup(e,t,s,i){const a=new sr;if(a.beat=this.beat,this.beat.isEmpty)a.visualBounds=new ft,a.visualBounds.x=t+this.x,a.visualBounds.y=e.visualBounds.y,a.visualBounds.w=this.width,a.visualBounds.h=e.visualBounds.h,a.realBounds=new ft,a.realBounds.x=t+this.x,a.realBounds.y=e.realBounds.y,a.realBounds.w=this.width,a.realBounds.h=e.realBounds.h,a.onNotesX=t+this.x+this.onNotes.centerX;else{a.visualBounds=new ft,a.visualBounds.x=t+this.x,this.preNotes.isEmpty?this.onNotes.isEmpty?a.visualBounds.x=t+this.x:a.visualBounds.x=t+this.x+this.onNotes.x:a.visualBounds.x=t+this.x+this.preNotes.x;let s=0;s=this.onNotes.isEmpty?this.preNotes.isEmpty?t+this.x+this.width:t+this.x+this.preNotes.x+this.preNotes.width:t+this.x+this.onNotes.x+this.onNotes.width,a.visualBounds.w=s-a.visualBounds.x;const i=this.renderer.helpers.getBeamingHelperForBeat(this.beat);(i&&this.drawBeamHelperAsFlags(i)||this.beat.graceType!==B.None)&&(a.visualBounds.w+=Fr.FlagWidth*(this.beat.graceType!==B.None?Pr.GraceScale:1)),a.visualBounds.y=e.visualBounds.y,a.visualBounds.h=e.visualBounds.h,a.realBounds=new ft,a.realBounds.x=t+this.x,a.realBounds.y=e.realBounds.y,a.realBounds.w=this.width,a.realBounds.h=e.realBounds.h,a.onNotesX=t+this.x+this.onNotes.x+this.onNotes.centerX}e.addBeat(a),this.renderer.settings.core.includeNoteBounds&&this.onNotes.buildBoundingsLookup(a,t+this.x,s+this.y)}}Cr.GraceBeatPadding=3;class Er{constructor(){this.oldWidth=0,this.newWidth=0,this.settings=null}core(){return this.settings&&this.causeIssue()?this.settings.core:new oc}causeIssue(){return this.settings=null,!0}}class Dr{constructor(e){this.activeBeats=e}}class Mr{constructor(e){this.bounds=null,this.beat=e}}class Lr{get score(){return this._score}get tracks(){return this._tracks}constructor(e,t){this._startTime=0,this._trackIndexes=null,this._trackIndexLookup=null,this._isDestroyed=!1,this._score=null,this._tracks=[],this._tickCache=null,this.player=null,this._cursorWrapper=null,this._barCursor=null,this._beatCursor=null,this._selectionWrapper=null,this._previousTick=0,this._playerState=Ht.Paused,this._currentBeat=null,this._currentBarBounds=null,this._previousStateForCursor=Ht.Paused,this._previousCursorCache=null,this._lastScroll=0,this.playedBeatChanged=new ea,this.activeBeatsChanged=new ea,this._beatMouseDown=!1,this._noteMouseDown=!1,this._selectionStart=null,this._selectionEnd=null,this.beatMouseDown=new ea,this.beatMouseMove=new ea,this.beatMouseUp=new ea,this.noteMouseDown=new ea,this.noteMouseMove=new ea,this.noteMouseUp=new ea,this.scoreLoaded=new ea,this.resize=new ea,this.renderStarted=new ea,this.renderFinished=new ea,this.postRenderFinished=new Zi,this.error=new ea,this.playerReady=new Zi,this.playerFinished=new Zi,this.soundFontLoaded=new Zi,this.midiLoad=new ea,this.midiLoaded=new ea,this.playerStateChanged=new ea,this.playerPositionChanged=new ea,this.midiEventsPlayed=new ea,this.playbackRangeChanged=new ea,this.settingsUpdated=new Zi,this.uiFacade=e,this.container=e.rootContainer,e.initialize(this,t),j.logLevel=this.settings.core.logLevel,nc.printEnvironmentInfo(!1),this.canvasElement=e.createCanvasElement(),this.container.appendChild(this.canvasElement),this.settings.core.useWorkers&&this.uiFacade.areWorkersSupported&&nc.getRenderEngineFactory(this.settings.core.engine).supportsWorkers?this.renderer=this.uiFacade.createWorkerRenderer():this.renderer=new or(this.settings),this.container.resize.on(nc.throttle((()=>{this._isDestroyed||this.container.width!==this.renderer.width&&this.triggerResize()}),e.resizeThrottle));const s=new Er;s.oldWidth=this.renderer.width,s.newWidth=0|this.container.width,s.settings=this.settings,this.onResize(s),this.renderer.preRender.on(this.onRenderStarted.bind(this)),this.renderer.renderFinished.on((e=>{this.onRenderFinished(e)})),this.renderer.postRenderFinished.on((()=>{const e=Date.now()-this._startTime;j.debug("rendering",`Rendering completed in ${e}ms`),this.onPostRenderFinished()})),this.renderer.preRender.on((e=>{this._startTime=Date.now()})),this.renderer.partialLayoutFinished.on(this.appendRenderResult.bind(this)),this.renderer.partialRenderFinished.on(this.updateRenderResult.bind(this)),this.renderer.renderFinished.on((e=>{this.appendRenderResult(e),this.appendRenderResult(null)})),this.renderer.error.on(this.onError.bind(this)),this.settings.player.enablePlayer&&this.setupPlayer(),this.setupClickHandling(),this.uiFacade.beginInvoke((()=>{this.uiFacade.initialRender()}))}destroy(){this._isDestroyed=!0,this.player&&this.player.destroy(),this.uiFacade.destroy(),this.renderer.destroy()}updateSettings(){const e=this.score;e&&ae.applyPitchOffsets(this.settings,e),this.renderer.updateSettings(this.settings),this.settings.player.enablePlayer?(this.setupPlayer(),e&&this.player?.applyTranspositionPitches(Br.buildTranspositionPitches(e,this.settings))):this.destroyPlayer(),this.onSettingsUpdated()}load(e,t){try{return this.uiFacade.load(e,(e=>{this.renderScore(e,t)}),(e=>{this.onError(e)}))}catch(e){return this.onError(e),!1}}renderScore(e,t){const s=[];if(t)if(0===t.length)e.tracks.length>0&&s.push(e.tracks[0]);else if(1===t.length&&-1===t[0])for(const t of e.tracks)s.push(t);else for(const i of t)i>=0&&i<=e.tracks.length&&s.push(e.tracks[i]);else e.tracks.length>0&&s.push(e.tracks[0]);this.internalRenderTracks(e,s)}renderTracks(t){if(t.length>0){const s=t[0].score;for(const i of t)if(i.score!==s)return void this.onError(new qe(e.AlphaTabErrorType.General,"All rendered tracks must belong to the same score."));this.internalRenderTracks(s,t)}}internalRenderTracks(e,t){if(ae.applyPitchOffsets(this.settings,e),e!==this.score){this._score=e,this._tracks=t,this._tickCache=null,this._trackIndexes=[];for(const e of t)this._trackIndexes.push(e.index);this._trackIndexLookup=new Set(this._trackIndexes),this.onScoreLoaded(e),this.loadMidiForScore(),this.render()}else{this._tracks=t;const s=ae.computeFirstDisplayedBarIndex(e,this.settings),i=ae.computeLastDisplayedBarIndex(e,this.settings,s);this._tickCache&&(this._tickCache.multiBarRestInfo=ae.buildMultiBarRestInfo(this.tracks,s,i)),this._trackIndexes=[];for(const e of t)this._trackIndexes.push(e.index);this._trackIndexLookup=new Set(this._trackIndexes),this.render()}}triggerResize(){if(this.container.isVisible){const e=new Er;e.oldWidth=this.renderer.width,e.newWidth=this.container.width,e.settings=this.settings,this.onResize(e),this.renderer.updateSettings(this.settings),this.renderer.width=this.container.width,this.renderer.resizeRender()}else j.warning("Rendering","AlphaTab container was invisible while autosizing, waiting for element to become visible",null),this.uiFacade.rootContainerBecameVisible.on((()=>{j.debug("Rendering","AlphaTab container became visible, doing autosizing",null),this.triggerResize()}))}appendRenderResult(e){e?(this.canvasElement.width=e.totalWidth,this.canvasElement.height=e.totalHeight,this._cursorWrapper&&(this._cursorWrapper.width=e.totalWidth,this._cursorWrapper.height=e.totalHeight),(e.width>0||e.height>0)&&this.uiFacade.beginAppendRenderResults(e)):this.uiFacade.beginAppendRenderResults(e)}updateRenderResult(e){e&&e.renderResult&&this.uiFacade.beginUpdateRenderResults(e)}tex(e,t){try{const s=new ut;s.logErrors=!0,s.initFromString(e,this.settings);const i=s.readScore();this.renderScore(i,t)}catch(e){this.onError(e)}}loadSoundFont(e,t=!1){return!!this.player&&this.uiFacade.loadSoundFont(e,t)}resetSoundFonts(){this.player&&this.player.resetSoundFonts()}render(){this.renderer&&(this.uiFacade.canRender?(this.renderer.width=this.container.width,this.renderer.renderScore(this.score,this._trackIndexes)):this.uiFacade.canRenderChanged.on((()=>this.render())))}get tickCache(){return this._tickCache}get boundsLookup(){return this.renderer.boundsLookup}get isReadyForPlayback(){return!!this.player&&this.player.isReadyForPlayback}get playerState(){return this.player?this.player.state:Ht.Paused}get masterVolume(){return this.player?this.player.masterVolume:0}set masterVolume(e){this.player&&(this.player.masterVolume=e)}get metronomeVolume(){return this.player?this.player.metronomeVolume:0}set metronomeVolume(e){this.player&&(this.player.metronomeVolume=e)}get countInVolume(){return this.player?this.player.countInVolume:0}set countInVolume(e){this.player&&(this.player.countInVolume=e)}get midiEventsPlayedFilter(){return this.player?this.player.midiEventsPlayedFilter:[]}set midiEventsPlayedFilter(e){this.player&&(this.player.midiEventsPlayedFilter=e)}get tickPosition(){return this.player?this.player.tickPosition:0}set tickPosition(e){this.player&&(this.player.tickPosition=e)}get timePosition(){return this.player?this.player.timePosition:0}set timePosition(e){this.player&&(this.player.timePosition=e)}get playbackRange(){return this.player?this.player.playbackRange:null}set playbackRange(e){this.player&&(this.player.playbackRange=e,this.settings.player.enableCursor&&this.updateSelectionCursor(e))}get playbackSpeed(){return this.player?this.player.playbackSpeed:0}set playbackSpeed(e){this.player&&(this.player.playbackSpeed=e)}get isLooping(){return!!this.player&&this.player.isLooping}set isLooping(e){this.player&&(this.player.isLooping=e)}destroyPlayer(){this.player&&(this.player.destroy(),this.player=null,this._previousTick=0,this._playerState=Ht.Paused,this.destroyCursors())}setupPlayer(){this.updateCursors(),this.player||(this.player=this.uiFacade.createWorkerPlayer(),this.player&&(this.player.ready.on((()=>{this.loadMidiForScore()})),this.player.readyForPlayback.on((()=>{if(this.onPlayerReady(),this.tracks)for(const e of this.tracks){const t=e.playbackInfo.volume/16;this.player.setChannelVolume(e.playbackInfo.primaryChannel,t),this.player.setChannelVolume(e.playbackInfo.secondaryChannel,t)}})),this.player.soundFontLoaded.on(this.onSoundFontLoaded.bind(this)),this.player.soundFontLoadFailed.on((e=>{this.onError(e)})),this.player.midiLoaded.on(this.onMidiLoaded.bind(this)),this.player.midiLoadFailed.on((e=>{this.onError(e)})),this.player.stateChanged.on(this.onPlayerStateChanged.bind(this)),this.player.positionChanged.on(this.onPlayerPositionChanged.bind(this)),this.player.midiEventsPlayed.on(this.onMidiEventsPlayed.bind(this)),this.player.playbackRangeChanged.on(this.onPlaybackRangeChanged.bind(this)),this.player.finished.on(this.onPlayerFinished.bind(this)),this.setupPlayerEvents()))}loadMidiForScore(){if(!this.score)return;const e=this.score;j.debug("AlphaTab","Generating Midi");const t=new Fs,s=new cr(t),i=new Br(e,this.settings,s),a=ae.computeFirstDisplayedBarIndex(e,this.settings),r=ae.computeLastDisplayedBarIndex(e,this.settings,a);i.tickLookup.multiBarRestInfo=ae.buildMultiBarRestInfo(this.tracks,a,r),i.applyTranspositionPitches=!1,i.generate(),this._tickCache=i.tickLookup,this.onMidiLoad(t);const n=this.player;n&&(n.loadMidiFile(t),n.applyTranspositionPitches(i.transpositionPitches))}changeTrackVolume(e,t){if(this.player)for(const s of e)this.player.setChannelVolume(s.playbackInfo.primaryChannel,t),this.player.setChannelVolume(s.playbackInfo.secondaryChannel,t)}changeTrackSolo(e,t){if(this.player)for(const s of e)this.player.setChannelSolo(s.playbackInfo.primaryChannel,t),this.player.setChannelSolo(s.playbackInfo.secondaryChannel,t)}changeTrackMute(e,t){if(this.player)for(const s of e)this.player.setChannelMute(s.playbackInfo.primaryChannel,t),this.player.setChannelMute(s.playbackInfo.secondaryChannel,t)}changeTrackTranspositionPitch(e,t){if(this.player)for(const s of e)this.player.setChannelTranspositionPitch(s.playbackInfo.primaryChannel,t),this.player.setChannelTranspositionPitch(s.playbackInfo.secondaryChannel,t)}play(){return!!this.player&&this.player.play()}pause(){this.player&&this.player.pause()}playPause(){this.player&&this.player.playPause()}stop(){this.player&&this.player.stop()}playBeat(e){if(!this.player)return;const t=new Fs,s=new cr(t);new Br(e.voice.bar.staff.track.score,this.settings,s).generateSingleBeat(e),this.player.playOneTimeMidiFile(t)}playNote(e){if(!this.player)return;const t=new Fs,s=new cr(t);new Br(e.beat.voice.bar.staff.track.score,this.settings,s).generateSingleNote(e),this.player.playOneTimeMidiFile(t)}destroyCursors(){this._cursorWrapper&&(this.uiFacade.destroyCursors(),this._cursorWrapper=null,this._barCursor=null,this._beatCursor=null,this._selectionWrapper=null)}updateCursors(){if(this.settings.player.enableCursor&&!this._cursorWrapper){const e=this.uiFacade.createCursors();e&&(this._cursorWrapper=e.cursorWrapper,this._barCursor=e.barCursor,this._beatCursor=e.beatCursor,this._selectionWrapper=e.selectionWrapper),null!==this._currentBeat&&this.cursorUpdateBeat(this._currentBeat,!1,this._previousTick>10,!0)}else!this.settings.player.enableCursor&&this._cursorWrapper&&this.destroyCursors()}setupPlayerEvents(){this._previousTick=0,this._playerState=Ht.Paused,this.renderer.postRenderFinished.on((()=>{this._currentBeat=null,this.cursorUpdateTick(this._previousTick,!1,this._previousTick>10)})),this.player&&(this.player.positionChanged.on((e=>{this._previousTick=e.currentTick,this.uiFacade.beginInvoke((()=>{this.cursorUpdateTick(e.currentTick,!1,!1,e.isSeek)}))})),this.player.stateChanged.on((e=>{if(this._playerState=e.state,!e.stopped&&e.state===Ht.Paused){const e=this._currentBeat,t=this._tickCache;e&&t&&(this.player.tickPosition=t.getBeatStart(e.beat))}})))}cursorUpdateTick(e,t,s=!1,i=!1){const a=this._tickCache;if(a){const r=this._trackIndexLookup;if(null!=r&&r.size>0){const n=a.findBeat(r,e,this._currentBeat);n&&this.cursorUpdateBeat(n,t,s,i||this.playerState===Ht.Paused)}}}cursorUpdateBeat(e,t,s,i=!1){const a=e.beat,r=e.nextBeat?.beat??null,n=e.duration,o=e.beatLookup.highlightedBeats;if(!a)return;const h=this.renderer.boundsLookup;if(!h)return;const l=this._currentBeat,c=this._previousCursorCache,d=this._previousStateForCursor;if(!i&&a===l?.beat&&h===c&&d===this._playerState&&l?.start===e.start)return;const u=h.findBeat(a);u&&(this._currentBeat=e,this._previousCursorCache=h,this._previousStateForCursor=this._playerState,this.uiFacade.beginInvoke((()=>{this.internalCursorUpdateBeat(a,r,n,t,o,h,u,s,e.cursorMode)})))}scrollToCursor(){const e=this._currentBarBounds;e&&this.internalScrollToCursor(e)}internalScrollToCursor(t){const s=this.uiFacade.getScrollContainer(),i=nc.getLayoutEngineFactory(this.settings.display.layoutMode).vertical,a=this.settings.player.scrollMode;if(i){const i=t.realBounds.y+this.settings.player.scrollOffsetY;if(i!==this._lastScroll)switch(this._lastScroll=i,a){case e.ScrollMode.Continuous:const a=this.uiFacade.getOffset(s,this.container);this.uiFacade.scrollToY(s,a.y+i,this.settings.player.scrollSpeed);break;case e.ScrollMode.OffScreen:const r=s.scrollTop+this.uiFacade.getOffset(null,s).h;if(t.visualBounds.y+t.visualBounds.h>=r||t.visualBounds.y<s.scrollTop){const e=t.realBounds.y+this.settings.player.scrollOffsetY;this.uiFacade.scrollToY(s,e,this.settings.player.scrollSpeed)}}}else{const i=t.visualBounds.x;if(i!==this._lastScroll)switch(this._lastScroll=i,a){case e.ScrollMode.Continuous:const i=t.realBounds.x+this.settings.player.scrollOffsetX;this._lastScroll=t.visualBounds.x,this.uiFacade.scrollToX(s,i,this.settings.player.scrollSpeed);break;case e.ScrollMode.OffScreen:const a=s.scrollLeft+this.uiFacade.getOffset(null,s).w;if(t.visualBounds.x+t.visualBounds.w>=a||t.visualBounds.x<s.scrollLeft){const e=t.realBounds.x+this.settings.player.scrollOffsetX;this._lastScroll=t.visualBounds.x,this.uiFacade.scrollToX(s,e,this.settings.player.scrollSpeed)}}}}internalCursorUpdateBeat(t,s,i,a,r,n,o,h,l){const c=this._barCursor,d=this._beatCursor,u=o.barBounds.masterBarBounds,p=u.visualBounds;this._currentBarBounds=u,c&&c.setBounds(p.x,p.y,p.w,p.h),d&&(this.settings.player.enableAnimatedBeatCursor&&d.stopAnimation(),d.setBounds(o.onNotesX,p.y,1,p.h)),this.settings.player.enableElementHighlighting&&this.uiFacade.removeHighlights();let g=!1;const m=this._playerState===Ht.Playing&&!a;if(m){if(this.settings.player.enableElementHighlighting)for(const e of r){const s=Cr.getGroupId(e.beat);this.uiFacade.highlightElements(s,t.voice.bar.index)}h=!a,g=!0}if(this.settings.player.enableAnimatedBeatCursor&&d){let e=u.visualBounds.x+u.visualBounds.w;if(s&&l===es.ToNextBext){const t=n.findBeat(s);t&&t.barBounds.masterBarBounds.staffSystemBounds===u.staffSystemBounds&&(e=t.onNotesX)}m&&this.uiFacade.beginInvoke((()=>{d.transitionToX(i/this.playbackSpeed,e)}))}h&&!this._beatMouseDown&&this.settings.player.scrollMode!==e.ScrollMode.Off&&this.internalScrollToCursor(u),g&&(this.onPlayedBeatChanged(t),this.onActiveBeatsChanged(new Dr(r.map((e=>e.beat)))))}onPlayedBeatChanged(e){this._isDestroyed||(this.playedBeatChanged.trigger(e),this.uiFacade.triggerEvent(this.container,"playedBeatChanged",e))}onActiveBeatsChanged(e){this._isDestroyed||(this.activeBeatsChanged.trigger(e),this.uiFacade.triggerEvent(this.container,"activeBeatsChanged",e))}onBeatMouseDown(e,t){this._isDestroyed||(this.settings.player.enablePlayer&&this.settings.player.enableCursor&&this.settings.player.enableUserInteraction&&(this._selectionStart=new Mr(t),this._selectionEnd=null),this._beatMouseDown=!0,this.beatMouseDown.trigger(t),this.uiFacade.triggerEvent(this.container,"beatMouseDown",t,e))}onNoteMouseDown(e,t){this._isDestroyed||(this._noteMouseDown=!0,this.noteMouseDown.trigger(t),this.uiFacade.triggerEvent(this.container,"noteMouseDown",t,e))}onBeatMouseMove(e,t){this._isDestroyed||(this.settings.player.enableUserInteraction&&(this._selectionEnd&&this._selectionEnd.beat===t||(this._selectionEnd=new Mr(t),this.cursorSelectRange(this._selectionStart,this._selectionEnd))),this.beatMouseMove.trigger(t),this.uiFacade.triggerEvent(this.container,"beatMouseMove",t,e))}onNoteMouseMove(e,t){this._isDestroyed||(this.noteMouseMove.trigger(t),this.uiFacade.triggerEvent(this.container,"noteMouseMove",t,e))}onBeatMouseUp(e,t){if(!this._isDestroyed){if(this.settings.player.enablePlayer&&this.settings.player.enableCursor&&this.settings.player.enableUserInteraction){if(this._selectionEnd){const e=this._tickCache?.getBeatStart(this._selectionStart.beat)??this._selectionStart.beat.absolutePlaybackStart;if((this._tickCache?.getBeatStart(this._selectionEnd.beat)??this._selectionEnd.beat.absolutePlaybackStart)<e){const e=this._selectionStart;this._selectionStart=this._selectionEnd,this._selectionEnd=e}}if(this._selectionStart&&this._tickCache){const e=this._tickCache,t=e.getMasterBarStart(this._selectionStart.beat.voice.bar.masterBar);if(this._currentBeat=null,this._playerState===Ht.Paused&&this.cursorUpdateTick(this._tickCache.getBeatStart(this._selectionStart.beat),!1),this.tickPosition=t+this._selectionStart.beat.playbackStart,this._selectionEnd&&this._selectionStart.beat!==this._selectionEnd.beat){const s=e.getMasterBarStart(this._selectionEnd.beat.voice.bar.masterBar),i=new kr;i.startTick=t+this._selectionStart.beat.playbackStart,i.endTick=s+this._selectionEnd.beat.playbackStart+this._selectionEnd.beat.playbackDuration-50,this.playbackRange=i}else this._selectionStart=null,this.playbackRange=null,this.cursorSelectRange(this._selectionStart,this._selectionEnd)}}this.beatMouseUp.trigger(t),this.uiFacade.triggerEvent(this.container,"beatMouseUp",t,e),this._beatMouseDown=!1}}onNoteMouseUp(e,t){this._isDestroyed||(this.noteMouseUp.trigger(t),this.uiFacade.triggerEvent(this.container,"noteMouseUp",t,e),this._noteMouseDown=!1)}updateSelectionCursor(e){if(this._tickCache)if(e){const t=this._tickCache.findBeat(this._trackIndexLookup,e.startTick),s=this._tickCache.findBeat(this._trackIndexLookup,e.endTick);if(t&&s){const e=new Mr(t.beat),i=new Mr(s.beat);this.cursorSelectRange(e,i)}}else this.cursorSelectRange(null,null)}setupClickHandling(){this.canvasElement.mouseDown.on((e=>{if(!e.isLeftMouseButton)return;this.settings.player.enableUserInteraction&&e.preventDefault();const t=e.getX(this.canvasElement),s=e.getY(this.canvasElement),i=this.renderer.boundsLookup?.getBeatAtPos(t,s)??null;if(i&&(this.onBeatMouseDown(e,i),this.settings.core.includeNoteBounds)){const a=this.renderer.boundsLookup?.getNoteAtPos(i,t,s);a&&this.onNoteMouseDown(e,a)}})),this.canvasElement.mouseMove.on((e=>{if(!this._beatMouseDown)return;const t=e.getX(this.canvasElement),s=e.getY(this.canvasElement),i=this.renderer.boundsLookup?.getBeatAtPos(t,s)??null;if(i&&(this.onBeatMouseMove(e,i),this._noteMouseDown)){const a=this.renderer.boundsLookup?.getNoteAtPos(i,t,s);a&&this.onNoteMouseMove(e,a)}})),this.canvasElement.mouseUp.on((e=>{if(!this._beatMouseDown)return;this.settings.player.enableUserInteraction&&e.preventDefault();const t=e.getX(this.canvasElement),s=e.getY(this.canvasElement),i=this.renderer.boundsLookup?.getBeatAtPos(t,s)??null;if(this.onBeatMouseUp(e,i),this._noteMouseDown)if(i){const a=this.renderer.boundsLookup?.getNoteAtPos(i,t,s)??null;this.onNoteMouseUp(e,a)}else this.onNoteMouseUp(e,null)})),this.renderer.postRenderFinished.on((()=>{this._selectionStart&&this.settings.player.enablePlayer&&this.settings.player.enableCursor&&this.settings.player.enableUserInteraction&&this.cursorSelectRange(this._selectionStart,this._selectionEnd)}))}cursorSelectRange(e,t){const s=this.renderer.boundsLookup;if(!s)return;const i=this._selectionWrapper;if(!i)return;if(i.clear(),!e||!t||e.beat===t.beat)return;e.bounds||(e.bounds=s.findBeat(e.beat)),t.bounds||(t.bounds=s.findBeat(t.beat));const a=this._tickCache?.getBeatStart(e.beat)??e.beat.absolutePlaybackStart;if((this._tickCache?.getBeatStart(t.beat)??t.beat.absolutePlaybackStart)<a){const s=e;e=t,t=s}const r=e.bounds.realBounds.x;let n=t.bounds.realBounds.x+t.bounds.realBounds.w;if(t.beat.index===t.beat.voice.beats.length-1&&(n=t.bounds.barBounds.masterBarBounds.realBounds.x+t.bounds.barBounds.masterBarBounds.realBounds.w),e.bounds.barBounds.masterBarBounds.staffSystemBounds!==t.bounds.barBounds.masterBarBounds.staffSystemBounds){const a=e.bounds.barBounds.masterBarBounds.staffSystemBounds.visualBounds.x,o=e.bounds.barBounds.masterBarBounds.staffSystemBounds.visualBounds.x+e.bounds.barBounds.masterBarBounds.staffSystemBounds.visualBounds.w,h=this.uiFacade.createSelectionElement();h.setBounds(r,e.bounds.barBounds.masterBarBounds.visualBounds.y,o-r,e.bounds.barBounds.masterBarBounds.visualBounds.h),i.appendChild(h);const l=e.bounds.barBounds.masterBarBounds.staffSystemBounds.index+1,c=t.bounds.barBounds.masterBarBounds.staffSystemBounds.index;for(let e=l;e<c;e++){const t=s.staffSystems[e],r=this.uiFacade.createSelectionElement();r.setBounds(a,t.visualBounds.y,o-a,t.visualBounds.h),i.appendChild(r)}const d=this.uiFacade.createSelectionElement();d.setBounds(a,t.bounds.barBounds.masterBarBounds.visualBounds.y,n-a,t.bounds.barBounds.masterBarBounds.visualBounds.h),i.appendChild(d)}else{const t=this.uiFacade.createSelectionElement();t.setBounds(r,e.bounds.barBounds.masterBarBounds.visualBounds.y,n-r,e.bounds.barBounds.masterBarBounds.visualBounds.h),i.appendChild(t)}}onScoreLoaded(e){this._isDestroyed||(this.scoreLoaded.trigger(e),this.uiFacade.triggerEvent(this.container,"scoreLoaded",e))}onResize(e){this._isDestroyed||(this.resize.trigger(e),this.uiFacade.triggerEvent(this.container,"resize",e))}onRenderStarted(e){this._isDestroyed||(this.renderStarted.trigger(e),this.uiFacade.triggerEvent(this.container,"renderStarted",e))}onRenderFinished(e){this._isDestroyed||(this.renderFinished.trigger(e),this.uiFacade.triggerEvent(this.container,"renderFinished",e))}onPostRenderFinished(){this._isDestroyed||(this.postRenderFinished.trigger(),this.uiFacade.triggerEvent(this.container,"postRenderFinished",null))}onError(e){this._isDestroyed||(j.error("API","An unexpected error occurred",e),this.error.trigger(e),this.uiFacade.triggerEvent(this.container,"error",e))}onPlayerReady(){this._isDestroyed||(this.playerReady.trigger(),this.uiFacade.triggerEvent(this.container,"playerReady",null))}onPlayerFinished(){this._isDestroyed||(this.playerFinished.trigger(),this.uiFacade.triggerEvent(this.container,"playerFinished",null))}onSoundFontLoaded(){this._isDestroyed||(this.soundFontLoaded.trigger(),this.uiFacade.triggerEvent(this.container,"soundFontLoaded",null))}onMidiLoad(e){this._isDestroyed||(this.midiLoad.trigger(e),this.uiFacade.triggerEvent(this.container,"midiLoad",e))}onMidiLoaded(e){this._isDestroyed||(this.midiLoaded.trigger(e),this.uiFacade.triggerEvent(this.container,"midiFileLoaded",e))}onPlayerStateChanged(e){this._isDestroyed||(this.playerStateChanged.trigger(e),this.uiFacade.triggerEvent(this.container,"playerStateChanged",e))}onPlayerPositionChanged(e){this._isDestroyed||null!==this.score&&this.tracks.length>0&&(this.playerPositionChanged.trigger(e),this.uiFacade.triggerEvent(this.container,"playerPositionChanged",e))}onMidiEventsPlayed(e){this._isDestroyed||(this.midiEventsPlayed.trigger(e),this.uiFacade.triggerEvent(this.container,"midiEventsPlayed",e))}onPlaybackRangeChanged(e){this._isDestroyed||(this.playbackRangeChanged.trigger(e),this.uiFacade.triggerEvent(this.container,"playbackRangeChanged",e))}onSettingsUpdated(){this._isDestroyed||(this.settingsUpdated.trigger(),this.uiFacade.triggerEvent(this.container,"settingsUpdated",null))}async enumerateOutputDevices(){return this.player?await this.player.output.enumerateOutputDevices():[]}async setOutputDevice(e){this.player&&await this.player.output.setOutputDevice(e)}async getOutputDevice(){return this.player?await this.player.output.getOutputDevice():null}}class Ar extends qe{constructor(t,s){super(e.AlphaTabErrorType.General,t),this.xhr=s,Object.setPrototypeOf(this,Ar.prototype)}}class Ir{static loadScoreAsync(e,t,s,i){const a=new XMLHttpRequest;a.open("GET",e,!0,null,null),a.responseType="arraybuffer",a.onreadystatechange=()=>{if(a.readyState===XMLHttpRequest.DONE){const e=a.response;if(200===a.status||0===a.status&&e)try{const e=a.response,s=new Uint8Array(e),r=Ir.loadScoreFromBytes(s,i);t(r)}catch(e){s(e)}else 0===a.status?s(new Ar("You are offline!!\n Please Check Your Network.",a)):404===a.status?s(new Ar("Requested URL not found.",a)):500===a.status?s(new Ar("Internel Server Error.",a)):"parsererror"===a.statusText?s(new Ar("Error.\nParsing JSON Request failed.",a)):"timeout"===a.statusText?s(new Ar("Request Time out.",a)):s(new Ar(`Unknow Error: ${a.responseText}`,a))}},a.send()}static loadScoreFromBytes(e,t){t||(t=new ka);const s=nc.buildImporters();j.debug("ScoreLoader",`Loading score from ${e.length} bytes using ${s.length} importers`);let i=null;const a=lt.fromBuffer(e);for(const e of s){a.reset();try{j.debug("ScoreLoader",`Importing using importer ${e.name}`),e.init(a,t),i=e.readScore(),j.debug("ScoreLoader",`Score imported using ${e.name}`);break}catch(t){if(!(t instanceof je))throw j.error("ScoreLoader","Score import failed due to unexpected error: ",t),t;j.debug("ScoreLoader",`${e.name} does not support the file`)}}if(i)return i;throw new je("No compatible importer found for file")}}class Rr{get isLeftMouseButton(){return 0===this.mouseEvent.button}getX(e){const t=e.element,s=t.getBoundingClientRect().left+t.ownerDocument.defaultView.pageXOffset;return this.mouseEvent.pageX-s}getY(e){const t=e.element,s=t.getBoundingClientRect().top+t.ownerDocument.defaultView.pageYOffset;return this.mouseEvent.pageY-s}preventDefault(){this.mouseEvent.preventDefault()}constructor(e){this.mouseEvent=e}}class Or{get width(){return this.element.offsetWidth}set width(e){this.element.style.width=`${e}px`}get scrollLeft(){return this.element.scrollLeft}set scrollLeft(e){this.element.scrollLeft=e}get scrollTop(){return this.element.scrollTop}set scrollTop(e){this.element.scrollTop=e}get height(){return this.element.offsetHeight}set height(e){this.element.style.height=e>=0?`${e}px`:"100%"}get isVisible(){return!!this.element.offsetWidth||!!this.element.offsetHeight||!!this.element.getClientRects().length}constructor(e){this._resizeListeners=0,this.lastBounds=new ft,this.element=e,this.mouseDown={on:e=>{this.element.addEventListener("mousedown",(t=>{e(new Rr(t))}),!0)},off:e=>{}},this.mouseUp={on:e=>{this.element.addEventListener("mouseup",(t=>{e(new Rr(t))}),!0)},off:e=>{}},this.mouseMove={on:e=>{this.element.addEventListener("mousemove",(t=>{e(new Rr(t))}),!0)},off:e=>{}},this.resize={on:e=>{0===this._resizeListeners&&Or.resizeObserver.value.observe(this.element),this.element.addEventListener("resize",e,!0),this._resizeListeners++},off:e=>{this.element.removeEventListener("resize",e,!0),this._resizeListeners--,this._resizeListeners<=0&&(this._resizeListeners=0,Or.resizeObserver.value.unobserve(this.element))}}}stopAnimation(){this.element.style.transition="none"}transitionToX(e,t){this.element.style.transition=`transform ${e}ms linear`,this.setBounds(t,Number.NaN,Number.NaN,Number.NaN)}setBounds(e,t,s,i){Number.isNaN(e)&&(e=this.lastBounds.x),Number.isNaN(t)&&(t=this.lastBounds.y),Number.isNaN(s)&&(s=this.lastBounds.w),Number.isNaN(i)&&(i=this.lastBounds.h),this.element.style.transform=`translate(${e}px, ${t}px) scale(${s}, ${i})`,this.element.style.transformOrigin="top left",this.lastBounds.x=e,this.lastBounds.y=t,this.lastBounds.w=s,this.lastBounds.h=i}appendChild(e){this.element.appendChild(e.element)}clear(){this.element.innerHTML=""}}Or.resizeObserver=new $((()=>new ResizeObserver((e=>{for(const t of e){const e=new CustomEvent("resize",{detail:t});t.target.dispatchEvent(e)}}))));class Hr{constructor(e){this._isStarted=!1,this.isFontLoaded=!1,this.fontLoaded=new ea,this._originalFamilies=e,this._families=e}checkForFontAvailability(){if(nc.isRunningInWorker)return void(this.isFontLoaded=!1);if(this._isStarted)return;this._isStarted=!0;let e=0;const t=window.setInterval((()=>{j.warning("Rendering",`Could not load font '${this._families[0]}' within ${5*(e+1)} seconds`,null),this._families.length>1?(this._families.shift(),e=0):e++}),5e3);j.debug("Font",`Start checking for font availablility: ${this._families.join(", ")}`);const s=e=>{this._families.length>1?(j.debug("Font",`[${this._families[0]}] Loading Failed, switching to ${this._families[1]}`,e),this._families.shift(),window.setTimeout((()=>{a()}),0)):(j.error("Font",`[${this._originalFamilies.join(",")}] Loading Failed, rendering cannot start`,e),window.clearInterval(t))},i=e=>{j.debug("Font",`[${e}] Font API signaled available`),this.isFontLoaded=!0,window.clearInterval(t),this.fontLoaded.trigger(this._families[0])},a=async()=>{for(const e of this._families)if(await this.isFontAvailable(e,!1))return void i(e);try{await document.fonts.load(`1em ${this._families[0]}`)}catch(e){s(e)}return j.debug("Font",`[${this._families[0]}] Font API signaled loaded`),await this.isFontAvailable(this._families[0],!0)?i(this._families[0]):s("Font not available"),!0};document.fonts.ready.then((()=>{a()}))}isFontAvailable(e,t){return new Promise((s=>{const i=`1em ${e}`;if(document.fonts.check(i))s(!0);else if(t){j.debug("Font",`Font ${e} not available, creating test element to trigger load`);const t=document.createElement("div");t.style.font=i,t.style.opacity="0",t.style.position="absolute",t.style.top="0",t.style.left="0",t.innerText=`Trigger ${e} load`,document.body.appendChild(t),setTimeout((()=>{document.body.removeChild(t),document.fonts.check(i)?s(!0):s(!1)}),200)}else s(!1)}))}}class Wr{constructor(e){this._writePosition=0,this._readPosition=0,this.count=0,this._buffer=new Float32Array(e)}clear(){this._readPosition=0,this._writePosition=0,this.count=0,this._buffer=new Float32Array(this._buffer.length)}write(e,t,s){let i=0;s>this._buffer.length-this.count&&(s=this._buffer.length-this.count);const a=Math.min(this._buffer.length-this._writePosition,s);return this._buffer.set(e.subarray(t,t+a),this._writePosition),this._writePosition+=a,this._writePosition%=this._buffer.length,i+=a,i<s&&(this._buffer.set(e.subarray(t+i,t+i+s-i),this._writePosition),this._writePosition+=s-i,i=s),this.count+=i,i}read(e,t,s){s>this.count&&(s=this.count);let i=0;const a=Math.min(this._buffer.length-this._readPosition,s);return e.set(this._buffer.subarray(this._readPosition,this._readPosition+a),t),i+=a,this._readPosition+=a,this._readPosition%=this._buffer.length,i<s&&(e.set(this._buffer.subarray(this._readPosition,this._readPosition+s-i),t+i),this._readPosition+=s-i,i=s),this.count-=i,i}}class Vr{constructor(e){this.isDefault=!1,this.device=e}get deviceId(){return this.device.deviceId}get label(){return this.device.label}}class Gr{constructor(){this._context=null,this._buffer=null,this._source=null,this.ready=new Zi,this.samplesPlayed=new ea,this.sampleRequest=new Zi,this._knownDevices=[]}get sampleRate(){return this._context?this._context.sampleRate:Gr.PreferredSampleRate}activate(e){this._context||(this._context=this.createAudioContext()),"suspended"!==this._context.state&&"interrupted"!==this._context.state||(j.debug("WebAudio","Audio Context is suspended, trying resume"),this._context.resume().then((()=>{j.debug("WebAudio",`Audio Context resume success: state=${this._context?.state}, sampleRate:${this._context?.sampleRate}`),e&&e()}),(e=>{j.warning("WebAudio",`Audio Context resume failed: state=${this._context?.state}, sampleRate:${this._context?.sampleRate}, reason=${e}`)})))}patchIosSampleRate(){const e=navigator.userAgent;if(-1!==e.indexOf("iPhone")||-1!==e.indexOf("iPad")){const e=this.createAudioContext(),t=e.createBuffer(1,1,Gr.PreferredSampleRate),s=e.createBufferSource();s.buffer=t,s.connect(e.destination),s.start(0),s.disconnect(0),e.close()}}createAudioContext(){if("AudioContext"in nc.globalThis)return new AudioContext;if("webkitAudioContext"in nc.globalThis)return new webkitAudioContext;throw new qe(e.AlphaTabErrorType.General,"AudioContext not found")}open(e){this.patchIosSampleRate(),this._context=this.createAudioContext();"suspended"===this._context.state&&this.registerResumeHandler()}registerResumeHandler(){this._resumeHandler=(()=>{this.activate((()=>{this.unregisterResumeHandler()}))}).bind(this),document.body.addEventListener("touchend",this._resumeHandler,!1),document.body.addEventListener("click",this._resumeHandler,!1)}unregisterResumeHandler(){const e=this._resumeHandler;e&&(document.body.removeEventListener("touchend",e,!1),document.body.removeEventListener("click",e,!1))}play(){const e=this._context;this.activate(),this._buffer=e.createBuffer(2,Gr.BufferSize,e.sampleRate),this._source=e.createBufferSource(),this._source.buffer=this._buffer,this._source.loop=!0}pause(){this._source&&(this._source.stop(0),this._source.disconnect()),this._source=null}destroy(){this.pause(),this._context?.close(),this._context=null,this.unregisterResumeHandler()}onSamplesPlayed(e){this.samplesPlayed.trigger(e)}onSampleRequest(){this.sampleRequest.trigger()}onReady(){this.ready.trigger()}async checkSinkIdSupport(){return"setSinkId"in(this._context??this.createAudioContext())||(j.warning("WebAudio","Browser does not support changing the output device"),!1)}async enumerateOutputDevices(){try{if(!await this.checkSinkIdSupport())return[];try{await navigator.mediaDevices.getUserMedia({audio:!0})}catch(e){j.warning("WebAudio","Output device permission rejected",e)}const e=await navigator.mediaDevices.enumerateDevices();let t="",s="";const i=new Map;for(const a of e)"audiooutput"===a.kind&&(i.set(a.groupId,new Vr(a)),"default"!==a.deviceId&&""!==a.deviceId||(t=a.groupId,s=a.deviceId));const a=Array.from(i.values());let r=a.find((e=>e.deviceId===s));return r||(r=a.find((e=>e.device.groupId===t))),!r&&a.length>0&&(r=a[0]),r&&(r.isDefault=!0),this._knownDevices=a,a}catch(e){return j.error("WebAudio","Failed to enumerate output devices",e),[]}}async setOutputDevice(e){await this.checkSinkIdSupport()&&(e?await this._context.setSinkId(e.deviceId):await this._context.setSinkId(""))}async getOutputDevice(){if(!await this.checkSinkIdSupport())return null;const e=this._context.sinkId;if("string"!=typeof e||""===e||"default"===e)return null;let t=this._knownDevices.find((t=>t.deviceId===e));if(t)return t;const s=await this.enumerateOutputDevices();return t=s.find((t=>t.deviceId===e)),t||(j.warning("WebAudio","Could not find output device in device list",e,s),null)}}Gr.BufferSize=4096,Gr.PreferredSampleRate=44100;class zr extends Gr{constructor(){super(...arguments),this._audioNode=null,this._bufferCount=0,this._requestedBufferCount=0,this._outputBuffer=new Float32Array(0)}open(e){super.open(e),this._bufferCount=Math.floor(e*this.sampleRate/1e3/Gr.BufferSize),this._circularBuffer=new Wr(Gr.BufferSize*this._bufferCount),this.onReady()}play(){super.play();const e=this._context;this._audioNode=e.createScriptProcessor(4096,0,2),this._audioNode.onaudioprocess=this.generateSound.bind(this),this._circularBuffer.clear(),this.requestBuffers(),this._source=e.createBufferSource(),this._source.buffer=this._buffer,this._source.loop=!0,this._source.connect(this._audioNode,0,0),this._source.start(0),this._audioNode.connect(e.destination,0,0)}pause(){super.pause(),this._audioNode&&this._audioNode.disconnect(0),this._audioNode=null}addSamples(e){this._circularBuffer.write(e,0,e.length),this._requestedBufferCount--}resetSamples(){this._circularBuffer.clear()}requestBuffers(){const e=this._bufferCount/2|0,t=e*Gr.BufferSize;if(this._circularBuffer.count+this._requestedBufferCount*Gr.BufferSize<t){for(let t=0;t<e;t++)this.onSampleRequest();this._requestedBufferCount+=e}}generateSound(e){const t=e.outputBuffer.getChannelData(0),s=e.outputBuffer.getChannelData(1),i=t.length+s.length;let a=this._outputBuffer;a.length!==i&&(a=new Float32Array(i),this._outputBuffer=a);const r=this._circularBuffer.read(a,0,Math.min(a.length,this._circularBuffer.count));let n=0;const o=Math.min(t.length,r);for(let e=0;e<o;e++)t[e]=a[n++],s[e]=a[n++];if(r<t.length)for(let e=r;e<t.length;e++)t[e]=0,s[e]=0;this.onSamplesPlayed(r/Q.AudioChannels),this.requestBuffers()}}class Ur{constructor(e,t){this.loaded=e,this.total=t}}class Xr{get output(){return this._output}get isReady(){return this._workerIsReady&&this._outputIsReady}get isReadyForPlayback(){return this._workerIsReadyForPlayback}get state(){return this._state}get logLevel(){return j.logLevel}set logLevel(e){j.logLevel=e,this._synth.postMessage({cmd:"alphaSynth.setLogLevel",value:e})}get masterVolume(){return this._masterVolume}set masterVolume(e){e=Math.max(e,Q.MinVolume),this._masterVolume=e,this._synth.postMessage({cmd:"alphaSynth.setMasterVolume",value:e})}get metronomeVolume(){return this._metronomeVolume}set metronomeVolume(e){e=Math.max(e,Q.MinVolume),this._metronomeVolume=e,this._synth.postMessage({cmd:"alphaSynth.setMetronomeVolume",value:e})}get countInVolume(){return this._countInVolume}set countInVolume(e){e=Math.max(e,Q.MinVolume),this._countInVolume=e,this._synth.postMessage({cmd:"alphaSynth.setCountInVolume",value:e})}get midiEventsPlayedFilter(){return this._midiEventsPlayedFilter}set midiEventsPlayedFilter(e){this._midiEventsPlayedFilter=e,this._synth.postMessage({cmd:"alphaSynth.setMidiEventsPlayedFilter",value:e})}get playbackSpeed(){return this._playbackSpeed}set playbackSpeed(e){e=ae.clamp(e,Q.MinPlaybackSpeed,Q.MaxPlaybackSpeed),this._playbackSpeed=e,this._synth.postMessage({cmd:"alphaSynth.setPlaybackSpeed",value:e})}get tickPosition(){return this._tickPosition}set tickPosition(e){e<0&&(e=0),this._tickPosition=e,this._synth.postMessage({cmd:"alphaSynth.setTickPosition",value:e})}get timePosition(){return this._timePosition}set timePosition(e){e<0&&(e=0),this._timePosition=e,this._synth.postMessage({cmd:"alphaSynth.setTimePosition",value:e})}get isLooping(){return this._isLooping}set isLooping(e){this._isLooping=e,this._synth.postMessage({cmd:"alphaSynth.setIsLooping",value:e})}get playbackRange(){return this._playbackRange}set playbackRange(e){e&&(e.startTick<0&&(e.startTick=0),e.endTick<0&&(e.endTick=0)),this._playbackRange=e,this._synth.postMessage({cmd:"alphaSynth.setPlaybackRange",value:e})}constructor(e,t){this._workerIsReadyForPlayback=!1,this._workerIsReady=!1,this._outputIsReady=!1,this._state=Ht.Paused,this._masterVolume=0,this._metronomeVolume=0,this._countInVolume=0,this._playbackSpeed=0,this._tickPosition=0,this._timePosition=0,this._isLooping=!1,this._playbackRange=null,this._midiEventsPlayedFilter=[],this.ready=new Zi,this.readyForPlayback=new Zi,this.finished=new Zi,this.soundFontLoaded=new Zi,this.soundFontLoadFailed=new ea,this.midiLoaded=new ea,this.midiLoadFailed=new ea,this.stateChanged=new ea,this.positionChanged=new ea,this.midiEventsPlayed=new ea,this.playbackRangeChanged=new ea,this._workerIsReadyForPlayback=!1,this._workerIsReady=!1,this._outputIsReady=!1,this._state=Ht.Paused,this._masterVolume=0,this._metronomeVolume=0,this._playbackSpeed=0,this._tickPosition=0,this._timePosition=0,this._isLooping=!1,this._playbackRange=null,this._output=e,this._output.ready.on(this.onOutputReady.bind(this)),this._output.samplesPlayed.on(this.onOutputSamplesPlayed.bind(this)),this._output.sampleRequest.on(this.onOutputSampleRequest.bind(this)),this._output.open(t.player.bufferTimeInMilliseconds);try{this._synth=nc.createWebWorker(t)}catch(e){j.error("AlphaSynth",`Failed to create WebWorker: ${e}`)}this._synth.addEventListener("message",this.handleWorkerMessage.bind(this),!1),this._synth.postMessage({cmd:"alphaSynth.initialize",sampleRate:this._output.sampleRate,logLevel:t.core.logLevel,bufferTimeInMilliseconds:t.player.bufferTimeInMilliseconds}),this.masterVolume=1,this.playbackSpeed=1,this.metronomeVolume=0}destroy(){this._synth.postMessage({cmd:"alphaSynth.destroy"})}play(){return this._output.activate(),this._synth.postMessage({cmd:"alphaSynth.play"}),!0}pause(){this._synth.postMessage({cmd:"alphaSynth.pause"})}playPause(){this._output.activate(),this._synth.postMessage({cmd:"alphaSynth.playPause"})}stop(){this._synth.postMessage({cmd:"alphaSynth.stop"})}playOneTimeMidiFile(e){this._synth.postMessage({cmd:"alphaSynth.playOneTimeMidiFile",midi:qa.midiFileToJsObject(e)})}loadSoundFont(e,t){this._synth.postMessage({cmd:"alphaSynth.loadSoundFontBytes",data:e,append:t})}loadSoundFontFromUrl(e,t,s){j.debug("AlphaSynth",`Start loading Soundfont from url ${e}`);const i=new XMLHttpRequest;i.open("GET",e,!0,null,null),i.responseType="arraybuffer",i.onload=e=>{const s=new Uint8Array(i.response);this.loadSoundFont(s,t)},i.onerror=e=>{j.error("AlphaSynth",`Loading failed: ${e.message}`),this.soundFontLoadFailed.trigger(new Ar(e.message,i))},i.onprogress=e=>{j.debug("AlphaSynth",`Soundfont downloading: ${e.loaded}/${e.total} bytes`),s(new Ur(e.loaded,e.total))},i.send()}resetSoundFonts(){this._synth.postMessage({cmd:"alphaSynth.resetSoundFonts"})}loadMidiFile(e){this._synth.postMessage({cmd:"alphaSynth.loadMidi",midi:qa.midiFileToJsObject(e)})}applyTranspositionPitches(e){this._synth.postMessage({cmd:"alphaSynth.applyTranspositionPitches",transpositionPitches:JSON.stringify(Array.from(e.entries()))})}setChannelTranspositionPitch(e,t){this._synth.postMessage({cmd:"alphaSynth.setChannelTranspositionPitch",channel:e,semitones:t})}setChannelMute(e,t){this._synth.postMessage({cmd:"alphaSynth.setChannelMute",channel:e,mute:t})}resetChannelStates(){this._synth.postMessage({cmd:"alphaSynth.resetChannelStates"})}setChannelSolo(e,t){this._synth.postMessage({cmd:"alphaSynth.setChannelSolo",channel:e,solo:t})}setChannelVolume(e,t){t=Math.max(t,Q.MinVolume),this._synth.postMessage({cmd:"alphaSynth.setChannelVolume",channel:e,volume:t})}handleWorkerMessage(e){const t=e.data;switch(t.cmd){case"alphaSynth.ready":this._workerIsReady=!0,this.checkReady();break;case"alphaSynth.destroyed":this._synth.terminate();break;case"alphaSynth.readyForPlayback":this._workerIsReadyForPlayback=!0,this.checkReadyForPlayback();break;case"alphaSynth.positionChanged":this._timePosition=t.currentTime,this._tickPosition=t.currentTick,this.positionChanged.trigger(new qs(t.currentTime,t.endTime,t.currentTick,t.endTick,t.isSeek));break;case"alphaSynth.midiEventsPlayed":this.midiEventsPlayed.trigger(new ta(t.events.map(qa.jsObjectToMidiEvent)));break;case"alphaSynth.playerStateChanged":this._state=t.state,this.stateChanged.trigger(new $s(t.state,t.stopped));break;case"alphaSynth.playbackRangeChanged":this._playbackRange=t.playbackRange,this.playbackRangeChanged.trigger(new sa(this._playbackRange));break;case"alphaSynth.finished":this.finished.trigger();break;case"alphaSynth.soundFontLoaded":this.soundFontLoaded.trigger();break;case"alphaSynth.soundFontLoadFailed":this.soundFontLoadFailed.trigger(t.error);break;case"alphaSynth.midiLoaded":this.checkReadyForPlayback(),this.midiLoaded.trigger(new qs(t.currentTime,t.endTime,t.currentTick,t.endTick,t.isSeek));break;case"alphaSynth.midiLoadFailed":this.checkReadyForPlayback(),this.midiLoadFailed.trigger(t.error);break;case"alphaSynth.output.addSamples":this._output.addSamples(t.samples);break;case"alphaSynth.output.play":this._output.play();break;case"alphaSynth.output.pause":this._output.pause();break;case"alphaSynth.output.destroy":this._output.destroy();break;case"alphaSynth.output.resetSamples":this._output.resetSamples()}}checkReady(){this.isReady&&this.ready.trigger()}checkReadyForPlayback(){this.isReadyForPlayback&&this.readyForPlayback.trigger()}onOutputSampleRequest(){this._synth.postMessage({cmd:"alphaSynth.output.sampleRequest"})}onOutputSamplesPlayed(e){this._synth.postMessage({cmd:"alphaSynth.output.samplesPlayed",samples:e})}onOutputReady(){this._outputIsReady=!0,this.checkReady()}}class Jr{constructor(e,t){this._width=0,this.boundsLookup=null,this.preRender=new ea,this.partialRenderFinished=new ea,this.partialLayoutFinished=new ea,this.renderFinished=new ea,this.postRenderFinished=new Zi,this.error=new ea,this._api=e;try{this._worker=nc.createWebWorker(t)}catch(e){return void j.error("Rendering",`Failed to create WebWorker: ${e}`)}this._worker.postMessage({cmd:"alphaTab.initialize",settings:this.serializeSettingsForWorker(t)}),this._worker.addEventListener("message",this.handleWorkerMessage.bind(this))}destroy(){this._worker.terminate()}updateSettings(e){this._worker.postMessage({cmd:"alphaTab.updateSettings",settings:this.serializeSettingsForWorker(e)})}serializeSettingsForWorker(e){const t=qa.settingsToJsObject(e);return t.delete("player"),t}render(){this._worker.postMessage({cmd:"alphaTab.render"})}resizeRender(){this._worker.postMessage({cmd:"alphaTab.resizeRender"})}renderResult(e){this._worker.postMessage({cmd:"alphaTab.renderResult",resultId:e})}get width(){return this._width}set width(e){this._width=e,this._worker.postMessage({cmd:"alphaTab.setWidth",width:e})}handleWorkerMessage(e){const t=e.data;switch(t.cmd){case"alphaTab.preRender":this.preRender.trigger(t.resize);break;case"alphaTab.partialRenderFinished":this.partialRenderFinished.trigger(t.result);break;case"alphaTab.partialLayoutFinished":this.partialLayoutFinished.trigger(t.result);break;case"alphaTab.renderFinished":this.renderFinished.trigger(t.result);break;case"alphaTab.postRenderFinished":this.boundsLookup=nr.fromJson(t.boundsLookup,this._api.score),this.boundsLookup.finish(),this.postRenderFinished.trigger();break;case"alphaTab.error":this.error.trigger(t.error)}}renderScore(e,t){const s=null==e?null:qa.scoreToJsObject(e);this._worker.postMessage({cmd:"alphaTab.renderScore",score:s,trackIndexes:t,fontSizes:Za.FontSizeLookupTables})}}class Yr{constructor(e,t,s,i){this.cursorWrapper=e,this.barCursor=t,this.beatCursor=s,this.selectionWrapper=i}}class $r{static init(){var e;$r._isRegistered||($r._isRegistered=!0,registerProcessor("alphatab",((e=class extends AudioWorkletProcessor{constructor(t){super(t),this._outputBuffer=new Float32Array(0),this._bufferCount=0,this._requestedBufferCount=0,this._isStopped=!1,j.debug("WebAudio","creating processor"),this._bufferCount=Math.floor(t.processorOptions.bufferTimeInMilliseconds*sampleRate/1e3/e.BufferSize),this._circularBuffer=new Wr(e.BufferSize*this._bufferCount),this.port.onmessage=this.handleMessage.bind(this)}handleMessage(e){const t=e.data;switch(t.cmd){case ja.CmdOutputAddSamples:const e=t.samples;this._circularBuffer.write(e,0,e.length),this._requestedBufferCount--;break;case ja.CmdOutputResetSamples:this._circularBuffer.clear();break;case ja.CmdOutputStop:this._isStopped=!0}}process(e,t,s){if(1!==t.length&&2!==t[0].length)return!1;const i=t[0][0],a=t[0][1];if(!i||!a)return!0;const r=i.length+a.length;let n=this._outputBuffer;n.length!==r&&(n=new Float32Array(r),this._outputBuffer=n);const o=this._circularBuffer.read(n,0,Math.min(n.length,this._circularBuffer.count));let h=0;const l=Math.min(i.length,o);for(let e=0;e<l;e++)i[e]=n[h++],a[e]=n[h++];if(o<i.length)for(let e=o;e<i.length;e++)i[e]=0,a[e]=0;return this.port.postMessage({cmd:ja.CmdOutputSamplesPlayed,samples:o/Q.AudioChannels}),this.requestBuffers(),this._circularBuffer.count>0||!this._isStopped}requestBuffers(){const t=this._bufferCount/2|0,s=t*e.BufferSize;if(this._circularBuffer.count+this._requestedBufferCount*e.BufferSize<s){for(let e=0;e<t;e++)this.port.postMessage({cmd:ja.CmdOutputSampleRequest});this._requestedBufferCount+=t}}}).BufferSize=4096,e)))}}$r._isRegistered=!1;class qr extends Gr{constructor(e){super(),this._worklet=null,this._bufferTimeInMilliseconds=0,this._settings=e}open(e){super.open(e),this._bufferTimeInMilliseconds=e,this.onReady()}play(){super.play();const e=this._context;nc.createAudioWorklet(e,this._settings).then((()=>{this._worklet=new AudioWorkletNode(e,"alphatab",{numberOfOutputs:1,outputChannelCount:[2],processorOptions:{bufferTimeInMilliseconds:this._bufferTimeInMilliseconds}}),this._worklet.port.onmessage=this.handleMessage.bind(this),this._source.connect(this._worklet),this._source.start(0),this._worklet.connect(e.destination)}),(e=>{j.error("WebAudio",`Audio Worklet creation failed: reason=${e}`)}))}handleMessage(e){const t=e.data;switch(t.cmd){case ja.CmdOutputSamplesPlayed:this.onSamplesPlayed(t.samples);break;case ja.CmdOutputSampleRequest:this.onSampleRequest()}}pause(){super.pause(),this._worklet&&(this._worklet.port.postMessage({cmd:ja.CmdOutputStop}),this._worklet.port.onmessage=null,this._worklet.disconnect()),this._worklet=null}addSamples(e){this._worklet?.port.postMessage({cmd:ja.CmdOutputAddSamples,samples:e})}resetSamples(){this._worklet?.port.postMessage({cmd:ja.CmdOutputResetSamples})}}class jr extends Or{constructor(e,t,s){super(e),this._xscale=t,this._yscale=s}get width(){return this.element.offsetWidth/this._xscale}set width(e){this.element.style.width=e*this._xscale+"px"}get height(){return this.element.offsetHeight/this._yscale}set height(e){this.element.style.height=e>=0?e*this._yscale+"px":"100%"}setBounds(e,t,s,i){Number.isNaN(e)&&(e=this.lastBounds.x),Number.isNaN(t)&&(t=this.lastBounds.y),Number.isNaN(s)?s=this.lastBounds.w:s/=this._xscale,Number.isNaN(i)?i=this.lastBounds.h:i/=this._yscale,this.element.style.transform=`translate(${e}px, ${t}px) scale(${s}, ${i})`,this.element.style.transformOrigin="top left",this.lastBounds.x=e,this.lastBounds.y=t,this.lastBounds.w=s,this.lastBounds.h=i}}!function(e){e[e.LayoutDone=0]="LayoutDone",e[e.RenderRequested=1]="RenderRequested",e[e.RenderDone=2]="RenderDone",e[e.Detached=3]="Detached"}(ts||(ts={}));class Kr{get resizeThrottle(){return 10}get canRender(){return this.areAllFontsLoaded()}areAllFontsLoaded(){if(nc.bravuraFontChecker.checkForFontAvailability(),!nc.bravuraFontChecker.isFontLoaded)return!1;let e=!1;for(const t of this._fontCheckers.values())t.isFontLoaded||(e=!0);return!e&&(j.debug("Font",`All fonts loaded: ${this._fontCheckers.size}`),!0)}onFontLoaded(e){Za.generateFontLookup(e),this.areAllFontsLoaded()&&this.canRenderChanged.trigger()}constructor(t){if(this._fontCheckers=new Map,this._contents=null,this._file=null,this._totalResultCount=0,this._initialTrackIndexes=null,this._barToElementLookup=new Map,this._resultIdToElementLookup=new Map,this.rootContainerBecameVisible=new Zi,this.canRenderChanged=new Zi,this._highlightedElements=[],this._scrollContainer=null,nc.webPlatform!==e.WebPlatform.Browser&&nc.webPlatform!==e.WebPlatform.BrowserModule)throw new qe(e.AlphaTabErrorType.General,"Usage of AlphaTabApi is only possible in browser environments. For usage in node use the Low Level APIs");t.classList.add("alphaTab"),this.rootContainer=new Or(t),this.areWorkersSupported="Worker"in window,nc.bravuraFontChecker.fontLoaded.on(this.onFontLoaded.bind(this)),this._intersectionObserver=new IntersectionObserver(this.onElementVisibilityChanged.bind(this),{threshold:[0,.01,1]}),this._intersectionObserver.observe(t)}onElementVisibilityChanged(e){for(const t of e){const e=t.target;if(e===this.rootContainer.element)t.isIntersecting&&(this.rootContainerBecameVisible.trigger(),this._intersectionObserver.unobserve(this.rootContainer.element));else if("layoutResultId"in e&&this._api.settings.core.enableLazyLoading){const s=e;t.isIntersecting?s.renderedResultId!==s.layoutResultId?this._resultIdToElementLookup.has(s.layoutResultId)?s.resultState!==ts.RenderRequested&&(s.resultState=ts.RenderRequested,this._api.renderer.renderResult(s.layoutResultId)):e.replaceChildren():s.resultState===ts.Detached&&(e.replaceChildren(...s.renderedResult),s.resultState=ts.RenderDone):s.resultState===ts.RenderDone&&(s.resultState=ts.Detached,s.replaceChildren())}}}createWorkerRenderer(){return new Jr(this._api,this._api.settings)}initialize(t,s){let i;this._api=t,i=s instanceof ka?s:qa.jsObjectToSettings(s);const a=this.getDataAttributes();Ba.fromJson(i,a),i.notation.notationMode===e.NotationMode.SongBook&&i.setSongBookModeSettings(),t.settings=i,this.setupFontCheckers(i),this._initialTrackIndexes=this.parseTracks(i.core.tracks),this._contents="";const r=t.container;i.core.tex&&(this._contents=r.element.innerHTML,r.element.innerHTML=""),this.createStyleElement(i),this._file=i.core.file}setupFontCheckers(e){this.registerFontChecker(e.display.resources.copyrightFont),this.registerFontChecker(e.display.resources.effectFont),this.registerFontChecker(e.display.resources.fingeringFont),this.registerFontChecker(e.display.resources.graceFont),this.registerFontChecker(e.display.resources.markerFont),this.registerFontChecker(e.display.resources.tablatureFont),this.registerFontChecker(e.display.resources.titleFont),this.registerFontChecker(e.display.resources.wordsFont),this.registerFontChecker(e.display.resources.barNumberFont),this.registerFontChecker(e.display.resources.fretboardNumberFont),this.registerFontChecker(e.display.resources.subTitleFont)}registerFontChecker(e){if(!this._fontCheckers.has(e.families.join(", "))){const t=new Hr(e.families);this._fontCheckers.set(e.families.join(", "),t),t.fontLoaded.on(this.onFontLoaded.bind(this)),t.checkForFontAvailability()}}destroy(){this.rootContainer.element.innerHTML=""}createCanvasElement(){const e=document.createElement("div");return e.className="at-surface",e.style.fontSize="0",e.style.overflow="hidden",e.style.lineHeight="0",e.style.position="relative",new Or(e)}triggerEvent(e,t,s=null,i){const a=e.element;t=`alphaTab.${t}`;const r=document.createEvent("CustomEvent"),n=i?i.mouseEvent:null;if(r.initCustomEvent(t,!1,!1,s),n&&(r.originalEvent=n),a.dispatchEvent(r),window&&"jQuery"in window){const e=window.jQuery,i=[];i.push(s),n&&i.push(n),e(a).trigger(t,i)}}load(e,t,s){if(e instanceof Ye)return t(e),!0;if(e instanceof ArrayBuffer){const s=new Uint8Array(e);return t(Ir.loadScoreFromBytes(s,this._api.settings)),!0}return e instanceof Uint8Array?(t(Ir.loadScoreFromBytes(e,this._api.settings)),!0):"string"==typeof e&&(Ir.loadScoreAsync(e,t,s,this._api.settings),!0)}loadSoundFont(e,t){return!!this._api.player&&(e instanceof ArrayBuffer?(this._api.player.loadSoundFont(new Uint8Array(e),t),!0):e instanceof Uint8Array?(this._api.player.loadSoundFont(e,t),!0):"string"==typeof e&&(this._api.loadSoundFontFromUrl(e,t),!0))}initialRender(){this._api.renderer.preRender.on((e=>{this._totalResultCount=0,this._resultIdToElementLookup.clear(),this._barToElementLookup.clear()}));const e=()=>{this._api.renderer.width=0|this.rootContainer.width,this._api.renderer.updateSettings(this._api.settings),this._contents?(this._api.tex(this._contents,this._initialTrackIndexes??void 0),this._initialTrackIndexes=null):this._file&&Ir.loadScoreAsync(this._file,(e=>{this._api.renderScore(e,this._initialTrackIndexes??void 0),this._initialTrackIndexes=null}),(e=>{this._api.onError(e)}),this._api.settings)};this.rootContainer.isVisible?e():this.rootContainerBecameVisible.on(e)}createStyleElement(e){const t=this._api.container.element.ownerDocument;nc.createStyleElement(t,e.core.fontDirectory)}parseTracks(e){if(!e)return[];const t=[];if("string"==typeof e)try{if("all"===e)return[-1];e=JSON.parse(e)}catch(t){e=[0]}if("number"==typeof e)t.push(e);else if("length"in e){const s=e.length,i=e;for(let e=0;e<s;e++){const s=i[e];let a=0;a="number"==typeof s?s:"index"in s?s.index:Number.parseInt(s.toString()),(a>=0||-1===a)&&t.push(a)}}else"index"in e&&t.push(e.index);return t}getDataAttributes(){const e=new Map,t=this._api.container.element;if(t.dataset)for(const s of Object.keys(t.dataset)){let i=t.dataset[s];try{const e=i;i=JSON.parse(e)}catch(e){""===i&&(i=null)}e.set(s,i)}else for(let s=0;s<t.attributes.length;s++){const i=t.attributes.item(s),a=i.nodeName;if(a.startsWith("data-")){const t=a.substr(5).split("-");let s=t[0];for(let e=1;e<t.length;e++)s+=t[e].substr(0,1).toUpperCase()+t[e].substr(1);let r=i.nodeValue;try{r=JSON.parse(r)}catch(e){""===r&&(r=null)}e.set(s,r)}}return e}beginUpdateRenderResults(e){if(!this._resultIdToElementLookup.has(e.id))return;const t=this._resultIdToElementLookup.get(e.id),s=e.renderResult;"string"==typeof s?t.innerHTML=s:"nodeType"in s&&t.replaceChildren(s),t.resultState=ts.RenderDone,t.renderedResultId=e.id,t.renderedResult=Array.from(t.children)}beginAppendRenderResults(e){const t=this._api.canvasElement.element;if(e){let s;this._totalResultCount<t.childElementCount?s=t.childNodes.item(this._totalResultCount):(s=document.createElement("div"),t.appendChild(s)),s.style.zIndex="1",s.style.position="absolute",s.style.left=`${e.x}px`,s.style.top=`${e.y}px`,s.style.width=`${e.width}px`,s.style.height=`${e.height}px`,s.style.display="inline-block",s.layoutResultId=e.id,s.resultState=ts.LayoutDone,s.renderedResultId=void 0,s.renderedResult=void 0,this._resultIdToElementLookup.set(e.id,s);for(let t=e.firstMasterBarIndex;t<=e.lastMasterBarIndex;t++)t>=0&&this._barToElementLookup.set(t,s);this._api.settings.core.enableLazyLoading&&(this._intersectionObserver.unobserve(s),this._intersectionObserver.observe(s)),this._totalResultCount++}else for(;t.childElementCount>this._totalResultCount;)this._api.settings.core.enableLazyLoading&&this._intersectionObserver.unobserve(t.lastChild),t.removeChild(t.lastElementChild)}createWorkerPlayer(){let t=null;const s="ScriptProcessorNode"in window;return window.isSecureContext&&"AudioWorkletNode"in window&&this._api.settings.player.outputMode===e.PlayerOutputMode.WebAudioAudioWorklets?(j.debug("Player","Will use webworkers for synthesizing and web audio api with worklets for playback"),t=new Xr(new qr(this._api.settings),this._api.settings)):s&&(j.debug("Player","Will use webworkers for synthesizing and web audio api with ScriptProcessor for playback"),t=new Xr(new zr,this._api.settings)),t?t.ready.on((()=>{this._api.settings.player.soundFont&&this._api.loadSoundFontFromUrl(this._api.settings.player.soundFont,!1)})):j.error("Player","Player requires webworkers and web audio api, browser unsupported",null),t}beginInvoke(e){window.requestAnimationFrame((()=>{e()}))}highlightElements(e,t){const s=this._barToElementLookup.get(t);if(s){const t=s.getElementsByClassName(e);for(let e=0;e<t.length;e++)t.item(e).classList.add("at-highlight"),this._highlightedElements.push(t.item(e))}}removeHighlights(){const e=this._highlightedElements;if(e){for(const t of e)t.classList.remove("at-highlight");this._highlightedElements=[]}}destroyCursors(){const e=this._api.container.element,t=e.querySelector(".at-cursors");e.removeChild(t)}createCursors(){const e=this._api.container.element,t=document.createElement("div");t.classList.add("at-cursors");const s=document.createElement("div");s.classList.add("at-selection");const i=this.createScalingElement(),a=this.createScalingElement(),r=i.element;r.classList.add("at-cursor-bar");const n=a.element;return n.classList.add("at-cursor-beat"),e.style.position="relative",e.style.textAlign="left",t.style.position="absolute",t.style.zIndex="1000",t.style.display="inline",t.style.pointerEvents="none",s.style.position="absolute",r.style.position="absolute",r.style.left="0",r.style.top="0",r.style.willChange="transform",i.width=1,i.height=1,i.setBounds(0,0,1,1),n.style.position="absolute",n.style.transition="all 0s linear",n.style.left="0",n.style.top="0",n.style.willChange="transform",a.width=3,a.height=1,a.setBounds(0,0,1,1),e.insertBefore(t,e.firstChild),t.appendChild(s),t.appendChild(r),t.appendChild(n),new Yr(new Or(t),i,a,new Or(s))}getOffset(e,t){const s=t.element,i=s.getBoundingClientRect();let a=i.top+s.ownerDocument.defaultView.pageYOffset,r=i.left+s.ownerDocument.defaultView.pageXOffset;if(e){const t=e.element,s=t.nodeName.toLowerCase();if("html"!==s&&"body"!==s){const s=this.getOffset(null,e);a=a+t.scrollTop-s.y,r=r+t.scrollLeft-s.x}}const n=new ft;return n.x=r,n.y=a,n.w=i.width,n.h=i.height,n}getScrollContainer(){if(this._scrollContainer)return this._scrollContainer;let e="string"==typeof this._api.settings.player.scrollElement?document.querySelector(this._api.settings.player.scrollElement):this._api.settings.player.scrollElement;const t=e.nodeName.toLowerCase();if("html"===t||"body"===t)if("scrollingElement"in document)e=document.scrollingElement;else{e=-1!==navigator.userAgent.indexOf("WebKit")?document.body:document.documentElement}return this._scrollContainer=new Or(e),this._scrollContainer}createSelectionElement(){return this.createScalingElement()}createScalingElement(){const e=document.createElement("div");e.style.position="absolute";const t=new jr(e,100,100);return t.width=1,t.height=1,t.setBounds(0,0,1,1),t}scrollToY(e,t,s){this.internalScrollToY(e.element,t,s)}scrollToX(e,t,s){this.internalScrollToX(e.element,t,s)}internalScrollToY(e,t,s){if(this._api.settings.player.nativeBrowserSmoothScroll)e.scrollTo({top:t,behavior:"smooth"});else{const i=e.scrollTop,a=t-i;let r=0;const n=t=>{0===r&&(r=t);const o=t-r,h=Math.min(o/s,1);e.scrollTop=i+a*h|0,o<s&&window.requestAnimationFrame(n)};window.requestAnimationFrame(n)}}internalScrollToX(e,t,s){if(this._api.settings.player.nativeBrowserSmoothScroll)e.scrollTo({left:t,behavior:"smooth"});else{const i=e.scrollLeft,a=t-i;let r=0;const n=t=>{0===r&&(r=t);const o=t-r,h=Math.min(o/s,1);e.scrollLeft=i+a*h|0,o<s&&window.requestAnimationFrame(n)};window.requestAnimationFrame(n)}}}class Qr extends Lr{constructor(e,t){super(new Kr(e),t),this.soundFontLoad=new ea}tex(e,t){const s=this.uiFacade;super.tex(e,s.parseTracks(t))}print(t,s=null){const i=window.open("","","width=0,height=0"),a=i.document.createElement("div");t?a.style.width=t:this.settings.display.layoutMode===e.LayoutMode.Horizontal?a.style.width="297mm":a.style.width="210mm",i.document.write("\n        <!DOCTYPE html>\n        <html>\n          <head>\n            <style>\n            .at-surface {\n                width: auto !important;\n                height: auto !important;\n            }\n            .at-surface > div {\n                position: relative!important;\n                left: auto !important;\n                top: auto !important;\n                break-inside: avoid;\n            }\n            </style>\n          </head>\n          <body></body>\n        </html>\n        ");const r=this.score;r&&(r.artist&&r.title?i.document.title=`${r.title} - ${r.artist}`:r.title&&(i.document.title=`${r.title}`)),i.document.body.appendChild(a);const n=void 0!==window.screenLeft?window.screenLeft:window.left,o=void 0!==window.screenTop?window.screenTop:window.top,h="innerWidth"in window?window.innerWidth:"clientWidth"in document.documentElement?document.documentElement.clientWidth:window.screen.width,l="innerHeight"in window?window.innerHeight:"clientHeight"in document.documentElement?document.documentElement.clientHeight:window.screen.height,c=a.offsetWidth+50,d=window.innerHeight,u=(h/2|0)-(c/2|0)+n,p=(l/2|0)-(d/2|0)+o;i.resizeTo(c,d),i.moveTo(u,p),i.focus();const g=qa.jsObjectToSettings(qa.settingsToJsObject(this.settings));g.core.enableLazyLoading=!1,g.core.useWorkers=!0,g.core.file=null,g.core.tracks=null,g.player.enableCursor=!1,g.player.enablePlayer=!1,g.player.enableElementHighlighting=!1,g.player.enableUserInteraction=!1,g.player.soundFont=null,g.display.scale=.8,g.display.stretchForce=.8,Ba.fromJson(g,s);const m=new Qr(a,g);i.onunload=()=>{m.destroy()},m.renderer.postRenderFinished.on((()=>{i.print()})),m.renderTracks(this.tracks)}downloadMidi(e=Rt.SingleTrackMultiChannel){if(!this.score)return;const t=new Fs;t.format=e;const s=new cr(t,!0);new Br(this.score,this.settings,s).generate();const i=t.toBinary(),a=this.score.title?`${this.score.title}.mid`:"File.mid",r=document.createElement("a");r.download=a;const n=new Blob([i],{type:"audio/midi"}),o=URL.createObjectURL(n);r.href=o,r.style.display="none",document.body.appendChild(r),r.click(),document.body.removeChild(r)}changeTrackMute(e,t){const s=this.trackIndexesToTracks(this.uiFacade.parseTracks(e));super.changeTrackMute(s,t)}changeTrackSolo(e,t){const s=this.trackIndexesToTracks(this.uiFacade.parseTracks(e));super.changeTrackSolo(s,t)}changeTrackVolume(e,t){const s=this.trackIndexesToTracks(this.uiFacade.parseTracks(e));super.changeTrackVolume(s,t)}trackIndexesToTracks(e){if(!this.score)return[];const t=[];if(1===e.length&&-1===e[0])for(const e of this.score.tracks)t.push(e);else for(const s of e)s>=0&&s<this.score.tracks.length&&t.push(this.score.tracks[s]);return t}loadSoundFontFromUrl(e,t){this.player&&this.player.loadSoundFontFromUrl(e,t,(e=>{this.soundFontLoad.trigger(e),this.uiFacade.triggerEvent(this.container,"soundFontLoad",e)}))}}class Zr{constructor(){this._initListeners=[]}exec(e,t,s){if("string"!=typeof t&&(s=[t],t="init"),95===t.charCodeAt(0)||"exec"===t)return null;const i=new jQuery(e),a=i.data("alphaTab");if("destroy"===t&&!a)return null;if("init"!==t&&!a)throw new Error("alphaTab not initialized");const r=this[t];if(r){const e=[i,a].concat(s);return r.apply(this,e)}return j.error("Api",`Method '${t}' does not exist on jQuery.alphaTab`),null}init(e,t,s){if(!t){t=new Qr(e[0],s),e.data("alphaTab",t);for(const i of this._initListeners)i(e,t,s)}}destroy(e,t){e.removeData("alphaTab"),t.destroy()}print(e,t,s,i){t.print(s,i)}load(e,t,s,i){return t.load(s,i)}render(e,t){t.render()}renderScore(e,t,s,i){t.renderScore(s,i)}renderTracks(e,t,s){t.renderTracks(s)}invalidate(e,t){t.render()}tex(e,t,s,i){t.tex(s,i)}muteTrack(e,t,s,i){t.changeTrackMute(s,i)}soloTrack(e,t,s,i){t.changeTrackSolo(s,i)}trackVolume(e,t,s,i){t.changeTrackVolume(s,i)}loadSoundFont(e,t,s,i){t.loadSoundFont(s,i)}resetSoundFonts(e,t){t.resetSoundFonts()}pause(e,t){t.pause()}play(e,t){return t.play()}playPause(e,t){t.playPause()}stop(e,t){t.stop()}api(e,t){return t}player(e,t){return t.player}isReadyForPlayback(e,t){return t.isReadyForPlayback}playerState(e,t){return t.playerState}masterVolume(e,t,s){return"number"==typeof s&&(t.masterVolume=s),t.masterVolume}metronomeVolume(e,t,s){return"number"==typeof s&&(t.metronomeVolume=s),t.metronomeVolume}countInVolume(e,t,s){return"number"==typeof s&&(t.countInVolume=s),t.countInVolume}midiEventsPlayedFilter(e,t,s){return Array.isArray(s)&&(t.midiEventsPlayedFilter=s),t.midiEventsPlayedFilter}playbackSpeed(e,t,s){return"number"==typeof s&&(t.playbackSpeed=s),t.playbackSpeed}tickPosition(e,t,s){return"number"==typeof s&&(t.tickPosition=s),t.tickPosition}timePosition(e,t,s){return"number"==typeof s&&(t.timePosition=s),t.timePosition}loop(e,t,s){return"boolean"==typeof s&&(t.isLooping=s),t.isLooping}renderer(e,t){return t.renderer}score(e,t){return t.score}settings(e,t){return t.settings}tracks(e,t){return t.tracks}_oninit(e){this._initListeners.push(e)}static restore(e){new jQuery(e).empty().removeData("alphaTab")}}class en{constructor(){this.buffer="",this._currentPath="",this._currentPathIsEmpty=!0,this.scale=1,this.color=new tt(255,255,255,255),this.lineWidth=1,this.font=new oa("Arial",10,Yt.Plain),this.textAlign=oe.Left,this.textBaseline=he.Top}destroy(){}beginRender(e,t){this.scale=this.settings.display.scale,this.buffer=`<svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="${0|e}px" height="${0|t}px" class="at-surface-svg">\n`,this._currentPath="",this._currentPathIsEmpty=!0,this.textBaseline=he.Top}beginGroup(e){this.buffer+=`<g class="${e}">`}endGroup(){this.buffer+="</g>"}endRender(){return this.buffer+="</svg>",this.buffer}fillRect(e,t,s,i){s>0&&(this.buffer+=`<rect x="${e*this.scale|0}" y="${t*this.scale|0}" width="${s*this.scale}" height="${i*this.scale}" fill="${this.color.rgba}" />\n`)}strokeRect(e,t,s,i){const a=this.lineWidth*this.scale%2==0?0:.5;this.buffer+=`<rect x="${(e*this.scale|0)+a}" y="${(t*this.scale|0)+a}" width="${s*this.scale}" height="${i*this.scale}" stroke="${this.color.rgba}"`,1!==this.lineWidth&&(this.buffer+=` stroke-width="${this.lineWidth*this.scale}"`),this.buffer+=' fill="transparent" />\n'}beginPath(){}closePath(){this._currentPath+=" z"}moveTo(e,t){this._currentPath+=` M${e*this.scale},${t*this.scale}`}lineTo(e,t){this._currentPathIsEmpty=!1,this._currentPath+=` L${e*this.scale},${t*this.scale}`}quadraticCurveTo(e,t,s,i){this._currentPathIsEmpty=!1,this._currentPath+=` Q${e*this.scale},${t*this.scale},${s*this.scale},${i*this.scale}`}bezierCurveTo(e,t,s,i,a,r){this._currentPathIsEmpty=!1,this._currentPath+=` C${e*this.scale},${t*this.scale},${s*this.scale},${i*this.scale},${a*this.scale},${r*this.scale}`}fillCircle(e,t,s){this._currentPathIsEmpty=!1,e*=this.scale,t*=this.scale,s*=this.scale,this._currentPath+=` M${e-s},${t} A1,1 0 0,0 ${e+s},${t} A1,1 0 0,0 ${e-s},${t} z`,this.fill()}strokeCircle(e,t,s){this._currentPathIsEmpty=!1,e*=this.scale,t*=this.scale,s*=this.scale,this._currentPath+=` M${e-s},${t} A1,1 0 0,0 ${e+s},${t} A1,1 0 0,0 ${e-s},${t} z`,this.stroke()}fill(){this._currentPathIsEmpty||(this.buffer+=`<path d="${this._currentPath}"`,"#000000"!==this.color.rgba&&(this.buffer+=` fill="${this.color.rgba}"`),this.buffer+=' style="stroke: none"/>'),this._currentPath="",this._currentPathIsEmpty=!0}stroke(){if(!this._currentPathIsEmpty){let e=`<path d="${this._currentPath}" stroke="${this.color.rgba}"`;1===this.lineWidth&&1===this.scale||(e+=` stroke-width="${this.lineWidth*this.scale}"`),e+=' style="fill: none" />',this.buffer+=e}this._currentPath="",this._currentPathIsEmpty=!0}fillText(e,t,s){if(""===e)return;let i=`<text x="${t*this.scale|0}" y="${s*this.scale|0}" style='stroke: none; font:${this.font.toCssString(this.settings.display.scale)}; ${this.getSvgBaseLine()}'`;"#000000"!==this.color.rgba&&(i+=` fill="${this.color.rgba}"`),this.textAlign!==oe.Left&&(i+=` text-anchor="${this.getSvgTextAlignment(this.textAlign)}"`),i+=`>${en.escapeText(e)}</text>`,this.buffer+=i}static escapeText(e){return e.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/'/g,"&#39;").replace(/</g,"&lt;").replace(/>/g,"&gt;")}getSvgTextAlignment(e){switch(e){case oe.Left:return"start";case oe.Center:return"middle";case oe.Right:return"end"}return""}getSvgBaseLine(){switch(this.textBaseline){case he.Top:return"dominant-baseline: hanging";case he.Bottom:return"dominant-baseline: ideographic";default:return""}}measureText(e){return e?Za.measureString(e,this.font.families,this.font.size*this.scale,this.font.style,this.font.weight):new De(0,0)}onRenderFinished(){return null}beginRotate(e,t,s){this.buffer+=`<g transform="translate(${e*this.scale} ,${t*this.scale}) rotate( ${s})">`}endRotate(){this.buffer+="</g>"}}class tn extends en{fillMusicFontSymbol(e,t,s,i,a){i!==ne.None&&this.fillMusicFontSymbolText(e,t,s,`&#${i};`,a)}fillMusicFontSymbols(e,t,s,i,a){let r="";for(const e of i)e!==ne.None&&(r+=`&#${e};`);this.fillMusicFontSymbolText(e,t,s,r,a)}fillMusicFontSymbolText(e,t,s,i,a){e*=this.scale,t*=this.scale,this.buffer+=`<g transform="translate(${e} ${t})" class="at" ><text`;const r=this.scale*s;this.buffer+=1!==r?` style="font-size: ${100*r}%; stroke:none"`:' style="stroke:none"',"#000000"!==this.color.rgba&&(this.buffer+=` fill="${this.color.rgba}"`),a&&(this.buffer+=` text-anchor="${this.getSvgTextAlignment(oe.Center)}"`),this.buffer+=`>${i}</text></g>`}}class sn{constructor(){this.isInsideBracket=!0,this.isRelevantForBoundsLookup=!0,this.hideOnMultiTrack=!1,this.hideOnPercussionTrack=!1}canCreate(e,t){return!this.hideOnPercussionTrack||!t.isPercussion}}!function(e){e[e.PreNotes=0]="PreNotes",e[e.OnNotes=1]="OnNotes",e[e.MiddleNotes=2]="MiddleNotes",e[e.Stem=3]="Stem",e[e.PostNotes=4]="PostNotes",e[e.EndBeat=5]="EndBeat"}(ss||(ss={}));class an extends Tr{constructor(){super(...arguments),this.glyphs=null}get isEmpty(){return!this.glyphs||0===this.glyphs.length}doLayout(){if(!this.glyphs||0===this.glyphs.length)return void(this.width=0);let e=0;for(let t=0,s=this.glyphs.length;t<s;t++){const s=this.glyphs[t];s.renderer=this.renderer,s.doLayout(),e=Math.max(e,s.width)}this.width=e}addGlyph(e){this.glyphs||(this.glyphs=[]),this.renderer&&(e.renderer=this.renderer),this.glyphs.push(e)}paint(e,t,s){const i=this.glyphs;if(i&&0!==i.length)for(const a of i)a.paint(e+this.x,t+this.y,s)}}class rn extends an{constructor(){super(0,0),this.glyphs=[]}doLayout(){}addGlyph(e){e.x=this.width,e.renderer=this.renderer,e.doLayout(),this.width=e.x+e.width,super.addGlyph(e)}}class nn{static score(e,t,s,i=!1){if(!s.style&&!i)return;const a=nn.scoreDefaultColor(e.settings.display.resources,t);return new on(e,t,s.style,a)}static scoreColor(e,t,s){const i=nn.scoreDefaultColor(e,t);if(s.style&&s.style.colors.has(t))return s.style.colors.get(t)??i}static scoreDefaultColor(e,t){return e.mainGlyphColor}static bar(e,t,s,i=!1){if(!s.style&&!i)return;let a=e.settings.display.resources.mainGlyphColor;switch(t){case p.StandardNotationRepeats:case p.GuitarTabsRepeats:case p.SlashRepeats:case p.NumberedRepeats:case p.StandardNotationClef:case p.GuitarTabsClef:case p.StandardNotationKeySignature:case p.NumberedKeySignature:case p.StandardNotationTimeSignature:case p.GuitarTabsTimeSignature:case p.SlashTimeSignature:case p.NumberedTimeSignature:break;case p.StandardNotationBarLines:case p.GuitarTabsBarLines:case p.SlashBarLines:case p.NumberedBarLines:a=e.settings.display.resources.barSeparatorColor;break;case p.StandardNotationBarNumber:case p.SlashBarNumber:case p.NumberedBarNumber:case p.GuitarTabsBarNumber:a=e.settings.display.resources.barNumberColor;break;case p.StandardNotationStaffLine:case p.GuitarTabsStaffLine:case p.SlashStaffLine:case p.NumberedStaffLine:a=e.settings.display.resources.staffLineColor}return new on(e,t,s.style,a)}static voice(e,t,s,i=!1){if(!s.style&&!i)return;const a=0===s.index?e.settings.display.resources.mainGlyphColor:e.settings.display.resources.secondaryGlyphColor;return new on(e,t,s.style,a)}static trackColor(e,t,s){const i=nn.trackDefaultColor(e,t);if(s.style&&s.style.colors.has(t))return s.style.colors.get(t)??i}static trackDefaultColor(e,t){let s=e.mainGlyphColor;switch(t){case Be.TrackName:case Be.SystemSeparator:case Be.StringTuning:break;case Be.BracesAndBrackets:s=e.barSeparatorColor}return s}static track(e,t,s,i=!1){if(!s.style&&!i)return;const a=nn.trackDefaultColor(e.settings.display.resources,t);return new on(e,t,s.style,a)}static beatColor(e,t,s){const i=nn.beatDefaultColor(e,t,s);if(s.style&&s.style.colors.has(t))return s.style.colors.get(t)??i}static beatDefaultColor(e,t,s){return 0===s.voice.index?e.mainGlyphColor:e.secondaryGlyphColor}static beat(e,t,s,i=!1){if(!s.style&&!i)return;const a=nn.beatDefaultColor(e.settings.display.resources,t,s);return new on(e,t,s.style,a)}static noteColor(e,t,s){const i=nn.noteDefaultColor(e,t,s);if(s.style&&s.style.colors.has(t))return s.style.colors.get(t)??i}static noteDefaultColor(e,t,s){return 0===s.beat.voice.index?e.mainGlyphColor:e.secondaryGlyphColor}static note(e,t,s,i=!1){if(!s.style&&!i)return;const a=0===s.beat.voice.index?e.settings.display.resources.mainGlyphColor:e.settings.display.resources.secondaryGlyphColor;return new on(e,t,s.style,a)}}class on{constructor(e,t,s,i){this._canvas=e,s&&s.colors.has(t)?(this._previousColor=e.color,e.color=s.colors.get(t)??i):s||(this._previousColor=e.color,e.color=i)}[Symbol.dispose](){this._previousColor&&(this._canvas.color=this._previousColor)}}class hn extends an{constructor(e,t,s){super(e,t),this.voice=s,this.beatGlyphs=[],this.tupletGroups=[]}scaleToWidth(e){const t=this.renderer.layoutingInfo.spaceToForce(e);this.scaleToForce(t)}scaleToForce(e){this.width=this.renderer.layoutingInfo.calculateVoiceWidth(e);const t=this.renderer.layoutingInfo.buildOnTimePositions(e),s=this.beatGlyphs;for(let e=0,i=s.length;e<i;e++){const a=s[e];if(a.beat.graceType===B.None)a.x=t.get(a.beat.absoluteDisplayStart)-a.onTimeX;else{const i=a.beat.graceGroup.beats[0].absoluteDisplayStart,r=a.beat.graceGroup.id;if(a.beat.graceGroup.isComplete&&t.has(i)){a.x=t.get(i)-a.onTimeX;const e=this.renderer.layoutingInfo.allGraceRods.get(r),s=a.beat.graceGroup.beats[a.beat.graceGroup.beats.length-1].nextBeat,n=s?this.renderer.layoutingInfo.getPreBeatSize(s)+Cr.GraceBeatPadding:0;a.x-=n,a.x-=e[a.beat.graceIndex].postSpringWidth,a.x+=e[a.beat.graceIndex].graceBeatWidth;const o=e[a.beat.graceGroup.beats.length-1];a.x-=o.graceBeatWidth}else{const t=this.renderer.layoutingInfo.incompleteGraceRods.get(r),i=t[a.beat.graceIndex].postSpringWidth-t[a.beat.graceIndex].preSpringWidth;e>0?0===a.beat.graceIndex?a.x=s[e-1].x+s[e-1].width:a.x=s[e-1].x+t[a.beat.graceIndex-1].postSpringWidth-t[a.beat.graceIndex-1].preSpringWidth-i:a.x=-i}}if(e>0){const t=a.x-s[e-1].x;s[e-1].scaleToWidth(t)}if(e===i-1){const e=this.width-s[s.length-1].x;a.scaleToWidth(e)}}}registerLayoutingInfo(e){const t=this.beatGlyphs;for(const s of t)s.registerLayoutingInfo(e)}applyLayoutingInfo(e){const t=this.beatGlyphs;for(const s of t)s.applyLayoutingInfo(e);this.scaleToForce(Math.max(this.renderer.settings.display.stretchForce,e.minStretchForce))}addGlyph(e){const t=e;e.x=0===this.beatGlyphs.length?0:this.beatGlyphs[this.beatGlyphs.length-1].x+this.beatGlyphs[this.beatGlyphs.length-1].width,e.renderer=this.renderer,e.doLayout(),this.beatGlyphs.push(t),this.width=e.x+e.width,t.beat.hasTuplet&&t.beat.tupletGroup.beats[0].id===t.beat.id&&this.tupletGroups.push(t.beat.tupletGroup)}doLayout(){}paint(e,t,s){const i=nn.voice(s,I.Glyphs,this.voice,!0);try{for(let i=0,a=this.beatGlyphs.length;i<a;i++)this.beatGlyphs[i].paint(e+this.x,t+this.y,s)}finally{i?.[Symbol.dispose]?.()}}}hn.KeySizeBeat="Beat";class ln{constructor(){this.staffId="",this.up=0,this.down=0}}class cn{constructor(){this.startBeat=null,this.startX=0,this.startY=0,this.endBeat=null,this.endX=0,this.endY=0}calcY(e){return this.startX===this.endX?this.startY:(this.endY-this.startY)/(this.endX-this.startX)*(e-this.startX)+this.startY}}class dn{get isRestBeamHelper(){return 1===this.beats.length&&this.beats[0].isRest}hasLine(e,t){return e&&this.beatHasLine(t)||!e&&1===this.beats.length&&this.beatHasLine(t)}beatHasLine(e){return e.duration>w.Whole}hasFlag(e,t){return e&&this.beatHasFlag(t)||!e&&1===this.beats.length&&this.beatHasFlag(this.beats[0])}beatHasFlag(e){return!e.deadSlapped&&!e.isRest&&(e.duration>w.Quarter||e.graceType!==B.None)}constructor(e,t){this._beatLineXPositions=new Map,this._firstNonRestBeat=null,this._lastNonRestBeat=null,this.voice=null,this.beats=[],this.shortestDuration=w.QuadrupleWhole,this.hasTuplet=!1,this.slashBeats=[],this._firstBeatLowestNoteCompareValue=-1,this._firstBeatHighestNoteCompareValue=-1,this._lastBeatLowestNoteCompareValue=-1,this._lastBeatHighestNoteCompareValue=-1,this.lowestNoteInHelper=null,this._lowestNoteCompareValueInHelper=-1,this.highestNoteInHelper=null,this._highestNoteCompareValueInHelper=-1,this.invertBeamDirection=!1,this.preferredBeamDirection=null,this.isGrace=!1,this.minRestLine=null,this.beatOfMinRestLine=null,this.maxRestLine=null,this.beatOfMaxRestLine=null,this.direction=Ne.Up,this.drawingInfos=new Map,this._staff=e,this._renderer=t,this.beats=[]}getBeatLineX(e,t){return t=t??this.direction,this.hasBeatLineX(e)?t===Ne.Up?this._beatLineXPositions.get(e.index).up:this._beatLineXPositions.get(e.index).down:0}hasBeatLineX(e){return this._beatLineXPositions.has(e.index)}registerBeatLineX(e,t,s,i){const a=this.getOrCreateBeatPositions(t);a.staffId=e,a.up=s,a.down=i;for(const e of this.drawingInfos.values())e.startBeat===t?e.startX=this.getBeatLineX(t):e.endBeat===t&&(e.endX=this.getBeatLineX(t))}getOrCreateBeatPositions(e){return this._beatLineXPositions.has(e.index)||this._beatLineXPositions.set(e.index,new ln),this._beatLineXPositions.get(e.index)}finish(){this.direction=this.calculateDirection()}calculateDirection(){let e=null;if(this.voice?null!==this.preferredBeamDirection?e=this.preferredBeamDirection:this.voice.index>0?e=this.invert(Ne.Down):(this.voice.bar.isMultiVoice||this.beats[0].graceType!==B.None)&&(e=this.invert(Ne.Up)):e=Ne.Up,this.highestNoteInHelper&&this.lowestNoteInHelper){const t=this._renderer.getNoteY(this.highestNoteInHelper,as.Center),s=this._renderer.getNoteY(this.lowestNoteInHelper,as.Center);if(null===e){const i=(t+s)/2;e=this.invert(this._renderer.middleYPosition<i?Ne.Up:Ne.Down)}this._renderer.completeBeamingHelper(this)}else e=this.invert(Ne.Up),this._renderer.completeBeamingHelper(this);return e}static computeLineHeightsForRest(e){switch(e){case w.QuadrupleWhole:case w.DoubleWhole:return[2,2];case w.Whole:return[0,1];case w.Half:return[1,0];case w.Quarter:return[3,3];case w.Eighth:return[2,2];case w.Sixteenth:return[2,4];case w.ThirtySecond:return[4,4];case w.SixtyFourth:return[4,6];case w.OneHundredTwentyEighth:return[6,6];case w.TwoHundredFiftySixth:return[6,8]}return[0,0]}applyRest(e,t){if(this._lastNonRestBeat&&e.index>=this._lastNonRestBeat.index||this._firstNonRestBeat&&e.index<=this._firstNonRestBeat.index)return;let s=t,i=t;const a=dn.computeLineHeightsForRest(e.duration);s-=a[0],i+=a[1];const r=this.minRestLine,n=this.maxRestLine;(null===r||r>s)&&(this.minRestLine=s,this.beatOfMinRestLine=e),(null===n||n<i)&&(this.maxRestLine=i,this.beatOfMaxRestLine=e)}invert(e){return this.invertBeamDirection?e===Ne.Down?Ne.Up:Ne.Down:e}checkBeat(e){e.invertBeamDirection&&(this.invertBeamDirection=!0),this.voice||(this.voice=e.voice);let t=!1;if(0===this.beats.length)t=!0;else switch(this.beats[this.beats.length-1].beamingMode){case ye.Auto:case ye.ForceSplitOnSecondaryToNext:t=dn.canJoin(this.beats[this.beats.length-1],e);break;case ye.ForceSplitToNext:t=!1;break;case ye.ForceMergeWithNext:t=!0}return t&&(null==this.preferredBeamDirection&&null!==e.preferredBeamDirection&&(this.preferredBeamDirection=e.preferredBeamDirection),e.hasTuplet&&(this.hasTuplet=!0),e.graceType!==B.None&&(this.isGrace=!0),e.isRest?0===this.beats.length&&this.beats.push(e):(this.isRestBeamHelper&&(this.beats=[]),this.beats.push(e),this.checkNote(e.minNote),this.checkNote(e.maxNote),this.shortestDuration<e.duration&&(this.shortestDuration=e.duration),this._firstNonRestBeat||(this._firstNonRestBeat=e),this._lastNonRestBeat=e),e.slashed&&this.slashBeats.push(e)),t}checkNote(e){if(!e)return;let t,s;this.voice&&e.isPercussion?(t=-ks.getPercussionLine(this.voice.bar,ks.getNoteValue(e)),s=t):(t=ks.getNoteValue(e),s=t,e.harmonicType!==N.None&&e.harmonicType!==N.Natural&&(s=e.realValue-this._staff.displayTranspositionPitch)),1===this.beats.length&&this.beats[0]===e.beat&&((-1===this._firstBeatLowestNoteCompareValue||t<this._firstBeatLowestNoteCompareValue)&&(this._firstBeatLowestNoteCompareValue=t),(-1===this._firstBeatHighestNoteCompareValue||s>this._firstBeatHighestNoteCompareValue)&&(this._firstBeatHighestNoteCompareValue=s)),(-1===this._lastBeatLowestNoteCompareValue||t<this._lastBeatLowestNoteCompareValue)&&(this._lastBeatLowestNoteCompareValue=t),(-1===this._lastBeatHighestNoteCompareValue||s>this._lastBeatHighestNoteCompareValue)&&(this._lastBeatHighestNoteCompareValue=s),(!this.lowestNoteInHelper||t<this._lowestNoteCompareValueInHelper)&&(this.lowestNoteInHelper=e,this._lowestNoteCompareValueInHelper=t),(!this.highestNoteInHelper||s>this._highestNoteCompareValueInHelper)&&(this.highestNoteInHelper=e,this._highestNoteCompareValueInHelper=s)}static canJoin(e,t){if(!e||!t||e.graceType!==t.graceType||e.graceType===B.BendGrace||t.graceType===B.BendGrace||e.deadSlapped||t.deadSlapped)return!1;if(e.graceType!==B.None&&t.graceType!==B.None)return!0;const s=e.voice.bar;if(s!==t.voice.bar)return!1;const i=e.playbackStart,a=t.playbackStart;if(!dn.canJoinDuration(e.duration)||!dn.canJoinDuration(t.duration))return i===a;if(e.tupletGroup!==t.tupletGroup)return!1;if(e.hasTuplet&&t.hasTuplet&&e.tupletGroup===t.tupletGroup&&e.tupletGroup.isFull)return!0;let r=U.QuarterTime;if(8===s.masterBar.timeSignatureDenominator)s.masterBar.timeSignatureNumerator%3==0&&(r+=U.QuarterTime/2|0);return((r+i)/r|0)===((r+a)/r|0)}static canJoinDuration(e){switch(e){case w.Whole:case w.Half:case w.Quarter:return!1;default:return!0}}static isFullBarJoin(e,t,s){return ae.getIndex(e.duration)-2-s>0&&ae.getIndex(t.duration)-2-s>0}get beatOfLowestNote(){return this.lowestNoteInHelper.beat}get beatOfHighestNote(){return this.highestNoteInHelper.beat}isPositionFrom(e,t){return!this._beatLineXPositions.has(t.index)||(this._beatLineXPositions.get(t.index).staffId===e||!this._beatLineXPositions.get(t.index).staffId)}}class un{constructor(e,t){this.topY=0,this.bottomY=0,this.topY=e,this.bottomY=t}}class pn{constructor(e){this.topY=-1e3,this.bottomY=-1e3,this.slots=[],this.beat=e}addSlot(e,t){if(this.slots.push(new un(e,t)),-1e3===this.topY)this.topY=e,this.bottomY=t;else{const s=Math.min(e,t),i=Math.max(e,t);s<this.topY&&(this.topY=s),i>this.bottomY&&(this.bottomY=i)}}}class gn{constructor(){this.reservedLayoutAreasByDisplayTime=new Map,this.restDurationsByDisplayTime=new Map}getBeatMinMaxY(){let e=-1e3,t=-1e3;for(const s of this.reservedLayoutAreasByDisplayTime.values())-1e3===e?(e=s.topY,t=s.bottomY):(e>s.topY&&(e=s.topY),t<s.bottomY&&(t=s.bottomY));return-1e3===e?[0,0]:[e,t]}reserveBeatSlot(e,t,s){t!==s&&(this.reservedLayoutAreasByDisplayTime.has(e.displayStart)||this.reservedLayoutAreasByDisplayTime.set(e.displayStart,new pn(e)),this.reservedLayoutAreasByDisplayTime.get(e.displayStart).addSlot(t,s),e.isRest&&this.registerRest(e))}registerRest(e){this.restDurationsByDisplayTime.has(e.displayStart)||this.restDurationsByDisplayTime.set(e.displayStart,new Map),this.restDurationsByDisplayTime.get(e.displayStart).has(e.playbackDuration)||this.restDurationsByDisplayTime.get(e.displayStart).set(e.playbackDuration,e.id)}applyRestCollisionOffset(e,t,s){if(e.voice.index>0&&this.reservedLayoutAreasByDisplayTime.has(e.playbackStart)){const i=dn.computeLineHeightsForRest(e.duration).map((e=>e*s)),a=t-i[0],r=t+i[1];let n=a;const o=this.reservedLayoutAreasByDisplayTime.get(e.playbackStart);let h=!1;for(const e of o.slots)if(a>=e.topY&&a<=e.bottomY||r>=e.topY&&r<=e.bottomY){h=!0;break}if(h){n=1===e.voice.index?o.topY-i[1]-i[0]:o.bottomY;const t=n+i[0]+i[1],r=2*s,h=Math.ceil(Math.abs(n-a)/r);return o.addSlot(n,t),n<a?h*-r:h*r}}return 0}}class mn{constructor(e){this.beamHelpers=[],this.beamHelperLookup=[],this.preferredBeamDirection=null,this._renderer=e,this.collisionHelper=new gn}initialize(){const e=this._renderer,t=this._renderer.bar;let s=null,i=null;for(let a=0,r=t.voices.length;a<r;a++){const r=t.voices[a];this.beamHelpers.push([]),this.beamHelperLookup.push(new Map);for(let a=0,n=r.beats.length;a<n;a++){const n=r.beats[a];let o;n.graceType!==B.None?o=i:(o=s,i=null),o&&o.checkBeat(n)||(o&&o.finish(),o=new dn(t.staff,e),o.preferredBeamDirection=this.preferredBeamDirection,o.checkBeat(n),n.graceType!==B.None?i=o:s=o,this.beamHelpers[r.index].push(o)),this.beamHelperLookup[r.index].set(n.index,o)}s&&s.finish(),i&&i.finish(),s=null,i=null}}getBeamingHelperForBeat(e){return this.beamHelperLookup[e.voice.index].get(e.index)}}class fn extends Nr{constructor(e,t,s){super(e,t),this._textRow=0,this._fretRow=0,this._firstFretSpacing=0,this._chord=s}doLayout(){super.doLayout();const e=this.renderer.resources;this._textRow=1.5*e.effectFont.size,this._fretRow=1.5*e.effectFont.size,this._chord.firstFret>1?this._firstFretSpacing=fn.FretSpacing:this._firstFretSpacing=0,this.height=this._textRow+this._fretRow+fn.Frets*fn.FretSpacing+2*fn.Padding[1],this.width=this._firstFretSpacing+(this._chord.strings.length-1)*fn.StringSpacing+2*fn.Padding[0]}paint(e,t,s){e+=this.x+fn.Padding[0]+this._firstFretSpacing,t+=this.y;const i=fn.StringSpacing,a=fn.FretSpacing,r=this.renderer.resources,n=fn.CircleRadius,o=this.width-2*fn.Padding[0]-this._firstFretSpacing,h=s.textAlign,l=s.textBaseline;s.font=r.effectFont,s.textAlign=oe.Center,s.textBaseline=he.Top,this._chord.showName&&s.fillText(this._chord.name,e+o/2,t+r.effectFont.size/2),t+=this._textRow,s.font=r.fretboardNumberFont,s.textBaseline=he.Middle;for(let a=0;a<this._chord.strings.length;a++){const r=e+a*i,n=t+this._fretRow/2;let o=this._chord.strings[this._chord.strings.length-a-1];o<0?s.fillMusicFontSymbol(r,n,1,ne.FretboardX,!0):0===o?s.fillMusicFontSymbol(r,n,1,ne.FretboardO,!0):(o-=this._chord.firstFret-1,s.fillText(o.toString(),r,n))}t+=this._fretRow;for(let r=0;r<this._chord.strings.length;r++){const n=e+r*i;s.fillRect(n,t,1,a*fn.Frets+1)}this._chord.firstFret>1&&(s.textAlign=oe.Left,s.fillText(this._chord.firstFret.toString(),e-this._firstFretSpacing,t+a/2)),s.fillRect(e,t-1,o,2);for(let i=0;i<=fn.Frets;i++){const r=t+i*a;s.fillRect(e,r,o,1)}const c=new Map;for(const e of this._chord.barreFrets){const t=[-1,-1];c.set(e-this._chord.firstFret,t)}for(let r=0;r<this._chord.strings.length;r++){let o=this._chord.strings[r];if(o>0){if(o-=this._chord.firstFret,c.has(o)){const e=c.get(o);(-1===e[0]||r<e[0])&&(e[0]=r),(-1===e[1]||r>e[1])&&(e[1]=r)}const h=t+o*a+a/2+.5,l=e+(this._chord.strings.length-r-1)*i;s.fillCircle(l,h,n)}}for(const[r,o]of c){const h=t+r*a+a/2+.5,l=e+(this._chord.strings.length-o[1]-1)*i,c=e+(this._chord.strings.length-o[0]-1)*i;s.fillRect(l,h-n,c-l,2*n)}s.textAlign=h,s.textBaseline=l}}fn.Padding=[5,2],fn.Frets=5,fn.CircleRadius=2.5,fn.StringSpacing=10,fn.FretSpacing=12;class yn extends an{constructor(e,t,s=oe.Center){super(e,t),this._glyphWidth=0,this.glyphs=[],this._align=s}doLayout(){let e=0;switch(this._align){case oe.Left:e=0;break;case oe.Center:e=(this.width-this._glyphWidth)/2;break;case oe.Right:e=this.width-this._glyphWidth}for(const t of this.glyphs)t.x=e,e+=t.width}addGlyphToRow(e){this.glyphs.push(e),this._glyphWidth+=e.width,e.height>this.height&&(this.height=e.height)}}class bn extends an{constructor(e,t,s=oe.Center){super(e,t),this._rows=[],this.height=0,this.glyphs=[],this._align=s}doLayout(){let e=0,t=0;const s=bn.Padding;this._rows=[];let i=new yn(e,t,this._align);i.width=this.width;for(const a of this.glyphs)e+a.width<this.width?(i.addGlyphToRow(a),e+=a.width):(i.isEmpty||(i.doLayout(),this._rows.push(i),t+=i.height+s),e=0,i=new yn(e,t,this._align),i.width=this.width,i.addGlyphToRow(a),e+=a.width);i.isEmpty||(i.doLayout(),this._rows.push(i),t+=i.height+s),this.height=t}paint(e,t,s){for(const i of this._rows)i.paint(e+this.x,t+this.y,s)}}bn.Padding=3;class Sn extends bn{addChord(e){if(e.strings.length>0){const t=new fn(0,0,e);t.renderer=this.renderer,t.doLayout(),this.glyphs.push(t)}}paint(e,t,s){if(this.glyphs.length>0){const i=nn.score(s,Se.ChordDiagramList,this.renderer.scoreRenderer.score);try{super.paint(e,t,s)}finally{i?.[Symbol.dispose]?.()}}}}class _n extends Nr{constructor(e,t,s,i,a=oe.Left,r=null,n){super(e,t),this._lineHeights=null,this._lines=s.split("\n"),this.font=i,this.textAlign=a,this.textBaseline=r,this.colorOverride=n}doLayout(){super.doLayout(),this._lineHeights=[];const e=this.renderer.scoreRenderer.canvas;for(const t of this._lines){e.font=this.font;const s=e.measureText(t),i=s.height;this._lineHeights.push(i),this.height+=i,this.width=Math.max(this.width,s.width)}}paint(e,t,s){const i=s.color;s.color=this.colorOverride??i,s.font=this.font;const a=s.textAlign,r=s.textBaseline;s.textAlign=this.textAlign,null!==this.textBaseline&&(s.textBaseline=this.textBaseline);let n=t+this.y;for(let t=0;t<this._lines.length;t++)s.fillText(this._lines[t],e+this.x,n),n+=this._lineHeights[t];s.textAlign=a,s.textBaseline=r,s.color=i}}class wn{get staffId(){return this._factory.staffId}get contentTop(){return this.y+this.staveTop+this.topSpacing+this.topOverflow}get contentBottom(){return this.y+this.topSpacing+this.topOverflow+this.staveBottom}constructor(e,t,s){this._sharedLayoutData=new Map,this.barRenderers=[],this.x=0,this.y=0,this.height=0,this.index=0,this.staffIndex=0,this.isFirstInSystem=!1,this.trackIndex=0,this.staveTop=0,this.topSpacing=0,this.bottomSpacing=0,this.staveBottom=0,this._factory=s,this.trackIndex=e,this.modelStaff=t}getSharedLayoutData(e,t){return this._sharedLayoutData.has(e)?this._sharedLayoutData.get(e):t}setSharedLayoutData(e,t){this._sharedLayoutData.set(e,t)}get isInsideBracket(){return this._factory.isInsideBracket}get isRelevantForBoundsLookup(){return this._factory.isRelevantForBoundsLookup}registerStaffTop(e){this.staveTop=e}registerStaffBottom(e){this.staveBottom=e}addBarRenderer(e){e.staff=this,e.index=this.barRenderers.length,e.reLayout(),this.barRenderers.push(e),this.system.layout.registerBarRenderer(this.staffId,e)}addBar(e,t,s){const i=this._factory.create(this.system.layout.renderer,e);i.additionalMultiRestBars=s,i.staff=this,i.index=this.barRenderers.length,i.layoutingInfo=t,i.doLayout(),i.registerLayoutingInfo();const a=i.barDisplayWidth;a>0&&this.system.layout.systemsLayoutMode===is.FromModelWithWidths&&(i.width=a),this.barRenderers.push(i),e&&this.system.layout.registerBarRenderer(this.staffId,i)}revertLastBar(){const e=this.barRenderers[this.barRenderers.length-1];this.barRenderers.splice(this.barRenderers.length-1,1),this.system.layout.unregisterBarRenderer(this.staffId,e);for(const e of this.barRenderers)e.applyLayoutingInfo();return e}scaleToWidth(e){this._sharedLayoutData=new Map;const t=this.topOverflow;let s=0;switch(this.system.layout.systemsLayoutMode){case is.Automatic:const i=(e-this.system.computedWidth)/this.barRenderers.length;for(const e of this.barRenderers){e.x=s,e.y=this.topSpacing+t;const a=e.computedWidth+i;e.scaleToWidth(a),s+=e.width}break;case is.FromModelWithScale:e-=this.system.accoladeWidth;const a=this.system.totalBarDisplayScale;for(const i of this.barRenderers){i.x=s,i.y=this.topSpacing+t;const r=i.barDisplayScale*e/a;i.scaleToWidth(r),s+=i.width}break;case is.FromModelWithWidths:for(const e of this.barRenderers){e.x=s,e.y=this.topSpacing+t;const i=e.barDisplayWidth;i>0?e.scaleToWidth(i):e.scaleToWidth(e.computedWidth),s+=e.width}}}get topOverflow(){let e=0;for(let t=0,s=this.barRenderers.length;t<s;t++){const s=this.barRenderers[t];s.topOverflow>e&&(e=s.topOverflow)}return e}get bottomOverflow(){let e=0;for(let t=0,s=this.barRenderers.length;t<s;t++){const s=this.barRenderers[t];s.bottomOverflow>e&&(e=s.bottomOverflow)}return e}calculateHeightForAccolade(){this.topSpacing=this._factory.getStaffPaddingTop(this),this.bottomSpacing=this._factory.getStaffPaddingBottom(this),this.height=this.barRenderers.length>0?this.barRenderers[0].height:0,this.height>0&&(this.height+=this.topSpacing+this.topOverflow+this.bottomOverflow+this.bottomSpacing)}finalizeStaff(){this.topSpacing=this._factory.getStaffPaddingTop(this),this.bottomSpacing=this._factory.getStaffPaddingBottom(this),this.height=0;let e=!1,t=this.topOverflow;for(let s=0;s<this.barRenderers.length;s++)this.barRenderers[s].y=this.topSpacing+t,this.height=Math.max(this.height,this.barRenderers[s].height),this.barRenderers[s].finalizeRenderer()&&(e=!0);if(e){t=this.topOverflow;for(let e=0;e<this.barRenderers.length;e++)this.barRenderers[e].y=this.topSpacing+t;for(let e=0;e<this.barRenderers.length;e++)this.barRenderers[e].finalizeRenderer()}this.height>0&&(this.height+=this.topSpacing+t+this.bottomOverflow+this.bottomSpacing)}paint(e,t,s,i,a){if(0!==this.height&&0!==a)for(let r=i,n=Math.min(i+a,this.barRenderers.length);r<n;r++)this.barRenderers[r].paint(e+this.x,t+this.y,s)}}class Bn{constructor(){this.timePosition=0,this.longestDuration=0,this.smallestDuration=0,this.force=0,this.springConstant=0,this.preBeatWidth=0,this.graceBeatWidth=0,this.postSpringWidth=0,this.allDurations=new Set}get springWidth(){return this.preSpringWidth+this.postSpringWidth}get preSpringWidth(){return this.preBeatWidth+this.graceBeatWidth}}class kn{constructor(){this._timeSortedSprings=[],this._minTime=-1,this._onTimePositionsForce=0,this._onTimePositions=new Map,this._incompleteGraceRodsWidth=0,this._minDuration=kn.MinDuration,this.version=0,this.preBeatSize=0,this.postBeatSize=0,this.minStretchForce=0,this.totalSpringConstant=0,this.incompleteGraceRods=new Map,this.allGraceRods=new Map,this.springs=new Map,this.height=0}updateMinStretchForce(e){this.minStretchForce<e&&(this.minStretchForce=e)}getPreBeatSize(e){if(e.graceType!==B.None){const t=e.graceGroup.id;return this.allGraceRods.get(t)[e.graceIndex].preBeatWidth}const t=e.absoluteDisplayStart;return this.springs.has(t)?this.springs.get(t).preBeatWidth:0}getPostBeatSize(e){if(e.graceType!==B.None){const t=e.graceGroup.id;return this.allGraceRods.get(t)[e.graceIndex].postSpringWidth}const t=e.absoluteDisplayStart;return this.springs.has(t)?this.springs.get(t).postSpringWidth:0}addSpring(e,t,s,i,a){let r;if(this.version++,this.springs.has(e))r=this.springs.get(e),r.postSpringWidth<a&&(r.postSpringWidth=a),r.graceBeatWidth<s&&(r.graceBeatWidth=s),r.preBeatWidth<i&&(r.preBeatWidth=i),t<r.smallestDuration&&(r.smallestDuration=t),t>r.longestDuration&&(r.longestDuration=t),r.allDurations.add(t);else{if(r=new Bn,r.timePosition=e,r.allDurations.add(t),this._timeSortedSprings.length>0){const e=this._timeSortedSprings[this._timeSortedSprings.length-1];for(const t of e.allDurations)e.timePosition;t<this._minDuration&&(this._minDuration=t)}r.longestDuration=t,r.postSpringWidth=a,r.graceBeatWidth=s,r.preBeatWidth=i,this.springs.set(e,r);const n=this._timeSortedSprings;let o=n.length-1;for(;o>0&&n[o].timePosition>e;)o--;this._timeSortedSprings.splice(o+1,0,r)}return(-1===this._minTime||this._minTime>e)&&(this._minTime=e),r}addBeatSpring(e,t,s){const i=e.absoluteDisplayStart;if(e.graceType!==B.None){const a=e.graceGroup.id;this.allGraceRods.has(a)||this.allGraceRods.set(a,new Array(e.graceGroup.beats.length)),e.graceGroup.isComplete||this.incompleteGraceRods.has(a)||this.incompleteGraceRods.set(a,new Array(e.graceGroup.beats.length));const r=this.allGraceRods.get(a)[e.graceIndex];if(r)r.postSpringWidth<s&&(r.postSpringWidth=s),r.preBeatWidth<t&&(r.preBeatWidth=t);else{const r=new Bn;r.timePosition=i,r.postSpringWidth=s,r.preBeatWidth=t,e.graceGroup.isComplete||(this.incompleteGraceRods.get(a)[e.graceIndex]=r),this.allGraceRods.get(a)[e.graceIndex]=r}}else{let a=0;if(e.graceGroup&&this.allGraceRods.has(e.graceGroup.id))for(const t of this.allGraceRods.get(e.graceGroup.id))a+=t.springWidth;this.addSpring(i,e.displayDuration,a,t,s)}}finish(){for(const[e,t]of this.allGraceRods){let e=0;for(const s of t)e+=s.preBeatWidth,s.graceBeatWidth=e,e+=s.postSpringWidth}this._incompleteGraceRodsWidth=0;for(const e of this.incompleteGraceRods.values())for(const t of e)this._incompleteGraceRodsWidth+=t.preBeatWidth+t.postSpringWidth;this.calculateSpringConstants(),this.version++}calculateSpringConstants(){let e=0;const t=this._timeSortedSprings;if(0===t.length)return this.totalSpringConstant=-1,void(this.minStretchForce=-1);for(let s=0;s<t.length;s++){const i=t[s];let a=0;if(s===t.length-1)a=i.longestDuration;else{const e=t[s+1];a=Math.abs(e.timePosition-i.timePosition)}i.springConstant=this.calculateSpringConstant(i,a),e+=1/i.springConstant}this.totalSpringConstant=1/e,this.minStretchForce=0;for(let e=0;e<t.length;e++){const s=t[e];let i=0;if(e===t.length-1)i=s.postSpringWidth;else{const a=t[e+1];i=s.postSpringWidth+a.preSpringWidth}0===e&&(i+=s.preSpringWidth);const a=i*s.springConstant;this.updateMinStretchForce(a)}}paint(e,t,s){}calculateSpringConstant(e,t){t<=0&&(t=U.toTicks(w.TwoHundredFiftySixth)),0===e.smallestDuration&&(e.smallestDuration=t);const s=e.smallestDuration,i=this._minDuration,a=kn.MinDurationWidth;return s/t*(1/((1+.85*Math.log2(t/i))*a))}spaceToForce(e){return-1!==this.totalSpringConstant?(this._timeSortedSprings.length>0&&(e-=this._timeSortedSprings[0].preSpringWidth),e-=this._incompleteGraceRodsWidth,Math.max(e,0)*this.totalSpringConstant):-1}calculateVoiceWidth(e){let t=0;return-1!==this.totalSpringConstant&&(t=this.calculateWidth(e,this.totalSpringConstant)),this._timeSortedSprings.length>0&&(t+=this._timeSortedSprings[0].preSpringWidth),t+=this._incompleteGraceRodsWidth,t}calculateWidth(e,t){return e/t}buildOnTimePositions(e){if(-1===this.totalSpringConstant)return new Map;if(ae.isAlmostEqualTo(this._onTimePositionsForce,e)&&this._onTimePositions)return this._onTimePositions;this._onTimePositionsForce=e;const t=new Map;this._onTimePositions=t;const s=this._timeSortedSprings;if(0===s.length)return t;let i=s[0].preSpringWidth;for(let a=0;a<s.length;a++)t.set(s[a].timePosition,i),i+=this.calculateWidth(e,s[a].springConstant);return t}}kn.MinDuration=30,kn.MinDurationWidth=7;class Tn{constructor(){this.width=0,this.isLinkedToPrevious=!1,this.canWrap=!0,this.additionalMultiBarRestIndexes=null,this.renderers=[]}get lastMasterBarIndex(){return this.additionalMultiBarRestIndexes?this.additionalMultiBarRestIndexes[this.additionalMultiBarRestIndexes.length-1]:this.masterBar.index}}class Nn{constructor(e,t){this.staves=[],this.stavesRelevantForBoundsLookup=[],this.firstStaffInBracket=null,this.lastStaffInBracket=null,this.bracket=null,this.staffSystem=e,this.track=t}addStaff(e){this.staves.push(e),e.isRelevantForBoundsLookup&&this.stavesRelevantForBoundsLookup.push(e)}}class xn{constructor(){this.firstStaffInBracket=null,this.lastStaffInBracket=null,this.drawAsBrace=!1,this.braceScale=1,this.width=0,this.index=0}finalizeBracket(){if(this.firstStaffInBracket===this.lastStaffInBracket)return void(this.width=0);const e=xr.Heights.get(ne.Brace),t=xr.Widths.get(ne.Brace);if(this.width=t,!this.drawAsBrace||!this.firstStaffInBracket||!this.lastStaffInBracket)return;const s=this.firstStaffInBracket.contentTop,i=(this.lastStaffInBracket.contentBottom-s)/e;this.braceScale=i,this.width=t*this.braceScale}}class vn extends xn{constructor(e){super(),this.track=e,this.drawAsBrace=vn.isTrackDrawAsBrace(e)}includesStaff(e){return e.modelStaff.track===this.track}static isTrackDrawAsBrace(e){return e.staves.filter((e=>e.showStandardNotation)).length>1}}class Pn extends vn{includesStaff(e){return e.modelStaff.track===this.track||!this.drawAsBrace&&this.track.playbackInfo.program===e.modelStaff.track.playbackInfo.program}}class Fn{constructor(e){this._allStaves=[],this._firstStaffInBrackets=null,this._lastStaffInBrackets=null,this._accoladeSpacingCalculated=!1,this._brackets=[],this._hasSystemSeparator=!1,this.x=0,this.y=0,this.index=0,this.accoladeWidth=0,this.isFull=!1,this.width=0,this.computedWidth=0,this.totalBarDisplayScale=0,this.isLast=!1,this.masterBarsRenderers=[],this.staves=[],this.layout=e,this.topPadding=e.renderer.settings.display.systemPaddingTop,this.bottomPadding=e.renderer.settings.display.systemPaddingBottom}get firstBarIndex(){return this.masterBarsRenderers[0].masterBar.index}get lastBarIndex(){return this.masterBarsRenderers[this.masterBarsRenderers.length-1].masterBar.index}addMasterBarRenderers(e,t){if(0===e.length)return null;this.masterBarsRenderers.push(t),t.layoutingInfo.preBeatSize=0;let s=0;for(let e=0,i=this.staves.length;e<i;e++){const i=this.staves[e];for(let e=0,a=i.staves.length;e<a;e++){const a=i.staves[e],r=t.renderers[s++];a.addBarRenderer(r)}}return this.calculateAccoladeSpacing(e),this.updateWidthFromLastBar(),t}addBars(e,t,s){const i=new Tn;i.additionalMultiBarRestIndexes=s,i.layoutingInfo=new kn,i.masterBar=e[0].score.masterBars[t],this.masterBarsRenderers.push(i);const a=i.layoutingInfo;for(const e of this.staves)for(const r of e.staves){const n=e.track.staves[r.modelStaff.index].bars[t],o=null==s?null:s.map((t=>e.track.staves[r.modelStaff.index].bars[t]));r.addBar(n,a,o);const h=r.barRenderers[r.barRenderers.length-1];i.renderers.push(h),h.isLinkedToPrevious&&(i.isLinkedToPrevious=!0),h.canWrap||(i.canWrap=!1)}return this.calculateAccoladeSpacing(e),a.finish(),i.width=this.updateWidthFromLastBar(),i}revertLastBar(){if(this.masterBarsRenderers.length>1){const e=this.masterBarsRenderers[this.masterBarsRenderers.length-1];this.masterBarsRenderers.splice(this.masterBarsRenderers.length-1,1);let t=0,s=0;for(let e=0,i=this._allStaves.length;e<i;e++){const i=this._allStaves[e].revertLastBar(),a=i.computedWidth;a>t&&(t=a);const r=i.barDisplayScale;r>s&&(s=r)}return this.width-=t,this.computedWidth-=t,this.totalBarDisplayScale-=s,e}return null}updateWidthFromLastBar(){let e=0,t=0;for(let s=0,i=this._allStaves.length;s<i;s++){const i=this._allStaves[s],a=i.barRenderers[i.barRenderers.length-1];a.applyLayoutingInfo(),a.computedWidth>e&&(e=a.computedWidth);const r=a.barDisplayScale;r>t&&(t=r)}return this.width+=e,this.computedWidth+=e,this.totalBarDisplayScale+=t,e}calculateAccoladeSpacing(t){const s=this.layout.renderer.settings;if(!this._accoladeSpacingCalculated){this._accoladeSpacingCalculated=!0,this.accoladeWidth=0;const i=this.layout.renderer.score.stylesheet;if(this.layout.renderer.settings.notation.isNotationElementVisible(e.NotationElement.TrackNames)){const e=1===this.layout.renderer.tracks.length?i.singleTrackTrackNamePolicy:i.multiTrackTrackNamePolicy,o=0===this.index?i.firstSystemTrackNameMode:i.otherSystemsTrackNameMode,h=0===this.index?i.firstSystemTrackNameOrientation:i.otherSystemsTrackNameOrientation;let l=!1;switch(e){case a.Hidden:break;case a.FirstSystem:l=0===this.index;break;case a.AllSystems:l=!0}let c=!1;if(l){const e=this.layout.renderer.canvas,i=s.display.resources.effectFont;e.font=i;for(const s of t){let t="";switch(o){case r.FullName:t=s.name;break;case r.ShortName:t=s.shortName}if(t.length>0){c=!0;const s=e.measureText(t);switch(h){case n.Horizontal:this.accoladeWidth=Math.ceil(Math.max(this.accoladeWidth,s.width));break;case n.Vertical:this.accoladeWidth=Math.ceil(Math.max(this.accoladeWidth,s.height))}}}c&&(this.accoladeWidth+=s.display.systemLabelPaddingLeft,this.accoladeWidth+=s.display.systemLabelPaddingRight)}}let o=0;for(const e of this._allStaves)e.y=o,e.calculateHeightForAccolade(),o+=e.height;let h=0;for(const e of this._brackets)e.finalizeBracket(),h=Math.max(h,e.width);this.accoladeWidth+=h,this.width+=this.accoladeWidth,this.computedWidth+=this.accoladeWidth}}getStaffTrackGroup(e){for(let t=0,s=this.staves.length;t<s;t++){const s=this.staves[t];if(s.track===e)return s}return null}addStaff(e,t){let s=this.getStaffTrackGroup(e);if(s||(s=new Nn(this,e),this.staves.push(s)),t.staffTrackGroup=s,t.system=this,t.index=this._allStaves.length,this._allStaves.push(t),s.addStaff(t),t.isInsideBracket){this._firstStaffInBrackets||(this._firstStaffInBrackets=t,t.isFirstInSystem=!0),s.firstStaffInBracket||(s.firstStaffInBracket=t),this._lastStaffInBrackets=t,s.lastStaffInBracket=t;let a=this._brackets.find((e=>e.includesStaff(t)));if(!a)switch(e.score.stylesheet.bracketExtendMode){case i.NoBrackets:break;case i.GroupStaves:a=new vn(e),a.index=this._brackets.length,this._brackets.push(a);break;case i.GroupSimilarInstruments:a=new Pn(e),a.index=this._brackets.length,this._brackets.push(a)}a&&(a.firstStaffInBracket||(a.firstStaffInBracket=t),a.lastStaffInBracket=t,s.bracket=a)}}get height(){return 0===this._allStaves.length?0:this._allStaves[this._allStaves.length-1].y+this._allStaves[this._allStaves.length-1].height+this.topPadding+this.bottomPadding}scaleToWidth(e){for(let t=0,s=this._allStaves.length;t<s;t++)this._allStaves[t].scaleToWidth(e);this.width=e}paint(e,t,s){if(t+=this.topPadding,this.paintPartial(e+this.x,t+this.y,s,0,this.masterBarsRenderers.length),this._hasSystemSeparator){const i=nn.track(s,Be.SystemSeparator,this._allStaves[0].modelStaff.track);try{s.fillMusicFontSymbol(e+this.x,t+this.y+this.height-10,1,ne.SystemDivider,!1),s.fillMusicFontSymbol(e+this.x+this.width-Fn.SystemSignSeparatorWidth,t+this.y+this.height-Fn.SystemSignSeparatorPadding,1,ne.SystemDivider,!1)}finally{i?.[Symbol.dispose]?.()}}}paintPartial(t,s,i,o,h){for(let e=0,a=this._allStaves.length;e<a;e++)this._allStaves[e].paint(t,s,i,o,h);const l=this.layout.renderer.settings.display.resources;if(this.staves.length>0&&0===o){i.color=l.barSeparatorColor;const o=this.layout.renderer.settings,h=this.layout.renderer.settings.notation.isNotationElementVisible(e.NotationElement.TrackNames);if(i.font=l.effectFont,h){const e=this.layout.renderer.score.stylesheet,h=1===this.layout.renderer.tracks.length?e.singleTrackTrackNamePolicy:e.multiTrackTrackNamePolicy,l=0===this.index?e.firstSystemTrackNameMode:e.otherSystemsTrackNameMode,c=0===this.index?e.firstSystemTrackNameOrientation:e.otherSystemsTrackNameOrientation;let d=!1;switch(h){case a.Hidden:break;case a.FirstSystem:d=0===this.index;break;case a.AllSystems:d=!0}if(d){const e=i.textBaseline,a=i.textAlign;for(const e of this.staves)if(e.firstStaffInBracket&&e.lastStaffInBracket){const a=s+e.firstStaffInBracket.contentTop,h=s+e.lastStaffInBracket.contentBottom;let d="";switch(l){case r.FullName:d=e.track.name;break;case r.ShortName:d=e.track.shortName}const u=nn.track(i,Be.TrackName,e.track);try{if(d.length>0){const s=t+e.firstStaffInBracket.x-o.display.accoladeBarPaddingRight-(e.bracket?.width??0)-o.display.systemLabelPaddingRight;switch(c){case n.Horizontal:i.textBaseline=he.Middle,i.textAlign=oe.Right,i.fillText(d,s,(a+h)/2);break;case n.Vertical:i.textBaseline=he.Bottom,i.textAlign=oe.Center;const e=.1;i.beginRotate(s,(a+h)/2,-90-e),i.fillText(d,0,0),i.endRotate()}}}finally{u?.[Symbol.dispose]?.()}}i.textBaseline=e,i.textAlign=a}}if(this._allStaves.length>0){let e=null;for(const a of this._allStaves)if(a.isInsideBracket){if(null!==e){const r=e.contentBottom,n=a.contentTop,o=t+e.x,h=e.barRenderers[0],l=nn.bar(i,h.staffLineBarSubElement,h.bar);try{const e=Math.ceil(n-r);i.fillRect(o,s+r,1,e)}finally{l?.[Symbol.dispose]?.()}}e=a}}for(const e of this._brackets)if(e.firstStaffInBracket&&e.lastStaffInBracket){const a=t+e.firstStaffInBracket.x,r=e.width,n=o.display.accoladeBarPaddingRight;let h=s+e.firstStaffInBracket.contentTop,l=s+e.lastStaffInBracket.contentBottom;if(e.drawAsBrace)i.fillMusicFontSymbol(a-n-r,l,e.braceScale,ne.Brace);else if(e.firstStaffInBracket!==e.lastStaffInBracket){const e=r/2;h-=e,l+=2*e,i.fillRect(a-n-r,h,r,Math.ceil(l-h));const t=a-n-r-.5;i.fillMusicFontSymbol(t,h,1,ne.BracketTop),i.fillMusicFontSymbol(t,Math.floor(l),1,ne.BracketBottom)}}}}finalizeSystem(){const e=this.layout.renderer.settings;0===this.index&&(this.topPadding=e.display.firstSystemPaddingTop),this.isLast?this.bottomPadding=e.display.lastSystemPaddingBottom:this.layout.renderer.score.stylesheet.useSystemSignSeparator&&this.layout.renderer.tracks.length>1&&(this.bottomPadding+=Fn.SystemSignSeparatorHeight,this._hasSystemSeparator=!0);let t=0;for(const e of this._allStaves)e.x=this.accoladeWidth,e.y=t,e.finalizeStaff(),t+=e.height;for(const e of this._brackets)e.finalizeBracket()}buildBoundingsLookup(e,t){if(this.layout.renderer.boundsLookup.isFinished)return;const s=this._firstStaffInBrackets,i=this._lastStaffInBrackets;if(!s||!i)return;t+=this.topPadding;const a=this._allStaves[this._allStaves.length-1],r=t+this.y+s.y,n=t+this.y+i.y+i.height,o=t+this.y+this._allStaves[0].y,h=t+this.y+a.y+a.height,l=t+this.y+s.y+s.topSpacing+s.topOverflow+(s.barRenderers.length>0?s.barRenderers[0].topPadding:0),c=n-r,d=t+this.y+a.y+a.height-a.bottomSpacing-a.bottomOverflow-(a.barRenderers.length>0?a.barRenderers[0].bottomPadding:0)-l,u=h-o,p=this.x+s.x,g=new rr;g.visualBounds=new ft,g.visualBounds.x=e+this.x,g.visualBounds.y=t+this.y,g.visualBounds.w=this.width,g.visualBounds.h=this.height-this.topPadding-this.bottomPadding,g.realBounds=new ft,g.realBounds.x=e+this.x,g.realBounds.y=t+this.y,g.realBounds.w=this.width,g.realBounds.h=this.height,this.layout.renderer.boundsLookup.addStaffSystem(g);const m=new Map;for(let e=0;e<this.staves.length;e++)for(const s of this.staves[e].stavesRelevantForBoundsLookup)for(const e of s.barRenderers){let i;m.has(e.bar.masterBar.index)?i=m.get(e.bar.masterBar.index):(i=new ir,i.index=e.bar.masterBar.index,i.isFirstOfLine=e.isFirstOfLine,i.realBounds=new ft,i.realBounds.x=p+e.x,i.realBounds.y=o,i.realBounds.w=e.width,i.realBounds.h=u,i.visualBounds=new ft,i.visualBounds.x=p+e.x,i.visualBounds.y=r,i.visualBounds.w=e.width,i.visualBounds.h=c,i.lineAlignedBounds=new ft,i.lineAlignedBounds.x=p+e.x,i.lineAlignedBounds.y=l,i.lineAlignedBounds.w=e.width,i.lineAlignedBounds.h=d,this.layout.renderer.boundsLookup.addMasterBar(i),m.set(i.index,i)),e.buildBoundingsLookup(i,p,t+this.y+s.y)}}getBarX(e){if(!this._firstStaffInBrackets||0===this.layout.renderer.tracks.length)return 0;const t=this.layout.renderer.tracks[0].staves[0].bars[e];return this.layout.getRendererForBar(this._firstStaffInBrackets.staffId,t).x}}Fn.SystemSignSeparatorHeight=40,Fn.SystemSignSeparatorPadding=10,Fn.SystemSignSeparatorWidth=36;class Cn extends bn{constructor(e,t){super(e,t,oe.Left)}}class En extends an{constructor(e,t,s,i){super(e,t),this._tuning=s,this._trackLabel=i,this.glyphs=[]}doLayout(){if(!(this.glyphs.length>0)){this.createGlyphs(this._tuning);for(const e of this.glyphs)e.renderer=this.renderer,e.doLayout()}}paint(e,t,s){s.textBaseline=he.Middle;const i=s.color;this.colorOverride&&(s.color=this.colorOverride),super.paint(e,t,s),s.color=i}createGlyphs(e){const t=this.renderer.resources;this.height=0;if(this._trackLabel.length>0){this.height+=1;const e=new _n(0,this.height,this._trackLabel,t.effectFont,oe.Left);e.renderer=this.renderer,e.doLayout(),this.height+=e.height+1,e.y+=e.height/2,this.addGlyph(e)}const s=new _n(0,this.height,e.name,t.effectFont,oe.Left);s.renderer=this.renderer,s.doLayout(),this.height+=s.height,s.y+=s.height/2,this.addGlyph(s);if(this.renderer.scoreRenderer.canvas.font=t.effectFont,this.width=Math.max(this.renderer.scoreRenderer.canvas.measureText(this._trackLabel).width,Math.max(this.renderer.scoreRenderer.canvas.measureText(e.name).width,128)),!e.isStandard){this.height+=15;const s=En.CircleNumberScale,i=xr.Heights.get(ne.GuitarString0)*s,a=0|Math.ceil(e.tunings.length/2);let r=0,n=this.height;for(let o=0,h=e.tunings.length;o<h;o++){const h=ne.GuitarString0+(o+1);this.addGlyph(new vr(r,n+i/2.5,s,h));const l=`= ${it.getTextForTuning(e.tunings[o],!1)}`;this.addGlyph(new _n(r+i+1,n,l,t.effectFont,oe.Left)),n+=15,o===a-1&&(n=this.height,r+=64)}this.height+=15*a}this.width+=15}}En.CircleNumberScale=.7;class Dn{constructor(e,t){this.args=e,this.renderCallback=t}}!function(e){e[e.Automatic=0]="Automatic",e[e.FromModelWithScale=1]="FromModelWithScale",e[e.FromModelWithWidths=2]="FromModelWithWidths"}(is||(is={}));class Mn{get scaledWidth(){return Math.round(this.width/this.renderer.settings.display.scale)}constructor(e){this._barRendererLookup=new Map,this.pagePadding=null,this.width=0,this.height=0,this.multiBarRestInfo=null,this.headerGlyphs=new Map,this.footerGlyphs=new Map,this.chordDiagrams=null,this.tuningGlyph=null,this.systemsLayoutMode=is.Automatic,this._lazyPartials=new Map,this.firstBarIndex=0,this.lastBarIndex=0,this.renderer=e}resize(){this._lazyPartials.clear(),this.doResize()}layoutAndRender(){this._lazyPartials.clear();const e=this.renderer.score;this.firstBarIndex=ae.computeFirstDisplayedBarIndex(e,this.renderer.settings),this.lastBarIndex=ae.computeLastDisplayedBarIndex(e,this.renderer.settings,this.firstBarIndex),this.multiBarRestInfo=ae.buildMultiBarRestInfo(this.renderer.tracks,this.firstBarIndex,this.lastBarIndex),this.pagePadding=this.renderer.settings.display.padding.map((e=>e/this.renderer.settings.display.scale)),this.pagePadding||(this.pagePadding=[0,0,0,0]),1===this.pagePadding.length?this.pagePadding=[this.pagePadding[0],this.pagePadding[0],this.pagePadding[0],this.pagePadding[0]]:2===this.pagePadding.length&&(this.pagePadding=[this.pagePadding[0],this.pagePadding[1],this.pagePadding[0],this.pagePadding[1]]),this.createScoreInfoGlyphs(),this.doLayoutAndRender()}registerPartial(e,t){if(0===e.height)return;const s=this.renderer.settings.display.scale;e.x*=s,e.y*=s,e.width*=s,e.height*=s,e.totalWidth*=s,e.totalHeight*=s,this.renderer.settings.core.enableLazyLoading?(this._lazyPartials.set(e.id,new Dn(e,t)),this.renderer.partialLayoutFinished.trigger(e)):(this.renderer.partialLayoutFinished.trigger(e),this.internalRenderLazyPartial(e,t))}internalRenderLazyPartial(e,t){const s=this.renderer.canvas;s.beginRender(e.width,e.height),t(s),e.renderResult=s.endRender(),this.renderer.partialRenderFinished.trigger(e)}renderLazyPartial(e){if(this._lazyPartials.has(e)){const t=this._lazyPartials.get(e);this.internalRenderLazyPartial(t.args,t.renderCallback)}}createHeaderFooterGlyph(e,t,s,i){switch(s){case Se.WordsAndMusic:if(t.words!==t.music)return;break;case Se.Words:case Se.Music:if(t.words===t.music)return;break;case Se.CopyrightSecondLine:if(!this.headerGlyphs.has(Se.Copyright))return}const a=e.display.resources,r=e.notation,n=t.style&&t.style.headerAndFooter.has(s)?t.style.headerAndFooter.get(s):Je.defaultHeaderAndFooter.get(s);let o=void 0===n.isVisible||n.isVisible;if(void 0!==i&&(o=r.isNotationElementVisible(i)),!o)return;const h=n.buildText(t);return h?new _n(0,0,h,a.getFontForElement(s),n.textAlign,void 0,nn.scoreColor(a,s,t)):void 0}createScoreInfoGlyphs(){j.debug("ScoreLayout","Creating score info glyphs");const t=this.renderer.settings,s=this.renderer.score;this.headerGlyphs=new Map,this.footerGlyphs=new Map;const i=new Hn(this.renderer,this.renderer.tracks[0].staves[0].bars[0]);for(const[e,a]of Mn.HeaderElements.value){const r=this.createHeaderFooterGlyph(t,s,e,a);r&&(r.renderer=i,r.doLayout(),this.headerGlyphs.set(e,r))}for(const[e,a]of Mn.FooterElements.value){const r=this.createHeaderFooterGlyph(t,s,e,a);r&&(r.renderer=i,r.doLayout(),this.footerGlyphs.set(e,r))}const a=t.notation,r=t.display.resources;if(a.isNotationElementVisible(e.NotationElement.GuitarTuning)){const e=[];for(const t of this.renderer.tracks)for(const i of t.staves){let a=!i.isPercussion&&i.isStringed&&i.tuning.length>0&&i.showTablature;if(s.stylesheet.perTrackDisplayTuning&&s.stylesheet.perTrackDisplayTuning.has(t.index)&&!1===s.stylesheet.perTrackDisplayTuning.get(t.index)&&(a=!1),a){e.push(i);break}}if(e.length>0&&s.stylesheet.globalDisplayTuning){this.tuningGlyph=new Cn(0,0),this.tuningGlyph.renderer=i;for(const t of e)if(t.stringTuning.tunings.length>0){const s=e.length>1?t.track.name:"",a=new En(0,0,t.stringTuning,s);a.colorOverride=nn.trackColor(r,Be.StringTuning,t.track),a.renderer=i,a.doLayout(),this.tuningGlyph.addGlyph(a)}}}if(a.isNotationElementVisible(e.NotationElement.ChordDiagrams)){this.chordDiagrams=new Sn(0,0),this.chordDiagrams.renderer=i;const e=new Set;for(const t of this.renderer.tracks){if(s.stylesheet.globalDisplayChordDiagramsOnTop&&(null==s.stylesheet.perTrackChordDiagramsOnTop||!s.stylesheet.perTrackChordDiagramsOnTop.has(t.index)||s.stylesheet.perTrackChordDiagramsOnTop.get(t.index)))for(const s of t.staves){const t=s.chords;if(t)for(const[,s]of t)e.has(s.uniqueId)||s.showDiagram&&(e.add(s.uniqueId),this.chordDiagrams.addChord(s))}}}}createEmptyStaffSystem(){const e=new Fn(this);for(let t=0;t<this.renderer.tracks.length;t++){const s=this.renderer.tracks[t];for(let i=0;i<s.staves.length;i++){const a=s.staves[i],r=nc.staveProfiles.get(this.renderer.settings.display.staveProfile);for(const i of r)i.canCreate(s,a)&&e.addStaff(s,new wn(t,a,i))}}return e}registerBarRenderer(e,t){if(this._barRendererLookup.has(e)||this._barRendererLookup.set(e,new Map),this._barRendererLookup.get(e).set(t.bar.id,t),t.additionalMultiRestBars)for(const s of t.additionalMultiRestBars)this._barRendererLookup.get(e).set(s.id,t)}unregisterBarRenderer(e,t){if(this._barRendererLookup.has(e)){const s=this._barRendererLookup.get(e);if(s.delete(t.bar.id),t.additionalMultiRestBars)for(const e of t.additionalMultiRestBars)s.delete(e.id)}}getRendererForBar(e,t){const s=t.id;return this._barRendererLookup.has(e)&&this._barRendererLookup.get(e).has(s)?this._barRendererLookup.get(e).get(s):null}layoutAndRenderBottomScoreInfo(e){e=Math.round(e);const t=new er;t.x=0,t.y=e;let s=0;const i=this.renderer.settings.display.resources,a=[];let r=0;for(const[e,t]of Mn.FooterElements.value)if(this.footerGlyphs.has(e)){const t=this.footerGlyphs.get(e);t.y=s,this.alignScoreInfoGlyph(t),s+=1.2*t.font.size,a.push(t),r=Math.max(r,Math.round(t.x+t.width))}return s=Math.round(s),a.length>0&&(t.width=r,t.height=s,t.totalWidth=this.scaledWidth,t.totalHeight=e+t.height,this.registerPartial(t,(e=>{e.color=i.scoreInfoColor,e.textAlign=oe.Left,e.textBaseline=he.Top;for(const t of a)t.paint(0,0,e)}))),e+s}alignScoreInfoGlyph(e){if(nc.getLayoutEngineFactory(this.renderer.settings.display.layoutMode).vertical)switch(e.textAlign){case oe.Left:e.x=this.pagePadding[0];break;case oe.Center:e.x=this.scaledWidth/2;break;case oe.Right:e.x=this.scaledWidth-this.pagePadding[2]}else e.x=this.firstBarX,e.textAlign=oe.Left}layoutAndRenderAnnotation(e){const t=this.renderer.settings.display.resources,s=oa.withFamilyList(t.copyrightFont.families,12,Yt.Plain,$t.Bold),i=new Hn(this.renderer,this.renderer.tracks[0].staves[0].bars[0]),a=new _n(0,0,"rendered by alphaTab",s,oe.Center,void 0,t.mainGlyphColor);a.renderer=i,a.doLayout(),this.alignScoreInfoGlyph(a);const r=new er;return r.width=a.x+a.width,r.x=0,r.height=12,r.y=e,r.totalWidth=this.scaledWidth,r.totalHeight=e+12,r.firstMasterBarIndex=-1,r.lastMasterBarIndex=-1,this.registerPartial(r,(e=>{e.color=t.mainGlyphColor,e.font=s,e.textAlign=oe.Left,e.textBaseline=he.Top,a.paint(0,0,e)})),e+12}}Mn.HeaderElements=new $((()=>new Map([[Se.Title,e.NotationElement.ScoreTitle],[Se.SubTitle,e.NotationElement.ScoreSubTitle],[Se.Artist,e.NotationElement.ScoreArtist],[Se.Album,e.NotationElement.ScoreAlbum],[Se.Words,e.NotationElement.ScoreWords],[Se.Music,e.NotationElement.ScoreMusic],[Se.WordsAndMusic,e.NotationElement.ScoreWordsAndMusic],[Se.Transcriber,void 0]]))),Mn.FooterElements=new $((()=>new Map([[Se.Copyright,e.NotationElement.ScoreCopyright],[Se.CopyrightSecondLine,void 0]])));class Ln extends an{constructor(){super(0,0),this._effectGlyphs=[],this._normalGlyphs=[],this.computedWidth=0}doLayout(){let e=0;if(this.glyphs)for(let t=0,s=this.glyphs.length;t<s;t++){const s=this.glyphs[t];s.x=e,s.renderer=this.renderer,s.doLayout(),e+=s.width}this.width=e,this.computedWidth=e}noteLoop(e){for(let t=this.container.beat.notes.length-1;t>=0;t--)e(this.container.beat.notes[t])}addEffect(e){super.addGlyph(e),this._effectGlyphs.push(e)}addNormal(e){super.addGlyph(e),this._normalGlyphs.push(e)}get effectElement(){}paint(e,t,s){this.paintEffects(e,t,s),this.paintNormal(e,t,s)}paintNormal(e,t,s){for(const i of this._normalGlyphs)i.paint(e+this.x,t+this.y,s)}paintEffects(e,t,s){const i=this.effectElement?nn.beat(s,this.effectElement,this.container.beat):void 0;try{for(const i of this._effectGlyphs)i.paint(e+this.x,t+this.y,s)}finally{i?.[Symbol.dispose]?.()}}}class An extends Ln{constructor(){super(...arguments),this.centerX=0}updateBeamingHelper(){}buildBoundingsLookup(e,t,s){}getNoteX(e,t){return 0}getNoteY(e,t){return 0}}class In extends Tr{constructor(e,t,s,i=1){super(e,t),this._scale=0,this._symbols=[],this._symbols=In.getSymbols(s),this._scale=i}static getSymbols(e){const t=[];for(;e>0;){const s=e%10;t.unshift(In.getSymbol(s)),e=e/10|0}return t}static getSymbol(e){switch(e){case 0:return ne.TimeSig0;case 1:return ne.TimeSig1;case 2:return ne.TimeSig2;case 3:return ne.TimeSig3;case 4:return ne.TimeSig4;case 5:return ne.TimeSig5;case 6:return ne.TimeSig6;case 7:return ne.TimeSig7;case 8:return ne.TimeSig8;case 9:return ne.TimeSig9;default:return ne.None}}doLayout(){let e=0;for(const t of this._symbols)e+=xr.Widths.get(t);this.width=e}paint(e,t,s){s.fillMusicFontSymbols(e+this.x,t+this.y,this._scale,this._symbols)}}In.numberHeight=18;class Rn extends Tr{constructor(){super(0,0),this._numberGlyph=[]}doLayout(){this.width=70,this.renderer.registerOverflowTop(this.renderer.getLineHeight(1));const e=this.renderer.additionalMultiRestBars.length+1;this._numberGlyph=In.getSymbols(e)}paint(e,t,s){s.fillMusicFontSymbols(e+this.x,t+this.y+this.renderer.height/2,1,[ne.RestHBarLeft,ne.RestHBarMiddle,ne.RestHBarMiddle,ne.RestHBarMiddle,ne.RestHBarRight]);const i=this.renderer.getLineY(-1.5);s.fillMusicFontSymbols(e+this.x+Rn.BarWidth/2,t+this.y+i|0,1,this._numberGlyph,!0)}}Rn.BarWidth=60;class On extends Cr{constructor(e){super(On.getOrCreatePlaceholderBeat(e),e),this.preNotes=new Ln,this.onNotes=new An}doLayout(){this.renderer.showMultiBarRest&&this.onNotes.addNormal(new Rn),super.doLayout()}static getOrCreatePlaceholderBeat(e){if(e.voice.beats.length>1)return e.voice.beats[0];const t=new Ue;return t.voice=e.voice,t}}!function(e){e[e.TopWithStem=0]="TopWithStem",e[e.Top=1]="Top",e[e.Center=2]="Center",e[e.Bottom=3]="Bottom",e[e.BottomWithStem=4]="BottomWithStem"}(as||(as={})),function(e){e[e.Left=0]="Left",e[e.Center=1]="Center",e[e.Right=2]="Right"}(rs||(rs={}));class Hn{get nextRenderer(){return this.bar&&this.bar.nextBar?this.scoreRenderer.layout.getRendererForBar(this.staff.staffId,this.bar.nextBar):null}get previousRenderer(){return this.bar&&this.bar.previousBar?this.scoreRenderer.layout.getRendererForBar(this.staff.staffId,this.bar.previousBar):null}get lastBar(){return this.additionalMultiRestBars?this.additionalMultiRestBars[this.additionalMultiRestBars.length-1]:this.bar}get showMultiBarRest(){return!1}constructor(e,t){this._preBeatGlyphs=new rn,this._voiceContainers=new Map,this._postBeatGlyphs=new rn,this._ties=[],this.additionalMultiRestBars=null,this.x=0,this.y=0,this.width=0,this.computedWidth=0,this.height=0,this.index=0,this.topOverflow=0,this.bottomOverflow=0,this.isLinkedToPrevious=!1,this.canWrap=!0,this.wasFirstOfLine=!1,this._appliedLayoutingInfo=0,this.isFinalized=!1,this.topPadding=0,this.bottomPadding=0,this.scoreRenderer=e,this.bar=t,t&&(this.helpers=new mn(this))}registerTies(e){this._ties.push(...e)}get middleYPosition(){return 0}registerOverflowTop(e){return e>this.topOverflow&&(this.topOverflow=e,!0)}registerOverflowBottom(e){return e>this.bottomOverflow&&(this.bottomOverflow=e,!0)}scaleToWidth(e){const t=e-this._preBeatGlyphs.width-this._postBeatGlyphs.width;for(const e of this._voiceContainers.values())e.scaleToWidth(t);this._postBeatGlyphs.x=this._preBeatGlyphs.x+this._preBeatGlyphs.width+t,this.width=e}get resources(){return this.settings.display.resources}get settings(){return this.scoreRenderer.settings}get barDisplayScale(){return this.staff.system.staves.length>1?this.bar.masterBar.displayScale:this.bar.displayScale}get barDisplayWidth(){return this.staff.system.staves.length>1?this.bar.masterBar.displayWidth:this.bar.displayWidth}get isFirstOfLine(){return 0===this.index}get isLast(){return!this.bar||this.bar.index===this.scoreRenderer.layout.lastBarIndex}registerLayoutingInfo(){const e=this.layoutingInfo,t=this._preBeatGlyphs.width;e.preBeatSize<t&&(e.preBeatSize=t);for(const t of this._voiceContainers.values())t.registerLayoutingInfo(e),t.x,t.width;const s=this._postBeatGlyphs.width;e.postBeatSize<s&&(e.postBeatSize=s)}applyLayoutingInfo(){if(this._appliedLayoutingInfo>=this.layoutingInfo.version)return!1;this._appliedLayoutingInfo=this.layoutingInfo.version,this._preBeatGlyphs.width=this.layoutingInfo.preBeatSize;let e=this._preBeatGlyphs.x+this._preBeatGlyphs.width;for(const t of this._voiceContainers.values()){t.x=this._preBeatGlyphs.x+this._preBeatGlyphs.width,t.applyLayoutingInfo(this.layoutingInfo);const s=t.x+t.width;e<s&&(e=s)}this._postBeatGlyphs.x=Math.floor(e),this._postBeatGlyphs.width=this.layoutingInfo.postBeatSize,this.width=Math.ceil(this._postBeatGlyphs.x+this._postBeatGlyphs.width),this.computedWidth=this.width;const t=this.barDisplayWidth;return t>0&&this.scoreRenderer.layout.systemsLayoutMode===is.FromModelWithWidths&&(this.width=t,this.computedWidth=t),!0}finalizeRenderer(){this.isFinalized=!0;let e=!1;const t=this.y-this.staff.topSpacing,s=this.y+this.height+this.staff.bottomSpacing;for(const i of this._ties)if(i.doLayout(),i.height>0){const a=i.y+i.height-s;a>0&&this.registerOverflowBottom(a)&&(e=!0);const r=i.y-t;r<0&&this.registerOverflowTop(-1*r)&&(e=!0)}return e}doLayout(){if(this.bar){this.helpers.initialize(),this._ties=[],this._preBeatGlyphs=new rn,this._preBeatGlyphs.renderer=this,this._voiceContainers.clear(),this._postBeatGlyphs=new rn,this._postBeatGlyphs.renderer=this;for(let e=0;e<this.bar.voices.length;e++){const t=this.bar.voices[e];if(this.hasVoiceContainer(t)){const s=new hn(0,0,t);s.renderer=this,this._voiceContainers.set(this.bar.voices[e].index,s)}}if(this.bar.simileMark===l.SecondOfDouble&&(this.canWrap=!1),this.createPreBeatGlyphs(),this.additionalMultiRestBars){const e=new On(this.getVoiceContainer(this.bar.voices[0]));this.addBeatGlyph(e)}else this.createBeatGlyphs();this.createPostBeatGlyphs(),this.updateSizes();for(const e of this.helpers.beamHelpers)for(const t of e)t.finish();this.computedWidth=this.width}}hasVoiceContainer(e){return!(!this.additionalMultiRestBars&&0!==e.index)||!e.isEmpty}updateSizes(){this.staff.registerStaffTop(this.topPadding),this.staff.registerStaffBottom(this.height-this.bottomPadding);const e=this._voiceContainers,t=this.beatGlyphsStart;let s=t;for(const i of e.values()){i.x=t,i.doLayout();const e=i.x+i.width;s<e&&(s=e)}this._postBeatGlyphs.x=Math.floor(s),this.width=Math.ceil(this._postBeatGlyphs.x+this._postBeatGlyphs.width),this.height+=this.layoutingInfo.height}addPreBeatGlyph(e){e.renderer=this,this._preBeatGlyphs.addGlyph(e)}addBeatGlyph(e){e.renderer=this,e.preNotes.renderer=this,e.onNotes.renderer=this,e.onNotes.beamingHelper=this.helpers.beamHelperLookup[e.beat.voice.index].get(e.beat.index),this.getVoiceContainer(e.beat.voice).addGlyph(e)}getVoiceContainer(e){return this._voiceContainers.has(e.index)?this._voiceContainers.get(e.index):void 0}getBeatContainer(e){return this.getVoiceContainer(e.voice)?.beatGlyphs?.[e.index]}getPreNotesGlyphForBeat(e){return this.getBeatContainer(e)?.preNotes}getOnNotesGlyphForBeat(e){return this.getBeatContainer(e)?.onNotes}paint(e,t,s){this.paintBackground(e,t,s),s.color=this.resources.mainGlyphColor,this._preBeatGlyphs.paint(e+this.x,t+this.y,s);for(const i of this._voiceContainers.values())i.paint(e+this.x,t+this.y,s);s.color=this.resources.mainGlyphColor,this._postBeatGlyphs.paint(e+this.x,t+this.y,s)}paintBackground(e,t,s){this.layoutingInfo.paint(e+this.x+this._preBeatGlyphs.x+this._preBeatGlyphs.width,t+this.y+this.height,s)}buildBoundingsLookup(e,t,s){const i=new tr;i.bar=this.bar,i.visualBounds=new ft,i.visualBounds.x=t+this.x,i.visualBounds.y=s+this.y+this.topPadding,i.visualBounds.w=this.width,i.visualBounds.h=this.height-this.topPadding-this.bottomPadding,i.realBounds=new ft,i.realBounds.x=t+this.x,i.realBounds.y=s+this.y,i.realBounds.w=this.width,i.realBounds.h=this.height,e.addBar(i);for(const[e,a]of this._voiceContainers){const r=this.bar.isEmpty&&0===e;if(!a.voice.isEmpty||r)for(let e=0,n=a.beatGlyphs.length;e<n;e++){a.beatGlyphs[e].buildBoundingsLookup(i,t+this.x+a.x,s+this.y+a.y,r)}}}addPostBeatGlyph(e){this._postBeatGlyphs.addGlyph(e)}createPreBeatGlyphs(){this.wasFirstOfLine=this.isFirstOfLine}createBeatGlyphs(){for(const e of this.bar.voices)this.hasVoiceContainer(e)&&this.createVoiceGlyphs(e)}createVoiceGlyphs(e){}createPostBeatGlyphs(){}get beatGlyphsStart(){return this._preBeatGlyphs.x+this._preBeatGlyphs.width}get postBeatGlyphsStart(){return this._postBeatGlyphs.x}getBeatX(e,t=ss.PreNotes){const s=this.getBeatContainer(e);if(s)switch(t){case ss.PreNotes:return s.voiceContainer.x+s.x;case ss.OnNotes:return s.voiceContainer.x+s.x+s.onNotes.x;case ss.MiddleNotes:return s.voiceContainer.x+s.x+s.onTimeX;case ss.Stem:const t=s.onNotes.beamingHelper?s.onNotes.beamingHelper.getBeatLineX(e):s.onNotes.x+s.onNotes.width/2;return s.voiceContainer.x+t;case ss.PostNotes:return s.voiceContainer.x+s.x+s.onNotes.x+s.onNotes.width;case ss.EndBeat:return s.voiceContainer.x+s.x+s.width}return 0}getRatioPositionX(e){const t=this.bar.isEmpty?this.beatGlyphsStart:this.getBeatX(this.bar.voices[0].beats[0],ss.OnNotes);return t+(this.postBeatGlyphsStart-t)*e}getNoteX(e,t){const s=this.getBeatContainer(e.beat);return s?s.voiceContainer.x+s.x+s.onNotes.x+s.onNotes.getNoteX(e,t):0}getNoteY(e,t){const s=this.getOnNotesGlyphForBeat(e.beat);return s?s.getNoteY(e,t):Number.NaN}reLayout(){(this.wasFirstOfLine&&!this.isFirstOfLine||!this.wasFirstOfLine&&this.isFirstOfLine)&&this.recreatePreBeatGlyphs(),this.updateSizes(),this.registerLayoutingInfo()}recreatePreBeatGlyphs(){this._preBeatGlyphs=new rn,this._preBeatGlyphs.renderer=this,this.createPreBeatGlyphs()}paintSimileMark(e,t,s){const i=nn.voice(s,I.Glyphs,this.bar.voices[0],!0);try{switch(this.bar.simileMark){case l.Simple:s.beginGroup(Cr.getGroupId(this.bar.voices[0].beats[0])),s.fillMusicFontSymbol(e+this.x+(this.width-20)/2,t+this.y+this.height/2,1,ne.Repeat1Bar,!1),s.endGroup();break;case l.SecondOfDouble:s.beginGroup(Cr.getGroupId(this.bar.voices[0].beats[0])),s.beginGroup(Cr.getGroupId(this.bar.previousBar.voices[0].beats[0])),s.fillMusicFontSymbol(e+this.x-14,t+this.y+this.height/2,1,ne.Repeat2Bars,!1),s.endGroup(),s.endGroup()}}finally{i?.[Symbol.dispose]?.()}}completeBeamingHelper(e){}getBeatDirection(e){return this.helpers.getBeamingHelperForBeat(e).direction}}Hn.RawLineSpacing=8,Hn.StemWidth=.12*Hn.RawLineSpacing,Hn.StaffLineThickness=.13*Hn.RawLineSpacing,Hn.BeamThickness=.5*Hn.RawLineSpacing,Hn.BeamSpacing=.25*Hn.RawLineSpacing,function(e){e[e.SinglePreBeat=0]="SinglePreBeat",e[e.SingleOnBeat=1]="SingleOnBeat",e[e.SingleOnBeatToEnd=2]="SingleOnBeatToEnd",e[e.GroupedOnBeat=3]="GroupedOnBeat",e[e.GroupedOnBeatToEnd=4]="GroupedOnBeatToEnd",e[e.FullBar=5]="FullBar"}(ns||(ns={}));class Wn extends Tr{constructor(e,t){super(0,0),this._uniqueEffectGlyphs=[],this._effectGlyphs=[],this.isEmpty=!0,this.previousBand=null,this.isLinkedToPrevious=!1,this.firstBeat=null,this.lastBeat=null,this.height=0,this.originalHeight=0,this.slot=null,this.voice=e,this.info=t}doLayout(){super.doLayout();for(let e=0;e<this.renderer.bar.voices.length;e++)this._effectGlyphs.push(new Map),this._uniqueEffectGlyphs.push([])}createGlyph(e){if(e.voice===this.voice&&this.info.shouldCreateGlyph(this.renderer.settings,e)&&(!this.info.hideOnMultiTrack||0===this.renderer.staff.trackIndex)){if(this.isEmpty=!1,this.firstBeat&&!e.isBefore(this.firstBeat)||(this.firstBeat=e),!this.lastBeat||e.isAfter(this.lastBeat))switch(this.lastBeat=e,this.info.sizingMode){case ns.SingleOnBeatToEnd:case ns.GroupedOnBeatToEnd:this.lastBeat.nextBeat&&(this.lastBeat=this.lastBeat.nextBeat)}const t=this.createOrResizeGlyph(this.info.sizingMode,e);t.height>this.height&&(this.height=t.height,this.originalHeight=t.height)}}resetHeight(){this.height=this.originalHeight}createOrResizeGlyph(e,t){let s;switch(e){case ns.FullBar:case ns.SinglePreBeat:case ns.SingleOnBeat:case ns.SingleOnBeatToEnd:return s=this.info.createNewGlyph(this.renderer,t),s.renderer=this.renderer,s.beat=t,s.doLayout(),this._effectGlyphs[t.voice.index].set(t.index,s),this._uniqueEffectGlyphs[t.voice.index].push(s),s;case ns.GroupedOnBeat:case ns.GroupedOnBeatToEnd:const i=e===ns.GroupedOnBeat?ns.SingleOnBeat:ns.SingleOnBeatToEnd;if(t.index>0||this.renderer.index>0){const e=t.previousBeat;if(this.info.shouldCreateGlyph(this.renderer.settings,e)){let s=null;if(t.index>0&&this._effectGlyphs[t.voice.index].has(e.index))s=this._effectGlyphs[t.voice.index].get(e.index);else if(this.renderer.index>0){const t=this.renderer.previousRenderer.getBand(e.voice,this.info.effectId);if(t){const i=t._effectGlyphs[e.voice.index];i.has(e.index)&&(s=i.get(e.index))}}const a=this.createOrResizeGlyph(i,t);return s&&this.info.canExpand(e,t)&&(s.nextGlyph=a,a.previousGlyph=s,this.isLinkedToPrevious=!0),a}return this.createOrResizeGlyph(i,t)}return this.createOrResizeGlyph(i,t);default:return this.createOrResizeGlyph(ns.SingleOnBeat,t)}}paint(e,t,s){super.paint(e,t,s);for(let i=0,a=this._uniqueEffectGlyphs.length;i<a;i++){const a=this._uniqueEffectGlyphs[i];for(let i=0,r=a.length;i<r;i++){const r=a[i],n=nn.beat(s,be.Effects,r.beat,!1);try{r.paint(e+this.x,t+this.y,s)}finally{n?.[Symbol.dispose]?.()}}}}alignGlyphs(){for(let e=0;e<this._effectGlyphs.length;e++)for(const t of this._effectGlyphs[e].keys())this.alignGlyph(this.info.sizingMode,this.renderer.bar.voices[e].beats[t])}alignGlyph(e,t){const s=this._effectGlyphs[t.voice.index].get(t.index),i=this.renderer.getBeatContainer(t);switch(e){case ns.SinglePreBeat:const e=this.renderer.layoutingInfo.getPreBeatSize(t);s.x=this.renderer.beatGlyphsStart+i.x-e;break;case ns.SingleOnBeat:case ns.GroupedOnBeat:s.x=this.renderer.beatGlyphsStart+i.x;break;case ns.SingleOnBeatToEnd:case ns.GroupedOnBeatToEnd:if(s.x=this.renderer.beatGlyphsStart+i.x,i.beat.isLastOfVoice)s.width=this.renderer.width-s.x;else{const e=this.renderer.layoutingInfo.getPostBeatSize(t);s.width=e}break;case ns.FullBar:s.width=this.renderer.width}}}class Vn{constructor(){this.uniqueEffectId=null,this.y=0,this.height=0,this.firstBeat=null,this.lastBeat=null}}class Gn{constructor(){this.bands=[],this.shared=new Vn}update(e){e.info.canShareBand||(this.shared.uniqueEffectId=e.info.effectId),e.slot=this,this.bands.push(e),e.height>this.shared.height&&(this.shared.height=e.height),this.shared.firstBeat&&!e.firstBeat.isBefore(this.shared.firstBeat)||(this.shared.firstBeat=e.firstBeat),this.shared.lastBeat&&!e.lastBeat.isAfter(this.shared.lastBeat)||(this.shared.lastBeat=e.lastBeat)}canBeUsed(e){return(!this.shared.uniqueEffectId&&e.info.canShareBand||e.info.effectId===this.shared.uniqueEffectId)&&(!this.shared.firstBeat||this.shared.lastBeat.isBefore(e.firstBeat)||this.shared.lastBeat.isBefore(this.shared.firstBeat))}}class zn{constructor(){this.slots=[],this._effectSlot=new Map}getOrCreateSlot(e){if(this._effectSlot.has(e.info.effectId)){const t=this._effectSlot.get(e.info.effectId);if(t.canBeUsed(e))return t}for(const t of this.slots)if(t.canBeUsed(e))return t;const t=new Gn;return this.slots.push(t),t}register(e){const t=this.getOrCreateSlot(e);t.update(e),this._effectSlot.set(e.info.effectId,t)}}class Un extends Hn{constructor(e,t,s){super(e,t),this._bands=[],this._bandLookup=new Map,this.sizingInfo=null,this._infos=s}updateSizes(){this.topOverflow=0,this.bottomOverflow=0,this.topPadding=0,this.bottomPadding=0,this.updateHeight(),super.updateSizes()}finalizeRenderer(){let e=super.finalizeRenderer();return this.updateHeight()&&(e=!0),e}updateHeight(){if(!this.sizingInfo)return!1;let e=0;for(const t of this.sizingInfo.slots){t.shared.y=e;for(const s of t.bands)s.y=e,s.height=t.shared.height;e+=t.shared.height}return e!==this.height&&(this.height=e,!0)}applyLayoutingInfo(){const e=!super.applyLayoutingInfo();if(this.index>0){const e=this.previousRenderer;this.sizingInfo=e.sizingInfo}else this.sizingInfo=new zn;for(const e of this._bands)e.resetHeight(),e.alignGlyphs(),e.isEmpty||this.sizingInfo.register(e);return this.updateHeight(),e}scaleToWidth(e){super.scaleToWidth(e);for(const e of this._bands)e.alignGlyphs()}createBeatGlyphs(){this._bands=[],this._bandLookup=new Map;for(const e of this.bar.voices)if(this.hasVoiceContainer(e))for(const t of this._infos){const s=new Wn(e,t);s.renderer=this,s.doLayout(),this._bands.push(s),this._bandLookup.set(`${e.index}.${t.effectId}`,s)}super.createBeatGlyphs();for(const e of this._bands)e.isLinkedToPrevious&&(this.isLinkedToPrevious=!0)}createVoiceGlyphs(e){for(const t of e.beats){const s=new Cr(t,this.getVoiceContainer(e));s.preNotes=new Ln,s.onNotes=new An,this.addBeatGlyph(s);for(const e of this._bands)e.createGlyph(t)}}paint(e,t,s){this.paintBackground(e,t,s);for(const i of this._bands)s.color=0===i.voice.index?this.resources.mainGlyphColor:this.resources.secondaryGlyphColor,i.isEmpty||i.paint(e+this.x,t+this.y,s)}getBand(e,t){const s=`${e.index}.${t}`;return this._bandLookup.has(s)?this._bandLookup.get(s):null}}class Xn extends sn{get staffId(){return this._staffId}getStaffPaddingTop(e){return e.system.layout.renderer.settings.display.effectStaffPaddingTop}getStaffPaddingBottom(e){return e.system.layout.renderer.settings.display.effectStaffPaddingBottom}constructor(e,t,s=null){super(),this.infos=t,this._staffId=e,this.isInsideBracket=!1,this.isRelevantForBoundsLookup=!1,this.shouldShow=s}canCreate(e,t){const s=this.shouldShow;return super.canCreate(e,t)&&(!s||s(e,t))}create(e,t){return new Un(e,t,this.infos.filter((t=>e.settings.notation.isNotationElementVisible(t.notationElement))))}}class Jn extends Nr{constructor(e,t,s,i,a){super(e,t),this._endingsString="",this._endings=ae.getAlternateEndingsList(s),this._openLine=i,this._closeLine=a}doLayout(){super.doLayout(),this.height=this.renderer.resources.wordsFont.size+(Jn.Padding+2);let e="";for(let t=0,s=this._endings.length;t<s;t++)e+=this._endings[t]+1,e+=". ";this._endingsString=e}paint(e,t,s){const i=this._closeLine?this.width-4:this.width;if(e=.5+(0|e),t=.5+(0|t),this._openLine?(s.moveTo(e+this.x,t+this.y+this.height),s.lineTo(e+this.x,t+this.y)):s.moveTo(e+this.x,t+this.y),s.lineTo(e+this.x+i,t+this.y),this._closeLine&&s.lineTo(e+this.x+i,t+this.y+this.height),s.stroke(),this._openLine){const i=s.textBaseline;s.textBaseline=he.Top;const a=this.renderer.resources;s.font=a.wordsFont,s.fillText(this._endingsString,e+this.x+Jn.Padding,t+this.y),s.textBaseline=i}}}Jn.Padding=3;class Yn{get effectId(){return this.notationElement.toString()}}class $n extends Yn{get notationElement(){return e.NotationElement.EffectAlternateEndings}get hideOnMultiTrack(){return!0}get canShareBand(){return!1}get sizingMode(){return ns.FullBar}shouldCreateGlyph(e,t){return 0===t.voice.index&&0===t.index&&0!==t.voice.bar.masterBar.alternateEndings}createNewGlyph(e,t){const s=t.voice.bar.masterBar,i=null===s.previousMasterBar||s.alternateEndings!==s.previousMasterBar.alternateEndings;let a=s.isRepeatEnd||null===s.nextMasterBar||s.alternateEndings!==s.nextMasterBar.alternateEndings;return s.repeatGroup.closings.some((e=>e.index>=s.index))||(a=!1),new Jn(0,0,s.alternateEndings,i,a)}canExpand(e,t){return!0}}class qn extends Yn{get notationElement(){return e.NotationElement.EffectCapo}get hideOnMultiTrack(){return!1}get canShareBand(){return!1}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return 0===t.index&&0===t.voice.bar.index&&0!==t.voice.bar.staff.capo}createNewGlyph(e,t){return new _n(0,0,`Capo. fret ${t.voice.bar.staff.capo}`,e.resources.effectFont,oe.Left)}canExpand(e,t){return!1}}class jn extends Yn{get notationElement(){return e.NotationElement.EffectChordNames}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return t.hasChord}createNewGlyph(e,t){return new _n(0,0,t.chord.name,e.resources.effectFont,oe.Center)}canExpand(e,t){return!1}}class Kn extends Nr{constructor(e){super(),this.forceGroupedRendering=!1,this.endOnBarLine=!1,this.endPosition=e}get isLinkedWithPrevious(){return!!this.previousGlyph&&this.previousGlyph.renderer.staff.system===this.renderer.staff.system}get isLinkedWithNext(){return!!this.nextGlyph&&this.nextGlyph.renderer.isFinalized&&this.nextGlyph.renderer.staff.system===this.renderer.staff.system}paint(e,t,s){if(this.isLinkedWithPrevious)return;if(!this.isLinkedWithNext&&!this.forceGroupedRendering)return void this.paintNonGrouped(e,t,s);let i;if(!this.isLinkedWithNext&&this.forceGroupedRendering)i=this;else for(i=this.nextGlyph;i.isLinkedWithNext;)i=i.nextGlyph;const a=i.renderer,r=i.beat,n=this.endPosition,o=e-this.renderer.x,h=this.calculateEndX(a,r,o,n);this.paintGrouped(e,t,h,s)}calculateEndX(e,t,s,i){return t?s+e.x+e.getBeatX(t,i):s+e.x+this.x+this.width}paintNonGrouped(e,t,s){const i=e-this.renderer.x,a=this.calculateEndX(this.renderer,this.beat,i,this.endPosition);this.paintGrouped(e,t,a,s)}}class Qn extends Kn{constructor(e,t,s){super(ss.EndBeat),this._crescendo=_.None,this._crescendo=s,this.x=e,this.y=t}doLayout(){super.doLayout(),this.height=17}paintGrouped(e,t,s,i){const a=e+this.x,r=this.height,n=xr.Widths.get(ne.NoteheadBlack)/2;i.beginPath(),this._crescendo===_.Crescendo?(s-=n,i.moveTo(s,t+this.y),i.lineTo(a,t+this.y+r/2),i.lineTo(s,t+this.y+r)):(s-=n,i.moveTo(a,t+this.y),i.lineTo(s,t+this.y+r/2),i.lineTo(a,t+this.y+r)),i.stroke()}}class Zn extends Yn{get notationElement(){return e.NotationElement.EffectCrescendo}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.GroupedOnBeatToEnd}shouldCreateGlyph(e,t){return t.crescendo!==_.None}createNewGlyph(e,t){return new Qn(0,0,t.crescendo)}canExpand(e,t){return e.crescendo===t.crescendo}}class eo extends vr{constructor(e,t,s){super(e,t,.6,eo.getSymbol(s)),this.center=!0}doLayout(){super.doLayout(),this.y+=this.height/2}static getSymbol(e){switch(e){case m.PPP:return ne.DynamicPPP;case m.PP:return ne.DynamicPP;case m.P:return ne.DynamicPiano;case m.MP:return ne.DynamicMP;case m.MF:return ne.DynamicMF;case m.F:return ne.DynamicForte;case m.FF:return ne.DynamicFF;case m.FFF:return ne.DynamicFFF;case m.PPPP:return ne.DynamicPPPP;case m.PPPPP:case m.PPPPPP:return ne.DynamicPPPPP;case m.FFFF:return ne.DynamicFFFF;case m.FFFFF:return ne.DynamicFFFFF;case m.FFFFFF:return ne.DynamicFFFFFF;case m.SF:return ne.DynamicSforzando1;case m.SFP:return ne.DynamicSforzandoPiano;case m.SFPP:return ne.DynamicSforzandoPianissimo;case m.FP:return ne.DynamicFortePiano;case m.RF:return ne.DynamicRinforzando1;case m.RFZ:return ne.DynamicRinforzando2;case m.SFZ:return ne.DynamicSforzato;case m.SFFZ:return ne.DynamicSforzatoFF;case m.FZ:return ne.DynamicForzando;case m.N:return ne.DynamicNiente;case m.PF:return ne.DynamicPF;case m.SFZP:return ne.DynamicSforzatoPiano;default:return ne.None}}}class to extends Yn{get notationElement(){return e.NotationElement.EffectDynamics}get hideOnMultiTrack(){return!1}get canShareBand(){return!1}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return this.internalShouldCreateGlyph(t)}internalShouldCreateGlyph(e){if(e.voice.bar.staff.track.score.stylesheet.hideDynamics||e.isEmpty||e.voice.isEmpty||e.isRest)return!1;const t=this.getPreviousDynamicsBeat(e);let s=0===e.voice.index&&!t||e.dynamics!==t?.dynamics;if(s&&e.voice.index>0)for(const t of e.voice.bar.voices)if(t.index<e.voice.index){const i=t.getBeatAtPlaybackStart(e.playbackStart);i&&e.dynamics===i.dynamics&&this.internalShouldCreateGlyph(i)&&(s=!1)}return s}getPreviousDynamicsBeat(e){let t=e.previousBeat;for(;null!=t;){if(!t.isRest)return t;t=t.previousBeat}return null}createNewGlyph(e,t){return new eo(0,0,t.dynamics)}canExpand(e,t){return!0}}class so extends vr{constructor(e){super(0,0,1,so.getSymbol(e)),this.center=!0}static getSymbol(e){switch(e){case pe.FadeIn:return ne.GuitarFadeIn;case pe.FadeOut:return ne.GuitarFadeOut;case pe.VolumeSwell:return ne.GuitarVolumeSwell}return ne.None}paint(e,t,s){super.paint(e,t+this.height,s)}}class io extends Yn{get notationElement(){return e.NotationElement.EffectFadeIn}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return t.fade!==pe.None}createNewGlyph(e,t){return new so(t.fade)}canExpand(e,t){return!0}}class ao extends vr{constructor(e,t,s){super(e,t,1,ao.getSymbol(s))}static getSymbol(e){switch(e){case Te.Short:return ne.FermataShortAbove;case Te.Medium:return ne.FermataAbove;case Te.Long:return ne.FermataLongAbove;default:return ne.None}}paint(e,t,s){super.paint(e-this.width/2,t+this.height,s)}}class ro extends Yn{get notationElement(){return e.NotationElement.EffectFermata}get hideOnMultiTrack(){return!1}get canShareBand(){return!1}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return 0===t.voice.index&&!!t.fermata}createNewGlyph(e,t){return new ao(0,0,t.fermata.type)}canExpand(e,t){return!0}}class no extends Yn{get notationElement(){return e.NotationElement.EffectFingering}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(t,s){return!(0!==s.voice.index||s.isRest||t.notation.fingeringMode!==e.FingeringMode.SingleNoteEffectBand&&t.notation.fingeringMode!==e.FingeringMode.SingleNoteEffectBandForcePiano)&&(1===s.notes.length&&s.notes[0].isFingering)}createNewGlyph(e,t){let s=T.Unknown,i=!1;const a=t.notes[0];a.leftHandFinger!==T.Unknown?(s=a.leftHandFinger,i=!0):a.rightHandFinger!==T.Unknown&&(s=a.rightHandFinger);const r=ae.fingerToString(e.settings,t,s,i)??"";return new _n(0,0,r,e.resources.fingeringFont,oe.Left)}canExpand(e,t){return!0}}class oo extends Yn{constructor(){super(...arguments),this.lastCreateInfo=null}shouldCreateGlyph(e,t){this.lastCreateInfo=[];for(let e=0,s=t.notes.length;e<s;e++){const s=t.notes[e];this.shouldCreateGlyphForNote(s)&&this.lastCreateInfo.push(s)}return this.lastCreateInfo.length>0}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}canExpand(e,t){return!0}}class ho extends Kn{constructor(e,t=!0){super(ss.OnNotes),this._label=e,this._dashed=t}doLayout(){this.renderer.settings.notation.extendLineEffectsToBeatEnd&&(this.endPosition=ss.EndBeat,this.forceGroupedRendering=!0),super.doLayout(),this.height=this.renderer.resources.effectFont.size}paintNonGrouped(e,t,s){const i=this.renderer.resources;s.font=i.effectFont;const a=s.textAlign;s.textAlign=oe.Center,s.fillText(this._label,e+this.x,t+this.y),s.textAlign=a}paintGrouped(e,t,s,i){this.paintNonGrouped(e,t,i);const a=i.measureText(this._label).width,r=e+this.x+a/2+3,n=t+this.y+4;if(this._dashed){if(s>r){let e=r;for(;e<s;)i.beginPath(),i.moveTo(e,0|n),i.lineTo(Math.min(e+8,s),0|n),e+=11,i.stroke();i.beginPath(),i.moveTo(s,n-5|0),i.lineTo(s,n+5|0),i.stroke()}}else i.beginPath(),i.moveTo(r,0|n),i.lineTo(s,0|n),i.lineTo(s,n+5|0),i.stroke()}}ho.LineSpacing=3,ho.LineTopPadding=4,ho.LineTopOffset=5,ho.LineSize=8;class lo extends oo{get effectId(){return this._effectId}get notationElement(){return e.NotationElement.EffectHarmonics}constructor(e){switch(super(),this._beat=null,this._harmonicType=e,e){case N.None:this._effectId="harmonics-none";break;case N.Natural:this._effectId="harmonics-natural";break;case N.Artificial:this._effectId="harmonics-artificial";break;case N.Pinch:this._effectId="harmonics-pinch";break;case N.Tap:this._effectId="harmonics-tap";break;case N.Semi:this._effectId="harmonics-semi";break;case N.Feedback:this._effectId="harmonics-feedback";break;default:this._effectId=""}}shouldCreateGlyphForNote(e){return!(!e.isHarmonic||e.harmonicType!==this._harmonicType)&&(e.beat!==this._beat&&(this._beat=e.beat),!0)}get sizingMode(){return ns.GroupedOnBeat}createNewGlyph(e,t){return new ho(lo.harmonicToString(this._harmonicType))}static harmonicToString(e){switch(e){case N.Natural:return"N.H.";case N.Artificial:return"A.H.";case N.Pinch:return"P.H.";case N.Tap:return"T.H.";case N.Semi:return"S.H.";case N.Feedback:return"Fdbk."}return""}}class co extends Yn{get notationElement(){return e.NotationElement.EffectLetRing}get canShareBand(){return!1}get hideOnMultiTrack(){return!1}shouldCreateGlyph(e,t){return t.isLetRing}get sizingMode(){return ns.GroupedOnBeat}createNewGlyph(e,t){return new ho("LetRing")}canExpand(e,t){return!0}}class uo extends Nr{constructor(e,t,s,i,a=oe.Center){super(e,t),this._lines=s,this.font=i,this.textAlign=a}doLayout(){super.doLayout(),this.height=this.font.size*this._lines.length}paint(e,t,s){s.font=this.font;const i=s.textAlign;s.textAlign=this.textAlign;for(let i=0;i<this._lines.length;i++)this._lines[i]&&s.fillText(this._lines[i],e+this.x,t+this.y+i*this.font.size);s.textAlign=i}}class po extends Yn{get notationElement(){return e.NotationElement.EffectLyrics}get hideOnMultiTrack(){return!1}get canShareBand(){return!1}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return!!t.lyrics}createNewGlyph(e,t){return new uo(0,0,t.lyrics,e.resources.effectFont,oe.Center)}canExpand(e,t){return!0}}class go extends Yn{get notationElement(){return e.NotationElement.EffectMarker}get hideOnMultiTrack(){return!0}get canShareBand(){return!0}get sizingMode(){return ns.SinglePreBeat}shouldCreateGlyph(e,t){return 0===t.voice.bar.staff.index&&0===t.voice.index&&0===t.index&&t.voice.bar.masterBar.isSectionStart}createNewGlyph(e,t){return new _n(0,0,t.voice.bar.masterBar.section.marker?`[${t.voice.bar.masterBar.section.marker}] ${t.voice.bar.masterBar.section.text}`:t.voice.bar.masterBar.section.text,e.resources.markerFont,oe.Left)}canExpand(e,t){return!0}}class mo extends Kn{constructor(e,t){super(ss.PostNotes),this._ottava=e,this._aboveStaff=t}doLayout(){super.doLayout(),this.height=xr.Heights.get(ne.QuindicesimaAlta)}paintNonGrouped(e,t,s){this.paintOttava(e,t,s)}paintOttava(e,t,s){let i=0;switch(this._ottava){case h._15ma:i=.8*xr.Widths.get(ne.QuindicesimaAlta),s.fillMusicFontSymbol(e+this.x-i/2,t+this.y+this.height,.8,ne.QuindicesimaAlta,!1);break;case h._8va:i=.8*xr.Widths.get(ne.OttavaAlta),s.fillMusicFontSymbol(e+this.x-i/2,t+this.y+this.height,.8,ne.OttavaAlta,!1);break;case h._8vb:i=.8*xr.Widths.get(ne.OttavaBassaVb),s.fillMusicFontSymbol(e+this.x-i/2,t+this.y+this.height,.8,ne.OttavaBassaVb,!1);break;case h._15mb:i=.8*(xr.Widths.get(ne.Quindicesima)+xr.Widths.get(ne.OctaveBaselineM)+xr.Widths.get(ne.OctaveBaselineB)),s.fillMusicFontSymbols(e+this.x-i/2,t+this.y+this.height,.8,[ne.Quindicesima,ne.OctaveBaselineM,ne.OctaveBaselineB],!1)}return i/2}paintGrouped(e,t,s,i){const a=this.paintOttava(e,t,i),r=e+this.x+a+3;let n=t+this.y;n+=this._aboveStaff?2:this.height-2;if(s>r){let e=r;for(;e<s;)i.beginPath(),i.moveTo(e,0|n),i.lineTo(Math.min(e+8,s),0|n),e+=11,i.stroke();i.beginPath(),this._aboveStaff?(i.moveTo(s,n),i.lineTo(s,t+this.y+this.height)):(i.moveTo(s,n),i.lineTo(s,t+this.y)),i.stroke()}}}class fo extends Yn{get effectId(){return"ottavia-"+(this._aboveStaff?"above":"below")}get notationElement(){return e.NotationElement.EffectOttavia}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.GroupedOnBeat}constructor(e){super(),this._aboveStaff=e}shouldCreateGlyph(e,t){switch(t.ottava){case h._15ma:case h._8va:return this._aboveStaff;case h._8vb:case h._15mb:return!this._aboveStaff}return!1}createNewGlyph(e,t){return new mo(t.ottava,this._aboveStaff)}canExpand(e,t){return e.ottava===t.ottava}}class yo extends oo{get notationElement(){return e.NotationElement.EffectPalmMute}shouldCreateGlyphForNote(e){return e.isPalmMute}get sizingMode(){return ns.GroupedOnBeat}createNewGlyph(e,t){return new ho("P.M.")}}class bo extends oo{get notationElement(){return e.NotationElement.EffectPickSlide}shouldCreateGlyphForNote(e){return e.slideOutType===P.PickSlideDown||e.slideOutType===P.PickSlideUp}get sizingMode(){return ns.GroupedOnBeat}createNewGlyph(e,t){return new ho("P.S.")}}class So extends vr{constructor(e,t,s){super(e,t,Pr.GraceScale,So.getSymbol(s))}paint(e,t,s){super.paint(e,t+this.height,s)}static getSymbol(e){switch(e){case re.Up:return ne.StringsUpBow;case re.Down:return ne.StringsDownBow;default:return ne.None}}}class _o extends Yn{get notationElement(){return e.NotationElement.EffectPickStroke}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return t.pickStroke!==re.None}createNewGlyph(e,t){return new So(0,0,t.pickStroke)}canExpand(e,t){return!0}}class wo extends Kn{constructor(e){super(ss.EndBeat),this._stepSize=0,this._type=e}doLayout(){switch(super.doLayout(),this._type){case F.Slight:this._stepSize=12;break;case F.Wide:this._stepSize=23}this.height=18}paintGrouped(e,t,s,i){let a=e+this.x;const r=s-a,n=Math.max(1,r/this._stepSize);i.beginPath(),i.moveTo(a,t+this.y);for(let e=0;e<n;e++)i.lineTo(a+this._stepSize/2,t+this.y+this.height),i.lineTo(a+this._stepSize,t+this.y),a+=this._stepSize;i.stroke()}}class Bo extends Yn{get notationElement(){return e.NotationElement.EffectSlightBeatVibrato}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.GroupedOnBeatToEnd}shouldCreateGlyph(e,t){return t.vibrato===F.Slight}createNewGlyph(e,t){return new wo(F.Slight)}canExpand(e,t){return!0}}class ko extends Kn{constructor(e,t,s,i=1.2,a=!1){super(ss.EndBeat),this._scale=0,this._symbol=ne.None,this._symbolSize=0,this._type=s,this._scale=i,this.x=e,this.y=t,this._partialWaves=a}doLayout(){switch(super.doLayout(),this._type){case F.Slight:this._symbol=ne.WiggleTrill;break;case F.Wide:this._symbol=ne.WiggleVibratoMediumFast}this._symbolSize=xr.Widths.get(this._symbol)*this._scale,this.height=xr.Heights.get(this._symbol)*this._scale}paintGrouped(e,t,s,i){const a=s-(e+this.x),r=this._symbolSize;let n=a/r;this._partialWaves||(n=Math.floor(n)),n<1&&(n=1);let o=0;for(let s=0;s<n;s++)i.fillMusicFontSymbol(e+this.x+o,t+this.y+2*this.height,this._scale,this._symbol,!1),o+=r}}class To extends oo{get notationElement(){return e.NotationElement.EffectSlightNoteVibrato}shouldCreateGlyphForNote(e){let t=e.vibrato===F.Slight||e.isTieDestination&&e.tieOrigin.vibrato===F.Slight;return this._hideOnTiedBend&&t&&e.isTieDestination&&e.tieOrigin.hasBend&&(t=!1),t}get sizingMode(){return ns.GroupedOnBeatToEnd}createNewGlyph(e,t){return new ko(0,0,F.Slight,1.2)}constructor(e){super(),this._hideOnTiedBend=e}}class No extends Yn{get notationElement(){return e.NotationElement.EffectTap}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return t.slap||t.pop||t.tap}createNewGlyph(e,t){const s=e.resources;return t.slap?new _n(0,0,"S",s.effectFont,oe.Left):t.pop?new _n(0,0,"P",s.effectFont,oe.Left):new _n(0,0,"T",s.effectFont,oe.Left)}canExpand(e,t){return!0}}class xo extends Nr{constructor(e){super(0,0),this.tempoAutomations=e}doLayout(){super.doLayout(),this.height=25}paint(e,t,s){for(const i of this.tempoAutomations){let a=e+this.renderer.getRatioPositionX(i.ratioPosition);const r=this.renderer.resources;if(s.font=r.markerFont,s.textBaseline=he.Top,i.text){const e=s.measureText(i.text);s.fillText(i.text,a,t+this.y+s.font.size/2),a+=e.width+.7*s.font.size}s.fillMusicFontSymbol(a,t+this.y+.8*this.height,.5,ne.NoteQuarterUp,!0),s.fillText(`= ${i.value.toString()}`,a+.5*xr.Widths.get(ne.NoteQuarterUp)+3,t+this.y+s.font.size/2)}}}class vo extends Yn{get notationElement(){return e.NotationElement.EffectTempo}get hideOnMultiTrack(){return!0}get canShareBand(){return!1}get sizingMode(){return ns.SinglePreBeat}shouldCreateGlyph(e,t){return 0===t.voice.bar.staff.index&&0===t.voice.index&&0===t.index&&t.voice.bar.masterBar.tempoAutomations.length>0}createNewGlyph(e,t){return new xo(t.voice.bar.masterBar.tempoAutomations)}canExpand(e,t){return!0}}class Po extends Yn{get notationElement(){return e.NotationElement.EffectText}get hideOnMultiTrack(){return!1}get canShareBand(){return!1}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return!!t.text}createNewGlyph(e,t){return new _n(0,0,t.text,e.resources.effectFont,oe.Left)}canExpand(e,t){return!0}}class Fo extends Kn{constructor(e,t){super(ss.EndBeat),this.x=e,this.y=t}doLayout(){super.doLayout(),this.height=xr.Heights.get(ne.OrnamentTrill)/2}paintGrouped(e,t,s,i){let a=e+this.x;i.fillMusicFontSymbol(a,t+this.y+this.height,1,ne.OrnamentTrill,!0),a+=xr.Widths.get(ne.OrnamentTrill)/2;const r=1.2*xr.Widths.get(ne.WiggleTrill),n=Math.floor((s-a)/r),o=t+this.y+1.37*this.height;let h=a;for(let e=0;e<n;e++)i.fillMusicFontSymbol(h,o,1.2,ne.WiggleTrill,!1),h+=r}}class Co extends oo{get notationElement(){return e.NotationElement.EffectTrill}shouldCreateGlyphForNote(e){return e.isTrill}get sizingMode(){return ns.GroupedOnBeatToEnd}createNewGlyph(e,t){return new Fo(0,0)}}!function(e){e[e.Full=0]="Full",e[e.PartialLeft=1]="PartialLeft",e[e.PartialRight=2]="PartialRight"}(os||(os={}));class Eo extends Nr{constructor(e){super(0,0),this._tripletFeel=e}doLayout(){super.doLayout(),this.height=25}paint(e,t,s){e+=this.x;const i=(t+=this.y)+this.height*Pr.GraceScale,a=i+8;s.font=this.renderer.resources.effectFont,s.fillText("(",e,t+.3*this.height);const r=e+10,n=e+40;let o=[],h=[],l=[],c=[];switch(this._tripletFeel){case A.NoTripletFeel:o=[ne.TextBlackNoteLongStem,ne.TextCont8thBeamLongStem,ne.TextBlackNoteFrac8thLongStem],l=[ne.TextBlackNoteLongStem,ne.TextCont8thBeamLongStem,ne.TextBlackNoteFrac8thLongStem];break;case A.Triplet8th:o=[ne.TextBlackNoteLongStem,ne.TextCont8thBeamLongStem,ne.TextBlackNoteFrac8thLongStem],l=[ne.TextBlackNoteLongStem,ne.Space,ne.NoteEighthUp],c=[ne.TextTupletBracketStartLongStem,ne.TextTuplet3LongStem,ne.TextTupletBracketEndLongStem];break;case A.Triplet16th:o=[ne.TextBlackNoteLongStem,ne.TextCont8thBeamLongStem,ne.TextBlackNoteFrac8thLongStem],l=[ne.TextBlackNoteLongStem,ne.TextCont8thBeamLongStem,ne.TextBlackNoteFrac16thLongStem],c=[ne.TextTupletBracketStartLongStem,ne.TextTuplet3LongStem,ne.TextTupletBracketEndLongStem];break;case A.Dotted8th:o=[ne.TextBlackNoteLongStem,ne.TextCont8thBeamLongStem,ne.TextBlackNoteFrac8thLongStem],h=[ne.TextAugmentationDot],l=[ne.TextBlackNoteLongStem,ne.TextCont8thBeamLongStem,ne.TextBlackNoteFrac16thLongStem];break;case A.Dotted16th:o=[ne.TextBlackNoteLongStem,ne.TextCont16thBeamLongStem,ne.TextBlackNoteFrac16thLongStem],h=[ne.TextAugmentationDot],l=[ne.TextBlackNoteLongStem,ne.TextCont16thBeamLongStem,ne.TextBlackNoteFrac32ndLongStem],s.fillCircle(n+9,i,1);break;case A.Scottish8th:o=[ne.TextBlackNoteLongStem,ne.TextCont8thBeamLongStem,ne.TextBlackNoteFrac8thLongStem],l=[ne.TextBlackNoteLongStem,ne.TextCont16thBeamLongStem,ne.TextBlackNoteFrac8thLongStem,ne.TextAugmentationDot];break;case A.Scottish16th:o=[ne.TextBlackNoteLongStem,ne.TextCont16thBeamLongStem,ne.TextBlackNoteFrac16thLongStem],l=[ne.TextBlackNoteLongStem,ne.TextCont32ndBeamLongStem,ne.TextBlackNoteFrac16thLongStem,ne.TextAugmentationDot]}s.fillMusicFontSymbols(r,i,Eo.NoteScale,o,!1),s.fillText("=",e+32,t+5),s.fillMusicFontSymbols(n,i,Eo.NoteScale,l,!1),h.length>0&&s.fillMusicFontSymbols(n+7,i,Eo.NoteScale,h,!1),c.length>0&&s.fillMusicFontSymbols(n,a,Eo.TupletScale,c,!1),s.fillText(")",e+65,t+.3*this.height)}}Eo.NoteScale=.5,Eo.TupletScale=.7;class Do extends Yn{get notationElement(){return e.NotationElement.EffectTripletFeel}get hideOnMultiTrack(){return!0}get canShareBand(){return!1}get sizingMode(){return ns.SinglePreBeat}shouldCreateGlyph(e,t){return 0===t.index&&(0===t.voice.bar.masterBar.index&&t.voice.bar.masterBar.tripletFeel!==A.NoTripletFeel||t.voice.bar.masterBar.index>0&&t.voice.bar.masterBar.tripletFeel!==t.voice.bar.masterBar.previousMasterBar.tripletFeel)}createNewGlyph(e,t){return new Eo(t.voice.bar.masterBar.tripletFeel)}canExpand(e,t){return!0}}class Mo extends Yn{get notationElement(){return e.NotationElement.EffectWhammyBar}get hideOnMultiTrack(){return!1}get canShareBand(){return!1}get sizingMode(){return ns.GroupedOnBeat}shouldCreateGlyph(e,t){return t.hasWhammyBar}createNewGlyph(e,t){return new ho("w/bar")}canExpand(e,t){return!0}}class Lo extends Yn{get notationElement(){return e.NotationElement.EffectWideBeatVibrato}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.GroupedOnBeatToEnd}shouldCreateGlyph(e,t){return t.vibrato===F.Wide}createNewGlyph(e,t){return new wo(F.Wide)}canExpand(e,t){return!0}}class Ao extends oo{get notationElement(){return e.NotationElement.EffectWideNoteVibrato}shouldCreateGlyphForNote(e){return e.vibrato===F.Wide||e.isTieDestination&&e.tieOrigin.vibrato===F.Wide}get sizingMode(){return ns.GroupedOnBeatToEnd}createNewGlyph(e,t){return new ko(0,0,F.Wide,1.2)}}class Io{constructor(){this.x=0,this.width=0,this.masterBars=[]}}class Ro extends Mn{constructor(){super(...arguments),this._system=null}get name(){return"HorizontalScreen"}get supportsResize(){return!1}get firstBarX(){let e=this.pagePadding[0];return this._system&&(e+=this._system.accoladeWidth),e}doResize(){}doLayoutAndRender(){switch(this.renderer.settings.display.systemsLayoutMode){case e.SystemsLayoutMode.Automatic:this.systemsLayoutMode=is.Automatic;break;case e.SystemsLayoutMode.UseModelLayout:this.systemsLayoutMode=is.FromModelWithWidths}const t=this.renderer.score;let s=this.renderer.settings.display.startBar;s--,s=Math.min(t.masterBars.length-1,Math.max(0,s));let i=s,a=this.renderer.settings.display.barCount;a<=0&&(a=t.masterBars.length),a=s+a-1,a=Math.min(t.masterBars.length-1,Math.max(0,a)),this._system=this.createEmptyStaffSystem(),this._system.isLast=!0,this._system.x=this.pagePadding[0],this._system.y=this.pagePadding[1];const r=this.renderer.settings.display.barCountPerPartial,n=[];let o=new Io,h=0;for(;i<=a;){const e=this.multiBarRestInfo,s=null!==e&&e.has(i)?e.get(i):null,a=this._system.addBars(this.renderer.tracks,i,s);if(0===o.masterBars.length&&a.isLinkedToPrevious&&n.length>0){const e=n[n.length-1];e.masterBars.push(t.masterBars[i]),e.width+=a.width,h+=a.width,o.x+=h}else o.masterBars.push(t.masterBars[i]),o.width+=a.width,o.masterBars.length>=r&&(0===n.length&&(o.width+=this._system.accoladeWidth+this.pagePadding[0]),h+=o.width,n.push(o),j.debug(this.name,`Finished partial from bar ${o.masterBars[0].index} to ${o.masterBars[o.masterBars.length-1].index}`,null),o=new Io,o.x=h);i++}o.masterBars.length>0&&(0===n.length&&(o.width+=this._system.accoladeWidth+this.pagePadding[0]),n.push(o),j.debug(this.name,`Finished partial from bar ${o.masterBars[0].index} to ${o.masterBars[o.masterBars.length-1].index}`,null)),this.finalizeStaffSystem();const l=this.renderer.settings.display.scale;this.height=Math.floor(this._system.y+this._system.height)*l,this.width=(this._system.x+this._system.width+this.pagePadding[2])*l,i=0;let c=0;for(let e=0;e<n.length;e++){const t=n[e],s=new er;s.x=c,s.y=0,s.totalWidth=this.width/l,s.totalHeight=this.height/l,s.width=t.width,s.height=this.height/l,s.firstMasterBarIndex=t.masterBars[0].index,s.lastMasterBarIndex=t.masterBars[t.masterBars.length-1].index,c+=t.width;const a=i,r=e;this._system.buildBoundingsLookup(0,0),this.registerPartial(s,(e=>{let s=this._system.getBarX(t.masterBars[0].index)+this._system.accoladeWidth;0===r&&(s-=this._system.x+this._system.accoladeWidth),e.color=this.renderer.settings.display.resources.mainGlyphColor,e.textAlign=oe.Left,j.debug(this.name,`Rendering partial from bar ${t.masterBars[0].index} to ${t.masterBars[t.masterBars.length-1].index}`,null),this._system.paintPartial(-s,this._system.y,e,a,t.masterBars.length)})),i+=t.masterBars.length}this.height=this.layoutAndRenderBottomScoreInfo(this.height),this.height=this.layoutAndRenderAnnotation(this.height),this.height+=this.pagePadding[3]}finalizeStaffSystem(){this._system.scaleToWidth(this._system.width),this._system.finalizeSystem()}}class Oo extends Mn{constructor(){super(...arguments),this._systems=[],this._allMasterBarRenderers=[],this._barsFromPreviousSystem=[]}get name(){return"PageView"}doLayoutAndRender(){switch(this.renderer.settings.display.systemsLayoutMode){case e.SystemsLayoutMode.Automatic:this.systemsLayoutMode=is.Automatic;break;case e.SystemsLayoutMode.UseModelLayout:this.systemsLayoutMode=is.FromModelWithScale}let t=this.pagePadding[1];this.width=this.renderer.width,this._allMasterBarRenderers=[],t=this.layoutAndRenderScoreInfo(t,-1),t=this.layoutAndRenderTunings(t,-1),t=this.layoutAndRenderChordDiagrams(t,-1),t=this.layoutAndRenderScore(t),t=this.layoutAndRenderBottomScoreInfo(t),t=this.layoutAndRenderAnnotation(t),this.height=(t+this.pagePadding[3])*this.renderer.settings.display.scale}get supportsResize(){return!0}get firstBarX(){let e=this.pagePadding[0];return this._systems.length>0&&(e+=this._systems[0].accoladeWidth),e}doResize(){let e=this.pagePadding[1];this.width=this.renderer.width;const t=this.height;e=this.layoutAndRenderScoreInfo(e,t),e=this.layoutAndRenderTunings(e,t),e=this.layoutAndRenderChordDiagrams(e,t),e=this.resizeAndRenderScore(e,t),e=this.layoutAndRenderBottomScoreInfo(e),e=this.layoutAndRenderAnnotation(e),this.height=(e+this.pagePadding[3])*this.renderer.settings.display.scale}layoutAndRenderTunings(e,t=-1){if(!this.tuningGlyph)return e;const s=this.renderer.settings.display.resources;this.tuningGlyph.x=this.pagePadding[0],this.tuningGlyph.width=this.scaledWidth,this.tuningGlyph.doLayout();const i=Math.round(this.tuningGlyph.height),a=new er;return a.x=0,a.y=e,a.width=this.scaledWidth,a.height=i,a.totalWidth=this.scaledWidth,a.totalHeight=t<0?e+a.height:t,this.registerPartial(a,(e=>{e.color=s.scoreInfoColor,e.textAlign=oe.Center,this.tuningGlyph.paint(0,0,e)})),e+i}layoutAndRenderChordDiagrams(e,t=-1){if(!this.chordDiagrams)return e;const s=this.renderer.settings.display.resources;this.chordDiagrams.width=this.scaledWidth,this.chordDiagrams.doLayout();const i=Math.round(this.chordDiagrams.height),a=new er;return a.x=0,a.y=e,a.width=this.scaledWidth,a.height=i,a.totalWidth=this.scaledWidth,a.totalHeight=t<0?e+i:t,this.registerPartial(a,(e=>{e.color=s.scoreInfoColor,e.textAlign=oe.Center,this.chordDiagrams.paint(0,0,e)})),e+i}layoutAndRenderScoreInfo(e,t=-1){j.debug(this.name,"Layouting score info");const s=new er;s.x=0,s.y=e;let i=0;const a=this.renderer.settings.display.resources,r=[];for(const[e,t]of Mn.HeaderElements.value)if(this.headerGlyphs.has(e)){const t=this.headerGlyphs.get(e);t.y=i,this.alignScoreInfoGlyph(t);let s=t.font.size;if(e===Se.Words&&this.headerGlyphs.has(Se.Music)){this.headerGlyphs.get(Se.Music).textAlign!==t.textAlign&&(s=0)}i+=s,r.push(t)}return r.length>0&&(i=Math.floor(i+17),s.width=this.scaledWidth,s.height=i,s.totalWidth=this.scaledWidth,s.totalHeight=t<0?e+s.height:t,this.registerPartial(s,(e=>{e.color=a.scoreInfoColor,e.textAlign=oe.Center;for(const t of r)t.paint(0,0,e)}))),e+i}resizeAndRenderScore(e,t){if(this.renderer.settings.display.barsPerRow>0||this.systemsLayoutMode===is.FromModelWithScale)for(let s=0;s<this._systems.length;s++){const i=this._systems[s];this.fitSystem(i),e+=this.paintSystem(i,t)}else{this._systems=[];let s=0;const i=this.maxWidth;let a=this.createEmptyStaffSystem();for(a.index=this._systems.length,a.x=this.pagePadding[0],a.y=e;s<this._allMasterBarRenderers.length;){let r=this._allMasterBarRenderers[s];if(a.width+r.width<=i||0===a.masterBarsRenderers.length)a.addMasterBarRenderers(this.renderer.tracks,r),s++;else{for(;r&&!r.canWrap&&a.masterBarsRenderers.length>1;)r=a.revertLastBar(),s--;a.isFull=!0,a.isLast=this.lastBarIndex===a.lastBarIndex,this._systems.push(a),this.fitSystem(a),e+=this.paintSystem(a,t),a=this.createEmptyStaffSystem(),a.index=this._systems.length,a.x=this.pagePadding[0],a.y=e}}a.isLast=this.lastBarIndex===a.lastBarIndex,this.fitSystem(a),e+=this.paintSystem(a,t)}return e}layoutAndRenderScore(e){let t=this.firstBarIndex;const s=this.lastBarIndex;for(this._systems=[];t<=s;){const i=this.createStaffSystem(t,s);this._systems.push(i),i.x=this.pagePadding[0],i.y=e,t=i.lastBarIndex+1,this.fitSystem(i),j.debug(this.name,`Rendering partial from bar ${i.firstBarIndex} to ${i.lastBarIndex}`,null),e+=this.paintSystem(i,e)}return e}paintSystem(e,t){const s=Math.floor(e.height),i=new er;return i.x=0,i.y=e.y,i.totalWidth=this.scaledWidth,i.totalHeight=t,i.width=this.scaledWidth,i.height=s,i.firstMasterBarIndex=e.firstBarIndex,i.lastMasterBarIndex=e.lastBarIndex,e.buildBoundingsLookup(0,0),this.registerPartial(i,(t=>{this.renderer.canvas.color=this.renderer.settings.display.resources.mainGlyphColor,this.renderer.canvas.textAlign=oe.Left,e.paint(0,-i.y/this.renderer.settings.display.scale,t)})),s}fitSystem(e){e.isFull||e.width>this.maxWidth||this.renderer.settings.display.justifyLastSystem?e.scaleToWidth(this.maxWidth):e.scaleToWidth(e.width),e.finalizeSystem()}getBarsPerSystem(e){let t=this.renderer.settings.display.barsPerRow;if(this.systemsLayoutMode===is.FromModelWithScale){let s,i;this.renderer.tracks.length>1?(s=this.renderer.score.defaultSystemsLayout,i=this.renderer.score.systemsLayout):(s=this.renderer.tracks[0].defaultSystemsLayout,i=this.renderer.tracks[0].systemsLayout),t=e<i.length?i[e]:s}return t}createStaffSystem(e,t){const s=this.createEmptyStaffSystem();s.index=this._systems.length;const i=this.getBarsPerSystem(s.index),a=this.maxWidth,r=t+1;let n=e;for(;n<r;){if(this._barsFromPreviousSystem.length>0)for(const e of this._barsFromPreviousSystem)s.addMasterBarRenderers(this.renderer.tracks,e),n=e.lastMasterBarIndex;else{const e=this.multiBarRestInfo,t=null!==e&&e.has(n)?e.get(n):null,i=s.addBars(this.renderer.tracks,n,t);this._allMasterBarRenderers.push(i),n=i.lastMasterBarIndex}this._barsFromPreviousSystem=[];let e=!1;if((-1===i&&s.width>=a&&0!==s.masterBarsRenderers.length||s.masterBarsRenderers.length===i+1)&&(e=!0),e){let e=s.revertLastBar();if(e)for(this._barsFromPreviousSystem.push(e);e&&!e.canWrap&&s.masterBarsRenderers.length>1;)e=s.revertLastBar(),e&&this._barsFromPreviousSystem.push(e);return s.isFull=!0,s.isLast=!1,this._barsFromPreviousSystem.reverse(),s}let t=!1,r=!0;for(const e of this.renderer.tracks)e.lineBreaks&&e.lineBreaks.has(n+1)?t=!0:r=!1;if(t&&r)return s.isFull=!0,s.isLast=!1,s;s.x=0,n++}return s.isLast=t===s.lastBarIndex,s}get maxWidth(){return this.scaledWidth-this.pagePadding[0]-this.pagePadding[2]}}class Ho extends vr{constructor(e,t,s,i){super(e,t,i,Ho.getMusicSymbol(s))}static getMusicSymbol(e){switch(e){case It.Natural:return ne.AccidentalNatural;case It.Sharp:return ne.AccidentalSharp;case It.Flat:return ne.AccidentalFlat;case It.NaturalQuarterNoteUp:return ne.AccidentalQuarterToneNaturalArrowUp;case It.SharpQuarterNoteUp:return ne.AccidentalQuarterToneSharpArrowUp;case It.FlatQuarterNoteUp:return ne.AccidentalQuarterToneFlatArrowUp;case It.DoubleSharp:return ne.AccidentalDoubleSharp;case It.DoubleFlat:return ne.AccidentalDoubleFlat}return ne.None}}class Wo extends vr{constructor(e,t,s,i){super(e,t,1,Wo.getSymbol(s)),this._clef=s,this._clefOttava=i}static getSymbol(e){switch(e){case o.Neutral:return ne.UnpitchedPercussionClef1;case o.C3:case o.C4:return ne.CClef;case o.F4:return ne.FClef;case o.G2:return ne.GClef;default:return ne.None}}paint(e,t,s){const i=nn.bar(s,p.StandardNotationClef,this.renderer.bar);try{let i;super.paint(e,t,s);let a=!1;switch(this._clefOttava){case h._15ma:i=new vr(-4,0,.5,ne.Quindicesima),a=!0;break;case h._8va:i=new vr(-2,0,.5,ne.Ottava),a=!0;break;case h._8vb:i=new vr(-6,0,.5,ne.Ottava);break;case h._15mb:i=new vr(-8,0,.5,ne.Quindicesima);break;default:return}let r=0,n=0;switch(this._clef){case o.Neutral:r=a?-12:15,n=0;break;case o.C3:case o.C4:r=a?-19:27,n=0;break;case o.F4:r=a?-9:27,n=-4;break;case o.G2:r=a?-37:30,n=0;break;default:return}i.renderer=this.renderer,i.doLayout();const l=this.width/2;i.paint(e+this.x+l+n,t+this.y+r,s)}finally{i?.[Symbol.dispose]?.()}}}class Vo extends Nr{constructor(e,t,s){super(e,t),this._note=s}static getSymbol(e,t){switch(e){case k.None:return ne.None;case k.Normal:return t?ne.ArticAccentAbove:ne.ArticAccentBelow;case k.Heavy:return t?ne.ArticMarcatoAbove:ne.ArticMarcatoBelow;case k.Tenuto:return t?ne.ArticTenutoAbove:ne.ArticTenutoBelow;default:return ne.None}}doLayout(){this.width=xr.Widths.get(ne.ArticAccentAbove),this.height=xr.Heights.get(ne.ArticAccentAbove)}paint(e,t,s){const i=this.renderer.getBeatDirection(this._note.beat),a=Vo.getSymbol(this._note.accentuated,i===Ne.Down),r=i===Ne.Up?t+this.y:t+this.y+this.height-2;s.fillMusicFontSymbol(e+this.x-2,r,1,a,!1)}}class Go extends Tr{constructor(e,t,s){super(e,t),this._size=0,this._size=s}doLayout(){this.width=this._size+3}paint(e,t,s){const i=s.color;this.colorOverride&&(s.color=this.colorOverride),s.fillCircle(e+this.x,t+this.y,this._size),s.color=i}}class zo extends vr{constructor(e,t,s){super(e,t,s?Pr.GraceScale:1,ne.NoteheadXOrnate)}}class Uo extends vr{constructor(e,t,s,i){super(e,t,i?Pr.GraceScale:1,Uo.getSymbol(s))}static getSymbol(e){switch(e){case w.QuadrupleWhole:case w.DoubleWhole:case w.Whole:case w.Half:return ne.NoteheadDiamondWhiteWide;default:return ne.NoteheadDiamondBlackWide}}}class Xo extends Tr{constructor(e,t,s){super(0,0),this.yOffset=0,this.startNoteRenderer=null,this.endNoteRenderer=null,this.tieDirection=Ne.Up,this._startX=0,this._startY=0,this._endX=0,this._endY=0,this._tieHeight=0,this._shouldDraw=!1,this.startBeat=e,this.endBeat=t,this.forEnd=s}doLayout(){if(this.width=0,!this.endBeat)return void(this._shouldDraw=!1);const e=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,this.startBeat.voice.bar);this.startNoteRenderer=e;const t=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,this.endBeat.voice.bar);if(this.endNoteRenderer=t,this._startX=0,this._endX=0,this._startY=0,this._endY=0,this.height=0,this._shouldDraw=!1,this.tieDirection=e?this.getBeamDirection(this.startBeat,e):this.getBeamDirection(this.endBeat,t),!this.forEnd&&e?(e!==t?(this._startX=e.x+this.getStartX(),this._startY=e.y+this.getStartY()+this.yOffset,t&&e.staff===t.staff?(this._endX=t.x+this.getEndX(),this._endY=t.y+this.getEndY()+this.yOffset):(this._endX=e.x+e.width,this._endY=this._startY)):(this._startX=e.x+this.getStartX(),this._endX=t.x+this.getEndX(),this._startY=e.y+this.getStartY()+this.yOffset,this._endY=t.y+this.getEndY()+this.yOffset),this._shouldDraw=!0):e&&e.staff===t.staff||(this._startX=t.x,this._endX=t.x+this.getEndX(),this._startY=t.y+this.getEndY()+this.yOffset,this._endY=this._startY,this._shouldDraw=!0),this._shouldDraw)if(this.y=Math.min(this._startY,this._endY),this.shouldDrawBendSlur())this._tieHeight=0;else{this._tieHeight=this.getTieHeight(this._startX,this._startY,this._endX,this._endY);const e=Xo.calculateActualTieHeight(1,this._startX,this._startY,this._endX,this._endY,this.tieDirection===Ne.Down,this._tieHeight,4);if(this.height=e.h,this.tieDirection===Ne.Up){const t=this.y-e.y;t>0&&(this.y-=t)}}}paint(e,t,s){this._shouldDraw&&(this.shouldDrawBendSlur()?Xo.drawBendSlur(s,e+this._startX,t+this._startY,e+this._endX,t+this._endY,this.tieDirection===Ne.Down,1):Xo.paintTie(s,1,e+this._startX,t+this._startY,e+this._endX,t+this._endY,this.tieDirection===Ne.Down,this._tieHeight,4))}shouldDrawBendSlur(){return!1}getTieHeight(e,t,s,i){return 22}getBeamDirection(e,t){return Ne.Down}getStartY(){return 0}getEndY(){return 0}getStartX(){return 0}getEndX(){return 0}static calculateActualTieHeight(e,t,s,i,a,r,n,o){const h=Xo.computeBezierControlPoints(e,t,s,i,a,r,n,o);t=h[0],s=h[1];const l=h[2],c=h[3];i=h[6],a=h[7];const d=(t-l)/(t-2*l+i),u=Xo.calculateExtrema(t,s,l,c,i,a,d),p=u.length>0?Math.min(t,i,u[0]):Math.min(t,i),g=u.length>0?Math.max(t,i,u[0]):Math.max(t,i),m=(s-c)/(s-2*c+a),f=Xo.calculateExtrema(t,s,l,c,i,a,m),y=f.length>0?Math.min(s,a,f[1]):Math.min(s,a),b=f.length>0?Math.max(s,a,f[1]):Math.max(s,a),S=new ft;return S.x=p,S.y=y,S.w=g-p,S.h=b-y,S}static calculateExtrema(e,t,s,i,a,r,n){if(n<=0||1<=n)return[];const o=e+(s-e)*n,h=t+(i-t)*n;return[o+(s+(a-s)*n-o)*n,h+(i+(r-i)*n-h)*n]}static computeBezierControlPoints(e,t,s,i,a,r,n,o){if(t===i&&s===a)return[];if(i<t){let e=t;t=i,i=e,e=s,s=a,a=e}n*=e,o*=e;let h=a-s,l=i-t;const c=Math.sqrt(h*h+l*l);r?h*=-1:l*=-1,h/=c,l/=c;const d=(i+t)/2,u=(a+s)/2;return[t,s,d+n*h,u+n*l,d+(n-o)*h,u+(n-o)*l,i,a]}static paintTie(e,t,s,i,a,r,n=!1,o=22,h=4){const l=Xo.computeBezierControlPoints(t,s,i,a,r,n,o,h);e.beginPath(),e.moveTo(l[0],l[1]),e.quadraticCurveTo(l[2],l[3],l[6],l[7]),e.quadraticCurveTo(l[4],l[5],l[0],l[1]),e.closePath(),e.fill()}static drawBendSlur(e,t,s,i,a,r,n,o){let h=a-s,l=i-t;const c=Math.sqrt(h*h+l*l);r?h*=-1:l*=-1,h/=c,l/=c;const d=(i+t)/2,u=(a+s)/2;let p=Xo.BendSlurHeight*n;i-t<20&&(p/=2);const g=d+p*h,m=u+p*l;if(e.beginPath(),e.moveTo(t,s),e.lineTo(g,m),e.lineTo(i,a),e.stroke(),o){const t=e.measureText(o).width,s=r?0:-e.font.size;e.fillText(o,g-t/2,m+s)}}}Xo.BendSlurHeight=11;class Jo extends Tr{constructor(e){super(0,0),this._isOpen=e}doLayout(){super.doLayout(),this.width=Jo.Size}paint(e,t,s){const i=s.color;this.colorOverride&&(s.color=this.colorOverride),this._isOpen?Xo.paintTie(s,1,e+this.x+this.width,t+this.y+this.height,e+this.x+this.width,t+this.y,!1,6,3):Xo.paintTie(s,1,e+this.x,t+this.y,e+this.x,t+this.y+this.height,!1,6,3),s.color=i}}Jo.Size=6;class Yo{constructor(e,t,s){this.line=0,this.line=e,this.isGhost=t,this.color=s}}class $o extends Tr{constructor(e){super(0,0),this._infos=[],this._glyphs=[],this.isEmpty=!0,this._isOpen=e}addParenthesis(t){const s=this.renderer,i=s.getNoteLine(t),a=t.isGhost||this.isTiedBend(t)&&s.settings.notation.isNotationElementVisible(e.NotationElement.ParenthesisOnTiedBends),r=nn.noteColor(s.resources,ce.Effects,t);this.add(new Yo(i,a,r))}addParenthesisOnLine(e,t){const s=new Yo(e,t,void 0);this.add(s)}add(e){this._infos.push(e),e.isGhost&&(this.isEmpty=!1)}isTiedBend(e){return!!e.isTieDestination&&(!!e.tieOrigin.hasBend||this.isTiedBend(e.tieOrigin))}doLayout(){const e=this.renderer;this._infos.sort(((e,t)=>e.line-t.line));let t=null;const s=e.getScoreHeight(1);for(let i=0,a=this._infos.length;i<a;i++){let a;if(this._infos[i].isGhost)if(t){const a=e.getScoreY(this._infos[i].line)+s;t.height=a-t.y}else a=new Jo(this._isOpen),a.colorOverride=this._infos[i].color,a.renderer=this.renderer,a.y=e.getScoreY(this._infos[i].line)-s,a.height=2*s,a.doLayout(),this._glyphs.push(a),t=a;else t=null}this.width=this._glyphs.length>0?this._glyphs[0].width:0}paint(e,t,s){super.paint(e,t,s);for(const i of this._glyphs)i.paint(e+this.x,t+this.y,s)}}class qo{constructor(e,t){this.steps=0,this.glyph=e,this.steps=t}}class jo extends Tr{constructor(){super(0,0),this._infos=[],this._noteHeadPadding=0,this.minNote=null,this.maxNote=null,this.spacingChanged=new Zi,this.upLineX=0,this.downLineX=0,this.displacedX=0,this.noteStartX=0}add(e,t){const s=new qo(e,t);this._infos.push(s),(!this.minNote||this.minNote.steps>s.steps)&&(this.minNote=s),(!this.maxNote||this.maxNote.steps<s.steps)&&(this.maxNote=s)}doLayout(){this._infos.sort(((e,t)=>t.steps-e.steps));let e=0,t=!1,s=0,i=!1;const a=this.direction;let r=0;for(let n=0,o=this._infos.length;n<o;n++){const o=this._infos[n].glyph;o.renderer=this.renderer,o.doLayout();let h=!1;0===n?e=o.width:Math.abs(s-this._infos[n].steps)<=1?t?t=!1:(h=!0,o.x=e,i=!0,t=!0):t=!1,a===Ne.Down?o.x=h?0:e:o.x=h?e:0,o.x+=this.noteStartX,s=this._infos[n].steps,r=Math.max(r,o.x+o.width),o instanceof Pr&&o.centerOnStem&&(o.x=e)}i?(this._noteHeadPadding=0,this.upLineX=e,this.downLineX=e):(this._noteHeadPadding=a===Ne.Down?-e:0,r+=this._noteHeadPadding,this.upLineX=r,this.downLineX=0),this.displacedX=e,this.width=r}paint(e,t,s){e+=this.x,t+=this.y,this.paintLedgerLines(e,t,s);const i=this._infos,a=e+this._noteHeadPadding;for(const e of i)e.glyph.renderer=this.renderer,e.glyph.paint(a,t,s)}paintLedgerLines(e,t,s){if(!this.minNote)return;const i=this.renderer,a=nn.bar(s,p.StandardNotationStaffLine,i.bar,!0);try{const a=3,r=this.width-this.noteStartX+2*a,n=i.getLineHeight(1),o=i.getLineY(-1),h=i.getLineY(i.drawnLineCount),l=i.getLineY(this.minNote.steps/2),c=i.getLineY(this.maxNote.steps/2);let d=o;for(;d>=l;)s.fillRect(e-a+this.noteStartX,t+d|0,r,Hn.StaffLineThickness),d-=n;for(d=h;d<=c;)s.fillRect(e-a+this.noteStartX,t+d|0,r,Hn.StaffLineThickness),d+=n}finally{a?.[Symbol.dispose]?.()}}}class Ko extends vr{constructor(e,t,s){super(e,t,1,Ko.getSymbol(s))}static getSymbol(e){switch(e){case w.ThirtySecond:return ne.Tremolo3;case w.Sixteenth:return ne.Tremolo2;case w.Eighth:return ne.Tremolo1;default:return ne.None}}}class Qo extends Tr{constructor(){super(0,0)}doLayout(){this.width=26}paint(e,t,s){const i=this.renderer,a=i.getLineHeight(i.heightLineCount-1),r=i.getLineY(0)+i.getLineHeight(i.drawnLineCount-1)/2-a/2,n=s.lineWidth;s.lineWidth=2,s.moveTo(e+this.x,t+r),s.lineTo(e+this.x+this.width,t+r+a),s.moveTo(e+this.x,t+r+a),s.lineTo(e+this.x+this.width,t+r),s.stroke(),s.lineWidth=n}}class Zo extends jo{constructor(){super(...arguments),this._noteGlyphLookup=new Map,this._notes=[],this._deadSlapped=null,this._tremoloPicking=null,this.aboveBeatEffects=new Map,this.belowBeatEffects=new Map}get direction(){return this.beamingHelper.direction}getNoteX(e,t){if(this._noteGlyphLookup.has(e.id)){const s=this._noteGlyphLookup.get(e.id);let i=this.x+s.x+this._noteHeadPadding;switch(t){case rs.Left:break;case rs.Center:i+=s.width/2;break;case rs.Right:i+=s.width}return i}return 0}getNoteY(e,t){if(this._noteGlyphLookup.has(e.id)){const s=this._noteGlyphLookup.get(e.id);let i=this.y+s.y;switch(t){case as.TopWithStem:i-=this.renderer.getStemSize(this.beamingHelper);break;case as.Top:i-=s.height/2;break;case as.Center:break;case as.Bottom:i+=s.height/2;break;case as.BottomWithStem:i+=this.renderer.getStemSize(this.beamingHelper)}return i}return 0}addNoteGlyph(e,t,s){super.add(e,s),this._noteGlyphLookup.set(t.id,e),this._notes.push(t)}updateBeamingHelper(e){this.beamingHelper&&this.beamingHelper.registerBeatLineX("score",this.beat,e+this.x+this.upLineX,e+this.x+this.downLineX)}doLayout(){super.doLayout();const e=this.renderer;this.beat.deadSlapped&&(this._deadSlapped=new Qo,this._deadSlapped.renderer=this.renderer,this._deadSlapped.doLayout(),this.width=this._deadSlapped.width);const t=this.direction;let s=0,i=0,a=1,r=-a,n=!1,o=!1;this.beat.deadSlapped?(i=e.getScoreY(0),s=e.getScoreY(e.heightLineCount)):this.direction===Ne.Up?(n=!1,o=!0,i=e.getScoreY(this.maxNote.steps+2),s=e.getScoreY(this.minNote.steps)-e.getStemSize(this.beamingHelper,!0)):(n=!0,o=!1,i=e.getScoreY(this.minNote.steps-1),a*=-1,r*=-1,s=e.getScoreY(this.maxNote.steps)+e.getStemSize(this.beamingHelper,!0));let h=null,l=null;for(const e of this.aboveBeatEffects.values())e.renderer=this.renderer,e.doLayout(),o&&(s+=r*e.height),e.y=s,(null===h||h>s)&&(h=s),(null===l||l<s)&&(l=s),o||(s+=r*e.height);for(const e of this.belowBeatEffects.values())e.renderer=this.renderer,e.doLayout(),n&&(i+=a*e.height),e.y=i,(null===h||h>i)&&(h=i),(null===l||l<i)&&(l=i),n||(i+=a*e.height);if(null!==h&&e.registerBeatEffectOverflows(h,l??0),this.beat.isTremolo&&!this.beat.deadSlapped){let e=0;const s=t===Ne.Up?this.minNote:this.maxNote;let i=t===Ne.Up?this.upLineX:this.downLineX;const a=this.beat.tremoloSpeed;switch(a){case w.ThirtySecond:e=t===Ne.Up?-15:15;break;case w.Sixteenth:e=t===Ne.Up?-12:15;break;case w.Eighth:e=t===Ne.Up?-10:10;break;default:e=t===Ne.Up?-10:15}this.beat.duration<w.Half&&(i=this.width/2),this._tremoloPicking=new Ko(i,s.glyph.y+e,a),this._tremoloPicking.renderer=this.renderer,this._tremoloPicking.doLayout()}}buildBoundingsLookup(e,t,s){for(const i of this._notes)if(this._noteGlyphLookup.has(i.id)){const a=this._noteGlyphLookup.get(i.id),r=new ar;r.note=i,r.noteHeadBounds=new ft,r.noteHeadBounds.x=t+this.x+this._noteHeadPadding+a.x,r.noteHeadBounds.y=s+this.y+a.y-a.height/2,r.noteHeadBounds.w=a.width,r.noteHeadBounds.h=a.height,e.addNote(r)}}paint(e,t,s){this.paintEffects(e,t,s),super.paint(e,t,s)}paintEffects(e,t,s){const i=nn.beat(s,be.StandardNotationEffects,this.beat);try{for(const i of this.aboveBeatEffects.values())i.paint(e+this.x+2,t+this.y,s);for(const i of this.belowBeatEffects.values())i.paint(e+this.x+2,t+this.y,s);this._tremoloPicking&&this._tremoloPicking.paint(e,t,s),this._deadSlapped&&this._deadSlapped.paint(e,t,s)}finally{i?.[Symbol.dispose]?.()}}}class eh extends vr{constructor(e,t,s){super(e,t,1,eh.getSymbol(s))}static getSymbol(e){switch(e){case w.QuadrupleWhole:return ne.RestLonga;case w.DoubleWhole:return ne.RestDoubleWhole;case w.Whole:return ne.RestWhole;case w.Half:return ne.RestHalf;case w.Quarter:return ne.RestQuarter;case w.Eighth:return ne.RestEighth;case w.Sixteenth:return ne.RestSixteenth;case w.ThirtySecond:return ne.RestThirtySecond;case w.SixtyFourth:return ne.RestSixtyFourth;case w.OneHundredTwentyEighth:return ne.RestOneHundredTwentyEighth;case w.TwoHundredFiftySixth:return ne.RestTwoHundredFiftySixth;default:return ne.None}}updateBeamingHelper(e){this.beamingHelper&&this.beamingHelper.registerBeatLineX("score",this.beat,e+this.x+this.width/2,e+this.x+this.width/2)}paint(e,t,s){this.internalPaint(e,t,s,be.StandardNotationRests)}internalPaint(e,t,s,i){const a=nn.beat(s,i,this.beat);try{super.paint(e,t,s)}finally{a?.[Symbol.dispose]?.()}}}class th{constructor(){this.x=0,this.y=-3e3,this.width=0}}class sh extends an{constructor(){super(0,0)}doLayout(){if(!this.glyphs||0===this.glyphs.length)return void(this.width=0);this.glyphs.sort(((e,t)=>e.y<t.y?-1:e.y>t.y?1:0));const e=[];e.push(new th);for(let t=0,s=this.glyphs.length;t<s;t++){const s=this.glyphs[t];s.renderer=this.renderer,s.doLayout();let i=0;for(;e[i].y>s.y;)i++,i===e.length&&e.push(new th);s.x=i,e[i].y=s.y+21,e[i].width<s.width&&(e[i].width=s.width)}this.width=0;for(const t of e)this.width+=t.width,t.x=this.width;for(let t=0,s=this.glyphs.length;t<s;t++){const s=this.glyphs[t],i=e[s.x];s.x=this.width-i.x}}}class ih extends jo{get direction(){return Ne.Up}constructor(e,t=!1){super(),this._showParenthesis=!1,this._noteValueLookup=new Map,this._accidentals=new sh,this._preNoteParenthesis=null,this._postNoteParenthesis=null,this.isEmpty=!0,this.noteHeadOffset=0,this._beat=e,this._showParenthesis=t,t&&(this._preNoteParenthesis=new $o(!0),this._postNoteParenthesis=new $o(!1))}containsNoteValue(e){return this._noteValueLookup.has(e)}getNoteValueY(e){return this._noteValueLookup.has(e)?this.y+this._noteValueLookup.get(e).y:0}addGlyph(e,t,s){const i=this.renderer,a=new Pr(0,0,w.Quarter,!0),r=i.accidentalHelper.applyAccidentalForValue(this._beat,e,t,!0),n=i.accidentalHelper.getNoteLineForValue(e,!1);if(a.y=i.getScoreY(n),this._showParenthesis&&(this._preNoteParenthesis.renderer=this.renderer,this._postNoteParenthesis.renderer=this.renderer,this._preNoteParenthesis.addParenthesisOnLine(n,!0),this._postNoteParenthesis.addParenthesisOnLine(n,!0)),r!==It.None){const e=new Ho(0,a.y,r,Pr.GraceScale);e.renderer=this.renderer,this._accidentals.renderer=this.renderer,this._accidentals.addGlyph(e)}this._noteValueLookup.set(e,a),this.add(a,n),this.isEmpty=!1}doLayout(){let e=0;this._showParenthesis&&(this._preNoteParenthesis.x=e,this._preNoteParenthesis.renderer=this.renderer,this._preNoteParenthesis.doLayout(),e+=this._preNoteParenthesis.width+ih.ElementPadding),this._accidentals.isEmpty||(e+=this._accidentals.width+ih.ElementPadding,this._accidentals.x=e,this._accidentals.renderer=this.renderer,this._accidentals.doLayout(),e+=this._accidentals.width+ih.ElementPadding),this.noteStartX=e,super.doLayout(),this.noteHeadOffset=this.noteStartX+(this.width-this.noteStartX)/2,this._showParenthesis&&(this._postNoteParenthesis.x=this.width+ih.ElementPadding,this._postNoteParenthesis.renderer=this.renderer,this._postNoteParenthesis.doLayout(),this.width+=this._postNoteParenthesis.width+ih.ElementPadding)}paint(e,t,s){this._accidentals.isEmpty||this._accidentals.paint(e+this.x,t+this.y,s),this._showParenthesis&&(this._preNoteParenthesis.paint(e+this.x,t+this.y,s),this._postNoteParenthesis.paint(e+this.x,t+this.y,s)),super.paint(e,t,s)}}ih.ElementPadding=2;class ah extends Tr{constructor(){super(...arguments),this.BendNoteHeads=[]}drawBendSlur(e,t,s,i,a,r,n,o){Xo.drawBendSlur(e,t,s,i,a,r,n,o)}doLayout(){super.doLayout(),this.width=0;for(const e of this.BendNoteHeads)e.doLayout(),this.width+=e.width+10}getTieDirection(e,t){return t.getBeatDirection(e)===Ne.Up?Ne.Down:Ne.Up}}ah.EndPadding=8;class rh extends J{constructor(e=0,t=0){super(e,t),this.lineValue=0,this.lineValue=t}}class nh extends Tr{constructor(){super(0,0),this._notes=[],this._renderPoints=new Map,this._preBendMinValue=-1,this._bendMiddleMinValue=-1,this._bendEndMinValue=-1,this._bendEndContinuedMinValue=-1,this._releaseMinValue=-1,this._releaseContinuedMinValue=-1,this._maxBendValue=-1}addBends(e){this._notes.push(e);const t=this.createRenderingPoints(e);this._renderPoints.set(e.id,t),(-1===this._maxBendValue||this._maxBendValue<e.maxBendPoint.value)&&(this._maxBendValue=e.maxBendPoint.value);let s=0;switch(e.bendType){case b.Bend:s=t[1].value,e.isTieOrigin?(-1===this._bendEndContinuedMinValue||s<this._bendEndContinuedMinValue)&&(this._bendEndContinuedMinValue=s):(-1===this._bendEndMinValue||s<this._bendEndMinValue)&&(this._bendEndMinValue=s);break;case b.Release:s=t[1].value,e.isTieOrigin?(-1===this._releaseContinuedMinValue||s<this._releaseContinuedMinValue)&&(this._releaseContinuedMinValue=s):s>0&&(-1===this._releaseMinValue||s<this._releaseMinValue)&&(this._releaseMinValue=s);break;case b.BendRelease:s=t[1].value,(-1===this._bendMiddleMinValue||s<this._bendMiddleMinValue)&&(this._bendMiddleMinValue=s),s=t[2].value,e.isTieOrigin?(-1===this._releaseContinuedMinValue||s<this._releaseContinuedMinValue)&&(this._releaseContinuedMinValue=s):s>0&&(-1===this._releaseMinValue||s<this._releaseMinValue)&&(this._releaseMinValue=s);break;case b.Prebend:s=t[0].value,(-1===this._preBendMinValue||s<this._preBendMinValue)&&(this._preBendMinValue=s);break;case b.PrebendBend:s=t[0].value,(-1===this._preBendMinValue||s<this._preBendMinValue)&&(this._preBendMinValue=s),s=t[1].value,e.isTieOrigin?(-1===this._bendEndContinuedMinValue||s<this._bendEndContinuedMinValue)&&(this._bendEndContinuedMinValue=s):(-1===this._bendEndMinValue||s<this._bendEndMinValue)&&(this._bendEndMinValue=s);break;case b.PrebendRelease:s=t[0].value,(-1===this._preBendMinValue||s<this._preBendMinValue)&&(this._preBendMinValue=s),s=t[1].value,e.isTieOrigin?(-1===this._releaseContinuedMinValue||s<this._releaseContinuedMinValue)&&(this._releaseContinuedMinValue=s):s>0&&(-1===this._releaseMinValue||s<this._releaseMinValue)&&(this._releaseMinValue=s)}}doLayout(){super.doLayout();const e=this._maxBendValue*nh.BendValueHeight;this.renderer.registerOverflowTop(e);let t=0;for(const e of this._notes){const s=this._renderPoints.get(e.id);switch(e.bendType){case b.Bend:s[1].lineValue=e.isTieOrigin?this._bendEndContinuedMinValue:this._bendEndMinValue;break;case b.Release:t=e.isTieOrigin?this._releaseContinuedMinValue:this._releaseMinValue,t>=0&&(s[1].lineValue=t);break;case b.BendRelease:s[1].lineValue=this._bendMiddleMinValue,t=e.isTieOrigin?this._releaseContinuedMinValue:this._releaseMinValue,t>=0&&(s[2].lineValue=t);break;case b.Prebend:s[0].lineValue=this._preBendMinValue;break;case b.PrebendBend:s[0].lineValue=this._preBendMinValue,s[1].lineValue=e.isTieOrigin?this._bendEndContinuedMinValue:this._bendEndMinValue;break;case b.PrebendRelease:s[0].lineValue=this._preBendMinValue,t=e.isTieOrigin?this._releaseContinuedMinValue:this._releaseMinValue,t>=0&&(s[1].lineValue=t)}}this.width=0,this._notes.sort(((e,t)=>e.isStringed?e.string-t.string:e.realValue-t.realValue))}createRenderingPoints(e){const t=[];switch(e.bendType){case b.Custom:for(const s of e.bendPoints)t.push(new rh(s.offset,s.value));break;case b.BendRelease:t.push(new rh(0,e.bendPoints[0].value)),t.push(new rh(J.MaxPosition/2|0,e.bendPoints[1].value)),t.push(new rh(J.MaxPosition,e.bendPoints[3].value));break;case b.Bend:case b.Hold:case b.Prebend:case b.PrebendBend:case b.PrebendRelease:case b.Release:t.push(new rh(0,e.bendPoints[0].value)),t.push(new rh(J.MaxPosition,e.bendPoints[1].value))}return t}paint(e,t,s){const i=s.color;this._notes.length>1&&(s.color=this.renderer.resources.secondaryGlyphColor);for(const a of this._notes){const r=this._renderPoints.get(a.id),n=this.renderer;let o=a,h=!1,l=null,c=!1;const d=a.bendStyle===y.Gradual?"grad.":"";let u=null;for(;o.isTieOrigin;){const e=o.tieDestination;if(l=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,e.beat.voice.bar),!l||n.staff!==l.staff)break;if(o=e,h=!0,o.hasBend||!this.renderer.settings.notation.extendBendArrowsOnTiedNotes||o.vibrato!==F.None){c=!0;break}}u=o.beat,l=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,u.voice.bar),u.isLastOfVoice&&!o.hasBend&&this.renderer.settings.notation.extendBendArrowsOnTiedNotes&&(u=null);let p=0,g=0;const m=t+n.y;p=e+n.x,r[0].value>0||a.isContinuedBend?p+=n.getBeatX(a.beat,ss.MiddleNotes):p+=n.getNoteX(a,rs.Right),g=!u||u.isLastOfVoice&&!c?e+l.x+l.postBeatGlyphsStart:c||!u.nextBeat?e+l.x+l.getBeatX(u,ss.MiddleNotes):a.bendType===b.Hold?e+l.x+l.getBeatX(u.nextBeat,ss.OnNotes):e+l.x+l.getBeatX(u.nextBeat,ss.PreNotes),h||(g-=nh.ArrowSize);const f=(g-p)/J.MaxPosition;s.beginPath();for(let e=0,t=r.length-1;e<t;e++){const t=r[e];let i=r[e+1];0!==e||0===t.value||a.isTieDestination||this.paintBend(a,new rh(0,0),t,p,m,f,d,s),a.bendType!==b.Prebend?(0===e&&(p+=2),this.paintBend(a,t,i,p,m,f,d,s)):a.isTieOrigin&&a.tieDestination.hasBend&&(i=new rh(J.MaxPosition,t.value),i.lineValue=t.lineValue,this.paintBend(a,t,i,p,m,f,d,s))}if(o.vibrato!==F.None){const i=g-e+nh.ArrowSize-l.x,a=m-t-nh.BendValueHeight*r[r.length-1].lineValue,n=new ko(i,a,o.vibrato,1.2);n.beat=o.beat,n.renderer=l,n.doLayout(),n.paint(e+l.x,t,s)}s.color=i}}paintBend(e,t,s,i,a,r,n,o){const h=this.renderer,l=this.renderer.resources,c=h.lineOffset/2,d=i+r*t.offset,u=nh.BendValueHeight;let p=a-u*t.lineValue;0===t.value?s.offset===t.offset?p+=h.getNoteY(e.beat.maxStringNote,as.Top):p+=h.getNoteY(e,as.Center):p+=c;const g=i+r*s.offset;let m=a-u*s.lineValue;0===s.lineValue?m+=h.getNoteY(e,as.Center):m+=c;let f=0;const y=nh.ArrowSize;if(s.value>t.value?(m+y>p&&(m=p-y),o.beginPath(),o.moveTo(g,m),o.lineTo(g-.5*y,m+y),o.lineTo(g+.5*y,m+y),o.closePath(),o.fill(),f=y):s.value!==t.value&&(m<p&&(m=p+y),o.beginPath(),o.moveTo(g,m),o.lineTo(g-.5*y,m-y),o.lineTo(g+.5*y,m-y),o.closePath(),o.fill(),f=-y),o.beginPath(),t.value===s.value){if(t.lineValue>0){let e=g;const t=nh.DashSize,s=d+t;if((e-d)/(2*t)<1)o.moveTo(e,p),o.lineTo(d,p);else for(;e>s;)o.moveTo(e,p),o.lineTo(e-t,p),e-=2*t;o.stroke()}}else g>d?(o.moveTo(d,p),o.bezierCurveTo((d+g)/2,p,g,p,g,m+f),o.stroke()):(o.moveTo(d,p),o.lineTo(g,m),o.stroke());if(n&&t.offset<s.offset){o.font=l.graceFont;const e=o.measureText(n).width;let t=0,s=0;if(p>m){const i=Math.abs(p-m);t=i>1.3*o.font.size?p-i/2:p,s=(d+g-e)/2}else t=p,s=g-e;o.fillText(n,s,t)}if(0!==s.value&&t.value!==s.value){let e=s.value;const i=s.value>t.value;e=Math.abs(e);let r="";if(4===e)r="full",e-=4;else if(e>=4||e<=-4){const t=e/4|0;r+=t,e-=4*t}if(e>0&&(r+=nh.getFractionSign(e)),""!==r){m=a-u*s.value;let e=m;i||(e=p+1*Math.abs(m-p)/3),o.font=l.tablatureFont;const t=o.measureText(r).width,n=e-.5*l.tablatureFont.size-2,h=g-t/2;o.fillText(r,h,n)}}}static getFractionSign(e){switch(e){case 1:return"¼";case 2:return"½";case 3:return"¾";default:return`${e}/ 4`}}}nh.ArrowSize=6,nh.DashSize=3,nh.BendValueHeight=6;class oh extends Tr{constructor(e){super(0,0),this._isSimpleDip=!1,this._beat=e,this._renderPoints=this.createRenderingPoints(e)}createRenderingPoints(e){if(e.whammyBarType===de.Custom)return e.whammyBarPoints;const t=[];switch(e.whammyBarType){case de.Dive:case de.Hold:case de.PrediveDive:case de.Predive:t.push(new J(0,e.whammyBarPoints[0].value)),t.push(new J(J.MaxPosition,e.whammyBarPoints[1].value));break;case de.Dip:t.push(new J(0,e.whammyBarPoints[0].value)),t.push(new J(J.MaxPosition/2|0,e.whammyBarPoints[1].value)),t.push(new J(J.MaxPosition,e.whammyBarPoints[e.whammyBarPoints.length-1].value))}return t}doLayout(){super.doLayout(),this._isSimpleDip=this.renderer.settings.notation.notationMode===e.NotationMode.SongBook&&this._beat.whammyBarType===de.Dip;let t=null,s=null,i=this._beat;for(;i&&i.hasWhammyBar;)(!t||t.value>i.minWhammyPoint.value)&&(t=i.minWhammyPoint),(!s||s.value<i.maxWhammyPoint.value)&&(s=i.maxWhammyPoint),i=i.nextBeat;let a=s.value>0?Math.abs(this.getOffset(s.value)):0;(a>0||0!==this._beat.whammyBarPoints[0].value||this.renderer.settings.notation.isNotationElementVisible(e.NotationElement.ZerosOnDiveWhammys))&&(a+=2*this.renderer.resources.tablatureFont.size);const r=t.value<0?Math.abs(this.getOffset(t.value)):0;this.renderer.registerOverflowTop(a+r);a>this.renderer.staff.getSharedLayoutData(oh.TopOffsetSharedDataKey,-1)&&this.renderer.staff.setSharedLayoutData(oh.TopOffsetSharedDataKey,a)}getOffset(e){if(0===e)return 0;let t=oh.PerHalfSize+Math.log2(Math.abs(e)/2)*oh.PerHalfSize;return e<0&&(t=-t),t}paint(t,s,i){const a=nn.beat(i,be.StandardNotationEffects,this._beat);try{const a=this.renderer;let r=this._beat.nextBeat,n=null,o=ss.PreNotes;r&&(n=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,r.voice.bar),n&&n.staff===a.staff&&(n===a||r.hasWhammyBar)?o=!r.hasWhammyBar||a.settings.notation.notationMode===e.NotationMode.SongBook&&r.whammyBarType===de.Dip?ss.PreNotes:ss.MiddleNotes:(r=null,n=null));let h=0,l=0;this._isSimpleDip?(h=t+a.x+a.getBeatX(this._beat,ss.OnNotes)-2,l=t+a.x+a.getBeatX(this._beat,ss.PostNotes)+2):(h=t+a.x+a.getBeatX(this._beat,ss.MiddleNotes),l=n?t+n.x+n.getBeatX(r,o):t+a.x+a.width-2);const c=i.textAlign;if(i.textAlign=oe.Center,this._renderPoints.length>=2){const e=(l-h)/J.MaxPosition;i.beginPath();const t=s+this.renderer.staff.getSharedLayoutData(oh.TopOffsetSharedDataKey,0);let a=this._beat.whammyStyle===y.Gradual?"grad.":"";for(let s=0,r=this._renderPoints.length-1;s<r;s++){const n=this._renderPoints[s],o=this._renderPoints[s+1],l=s<r-2?this._renderPoints[s+2]:null;let c=0===s;0!==s||0===n.value||this._beat.isContinuedWhammy||(this.paintWhammy(!1,new J(0,0),n,o,h,t,e,i),c=!1),this.paintWhammy(c,n,o,l,h,t,e,i,a),a=""}i.stroke()}i.textAlign=c}finally{a?.[Symbol.dispose]?.()}}paintWhammy(t,s,i,a,r,n,o,h,l){const c=r+o*s.offset,d=r+o*i.offset,u=n-this.getOffset(s.value),p=n-this.getOffset(i.value);if(s.offset===i.offset){const e=oh.DashSize;if(Math.abs(p-u)/(2*e)<1)h.moveTo(c,u),h.lineTo(d,p);else{const t=Math.max(u,p);let s=Math.min(u,p);for(;t>s;)h.moveTo(c,s),h.lineTo(c,s+e),s+=2*e}h.stroke()}else if(s.value===i.value){const e=oh.DashSize;if(Math.abs(d-c)/(2*e)<1)h.moveTo(c,u),h.lineTo(d,p);else{let t=Math.max(c,d);const s=Math.min(c,d);for(;t>s;)h.moveTo(t,u),h.lineTo(t-e,u),t-=2*e}h.stroke()}else h.moveTo(c,u),h.lineTo(d,p);const g=this.renderer.resources;if(t&&!this._beat.isContinuedWhammy&&!this._isSimpleDip){let t=u;t-=g.tablatureFont.size+2,this.renderer.settings.notation.isNotationElementVisible(e.NotationElement.ZerosOnDiveWhammys)&&h.fillText("0",c,t),l&&(t-=g.tablatureFont.size+2,h.fillText(l,c,t))}let m=Math.abs(i.value);if((0!==m||this.renderer.settings.notation.isNotationElementVisible(e.NotationElement.ZerosOnDiveWhammys)&&!this._isSimpleDip)&&s.value!==i.value){let e="";if(i.value<0&&(e+="-"),m>=4){const t=m/4|0;e+=t,m-=4*t}else 0===m&&(e+="0");m>0&&(e+=nh.getFractionSign(m));let t=0;this._isSimpleDip?t=Math.min(u,p)-g.tablatureFont.size-2:(t=s.offset===i.offset?Math.min(u,p):p,t-=g.tablatureFont.size+2,a&&a.value>i.value&&(t-=2));const r=d;h.fillText(e,r,t)}}}oh.TopOffsetSharedDataKey="tab.whammy.topoffset",oh.PerHalfSize=6,oh.DashSize=3;class hh extends ah{constructor(e){super(0,0),this._beat=e}doLayout(){const t=this.renderer.settings.notation.notationMode;switch(this._beat.whammyBarType){case de.None:case de.Custom:case de.Hold:return;case de.Dive:case de.PrediveDive:{const e=new ih(this._beat,!1);e.renderer=this.renderer;const t=this._beat.whammyBarPoints[this._beat.whammyBarPoints.length-1];for(const s of this._beat.notes)s.isTieOrigin||e.addGlyph(this.getBendNoteValue(s,t),t.value%2!=0,void 0);e.doLayout(),this.BendNoteHeads.push(e)}break;case de.Dip:if(t===e.NotationMode.SongBook){const e=this.renderer.resources;this.renderer.simpleWhammyOverflow=1.5*e.tablatureFont.size+hh.SimpleDipHeight+hh.SimpleDipPadding}else{const t=new ih(this._beat,!1);if(t.renderer=this.renderer,this.renderer.settings.notation.notationMode===e.NotationMode.GuitarPro){const e=this._beat.whammyBarPoints[1];for(const s of this._beat.notes)t.addGlyph(this.getBendNoteValue(s,this._beat.whammyBarPoints[1]),e.value%2!=0,void 0)}t.doLayout(),this.BendNoteHeads.push(t);const s=new ih(this._beat,!1);if(s.renderer=this.renderer,this.renderer.settings.notation.notationMode===e.NotationMode.GuitarPro){const e=this._beat.whammyBarPoints[this._beat.whammyBarPoints.length-1];for(const t of this._beat.notes)s.addGlyph(this.getBendNoteValue(t,e),e.value%2!=0,void 0)}s.doLayout(),this.BendNoteHeads.push(s)}case de.Predive:}super.doLayout()}paint(t,s,i){const a=this._beat;switch(a.whammyBarType){case de.None:case de.Custom:return}const r=this.renderer.settings.notation.notationMode,n=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,a.voice.bar),o=nn.beat(i,be.StandardNotationEffects,a);try{const o=t+n.x+n.getBeatX(a,ss.MiddleNotes),h=this.getTieDirection(a,n);let l=1===this._beat.notes.length?h:Ne.Up;const c=i.textAlign,d=xr.Heights.get(ne.NoteheadBlack);for(let c=0;c<a.notes.length;c++){const u=a.notes[c],p=nn.note(i,ce.StandardNotationEffects,u);try{let p=s+n.y;c>0&&c>=(this._beat.notes.length/2|0)&&(l=Ne.Down),l===Ne.Down?p+=n.getNoteY(u,as.Bottom):p+=n.getNoteY(u,as.Top);let g=t+n.x;a.isLastOfVoice?g+=n.width:g+=n.getBeatX(a,ss.EndBeat),g-=8;const m=a.whammyStyle===y.Gradual&&0===c?"grad.":"";let f=null;u.isTieOrigin&&(f=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,u.tieDestination.beat.voice.bar),f&&f.staff===n.staff?g=t+f.x+f.getBeatX(u.tieDestination.beat,ss.MiddleNotes):f=null);let b=d*Pr.GraceScale*.5;l===Ne.Up&&(b=-b);const S=a.whammyBarPoints.length>0?this.getBendNoteValue(u,a.whammyBarPoints[a.whammyBarPoints.length-1]):0;let _=0,w=!1;switch(this.BendNoteHeads.length>0&&this.BendNoteHeads[0].containsNoteValue(S)?(_=this.BendNoteHeads[0].getNoteValueY(S)+b,w=!0):f&&(u.isTieOrigin&&u.tieDestination.beat.hasWhammyBar||u.beat.isContinuedWhammy)?(_=s+f.y+f.getNoteY(u.tieDestination,as.Top),w=!0,l===Ne.Down&&(_+=d)):u.isTieOrigin&&(_=f?s+f.y+f.getNoteY(u.tieDestination,as.Top):p,l===Ne.Down&&(_+=d)),a.whammyBarType){case de.Hold:u.isTieOrigin&&Xo.paintTie(i,1,o,p,g,_,h===Ne.Down,22,4);break;case de.Dive:if(0===c){this.BendNoteHeads[0].x=g-this.BendNoteHeads[0].noteHeadOffset;const e=this.BendNoteHeads[0].y;this.BendNoteHeads[0].y=s+n.y,this.BendNoteHeads[0].paint(0,0,i),this.BendNoteHeads[0].containsNoteValue(S)&&(_-=e,_+=this.BendNoteHeads[0].y)}w?this.drawBendSlur(i,o,p,g,_,l===Ne.Down,1,m):u.isTieOrigin&&Xo.paintTie(i,1,o,p,g,_,h===Ne.Down,22,4);break;case de.Dip:if(r===e.NotationMode.SongBook){if(0===c){const e=t+n.x+n.getBeatX(this._beat,ss.OnNotes)-2,a=t+n.x+n.getBeatX(this._beat,ss.PostNotes)+2,r=(e+a)/2,o=((this._beat.whammyBarPoints[1].value-this._beat.whammyBarPoints[0].value)/4|0).toString();i.font=this.renderer.resources.tablatureFont,i.fillText(o,r,s+this.y);const h=s+this.y+i.font.size+2,l=h+hh.SimpleDipHeight;this._beat.whammyBarPoints[1].value>this._beat.whammyBarPoints[0].value?(i.moveTo(e,l),i.lineTo(r,h),i.lineTo(a,l)):(i.moveTo(e,h),i.lineTo(r,l),i.lineTo(a,h)),i.stroke()}u.isTieOrigin&&Xo.paintTie(i,1,o,p,g,_,h===Ne.Down,22,4)}else{const e=(o+g)/2;this.BendNoteHeads[0].x=e-this.BendNoteHeads[0].noteHeadOffset,this.BendNoteHeads[0].y=s+n.y,this.BendNoteHeads[0].paint(0,0,i);const t=this.getBendNoteValue(u,a.whammyBarPoints[1]),r=this.BendNoteHeads[0].getNoteValueY(t)+b;this.drawBendSlur(i,o,p,e,r,l===Ne.Down,1,m),this.BendNoteHeads[1].x=g-this.BendNoteHeads[1].noteHeadOffset,this.BendNoteHeads[1].y=s+n.y,this.BendNoteHeads[1].paint(0,0,i),_=this.BendNoteHeads[1].getNoteValueY(S)+b,this.drawBendSlur(i,e,r,g,_,l===Ne.Down,1,m)}break;case de.PrediveDive:case de.Predive:let d=t+n.x+n.getBeatX(u.beat,ss.PreNotes);d+=n.getPreNotesGlyphForBeat(u.beat).prebendNoteHeadOffset;const f=s+n.y+n.getScoreY(n.accidentalHelper.getNoteLineForValue(u.displayValue-(u.beat.whammyBarPoints[0].value/2|0),!1))+b;this.drawBendSlur(i,d,f,o,p,l===Ne.Down,1,m),this.BendNoteHeads.length>0&&(this.BendNoteHeads[0].x=g-this.BendNoteHeads[0].noteHeadOffset,this.BendNoteHeads[0].y=s+n.y,this.BendNoteHeads[0].paint(0,0,i),this.drawBendSlur(i,o,p,g,_,l===Ne.Down,1,m))}}finally{p?.[Symbol.dispose]?.()}}i.textAlign=c}finally{o?.[Symbol.dispose]?.()}}getBendNoteValue(e,t){return e.displayValueWithoutBend+(t.value/2|0)}}hh.SimpleDipHeight=2*oh.PerHalfSize,hh.SimpleDipPadding=2;class lh extends Tr{constructor(e,t,s){super(e,t),this.width=s}}class ch extends vr{constructor(e,t,s,i,a){super(e,t,a?Pr.GraceScale:1,s.getSymbol(i)),this._isGrace=a,this._articulation=s}paint(e,t,s){const i=s.color;this.colorOverride&&(s.color=this.colorOverride);const a=this._isGrace?1:0;s.fillMusicFontSymbol(e+this.x,t+this.y+a,this.glyphScale,this.symbol,!1),this._articulation.techniqueSymbol!==ne.None&&this._articulation.techniqueSymbolPlacement===he.Middle&&s.fillMusicFontSymbol(e+this.x,t+this.y+a,this.glyphScale,this._articulation.techniqueSymbol,!1),s.color=i}doLayout(){super.doLayout(),0===this.width&&(this.height=xr.Widths.get(ne.NoteheadBlack)),0===this.height&&(this.height=xr.Heights.get(ne.NoteheadBlack))}}class dh extends vr{constructor(e,t){super(e,t,Pr.GraceScale,ne.ArticStaccatoAbove)}paint(e,t,s){super.paint(e+3,t+5,s)}}class uh extends vr{constructor(e,t){super(e,t,.5,ne.PictEdgeOfCymbal)}paint(e,t,s){super.paint(e-3,t+this.height,s)}}class ph extends vr{constructor(e,t,s=!1){super(e,t,Pr.GraceScale,ne.GuitarGolpe),this.center=s}paint(e,t,s){super.paint(e,t+this.height,s)}}class gh extends Nr{constructor(){super(...arguments),this._strings=new Set}addString(e){this._strings.add(e)}doLayout(){const e=xr.Widths.get(ne.GuitarString0)*En.CircleNumberScale;this.height=(e+3)*this._strings.size,this.width=e}paint(e,t,s){const i=this.renderer.bar.staff.tuning.length;let a=0;const r=xr.Widths.get(ne.GuitarString0)*En.CircleNumberScale,n=xr.Heights.get(ne.NoteheadBlack);for(const o of this._strings){const h=i-o,l=ne.GuitarString1+h;s.fillMusicFontSymbol(e+this.x+n/2,t+this.y+r+a,En.CircleNumberScale,l,!0),a+=r+3}}}class mh extends Nr{constructor(e,t,s,i,a){super(e,t),this.beatEffects=new Map,this.noteHeadElement=ce.SlashNoteHead,this.effectElement=be.SlashEffects,this._isGrace=i,this._symbol=mh.getSymbol(s),this.beat=a}paint(e,t,s){const i=0===this.beat.notes.length?void 0:nn.note(s,this.noteHeadElement,this.beat.notes[0]);try{const i=this._isGrace?1:0,a=this._isGrace?Pr.GraceScale:1;s.fillMusicFontSymbol(e+this.x,t+this.y+i,a,this._symbol,!1),this.paintEffects(e,t,s)}finally{i?.[Symbol.dispose]?.()}}paintEffects(e,t,s){const i=nn.beat(s,this.effectElement,this.beat);try{for(const i of this.beatEffects.values())i.paint(e+this.x,t+this.y,s)}finally{i?.[Symbol.dispose]?.()}}doLayout(){const e=this._isGrace?Pr.GraceScale:1;this.width=xr.Widths.get(this._symbol)*e,this.height=xr.Heights.get(this._symbol)*e;let t=xr.Heights.get(this._symbol);for(const e of this.beatEffects.values())e.y+=t,e.x+=this.width/2,e.renderer=this.renderer,t+=7,e.doLayout()}static getSymbol(e){switch(e){case w.QuadrupleWhole:case w.DoubleWhole:case w.Whole:return ne.NoteheadSlashWhiteWhole;case w.Half:return ne.NoteheadSlashWhiteHalf;default:return ne.NoteheadSlashVerticalEnds}}updateBeamingHelper(e){this.beamingHelper&&this.beamingHelper.registerBeatLineX("slash",this.beat,e+this.x+this.width,e+this.x)}}class fh extends An{constructor(){super(...arguments),this._collisionOffset=-1e3,this._skipPaint=!1,this.slash=null,this.noteHeads=null,this.restGlyph=null}get effectElement(){return be.StandardNotationEffects}getNoteX(e,t){return this.noteHeads?this.noteHeads.getNoteX(e,t):0}buildBoundingsLookup(e,t,s){this.noteHeads&&this.noteHeads.buildBoundingsLookup(e,t+this.x,s+this.y)}getNoteY(e,t){return this.noteHeads?this.noteHeads.getNoteY(e,t):0}updateBeamingHelper(){if(this.noteHeads)this.noteHeads.updateBeamingHelper(this.container.x+this.x);else if(this.restGlyph){if(this.restGlyph.updateBeamingHelper(this.container.x+this.x),this.renderer.bar.isMultiVoice&&-1e3===this._collisionOffset){this._collisionOffset=this.renderer.helpers.collisionHelper.applyRestCollisionOffset(this.container.beat,this.restGlyph.y,this.renderer.getScoreHeight(1)),this.y+=this._collisionOffset;const e=this.renderer.helpers.collisionHelper.restDurationsByDisplayTime;e.has(this.container.beat.playbackStart)&&e.get(this.container.beat.playbackStart).has(this.container.beat.playbackDuration)&&e.get(this.container.beat.playbackStart).get(this.container.beat.playbackDuration)!==this.container.beat.id&&(this._skipPaint=!0)}}else this.slash&&this.slash.updateBeamingHelper(this.container.x+this.x)}paint(e,t,s){this._skipPaint||super.paint(e,t,s)}doLayout(){const e=this.renderer;if(!this.container.beat.isEmpty)if(this.container.beat.isRest){let t=2*Math.ceil((this.renderer.bar.staff.standardNotationLineCount-1)/2);this.container.beat.duration===w.Whole&&1!==this.renderer.bar.staff.standardNotationLineCount&&3!==this.renderer.bar.staff.standardNotationLineCount&&(t-=2);const s=new eh(0,e.getScoreY(t),this.container.beat.duration);if(this.restGlyph=s,s.beat=this.container.beat,s.beamingHelper=this.beamingHelper,this.addNormal(s),this.renderer.bar.isMultiVoice)if(0===this.container.beat.voice.index){const t=dn.computeLineHeightsForRest(this.container.beat.duration),i=s.y-e.getScoreHeight(t[0]),a=s.y+e.getScoreHeight(t[1]);this.renderer.helpers.collisionHelper.reserveBeatSlot(this.container.beat,i,a)}else this.renderer.helpers.collisionHelper.registerRest(this.container.beat);if(this.beamingHelper&&this.beamingHelper.applyRest(this.container.beat,t),this.container.beat.dots>0){this.addNormal(new lh(0,0,5));for(let e=0;e<this.container.beat.dots;e++){const e=new an(0,0);e.renderer=this.renderer,this.createBeatDot(t,e),this.addEffect(e)}}}else{if(this.container.beat.slashed){const t=this.container.beat.graceType!==B.None,s=(e.heightLineCount-1)/2,i=e.getLineY(s),a=new mh(0,i,this.container.beat.duration,t,this.container.beat);a.noteHeadElement=ce.StandardNotationNoteHead,a.effectElement=be.StandardNotationEffects,this.slash=a,a.beat=this.container.beat,a.beamingHelper=this.beamingHelper,this.addNormal(a)}else{const e=new Zo;this.noteHeads=e,e.beat=this.container.beat,e.beamingHelper=this.beamingHelper;const t=new $o(!1);t.renderer=this.renderer;for(const e of this.container.beat.notes)e.isVisible&&(this.createNoteGlyph(e),t.addParenthesis(e));this.addNormal(e),t.isEmpty||(this.addNormal(new lh(0,0,4*(this.container.beat.graceType!==B.None?Pr.GraceScale:1))),this.addEffect(t))}if(this.container.beat.hasWhammyBar){const e=new hh(this.container.beat);e.renderer=this.renderer,e.doLayout(),this.container.ties.push(e)}if(this.container.beat.dots>0){this.addNormal(new lh(0,0,5));for(let t=0;t<this.container.beat.dots;t++){const t=new an(0,0);t.renderer=this.renderer;for(const s of this.container.beat.notes){this.createBeatDot(e.getNoteLine(s),t).colorOverride=nn.noteColor(e.resources,ce.StandardNotationEffects,s)}this.addEffect(t)}}}super.doLayout(),this.container.beat.isEmpty?this.centerX=this.width/2:this.restGlyph?this.centerX=this.restGlyph.x+this.restGlyph.width/2:this.noteHeads?this.centerX=this.noteHeads.x+this.noteHeads.width/2:this.slash&&(this.centerX=this.slash.x+this.slash.width/2)}createBeatDot(e,t){const s=this.renderer,i=new Go(0,s.getScoreY(e),1.5);return t.addGlyph(i),i}createNoteHeadGlyph(e){const t=this.container.beat.graceType!==B.None,s=e.style;if(void 0!==s?.noteHead){const i=new Pr(0,0,e.beat.duration,t);return i.symbol=s.noteHead,s.noteHeadCenterOnStem&&(i.centerOnStem=!0),i}if(e.beat.voice.bar.staff.isPercussion){const s=Le.getArticulation(e);if(s)return new ch(0,0,s,e.beat.duration,t);j.warning("Rendering",`No articulation found for percussion instrument ${e.percussionArticulation}`)}return e.isDead?new zo(0,0,t):e.beat.graceType===B.BendGrace?new Pr(0,0,w.Quarter,!0):e.harmonicType===N.Natural?new Uo(0,0,e.beat.duration,t):new Pr(0,0,e.beat.duration,t)}createNoteGlyph(e){if(e.beat.graceType===B.BendGrace&&!e.hasBend)return;const t=this.renderer,s=this.createNoteHeadGlyph(e);s.colorOverride=nn.noteColor(t.resources,ce.StandardNotationNoteHead,e);let i=t.getNoteLine(e);if(s.y=t.getScoreY(i),this.noteHeads.addNoteGlyph(s,e,i),e.harmonicType!==N.None&&e.harmonicType!==N.Natural){const a=e.displayValue+e.harmonicPitch,r=new Uo(0,0,e.beat.duration,this.container.beat.graceType!==B.None);r.colorOverride=s.colorOverride,i=t.accidentalHelper.getNoteLineForValue(a,!1),r.y=t.getScoreY(i),this.noteHeads.addNoteGlyph(r,e,i)}const a=this.noteHeads.belowBeatEffects,r=this.noteHeads.aboveBeatEffects;if(e.isStaccato&&!a.has("Staccato")&&a.set("Staccato",new dh(0,0)),e.accentuated!==k.Normal||a.has("Accent")||a.set("Accent",new Vo(0,0,e)),e.accentuated!==k.Heavy||a.has("HAccent")||a.set("HAccent",new Vo(0,0,e)),e.accentuated!==k.Tenuto||a.has("Tenuto")||a.set("Tenuto",new Vo(0,0,e)),e.showStringNumber&&e.isStringed){let t;r.has("StringNumber")?t=r.get("StringNumber"):(t=new gh(0,0),r.set("StringNumber",t)),t.addString(e.string)}if(e.isPercussion){const t=Le.getArticulation(e);if(t&&t.techniqueSymbolPlacement!==he.Middle){const e=t.techniqueSymbolPlacement===he.Top?this.noteHeads.aboveBeatEffects:this.noteHeads.belowBeatEffects;switch(t.techniqueSymbol){case ne.PictEdgeOfCymbal:e.set("PictEdgeOfCymbal",new uh(0,0));break;case ne.ArticStaccatoAbove:e.set("ArticStaccatoAbove",new dh(0,0));break;case ne.StringsUpBow:e.set("StringsUpBow",new So(0,0,re.Up));break;case ne.StringsDownBow:e.set("StringsDownBow",new So(0,0,re.Down));break;case ne.GuitarGolpe:e.set("GuitarGolpe",new ph(0,0))}}}}}class yh extends Tr{constructor(e){super(0,0),this._beat=e}doLayout(){this.width=this._beat.brushType===S.ArpeggioUp||this._beat.brushType===S.ArpeggioDown?10:0}paint(e,t,s){if(this._beat.brushType===S.ArpeggioUp||this._beat.brushType===S.ArpeggioDown){const i=this.renderer,a=i.lineOffset,r=t+this.y+(i.getNoteY(this._beat.maxNote,as.Bottom)-a),n=t+this.y+i.getNoteY(this._beat.minNote,as.Top)+a,o=e+this.x+this.width/2,h=8,l=new ko(0,0,F.Slight,1.2,!0);l.renderer=this.renderer,l.doLayout();const c=-l.height/2;if(this._beat.brushType===S.ArpeggioUp){const t=r+h,i=n-h;l.width=Math.abs(i-t),s.beginRotate(e+this.x+5,i,-90),l.paint(0,c,s),s.endRotate(),s.beginPath(),s.moveTo(o,n),s.lineTo(o+h/2,n-h),s.lineTo(o-h/2,n-h),s.closePath(),s.fill()}else if(this._beat.brushType===S.ArpeggioDown){const t=r+h,i=n;l.width=Math.abs(i-t),s.beginRotate(e+this.x+5,t,90),l.paint(0,c,s),s.endRotate(),s.beginPath(),s.moveTo(o,r),s.lineTo(o+h/2,r+h),s.lineTo(o-h/2,r+h),s.closePath(),s.fill()}}}}class bh{constructor(e,t){this.line=0,this.line=e,this.text=t}}class Sh extends an{constructor(){super(0,0),this._infos=new Map}get isEmpty(){return 0===this._infos.size}addFingers(t){const s=this.renderer.settings;if(s.notation.fingeringMode!==e.FingeringMode.ScoreDefault&&s.notation.fingeringMode!==e.FingeringMode.ScoreForcePiano)return;const i=ae.fingerToString(this.renderer.settings,t.beat,t.leftHandFinger,!0);i&&this.addFinger(t,i);const a=ae.fingerToString(this.renderer.settings,t.beat,t.rightHandFinger,!1);a&&this.addFinger(t,a)}addFinger(e,t){const s=this.renderer,i=s.getNoteLine(e);if(this._infos.has(i)){this._infos.get(i).text+=t}else{const a=new bh(i,t);a.color=nn.noteColor(s.resources,ce.StandardNotationEffects,e),this._infos.set(i,a)}}doLayout(){const e=this.renderer;for(const[t,s]of this._infos){const t=new _n(0,0,s.text,e.resources.inlineFingeringFont,oe.Left,he.Middle);t.colorOverride=s.color,t.renderer=e,t.y=e.getScoreY(s.line),t.doLayout(),this.addGlyph(t),this.width=Math.max(this.width,t.width)}}}class _h extends Ln{constructor(){super(...arguments),this._prebends=null,this.accidentals=null}get prebendNoteHeadOffset(){return this._prebends?this._prebends.x+this._prebends.noteHeadOffset:0}get effectElement(){return be.StandardNotationEffects}doLayout(){if(!this.container.beat.isRest){const e=new sh;e.renderer=this.renderer;const t=new Sh;t.renderer=this.renderer;const s=new $o(!0);s.renderer=this.renderer;const i=new ih(this.container.beat,!0);this._prebends=i,i.renderer=this.renderer;for(const a of this.container.beat.notes){const r=nn.noteColor(this.renderer.resources,ce.StandardNotationEffects,a);if(a.isVisible){if(a.hasBend)switch(a.bendType){case b.PrebendBend:case b.Prebend:case b.PrebendRelease:i.addGlyph(a.displayValue-(a.bendPoints[0].value/2|0),!1,r)}else if(a.beat.hasWhammyBar)switch(a.beat.whammyBarType){case de.PrediveDive:case de.Predive:this._prebends.addGlyph(a.displayValue-(a.beat.whammyBarPoints[0].value/2|0),!1,r)}this.createAccidentalGlyph(a,e),s.addParenthesis(a),t.addFingers(a)}}i.isEmpty||(this.addEffect(i),this.addNormal(new lh(0,0,4*(this.container.beat.graceType!==B.None?Pr.GraceScale:1)))),this.container.beat.brushType!==S.None&&(this.addEffect(new yh(this.container.beat)),this.addNormal(new lh(0,0,4))),t.isEmpty||(this.isEmpty||this.addNormal(new lh(0,0,2*(this.container.beat.graceType!==B.None?Pr.GraceScale:1))),this.addEffect(t),this.addNormal(new lh(0,0,2*(this.container.beat.graceType!==B.None?Pr.GraceScale:1)))),s.isEmpty||(this.addEffect(s),this.addNormal(new lh(0,0,4*(this.container.beat.graceType!==B.None?Pr.GraceScale:1)))),e.isEmpty||(this.accidentals=e,this.isEmpty||this.addNormal(new lh(0,0,2*(this.container.beat.graceType!==B.None?Pr.GraceScale:1))),this.addNormal(e),this.addNormal(new lh(0,0,2*(this.container.beat.graceType!==B.None?Pr.GraceScale:1))))}super.doLayout()}createAccidentalGlyph(e,t){const s=this.renderer;let i=s.accidentalHelper.applyAccidental(e),a=s.getNoteLine(e);const r=this.container.beat.graceType!==B.None,n=nn.noteColor(s.resources,ce.StandardNotationAccidentals,e),o=r?Pr.GraceScale:1;if(i!==It.None){const e=new Ho(0,s.getScoreY(a),i,o);e.colorOverride=n,e.renderer=this.renderer,t.addGlyph(e)}if(e.harmonicType!==N.None&&e.harmonicType!==N.Natural){const h=e.displayValue+e.harmonicPitch;i=s.accidentalHelper.applyAccidentalForValue(e.beat,h,r,!1),a=s.accidentalHelper.getNoteLineForValue(h,!1);const l=new Ho(0,s.getScoreY(a),i,o);l.colorOverride=n,l.renderer=this.renderer,t.addGlyph(l)}}}class wh extends an{constructor(e,t,s,i,a,r){super(e,t),this._numerator=0,this._denominator=0,this.barSubElement=p.StandardNotationTimeSignature,this._numerator=s,this._denominator=i,this._isCommon=a,this._isFreeTime=r}paint(e,t,s){const i=nn.bar(s,this.barSubElement,this.renderer.bar);try{super.paint(e,t,s)}finally{i?.[Symbol.dispose]?.()}}doLayout(){let e=0;const t=In.numberHeight;if(this._isFreeTime){const s=new Jo(!0);s.renderer=this.renderer,s.y=-t,s.height=2*t,s.doLayout(),this.addGlyph(s),e+=s.width+10}if(this._isCommon&&2===this._numerator&&2===this._denominator){const t=new vr(e,0,this.commonScale,ne.TimeSigCutCommon);this.addGlyph(t),super.doLayout()}else if(this._isCommon&&4===this._numerator&&4===this._denominator){const t=new vr(e,0,this.commonScale,ne.TimeSigCommon);this.addGlyph(t),super.doLayout()}else{const s=new In(e,-t/2,this._numerator,this.numberScale),i=new In(e,t/2,this._denominator,this.numberScale);this.addGlyph(s),this.addGlyph(i),super.doLayout();const a=this.width-e;s.x=e+(a-s.width)/2,i.x=e+(a-i.width)/2}if(this._isFreeTime){const e=new Jo(!1);e.renderer=this.renderer,e.x=this.width+13,e.y=-t,e.height=2*t,e.doLayout(),this.addGlyph(e),this.width=e.x+e.width}}}class Bh extends wh{get commonScale(){return 1}get numberScale(){return 1}}class kh extends ah{constructor(e){super(0,0),this._notes=[],this._endNoteGlyph=null,this._middleNoteGlyph=null,this._beat=e}addBends(e){if(this._notes.push(e),e.isTieOrigin)return;const t=nn.noteColor(this.renderer.resources,ce.StandardNotationEffects,e);switch(e.bendType){case b.Bend:case b.PrebendRelease:case b.PrebendBend:{let s=this._endNoteGlyph;s||(s=new ih(e.beat,!1),s.renderer=this.renderer,this._endNoteGlyph=s,this.BendNoteHeads.push(s));const i=e.bendPoints[e.bendPoints.length-1];s.addGlyph(this.getBendNoteValue(e,i),i.value%2!=0,t)}break;case b.Release:if(!e.isTieOrigin){let s=this._endNoteGlyph;s||(s=new ih(e.beat,!1),s.renderer=this.renderer,this._endNoteGlyph=s,this.BendNoteHeads.push(s));const i=e.bendPoints[e.bendPoints.length-1];s.addGlyph(this.getBendNoteValue(e,i),i.value%2!=0,t)}break;case b.BendRelease:{let s=this._middleNoteGlyph;s||(s=new ih(e.beat,!1),this._middleNoteGlyph=s,s.renderer=this.renderer,this.BendNoteHeads.push(s));const i=e.bendPoints[1];s.addGlyph(this.getBendNoteValue(e,e.bendPoints[1]),i.value%2!=0,t);let a=this._endNoteGlyph;a||(a=new ih(e.beat,!1),a.renderer=this.renderer,this._endNoteGlyph=a,this.BendNoteHeads.push(a));const r=e.bendPoints[e.bendPoints.length-1];a.addGlyph(this.getBendNoteValue(e,r),r.value%2!=0,t)}}}paint(e,t,s){const i=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,this._beat.voice.bar),a=e+i.x+i.getBeatX(this._beat,ss.MiddleNotes);let r=e+i.x;this._beat.isLastOfVoice?r+=i.postBeatGlyphsStart:r+=i.getBeatX(this._beat.nextBeat,ss.PreNotes),r-=8;const n=(a+r)/2;this._middleNoteGlyph&&(this._middleNoteGlyph.x=n-this._middleNoteGlyph.noteHeadOffset,this._middleNoteGlyph.y=t+i.y,this._middleNoteGlyph.paint(0,0,s)),this._endNoteGlyph&&(this._endNoteGlyph.x=r-this._endNoteGlyph.noteHeadOffset,this._endNoteGlyph.y=t+i.y,this._endNoteGlyph.paint(0,0,s)),this._notes.sort(((e,t)=>t.displayValue-e.displayValue));const o=this._beat.graceType===B.BendGrace?this._beat.nextBeat:this._beat;let h=1===this._notes.length?this.getTieDirection(o,i):Ne.Up;const l=xr.Heights.get(ne.NoteheadBlack);for(let o=0;o<this._notes.length;o++){const c=this._notes[o],d=nn.note(s,ce.StandardNotationEffects,c);try{o>0&&o>=(this._notes.length/2|0)&&(h=Ne.Down);let d=t+i.y+i.getNoteY(c,as.Top),u=l*Pr.GraceScale*.5;h===Ne.Down&&(d+=l);const p=c.bendStyle===y.Gradual?"grad.":"";if(c.isTieOrigin){const r=c.tieDestination,n=r?this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,r.beat.voice.bar):null;if(n&&n.staff===i.staff){const i=e+n.x+n.getBeatX(r.beat,ss.MiddleNotes);let o=t+n.y+n.getNoteY(r,as.Top);h===Ne.Down&&(o+=l),c.bendType===b.Hold||c.bendType===b.Prebend?Xo.paintTie(s,1,a,d,i,o,h===Ne.Down,22,4):this.drawBendSlur(s,a,d,i,o,h===Ne.Down,1,p)}else{const r=e+i.x+i.width,n=c.tieDestination.realValue;i.accidentalHelper.applyAccidentalForValue(c.beat,n,!1,!0);const o=t+i.y+i.getScoreY(i.accidentalHelper.getNoteLineForValue(n,!1));c.bendType===b.Hold||c.bendType===b.Prebend?Xo.paintTie(s,1,a,d,r,o,h===Ne.Down,22,4):this.drawBendSlur(s,a,d,r,o,h===Ne.Down,1,p)}switch(c.bendType){case b.Prebend:case b.PrebendBend:case b.PrebendRelease:let r=e+i.x+i.getBeatX(c.beat,ss.PreNotes);r+=i.getPreNotesGlyphForBeat(c.beat).prebendNoteHeadOffset;const n=t+i.y+i.getScoreY(i.accidentalHelper.getNoteLineForValue(c.displayValue-(c.bendPoints[0].value/2|0),!1))+u;this.drawBendSlur(s,r,n,a,d,h===Ne.Down,1)}}else{h===Ne.Up&&(u=-u);let o=0,l=0;switch(c.bendType){case b.Bend:o=this.getBendNoteValue(c,c.bendPoints[c.bendPoints.length-1]),l=this._endNoteGlyph.getNoteValueY(o)+u,this.drawBendSlur(s,a,d,r,l,h===Ne.Down,1,p);break;case b.BendRelease:const g=this.getBendNoteValue(c,c.bendPoints[1]),m=this._middleNoteGlyph.getNoteValueY(g)+u;this.drawBendSlur(s,a,d,n,m,h===Ne.Down,1,p),o=this.getBendNoteValue(c,c.bendPoints[c.bendPoints.length-1]),l=this._endNoteGlyph.getNoteValueY(o)+u,this.drawBendSlur(s,n,m,r,l,h===Ne.Down,1,p);break;case b.Release:this.BendNoteHeads.length>0&&(o=this.getBendNoteValue(c,c.bendPoints[c.bendPoints.length-1]),l=this.BendNoteHeads[0].getNoteValueY(o)+u,this.drawBendSlur(s,a,d,r,l,h===Ne.Down,1,p));break;case b.Prebend:case b.PrebendBend:case b.PrebendRelease:let f=e+i.x+i.getBeatX(c.beat,ss.PreNotes);f+=i.getPreNotesGlyphForBeat(c.beat).prebendNoteHeadOffset;const y=t+i.y+i.getScoreY(i.accidentalHelper.getNoteLineForValue(c.displayValue-(c.bendPoints[0].value/2|0),!1))+u;this.drawBendSlur(s,f,y,a,d,h===Ne.Down,1),this.BendNoteHeads.length>0&&(o=this.getBendNoteValue(c,c.bendPoints[c.bendPoints.length-1]),l=this.BendNoteHeads[0].getNoteValueY(o)+u,this.drawBendSlur(s,a,d,r,l,h===Ne.Down,1,p))}}}finally{d?.[Symbol.dispose]?.()}}}getBendNoteValue(e,t){return e.displayValueWithoutBend+(t.value/2|0)}}class Th extends Xo{constructor(e,t,s=!1){super(e,t,s)}doLayout(){super.doLayout()}getBeamDirection(e,t){return e.isRest?Ne.Up:t.getBeatDirection(e)===Ne.Up?Ne.Down:Ne.Up}getStartY(){return this.startBeat.isRest?this.startNoteRenderer.getScoreY(9):this.tieDirection===Ne.Up?this.startNoteRenderer.getNoteY(this.startBeat.maxNote,as.Top):this.startNoteRenderer.getNoteY(this.startBeat.minNote,as.Bottom)}getEndY(){const e=this.endNoteRenderer;if(this.endBeat.isRest)return this.tieDirection===Ne.Up?e.getScoreY(9):e.getScoreY(0);const t=this.startNoteRenderer.getBeatDirection(this.startBeat),s=e.getBeatDirection(this.endBeat);return t!==s&&this.startBeat.graceType===B.None?s===this.tieDirection?this.tieDirection===Ne.Up?e.getNoteY(this.endBeat.maxNote,as.TopWithStem):e.getNoteY(this.endBeat.minNote,as.BottomWithStem):this.tieDirection===Ne.Up?e.getNoteY(this.endBeat.maxNote,as.BottomWithStem):e.getNoteY(this.endBeat.minNote,as.TopWithStem):this.tieDirection===Ne.Up?e.getNoteY(this.endBeat.maxNote,as.Top):e.getNoteY(this.endBeat.minNote,as.Bottom)}getStartX(){return this.startNoteRenderer.getBeatX(this.startBeat,ss.MiddleNotes)}getEndX(){const e=this.endNoteRenderer.getBeatDirection(this.endBeat);return this.endNoteRenderer.getBeatX(this.endBeat,this.endBeat.duration>w.Whole&&e===this.tieDirection?ss.Stem:ss.MiddleNotes)}}class Nh extends Tr{constructor(e,t,s,i){super(0,0),this._outType=t,this._inType=e,this._startNote=s,this._parent=i}doLayout(){this.width=0}paint(e,t,s){this.paintSlideIn(e,t,s),this.drawSlideOut(e,t,s)}paintSlideIn(e,t,s){const i=this.renderer;let a=e+i.x+i.getNoteX(this._startNote,rs.Left)-2;const r=t+i.y+i.getNoteY(this._startNote,as.Center);let n=a-12,o=t+i.y;switch(this._inType){case v.IntoFromBelow:o+=i.getNoteY(this._startNote,as.Bottom);break;case v.IntoFromAbove:o+=i.getNoteY(this._startNote,as.Top);break;default:return}const h=this.getAccidentalsWidth(i,this._startNote.beat);n-=h,a-=h,this.paintSlideLine(s,!1,n,a,o,r)}getAccidentalsWidth(e,t){const s=e.getPreNotesGlyphForBeat(t);return s&&s.accidentals?s.accidentals.width:0}drawSlideOut(e,t,s){const i=this.renderer;let a=0,r=0,n=0,o=0,h=!1;switch(this._outType){case P.Shift:case P.Legato:if(a=e+i.x+i.getBeatX(this._startNote.beat,ss.PostNotes)+2,r=t+i.y+i.getNoteY(this._startNote,as.Center),this._startNote.slideTarget){const s=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,this._startNote.slideTarget.beat.voice.bar);s&&s.staff===i.staff?(n=e+s.x+s.getBeatX(this._startNote.slideTarget.beat,ss.PreNotes)-2,o=t+s.y+s.getNoteY(this._startNote.slideTarget,as.Center)):(n=e+i.x+i.width,o=r),this._startNote.slideTarget.realValue>this._startNote.realValue?(r+=2,o-=2):(r-=2,o+=2)}else n=e+i.x+this._parent.x,o=r;break;case P.OutUp:a=e+i.x+i.getNoteX(this._startNote,rs.Right)+2,r=t+i.y+i.getNoteY(this._startNote,as.Center),n=a+12,o=t+i.y+i.getNoteY(this._startNote,as.Top);break;case P.OutDown:a=e+i.x+i.getNoteX(this._startNote,rs.Right)+2,r=t+i.y+i.getNoteY(this._startNote,as.Center),n=a+12,o=t+i.y+i.getNoteY(this._startNote,as.Bottom);break;case P.PickSlideUp:a=e+i.x+i.getNoteX(this._startNote,rs.Right)+4,r=t+i.y+i.getNoteY(this._startNote,as.Center),o=t+i.y+i.getNoteY(this._startNote,as.Top),n=e+i.x+i.width,this._startNote.beat.nextBeat&&this._startNote.beat.nextBeat.voice===this._startNote.beat.voice&&(n=e+i.x+i.getBeatX(this._startNote.beat.nextBeat,ss.PreNotes)),h=!0;break;case P.PickSlideDown:a=e+i.x+i.getNoteX(this._startNote,rs.Right)+4,r=t+i.y+i.getNoteY(this._startNote,as.Center),o=t+i.y+i.getNoteY(this._startNote,as.Bottom),n=e+i.x+i.width,this._startNote.beat.nextBeat&&this._startNote.beat.nextBeat.voice===this._startNote.beat.voice&&(n=e+i.x+i.getBeatX(this._startNote.beat.nextBeat,ss.PreNotes)),h=!0;break;default:return}this.paintSlideLine(s,h,a,n,r,o)}paintSlideLine(e,t,s,i,a,r){if(t){const t=new ko(0,0,F.Slight,1.2);t.renderer=this.renderer,t.doLayout(),a-=t.height/2;const n=i-s,o=(r-=t.height/2)-a,h=Math.sqrt(Math.pow(o,2)+Math.pow(n,2));t.width=n;const l=Math.asin(o/h)*(180/Math.PI);e.beginRotate(s,a,l),t.paint(0,0,e),e.endRotate()}else e.beginPath(),e.moveTo(s,a),e.lineTo(i,r),e.stroke()}}class xh extends Th{constructor(e,t,s=!1){super(e.beat,t.beat,s),this._startNote=e,this._endNote=t}getTieHeight(e,t,s,i){return Math.log2(s-e+1)*this.renderer.settings.notation.slurHeight}getStartY(){return this.isStartCentered()?this.tieDirection===Ne.Up?this.startNoteRenderer.getNoteY(this._startNote,as.Top):this.startNoteRenderer.getNoteY(this._startNote,as.Bottom):this.startNoteRenderer.getNoteY(this._startNote,as.Center)}getEndY(){return this.isEndCentered()?this.isEndOnStem()?this.tieDirection===Ne.Up?this.endNoteRenderer.getNoteY(this._endNote,as.TopWithStem):this.endNoteRenderer.getNoteY(this._endNote,as.BottomWithStem):this.tieDirection===Ne.Up?this.endNoteRenderer.getNoteY(this._endNote,as.Top):this.endNoteRenderer.getNoteY(this._endNote,as.Bottom):this.endNoteRenderer.getNoteY(this._endNote,as.Center)}isStartCentered(){return this._startNote===this._startNote.beat.maxNote&&this.tieDirection===Ne.Up||this._startNote===this._startNote.beat.minNote&&this.tieDirection===Ne.Down}isEndCentered(){return this._startNote.beat.graceType===B.None&&(this._endNote===this._endNote.beat.maxNote&&this.tieDirection===Ne.Up||this._endNote===this._endNote.beat.minNote&&this.tieDirection===Ne.Down)}isEndOnStem(){const e=this.endNoteRenderer;return this.startNoteRenderer.getBeatDirection(this.startBeat)!==e.getBeatDirection(this.endBeat)&&this.startBeat.graceType===B.None}getStartX(){return this.isStartCentered()?this.startNoteRenderer.getBeatX(this._startNote.beat,ss.MiddleNotes):this.startNoteRenderer.getNoteX(this._startNote,rs.Right)}getEndX(){return this.isEndCentered()?this.isEndOnStem()?this.endNoteRenderer.getBeatX(this._endNote.beat,ss.Stem):this.endNoteRenderer.getNoteX(this._endNote,rs.Center):this.endNoteRenderer.getBeatX(this._endNote.beat,ss.PreNotes)}}class vh extends Xo{constructor(e,t,s=!1){super(e?e.beat:null,t?t.beat:null,s),this.startNote=e,this.endNote=t}shouldDrawBendSlur(){return this.renderer.settings.notation.extendBendArrowsOnTiedNotes&&!!this.startNote.bendOrigin&&this.startNote.isTieOrigin}doLayout(){super.doLayout()}getBeamDirection(e,t){return t.getBeatDirection(e)===Ne.Up?Ne.Down:Ne.Up}getStartY(){return this.startBeat.isRest?this.startNoteRenderer.getScoreY(9):this.tieDirection===Ne.Up?this.startNoteRenderer.getNoteY(this.startNote,as.Top):this.startNoteRenderer.getNoteY(this.startNote,as.Bottom)}getEndY(){const e=this.endNoteRenderer;return this.endBeat.isRest?this.tieDirection===Ne.Up?e.getScoreY(9):e.getScoreY(0):this.tieDirection===Ne.Up?e.getNoteY(this.endNote,as.Top):e.getNoteY(this.endNote,as.Bottom)}getStartX(){return this.startNoteRenderer.getBeatX(this.startNote.beat,ss.PostNotes)}getEndX(){return this.endNoteRenderer.getBeatX(this.endNote.beat,ss.PreNotes)}}class Ph extends Cr{constructor(){super(...arguments),this._bend=null,this._effectSlur=null,this._effectEndSlur=null}doLayout(){this._effectSlur=null,this._effectEndSlur=null,super.doLayout(),this._bend&&(this._bend.renderer=this.renderer,this._bend.doLayout(),this.updateWidth())}createTies(e){if(e.isVisible){if(e.isTieOrigin&&!e.hasBend&&!e.beat.hasWhammyBar&&e.beat.graceType!==B.BendGrace&&e.tieDestination&&e.tieDestination.isVisible){const t=new vh(e,e.tieDestination,!1);this.addTie(t)}if(e.isTieDestination&&!e.tieOrigin.hasBend&&!e.beat.hasWhammyBar){const t=new vh(e.tieOrigin,e,!0);this.addTie(t)}if(e.slideInType!==v.None||e.slideOutType!==P.None){const t=new Nh(e.slideInType,e.slideOutType,e,this);this.addTie(t)}if(e.isSlurOrigin&&e.slurDestination&&e.slurDestination.isVisible){const t=new xh(e,e.slurDestination,!1);this.addTie(t)}if(e.isSlurDestination){const t=new xh(e.slurOrigin,e,!0);this.addTie(t)}if(!this._effectSlur&&e.isEffectSlurOrigin&&e.effectSlurDestination){const t=new xh(e,e.effectSlurDestination,!1);this._effectSlur=t,this.addTie(t)}if(!this._effectEndSlur&&e.beat.isEffectSlurDestination&&e.beat.effectSlurOrigin){const t=this.onNotes.beamingHelper.direction,s=t===Ne.Up?e.beat.effectSlurOrigin.minNote:e.beat.effectSlurOrigin.maxNote,i=t===Ne.Up?e.beat.minNote:e.beat.maxNote,a=new xh(s,i,!0);this._effectEndSlur=a,this.addTie(a)}if(e.hasBend){if(!this._bend){const t=new kh(e.beat);this._bend=t,t.renderer=this.renderer,this.addTie(t)}this._bend.addBends(e)}if(this.beat.isLegatoOrigin){if(!this.beat.previousBeat||!this.beat.previousBeat.isLegatoOrigin){let e=this.beat.nextBeat;for(;e.nextBeat&&e.nextBeat.isLegatoDestination;)e=e.nextBeat;this.addTie(new Th(this.beat,e,!1))}}else if(this.beat.isLegatoDestination&&!this.beat.isLegatoOrigin){let e=this.beat.previousBeat;for(;e.previousBeat&&e.previousBeat.isLegatoOrigin;)e=e.previousBeat;this.addTie(new Th(e,this.beat,!0))}}}}class Fh extends Tr{doLayout(){this.width=1}paint(e,t,s){const i=e+this.x,a=t+this.y+this.renderer.topPadding,r=t+this.y+this.renderer.height-this.renderer.bottomPadding-a;this.paintInternal(i,a,r,s)}}class Ch extends Fh{paintInternal(e,t,s,i){i.fillRect(e,t,1,s)}}class Eh extends Fh{paintInternal(e,t,s,i){const a=e,r=this.renderer.getLineHeight(1);let n=t+.5*r+1;const o=t+s;for(;n<o;)i.fillCircle(a,n,1),n+=r}}class Dh extends Fh{paintInternal(e,t,s,i){const a=Dh.DashSize,r=e+.5,n=Math.ceil(s/2/a),o=t+s;if(i.beginPath(),n<1)i.moveTo(r,t),i.lineTo(r,o);else{let e=t;const h=(s-n*a)/(n-1);for(;e<o;)i.moveTo(r,e),i.lineTo(r,e+a),e+=a+h}i.stroke()}}Dh.DashSize=4;class Mh extends Fh{doLayout(){this.width=4}paintInternal(e,t,s,i){i.fillRect(e,t,this.width,s)}}class Lh extends Fh{paintInternal(e,t,s,i){const a=1.5,r=(t+(t+s))/2;i.fillCircle(e,r-4.5,a),i.fillCircle(e,r+4.5,a)}}class Ah extends Fh{paintInternal(e,t,s,i){const a=this.renderer,r=a.drawnLineCount-1;if(r<=2)return;const n=a.getLineHeight(1),o=2*n,h=r/2*n-o/2;i.fillRect(e,t+h,1,o)}}class Ih extends Fh{paintInternal(e,t,s,i){const a=this.renderer.getLineHeight(1),r=-a/2+1;i.fillRect(e,t+r,1,a)}}class Rh extends rn{constructor(e){super(),this._isRight=e}doLayout(){const e=this.renderer.bar,t=e.masterBar,s=this._isRight?e.getActualBarLineRight():e.getActualBarLineLeft(0===this.renderer.index);let i=g.Automatic;if(!this._isRight){const e=this.renderer.previousRenderer;if(e&&e.staff===this.renderer.staff&&(i=e.bar.getActualBarLineRight(),s===i))return}switch(this._isRight&&t.isRepeatEnd&&(this.addGlyph(new Lh(0,0)),this.width+=3),s){case g.Dashed:this.addGlyph(new Dh(0,0));break;case g.Dotted:this.addGlyph(new Eh(0,0));break;case g.Heavy:i!==g.LightHeavy&&i!==g.HeavyHeavy&&this.addGlyph(new Mh(0,0));break;case g.HeavyHeavy:i!==g.LightHeavy&&i!==g.Heavy&&this.addGlyph(new Mh(0,0)),this.width+=3,this.addGlyph(new Mh(0,0));break;case g.HeavyLight:i!==g.LightHeavy&&i!==g.Heavy&&i!==g.HeavyHeavy&&this.addGlyph(new Mh(0,0)),this.width+=3,this.addGlyph(new Ch(0,0));break;case g.LightHeavy:i!==g.HeavyLight&&i!==g.Regular&&i!==g.LightLight&&this.addGlyph(new Ch(0,0)),this.width+=3,this.addGlyph(new Mh(0,0));break;case g.LightLight:i!==g.HeavyLight&&i!==g.Regular&&this.addGlyph(new Ch(0,0)),this.width+=3,this.addGlyph(new Ch(0,0));break;case g.None:break;case g.Regular:i!==g.HeavyLight&&i!==g.LightLight&&this.addGlyph(new Ch(0,0));break;case g.Short:this.addGlyph(new Ah(0,0));break;case g.Tick:this.addGlyph(new Ih(0,0))}this._isRight||t.isRepeatStart&&(this.width+=3,this.addGlyph(new Lh(0,0)))}paint(e,t,s){const i=this.renderer,a=nn.bar(s,i.barLineBarSubElement,this.renderer.bar,!0);try{super.paint(e,t,s)}finally{a?.[Symbol.dispose]?.()}}}class Oh extends Tr{constructor(e,t,s){super(e,t),this._count=0,this._count=0,this._count=s}doLayout(){this.width=0}paint(e,t,s){const i=nn.bar(s,this.renderer.repeatsBarSubElement,this.renderer.bar);try{const i=this.renderer.resources,a=s.textAlign;s.font=i.barNumberFont,s.textAlign=oe.Right;const r=`x${this._count}`,n=s.measureText(r).width/1.5;s.fillText(r,e+this.x-n,t+this.y),s.textAlign=a}finally{i?.[Symbol.dispose]?.()}}}class Hh extends Tr{constructor(e,t,s){super(e,t),this._number=0,this._number=s}doLayout(){this.renderer.scoreRenderer.canvas.font=this.renderer.resources.barNumberFont,this.width=this.renderer.scoreRenderer.canvas.measureText(this._number.toString()).width+5}paint(e,t,s){if(!this.renderer.staff.isFirstInSystem)return;const i=nn.bar(s,this.renderer.barNumberBarSubElement,this.renderer.bar,!0);try{const i=this.renderer.resources,a=s.textBaseline;s.textBaseline=he.Top,s.font=i.barNumberFont,s.fillText(this._number.toString(),e+this.x,t+this.y),s.textBaseline=a}finally{i?.[Symbol.dispose]?.()}}}class Wh extends Hn{constructor(){super(...arguments),this.firstLineY=0,this._startSpacing=!1,this.tupletSize=0}get lineOffset(){return this.lineSpacing+1}get tupletOffset(){return 10}get topGlyphOverflow(){const e=this.resources;return e.tablatureFont.size/2+.2*e.tablatureFont.size}get bottomGlyphOverflow(){const e=this.resources;return e.tablatureFont.size/2+.2*e.tablatureFont.size}initLineBasedSizes(){this.topPadding=this.topGlyphOverflow,this.bottomPadding=this.bottomGlyphOverflow,this.height=this.lineOffset*(this.heightLineCount-1)+this.topPadding+this.bottomPadding}updateSizes(){this.initLineBasedSizes(),this.adjustSizes(),this.updateFirstLineY(),super.updateSizes()}adjustSizes(){}updateFirstLineY(){const e=this.lineOffset*(this.heightLineCount-1),t=(this.drawnLineCount-1)*this.lineOffset;this.firstLineY=this.topPadding+(e-t)/2}doLayout(){this.initLineBasedSizes(),this.updateFirstLineY(),this.tupletSize=15+.3*this.resources.effectFont.size,super.doLayout()}getLineY(e){return this.firstLineY+this.getLineHeight(e)}getLineHeight(e){return this.lineOffset*e}paintBackground(e,t,s){super.paintBackground(e,t,s),this.paintStaffLines(e,t,s),this.paintSimileMark(e,t,s)}paintStaffLines(e,t,s){const i=nn.bar(s,this.staffLineBarSubElement,this.bar,!0);try{const i=[];for(let e=0,t=this.drawnLineCount;e<t;e++)i.push([]);this.additionalMultiRestBars||this.collectSpaces(i);for(const e of i)e.sort(((e,t)=>e[0]>t[0]?1:e[0]<t[0]?-1:0));const a=Math.ceil(this.width);for(let r=0;r<this.drawnLineCount;r++){const n=this.getLineY(r);let o=0;for(const a of i[r])s.fillRect(e+this.x+o,t+this.y+n|0,a[0]-o,Hn.StaffLineThickness),o=a[0]+a[1];s.fillRect(e+this.x+o,t+this.y+n|0,a-o,Hn.StaffLineThickness)}}finally{i?.[Symbol.dispose]?.()}}collectSpaces(e){}createStartSpacing(){if(this._startSpacing)return;const e=0===this.index?this.settings.display.firstStaffPaddingLeft:this.settings.display.staffPaddingLeft;this.addPreBeatGlyph(new lh(0,0,e)),this._startSpacing=!0}paintTuplets(e,t,s,i,a=!1){for(const r of this.bar.voices)if(this.hasVoiceContainer(r)){const n=this.getVoiceContainer(r);for(const r of n.tupletGroups)this.paintTupletHelper(e+this.beatGlyphsStart,t,s,r,i,a)}}getTupletBeamDirection(e){return this.getBeamDirection(e)}paintTupletHelper(e,t,s,i,a,r){const n=this.resources,o=s.textAlign,h=s.textBaseline;let l;s.color=0===i.voice.index?this.resources.mainGlyphColor:this.resources.secondaryGlyphColor,s.textAlign=oe.Center,s.textBaseline=he.Middle;const c=i.beats[0].tupletNumerator,d=i.beats[0].tupletDenominator;l=2===c&&3===d?"2":3===c&&2===d?"3":4===c&&6===d?"4":5===c&&4===d?"5":6===c&&4===d?"6":7===c&&4===d?"7":9===c&&8===d?"9":10===c&&8===d?"10":11===c&&8===d?"11":12===c&&8===d?"12":13===c&&8===d?"13":`${c}:${d}`;let u=this.tupletOffset,p=5;const g=nn.beat(s,a,i.beats[0]);try{if(1!==i.beats.length&&i.isFull){const a=i.beats[0],o=i.beats[i.beats.length-1];let h=null,c=null;for(let e=0;e<i.beats.length;e++)if(!i.beats[e].isRest){h=i.beats[e];break}for(let e=i.beats.length-1;e>=0;e--)if(!i.beats[e].isRest){c=i.beats[e];break}let d=!1;h||(h=a,d=!0),c||(c=o);const g=this.helpers.beamHelperLookup[i.voice.index].get(a.index),m=this.helpers.beamHelperLookup[i.voice.index].get(o.index),f=g.getBeatLineX(a),y=m.getBeatLineX(o),b=this.helpers.beamHelperLookup[i.voice.index].get(h.index),S=this.helpers.beamHelperLookup[i.voice.index].get(c.index),_=this.getTupletBeamDirection(g);let w=this.calculateBeamYWithDirection(b,f,_),B=this.calculateBeamYWithDirection(S,y,_);d&&(w=Math.max(w,B),B=w),s.font=n.effectFont;const k=s.measureText(l).width,T=3,N=(f+y)/2,x=N-k/2-T,v=N+k/2+T,P=(B-w)/(y-f),F=w-P*f,C=P*x+F,E=P*N+F,D=P*v+F;_===Ne.Down&&(u*=-1,p*=-1),s.beginPath(),s.moveTo(e+this.x+f,t+this.y+w-u|0),r?s.quadraticCurveTo(e+this.x+(x+f)/2,t+this.y+C-u-p|0,e+this.x+x,t+this.y+C-u-p|0):(s.lineTo(e+this.x+f,t+this.y+w-u-p|0),s.lineTo(e+this.x+x,t+this.y+C-u-p|0)),s.stroke(),s.beginPath(),s.moveTo(e+this.x+v,t+this.y+D-u-p|0),r?s.quadraticCurveTo(e+this.x+(y+v)/2,t+this.y+D-u-p|0,e+this.x+y,t+this.y+B-u|0):(s.lineTo(e+this.x+y,t+this.y+B-u-p|0),s.lineTo(e+this.x+y,t+this.y+B-u|0)),s.stroke(),s.fillText(l,e+this.x+N,t+this.y+E-u-p)}else for(const a of i.beats){const r=this.helpers.beamHelperLookup[i.voice.index].get(a.index);if(!r)continue;const o=this.getTupletBeamDirection(r),h=r.getBeatLineX(a);let c=this.calculateBeamYWithDirection(r,h,o);o===Ne.Down?c+=u+p:c-=u+p,s.font=n.effectFont,s.fillText(l,e+this.x+h,t+this.y+c)}s.textAlign=o,s.textBaseline=h}finally{g?.[Symbol.dispose]?.()}}paintBeams(e,t,s,i,a){for(const r of this.helpers.beamHelpers)for(const n of r)this.paintBeamHelper(e+this.beatGlyphsStart,t,s,n,i,a)}drawBeamHelperAsFlags(e){return 1===e.beats.length}paintBeamHelper(e,t,s,i,a,r){s.color=0===i.voice.index?this.resources.mainGlyphColor:this.resources.secondaryGlyphColor,i.isRestBeamHelper||(this.drawBeamHelperAsFlags(i)?this.paintFlag(e,t,s,i,a):this.paintBar(e,t,s,i,r))}shouldPaintFlag(t,s){return t.graceType!==B.BendGrace&&(!t.deadSlapped&&(!!s.hasBeatLineX(t)&&((t.graceType===B.None||this.settings.notation.notationMode!==e.NotationMode.SongBook)&&(t.duration!==w.Whole&&t.duration!==w.DoubleWhole&&t.duration!==w.QuadrupleWhole))))}paintFlag(e,t,s,i,a){for(const r of i.beats){if(!this.shouldPaintFlag(r,i))continue;const n=r.graceType!==B.None,o=n?Pr.GraceScale:1,h=this.getFlagStemSize(i.shortestDuration),l=i.getBeatLineX(r),c=this.getBeamDirection(i);let d=this.getFlagTopY(r,c),u=this.getFlagBottomY(r,c),p=0;if(c===Ne.Down?(u+=h*o,p=u):(d-=h*o,p=d),!i.hasLine(!0,r))continue;this.paintBeamingStem(r,t+this.y,e+this.x+l,t+this.y+d,t+this.y+u,s);const g=nn.beat(s,a,r);try{if(r.graceType===B.BeforeBeat){const i=15,a=12;s.beginPath(),c===Ne.Down?(s.moveTo(e+this.x+l-a/2,t+this.y+u-i),s.lineTo(e+this.x+l+a/2,t+this.y+u)):(s.moveTo(e+this.x+l-a/2,t+this.y+d+i),s.lineTo(e+this.x+l+a/2,t+this.y+d)),s.stroke()}if(i.hasFlag(!0,r)){const i=new Fr(l-.5,p,r.duration,c,n);i.renderer=this,i.doLayout(),i.paint(e+this.x,t+this.y,s)}}finally{g?.[Symbol.dispose]?.()}}}getFlagStemSize(e,t=!1){let s=0;switch(e){case w.QuadrupleWhole:case w.Half:case w.Quarter:case w.Eighth:case w.Sixteenth:case w.ThirtySecond:case w.SixtyFourth:case w.OneHundredTwentyEighth:case w.TwoHundredFiftySixth:s=3;break;default:s=t?3:0}return this.getLineHeight(s)}recreatePreBeatGlyphs(){this._startSpacing=!1,super.recreatePreBeatGlyphs()}calculateBeamY(e,t){return this.calculateBeamYWithDirection(e,t,this.getBeamDirection(e))}createPreBeatGlyphs(){super.createPreBeatGlyphs(),this.addPreBeatGlyph(new Rh(!1)),this.createLinePreBeatGlyphs(),this.addPreBeatGlyph(new Hh(0,this.getLineHeight(-.25),this.bar.index+1))}createPostBeatGlyphs(){super.createPostBeatGlyphs();const e=this.lastBar;this.addPostBeatGlyph(new Rh(!0)),e.masterBar.isRepeatEnd&&e.masterBar.repeatCount>2&&this.addPostBeatGlyph(new Oh(0,this.getLineHeight(-.25),this.bar.masterBar.repeatCount))}paintBar(e,t,s,i,a){for(let r=0,n=i.beats.length;r<n;r++){const n=i.beats[r];if(!i.hasBeatLineX(n)||n.deadSlapped)continue;const o=n.graceType!==B.None?Pr.GraceScale:1,h=i.getBeatLineX(n),l=this.getBeamDirection(i),c=t+this.y+this.getBarLineStart(n,l),d=t+this.y+this.calculateBeamY(i,h);this.paintBeamingStem(n,t+this.y,e+this.x+h,c,d,s);const u=nn.beat(s,a,n);try{let a=d;l===Ne.Down?a+=2*s.font.size:0!==r&&(a-=1.5*s.font.size);const c=6*o;let u=(Hn.BeamSpacing+Hn.BeamThickness)*o,p=Hn.BeamThickness*o;const g=ae.getIndex(n.duration)-2,m=t+this.y;l===Ne.Down&&(u=-u,p=-p);for(let t=0;t<g;t++){let a=0,o=0,l=0,d=0;const f=m+t*u;if(r<i.beats.length-1){const u=dn.isFullBarJoin(n,i.beats[r+1],t);if(t===g-1&&u&&n.beamingMode===ye.ForceSplitOnSecondaryToNext)a=h,o=a+c,l=f+this.calculateBeamY(i,a),d=f+this.calculateBeamY(i,o),Wh.paintSingleBar(s,e+this.x+a,l,e+this.x+o,d,p),o=i.getBeatLineX(i.beats[r+1]),a=o-c,l=f+this.calculateBeamY(i,a),d=f+this.calculateBeamY(i,o),Wh.paintSingleBar(s,e+this.x+a,l,e+this.x+o,d,p);else{if(u)a=h,o=i.getBeatLineX(i.beats[r+1]);else{if(0!==r&&dn.isFullBarJoin(i.beats[r-1],n,t))continue;a=h,o=a+c}l=f+this.calculateBeamY(i,a),d=f+this.calculateBeamY(i,o),Wh.paintSingleBar(s,e+this.x+a,l,e+this.x+o,d,p)}}else r>0&&!dn.isFullBarJoin(n,i.beats[r-1],t)&&(a=h-c,o=h,l=f+this.calculateBeamY(i,a),d=f+this.calculateBeamY(i,o),Wh.paintSingleBar(s,e+this.x+a,l,e+this.x+o,d,p))}}finally{u?.[Symbol.dispose]?.()}}}static paintSingleBar(e,t,s,i,a,r){e.beginPath(),e.moveTo(t,s),e.lineTo(i,a),e.lineTo(i,a+r),e.lineTo(t,s+r),e.closePath(),e.fill()}}class Vh extends rn{paint(e,t,s){const i=nn.bar(s,p.StandardNotationKeySignature,this.renderer.bar);try{super.paint(e,t,s)}finally{i?.[Symbol.dispose]?.()}}}class Gh extends Wh{constructor(e,t){super(e,t),this.simpleWhammyOverflow=0,this.beatEffectsMinY=null,this.beatEffectsMaxY=null,this.accidentalHelper=new ks(this)}get repeatsBarSubElement(){return p.StandardNotationRepeats}get barNumberBarSubElement(){return p.StandardNotationBarNumber}get barLineBarSubElement(){return p.StandardNotationBarLines}get staffLineBarSubElement(){return p.StandardNotationStaffLine}get showMultiBarRest(){return!0}get lineSpacing(){return Hn.RawLineSpacing}get heightLineCount(){return 5}get drawnLineCount(){return this.bar.staff.standardNotationLineCount}registerBeatEffectOverflows(e,t){const s=this.beatEffectsMinY;(null==s||e<s)&&(this.beatEffectsMinY=e);const i=this.beatEffectsMaxY;(null==i||t>i)&&(this.beatEffectsMaxY=t)}getScoreY(e){return super.getLineY(e/2)}getScoreHeight(e){return super.getLineHeight(e/2)}doLayout(){if(super.doLayout(),!this.bar.isEmpty&&this.accidentalHelper.maxLineBeat){const e=this.getScoreY(-2),t=this.getScoreY(10),s=this.simpleWhammyOverflow,i=this.beatEffectsMinY;if(null!==i){const t=e-i;t>0&&this.registerOverflowTop(t)}const a=this.beatEffectsMaxY;if(null!==a){const e=a-t;e>0&&this.registerOverflowBottom(e)}this.registerOverflowTop(s);let r=this.getScoreY(this.accidentalHelper.maxLine);const n=this.helpers.getBeamingHelperForBeat(this.accidentalHelper.maxLineBeat);n.direction===Ne.Up&&(r-=this.getStemSize(n),n.hasTuplet&&(r-=this.tupletSize)),r<e&&this.registerOverflowTop(Math.abs(r)+s);let o=this.getScoreY(this.accidentalHelper.minLine);const h=this.helpers.getBeamingHelperForBeat(this.accidentalHelper.minLineBeat);h.direction===Ne.Down&&(o+=this.getStemSize(h),h.hasTuplet&&(o+=this.tupletSize)),o>t&&this.registerOverflowBottom(Math.abs(o)-t)}}paint(e,t,s){super.paint(e,t,s),this.paintBeams(e,t,s,be.StandardNotationFlags,be.StandardNotationBeams),this.paintTuplets(e,t,s,be.StandardNotationTuplet)}getSlashFlagY(e,t){let s=(this.heightLineCount-1)/2,i=0;switch(e){case w.QuadrupleWhole:case w.DoubleWhole:case w.Whole:i+=2;break;default:i+=1}t===Ne.Down?s+=i:s-=i;return this.getLineY(s)}getFlagTopY(e,t){return e.slashed?this.getSlashFlagY(e.duration,t):this.getScoreY(this.accidentalHelper.getMinLine(e))}getFlagBottomY(e,t){return e.slashed?this.getSlashFlagY(e.duration,t):this.getScoreY(this.accidentalHelper.getMaxLine(e))}getBeamDirection(e){return e.direction}getStemSize(e,t=!1){let s=1===e.beats.length?this.getFlagStemSize(e.shortestDuration,t):this.getBarStemSize(e.shortestDuration);return e.isGrace&&(s*=Pr.GraceScale),s}getBarStemSize(e){let t=0;switch(e){case w.QuadrupleWhole:case w.Half:case w.Quarter:case w.Eighth:case w.Sixteenth:t=6;break;case w.ThirtySecond:t=8;break;case w.SixtyFourth:case w.OneHundredTwentyEighth:t=9;break;case w.TwoHundredFiftySixth:t=10;break;default:t=0}return this.getScoreHeight(t)}get middleYPosition(){return this.getScoreY(this.bar.staff.standardNotationLineCount-1)}getNoteY(e,t){if(e.beat.slashed){const e=(this.heightLineCount-1)/2;return this.getLineY(e)}let s=super.getNoteY(e,t);if(Number.isNaN(s)){const t=ks.computeLineWithoutAccidentals(this.bar,e);s=this.getScoreY(t)}return s}applyLayoutingInfo(){const e=super.applyLayoutingInfo();if(e&&this.bar.isMultiVoice){const e=this.getScoreY(-2),t=this.getScoreY(10),s=this.helpers.collisionHelper.getBeatMinMaxY();s[0]<e&&this.registerOverflowTop(Math.abs(s[0])),s[1]>t&&this.registerOverflowBottom(Math.abs(s[1])-t)}return e}calculateBeamYWithDirection(e,t,s){const i=this.getStemSize(e);if(!e.drawingInfos.has(s)){const t=new cn;e.drawingInfos.set(s,t);const a=e.beats[0],r=e.beats[e.beats.length-1],n=e.isRestBeamHelper;t.startBeat=a,t.startX=e.getBeatLineX(a),t.startY=n?s===Ne.Up?this.getScoreY(e.minRestLine):this.getScoreY(e.maxRestLine):s===Ne.Up?this.getFlagTopY(a,s)-i:this.getFlagBottomY(a,s)+i,t.endBeat=r,t.endX=e.getBeatLineX(r),t.endY=n?s===Ne.Up?this.getScoreY(e.minRestLine):this.getScoreY(e.maxRestLine):s===Ne.Up?this.getFlagTopY(r,s)-i:this.getFlagBottomY(r,s)+i;const o=10;if(s===Ne.Down&&t.startY>t.endY&&t.startY-t.endY>o&&(t.endY=t.startY-o),s===Ne.Down&&t.endY>t.startY&&t.endY-t.startY>o&&(t.startY=t.endY-o),s===Ne.Up&&t.startY<t.endY&&t.endY-t.startY>o&&(t.endY=t.startY+o),s===Ne.Up&&t.endY<t.startY&&t.startY-t.endY>o&&(t.startY=t.endY+o),e.beats.length>1){if(s===Ne.Up){const s=this.getScoreY(this.accidentalHelper.getMinLine(e.beatOfHighestNote))-i,a=t.calcY(e.getBeatLineX(e.beatOfHighestNote))-s;a>0&&(t.startY-=a,t.endY-=a)}else{const s=this.getScoreY(this.accidentalHelper.getMaxLine(e.beatOfLowestNote))+i-t.calcY(e.getBeatLineX(e.beatOfLowestNote));s>0&&(t.startY+=s,t.endY+=s)}if(null!==e.minRestLine||null!==e.maxRestLine){const i=ae.getIndex(e.shortestDuration)-2,a=e.isGrace?Pr.GraceScale:1;let r=i*(Hn.BeamSpacing+Hn.BeamThickness)*a;if(r+=Hn.BeamSpacing,s===Ne.Up&&null!==e.minRestLine){const s=this.getScoreY(e.minRestLine)-r,i=t.calcY(e.getBeatLineX(e.beatOfMinRestLine))-s;i>0&&(t.startY-=i,t.endY-=i)}else if(s===Ne.Down&&null!==e.maxRestLine){const s=this.getScoreY(e.maxRestLine)+r-t.calcY(e.getBeatLineX(e.beatOfMaxRestLine));s>0&&(t.startY+=s,t.endY+=s)}}if(e.slashBeats.length>0)for(const a of e.slashBeats){const r=t.calcY(e.getBeatLineX(a));let n=this.getSlashFlagY(a.duration,s);s===Ne.Up?n-=i:s===Ne.Down&&(n+=i);const o=n-r;o>0&&(t.startY+=o,t.endY+=o)}}}return e.drawingInfos.get(s).calcY(t)}getBarLineStart(e,t){return e.slashed?this.getSlashFlagY(e.duration,t):t===Ne.Up?this.getScoreY(this.accidentalHelper.getMaxLine(e)):this.getScoreY(this.accidentalHelper.getMinLine(e))}createLinePreBeatGlyphs(){let e=!1;if(this.isFirstOfLine||this.bar.clef!==this.bar.previousBar.clef||this.bar.clefOttava!==this.bar.previousBar.clefOttava){let t=0;switch(this.bar.clef){case o.Neutral:t=this.bar.staff.standardNotationLineCount-1;break;case o.F4:t=2;break;case o.C3:t=4;break;case o.C4:t=2;break;case o.G2:t=6}this.createStartSpacing(),this.addPreBeatGlyph(new Wo(0,this.getScoreY(t)+.5*Hn.StaffLineThickness,this.bar.clef,this.bar.clefOttava)),e=!0}(e||0===this.index&&this.bar.keySignature!==c.C||this.bar.previousBar&&this.bar.keySignature!==this.bar.previousBar.keySignature)&&(this.createStartSpacing(),this.createKeySignatureGlyphs()),(!this.bar.previousBar||this.bar.previousBar&&this.bar.masterBar.timeSignatureNumerator!==this.bar.previousBar.masterBar.timeSignatureNumerator||this.bar.previousBar&&this.bar.masterBar.timeSignatureDenominator!==this.bar.previousBar.masterBar.timeSignatureDenominator||this.bar.previousBar&&this.bar.masterBar.isFreeTime&&this.bar.masterBar.isFreeTime!==this.bar.previousBar.masterBar.isFreeTime)&&(this.createStartSpacing(),this.createTimeSignatureGlyphs())}createKeySignatureGlyphs(){let e=0;const t=this.bar.keySignature,s=this.bar.previousBar?this.bar.previousBar.keySignature:0;switch(this.bar.clef){case o.Neutral:e=0;break;case o.G2:e=1;break;case o.F4:e=3;break;case o.C3:e=2;break;case o.C4:e=0}const i=new Vh;i.renderer=this;const a=new Map,r=[];if(ae.keySignatureIsSharp(t))for(let s=0;s<Math.abs(t);s++){const t=Gh.SharpKsSteps[s]+e;r.push(new Ho(0,this.getScoreY(t),It.Sharp,1)),a.set(t,!0)}else for(let s=0;s<Math.abs(t);s++){const t=Gh.FlatKsSteps[s]+e;r.push(new Ho(0,this.getScoreY(t),It.Flat,1)),a.set(t,!0)}if(this.bar.keySignature===c.C){const t=Math.abs(s),r=ae.keySignatureIsSharp(s)?Gh.SharpKsSteps:Gh.FlatKsSteps;for(let s=0;s<t;s++){const t=r[s]+e;a.has(t)||i.addGlyph(new Ho(0,this.getScoreY(r[s]+e),It.Natural,1))}}for(const e of r)i.addGlyph(e);this.addPreBeatGlyph(i)}createTimeSignatureGlyphs(){this.addPreBeatGlyph(new lh(0,0,5));const e=this.bar.staff.standardNotationLineCount-1;this.addPreBeatGlyph(new Bh(0,this.getScoreY(e),this.bar.masterBar.timeSignatureNumerator,this.bar.masterBar.timeSignatureDenominator,this.bar.masterBar.timeSignatureCommon,this.bar.masterBar.isFreeTime))}createVoiceGlyphs(e){for(const t of e.beats){const s=new Ph(t,this.getVoiceContainer(e));s.preNotes=new _h,s.onNotes=new fh,this.addBeatGlyph(s)}}getNoteLine(e){return this.accidentalHelper.getNoteLine(e)}completeBeamingHelper(e){if(this.bar.isMultiVoice&&e.highestNoteInHelper&&e.lowestNoteInHelper){let t=this.getNoteY(e.highestNoteInHelper,as.Center),s=this.getNoteY(e.lowestNoteInHelper,as.Center),i=this.getStemSize(e);e.hasTuplet&&(i+=2*this.resources.effectFont.size),e.direction===Ne.Up?t-=i:s+=i;for(const i of e.beats)this.helpers.collisionHelper.reserveBeatSlot(i,t,s)}}paintBeamingStem(e,t,s,i,a,r){const n=nn.beat(r,be.StandardNotationStem,e);try{r.lineWidth=Hn.StemWidth,r.beginPath(),r.moveTo(s,i),r.lineTo(s,a),r.stroke(),r.lineWidth=1}finally{n?.[Symbol.dispose]?.()}}}Gh.StaffId="score",Gh.SharpKsSteps=[-1,2,-2,1,4,0,3],Gh.FlatKsSteps=[3,0,4,1,5,2,6];class zh extends sn{get staffId(){return Gh.StaffId}getStaffPaddingTop(e){return e.system.layout.renderer.settings.display.notationStaffPaddingTop}getStaffPaddingBottom(e){return e.system.layout.renderer.settings.display.notationStaffPaddingBottom}create(e,t){return new Gh(e,t)}canCreate(e,t){return super.canCreate(e,t)&&t.showStandardNotation}}class Uh extends Tr{constructor(e,t,s,i){super(0,0),this._inType=e,this._outType=t,this._startNote=s,this._parent=i}doLayout(){this.width=0}paint(e,t,s){this.paintSlideIn(e,t,s),this.paintSlideOut(e,t,s)}paintSlideIn(e,t,s){const i=this.renderer;let a=0,r=0,n=0,o=0;switch(this._inType){case v.IntoFromBelow:n=e+i.x+i.getNoteX(this._startNote,rs.Left)-2,o=t+i.y+i.getNoteY(this._startNote,as.Center),a=n-12,r=t+i.y+i.getNoteY(this._startNote,as.Center)+3;break;case v.IntoFromAbove:n=e+i.x+i.getNoteX(this._startNote,rs.Left)-2,o=t+i.y+i.getNoteY(this._startNote,as.Center),a=n-12,r=t+i.y+i.getNoteY(this._startNote,as.Center)-3;break;default:return}this.paintSlideLine(s,!1,a,n,r,o)}paintSlideOut(e,t,s){const i=this.renderer;let a=0,r=0,n=0,o=0,h=!1;switch(this._outType){case P.Shift:case P.Legato:if(a=e+i.x+i.getBeatX(this._startNote.beat,ss.PostNotes)+2,r=t+i.y+i.getNoteY(this._startNote,as.Center),this._startNote.slideTarget){const s=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,this._startNote.slideTarget.beat.voice.bar);s&&s.staff===i.staff?(n=e+s.x+s.getBeatX(this._startNote.slideTarget.beat,ss.OnNotes)-2,o=t+s.y+s.getNoteY(this._startNote.slideTarget,as.Center)):(n=e+i.x+i.width,o=r),this._startNote.slideTarget.fret>this._startNote.fret?(r+=3,o-=3):(r-=3,o+=3)}else n=e+i.x+this._parent.x,o=r;break;case P.OutUp:a=e+i.x+i.getNoteX(this._startNote,rs.Right)+2,r=t+i.y+i.getNoteY(this._startNote,as.Center),n=a+12,o=t+i.y+i.getNoteY(this._startNote,as.Center)-3;break;case P.OutDown:a=e+i.x+i.getNoteX(this._startNote,rs.Right)+2,r=t+i.y+i.getNoteY(this._startNote,as.Center),n=a+12,o=t+i.y+i.getNoteY(this._startNote,as.Center)+3;break;case P.PickSlideDown:a=e+i.x+i.getNoteX(this._startNote,rs.Right)+4,r=t+i.y+i.getNoteY(this._startNote,as.Center),n=e+i.x+i.width,o=r+9,this._startNote.beat.nextBeat&&this._startNote.beat.nextBeat.voice===this._startNote.beat.voice&&(n=e+i.x+i.getBeatX(this._startNote.beat.nextBeat,ss.PreNotes)),h=!0;break;case P.PickSlideUp:a=e+i.x+i.getNoteX(this._startNote,rs.Right)+4,r=t+i.y+i.getNoteY(this._startNote,as.Center),n=e+i.x+i.width,o=r-9,this._startNote.beat.nextBeat&&this._startNote.beat.nextBeat.voice===this._startNote.beat.voice&&(n=e+i.x+i.getBeatX(this._startNote.beat.nextBeat,ss.PreNotes)),h=!0;break;default:return}this.paintSlideLine(s,h,a,n,r,o)}paintSlideLine(e,t,s,i,a,r){if(t){const t=new ko(0,0,F.Slight,1.2);t.renderer=this.renderer,t.doLayout(),a-=t.height/2;const n=i-s,o=(r-=t.height/2)-a,h=Math.sqrt(Math.pow(o,2)+Math.pow(n,2));t.width=n;const l=Math.asin(o/h)*(180/Math.PI);e.beginRotate(s,a,l),t.paint(0,0,e),e.endRotate()}else e.beginPath(),e.moveTo(s,a),e.lineTo(i,r),e.stroke()}}class Xh extends Xo{constructor(e,t,s=!1){super(e.beat,t.beat,s),this.startNote=e,this.endNote=t}getTieHeight(e,t,s,i){return this.startNote===this.endNote?15:super.getTieHeight(e,t,s,i)}getBeamDirection(e,t){return this.startNote===this.endNote?Ne.Up:Xh.getBeamDirectionForNote(this.startNote)}static getBeamDirectionForNote(e){return e.string>3?Ne.Up:Ne.Down}getStartY(){return this.startNote===this.endNote?this.startNoteRenderer.getNoteY(this.startNote,as.Center):this.tieDirection===Ne.Up?this.startNoteRenderer.getNoteY(this.startNote,as.Top):this.startNoteRenderer.getNoteY(this.startNote,as.Bottom)}getEndY(){return this.getStartY()}getStartX(){return this.startNote===this.endNote?this.getEndX()-20:this.startNoteRenderer.getNoteX(this.startNote,rs.Center)}getEndX(){return this.startNote===this.endNote?this.endNoteRenderer.getNoteX(this.endNote,rs.Left):this.endNoteRenderer.getNoteX(this.endNote,rs.Center)}}class Jh extends Xh{constructor(e,t,s,i=!1){super(e,t,i),this._direction=Xh.getBeamDirectionForNote(e),this._forSlide=s}getTieHeight(e,t,s,i){return Math.log(s-e+1)*this.renderer.settings.notation.slurHeight}tryExpand(e,t,s,i){if(this._forSlide!==s)return!1;if(this.forEnd!==i)return!1;if(this.startNote.beat.id!==e.beat.id)return!1;if(this.endNote.beat.id!==t.beat.id)return!1;if(this._direction!==Xh.getBeamDirectionForNote(e))return!1;switch(this._direction){case Ne.Up:e.realValue>this.startNote.realValue&&(this.startNote=e,this.startBeat=e.beat),t.realValue>this.endNote.realValue&&(this.endNote=t,this.endBeat=t.beat);break;case Ne.Down:e.realValue<this.startNote.realValue&&(this.startNote=e,this.startBeat=e.beat),t.realValue<this.endNote.realValue&&(this.endNote=t,this.endBeat=t.beat)}return!0}paint(e,t,s){const i=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,this.startBeat.voice.bar),a=this.getBeamDirection(this.startBeat,i),r=`tab.slur.${this.startNote.beat.id}.${this.endNote.beat.id}.${a}`,n=this.renderer;n.staff.getSharedLayoutData(r,!1)||(n.staff.setSharedLayoutData(r,!0),super.paint(e,t,s))}}class Yh extends Cr{constructor(){super(...arguments),this._bend=null,this._effectSlurs=[]}drawBeamHelperAsFlags(e){return e.hasFlag(this.renderer.drawBeamHelperAsFlags(e),this.beat)}doLayout(){this._effectSlurs=[],super.doLayout(),this._bend&&(this._bend.renderer=this.renderer,this._bend.doLayout(),this.updateWidth())}createTies(e){if(!e.isVisible)return;const t=this.renderer;if(e.isTieOrigin&&t.showTiedNotes&&e.tieDestination.isVisible){const t=new Xh(e,e.tieDestination,!1);this.addTie(t)}if(e.isTieDestination&&t.showTiedNotes){const t=new Xh(e.tieOrigin,e,!0);this.addTie(t)}if(e.isLeftHandTapped&&!e.isHammerPullDestination){const t=new Xh(e,e,!1);this.addTie(t)}if(e.isEffectSlurOrigin&&e.effectSlurDestination){let t=!1;for(const s of this._effectSlurs)if(s.tryExpand(e,e.effectSlurDestination,!1,!1)){t=!0;break}if(!t){const t=new Jh(e,e.effectSlurDestination,!1,!1);this._effectSlurs.push(t),this.addTie(t)}}if(e.isEffectSlurDestination&&e.effectSlurOrigin){let t=!1;for(const s of this._effectSlurs)if(s.tryExpand(e.effectSlurOrigin,e,!1,!0)){t=!0;break}if(!t){const t=new Jh(e.effectSlurOrigin,e,!1,!0);this._effectSlurs.push(t),this.addTie(t)}}if(e.slideInType!==v.None||e.slideOutType!==P.None){const t=new Uh(e.slideInType,e.slideOutType,e,this);this.addTie(t)}if(e.hasBend){if(!this._bend){const e=new nh;this._bend=e,e.renderer=this.renderer,this.addTie(e)}this._bend.addBends(e)}}}class $h extends Tr{constructor(e,t,s){super(e,t),this._noteString=null,this._trillNoteString=null,this._trillNoteStringWidth=0,this.isEmpty=!1,this.noteStringWidth=0,this._note=s}doLayout(){const t=this._note;let s=t.fret-t.beat.voice.bar.staff.transpositionPitch;if(t.harmonicType===N.Natural&&0!==t.harmonicValue&&(s=t.harmonicValue-t.beat.voice.bar.staff.transpositionPitch),t.isTieDestination)0===t.beat.index&&this.renderer.settings.notation.notationMode===e.NotationMode.GuitarPro||(t.bendType===b.Bend||t.bendType===b.BendRelease)&&this.renderer.settings.notation.isNotationElementVisible(e.NotationElement.TabNotesOnTiedBends)?this._noteString=`(${(t.tieOrigin.fret-t.beat.voice.bar.staff.transpositionPitch).toString()})`:this._noteString="";else if(this._noteString=t.isDead?"x":s.toString(),t.isGhost)this._noteString=`(${this._noteString})`;else if(t.harmonicType===N.Natural){const e=this._noteString.indexOf(String.fromCharCode(46));e>=0&&(this._noteString=this._noteString.substr(0,e+2)),this._noteString=`<${this._noteString}>`}if(t.isTrill)this._trillNoteString=`(${(t.trillFret-t.beat.voice.bar.staff.transpositionPitch).toString()})`;else if(ae.isAlmostEqualTo(t.harmonicValue,0))this._trillNoteString="";else switch(t.harmonicType){case N.Artificial:case N.Pinch:case N.Tap:case N.Semi:case N.Feedback:let e=(s+t.harmonicValue).toString();const i=e.indexOf(String.fromCharCode(46));i>=0&&(e=e.substr(0,i+2)),this._trillNoteString=`<${e}>`;break;default:this._trillNoteString=""}if(this.isEmpty=!this._noteString,!this.isEmpty){this.renderer.scoreRenderer.canvas.font=this.renderer.resources.tablatureFont,this.noteStringWidth=this.renderer.scoreRenderer.canvas.measureText(this._noteString).width,this.width=this.noteStringWidth,this.height=this.renderer.scoreRenderer.canvas.font.size;!!this._trillNoteString&&(this.renderer.scoreRenderer.canvas.font=this.renderer.resources.graceFont,this._trillNoteStringWidth=3+this.renderer.scoreRenderer.canvas.measureText(this._trillNoteString).width,this.width+=this._trillNoteStringWidth)}}paint(e,t,s){if(this.isEmpty)return;const i=this.noteStringWidth+this._trillNoteStringWidth,a=e+this.x+(this.width-i)/2;this.paintTrill(a,t,s);const r=nn.note(s,ce.GuitarTabFretNumber,this._note);try{s.fillText(this._noteString,a,t+this.y)}finally{r?.[Symbol.dispose]?.()}}paintTrill(e,t,s){const i=nn.note(s,ce.GuitarTabFretNumber,this._note);try{const i=this.renderer.scoreRenderer.canvas.font;this.renderer.scoreRenderer.canvas.font=this.renderer.resources.graceFont,s.fillText(this._trillNoteString,e+this.noteStringWidth+3,t+this.y),this.renderer.scoreRenderer.canvas.font=i}finally{i?.[Symbol.dispose]?.()}}buildBoundingsLookup(e,t,s){const i=new ar;i.note=this._note,i.noteHeadBounds=new ft,i.noteHeadBounds.x=t+this.x,i.noteHeadBounds.y=s+this.y-this.height/2,i.noteHeadBounds.w=this.width,i.noteHeadBounds.h=this.height,e.addNote(i)}}class qh extends Tr{constructor(e,t,s){super(e,t),this._notes=[],this._deadSlapped=null,this.minStringNote=null,this.beatEffects=new Map,this.notesPerString=new Map,this.noteStringWidth=0,this._isGrace=s}buildBoundingsLookup(e,t,s){for(const i of this._notes)i.buildBoundingsLookup(e,t+this.x,s+this.y)}getNoteX(e,t){if(this.notesPerString.has(e.string)){const s=this.notesPerString.get(e.string);let i=this.x+s.x;switch(t){case rs.Left:break;case rs.Center:i+=s.noteStringWidth/2;break;case rs.Right:i+=s.width}return i}return 0}getNoteY(e,t){if(this.notesPerString.has(e.string)){const s=this.notesPerString.get(e.string);let i=this.y+s.y;switch(t){case as.Top:case as.TopWithStem:i-=s.height/2+2;break;case as.Center:break;case as.Bottom:case as.BottomWithStem:i+=s.height/2}return i}return 0}doLayout(){let e=0;if(this.beat.deadSlapped)this._deadSlapped=new Qo,this._deadSlapped.renderer=this.renderer,this._deadSlapped.doLayout(),e=this._deadSlapped.width,this.noteStringWidth=e;else{let t=0;for(let s=0,i=this._notes.length;s<i;s++){const i=this._notes[s];i.renderer=this.renderer,i.doLayout(),i.width>e&&(e=i.width),i.noteStringWidth>t&&(t=i.noteStringWidth)}this.noteStringWidth=t;const s=this.renderer.resources.tablatureFont.size;let i=this.getNoteY(this.minStringNote,as.Center)+s/2;const a=7;for(const e of this.beatEffects.values())e.y+=i,e.x+=this.width/2,e.renderer=this.renderer,i+=a,e.doLayout()}this.width=e}addNoteGlyph(e,t){this._notes.push(e),this.notesPerString.set(t.string,e),(!this.minStringNote||t.string<this.minStringNote.string)&&(this.minStringNote=t)}paint(e,t,s){if(e+=this.x,t+=this.y,this.beat.deadSlapped)this._deadSlapped?.paint(e,t,s);else{const i=this.renderer.resources,a=s.textBaseline;s.textBaseline=he.Middle,s.font=this._isGrace?i.graceFont:i.tablatureFont;const r=this._notes,n=this.width;for(const i of r)i.renderer=this.renderer,i.width=n,i.paint(e,t,s);s.textBaseline=a;const o=nn.beat(s,be.GuitarTabEffects,this.beat);try{for(const i of this.beatEffects.values())i.paint(e,t,s)}finally{o?.[Symbol.dispose]?.()}}}updateBeamingHelper(e){this.beamingHelper&&this.beamingHelper.isPositionFrom("tab",this.beat)&&this.beamingHelper.registerBeatLineX("tab",this.beat,e+this.x+this.width/2,e+this.x+this.width/2)}}class jh extends vr{constructor(e,t,s,i){super(e,t,1,eh.getSymbol(i)),this._isVisibleRest=s}doLayout(){super.doLayout(),this._isVisibleRest||(this.width=10)}updateBeamingHelper(e){this.beamingHelper&&this.beamingHelper.isPositionFrom("tab",this.beat)&&this.beamingHelper.registerBeatLineX("tab",this.beat,e+this.x+this.width/2,e+this.x+this.width/2)}paint(e,t,s){if(this._isVisibleRest){const i=nn.beat(s,be.GuitarTabRests,this.beat);try{super.paint(e,t,s)}finally{i?.[Symbol.dispose]?.()}}}}class Kh extends An{constructor(){super(...arguments),this.slash=null,this.noteNumbers=null,this.restGlyph=null}get effectElement(){return be.GuitarTabEffects}getNoteX(e,t){return this.noteNumbers?this.noteNumbers.getNoteX(e,t):0}getNoteY(e,t){return this.noteNumbers?this.noteNumbers.getNoteY(e,t):0}buildBoundingsLookup(e,t,s){this.noteNumbers&&this.noteNumbers.buildBoundingsLookup(e,t+this.x,s+this.y)}doLayout(){const t=this.renderer;if(this.container.beat.isRest){const e=Math.floor((this.renderer.bar.staff.tuning.length-1)/2),s=t.getTabY(e),i=new jh(0,s,t.showRests,this.container.beat.duration);if(this.restGlyph=i,i.beat=this.container.beat,i.beamingHelper=this.beamingHelper,this.addNormal(i),this.container.beat.dots>0&&t.showRests){this.addNormal(new lh(0,0,5));for(let e=0;e<this.container.beat.dots;e++)this.addEffect(new Go(0,s,1.5))}}else{const s=this.renderer.settings.notation.smallGraceTabNotes&&this.container.beat.graceType!==B.None;let i;if(this.container.beat.slashed&&!this.container.beat.notes.some((e=>e.isTieDestination))){const e=Math.floor((this.renderer.bar.staff.tuning.length-1)/2),a=t.getLineY(e),r=new mh(0,a,this.container.beat.duration,s,this.container.beat);r.noteHeadElement=ce.GuitarTabFretNumber,r.effectElement=be.GuitarTabEffects,this.slash=r,r.beat=this.container.beat,r.beamingHelper=this.beamingHelper,this.addNormal(r),i=r.beatEffects}else{const e=new qh(0,0,s);this.noteNumbers=e,e.beat=this.container.beat,e.beamingHelper=this.beamingHelper;for(const e of this.container.beat.notes)e.isVisible&&this.createNoteGlyph(e);this.addNormal(e),i=e.beatEffects}if(this.container.beat.hasWhammyBar){const e=new oh(this.container.beat);e.renderer=this.renderer,e.doLayout(),this.container.ties.push(e)}if(this.container.beat.isTremolo&&!i.has("tremolo")){let e=0;const t=this.container.beat.tremoloSpeed;let s=5;switch(t){case w.ThirtySecond:e=10;break;case w.Sixteenth:e=5;break;case w.Eighth:e=0}this.container.beat.duration<w.Half&&(s=0),i.set("tremolo",new Ko(s,e,t))}if(this.container.beat.dots>0&&t.rhythmMode!==e.TabRhythmMode.Hidden){this.addNormal(new lh(0,0,5));for(let e=0;e<this.container.beat.dots;e++)this.addEffect(new Go(0,t.lineOffset*t.bar.staff.tuning.length+t.settings.notation.rhythmHeight,1.5))}}if(this.isEmpty)return;let s=0;for(let e=0,t=this.glyphs.length;e<t;e++){const t=this.glyphs[e];t.x=s,t.renderer=this.renderer,t.doLayout(),s+=t.width}this.width=s,this.computedWidth=s,this.container.beat.isEmpty?this.centerX=this.width/2:this.restGlyph?this.centerX=this.restGlyph.x+this.restGlyph.width/2:this.noteNumbers?this.centerX=this.noteNumbers.x+this.noteNumbers.noteStringWidth/2:this.slash&&(this.centerX=this.slash.x+this.slash.width/2)}updateBeamingHelper(){this.noteNumbers?this.noteNumbers.updateBeamingHelper(this.container.x+this.x):this.restGlyph?this.restGlyph.updateBeamingHelper(this.container.x+this.x):this.slash&&this.slash.updateBeamingHelper(this.container.x+this.x)}createNoteGlyph(e){const t=this.renderer,s=new $h(0,0,e),i=e.beat.voice.bar.staff.tuning.length-e.string;s.y=t.getTabY(i),s.renderer=this.renderer,s.doLayout(),this.noteNumbers.addNoteGlyph(s,e);const a=s.y-s.height/2,r=a+s.height;this.renderer.helpers.collisionHelper.reserveBeatSlot(this.container.beat,a,r)}}class Qh extends Tr{constructor(e){super(0,0),this._beat=e}doLayout(){this.width=10}paint(e,t,s){const i=this.renderer,a=t+this.x+i.getNoteY(this._beat.maxStringNote,as.Top),r=t+this.y+i.getNoteY(this._beat.minStringNote,as.Bottom),n=e+this.x+this.width/2|0;if(this._beat.brushType!==S.None){if(this._beat.brushType===S.BrushUp||this._beat.brushType===S.BrushDown)s.beginPath(),s.moveTo(n,a),s.lineTo(n,r),s.stroke();else if(this._beat.brushType===S.ArpeggioUp){const t=new ko(0,0,F.Slight,1.2,!0);t.renderer=this.renderer,t.doLayout();const i=a,n=r-8;t.width=Math.abs(n-i),s.beginRotate(e+this.x+4,n,-90),t.paint(0,-t.height/2,s),s.endRotate()}else if(this._beat.brushType===S.ArpeggioDown){const t=new ko(0,0,F.Slight,1.2,!0);t.renderer=this.renderer,t.doLayout();const i=a+8,n=r;t.width=Math.abs(n-i),s.beginRotate(e+this.x+4,i,90),t.paint(0,-t.height/2,s),s.endRotate()}this._beat.brushType===S.BrushUp||this._beat.brushType===S.ArpeggioUp?(s.beginPath(),s.moveTo(n,r),s.lineTo(n+4,r-8),s.lineTo(n-4,r-8),s.closePath(),s.fill()):(s.beginPath(),s.moveTo(n,a),s.lineTo(n+4,a+8),s.lineTo(n-4,a+8),s.closePath(),s.fill())}}}class Zh extends Ln{doLayout(){this.container.beat.brushType===S.None||this.container.beat.isRest||(this.addEffect(new Qh(this.container.beat)),this.addNormal(new lh(0,0,4))),super.doLayout()}get effectElement(){return be.GuitarTabEffects}}class el extends Tr{doLayout(){this.width=xr.Widths.get(ne.SixStringTabClef)}paint(e,t,s){const i=nn.bar(s,p.GuitarTabsClef,this.renderer.bar);try{const i=this.renderer.bar.staff.tuning.length,a=i<=4?ne.FourStringTabClef:ne.SixStringTabClef,r=i<=4?i/4.5:i/6.5;s.fillMusicFontSymbol(e+this.x+5,t+this.y,r,a,!1)}finally{i?.[Symbol.dispose]?.()}}}class tl extends wh{doLayout(){this.barSubElement=p.GuitarTabsTimeSignature,super.doLayout()}get commonScale(){return 1}get numberScale(){return this.renderer.bar.staff.tuning.length<=4?Pr.GraceScale:1}}class sl extends Wh{get showMultiBarRest(){return this._showMultiBarRest}get repeatsBarSubElement(){return p.GuitarTabsRepeats}get barNumberBarSubElement(){return p.GuitarTabsBarNumber}get barLineBarSubElement(){return p.GuitarTabsBarLines}get staffLineBarSubElement(){return p.GuitarTabsStaffLine}constructor(e,t){super(e,t),this._hasTuplets=!1,this.showTimeSignature=!1,this.showRests=!1,this.showTiedNotes=!1,this._showMultiBarRest=!1,t.staff.showStandardNotation||(this.showTimeSignature=!0,this.showRests=!0,this.showTiedNotes=!0,this._showMultiBarRest=!0)}get lineSpacing(){return sl.TabLineSpacing}get heightLineCount(){return this.bar.staff.tuning.length}get drawnLineCount(){return this.bar.staff.tuning.length}get rhythmMode(){let t=this.settings.notation.rhythmMode;return t===e.TabRhythmMode.Automatic&&(t=this.bar.staff.showStandardNotation?e.TabRhythmMode.Hidden:e.TabRhythmMode.ShowWithBars),t}getTabY(e){return super.getLineY(e)}getTabHeight(e){return super.getLineHeight(e)}collectSpaces(e){for(const t of this.bar.voices)if(this.hasVoiceContainer(t)){const s=this.getVoiceContainer(t);for(const t of s.beatGlyphs){const i=t.onNotes,a=i.noteNumbers;if(a)for(const[r,n]of a.notesPerString)n.isEmpty||e[this.bar.staff.tuning.length-r].push(new Float32Array([s.x+t.x+i.x+a.x,a.width+1]))}}}adjustSizes(){this.rhythmMode!==e.TabRhythmMode.Hidden&&(this.height+=this.settings.notation.rhythmHeight,this.bottomPadding+=this.settings.notation.rhythmHeight)}doLayout(){if(super.doLayout(),this.rhythmMode!==e.TabRhythmMode.Hidden){this._hasTuplets=!1;for(const e of this.bar.voices)if(this.hasVoiceContainer(e)){if(this.getVoiceContainer(e).tupletGroups.length>0){this._hasTuplets=!0;break}}this._hasTuplets&&this.registerOverflowBottom(this.tupletSize)}}createLinePreBeatGlyphs(){if(this.isFirstOfLine){const e=(this.bar.staff.tuning.length-1)/2;this.addPreBeatGlyph(new el(5,this.getTabY(e)))}this.showTimeSignature&&(!this.bar.previousBar||this.bar.previousBar&&this.bar.masterBar.timeSignatureNumerator!==this.bar.previousBar.masterBar.timeSignatureNumerator||this.bar.previousBar&&this.bar.masterBar.timeSignatureDenominator!==this.bar.previousBar.masterBar.timeSignatureDenominator||this.bar.previousBar&&this.bar.masterBar.isFreeTime&&this.bar.masterBar.isFreeTime!==this.bar.previousBar.masterBar.isFreeTime)&&(this.createStartSpacing(),this.createTimeSignatureGlyphs())}createTimeSignatureGlyphs(){this.addPreBeatGlyph(new lh(0,0,5));const e=(this.bar.staff.tuning.length+1)/2-1;this.addPreBeatGlyph(new tl(0,this.getTabY(e),this.bar.masterBar.timeSignatureNumerator,this.bar.masterBar.timeSignatureDenominator,this.bar.masterBar.timeSignatureCommon,this.bar.masterBar.isFreeTime))}createVoiceGlyphs(e){if(this.additionalMultiRestBars){const t=new On(this.getVoiceContainer(e));this.addBeatGlyph(t)}else for(const t of e.beats){const s=new Yh(t,this.getVoiceContainer(e));s.preNotes=new Zh,s.onNotes=new Kh,this.addBeatGlyph(s)}}paint(t,s,i){super.paint(t,s,i),this.rhythmMode!==e.TabRhythmMode.Hidden&&(this.paintBeams(t,s,i,be.GuitarTabFlags,be.GuitarTabBeams),this.paintTuplets(t,s,i,be.GuitarTabTuplet))}drawBeamHelperAsFlags(t){return super.drawBeamHelperAsFlags(t)||this.rhythmMode===e.TabRhythmMode.ShowWithBeams}getFlagTopY(e,t){const s=this.getOnNotesGlyphForBeat(e);return s.noteNumbers&&e.duration!==w.Half?s.noteNumbers.getNoteY(s.noteNumbers.minStringNote,as.Bottom):this.height-this.settings.notation.rhythmHeight-this.tupletSize}getFlagBottomY(e,t){return this.getFlagAndBarPos()}getFlagStemSize(e,t=!1){return 0}getBarLineStart(e,t){const s=this.getOnNotesGlyphForBeat(e);return s.noteNumbers&&e.duration!==w.Half?s.noteNumbers.getNoteY(s.noteNumbers.minStringNote,as.Bottom)+this.lineOffset/2:this.height-this.settings.notation.rhythmHeight-this.tupletSize}getBeamDirection(e){return Ne.Down}getFlagAndBarPos(){return this.height-(this._hasTuplets?this.tupletSize/2:0)}calculateBeamYWithDirection(e,t,s){return this.getFlagAndBarPos()}shouldPaintFlag(e,t){return!!super.shouldPaintFlag(e,t)&&(e.graceType===B.None&&this.drawBeamHelperAsFlags(t))}paintBeamingStem(e,t,s,i,a,r){if(a<i){const e=a;a=i,i=e}const n=nn.beat(r,be.GuitarTabStem,e);try{r.lineWidth=Hn.StemWidth,r.beginPath();let n=[];this.helpers.collisionHelper.reservedLayoutAreasByDisplayTime.has(e.displayStart)&&(n=this.helpers.collisionHelper.reservedLayoutAreasByDisplayTime.get(e.displayStart).slots.slice(),n.sort(((e,t)=>e.topY-t.topY)));let o=a;for(;o>i;){r.moveTo(s,o);let e=i;if(!(n.length>0&&n[n.length-1].bottomY>e)){r.lineTo(s,e);break}{const i=n.pop();e=t+i.bottomY,r.lineTo(s,e),o=t+i.topY}}r.stroke(),r.lineWidth=1}finally{n?.[Symbol.dispose]?.()}}}sl.StaffId="tab",sl.TabLineSpacing=10;class il extends sn{get staffId(){return sl.StaffId}getStaffPaddingTop(e){return e.system.layout.renderer.settings.display.notationStaffPaddingTop}getStaffPaddingBottom(e){return e.system.layout.renderer.settings.display.notationStaffPaddingBottom}constructor(){super(),this.showTimeSignature=null,this.showRests=null,this.showTiedNotes=null,this.hideOnPercussionTrack=!0}canCreate(e,t){return t.showTablature&&t.tuning.length>0&&super.canCreate(e,t)}create(e,t){const s=new sl(e,t);return null!==this.showRests&&(s.showRests=this.showRests),null!==this.showTimeSignature&&(s.showTimeSignature=this.showTimeSignature),null!==this.showTiedNotes&&(s.showTiedNotes=this.showTiedNotes),s}}class al extends Nr{constructor(){super(0,0)}doLayout(){super.doLayout();const e=this.renderer.resources.effectFont;this.height=e.size+al.Padding}paint(e,t,s){const i=this.renderer.resources;s.font=i.effectFont;const a=s.textAlign;s.textAlign=oe.Center,s.fillText("T",e+this.x,t+this.y+s.font.size/2),s.textAlign=a,s.strokeCircle(e+this.x,t+this.y+s.font.size/2+(al.Padding-1),s.font.size/1.6)}}al.Padding=4;class rl extends oo{get notationElement(){return e.NotationElement.EffectTap}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyphForNote(e){return e.isLeftHandTapped}createNewGlyph(e,t){return new al}}class nl{constructor(){this.noteRange=1,this.x=0,this.y=0}}!function(e){e[e.None=0]="None",e[e.Rectangle=1]="Rectangle",e[e.Ellipse=2]="Ellipse",e[e.Circle=3]="Circle"}(hs||(hs={}));class ol extends nl{constructor(){super(...arguments),this.align=oe.Left,this.frame=hs.None,this.text="",this.fontFace="",this.weight=0,this.height=0}}class hl extends nl{constructor(){super(...arguments),this.chord=new Ke}}class ll extends nl{}class cl extends nl{}class dl extends nl{constructor(){super(...arguments),this.number=0}}class ul extends nl{constructor(){super(...arguments),this.decrescendo=!1}}class pl extends nl{constructor(){super(...arguments),this.allNumbers=!1,this.firstNumber=0,this.lastNumber=0}}class gl extends nl{constructor(){super(...arguments),this.octave=1}}class ml extends nl{}class fl{constructor(){this.defaultClef=o.G2,this.description="",this.percussion=!1,this.instrument=0,this.volume=0,this.transpose=0,this.index=0}}class yl{constructor(){this.from=0,this.to=0,this.curly=!1}}class bl{constructor(){this.currentBarIndex=-1,this.currentBarComplete=!0,this.currentBarDuration=0,this.currentPosition=0,this.voiceStemDir=null,this.repeatCount=0,this.repeatEnd=null}}class Sl{constructor(){this._trackChannel=0,this._beamingMode=ye.Auto,this._isFirstSystem=!0,this._staffLookup=new Map,this._brackets=[],this._staffLayoutLookup=new Map,this._staffLayouts=[],this._timeSignature=new K,this._voiceStates=new Map}parseXml(e,t){this._galleryObjects=new Map,this._tieStarts=[],this._tieStartIds=new Map,this._voiceCounts=new Map,this._slurs=new Map,this._crescendo=new Map,this._isFirstSystem=!0;const s=new Bt;try{s.parse(e)}catch(e){throw new je("Could not parse XML",e)}this.parseDom(s),this.consolidate(),this.score.finish(t)}consolidate(){ae.consolidate(this.score),Sl.applyEffectRange(this._slurs,((e,t)=>{t.isLegatoOrigin=!0})),Sl.applyEffectRange(this._crescendo,((e,t)=>{t.crescendo=e.decrescendo?_.Decrescendo:_.Crescendo}))}static applyEffectRange(e,t){for(const[s,i]of e){const e=i.noteRange;let a=s;for(let s=0;s<e;s++)if(t(i,a),a.index+1<a.voice.beats.length)a=a.voice.beats[a.index+1];else{if(!(a.voice.bar.index+1<a.voice.bar.staff.bars.length))break;a=a.voice.bar.staff.bars[a.voice.bar.index+1].voices[a.voice.index].beats[0]}}}parseDom(e){const t=e.firstElement;if(!t)throw new je("No valid XML");if("score"!==t.localName)throw new je('Root node of XML was not "score"');this.score=new Ye,this.score.tempo=120;for(const e of t.childElements())switch(e.localName){case"info":this.parseInfo(e);break;case"layout":this.parseLayout(e);break;case"gallery":this.parseGallery(e);break;case"pageObjects":this.parsePageObjects(e);break;case"systems":this.parseSystems(e)}}parseLayout(e){for(const t of e.childElements())switch(t.localName){case"staves":this.parseLayoutStaves(t);break;case"brackets":this.parseBrackets(t)}const t=this._brackets.filter((e=>!!e.curly));t.sort(((e,t)=>e.from-t.from));let s=0,i=null;for(let e=0;e<this._staffLayouts.length;e++){const a=this._staffLayouts[e];for(;s<t.length&&e>t[s].to;)s++;i&&s<t.length&&e>t[s].from&&e<=t[s].to?i.ensureStaveCount(i.staves.length+1):(i=new nt,i.ensureStaveCount(1),i.name=a.description,i.playbackInfo.volume=Math.floor(a.volume/128*16),i.playbackInfo.program=a.instrument,a.percussion?(i.playbackInfo.primaryChannel=9,i.playbackInfo.secondaryChannel=9):(i.playbackInfo.primaryChannel=this._trackChannel++,i.playbackInfo.secondaryChannel=this._trackChannel++),this.score.addTrack(i));const r=i.staves[i.staves.length-1];r.isPercussion=a.percussion,r.transpositionPitch=a.transpose,r.displayTranspositionPitch=0,r.showTablature=!1,this._staffLookup.set(a.index,r)}}parseBrackets(e){for(const t of e.childElements())if("bracket"===t.localName)this.parseBracket(t)}parseBracket(e){const t=new yl;t.from=Number.parseInt(e.getAttribute("from")),t.to=Number.parseInt(e.getAttribute("to")),e.attributes.has("curly")&&(t.curly="true"===e.attributes.get("curly")),this._brackets.push(t)}parseLayoutStaves(e){for(const t of e.childElements())if("staffLayout"===t.localName)this.parseStaffLayout(t)}parseStaffLayout(e){const t=new fl;t.description=e.getAttribute("description");for(const s of e.childElements())switch(s.localName){case"notation":s.attributes.has("defaultClef")&&(t.defaultClef=this.parseClef(s.attributes.get("defaultClef")));break;case"sound":s.attributes.has("percussion")&&(t.percussion="true"===s.attributes.get("percussion")),s.attributes.has("instr")&&(t.instrument=Number.parseInt(s.attributes.get("instr"))),s.attributes.has("volume")&&(t.volume=Number.parseInt(s.attributes.get("volume"))),s.attributes.has("transpose")&&(t.transpose=Number.parseInt(s.attributes.get("transpose")))}this._staffLayoutLookup.set(t.description,t),t.index=this._staffLayouts.length,this._staffLayouts.push(t)}parseClef(e){switch(e){case"treble":return o.G2;case"bass":return o.F4;case"alto":case"tenor":return o.C4}return o.G2}parseClefOttava(e){return e.endsWith("-")?h._8vb:e.endsWith("+")?h._8va:h.Regular}parseSystems(e){for(const t of e.childElements())if("system"===t.localName)this.parseSystem(t)}parseSystem(e){e.attributes.has("tempo")&&0===this.score.masterBars.length&&(this.score.tempo=Number.parseInt(e.attributes.get("tempo"))),"0"===e.getAttribute("beamGrouping")&&(this._beamingMode=ye.ForceSplitToNext);for(const t of e.childElements())if("staves"===t.localName)this.parseStaves(e,t);this._isFirstSystem=!1}parseStaves(e,t){const s=this.score.masterBars.length;for(const i of t.childElements())if("staff"===i.localName)this.parseStaff(e,s,i)}parseStaff(e,t,s){const i=s.getAttribute("layout");this._currentStaffLayout=this._staffLayoutLookup.get(i),this._timeSignature.timeSignatureNumerator=4,this._timeSignature.timeSignatureDenominator=4,this._timeSignature.timeSignatureCommon=!1,this.parseTime(s.getAttribute("defaultTime"));const a=this._staffLookup.get(this._currentStaffLayout.index);for(;a.bars.length<t;)this.addNewBar(a);for(const r of s.childElements())if("voices"===r.localName)this.parseVoices(i,a,e,t,r)}parseTime(e){switch(e){case"allaBreve":case"C":this._timeSignature.timeSignatureNumerator=2,this._timeSignature.timeSignatureDenominator=2,this._timeSignature.timeSignatureCommon=!0;break;case"longAllaBreve":this._timeSignature.timeSignatureNumerator=4,this._timeSignature.timeSignatureDenominator=4,this._timeSignature.timeSignatureCommon=!0;break;default:if(e.indexOf("/")>0){const t=e.split("/");this._timeSignature.timeSignatureNumerator=Number.parseInt(t[0]),this._timeSignature.timeSignatureDenominator=Number.parseInt(t[1]),this._timeSignature.timeSignatureCommon=!1}}}parseVoices(e,t,s,i,a){let r=0;for(const n of a.childElements())if("voice"===n.localName)this.parseVoice(e,t,s,r,i,n),r++}getOrCreateBar(e,t){return t<e.bars.length?e.bars[t]:this.addNewBar(e)}addNewBar(e){const t=new z;if(e.bars.length>0?(t.clef=e.bars[e.bars.length-1].clef,t.clefOttava=e.bars[e.bars.length-1].clefOttava,t.keySignature=e.bars[e.bars.length-1].keySignature,t.keySignatureType=e.bars[e.bars.length-1].keySignatureType):t.clef=this._currentStaffLayout.defaultClef,e.addBar(t),e.bars.length>this.score.masterBars.length){const e=new K;this.score.addMasterBar(e),e.index>0&&(e.tripletFeel=e.previousMasterBar.tripletFeel),e.timeSignatureDenominator=this._timeSignature.timeSignatureDenominator,e.timeSignatureNumerator=this._timeSignature.timeSignatureNumerator,e.timeSignatureCommon=this._timeSignature.timeSignatureCommon}return t}newBar(e,t){this._currentVoiceState.currentBarIndex++,this._currentBar=this.getOrCreateBar(e,this._currentVoiceState.currentBarIndex),this._currentVoiceState.currentBarDuration=this._currentBar.masterBar.calculateDuration(!1),this._currentVoiceState.currentBarComplete=!1,this._currentVoiceState.currentPosition=0,this.ensureVoice(e,t)}parseVoice(e,t,s,i,a,r){const n=`${e}_${i}`;if(this._currentVoiceState&&!this._currentVoiceState.currentBarComplete&&(this._currentBar.masterBar.isAnacrusis=!0),this._voiceStates.has(n)?(this._currentVoiceState=this._voiceStates.get(n),this._currentBar=this.getOrCreateBar(t,this._currentVoiceState.currentBarIndex),this.ensureVoice(t,i)):(this._currentVoiceState=new bl,this._currentVoiceState.currentBarIndex=a-1,this._voiceStates.set(n,this._currentVoiceState),this.newBar(t,i)),r.attributes.has("stemDir"))switch(r.attributes.get("stemDir")){case"up":this._currentVoiceState.voiceStemDir=Ne.Up;break;case"down":this._currentVoiceState.voiceStemDir=Ne.Down;break;default:this._currentVoiceState.voiceStemDir=null}else this._currentVoiceState.voiceStemDir=null;const o=r.findChildElement("noteObjects");if(s.attributes.has("tempo")){const e=new X;e.isLinear=!0,e.type=f.Tempo,e.value=Number.parseInt(s.attributes.get("tempo")),e.ratioPosition=this._currentVoiceState.currentPosition/this._currentVoiceState.currentBarDuration,this._currentBar.masterBar.tempoAutomations.push(e)}if(o)for(const e of o.childElements())switch(this._currentVoiceState.currentBarComplete&&"barline"!==e.localName&&this.newBar(t,i),e.localName){case"clefSign":this._currentBar.clef=this.parseClef(e.getAttribute("clef")),this._currentBar.clefOttava=this.parseClefOttava(e.getAttribute("clef"));break;case"keySign":this._currentBar.keySignature=Number.parseInt(e.getAttribute("fifths"));break;case"timeSign":this.parseTime(e.getAttribute("time")),this._currentBar.masterBar.timeSignatureDenominator=this._timeSignature.timeSignatureDenominator,this._currentBar.masterBar.timeSignatureNumerator=this._timeSignature.timeSignatureNumerator,this._currentBar.masterBar.timeSignatureCommon=this._timeSignature.timeSignatureCommon,this._currentVoiceState.currentPosition=0,this._currentVoiceState.currentBarDuration=this._currentBar.masterBar.calculateDuration(!1);break;case"barline":switch(e.getAttribute("type")){case"double":this._currentBar.barLineRight=g.LightLight,this._currentVoiceState.currentBarComplete||(this._currentBar.masterBar.isAnacrusis=!0),this._currentVoiceState.currentBarComplete=!0;break;case"end":this._currentVoiceState.currentBarComplete||(this._currentBar.masterBar.isAnacrusis=!0);break;case"repEnd":this._currentVoiceState.repeatEnd=this._currentBar.masterBar,this._currentBar.masterBar.repeatCount<this._currentVoiceState.repeatCount&&(this._currentBar.masterBar.repeatCount=this._currentVoiceState.repeatCount),this.parseBarDrawObject(e),this._currentVoiceState.currentBarComplete||(this._currentBar.masterBar.isAnacrusis=!0),this._currentVoiceState.currentBarComplete=!0;break;case"repBegin":this.newBar(t,i),this._currentBar.masterBar.isRepeatStart=!0,this._currentVoiceState.repeatEnd=null,this._currentVoiceState.repeatCount=0;break;case"repEndBegin":this._currentVoiceState.repeatEnd=this._currentBar.masterBar,this._currentBar.masterBar.repeatCount<this._currentVoiceState.repeatCount&&(this._currentBar.masterBar.repeatCount=this._currentVoiceState.repeatCount),this.parseBarDrawObject(e),this.newBar(t,i),this._currentBar.masterBar.isRepeatStart=!0;break;default:this._currentVoiceState.currentBarComplete||(this._currentBar.masterBar.isAnacrusis=!0),this._currentVoiceState.currentBarComplete=!0}break;case"chord":const s=new Ue;this.initFromPreviousBeat(s,this._currentVoice),s.beamingMode=this._beamingMode,this._currentVoiceState.voiceStemDir&&(s.preferredBeamDirection=this._currentVoiceState.voiceStemDir),this.parseDuration(this._currentBar,s,e.findChildElement("duration")),s.updateDurations(),this._currentVoiceState.currentPosition+=s.playbackDuration,this._currentVoice.addBeat(s),this.parseChord(s,e),this._currentVoiceState.currentPosition>=this._currentVoiceState.currentBarDuration&&(this._currentVoiceState.currentBarComplete=!0);break;case"rest":const a=this.parseRestDurations(this._currentBar,e.findChildElement("duration"));a&&(this.initFromPreviousBeat(a,this._currentVoice),a.updateDurations(),this._currentVoiceState.currentPosition+=a.playbackDuration,this._currentVoice.addBeat(a),this._currentVoiceState.currentPosition>=this._currentVoiceState.currentBarDuration&&(this._currentVoiceState.currentBarComplete=!0))}}initFromPreviousBeat(e,t){const s=this.getLastBeat(t);s&&(e.dynamics=s.dynamics)}getLastBeat(e){if(e.beats.length>0)return e.beats[e.beats.length-1];if(e.bar.index>0){const t=e.bar.staff.bars[e.bar.index-1];if(e.index<t.voices.length){const s=t.voices[e.index];return this.getLastBeat(s)}}return null}ensureVoice(e,t){for(;this._currentBar.voices.length<t+1;)this._currentBar.addVoice(new te);(!this._voiceCounts.has(e.track.index)||this._voiceCounts.get(e.track.index)<this._currentBar.voices.length)&&this._voiceCounts.set(e.track.index,this._currentBar.voices.length),this._currentVoice=this._currentBar.voices[t]}parseChord(e,t){const s=new Re;for(const i of t.childElements())switch(i.localName){case"stem":switch(i.getAttribute("dir")){case"up":e.preferredBeamDirection=Ne.Up;break;case"down":e.preferredBeamDirection=Ne.Down}break;case"articulation":switch(i.getAttribute("type")){case"staccato":s.isStaccato=!0;break;case"normalAccent":s.accentuated=k.Normal;break;case"strongAccent":s.accentuated=k.Heavy}break;case"lyric":this.parseLyric(e,i);break;case"drawObjects":this.parseBeatDrawObject(e,i);break;case"heads":this.parseHeads(e,s,i);break;case"beam":switch(i.getAttribute("group")){case"force":e.beamingMode=ye.ForceMergeWithNext;break;case"divide":e.beamingMode=ye.ForceSplitToNext}}}parseHeads(e,t,s){for(const i of s.childElements())if("head"===i.localName)this.parseHead(e,t,i)}parseHead(e,t,s){const i=new Re,a=ae.parseTuning(s.getAttribute("pitch"));i.octave=a.octave-1,i.tone=a.tone.noteValue,i.isStaccato=t.isStaccato,i.accentuated=t.accentuated,e.addNote(i);for(const e of s.childElements())switch(e.localName){case"alter":e.attributes.has("step")&&(i.tone+=Number.parseInt(e.attributes.get("step")));break;case"tie":e.attributes.has("begin")?this._tieStartIds.has(i.id)||(this._tieStartIds.set(i.id,!0),this._tieStarts.push(i)):e.attributes.has("end")&&this._tieStarts.length>0&&!i.isTieDestination&&(i.isTieDestination=!0,i.tieOrigin=this._tieStarts[0],this._tieStarts.splice(0,1),this._tieStartIds.delete(i.id))}}parseBeatDrawObject(e,t){for(const s of t.childElements())if("drawObj"===s.localName){const t=this.parseDrawObj(s);if(t)if(t instanceof ol)t.fontFace.startsWith("capella")?"u"===t.text?(e.fermata=new ct,e.fermata.type=Te.Medium):"f"===t.text?e.dynamics=m.F:"j"===t.text&&(e.dynamics=m.MF):this._isFirstSystem&&""===this.score.title&&t.align===oe.Center&&t.height>16&&t.weight>400?this.score.title=t.text:this._isFirstSystem&&""===this.score.artist&&t.align===oe.Center&&t.y<0?this.score.artist=t.text:this._isFirstSystem&&""===this.score.music&&t.align===oe.Right&&t.y<0?this.score.music=t.text:t.text.startsWith("by capella")||(e.text=t.text);else if(t instanceof hl);else if(t instanceof cl)e.vibrato=F.Slight;else if(t instanceof ul)e.crescendo=t.decrescendo?_.Decrescendo:_.Crescendo,t.noteRange++,this._crescendo.set(e,t);else if(t instanceof ll){const s=t;this._slurs.set(e,s)}else t instanceof pl&&this.applyVolta(t)}}parseBarDrawObject(e){for(const t of e.childElements())if("drawObj"===t.localName){const e=this.parseDrawObj(t);e&&e instanceof pl&&this.applyVolta(e)}}applyVolta(e){if(e.lastNumber>0?(this._currentVoiceState.repeatCount=e.lastNumber,this._currentVoiceState.repeatEnd&&this._currentVoiceState.repeatEnd.repeatCount<this._currentVoiceState.repeatCount&&(this._currentVoiceState.repeatEnd.repeatCount=this._currentVoiceState.repeatCount)):e.firstNumber>0&&(this._currentVoiceState.repeatCount=e.firstNumber,this._currentVoiceState.repeatEnd&&this._currentVoiceState.repeatEnd.repeatCount<this._currentVoiceState.repeatCount&&(this._currentVoiceState.repeatEnd.repeatCount=this._currentVoiceState.repeatCount)),e.lastNumber>0&&e.firstNumber>0){let t=0;for(let s=e.firstNumber;s<=e.lastNumber;s++)t|=1<<s-1;this._currentBar.masterBar.alternateEndings=t}else e.lastNumber>0?this._currentBar.masterBar.alternateEndings=1<<e.lastNumber-1:e.firstNumber>0&&(this._currentBar.masterBar.alternateEndings=1<<e.firstNumber-1)}parseLyric(e,t){for(const s of t.childElements())if("verse"===s.localName){e.lyrics||(e.lyrics=[]);let t=s.innerText;"true"===s.getAttribute("hyphen")&&(t+="-"),e.lyrics.push(t)}}parseRestDurations(e,t){const s=t.getAttribute("base");if(-1!==s.indexOf("/")){const s=new Ue;return s.beamingMode=this._beamingMode,this.parseDuration(e,s,t),s}if(1===Number.parseInt(s)){const e=new Ue;return e.beamingMode=this._beamingMode,e.duration=w.Whole,e}return j.warning("Importer","Multi-Bar rests are not supported"),null}parseDurationValue(e){switch(e){case"2/1":return w.DoubleWhole;case"1/1":return w.Whole;case"1/2":return w.Half;case"1/4":return w.Quarter;case"1/8":return w.Eighth;case"1/16":return w.Sixteenth;case"1/32":return w.ThirtySecond;case"1/64":return w.SixtyFourth;case"1/128":return w.OneHundredTwentyEighth;default:return j.warning("Importer","Unsupported duration"),w.Quarter}}parseDuration(e,t,s){const i=s.getAttribute("base");t.duration=this.parseDurationValue(i),s.attributes.has("dots")&&(t.dots=Number.parseInt(s.attributes.get("dots")));const a=s.findChildElement("tuplet");if(a){t.tupletNumerator=Number.parseInt(a.getAttribute("count"));const e="true"===a.getAttribute("tripartite")?3:1,s="true"===a.getAttribute("prolong")?0:1;let i=0;for(;e*Math.pow(2,i+s)<t.tupletNumerator;)i++;t.tupletDenominator=e*Math.pow(2,i)}}parsePageObjects(e){for(const t of e.childElements())if("drawObj"===t.localName){const e=this.parseDrawObj(t);if(e&&e instanceof ol)switch(e.align){case oe.Center:this.score.title?this.score.subTitle||(this.score.subTitle=t.innerText):this.score.title=t.innerText;break;case oe.Right:this.score.artist||(this.score.artist=t.innerText)}}}parseGallery(e){for(const t of e.childElements())if("drawObj"===t.localName){const e=this.parseDrawObj(t);e&&this._galleryObjects.set(t.getAttribute("name"),e)}}parseDrawObj(e){let t=null,s=1;for(const i of e.childElements())switch(i.localName){case"text":t=this.parseText(i);break;case"guitar":t=this.parseGuitar(i);break;case"slur":t=this.parseSlur(i);break;case"wavyLine":t=this.parseWavyLine(i);break;case"bracket":t=this.parseTupletBracket(i);break;case"wedge":t=this.parseWedge(i);break;case"volta":t=this.parseVolta(i);break;case"octaveClef":t=this.parseOctaveClef(i);break;case"trill":t=this.parseTrill(i);break;case"basic":i.attributes.has("noteRange")&&(s=Number.parseInt(i.attributes.get("noteRange")))}return t&&(t.noteRange=s),t}parseTrill(e){return new ml}parseOctaveClef(e){const t=new gl;return e.attributes.has("octave")&&(t.octave=Number.parseInt(e.attributes.get("octave"))),t}parseVolta(e){const t=new pl;return t.allNumbers="true"===e.attributes.get("allNumbers"),e.attributes.has("firstNumber")&&(t.firstNumber=Number.parseInt(e.attributes.get("firstNumber"))),e.attributes.has("lastNumber")&&(t.lastNumber=Number.parseInt(e.attributes.get("lastNumber"))),t}parseWedge(e){const t=new ul;return t.decrescendo="true"===e.attributes.get("decrescendo"),t}parseTupletBracket(e){const t=new dl;return e.attributes.has("number")&&(t.number=Number.parseInt(e.attributes.get("number"))),t}parseWavyLine(e){return new cl}parseSlur(e){return new ll}parseGuitar(e){const t=new hl,s=e.innerText.trim();for(let e=0;e<s.length;e++)"/"===s.charAt(e)?t.chord.strings.push(0):t.chord.strings.push(Number.parseInt(s.charAt(e)));return t}parseText(e){const t=new ol;switch(e.attributes.has("x")&&(t.x=Number.parseFloat(e.attributes.get("x"))),e.attributes.has("x")&&(t.y=Number.parseFloat(e.attributes.get("y"))),e.getAttribute("align")){case"left":t.align=oe.Left;break;case"center":t.align=oe.Center;break;case"right":t.align=oe.Right}switch(e.getAttribute("frame")){case"rectangle":t.frame=hs.Rectangle;break;case"ellipse":t.frame=hs.Ellipse;break;case"circle":t.frame=hs.Circle;break;case"none":t.frame=hs.None}if(e.firstElement)for(const s of e.childElements())switch(s.localName){case"font":t.fontFace=s.getAttribute("face"),s.attributes.has("weight")&&(t.weight=Number.parseInt(s.attributes.get("weight"))),s.attributes.has("height")&&(t.height=Number.parseInt(s.attributes.get("height")));break;case"content":t.text=s.innerText}else t.text=e.innerText;return t}parseInfo(e){for(const t of e.childElements())switch(t.localName){case"author":this.score.tab=t.firstChild.innerText;break;case"comment":this.score.notices=t.firstChild.innerText}}}class _l extends $e{get name(){return"Capella"}readScore(){j.debug(this.name,"Loading ZIP entries");let e,t=null;if(e=new us(this.data).read(),j.debug(this.name,"Zip entries loaded"),e.length>0){for(const s of e)if("score.xml"===s.fileName)t=ht.toString(s.data,this.settings.importer.encoding)}else this.data.reset(),t=ht.toString(this.data.readAll(),this.settings.importer.encoding);if(!t)throw new je("No valid capella file");j.debug(this.name,"Start Parsing score.xml");try{const e=new Sl;e.parseXml(t,this.settings),j.debug(this.name,"score.xml parsed");return e.score}catch(e){throw new je("Failed to parse CapXML",e)}}}class wl{constructor(e){this._targets=new Set,this._callback=e,window.addEventListener("resize",this.onWindowResize.bind(this),!1)}observe(e){this._targets.add(e)}unobserve(e){this._targets.delete(e)}disconnect(){this._targets.clear()}onWindowResize(){const e=[];for(const t of this._targets)e.push({target:t,contentRect:void 0,borderBoxSize:void 0,contentBoxSize:[],devicePixelContentBoxSize:[]});this._callback(e,this)}}class Bl{constructor(e){this._elements=[];let t=null;const s=this.check.bind(this);this.check=()=>{t||(t=setTimeout((()=>{s(),t=null}),100))},this._callback=e,window.addEventListener("resize",this.check,!0),document.addEventListener("scroll",this.check,!0)}observe(e){this._elements.indexOf(e)>=0||(this._elements.push(e),this.check())}unobserve(e){this._elements=this._elements.filter((t=>t!==e))}check(){const e=[];for(const t of this._elements){const s=t.getBoundingClientRect();s.top+s.height>=0&&s.top<=window.innerHeight&&s.left+s.width>=0&&s.left<=window.innerWidth&&e.push({target:t,isIntersecting:!0})}e.length&&this._callback(e,this)}}var kl="function"==typeof SuppressedError?SuppressedError:function(e,t,s){var i=new Error(s);return i.name="SuppressedError",i.error=e,i.suppressed=t,i};class Tl{static enable(e,t){Tl.alphaSkia=t,Tl.initializeMusicFont(Tl.alphaSkia.AlphaSkiaTypeface.register(e))}static initializeMusicFont(e){Tl.musicTextStyle=new Tl.alphaSkia.AlphaSkiaTextStyle([e.familyName],e.weight,e.isItalic)}static registerFont(e,t){const s=Tl.alphaSkia.AlphaSkiaTypeface.register(e.buffer);return t||(t=oa.withFamilyList([s.familyName],12,s.isItalic?Yt.Italic:Yt.Plain,s.weight>400?$t.Bold:$t.Regular)),t}get font(){return this._font}set font(e){if(this._font===e)return;this._font=e;const t=this.textStyleKey(e);if(this._textStyles.has(t))this._textStyle=this._textStyles.get(t);else{const s=new Tl.alphaSkia.AlphaSkiaTextStyle(e.families,e.weight===$t.Bold?700:400,e.isItalic);this._textStyles.set(t,s),this._textStyle=s}}textStyleKey(e){return[...e.families,e.weight.toString(),e.isItalic?"italic":"upright"].join("_")}constructor(){this._color=new tt(0,0,0,0),this._lineWidth=0,this._textStyle=null,this._scale=1,this._textStyles=new Map,this._font=new oa("Arial",10,Yt.Plain),this.textAlign=oe.Left,this.textBaseline=he.Top,this._canvas=new Tl.alphaSkia.AlphaSkiaCanvas,this.color=new tt(0,0,0,255)}destroy(){this._canvas[Symbol.dispose]();for(const e of this._textStyles.values())e[Symbol.dispose]()}onRenderFinished(){return null}beginRender(e,t){this._scale=this.settings.display.scale,this._canvas.beginRender(e,t,nc.HighDpiFactor)}endRender(){return this._canvas.endRender()}get color(){return this._color}set color(e){this._color.rgba!==e.rgba&&(this._color=e,this._canvas.color=Tl.alphaSkia.AlphaSkiaCanvas.rgbaToColor(e.r,e.g,e.b,e.a))}get lineWidth(){return this._lineWidth}set lineWidth(e){this._lineWidth=e,this._canvas.lineWidth=e}fillRect(e,t,s,i){s>0&&this._canvas.fillRect(e*this._scale|0,t*this._scale|0,s*this._scale,i*this._scale)}strokeRect(e,t,s,i){const a=this.lineWidth%2==0?0:.5;this._canvas.strokeRect((e*this._scale|0)+a,(t*this._scale|0)+a,s*this._scale,i*this._scale)}beginPath(){this._canvas.beginPath()}closePath(){this._canvas.closePath()}moveTo(e,t){this._canvas.moveTo(e*this._scale,t*this._scale)}lineTo(e,t){this._canvas.lineTo(e*this._scale,t*this._scale)}quadraticCurveTo(e,t,s,i){this._canvas.quadraticCurveTo(e*this._scale,t*this._scale,s*this._scale,i*this._scale)}bezierCurveTo(e,t,s,i,a,r){this._canvas.bezierCurveTo(e*this._scale,t*this._scale,s*this._scale,i*this._scale,a*this._scale,r*this._scale)}fillCircle(e,t,s){this._canvas.fillCircle(e*this._scale,t*this._scale,s*this._scale)}strokeCircle(e,t,s){this._canvas.strokeCircle(e*this._scale,t*this._scale,s*this._scale)}fill(){this._canvas.fill()}stroke(){this._canvas.stroke()}beginGroup(e){}endGroup(){}fillText(e,t,s){if(0===e.length)return;let i=Tl.alphaSkia.AlphaSkiaTextAlign.Left;switch(this.textAlign){case oe.Left:i=Tl.alphaSkia.AlphaSkiaTextAlign.Left;break;case oe.Center:i=Tl.alphaSkia.AlphaSkiaTextAlign.Center;break;case oe.Right:i=Tl.alphaSkia.AlphaSkiaTextAlign.Right}let a=Tl.alphaSkia.AlphaSkiaTextBaseline.Top;switch(this.textBaseline){case he.Top:a=Tl.alphaSkia.AlphaSkiaTextBaseline.Top;break;case he.Middle:a=Tl.alphaSkia.AlphaSkiaTextBaseline.Middle;break;case he.Bottom:a=Tl.alphaSkia.AlphaSkiaTextBaseline.Bottom}this._canvas.fillText(e,this._textStyle,this._font.size*this._scale,t*this._scale|0,s*this._scale|0,i,a)}measureText(e){const t={stack:[],error:void 0,hasError:!1};try{const s=function(e,t,s){if(null!=t){if("object"!=typeof t&&"function"!=typeof t)throw new TypeError("Object expected.");var i,a;if(s){if(!Symbol.asyncDispose)throw new TypeError("Symbol.asyncDispose is not defined.");i=t[Symbol.asyncDispose]}if(void 0===i){if(!Symbol.dispose)throw new TypeError("Symbol.dispose is not defined.");i=t[Symbol.dispose],s&&(a=i)}if("function"!=typeof i)throw new TypeError("Object not disposable.");a&&(i=function(){try{a.call(this)}catch(e){return Promise.reject(e)}}),e.stack.push({value:t,dispose:i,async:s})}else s&&e.stack.push({async:!0});return t}(t,this._canvas.measureText(e,this._textStyle,this._font.size,Tl.alphaSkia.AlphaSkiaTextAlign.Left,Tl.alphaSkia.AlphaSkiaTextBaseline.Alphabetic),!1);return new De(s.width,s.actualBoundingBoxAscent+s.actualBoundingBoxDescent)}catch(e){t.error=e,t.hasError=!0}finally{!function(e){function t(t){e.error=e.hasError?new kl(t,e.error,"An error was suppressed during disposal."):t,e.hasError=!0}var s,i=0;(function a(){for(;s=e.stack.pop();)try{if(!s.async&&1===i)return i=0,e.stack.push(s),Promise.resolve().then(a);if(s.dispose){var r=s.dispose.call(s.value);if(s.async)return i|=2,Promise.resolve(r).then(a,(function(e){return t(e),a()}))}else i|=1}catch(e){t(e)}if(1===i)return e.hasError?Promise.reject(e.error):Promise.resolve();if(e.hasError)throw e.error})()}(t)}}fillMusicFontSymbol(e,t,s,i,a){i!==ne.None&&this.fillMusicFontSymbolText(e,t,s,String.fromCharCode(i),a)}fillMusicFontSymbols(e,t,s,i,a){let r="";for(const e of i)e!==ne.None&&(r+=String.fromCharCode(e));this.fillMusicFontSymbolText(e,t,s,r,a)}fillMusicFontSymbolText(e,t,s,i,a){this._canvas.fillText(i,Tl.musicTextStyle,nc.MusicFontSize*this._scale*s,e*this._scale,t*this._scale,a?Tl.alphaSkia.AlphaSkiaTextAlign.Center:Tl.alphaSkia.AlphaSkiaTextAlign.Left,Tl.alphaSkia.AlphaSkiaTextBaseline.Alphabetic)}beginRotate(e,t,s){this._canvas.beginRotate(e*this._scale,t*this._scale,s)}endRotate(){this._canvas.endRotate()}}Tl.musicTextStyle=null;class Nl extends Xo{constructor(e,t,s=!1){super(e.beat,t.beat,s),this.startNote=e,this.endNote=t}getTieHeight(e,t,s,i){return this.startNote===this.endNote?15:super.getTieHeight(e,t,s,i)}getBeamDirection(e,t){return Ne.Down}static getBeamDirectionForNote(e){return Ne.Down}getStartY(){return this.startNoteRenderer.getNoteY(this.startNote,as.Center)}getEndY(){return this.getStartY()}getStartX(){return this.startNote===this.endNote?this.getEndX()-20:this.startNoteRenderer.getNoteX(this.startNote,rs.Right)}getEndX(){return this.endNoteRenderer.getNoteX(this.endNote,rs.Left)}}class xl extends Cr{constructor(){super(...arguments),this._tiedNoteTie=null}createTies(e){if(e.isVisible){if(!this._tiedNoteTie&&e.isTieOrigin&&e.tieDestination.isVisible){const t=new Nl(e,e.tieDestination,!1);this._tiedNoteTie=t,this.addTie(t)}if(!this._tiedNoteTie&&e.isTieDestination){const t=new Nl(e.tieOrigin,e,!0);this._tiedNoteTie=t,this.addTie(t)}}}}class vl extends eh{updateBeamingHelper(e){this.beamingHelper&&this.beamingHelper.registerBeatLineX("slash",this.beat,e+this.x+this.width/2,e+this.x+this.width/2)}paint(e,t,s){super.internalPaint(e,t,s,be.SlashRests)}}class Pl extends An{constructor(){super(...arguments),this.noteHeads=null,this.deadSlapped=null,this.restGlyph=null}get effectElement(){return be.SlashEffects}getNoteX(e,t){let s=null;if(this.noteHeads?s=this.noteHeads:this.deadSlapped&&(s=this.deadSlapped),s){let e=s.x;switch(t){case rs.Left:break;case rs.Center:e+=s.width/2;break;case rs.Right:e+=s.width}return e}return 0}buildBoundingsLookup(e,t,s){if(this.noteHeads&&this.container.beat.notes.length>0){const i=new ar;i.note=this.container.beat.notes[0],i.noteHeadBounds=new ft,i.noteHeadBounds.x=t+this.x+this.noteHeads.x,i.noteHeadBounds.y=s+this.y+this.noteHeads.y-this.noteHeads.height/2,i.noteHeadBounds.w=this.width,i.noteHeadBounds.h=this.height,e.addNote(i)}}getNoteY(e,t){let s=null;if(this.noteHeads?s=this.noteHeads:this.deadSlapped&&(s=this.deadSlapped),s){let e=this.y+s.y;switch(t){case as.Top:case as.TopWithStem:e-=s.height/2+2;break;case as.Center:break;case as.Bottom:case as.BottomWithStem:e+=s.height/2}return e}return 0}updateBeamingHelper(){this.noteHeads?this.noteHeads.updateBeamingHelper(this.container.x+this.x):this.deadSlapped?this.beamingHelper&&this.beamingHelper.registerBeatLineX("slash",this.container.beat,this.container.x+this.x+this.deadSlapped.x+this.width,this.container.x+this.x+this.deadSlapped.x):this.restGlyph&&this.restGlyph.updateBeamingHelper(this.container.x+this.x)}doLayout(){const e=this.renderer,t=e.getNoteLine(),s=e.getLineY(t);if(this.container.beat.deadSlapped){const e=new Qo;e.renderer=this.renderer,e.doLayout(),this.deadSlapped=e,this.addEffect(e)}else if(!this.container.beat.isEmpty)if(this.container.beat.isRest){const e=new vl(0,s,this.container.beat.duration);this.restGlyph=e,e.beat=this.container.beat,e.beamingHelper=this.beamingHelper,this.addNormal(e),this.beamingHelper&&this.beamingHelper.applyRest(this.container.beat,0)}else{const e=this.container.beat.graceType!==B.None,t=new mh(0,s,this.container.beat.duration,e,this.container.beat);this.noteHeads=t,t.beat=this.container.beat,t.beamingHelper=this.beamingHelper,this.addNormal(t)}if(this.container.beat.dots>0){this.addNormal(new lh(0,0,5));for(let t=0;t<this.container.beat.dots;t++)this.addEffect(new Go(0,e.getLineY(e.getNoteLine())-e.getLineHeight(.5),1.5))}super.doLayout(),this.container.beat.isEmpty?this.centerX=this.width/2:this.restGlyph?this.centerX=this.restGlyph.x+this.restGlyph.width/2:this.noteHeads?this.centerX=this.noteHeads.x+this.noteHeads.width/2:this.deadSlapped&&(this.centerX=this.deadSlapped.x+this.deadSlapped.width/2)}}class Fl extends Wh{constructor(e,t){super(e,t),this.simpleWhammyOverflow=0,this._isOnlySlash=!t.staff.showTablature&&!t.staff.showStandardNotation,this.helpers.preferredBeamDirection=Ne.Up}get repeatsBarSubElement(){return p.SlashRepeats}get barNumberBarSubElement(){return p.SlashBarNumber}get barLineBarSubElement(){return p.SlashBarLines}get staffLineBarSubElement(){return p.SlashStaffLine}get lineSpacing(){return Hn.RawLineSpacing}get heightLineCount(){return 5}get drawnLineCount(){return 1}get bottomGlyphOverflow(){return 0}paint(e,t,s){super.paint(e,t,s),this.paintBeams(e,t,s,be.SlashFlags,be.SlashBeams),this.paintTuplets(e,t,s,be.SlashTuplet)}doLayout(){super.doLayout();let e=!1;for(const t of this.bar.voices)if(this.hasVoiceContainer(t)){if(this.getVoiceContainer(t).tupletGroups.length>0){e=!0;break}}e&&this.registerOverflowTop(this.tupletSize)}getNoteLine(){return 0}getFlagTopY(e,t){const s=xr.Heights.get(ne.NoteheadSlashWhiteHalf);return this.getLineY(0)-s/2}getFlagBottomY(e,t){const s=xr.Heights.get(ne.NoteheadSlashWhiteHalf);return this.getLineY(0)-s/2}getBeamDirection(e){return Ne.Up}getNoteY(e,t){let s=super.getNoteY(e,t);return Number.isNaN(s)&&(s=this.getLineY(0)),s}calculateBeamYWithDirection(e,t,s){return this.getLineY(0)-this.getFlagStemSize(e.shortestDuration)}getBarLineStart(e,t){const s=xr.Heights.get(ne.NoteheadSlashWhiteHalf);return this.getLineY(0)-s/2}createLinePreBeatGlyphs(){this._isOnlySlash&&(!this.bar.previousBar||this.bar.previousBar&&this.bar.masterBar.timeSignatureNumerator!==this.bar.previousBar.masterBar.timeSignatureNumerator||this.bar.previousBar&&this.bar.masterBar.timeSignatureDenominator!==this.bar.previousBar.masterBar.timeSignatureDenominator||this.bar.previousBar&&this.bar.masterBar.isFreeTime&&this.bar.masterBar.isFreeTime!==this.bar.previousBar.masterBar.isFreeTime)&&(this.createStartSpacing(),this.createTimeSignatureGlyphs())}createTimeSignatureGlyphs(){this.addPreBeatGlyph(new lh(0,0,5));const e=this.bar.masterBar,t=new Bh(0,this.getLineY(0),e.timeSignatureNumerator,e.timeSignatureDenominator,e.timeSignatureCommon,e.isFreeTime&&(null==e.previousMasterBar||e.isFreeTime!==e.previousMasterBar.isFreeTime));t.barSubElement=p.SlashTimeSignature,this.addPreBeatGlyph(t)}createVoiceGlyphs(e){for(const t of e.beats){const s=new xl(t,this.getVoiceContainer(e));s.preNotes=new Ln,s.onNotes=0===e.index?new Pl:new An,this.addBeatGlyph(s)}}paintBeamingStem(e,t,s,i,a,r){const n=nn.beat(r,be.SlashStem,e);try{r.lineWidth=Hn.StemWidth,r.beginPath(),r.moveTo(s,i),r.lineTo(s,a),r.stroke(),r.lineWidth=1}finally{n?.[Symbol.dispose]?.()}}}Fl.StaffId="slash";class Cl extends sn{get staffId(){return Fl.StaffId}getStaffPaddingTop(e){return e.system.layout.renderer.settings.display.notationStaffPaddingTop}getStaffPaddingBottom(e){return e.system.layout.renderer.settings.display.notationStaffPaddingBottom}create(e,t){return new Fl(e,t)}canCreate(e,t){return super.canCreate(e,t)&&t.showSlash}}class El extends Xo{constructor(e,t,s=!1){super(e?e.beat:null,t?t.beat:null,s),this.startNote=e,this.endNote=t}shouldDrawBendSlur(){return this.renderer.settings.notation.extendBendArrowsOnTiedNotes&&!!this.startNote.bendOrigin&&this.startNote.isTieOrigin}doLayout(){super.doLayout()}getBeamDirection(e,t){return Ne.Up}getStartY(){return this.startNoteRenderer.getNoteY(this.startNote,as.Top)}getEndY(){return this.getStartY()}getStartX(){return this.startNote===this.endNote?this.getEndX()-20:this.startNoteRenderer.getNoteX(this.startNote,rs.Center)}getEndX(){return this.startNote===this.endNote?this.endNoteRenderer.getNoteX(this.endNote,rs.Left):this.endNoteRenderer.getNoteX(this.endNote,rs.Center)}}class Dl extends Xh{constructor(e,t,s,i=!1){super(e,t,i),this._direction=Ne.Up,this._forSlide=s}getTieHeight(e,t,s,i){return Math.log(s-e+1)*this.renderer.settings.notation.slurHeight}tryExpand(e,t,s,i){if(this._forSlide!==s)return!1;if(this.forEnd!==i)return!1;if(this.startNote.beat.id!==e.beat.id)return!1;if(this.endNote.beat.id!==t.beat.id)return!1;switch(this._direction){case Ne.Up:e.realValue>this.startNote.realValue&&(this.startNote=e,this.startBeat=e.beat),t.realValue>this.endNote.realValue&&(this.endNote=t,this.endBeat=t.beat);break;case Ne.Down:e.realValue<this.startNote.realValue&&(this.startNote=e,this.startBeat=e.beat),t.realValue<this.endNote.realValue&&(this.endNote=t,this.endBeat=t.beat)}return!0}paint(e,t,s){const i=this.renderer.scoreRenderer.layout.getRendererForBar(this.renderer.staff.staffId,this.startBeat.voice.bar),a=this.getBeamDirection(this.startBeat,i),r=`numbered.slur.${this.startNote.beat.id}.${this.endNote.beat.id}.${a}`,n=this.renderer;n.staff.getSharedLayoutData(r,!1)||(n.staff.setSharedLayoutData(r,!0),super.paint(e,t,s))}}class Ml extends Cr{constructor(){super(...arguments),this._effectSlurs=[]}createTies(e){if(e.isVisible){if(e.isTieOrigin&&e.tieDestination.isVisible){const t=new El(e,e.tieDestination,!1);this.addTie(t)}if(e.isTieDestination){const t=new El(e.tieOrigin,e,!0);this.addTie(t)}if(e.isLeftHandTapped&&!e.isHammerPullDestination){const t=new El(e,e,!1);this.addTie(t)}if(e.isEffectSlurOrigin&&e.effectSlurDestination){let t=!1;for(const s of this._effectSlurs)if(s.tryExpand(e,e.effectSlurDestination,!1,!1)){t=!0;break}if(!t){const t=new Dl(e,e.effectSlurDestination,!1,!1);this._effectSlurs.push(t),this.addTie(t)}}if(e.isEffectSlurDestination&&e.effectSlurOrigin){let t=!1;for(const s of this._effectSlurs)if(s.tryExpand(e.effectSlurOrigin,e,!1,!0)){t=!0;break}if(!t){const t=new Dl(e.effectSlurOrigin,e,!1,!0);this._effectSlurs.push(t),this.addTie(t)}}}}}class Ll extends Tr{constructor(e,t,s,i,a){super(e,t),this._isGrace=i,this._number=s,this._beat=a}paint(e,t,s){const i=this._beat.isRest?nn.beat(s,be.NumberedRests,this._beat):this._beat.notes.length>0?nn.note(s,ce.NumberedNumber,this._beat.notes[0]):void 0;try{const i=this.renderer.resources;s.font=this._isGrace?i.numberedNotationGraceFont:i.numberedNotationFont,s.textBaseline=he.Middle,s.textAlign=oe.Left,s.fillText(this._number.toString(),e+this.x,t+this.y)}finally{i?.[Symbol.dispose]?.()}}doLayout(){const e=this._isGrace?Pr.GraceScale:1;this.width=Ll.NoteHeadWidth*e,this.height=Ll.NoteHeadHeight*e}}Ll.NoteHeadHeight=17,Ll.NoteHeadWidth=12;class Al extends Tr{constructor(e,t,s){super(e,t),this._beat=s}doLayout(){this.width=14+Al.Padding,this.height=Hl.BarSize}paint(e,t,s){const i=nn.beat(s,be.NumberedDuration,this._beat);try{const i=Al.Padding;s.fillRect(e+this.x,t+this.y,this.width-i,this.height)}finally{i?.[Symbol.dispose]?.()}}}Al.Padding=3;class Il extends Ln{constructor(){super(...arguments),this.isNaturalizeAccidental=!1,this.accidental=It.None}get effectElement(){return be.NumberedEffects}doLayout(){if(!this.container.beat.isRest&&!this.container.beat.isEmpty){const e=new sh;if(e.renderer=this.renderer,this.container.beat.notes.length>0){const t=this.container.beat.notes[0],s=t?t.accidentalMode:x.Default,i=ks.getNoteValue(t);let a=ks.computeAccidental(this.renderer.bar.keySignature,s,i,t.hasQuarterToneOffset);if(a===It.Natural){a=this.renderer.bar.keySignature+7<7?It.Sharp:It.Flat,this.isNaturalizeAccidental=!0}if(a!==It.None){this.accidental=a;const s=this.renderer,i=nn.noteColor(s.resources,ce.NumberedAccidentals,t),r=new Ho(0,s.getLineY(0),a,t.beat.graceType!==B.None?Pr.GraceScale*Pr.GraceScale:Pr.GraceScale);r.colorOverride=i,r.renderer=this.renderer,e.addGlyph(r),this.addNormal(e),this.addNormal(new lh(0,0,4))}}}super.doLayout()}}class Rl extends An{constructor(){super(...arguments),this.noteHeads=null,this.deadSlapped=null,this.octaveDots=0}get effectElement(){return be.NumberedEffects}getNoteX(e,t){let s=null;if(this.noteHeads?s=this.noteHeads:this.deadSlapped&&(s=this.deadSlapped),s){let e=s.x;switch(t){case rs.Left:break;case rs.Center:e+=s.width/2;break;case rs.Right:e+=s.width}return e}return 0}buildBoundingsLookup(e,t,s){if(this.noteHeads&&this.container.beat.notes.length>0){const i=new ar;i.note=this.container.beat.notes[0],i.noteHeadBounds=new ft,i.noteHeadBounds.x=t+this.x+this.noteHeads.x,i.noteHeadBounds.y=s+this.y+this.noteHeads.y-this.noteHeads.height/2,i.noteHeadBounds.w=this.width,i.noteHeadBounds.h=this.height,e.addNote(i)}}getNoteY(e,t){let s=null;if(this.noteHeads?s=this.noteHeads:this.deadSlapped&&(s=this.deadSlapped),s){let e=this.y+s.y;switch(t){case as.Top:case as.TopWithStem:e-=s.height/2+2;break;case as.Center:break;case as.Bottom:case as.BottomWithStem:e+=s.height/2}return e}return 0}updateBeamingHelper(){if(this.beamingHelper){let e=null;this.noteHeads?e=this.noteHeads:this.deadSlapped&&(e=this.deadSlapped),e&&this.beamingHelper.registerBeatLineX("numbered",this.container.beat,this.container.x+this.x+e.x,this.container.x+this.x+e.x+e.width)}}doLayout(){const e=this.renderer;e.shortestDuration<this.container.beat.duration&&(e.shortestDuration=this.container.beat.duration);const t=e.getLineY(e.getNoteLine());if(!this.container.beat.isEmpty){let s="0";if(this.container.beat.notes.length>0){const t=this.renderer.bar.keySignatureType,i=this.renderer.bar.keySignature,a=i+7,r=(t===d.Minor?Rl.MinorKeySignatureOneValues:Rl.MajorKeySignatureOneValues)[a],n=this.container.beat.notes[0];if(n.isDead)s="X";else{const t=n.displayValue-r,o=t<0?(t%12+12)%12:t%12;let h=t<0?(Math.abs(t)+12)/12|0:t/12|0;t<0&&(h*=-1),this.octaveDots=h,e.registerOctave(h);let l=(ae.keySignatureIsSharp(i)||ae.keySignatureIsNatural(i)?ks.FlatNoteSteps:ks.SharpNoteSteps)[o]+1;ks.AccidentalNotes[o]&&!this.container.preNotes.isNaturalizeAccidental&&(a<7?l++:l--),s=l.toString()}}if(this.container.beat.deadSlapped){const e=new Qo;e.renderer=this.renderer,e.doLayout(),this.deadSlapped=e,this.addEffect(e)}else{const e=this.container.beat.graceType!==B.None,i=new Ll(0,t,s,e,this.container.beat);this.noteHeads=i,this.addNormal(i)}if(this.container.beat.dots>0&&this.container.beat.duration>=w.Quarter){this.addNormal(new lh(0,0,5));for(let t=0;t<this.container.beat.dots;t++){const t=new Go(0,e.getLineY(0),1.5);t.renderer=this.renderer,this.addEffect(t)}}let i=0;switch(this.container.beat.duration){case w.QuadrupleWhole:i=16;break;case w.DoubleWhole:i=8;break;case w.Whole:i=4;break;case w.Half:i=2}let a=i;for(let e=0;e<this.container.beat.dots;e++)a=a/2|0,i+=a;for(let t=0;t<i-1;t++){const t=new Al(0,e.getLineY(0),this.container.beat);t.renderer=this.renderer,this.addNormal(t)}}super.doLayout(),this.container.beat.isEmpty?this.centerX=this.width/2:this.noteHeads?this.centerX=this.noteHeads.x+this.noteHeads.width/2:this.deadSlapped&&(this.centerX=this.deadSlapped.x+this.deadSlapped.width/2)}}Rl.MajorKeySignatureOneValues=[59,66,61,68,63,58,65,60,67,62,69,64,71,66,61],Rl.MinorKeySignatureOneValues=[71,66,73,68,63,70,65,72,67,74,69,64,71,66,73];class Ol extends Tr{constructor(e,t,s,i){super(e,t),this._text="",this._accidental=It.None,this._accidentalOffset=0,this._keySignature=s,this._keySignatureType=i}doLayout(){super.doLayout();const e="1 = ";let t="",s=It.None;switch(this._keySignatureType){case d.Major:switch(this._keySignature){case c.Cb:t="  C",s=It.Flat;break;case c.Gb:t="  G",s=It.Flat;break;case c.Db:t="  D",s=It.Flat;break;case c.Ab:t="  A",s=It.Flat;break;case c.Eb:t="  E",s=It.Flat;break;case c.Bb:t="  B",s=It.Flat;break;case c.F:t="F";break;case c.C:t="C",s=It.None;break;case c.G:t="G",s=It.None;break;case c.D:t="D",s=It.None;break;case c.A:t="A",s=It.None;break;case c.E:t="E",s=It.None;break;case c.B:t="B",s=It.None;break;case c.FSharp:t="  F",s=It.Sharp;break;case c.CSharp:t="  C",s=It.Sharp}break;case d.Minor:switch(this._keySignature){case c.Cb:t="  a",s=It.Flat;break;case c.Gb:t="  e",s=It.Flat;break;case c.Db:t="  b",s=It.Flat;break;case c.Ab:t="f",s=It.None;break;case c.Eb:t="c",s=It.None;break;case c.Bb:t="g",s=It.None;break;case c.F:t="d";break;case c.C:t="a",s=It.None;break;case c.G:t="e",s=It.None;break;case c.D:t="b",s=It.None;break;case c.A:t="  f",s=It.Sharp;break;case c.E:t="  c",s=It.Sharp;break;case c.B:t="  g",s=It.Sharp;break;case c.FSharp:t="  d",s=It.Sharp;break;case c.CSharp:t="  a",s=It.Sharp}}this._text=e+t,this._accidental=s;const i=this.renderer.scoreRenderer.canvas,a=this.renderer.resources;i.font=a.numberedNotationFont,this._accidentalOffset=i.measureText(e).width,this.width=i.measureText(e+t).width}paint(e,t,s){const i=nn.bar(s,p.NumberedKeySignature,this.renderer.bar);try{const i=this.renderer.resources;s.font=i.numberedNotationFont,s.textBaseline=he.Middle,s.fillText(this._text,e+this.x,t+this.y),this._accidental!==It.None&&s.fillMusicFontSymbol(e+this.x+this._accidentalOffset,t+this.y,.7,Ho.getMusicSymbol(this._accidental),!1)}finally{i?.[Symbol.dispose]?.()}}}class Hl extends Wh{registerOctave(e){null===this.lowestOctave?(this.lowestOctave=e,this.highestOctave=e):(e<this.lowestOctave&&(this.lowestOctave=e),e>this.highestOctave&&(this.highestOctave=e))}get repeatsBarSubElement(){return p.NumberedRepeats}get barNumberBarSubElement(){return p.NumberedBarNumber}get barLineBarSubElement(){return p.NumberedBarLines}get staffLineBarSubElement(){return p.NumberedStaffLine}constructor(e,t){super(e,t),this.simpleWhammyOverflow=0,this.shortestDuration=w.QuadrupleWhole,this.lowestOctave=null,this.highestOctave=null,this._isOnlyNumbered=!t.staff.showSlash&&!t.staff.showTablature&&!t.staff.showStandardNotation}get lineSpacing(){return Hn.RawLineSpacing}get heightLineCount(){return 5}get drawnLineCount(){return 0}get bottomGlyphOverflow(){return 0}paint(e,t,s){super.paint(e,t,s),this.paintBeams(e,t,s,be.NumberedDuration,be.NumberedDuration),this.paintTuplets(e,t,s,be.NumberedTuplet,!0)}doLayout(){super.doLayout();let e=!1;for(const t of this.bar.voices)if(this.hasVoiceContainer(t)){if(this.getVoiceContainer(t).tupletGroups.length>0){e=!0;break}}if(e&&this.registerOverflowTop(this.tupletSize),!this.bar.isEmpty){const e=ae.getIndex(this.shortestDuration)-2;if(e>0){const t=(e-1)*Hl.BarSpacing+Hl.BarSize;let s=0;const i=this.lowestOctave;null!==i&&(s=Math.abs(i)*Hl.DotSpacing+Hl.DotSize),this.registerOverflowBottom(t+s)}const t=this.highestOctave;if(null!==t){const e=Math.abs(t)*Hl.DotSpacing+Hl.DotSize;this.registerOverflowTop(e)}}}paintFlag(e,t,s,i,a){this.paintBar(e,t,s,i,a)}paintBar(e,t,s,i,a){if(0===i.beats.length)return;const r=this.resources;for(let n=0,o=i.beats.length;n<o;n++){const o=i.beats[n],h=nn.beat(s,a,o);try{const a=Hl.BarSpacing,h=Hl.BarSize,l=ae.getIndex(o.duration)-2,c=t+this.y,d=this.getBeatX(o,ss.PreNotes)-this.beatGlyphsStart,u=this.calculateBeamY(i,d);for(let t=0;t<l;t++){let r=0,l=0,p=0;const g=c+t*a;n===i.beats.length-1?(r=d,l=this.getBeatX(o,ss.PostNotes)-this.beatGlyphsStart):(r=d,l=this.getBeatX(i.beats[n+1],ss.PreNotes)-this.beatGlyphsStart),p=g+u|0,Wh.paintSingleBar(s,e+this.x+r,p,e+this.x+l,p,h)}const p=this.getBeatContainer(o).onNotes;let g=p instanceof Rl?p.octaveDots:0,m=0,f=0;g>0?(m=c+this.getLineY(0)-r.numberedNotationFont.size/1.5,f=-1*Hl.DotSpacing):g<0&&(m=c+u+l*a,f=Hl.DotSpacing);const y=this.getBeatX(o,ss.OnNotes)+4-this.beatGlyphsStart;g=Math.abs(g);for(let t=0;t<g;t++)s.fillCircle(e+this.x+y,m,Hl.DotSize),m+=f}finally{h?.[Symbol.dispose]?.()}}}getNoteLine(){return 0}get tupletOffset(){return super.tupletOffset+this.resources.numberedNotationFont.size}getFlagTopY(e,t){const s=xr.Heights.get(ne.NoteheadBlack);return this.getLineY(0)-s/2}getFlagBottomY(e,t){const s=xr.Heights.get(ne.NoteheadBlack);return this.getLineY(0)-s/2}getBeamDirection(e){return Ne.Down}getTupletBeamDirection(e){return Ne.Up}getNoteY(e,t){let s=super.getNoteY(e,t);return Number.isNaN(s)&&(s=this.getLineY(0)),s}calculateBeamYWithDirection(e,t,s){const i=this.resources.numberedNotationFont;return this.getLineY(0)+i.size}getBarLineStart(e,t){const s=xr.Heights.get(ne.NoteheadBlack);return this.getLineY(0)-s/2}createPreBeatGlyphs(){this.wasFirstOfLine=this.isFirstOfLine,(0===this.index||this.bar.masterBar.isRepeatStart&&this._isOnlyNumbered)&&this.addPreBeatGlyph(new Rh(!1)),this.createLinePreBeatGlyphs(),this.addPreBeatGlyph(new Hh(0,this.getLineHeight(-.25),this.bar.index+1))}createLinePreBeatGlyphs(){this.bar.previousBar&&this.bar.keySignature===this.bar.previousBar.keySignature||(this.createStartSpacing(),this.createKeySignatureGlyphs()),this._isOnlyNumbered&&(!this.bar.previousBar||this.bar.previousBar&&this.bar.masterBar.timeSignatureNumerator!==this.bar.previousBar.masterBar.timeSignatureNumerator||this.bar.previousBar&&this.bar.masterBar.timeSignatureDenominator!==this.bar.previousBar.masterBar.timeSignatureDenominator||this.bar.previousBar&&this.bar.masterBar.isFreeTime&&this.bar.masterBar.isFreeTime!==this.bar.previousBar.masterBar.isFreeTime)&&(this.createStartSpacing(),this.createTimeSignatureGlyphs())}createKeySignatureGlyphs(){this.addPreBeatGlyph(new Ol(0,this.getLineY(0),this.bar.keySignature,this.bar.keySignatureType))}createTimeSignatureGlyphs(){this.addPreBeatGlyph(new lh(0,0,5));const e=this.bar.masterBar,t=new Bh(0,this.getLineY(0),e.timeSignatureNumerator,e.timeSignatureDenominator,e.timeSignatureCommon,e.isFreeTime&&(null==e.previousMasterBar||e.isFreeTime!==e.previousMasterBar.isFreeTime));t.barSubElement=p.NumberedTimeSignature,this.addPreBeatGlyph(t)}createPostBeatGlyphs(){this._isOnlyNumbered&&super.createPostBeatGlyphs()}createVoiceGlyphs(e){for(const t of e.beats){const s=new Ml(t,this.getVoiceContainer(e));s.preNotes=0===e.index?new Il:new Ln,s.onNotes=0===e.index?new Rl:new An,this.addBeatGlyph(s)}}paintBeamingStem(e,t,s,i,a,r){}}Hl.StaffId="numbered",Hl.BarSpacing=Hn.BeamSpacing+Hn.BeamThickness,Hl.BarSize=2,Hl.DotSpacing=5,Hl.DotSize=2;class Wl extends sn{get staffId(){return Hl.StaffId}getStaffPaddingTop(e){return e.system.layout.renderer.settings.display.notationStaffPaddingTop}getStaffPaddingBottom(e){return e.system.layout.renderer.settings.display.notationStaffPaddingBottom}create(e,t){return new Hl(e,t)}canCreate(e,t){return super.canCreate(e,t)&&t.showNumbered}}class Vl extends Yn{get notationElement(){return e.NotationElement.EffectText}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.SinglePreBeat}shouldCreateGlyph(e,t){const s=t.voice.bar.masterBar;return 0===t.voice.bar.staff.index&&0===t.voice.index&&0===t.index&&s.isFreeTime&&(0===s.index||s.isFreeTime!==s.previousMasterBar.isFreeTime)}createNewGlyph(e,t){return new _n(0,0,"Free time",e.resources.effectFont,oe.Left)}canExpand(e,t){return!0}}class Gl extends Nr{constructor(){super(0,0)}doLayout(){super.doLayout(),this.height=xr.Heights.get(ne.KeyboardPedalPed)}paint(e,t,s){const i=this.renderer,a=t+this.y,r=this.height,n=i.bar.sustainPedals,o=xr.Widths.get(ne.KeyboardPedalPed),h=xr.Widths.get(ne.KeyboardPedalUp);let l=0;for(;l<n.length;){let t=n[l];for(;null!=t;){const i=e+this.renderer.getRatioPositionX(t.ratioPosition);let c=0;if(t.pedalType===u.Down?(s.fillMusicFontSymbol(i,a+r,1,ne.KeyboardPedalPed,!0),c=o/2+Gl.TextLinePadding):t.pedalType===u.Up&&(s.fillMusicFontSymbol(i,a+r,1,ne.KeyboardPedalUp,!0),c=h/2+Gl.StarLinePadding),t.nextPedalMarker)if(t.nextPedalMarker.bar===t.bar){let n=e+this.renderer.getRatioPositionX(t.nextPedalMarker.ratioPosition);switch(t.nextPedalMarker.pedalType){case u.Down:n-=o/2;break;case u.Hold:break;case u.Up:n-=h/2}const l=i+c;n>l&&s.fillRect(l,a+r-1,n-l,1)}else{const t=e+this.x+this.width,n=i+c;s.fillRect(n,a+r-1,t-n,1)}if(0===l&&t.previousPedalMarker){const t=e+this.x,n=i-c;s.fillRect(t,a+r-1,n-t,1)}l++,null!=t.nextPedalMarker&&t.nextPedalMarker.bar!==t.bar?(t=null,l=n.length):t=t.nextPedalMarker}}}}Gl.TextLinePadding=3,Gl.StarLinePadding=3;class zl extends Yn{get notationElement(){return e.NotationElement.EffectSustainPedal}get hideOnMultiTrack(){return!1}get canShareBand(){return!1}get sizingMode(){return ns.FullBar}shouldCreateGlyph(e,t){return 0===t.voice.index&&0===t.index&&t.voice.bar.sustainPedals.length>0}createNewGlyph(e,t){return new Gl}canExpand(e,t){return!0}}class Ul extends Yn{constructor(e,t){super(),this._type=e,this._shouldCreate=t}get notationElement(){return e.NotationElement.EffectGolpe}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){const s=this._shouldCreate;return t.golpe===this._type&&(!s||s(e,t))}createNewGlyph(e,t){return new ph(0,0,!0)}canExpand(e,t){return!1}}class Xl extends vr{constructor(e){super(0,0,1,Xl.getSymbol(e)),this.center=!0}static getSymbol(e){switch(e){case ge.Open:return ne.GuitarOpenPedal;case ge.Closed:return ne.GuitarClosePedal}return ne.None}paint(e,t,s){super.paint(e,t+this.height,s)}}class Jl extends Yn{get notationElement(){return e.NotationElement.EffectWahPedal}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return t.wahPedal!==ge.None}createNewGlyph(e,t){return new Xl(t.wahPedal)}canExpand(e,t){return!1}}class Yl extends Yn{get notationElement(){return e.NotationElement.EffectLetRing}get canShareBand(){return!1}get hideOnMultiTrack(){return!1}shouldCreateGlyph(e,t){return t.isBarre}get sizingMode(){return ns.GroupedOnBeat}createNewGlyph(e,t){let s="";switch(t.barreShape){case me.None:case me.Full:break;case me.Half:s+="1/2"}return s+=`B ${Yl.toRoman(t.barreFret)}`,new ho(s,!1)}static toRoman(e){let t="";if(e>0)for(const[s,i]of Yl.RomanLetters){const a=Math.floor(e/i);e-=a*i,t+=s.repeat(a)}return t}canExpand(e,t){return e.barreFret===t.barreFret&&e.barreShape===t.barreShape}}Yl.RomanLetters=new Map([["L",50],["XL",40],["X",10],["IX",9],["V",5],["IV",4],["I",1]]);class $l extends vr{constructor(e){super(0,0,1,$l.getSymbol(e)),this.center=!0}static getSymbol(e){switch(e){case le.InvertedTurn:return ne.OrnamentTurnInverted;case le.Turn:return ne.OrnamentTurn;case le.UpperMordent:return ne.OrnamentShortTrill;case le.LowerMordent:return ne.OrnamentMordent}return ne.None}paint(e,t,s){super.paint(e,t+this.height-4,s)}}class ql extends Yn{get notationElement(){return e.NotationElement.EffectNoteOrnament}get hideOnMultiTrack(){return!1}get canShareBand(){return!0}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return t.notes.some((e=>e.ornament!==le.None))}createNewGlyph(e,t){return new $l(t.notes.find((e=>e.ornament!==le.None)).ornament)}canExpand(e,t){return!1}}class jl extends Yn{get notationElement(){return e.NotationElement.EffectRasgueado}get canShareBand(){return!1}get hideOnMultiTrack(){return!1}shouldCreateGlyph(e,t){return t.hasRasgueado}get sizingMode(){return ns.GroupedOnBeat}createNewGlyph(e,t){return new ho("rasg.")}canExpand(e,t){return!0}}class Kl extends Tr{constructor(e){super(0,0),this._symbols=e}doLayout(){this.height=27}paint(e,t,s){s.fillMusicFontSymbols(e+this.x,t+this.y+this.height,.8,this._symbols,!0)}}class Ql extends Tr{constructor(e){super(0,0),this._text=e}doLayout(){this.height=1.5*this.renderer.resources.directionsFont.size}paint(e,t,s){const i=s.font,a=s.textBaseline,r=s.textAlign;s.font=this.renderer.resources.directionsFont,s.textBaseline=he.Middle,s.textAlign=oe.Right,s.fillText(this._text,e+this.x,t+this.y+this.height/2),s.font=i,s.textBaseline=a,s.textAlign=r}}class Zl extends Nr{constructor(e,t,s){super(e,t),this._barBeginGlyphs=[],this._barEndGlyphs=[],this._directions=s}doLayout(){const e=this._directions;e.has(ke.TargetSegnoSegno)&&this._barBeginGlyphs.push(new Kl([ne.Segno,ne.Segno])),e.has(ke.TargetSegno)&&this._barBeginGlyphs.push(new Kl([ne.Segno])),e.has(ke.TargetDoubleCoda)&&this._barBeginGlyphs.push(new Kl([ne.Coda,ne.Coda])),e.has(ke.TargetCoda)&&this._barBeginGlyphs.push(new Kl([ne.Coda])),e.has(ke.TargetFine)&&this._barEndGlyphs.push(new Ql("Fine")),e.has(ke.JumpDaDoubleCoda)&&this._barEndGlyphs.push(new Ql("To Double Coda")),e.has(ke.JumpDaCoda)&&this._barEndGlyphs.push(new Ql("To Coda")),e.has(ke.JumpDalSegnoSegno)&&this._barEndGlyphs.push(new Ql("D.S.S.")),e.has(ke.JumpDalSegnoSegnoAlCoda)&&this._barEndGlyphs.push(new Ql("D.S.S. al Coda")),e.has(ke.JumpDalSegnoSegnoAlDoubleCoda)&&this._barEndGlyphs.push(new Ql("D.S.S. al Double Coda")),e.has(ke.JumpDalSegnoSegnoAlFine)&&this._barEndGlyphs.push(new Ql("D.S.S. al Fine")),e.has(ke.JumpDalSegno)&&this._barEndGlyphs.push(new Ql("D.S.")),e.has(ke.JumpDalSegnoAlCoda)&&this._barEndGlyphs.push(new Ql("D.S. al Coda")),e.has(ke.JumpDalSegnoAlDoubleCoda)&&this._barEndGlyphs.push(new Ql("D.S. al Double Coda")),e.has(ke.JumpDalSegnoAlFine)&&this._barEndGlyphs.push(new Ql("D.S. al Fine")),e.has(ke.JumpDaCapo)&&this._barEndGlyphs.push(new Ql("D.C.")),e.has(ke.JumpDaCapoAlCoda)&&this._barEndGlyphs.push(new Ql("D.C. al Coda")),e.has(ke.JumpDaCapoAlDoubleCoda)&&this._barEndGlyphs.push(new Ql("D.C. al Double Coda")),e.has(ke.JumpDaCapoAlFine)&&this._barEndGlyphs.push(new Ql("D.C. al Fine"));const t=this.doSideLayout(this._barBeginGlyphs),s=this.doSideLayout(this._barEndGlyphs);this.height=Math.max(t,s)}doSideLayout(e){let t=0;for(const s of e)s.y=t,s.renderer=this.renderer,s.doLayout(),t+=s.height+3;return t}paint(e,t,s){for(const i of this._barBeginGlyphs)i.paint(e+this.x,t+this.y,s);for(const i of this._barEndGlyphs)i.paint(e+this.x+this.width,t+this.y,s)}}class ec extends Yn{get notationElement(){return e.NotationElement.EffectDirections}get hideOnMultiTrack(){return!0}get canShareBand(){return!1}get sizingMode(){return ns.FullBar}shouldCreateGlyph(e,t){return 0===t.voice.index&&0===t.index&&null!==t.voice.bar.masterBar.directions&&t.voice.bar.masterBar.directions.size>0}createNewGlyph(e,t){return new Zl(0,0,t.voice.bar.masterBar.directions)}canExpand(e,t){return!0}}class tc extends Nr{constructor(e){super(0,0),this._text="",this._textWidth=0,this._textHeight=0,this._timer=e}doLayout(){const e=this._timer/6e4|0,t=(this._timer-6e4*e)/1e3|0;this._text=`${e}:${t.toString().padStart(2,"0")}`;const s=this.renderer.scoreRenderer.canvas;s.font=this.renderer.resources.timerFont;const i=s.measureText(this._text);this._textHeight=s.font.size+2*tc.PaddingY,this._textWidth=i.width+2*tc.PaddingX,this.height=this._textHeight+2*tc.MarginY}paint(e,t,s){const i=this._textWidth/2|0;s.strokeRect(e+this.x-i,t+this.y+tc.MarginY,this._textWidth,this._textHeight);const a=s.font,r=s.textBaseline,n=s.textAlign;s.font=this.renderer.resources.timerFont,s.textBaseline=he.Middle,s.textAlign=oe.Center,s.fillText(this._text,e+this.x,t+this.y+this.height/2),s.font=a,s.textBaseline=r,s.textAlign=n}}tc.PaddingX=2,tc.PaddingY=2,tc.MarginY=2;class sc extends Yn{get notationElement(){return e.NotationElement.EffectBeatTimer}get hideOnMultiTrack(){return!0}get canShareBand(){return!0}get sizingMode(){return ns.SingleOnBeat}shouldCreateGlyph(e,t){return t.showTimer}createNewGlyph(e,t){return new tc(t.timer??0)}canExpand(e,t){return!0}}class ic{static print(e){e(`alphaTab ${ic.version}`),e(`commit: ${ic.commit}`),e(`build date: ${ic.date}`)}}ic.version="1.5.0",ic.date="2025-05-04T16:47:31.157Z",ic.commit="a7cda51f24b9e783ce3d3b719fa1e65198c24319";class ac{constructor(e,t){this.vertical=e,this.createLayout=t}}class rc{constructor(e,t){this.supportsWorkers=e,this.createCanvas=t}}class nc{static createStyleElement(e,t){let s=e.getElementById("alphaTabStyle");if(!s){if(!t)return void j.error("AlphaTab","Font directory could not be detected, cannot create style element");s=e.createElement("style"),s.id="alphaTabStyle";const i=`\n            @font-face {\n                font-display: block;\n                font-family: 'alphaTab';\n                 src: url('${t}Bravura.eot');\n                 src: url('${t}Bravura.eot?#iefix') format('embedded-opentype')\n                      , url('${t}Bravura.woff') format('woff')\n                      , url('${t}Bravura.otf') format('opentype')\n                      , url('${t}Bravura.svg#Bravura') format('svg');\n                 font-weight: normal;\n                 font-style: normal;\n            }\n            .at-surface * {\n                cursor: default;\n                vertical-align: top;\n                overflow: visible;\n            }\n            .at-surface-svg text {\n                dominant-baseline: central;\n                white-space:pre;\n            }\n            .at {\n                 font-family: 'alphaTab';\n                 speak: none;\n                 font-style: normal;\n                 font-weight: normal;\n                 font-variant: normal;\n                 text-transform: none;\n                 line-height: 1;\n                 line-height: 1;\n                 -webkit-font-smoothing: antialiased;\n                 -moz-osx-font-smoothing: grayscale;\n                 font-size: ${nc.MusicFontSize}px;\n                 overflow: visible !important;\n            }`;s.innerHTML=i,e.getElementsByTagName("head").item(0).appendChild(s),nc.bravuraFontChecker.checkForFontAvailability()}}static get globalThis(){if(void 0===nc._globalThis){try{nc._globalThis=globalThis}catch(e){}void 0===nc._globalThis&&(nc._globalThis=self),void 0===nc._globalThis&&(nc._globalThis=global),void 0===nc._globalThis&&(nc._globalThis=window),void 0===nc._globalThis&&(nc._globalThis=Function("return this")())}return nc._globalThis}static get isRunningInWorker(){return"WorkerGlobalScope"in nc.globalThis}static get isRunningInAudioWorklet(){return"AudioWorkletGlobalScope"in nc.globalThis}static throttle(e,t){let s=0;return()=>{nc.globalThis.clearTimeout(s),s=nc.globalThis.setTimeout(e,t)}}static detectScriptFile(){if(!nc.isRunningInWorker&&nc.globalThis.ALPHATAB_ROOT){let e=nc.globalThis.ALPHATAB_ROOT;return e=nc.ensureFullUrl(e),e=nc.appendScriptName(e),e}try{const e={};if(e&&-1===e.indexOf("file://"))return e}catch(e){}return"document"in nc.globalThis&&document.currentScript?document.currentScript.src:null}static ensureFullUrl(e){if(!e)return"";if(!e.startsWith("http")&&!e.startsWith("https")&&!e.startsWith("file")){let t="";const s=nc.globalThis.location;if(t+=s.protocol?.toString(),t+="//"?.toString(),s.hostname&&(t+=s.hostname?.toString()),s.port&&(t+=":"?.toString(),t+=s.port?.toString()),!e.startsWith("/")){const e=s.pathname.split("/").slice(0,-1).join("/");e.length>0&&(e.startsWith("/")||(t+="/"?.toString()),t+=e?.toString())}return e.startsWith("/")||(t+="/"?.toString()),t+=e?.toString(),t}return e}static appendScriptName(e){return e&&!e.endsWith(".js")&&(e.endsWith("/")||(e+="/"),e+="alphaTab.js"),e}static detectFontDirectory(){if(!nc.isRunningInWorker&&nc.globalThis.ALPHATAB_FONT)return nc.ensureFullUrl(nc.globalThis.ALPHATAB_FONT);const e=nc.scriptFile;if(e){const t=e.lastIndexOf(String.fromCharCode(47));if(t>=0)return`${e.substr(0,t)}/font/`}return null}static registerJQueryPlugin(){if(!nc.isRunningInWorker&&nc.globalThis&&"jQuery"in nc.globalThis){const e=nc.globalThis.jQuery,t=new Zr;e.fn.alphaTab=function(e){const s=Array.prototype.slice.call(arguments,1);return 1===this.length?t.exec(this[0],e,s):this.each(((i,a)=>{t.exec(a,e,s)}))},e.alphaTab={restore:Zr.restore},e.fn.alphaTab.fn=t}}static getRenderEngineFactory(e){return e&&nc.renderEngines.has(e)?nc.renderEngines.get(e):nc.renderEngines.get("default")}static getLayoutEngineFactory(t){return t&&nc.layoutEngines.has(t)?nc.layoutEngines.get(t):nc.layoutEngines.get(e.LayoutMode.Page)}static buildImporters(){return[new pt,new ws,new fs,new vs,new _l,new ut]}static createDefaultRenderEngines(){const e=new Map;return e.set("svg",new rc(!0,(()=>new tn))),e.set("default",e.get("svg")),e.set("skia",new rc(!1,(()=>new Tl))),nc.createPlatformSpecificRenderEngines(e),e}static enableAlphaSkia(e,t){Tl.enable(e,t)}static registerAlphaSkiaCustomFont(e){return Tl.registerFont(e)}static createPlatformSpecificRenderEngines(e){e.set("html5",new rc(!1,(()=>new lr)))}static createDefaultRenderers(){return[new Xn(nc.StaffIdBeforeSlashAlways,[new vo,new Do,new go,new ec,new $n,new Vl,new Po,new sc,new jn]),new Cl,new Xn(nc.StaffIdBeforeScoreAlways,[new ro,new Yl,new ql,new jl,new Jl]),new Xn(nc.StaffIdBeforeScoreHideable,[new Mo,new Co,new fo(!0),new Lo,new Bo,new Ao,new To(!1),new rl,new Ul(ue.Finger)],((e,t)=>t.showStandardNotation)),new zh,new Xn(nc.StaffIdBeforeNumberedAlways,[new Zn,new fo(!1),new to,new Ul(ue.Thumb,((e,t)=>t.voice.bar.staff.showStandardNotation)),new zl]),new Wl,new Xn(nc.StaffIdBeforeTabAlways,[new po]),new Xn(nc.StaffIdBeforeTabHideable,[new Co,new Lo,new Bo,new Ao,new To(!0),new No,new io,new lo(N.Natural),new lo(N.Artificial),new lo(N.Pinch),new lo(N.Tap),new lo(N.Semi),new lo(N.Feedback),new co,new qn,new no,new yo,new _o,new bo,new rl,new Ul(ue.Finger,((e,t)=>!t.voice.bar.staff.showStandardNotation))],((e,t)=>t.showTablature)),new il,new Xn(nc.StaffIdBeforeEndAlways,[new Ul(ue.Thumb,((e,t)=>!t.voice.bar.staff.showStandardNotation))])]}static createDefaultStaveProfiles(){const t=new Map,s=nc.createDefaultRenderers();t.set(e.StaveProfile.Default,s),t.set(e.StaveProfile.ScoreTab,s);const i=new Set([nc.StaffIdBeforeSlashAlways,nc.StaffIdBeforeScoreAlways,nc.StaffIdBeforeNumberedAlways,nc.StaffIdBeforeTabAlways,Gh.StaffId,nc.StaffIdBeforeEndAlways]);t.set(e.StaveProfile.Score,s.filter((e=>i.has(e.staffId))));const a=new Set([nc.StaffIdBeforeSlashAlways,nc.StaffIdBeforeScoreAlways,nc.StaffIdBeforeNumberedAlways,nc.StaffIdBeforeTabAlways,sl.StaffId,nc.StaffIdBeforeEndAlways]);return t.set(e.StaveProfile.Tab,nc.createDefaultRenderers().filter((e=>{if(e instanceof il){const t=e;t.showTimeSignature=!0,t.showRests=!0,t.showTiedNotes=!0}return a.has(e.staffId)}))),t.set(e.StaveProfile.TabMixed,nc.createDefaultRenderers().filter((e=>{if(e instanceof il){const t=e;t.showTimeSignature=!1,t.showRests=!1,t.showTiedNotes=!1}return a.has(e.staffId)}))),t}static createDefaultLayoutEngines(){const t=new Map;return t.set(e.LayoutMode.Page,new ac(!0,(e=>new Oo(e)))),t.set(e.LayoutMode.Horizontal,new ac(!1,(e=>new Ro(e)))),t}static initializeMain(t,s){nc.isRunningInWorker||nc.isRunningInAudioWorklet||(nc.webPlatform!==e.WebPlatform.Browser&&nc.webPlatform!==e.WebPlatform.BrowserModule||(nc.registerJQueryPlugin(),nc.HighDpiFactor=window.devicePixelRatio,"ResizeObserver"in nc.globalThis||(nc.globalThis.ResizeObserver=wl),"IntersectionObserver"in nc.globalThis||(nc.globalThis.IntersectionObserver=Bl),"replaceChildren"in Element.prototype||(Element.prototype.replaceChildren=function(...e){this.innerHTML="",this.append(...e)},Document.prototype.replaceChildren=Element.prototype.replaceChildren,DocumentFragment.prototype.replaceChildren=Element.prototype.replaceChildren),"replaceAll"in String.prototype||(String.prototype.replaceAll=function(e,t){return this.replace(new RegExp(e,"g"),t)})),nc.createWebWorker=t,nc.createAudioWorklet=s)}static get alphaTabWorker(){return nc.globalThis.Worker}static get alphaTabUrl(){return nc.globalThis.URL}static initializeWorker(){if(!nc.isRunningInWorker)throw new qe(e.AlphaTabErrorType.General,"Not running in worker, cannot run worker initialization");hr.init(),Ka.init(),nc.createWebWorker=t=>{throw new qe(e.AlphaTabErrorType.General,"Nested workers are not supported")}}static initializeAudioWorklet(){if(!nc.isRunningInAudioWorklet)throw new qe(e.AlphaTabErrorType.General,"Not running in audio worklet, cannot run worklet initialization");$r.init()}static detectWebPack(){try{if("function"==typeof __webpack_require__)return!0}catch(e){}return!1}static detectVite(){try{if("string"==typeof __BASE__)return!0}catch(e){}return!1}static detectWebPlatform(){try{if("[object process]"===Object.prototype.toString.call("undefined"!=typeof process?process:0))return e.WebPlatform.NodeJs}catch(e){}try{const t={};if(t&&"string"==typeof t&&!t.startsWith("file://"))return e.WebPlatform.BrowserModule}catch(e){}return e.WebPlatform.Browser}static printEnvironmentInfo(e=!0){const t=e?e=>{j.log.debug("VersionInfo",e)}:e=>{j.debug("VersionInfo",e)};ic.print(t),t(`High DPI: ${nc.HighDpiFactor}`),nc.printPlatformInfo(t)}static printPlatformInfo(t){t(`Browser: ${navigator.userAgent}`),t(`Platform: ${e.WebPlatform[nc.webPlatform]}`),t(`WebPack: ${nc.isWebPackBundled}`),t(`Vite: ${nc.isViteBundled}`),nc.webPlatform!==e.WebPlatform.NodeJs&&(t(`Window Size: ${window.outerWidth}x${window.outerHeight}`),t(`Screen Size: ${window.screen.width}x${window.screen.height}`))}}nc.StaffIdBeforeSlashAlways="before-slash-always",nc.StaffIdBeforeScoreAlways="before-score-always",nc.StaffIdBeforeScoreHideable="before-score-hideable",nc.StaffIdBeforeNumberedAlways="before-numbered-always",nc.StaffIdBeforeTabAlways="before-tab-always",nc.StaffIdBeforeTabHideable="before-tab-hideable",nc.StaffIdBeforeEndAlways="before-end-always",nc.MusicFontSize=34,nc.HighDpiFactor=1,nc._globalThis=void 0,nc.webPlatform=nc.detectWebPlatform(),nc.isWebPackBundled=nc.detectWebPack(),nc.isViteBundled=nc.detectVite(),nc.scriptFile=nc.detectScriptFile(),nc.fontDirectory=nc.detectFontDirectory(),nc.bravuraFontChecker=new Hr(["alphaTab"]),nc.renderEngines=nc.createDefaultRenderEngines(),nc.layoutEngines=nc.createDefaultLayoutEngines(),nc.staveProfiles=nc.createDefaultStaveProfiles();class oc{constructor(){this.scriptFile=null,this.fontDirectory=null,this.file=null,this.tex=!1,this.tracks=null,this.enableLazyLoading=!0,this.engine="default",this.logLevel=e.LogLevel.Info,this.useWorkers=!0,this.includeNoteBounds=!1,this.scriptFile=nc.scriptFile,this.fontDirectory=nc.fontDirectory}}const hc=Object.freeze(Object.defineProperty({__proto__:null,ScoreImporter:$e,ScoreLoader:Ir,UnsupportedFormatError:je},Symbol.toStringTag,{value:"Module"})),lc=Object.freeze(Object.defineProperty({__proto__:null,ByteBuffer:lt,IOHelper:ht},Symbol.toStringTag,{value:"Module"}));class cc{init(e,t){this.data=e,this.settings=t}export(e,t=null){const s=lt.withCapacity(1024);return this.init(s,t??new ka),this.writeScore(e),s.toArray()}}var dc;!function(e){e[e.SteelGuitar=1]="SteelGuitar",e[e.AcousticGuitar=2]="AcousticGuitar",e[e.TwelveStringGuitar=3]="TwelveStringGuitar",e[e.ElectricGuitar=4]="ElectricGuitar",e[e.Bass=5]="Bass",e[e.ClassicalGuitar=23]="ClassicalGuitar",e[e.UprightBass=6]="UprightBass",e[e.Ukulele=7]="Ukulele",e[e.Banjo=8]="Banjo",e[e.Mandolin=9]="Mandolin",e[e.Piano=10]="Piano",e[e.Synth=12]="Synth",e[e.Strings=11]="Strings",e[e.Brass=13]="Brass",e[e.Reed=14]="Reed",e[e.Woodwind=15]="Woodwind",e[e.Vocal=16]="Vocal",e[e.PitchedIdiophone=17]="PitchedIdiophone",e[e.Fx=21]="Fx",e[e.PercussionKit=18]="PercussionKit",e[e.Idiophone=19]="Idiophone",e[e.Membraphone=20]="Membraphone"}(dc||(dc={}));class uc{constructor(e,t,s=null){if(this.icon=dc.Piano,this.icon=e,this.instrumentSetName=t,s)this.instrumentSetType=s;else{const e=t.split(" ");e[0]=e[0].substr(0,1).toLowerCase()+e[0].substr(1),this.instrumentSetType=e.join("")}}}class pc{constructor(){this._rhythmIdLookup=new Map}writeXml(e){const t=new Bt;return this._rhythmIdLookup=new Map,this.writeDom(t,e),t.toFormattedString("",!0)}writeDom(e,t){const s=e.addElement("GPIF");s.addElement("GPVersion").innerText="7";const i=s.addElement("GPRevision");i.innerText="7",i.attributes.set("required","12021"),i.attributes.set("recommended","12023"),i.innerText="12025",s.addElement("Encoding").addElement("EncodingDescription").innerText="GP7",this.writeScoreNode(s,t),this.writeMasterTrackNode(s,t),this.writeAudioTracksNode(s,t),this.writeTracksNode(s,t),this.writeMasterBarsNode(s,t);const a=s.addElement("Bars"),r=s.addElement("Voices"),n=s.addElement("Beats"),o=s.addElement("Notes"),h=s.addElement("Rhythms");for(const e of t.tracks)for(const t of e.staves)for(const e of t.bars){this.writeBarNode(a,e);for(const t of e.voices){this.writeVoiceNode(r,t);for(const e of t.beats){this.writeBeatNode(n,e,h);for(const t of e.notes)this.writeNoteNode(o,t)}}}}writeNoteNode(e,t){const s=e.addElement("Note");s.attributes.set("id",t.id.toString()),this.writeNoteProperties(s,t),t.isGhost&&(s.addElement("AntiAccent").innerText="normal"),t.isLetRing&&s.addElement("LetRing"),t.isTrill&&(s.addElement("Trill").innerText=t.trillValue.toString());let i=0;switch(t.isStaccato&&(i|=1),t.accentuated){case k.Normal:i|=8;break;case k.Heavy:i|=4;break;case k.Tenuto:i|=16}if(i>0&&(s.addElement("Accent").innerText=i.toString()),t.isTieOrigin||t.isTieDestination){const e=s.addElement("Tie");e.attributes.set("origin",t.isTieOrigin?"true":"false"),e.attributes.set("destination",t.isTieDestination?"true":"false")}switch(t.vibrato){case F.Slight:s.addElement("Vibrato").innerText="Slight";break;case F.Wide:s.addElement("Vibrato").innerText="Wide"}if(t.isFingering){switch(t.leftHandFinger){case T.Thumb:s.addElement("LeftFingering").innerText="P";break;case T.IndexFinger:s.addElement("LeftFingering").innerText="I";break;case T.MiddleFinger:s.addElement("LeftFingering").innerText="M";break;case T.AnnularFinger:s.addElement("LeftFingering").innerText="A";break;case T.LittleFinger:s.addElement("LeftFingering").innerText="C"}switch(t.rightHandFinger){case T.Thumb:s.addElement("RightFingering").innerText="P";break;case T.IndexFinger:s.addElement("RightFingering").innerText="I";break;case T.MiddleFinger:s.addElement("RightFingering").innerText="M";break;case T.AnnularFinger:s.addElement("RightFingering").innerText="A";break;case T.LittleFinger:s.addElement("RightFingering").innerText="C"}}t.percussionArticulation>=0?s.addElement("InstrumentArticulation").innerText=t.percussionArticulation.toString():s.addElement("InstrumentArticulation").innerText="0",t.ornament!==le.None&&(s.addElement("Ornament").innerText=le[t.ornament])}writeNoteProperties(e,t){const s=e.addElement("Properties");if(this.writeConcertPitch(s,t),this.writeTransposedPitch(s,t),t.isStringed&&(this.writeSimplePropertyNode(s,"String","String",(t.string-1).toString()),this.writeSimplePropertyNode(s,"Fret","Fret",t.fret.toString()),this.writeSimplePropertyNode(s,"Midi","Number",t.realValue.toString()),t.showStringNumber&&this.writeSimplePropertyNode(s,"ShowStringNumber","Enable",null)),t.isPiano&&(this.writeSimplePropertyNode(s,"Octave","Number",t.octave.toString()),this.writeSimplePropertyNode(s,"Tone","Step",t.tone.toString()),this.writeSimplePropertyNode(s,"Midi","Number",t.realValue.toString())),t.beat.tap&&this.writeSimplePropertyNode(s,"Tapped","Enable",null),t.harmonicType!==N.None){switch(t.harmonicType){case N.Natural:this.writeSimplePropertyNode(s,"HarmonicType","HType","Natural");break;case N.Artificial:this.writeSimplePropertyNode(s,"HarmonicType","HType","Artificial");break;case N.Pinch:this.writeSimplePropertyNode(s,"HarmonicType","HType","Pinch");break;case N.Tap:this.writeSimplePropertyNode(s,"HarmonicType","HType","Tap");break;case N.Semi:this.writeSimplePropertyNode(s,"HarmonicType","HType","Semi");break;case N.Feedback:this.writeSimplePropertyNode(s,"HarmonicType","HType","Feedback")}0!==t.harmonicValue&&this.writeSimplePropertyNode(s,"HarmonicFret","HFret",t.harmonicValue.toString())}t.isDead&&this.writeSimplePropertyNode(s,"Muted","Enable",null),t.isPalmMute&&this.writeSimplePropertyNode(s,"PalmMuted","Enable",null),t.hasBend&&this.writeBend(s,t),t.isHammerPullOrigin&&this.writeSimplePropertyNode(s,"HopoOrigin","Enable",null),t.isHammerPullDestination&&this.writeSimplePropertyNode(s,"HopoDestination","Enable",null),t.isLeftHandTapped&&this.writeSimplePropertyNode(s,"LeftHandTapped","Enable",null);let i=0;switch(t.slideInType){case v.IntoFromAbove:i|=32;break;case v.IntoFromBelow:i|=16}switch(t.slideOutType){case P.Shift:i|=1;break;case P.Legato:i|=2;break;case P.OutDown:i|=4;break;case P.OutUp:i|=8;break;case P.PickSlideDown:i|=64;break;case P.PickSlideUp:i|=128}i>0&&this.writeSimplePropertyNode(s,"Slide","Flags",i.toString())}writeTransposedPitch(e,t){t.isPercussion?this.writePitch(e,"ConcertPitch","C","-1",""):this.writePitchForValue(e,"TransposedPitch",t.displayValueWithoutBend,t.accidentalMode)}writeConcertPitch(e,t){t.isPercussion?this.writePitch(e,"ConcertPitch","C","-1",""):this.writePitchForValue(e,"ConcertPitch",t.realValueWithoutHarmonic,t.accidentalMode)}writePitchForValue(e,t,s,i){let a=0,r=0,n="",o="";const h=()=>{a=s%12,r=s/12|0,n=it.defaultSteps[a],o=it.defaultAccidentals[a]};switch(h(),i){case x.Default:break;case x.ForceNone:case x.ForceNatural:o="";break;case x.ForceSharp:o="#";break;case x.ForceDoubleSharp:"#"===o&&(s-=2,h()),o="x";break;case x.ForceFlat:"#"===o&&(s+=1,h()),o="b";break;case x.ForceDoubleFlat:"#"===o&&(s+=2,h()),o="bb"}this.writePitch(e,t,n,r.toString(),o)}writePitch(e,t,s,i,a){const r=e.addElement("Property");r.attributes.set("name",t);const n=r.addElement("Pitch");n.addElement("Step").innerText=s,n.addElement("Accidental").innerText=a,n.addElement("Octave").innerText=i}writeBend(e,t){t.hasBend&&t.bendPoints.length<=4&&this.writeStandardBend(e,t.bendPoints)}writeStandardBend(e,t){this.writeSimplePropertyNode(e,"Bended","Enable",null);const s=t[0],i=t[t.length-1];let a,r;switch(t.length){case 4:a=t[1],r=t[2];break;case 3:a=t[1],r=t[1];break;default:a=new J((s.offset+i.offset)/2,(s.value+i.value)/2),r=a}this.writeSimplePropertyNode(e,"BendDestinationOffset","Float",this.toBendOffset(i.offset).toString()),this.writeSimplePropertyNode(e,"BendDestinationValue","Float",this.toBendValue(i.value).toString()),this.writeSimplePropertyNode(e,"BendMiddleOffset1","Float",this.toBendOffset(a.offset).toString()),this.writeSimplePropertyNode(e,"BendMiddleOffset2","Float",this.toBendOffset(r.offset).toString()),this.writeSimplePropertyNode(e,"BendMiddleValue","Float",this.toBendValue(a.value).toString()),this.writeSimplePropertyNode(e,"BendOriginOffset","Float",this.toBendOffset(s.offset).toString()),this.writeSimplePropertyNode(e,"BendOriginValue","Float",this.toBendValue(s.value).toString())}toBendValue(e){return 25*e}toBendOffset(e){return e/J.MaxPosition*100}writeBeatNode(e,t,s){const i=e.addElement("Beat");if(i.attributes.set("id",t.id.toString()),i.addElement("Dynamic").innerText=m[t.dynamics],t.fade!==pe.None&&(i.addElement("Fadding").innerText=pe[t.fade]),t.isTremolo)switch(t.tremoloSpeed){case w.Eighth:i.addElement("Tremolo").innerText="1/2";break;case w.Sixteenth:i.addElement("Tremolo").innerText="1/4";break;case w.ThirtySecond:i.addElement("Tremolo").innerText="1/8"}switch(t.hasChord&&i.addElement("Chord").setCData(t.chordId),t.crescendo!==_.None&&(i.addElement("Hairpin").innerText=_[t.crescendo]),t.brushType){case S.ArpeggioUp:i.addElement("Arpeggio").innerText="Up";break;case S.ArpeggioDown:i.addElement("Arpeggio").innerText="Down"}switch(t.text&&i.addElement("FreeText").setCData(t.text),t.graceType){case B.OnBeat:case B.BeforeBeat:i.addElement("GraceNotes").innerText=B[t.graceType]}if(t.ottava!==h.Regular&&(i.addElement("Ottavia").innerText=h[t.ottava].substr(1)),t.hasWhammyBar&&this.writeWhammyNode(i,t),t.isLegatoOrigin||t.isLegatoDestination){const e=i.addElement("Legato");e.attributes.set("origin",t.isLegatoOrigin?"true":"false"),e.attributes.set("destination",t.isLegatoDestination?"true":"false")}if(this.writeRhythm(i,t,s),null!==t.preferredBeamDirection)switch(t.preferredBeamDirection){case Ne.Up:i.addElement("TransposedPitchStemOrientation").innerText="Upward",i.addElement("UserTransposedPitchStemOrientation").innerText="Upward";break;case Ne.Down:i.addElement("TransposedPitchStemOrientation").innerText="Downward",i.addElement("UserTransposedPitchStemOrientation").innerText="Downward"}i.addElement("ConcertPitchStemOrientation").innerText="Undefined",t.slashed&&i.addElement("Slashed"),t.deadSlapped&&i.addElement("DeadSlapped"),t.notes.length>0&&(i.addElement("Notes").innerText=t.notes.map((e=>e.id)).join(" ")),t.golpe!==ue.None&&(i.addElement("Golpe").innerText=ue[t.golpe]),t.wahPedal!==ge.None&&(i.addElement("Wah").innerText=ge[t.wahPedal]),t.showTimer&&(i.addElement("Timer").innerText=(t.timer??0).toString()),this.writeBeatProperties(i,t),this.writeBeatXProperties(i,t),t.lyrics&&t.lyrics.length>0&&this.writeBeatLyrics(i,t.lyrics)}writeBeatLyrics(e,t){const s=e.addElement("Lyrics");for(const e of t){s.addElement("Line").setCData(e)}}writeBeatXProperties(e,t){const s=e.addElement("XProperties");switch(t.brushDuration>0&&this.writeSimpleXPropertyNode(s,"687935489","Int",t.brushDuration.toString()),t.beamingMode){case ye.ForceSplitToNext:this.writeSimpleXPropertyNode(s,"1124204546","Int","2");break;case ye.ForceMergeWithNext:this.writeSimpleXPropertyNode(s,"1124204546","Int","1");break;case ye.ForceSplitOnSecondaryToNext:this.writeSimpleXPropertyNode(s,"1124204552","Int","1")}}writeBeatProperties(e,t){const s=e.addElement("Properties");switch(t.brushType){case S.BrushUp:this.writeSimplePropertyNode(s,"Brush","Direction","Up");break;case S.BrushDown:this.writeSimplePropertyNode(s,"Brush","Direction","Down")}switch(t.pickStroke){case re.Up:this.writeSimplePropertyNode(s,"PickStroke","Direction","Up");break;case re.Down:this.writeSimplePropertyNode(s,"PickStroke","Direction","Down")}switch(t.slap&&this.writeSimplePropertyNode(s,"Slapped","Enable",null),t.pop&&this.writeSimplePropertyNode(s,"Popped","Enable",null),t.vibrato){case F.Wide:this.writeSimplePropertyNode(s,"VibratoWTremBar","Strength","Wide");break;case F.Slight:this.writeSimplePropertyNode(s,"VibratoWTremBar","Strength","Slight")}if(t.isBarre)switch(this.writeSimplePropertyNode(s,"BarreFret","Fret",t.barreFret.toString()),t.barreShape){case me.Full:this.writeSimplePropertyNode(s,"BarreString","String","0");break;case me.Half:this.writeSimplePropertyNode(s,"BarreString","String","1")}if(t.rasgueado!==fe.None){let e="";switch(t.rasgueado){case fe.Ii:e="ii_1";break;case fe.Mi:e="mi_1";break;case fe.MiiTriplet:e="mii_1";break;case fe.MiiAnapaest:e="mii_2";break;case fe.PmpTriplet:e="pmp_1";break;case fe.PmpAnapaest:e="pmp_2";break;case fe.PeiTriplet:e="pei_1";break;case fe.PeiAnapaest:e="pei_2";break;case fe.PaiTriplet:e="pai_1";break;case fe.PaiAnapaest:e="pai_2";break;case fe.AmiTriplet:e="ami_1";break;case fe.AmiAnapaest:e="ami_2";break;case fe.Ppp:e="ppp_1";break;case fe.Amii:e="amii_1";break;case fe.Amip:e="amip_1";break;case fe.Eami:e="eami_1";break;case fe.Eamii:e="eamii_1";break;case fe.Peami:e="peami_1"}this.writeSimplePropertyNode(s,"Rasgueado","Rasgueado",e)}}writeRhythm(e,t,s){const i=`${t.duration}_${t.dots}_${t.tupletNumerator}_${t.tupletDenominator}';`;let a;if(this._rhythmIdLookup.has(i))a=this._rhythmIdLookup.get(i);else{a=this._rhythmIdLookup.size.toString(),this._rhythmIdLookup.set(i,a);const e=s.addElement("Rhythm");if(e.attributes.set("id",a),t.hasTuplet){const s=e.addElement("PrimaryTuplet");s.attributes.set("num",t.tupletNumerator.toString()),s.attributes.set("den",t.tupletDenominator.toString())}t.dots>0&&e.addElement("AugmentationDot").attributes.set("count",t.dots.toString());let r="Quarter";switch(t.duration){case w.QuadrupleWhole:r="Long";break;case w.DoubleWhole:r="DoubleWhole";break;case w.Whole:r="Whole";break;case w.Half:r="Half";break;case w.Quarter:r="Quarter";break;case w.Eighth:r="Eighth";break;case w.Sixteenth:r="16th";break;case w.ThirtySecond:r="32nd";break;case w.SixtyFourth:r="64th";break;case w.OneHundredTwentyEighth:r="128th";break;case w.TwoHundredFiftySixth:r="256th"}e.addElement("NoteValue").innerText=r}e.addElement("Rhythm").attributes.set("ref",a)}writeWhammyNode(e,t){t.hasWhammyBar&&t.whammyBarPoints.length<=4&&this.writeStandardWhammy(e,t.whammyBarPoints)}writeStandardWhammy(e,t){const s=e.addElement("Whammy"),i=t[0],a=t[t.length-1];let r,n;switch(t.length){case 4:r=t[1],n=t[2];break;case 3:r=t[1],n=t[1];break;default:r=new J((i.offset+a.offset)/2,(i.value+a.value)/2),n=r}s.attributes.set("destinationOffset",this.toBendOffset(a.offset).toString()),s.attributes.set("destinationValue",this.toBendValue(a.value).toString()),s.attributes.set("middleOffset1",this.toBendOffset(r.offset).toString()),s.attributes.set("middleOffset2",this.toBendOffset(n.offset).toString()),s.attributes.set("middleValue",this.toBendValue(r.value).toString()),s.attributes.set("originOffset",this.toBendOffset(i.offset).toString()),s.attributes.set("originValue",this.toBendValue(i.value).toString())}writeScoreNode(e,t){const s=e.addElement("Score");s.addElement("Title").setCData(t.title),s.addElement("SubTitle").setCData(t.subTitle),s.addElement("Artist").setCData(t.artist),s.addElement("Album").setCData(t.album),s.addElement("Words").setCData(t.words),s.addElement("Music").setCData(t.music),s.addElement("WordsAndMusic").setCData(t.words===t.music?t.words:""),s.addElement("Copyright").setCData(t.copyright),s.addElement("Tabber").setCData(t.tab),s.addElement("Instructions").setCData(t.instructions),s.addElement("Notices").setCData(t.notices),s.addElement("FirstPageHeader").setCData(""),s.addElement("FirstPageFooter").setCData(""),s.addElement("PageHeader").setCData(""),s.addElement("PageFooter").setCData(""),s.addElement("ScoreSystemsDefaultLayout").setCData(t.defaultSystemsLayout.toString()),s.addElement("ScoreSystemsLayout").setCData(t.systemsLayout.join(" ")),s.addElement("ScoreZoomPolicy").innerText="Value",s.addElement("ScoreZoom").innerText="1",s.addElement("MultiVoice").innerText="1>"}writeMasterTrackNode(e,t){const s=e.addElement("MasterTrack");s.addElement("Tracks").innerText=t.tracks.map((e=>e.index)).join(" ");const i=s.addElement("Automations");if(t.masterBars.length>0&&t.masterBars[0].isAnacrusis&&s.addElement("Anacrusis"),0===t.masterBars[0].tempoAutomations.length){const e=i.addElement("Automation");e.addElement("Type").innerText="Tempo",e.addElement("Linear").innerText="false",e.addElement("Bar").innerText="0",e.addElement("Position").innerText="0",e.addElement("Visible").innerText="true",e.addElement("Value").innerText=`${t.tempo} 2`,t.tempoLabel&&(e.addElement("Text").innerText=t.tempoLabel)}for(const e of t.masterBars)for(const t of e.tempoAutomations){const s=i.addElement("Automation");s.addElement("Type").innerText="Tempo",s.addElement("Linear").innerText=t.isLinear?"true":"false",s.addElement("Bar").innerText=e.index.toString(),s.addElement("Position").innerText=t.ratioPosition.toString(),s.addElement("Visible").innerText="true",s.addElement("Value").innerText=`${t.value} 2`,t.text&&(s.addElement("Text").innerText=t.text)}}writeAudioTracksNode(e,t){e.addElement("AudioTracks")}writeTracksNode(e,t){const s=e.addElement("Tracks");for(const e of t.tracks)this.writeTrackNode(s,e)}writeTrackNode(e,t){const s=e.addElement("Track");s.attributes.set("id",t.index.toString()),s.addElement("Name").setCData(t.name),s.addElement("ShortName").setCData(t.shortName),s.addElement("Color").innerText=`${t.color.r} ${t.color.g} ${t.color.b}`,s.addElement("SystemsDefautLayout").innerText=t.defaultSystemsLayout.toString(),s.addElement("SystemsLayout").innerText=t.systemsLayout.join(" "),s.addElement("AutoBrush"),s.addElement("PalmMute").innerText="0",s.addElement("PlayingStyle").innerText=R.isGuitar(t.playbackInfo.program)?"StringedPick":"Default",s.addElement("UseOneChannelPerString"),s.addElement("IconId").innerText=pc.getIconId(t.playbackInfo).toString(),this.writeInstrumentSetNode(s,t),this.writeTransposeNode(s,t),this.writeRseNode(s,t),s.addElement("ForcedSound").innerText="-1",this.writeMidiConnectionNode(s,t),t.playbackInfo.isSolo?s.addElement("PlaybackState").innerText="Solo":t.playbackInfo.isMute?s.addElement("PlaybackState").innerText="Mute":s.addElement("PlaybackState").innerText="Default",s.addElement("AudioEngineState").innerText="MIDI",this.writeLyricsNode(s,t),this.writeStavesNode(s,t),this.writeSoundsAndAutomations(s,t)}static getIconId(e){return 9===e.primaryChannel?pc.DrumKitProgramInfo.icon:pc.MidiProgramInfoLookup.has(e.program)?pc.MidiProgramInfoLookup.get(e.program).icon:dc.SteelGuitar}writeSoundAndAutomation(e,t,s,i,a,r,n,o=0){const h=e.addElement("Sound");h.addElement("Name").setCData(s),h.addElement("Label").setCData(s),h.addElement("Path").setCData(i),h.addElement("Role").setCData(a);const l=h.addElement("MIDI");l.addElement("LSB").innerText="0",l.addElement("MSB").innerText="0",l.addElement("Program").innerText=n.toString();const c=t.addElement("Automation");c.addElement("Type").innerText="Sound",c.addElement("Linear").innerText="false",c.addElement("Bar").innerText=r.toString(),c.addElement("Position").innerText=o.toString(),c.addElement("Visible").innerText="true",c.addElement("Value").setCData(`${i};${s};${a}`)}writeSoundsAndAutomations(e,t){const s=e.addElement("Sounds"),i=e.addElement("Automations");if(t.staves.length>0&&t.staves[0].bars.length>0){const e=`Track_${t.index}_Initial`,a=`Midi/${t.playbackInfo.program}`,r="Factory";let n=!1;for(const o of t.staves)for(const h of o.bars)for(const o of h.voices)for(const l of o.beats){const o=l.getAutomation(f.Instrument),c=0===h.index&&0===l.index;if(o){const d=c?e:`ProgramChange_${l.id}`,u=c?a:`Midi/${o.value}`,p=c?r:"User";c||n||(this.writeSoundAndAutomation(s,i,e,a,r,t.staves[0].bars[0].index,t.playbackInfo.program),n=!0),this.writeSoundAndAutomation(s,i,d,u,p,h.index,o.value,o.ratioPosition),c&&(n=!0)}}}for(const e of t.staves)for(const t of e.bars)for(const e of t.sustainPedals)if(e.pedalType!==u.Hold){const s=i.addElement("Automation");switch(s.addElement("Type").innerText="SustainPedal",s.addElement("Linear").innerText="false",s.addElement("Bar").innerText=t.index.toString(),s.addElement("Position").innerText=e.ratioPosition.toString(),s.addElement("Visible").innerText="true",e.pedalType){case u.Down:s.addElement("Value").innerText="0 1";break;case u.Up:s.addElement("Value").innerText="0 3"}}}writeMidiConnectionNode(e,t){const s=e.addElement("MidiConnection");s.addElement("Port").innerText=t.playbackInfo.port.toString(),s.addElement("PrimaryChannel").innerText=t.playbackInfo.primaryChannel.toString(),s.addElement("SecondaryChannel").innerText=t.playbackInfo.secondaryChannel.toString(),s.addElement("ForeOneChannelPerString").innerText="false"}writeRseNode(e,t){const s=e.addElement("RSE").addElement("ChannelStrip");s.attributes.set("version","E56");s.addElement("Parameters").innerText=`0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5 1 0.5 ${t.playbackInfo.balance/16} ${t.playbackInfo.volume/16} 0.5 0.5 0.5`}writeStavesNode(e,t){const s=e.addElement("Staves");for(const e of t.staves)this.writeStaffNode(s,e)}writeStaffNode(e,t){const s=e.addElement("Staff").addElement("Properties");if(this.writeSimplePropertyNode(s,"CapoFret","Fret",t.capo.toString()),this.writeSimplePropertyNode(s,"FretCount","Fret","24"),t.tuning.length>0){const e=s.addElement("Property");switch(e.attributes.set("name","Tuning"),e.addElement("Pitches").innerText=t.tuning.slice().reverse().join(" "),e.addElement("Label").setCData(t.tuningName),e.addElement("LabelVisible").innerText=t.tuningName?"true":"false",e.addElement("Flat"),t.tuning.length){case 3:e.addElement("Instrument").innerText="Shamisen";break;case 4:105===t.track.playbackInfo.program?e.addElement("Instrument").innerText="Banjo":42===t.track.playbackInfo.program?e.addElement("Instrument").innerText="Cello":43===t.track.playbackInfo.program?e.addElement("Instrument").innerText="Contrabass":40===t.track.playbackInfo.program?e.addElement("Instrument").innerText="Violin":41===t.track.playbackInfo.program?e.addElement("Instrument").innerText="Viola":e.addElement("Instrument").innerText="Bass";break;case 5:105===t.track.playbackInfo.program?e.addElement("Instrument").innerText="Banjo":e.addElement("Instrument").innerText="Bass";break;case 6:105===t.track.playbackInfo.program?e.addElement("Instrument").innerText="Banjo":t.track.playbackInfo.program<=39?e.addElement("Instrument").innerText="Bass":e.addElement("Instrument").innerText="Guitar";break;case 7:t.track.playbackInfo.program<=39?e.addElement("Instrument").innerText="Bass":e.addElement("Instrument").innerText="Guitar";break;default:e.addElement("Instrument").innerText="Guitar"}}this.writeSimplePropertyNode(s,"PartialCapoFret","Fret","0"),this.writeSimplePropertyNode(s,"PartialCapoStringFlags","Bitset",t.tuning.map((e=>"0")).join("")),this.writeSimplePropertyNode(s,"TuningFlat","Enable",null),this.writeDiagramCollection(s,t,"DiagramCollection"),this.writeDiagramCollection(s,t,"DiagramWorkingSet")}writeDiagramCollection(e,t,s){const i=e.addElement("Property");i.attributes.set("name",s);const a=i.addElement("Items"),r=t.chords;if(r)for(const[e,t]of r){const s=a.addElement("Item");s.attributes.set("id",e),s.attributes.set("name",t.name);const i=s.addElement("Diagram");i.attributes.set("stringCount",t.strings.length.toString()),i.attributes.set("fretCount","5"),i.attributes.set("baseFret",(t.firstFret-1).toString()),i.attributes.set("barStates",t.strings.map((e=>"1")).join(" "));const r=[],n=new Map;for(let e=0;e<t.strings.length;e++){const s=t.strings[e];if(-1!==s){const a=i.addElement("Fret"),o=t.strings.length-1-e;a.attributes.set("string",o.toString()),a.attributes.set("fret",(s-t.firstFret+1).toString()),n.has(s)||(n.set(s,[]),r.push(s)),n.get(s).push(o)}}r.sort();const o=i.addElement("Fingering");if(t.barreFrets.length>0){const e=[T.LittleFinger,T.AnnularFinger,T.MiddleFinger,T.IndexFinger];for(const s of r){const i=n.get(s);if(i.length>1&&t.barreFrets.indexOf(s)>=0){const a=e.length>0?e.pop():T.IndexFinger;for(const e of i){const i=o.addElement("Position");switch(a){case T.LittleFinger:i.attributes.set("finger","Pinky");break;case T.AnnularFinger:i.attributes.set("finger","Ring");break;case T.MiddleFinger:i.attributes.set("finger","Middle");break;case T.IndexFinger:i.attributes.set("finger","Index")}i.attributes.set("fret",(s-t.firstFret+1).toString()),i.attributes.set("string",e.toString())}}}}const h=i.addElement("Property");h.attributes.set("name","ShowName"),h.attributes.set("type","bool"),h.attributes.set("value",t.showName?"true":"false");const l=i.addElement("Property");l.attributes.set("name","ShowDiagram"),l.attributes.set("type","bool"),l.attributes.set("value",t.showDiagram?"true":"false");const c=i.addElement("Property");c.attributes.set("name","ShowFingering"),c.attributes.set("type","bool"),c.attributes.set("value",t.showFingering?"true":"false");const d=i.addElement("Chord"),u=d.addElement("KeyNote");u.attributes.set("step","C"),u.attributes.set("accidental","Natural");const p=d.addElement("BassNote");p.attributes.set("step","C"),p.attributes.set("accidental","Natural");const g=d.addElement("Degree");g.attributes.set("interval","Third"),g.attributes.set("alteration","Major"),g.attributes.set("omitted","false");const m=d.addElement("Degree");m.attributes.set("interval","Fifth"),m.attributes.set("alteration","Perfect"),m.attributes.set("omitted","false")}}writeSimplePropertyNode(e,t,s,i){const a=e.addElement("Property");a.attributes.set("name",t);const r=a.addElement(s);return null!==i&&(r.innerText=i),a}writeSimpleXPropertyNode(e,t,s,i){const a=e.addElement("XProperty");a.attributes.set("id",t);const r=a.addElement(s);return null!==i&&(r.innerText=i),a}writeLyricsNode(e,t){const s=e.addElement("Lyrics");s.attributes.set("dispatched","true");const i=[];for(const e of t.staves[0].bars)for(const t of e.voices)if(!t.isEmpty)for(const s of t.beats)if(s.lyrics)for(let t=0;t<s.lyrics.length;t++){for(;t>=i.length;){const t=new Qe;t.startBar=e.index,t.text="[Empty]",i.push(t)}const a=i[t];a.text="[Empty]"===a.text?s.lyrics[t]:`${a.text} ${s.lyrics[t].split(" ").join("+")}`}for(let e=0;e<i.length;e++){const t=s.addElement("Line");t.addElement("Text").setCData(i[e].text),t.addElement("Offset").innerText=i[e].startBar.toString()}}writeTransposeNode(e,t){const s=e.addElement("Transpose"),i=Math.floor(t.staves[0].displayTranspositionPitch/12),a=t.staves[0].displayTranspositionPitch-12*i;s.addElement("Chromatic").innerText=a.toString(),s.addElement("Octave").innerText=i.toString()}writeInstrumentSetNode(e,t){const s=e.addElement("InstrumentSet"),i=t.staves[0];if(s.addElement("LineCount").innerText=i.standardNotationLineCount.toString(),t.percussionArticulations.length>0||i.isPercussion){const e=t.percussionArticulations.length>0?t.percussionArticulations:Array.from(Le.instrumentArticulations.values());s.addElement("Name").innerText=pc.DrumKitProgramInfo.instrumentSetName,s.addElement("Type").innerText=pc.DrumKitProgramInfo.instrumentSetType;let i="",a=new bt;const r=new Map,n=s.addElement("Elements");for(const t of e){{const e=n.addElement("Element");let s=t.elementType;if(r.has(s)){const e=r.get(s);s+=` ${e}`,r.set(s,e+1)}else r.set(s,1);i=s,e.addElement("Name").innerText=s,e.addElement("Type").innerText=t.elementType,a=e.addElement("Articulations")}const e=a.addElement("Articulation");switch(e.addElement("Name").innerText=`${i} ${a.childNodes.length}`,e.addElement("StaffLine").innerText=t.staffLine.toString(),e.addElement("Noteheads").innerText=[this.mapMusicSymbol(t.noteHeadDefault),this.mapMusicSymbol(t.noteHeadHalf),this.mapMusicSymbol(t.noteHeadWhole)].join(" "),t.techniqueSymbolPlacement){case he.Top:e.addElement("TechniquePlacement").innerText="below";break;case he.Middle:e.addElement("TechniquePlacement").innerText="inside";break;case he.Bottom:e.addElement("TechniquePlacement").innerText="above"}e.addElement("TechniqueSymbol").innerText=this.mapMusicSymbol(t.techniqueSymbol),e.addElement("InputMidiNumbers").innerText="",e.addElement("OutputMidiNumber").innerText=t.outputMidiNumber.toString()}}else{const e=pc.MidiProgramInfoLookup.has(t.playbackInfo.program)?pc.MidiProgramInfoLookup.get(t.playbackInfo.program):pc.MidiProgramInfoLookup.get(0);s.addElement("Name").innerText=e.instrumentSetName,s.addElement("Type").innerText=e.instrumentSetType;const i=s.addElement("Elements").addElement("Element");i.addElement("Pitched").innerText="Pitched",i.addElement("Type").innerText="pitched",i.addElement("SoundbankName").innerText="";const a=i.addElement("Articulations").addElement("Articulation");a.addElement("Name").innerText="",a.addElement("StaffLine").innerText="0",a.addElement("Noteheads").innerText="noteheadBlack noteheadHalf noteheadWhole",a.addElement("TechniquePlacement").innerText="outside",a.addElement("TechniqueSymbol").innerText="",a.addElement("InputMidiNumbers").innerText="",a.addElement("OutputRSESound").innerText="",a.addElement("OutputMidiNumber").innerText="0"}}mapMusicSymbol(e){if(e===ne.None)return"";const t=ne[e];return t.substring(0,1).toLowerCase()+t.substring(1)}writeMasterBarsNode(e,t){const s=e.addElement("MasterBars");for(const e of t.masterBars)this.writeMasterBarNode(s,e)}writeMasterBarNode(e,t){const s=e.addElement("MasterBar"),i=s.addElement("Key");i.addElement("AccidentalCount").innerText=t.keySignature.toString(),i.addElement("Mode").innerText=d[t.keySignatureType],i.addElement("Sharps").innerText="Sharps",s.addElement("Time").innerText=`${t.timeSignatureNumerator}/${t.timeSignatureDenominator}`,t.isFreeTime&&s.addElement("FreeTime");const a=[];for(const e of t.score.tracks)for(const s of e.staves)a.push(s.bars[t.index].id.toString());if(s.addElement("Bars").innerText=a.join(" "),t.isDoubleBar&&s.addElement("DoubleBar"),t.isSectionStart){const e=s.addElement("Section");e.addElement("Letter").setCData(t.section.marker),e.addElement("Text").setCData(t.section.text)}if(t.isRepeatStart||t.isRepeatEnd){const e=s.addElement("Repeat");e.attributes.set("start",t.isRepeatStart?"true":"false"),e.attributes.set("end",t.isRepeatEnd?"true":"false"),t.isRepeatEnd&&e.attributes.set("count",t.repeatCount.toString())}if(t.alternateEndings>0){let e=t.alternateEndings;const i=[];let a=0;for(;e>0;)1==(e>>a&1)&&(i.push(a+1),e&=~(1<<a)),a++;s.addElement("AlternateEndings").innerText=i.join(" ")}if(t.tripletFeel!==A.NoTripletFeel&&(s.addElement("TripletFeel").innerText=A[t.tripletFeel]),t.directions&&t.directions.size>0){const e=s.addElement("Directions");for(const s of t.directions)switch(s){case ke.TargetFine:e.addElement("Target").innerText="Fine";break;case ke.TargetSegno:e.addElement("Target").innerText="Segno";break;case ke.TargetSegnoSegno:e.addElement("Target").innerText="SegnoSegno";break;case ke.TargetCoda:e.addElement("Target").innerText="Coda";break;case ke.TargetDoubleCoda:e.addElement("Target").innerText="DoubleCoda";break;case ke.JumpDaCapo:e.addElement("Jump").innerText="DaCapo";break;case ke.JumpDaCapoAlCoda:e.addElement("Jump").innerText="DaCapoAlCoda";break;case ke.JumpDaCapoAlDoubleCoda:e.addElement("Jump").innerText="DaCapoAlDoubleCoda";break;case ke.JumpDaCapoAlFine:e.addElement("Jump").innerText="DaCapoAlFine";break;case ke.JumpDalSegno:e.addElement("Jump").innerText="DaSegno";break;case ke.JumpDalSegnoAlCoda:e.addElement("Jump").innerText="DaSegnoAlCoda";break;case ke.JumpDalSegnoAlDoubleCoda:e.addElement("Jump").innerText="DaSegnoAlDoubleCoda";break;case ke.JumpDalSegnoAlFine:e.addElement("Jump").innerText="DaSegnoAlFine";break;case ke.JumpDalSegnoSegno:e.addElement("Jump").innerText="DaSegnoSegno";break;case ke.JumpDalSegnoSegnoAlCoda:e.addElement("Jump").innerText="DaSegnoSegnoAlCoda";break;case ke.JumpDalSegnoSegnoAlDoubleCoda:e.addElement("Jump").innerText="DaSegnoSegnoAlDoubleCoda";break;case ke.JumpDalSegnoSegnoAlFine:e.addElement("Jump").innerText="DaSegnoSegnoAlFine";break;case ke.JumpDaCoda:e.addElement("Jump").innerText="DaCoda";break;case ke.JumpDaDoubleCoda:e.addElement("Jump").innerText="DaDoubleCoda"}}this.writeFermatas(s,t)}writeFermatas(e,t){const s=t.fermata?.size??0;if(0!==s&&s>0){const s=e.addElement("Fermatas");for(const[e,i]of t.fermata)this.writeFermata(s,e,i)}}writeFermata(e,t,s){let i=-1,a=1;if(t>0)for(;a<10&&(i=t/U.QuarterTime*a,i!==Math.floor(i));)i=-1,a++;else i=0,a=1;if(-1===i)return;const r=e.addElement("Fermata");r.addElement("Type").innerText=Te[s.type],r.addElement("Length").innerText=s.length.toString(),r.addElement("Offset").innerText=`${i}/${a}`}writeBarNode(e,t){const s=e.addElement("Bar");s.attributes.set("id",t.id.toString()),s.addElement("Voices").innerText=t.voices.map((e=>e.isEmpty?"-1":e.id.toString())).join(" "),s.addElement("Clef").innerText=o[t.clef],t.clefOttava!==h.Regular&&(s.addElement("Ottavia").innerText=h[t.clefOttava].substr(1)),t.simileMark!==l.None&&(s.addElement("SimileMark").innerText=l[t.simileMark])}writeVoiceNode(e,t){if(t.isEmpty)return;const s=e.addElement("Voice");s.attributes.set("id",t.id.toString()),s.addElement("Beats").innerText=t.beats.map((e=>e.id)).join(" ")}}pc.MidiProgramInfoLookup=new Map([[0,new uc(dc.Piano,"Acoustic Piano")],[1,new uc(dc.Piano,"Acoustic Piano")],[2,new uc(dc.Piano,"Electric Piano")],[3,new uc(dc.Piano,"Acoustic Piano")],[4,new uc(dc.Piano,"Electric Piano")],[5,new uc(dc.Piano,"Electric Piano")],[6,new uc(dc.Piano,"Harpsichord")],[7,new uc(dc.Piano,"Harpsichord")],[8,new uc(dc.PitchedIdiophone,"Celesta")],[9,new uc(dc.PitchedIdiophone,"Vibraphone")],[10,new uc(dc.PitchedIdiophone,"Vibraphone")],[11,new uc(dc.PitchedIdiophone,"Vibraphone")],[12,new uc(dc.PitchedIdiophone,"Xylophone")],[13,new uc(dc.PitchedIdiophone,"Xylophone")],[14,new uc(dc.PitchedIdiophone,"Vibraphone")],[15,new uc(dc.Banjo,"Banjo")],[16,new uc(dc.Piano,"Electric Organ")],[17,new uc(dc.Piano,"Electric Organ")],[18,new uc(dc.Piano,"Electric Organ")],[19,new uc(dc.Piano,"Electric Organ")],[20,new uc(dc.Piano,"Electric Organ")],[21,new uc(dc.Piano,"Electric Organ")],[22,new uc(dc.Woodwind,"Recorder")],[23,new uc(dc.Piano,"Electric Organ")],[24,new uc(dc.ClassicalGuitar,"Nylon Guitar")],[25,new uc(dc.SteelGuitar,"Steel Guitar")],[26,new uc(dc.SteelGuitar,"Electric Guitar")],[27,new uc(dc.ElectricGuitar,"Electric Guitar")],[28,new uc(dc.ElectricGuitar,"Electric Guitar")],[29,new uc(dc.ElectricGuitar,"Electric Guitar")],[30,new uc(dc.SteelGuitar,"Electric Guitar")],[31,new uc(dc.SteelGuitar,"Electric Guitar")],[32,new uc(dc.Bass,"Acoustic Bass")],[33,new uc(dc.Bass,"Electric Bass")],[34,new uc(dc.Bass,"Electric Bass")],[35,new uc(dc.Bass,"Acoustic Bass")],[36,new uc(dc.Bass,"Electric Bass")],[37,new uc(dc.Bass,"Electric Bass")],[38,new uc(dc.Synth,"Synth Bass")],[39,new uc(dc.Synth,"Synth Bass")],[40,new uc(dc.Strings,"Violin")],[41,new uc(dc.Strings,"Viola")],[42,new uc(dc.Strings,"Cello")],[43,new uc(dc.Strings,"Contrabass")],[44,new uc(dc.Strings,"Violin")],[45,new uc(dc.Strings,"Violin")],[46,new uc(dc.Piano,"Harp")],[47,new uc(dc.Membraphone,"Timpani")],[48,new uc(dc.Strings,"Violin")],[49,new uc(dc.Strings,"Violin")],[50,new uc(dc.Strings,"Violin")],[51,new uc(dc.Strings,"Violin")],[52,new uc(dc.Vocal,"Voice")],[53,new uc(dc.Vocal,"Voice")],[54,new uc(dc.Vocal,"Voice")],[55,new uc(dc.Synth,"Pad Synthesizer")],[56,new uc(dc.Brass,"Trumpet")],[57,new uc(dc.Brass,"Trombone")],[58,new uc(dc.Brass,"Tuba")],[59,new uc(dc.Brass,"Trumpet")],[60,new uc(dc.Brass,"French Horn")],[61,new uc(dc.Brass,"Trumpet")],[62,new uc(dc.Brass,"Trumpet")],[63,new uc(dc.Brass,"Trumpet")],[64,new uc(dc.Reed,"Saxophone")],[65,new uc(dc.Reed,"Saxophone")],[66,new uc(dc.Reed,"Saxophone")],[67,new uc(dc.Reed,"Saxophone")],[68,new uc(dc.Reed,"Oboe")],[69,new uc(dc.Reed,"English Horn")],[70,new uc(dc.Reed,"Bassoon")],[71,new uc(dc.Reed,"Clarinet")],[72,new uc(dc.Reed,"Piccolo")],[73,new uc(dc.Woodwind,"Flute")],[74,new uc(dc.Woodwind,"Recorder")],[75,new uc(dc.Woodwind,"Flute")],[76,new uc(dc.Woodwind,"Recorder")],[77,new uc(dc.Woodwind,"Flute")],[78,new uc(dc.Woodwind,"Recorder")],[79,new uc(dc.Woodwind,"Flute")],[80,new uc(dc.Synth,"Lead Synthesizer")],[81,new uc(dc.Synth,"Lead Synthesizer")],[82,new uc(dc.Synth,"Lead Synthesizer")],[83,new uc(dc.Synth,"Lead Synthesizer")],[84,new uc(dc.Synth,"Lead Synthesizer")],[85,new uc(dc.Synth,"Lead Synthesizer")],[86,new uc(dc.Synth,"Lead Synthesizer")],[87,new uc(dc.Synth,"Lead Synthesizer")],[88,new uc(dc.Synth,"Pad Synthesizer")],[89,new uc(dc.Synth,"Pad Synthesizer")],[90,new uc(dc.Synth,"Pad Synthesizer")],[91,new uc(dc.Synth,"Pad Synthesizer")],[92,new uc(dc.Synth,"Pad Synthesizer")],[93,new uc(dc.Synth,"Pad Synthesizer")],[94,new uc(dc.Synth,"Pad Synthesizer")],[95,new uc(dc.Synth,"Pad Synthesizer")],[96,new uc(dc.Fx,"Pad Synthesizer")],[97,new uc(dc.Fx,"Pad Synthesizer")],[98,new uc(dc.Fx,"Pad Synthesizer")],[99,new uc(dc.Fx,"Pad Synthesizer")],[100,new uc(dc.Fx,"Lead Synthesizer")],[101,new uc(dc.Fx,"Lead Synthesizer")],[102,new uc(dc.Fx,"Lead Synthesizer")],[103,new uc(dc.Fx,"Trumpet")],[104,new uc(dc.ElectricGuitar,"Banjo")],[105,new uc(dc.Banjo,"Banjo")],[106,new uc(dc.Ukulele,"Ukulele")],[107,new uc(dc.Banjo,"Banjo")],[108,new uc(dc.PitchedIdiophone,"Xylophone")],[109,new uc(dc.Reed,"Bassoon")],[110,new uc(dc.Strings,"Violin")],[111,new uc(dc.Woodwind,"Flute")],[112,new uc(dc.PitchedIdiophone,"Xylophone")],[113,new uc(dc.Idiophone,"Celesta")],[114,new uc(dc.PitchedIdiophone,"Vibraphone")],[115,new uc(dc.Idiophone,"Xylophone")],[116,new uc(dc.Membraphone,"Xylophone")],[117,new uc(dc.Membraphone,"Xylophone")],[118,new uc(dc.Membraphone,"Xylophone")],[119,new uc(dc.Idiophone,"Celesta")],[120,new uc(dc.Fx,"Steel Guitar")],[121,new uc(dc.Fx,"Recorder")],[122,new uc(dc.Fx,"Recorder")],[123,new uc(dc.Fx,"Recorder")],[124,new uc(dc.Fx,"Recorder")],[125,new uc(dc.Fx,"Recorder")],[126,new uc(dc.Fx,"Recorder")],[127,new uc(dc.Fx,"Timpani")]]),pc.DrumKitProgramInfo=new uc(dc.PercussionKit,"Drums","drumKit");class gc{static buildCrc32Lookup(){const e=new Uint32Array(256);for(let t=0;t<e.length;t++){let s=t;for(let e=0;e<8;e++)s=1&~s?s>>>1:s>>>1^3988292384;e[t]=s}return e}get value(){return~this._checkValue}constructor(){this._checkValue=gc.CrcInit,this.reset()}update(e,t,s){for(let i=0;i<s;i++)this._checkValue=gc.Crc32Lookup[255&(this._checkValue^e[t+i])]^this._checkValue>>>8}reset(){this._checkValue=gc.CrcInit}}gc.Crc32Lookup=gc.buildCrc32Lookup(),gc.CrcInit=4294967295;class mc{}mc.MAX_WBITS=15,mc.WSIZE=1<<mc.MAX_WBITS,mc.WMASK=mc.WSIZE-1,mc.MIN_MATCH=3,mc.MAX_MATCH=258,mc.DEFAULT_MEM_LEVEL=8,mc.PENDING_BUF_SIZE=1<<mc.DEFAULT_MEM_LEVEL+8,mc.HASH_BITS=mc.DEFAULT_MEM_LEVEL+7,mc.HASH_SIZE=1<<mc.HASH_BITS,mc.HASH_SHIFT=(mc.HASH_BITS+mc.MIN_MATCH-1)/mc.MIN_MATCH,mc.HASH_MASK=mc.HASH_SIZE-1,mc.MIN_LOOKAHEAD=mc.MAX_MATCH+mc.MIN_MATCH+1,mc.MAX_DIST=mc.WSIZE-mc.MIN_LOOKAHEAD;class fc{constructor(e,t,s,i){this.length=null,this.numCodes=0,this.codes=null,this.huffman=e,this.minNumCodes=s,this.maxLength=i,this.freqs=new Int16Array(t),this.bitLengthCounts=new Int32Array(i)}reset(){for(let e=0;e<this.freqs.length;e++)this.freqs[e]=0;this.codes=null,this.length=null}buildTree(){const e=this.freqs.length,t=new Int32Array(e);let s=0,i=0;for(let a=0;a<e;a++){const e=this.freqs[a];if(0!==e){let r=s++;for(;r>0;){const s=Math.floor((r-1)/2);if(!(this.freqs[t[s]]>e))break;t[r]=t[s],r=s}t[r]=a,i=a}}for(;s<2;){const e=i<2?++i:0;t[s++]=e}this.numCodes=Math.max(i+1,this.minNumCodes);const a=s,r=new Int32Array(4*s-2),n=new Int32Array(2*s-1);let o=a;for(let e=0;e<s;e++){const s=t[e];r[2*e]=s,r[2*e+1]=-1,n[e]=this.freqs[s]<<8,t[e]=e}do{const e=t[0];let i=t[--s],a=0,h=1;for(;h<s;)h+1<s&&n[t[h]]>n[t[h+1]]&&h++,t[a]=t[h],a=h,h=2*h+1;let l=n[i];for(;h=a,a>0&&(a=Math.floor((h-1)/2),n[t[a]]>l);)t[h]=t[a];t[h]=i;const c=t[0];i=o++,r[2*i]=e,r[2*i+1]=c;const d=Math.min(255&n[e],255&n[c]);for(l=n[e]+n[c]-d+1,n[i]=l,a=0,h=1;h<s;)h+1<s&&n[t[h]]>n[t[h+1]]&&h++,t[a]=t[h],a=h,h=2*a+1;for(;h=a,h>0&&(a=Math.floor((h-1)/2),n[t[a]]>l);)t[h]=t[a];t[h]=i}while(s>1);this.buildLength(r)}buildLength(e){this.length=new Uint8Array(this.freqs.length);const t=Math.floor(e.length/2),s=Math.floor((t+1)/2);let i=0;for(let e=0;e<this.maxLength;e++)this.bitLengthCounts[e]=0;const a=new Int32Array(t);a[t-1]=0;for(let s=t-1;s>=0;s--)if(-1!==e[2*s+1]){let t=a[s]+1;t>this.maxLength&&(t=this.maxLength,i++),a[e[2*s]]=t,a[e[2*s+1]]=t}else{const t=a[s];this.bitLengthCounts[t-1]++,this.length[e[2*s]]=a[s]}if(0===i)return;let r=this.maxLength-1;do{for(;0===this.bitLengthCounts[--r];);do{this.bitLengthCounts[r]--,this.bitLengthCounts[++r]++,i-=1<<this.maxLength-1-r}while(i>0&&r<this.maxLength-1)}while(i>0);this.bitLengthCounts[this.maxLength-1]+=i,this.bitLengthCounts[this.maxLength-2]-=i;let n=2*s;for(let t=this.maxLength;0!==t;t--){let s=this.bitLengthCounts[t-1];for(;s>0;){const i=2*e[n++];-1===e[i+1]&&(this.length[e[i]]=t,s--)}}}getEncodedLength(){let e=0;for(let t=0;t<this.freqs.length;t++)e+=this.freqs[t]*this.length[t];return e}calcBLFreq(e){let t,s,i,a=-1,r=0;for(;r<this.numCodes;){i=1;const n=this.length[r];for(0===n?(t=138,s=3):(t=6,s=3,a!==n&&(e.freqs[n]++,i=0)),a=n,r++;r<this.numCodes&&a===this.length[r]&&(r++,!(++i>=t)););i<s?e.freqs[a]+=i:0!==a?e.freqs[fc.Repeat3To6]++:i<=10?e.freqs[fc.Repeat3To10]++:e.freqs[fc.Repeat11To138]++}}setStaticCodes(e,t){this.codes=e,this.length=t}buildCodes(){const e=new Int32Array(this.maxLength);let t=0;this.codes=new Int16Array(this.freqs.length);for(let s=0;s<this.maxLength;s++)e[s]=t,t+=this.bitLengthCounts[s]<<15-s;for(let t=0;t<this.numCodes;t++){const s=this.length[t];s>0&&(this.codes[t]=yc.bitReverse(e[s-1]),e[s-1]+=1<<16-s)}}writeTree(e){let t,s,i,a=-1,r=0;for(;r<this.numCodes;){i=1;const n=this.length[r];for(0===n?(t=138,s=3):(t=6,s=3,a!==n&&(e.writeSymbol(n),i=0)),a=n,r++;r<this.numCodes&&a===this.length[r]&&(r++,!(++i>=t)););if(i<s)for(;i-- >0;)e.writeSymbol(a);else 0!==a?(e.writeSymbol(fc.Repeat3To6),this.huffman.pending.writeBits(i-3,2)):i<=10?(e.writeSymbol(fc.Repeat3To10),this.huffman.pending.writeBits(i-3,3)):(e.writeSymbol(fc.Repeat11To138),this.huffman.pending.writeBits(i-11,7))}}writeSymbol(e){this.huffman.pending.writeBits(65535&this.codes[e],this.length[e])}}fc.Repeat3To6=16,fc.Repeat3To10=17,fc.Repeat11To138=18;class yc{static staticInit(){let e=0;for(;e<144;)yc.staticLCodes[e]=yc.bitReverse(48+e<<8),yc.staticLLength[e++]=8;for(;e<256;)yc.staticLCodes[e]=yc.bitReverse(256+e<<7),yc.staticLLength[e++]=9;for(;e<280;)yc.staticLCodes[e]=yc.bitReverse(-256+e<<9),yc.staticLLength[e++]=7;for(;e<yc.LITERAL_NUM;)yc.staticLCodes[e]=yc.bitReverse(-88+e<<8),yc.staticLLength[e++]=8;for(e=0;e<yc.DIST_NUM;e++)yc.staticDCodes[e]=yc.bitReverse(e<<11),yc.staticDLength[e]=5}static bitReverse(e){return yc.bit4Reverse[15&e]<<12|yc.bit4Reverse[e>>4&15]<<8|yc.bit4Reverse[e>>8&15]<<4|yc.bit4Reverse[e>>12]}constructor(e){this.last_lit=0,this.extra_bits=0,this.pending=e,this.literalTree=new fc(this,yc.LITERAL_NUM,257,15),this.distTree=new fc(this,yc.DIST_NUM,1,15),this.blTree=new fc(this,yc.BITLEN_NUM,4,7),this.d_buf=new Int16Array(yc.BUFSIZE),this.l_buf=new Uint8Array(yc.BUFSIZE)}isFull(){return this.last_lit>=yc.BUFSIZE}reset(){this.last_lit=0,this.extra_bits=0,this.literalTree.reset(),this.distTree.reset(),this.blTree.reset()}flushStoredBlock(e,t,s,i){this.pending.writeBits((yc.STORED_BLOCK<<1)+(i?1:0),3),this.pending.alignToByte(),this.pending.writeShort(s),this.pending.writeShort(~s),this.pending.writeBlock(e,t,s),this.reset()}flushBlock(e,t,s,i){this.literalTree.freqs[yc.EOF_SYMBOL]++,this.literalTree.buildTree(),this.distTree.buildTree(),this.literalTree.calcBLFreq(this.blTree),this.distTree.calcBLFreq(this.blTree),this.blTree.buildTree();let a=4;for(let e=18;e>a;e--)this.blTree.length[yc.BL_ORDER[e]]>0&&(a=e+1);let r=14+3*a+this.blTree.getEncodedLength()+this.literalTree.getEncodedLength()+this.distTree.getEncodedLength()+this.extra_bits,n=this.extra_bits;for(let e=0;e<yc.LITERAL_NUM;e++)n+=this.literalTree.freqs[e]*yc.staticLLength[e];for(let e=0;e<yc.DIST_NUM;e++)n+=this.distTree.freqs[e]*yc.staticDLength[e];r>=n&&(r=n),t>=0&&s+4<r>>3?this.flushStoredBlock(e,t,s,i):r===n?(this.pending.writeBits((yc.STATIC_TREES<<1)+(i?1:0),3),this.literalTree.setStaticCodes(yc.staticLCodes,yc.staticLLength),this.distTree.setStaticCodes(yc.staticDCodes,yc.staticDLength),this.compressBlock(),this.reset()):(this.pending.writeBits((yc.DYN_TREES<<1)+(i?1:0),3),this.sendAllTrees(a),this.compressBlock(),this.reset())}sendAllTrees(e){this.blTree.buildCodes(),this.literalTree.buildCodes(),this.distTree.buildCodes(),this.pending.writeBits(this.literalTree.numCodes-257,5),this.pending.writeBits(this.distTree.numCodes-1,5),this.pending.writeBits(e-4,4);for(let t=0;t<e;t++)this.pending.writeBits(this.blTree.length[yc.BL_ORDER[t]],3);this.literalTree.writeTree(this.blTree),this.distTree.writeTree(this.blTree)}compressBlock(){for(let e=0;e<this.last_lit;e++){const t=255&this.l_buf[e];let s=this.d_buf[e];if(0!=s--){const e=yc.Lcode(t);this.literalTree.writeSymbol(e);let i=Math.floor((e-261)/4);i>0&&i<=5&&this.pending.writeBits(t&(1<<i)-1,i);const a=yc.Dcode(s);this.distTree.writeSymbol(a),i=Math.floor(a/2)-1,i>0&&this.pending.writeBits(s&(1<<i)-1,i)}else this.literalTree.writeSymbol(t)}this.literalTree.writeSymbol(yc.EOF_SYMBOL)}tallyDist(e,t){this.d_buf[this.last_lit]=e,this.l_buf[this.last_lit++]=t-3;const s=yc.Lcode(t-3);this.literalTree.freqs[s]++,s>=265&&s<285&&(this.extra_bits+=Math.floor((s-261)/4));const i=yc.Dcode(e-1);return this.distTree.freqs[i]++,i>=4&&(this.extra_bits+=Math.floor(i/2)-1),this.isFull()}tallyLit(e){return this.d_buf[this.last_lit]=0,this.l_buf[this.last_lit++]=e,this.literalTree.freqs[e]++,this.isFull()}static Lcode(e){if(255===e)return 285;let t=257;for(;e>=8;)t+=4,e>>=1;return t+e}static Dcode(e){let t=0;for(;e>=4;)t+=2,e>>=1;return t+e}}yc.BUFSIZE=1<<mc.DEFAULT_MEM_LEVEL+6,yc.LITERAL_NUM=286,yc.STORED_BLOCK=0,yc.STATIC_TREES=1,yc.DYN_TREES=2,yc.DIST_NUM=30,yc.staticLCodes=new Int16Array(yc.LITERAL_NUM),yc.staticLLength=new Uint8Array(yc.LITERAL_NUM),yc.staticDCodes=new Int16Array(yc.DIST_NUM),yc.staticDLength=new Uint8Array(yc.DIST_NUM),yc.BL_ORDER=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],yc.bit4Reverse=new Uint8Array([0,8,4,12,2,10,6,14,1,9,5,13,3,11,7,15]),yc.BITLEN_NUM=19,yc.EOF_SYMBOL=256,yc.staticInit();class bc{constructor(e){this.maxChain=128,this.niceLength=128,this.goodLength=8,this.insertHashIndex=0,this.lookahead=0,this.inputBuf=null,this.inputOff=0,this.inputEnd=0,this.prevAvailable=!1,this.matchStart=0,this.matchLen=0,this.pending=e,this.huffman=new yc(e),this.inputCrc=new gc,this.window=new Uint8Array(2*mc.WSIZE),this.head=new Int16Array(mc.HASH_SIZE),this.prev=new Int16Array(mc.WSIZE),this.blockStart=1,this.strstart=1}reset(){this.huffman.reset(),this.inputCrc.reset(),this.blockStart=1,this.strstart=1,this.lookahead=0,this.prevAvailable=!1,this.matchLen=mc.MIN_MATCH-1;for(let e=0;e<mc.HASH_SIZE;e++)this.head[e]=0;for(let e=0;e<mc.WSIZE;e++)this.prev[e]=0}updateHash(){this.insertHashIndex=this.window[this.strstart]<<mc.HASH_SHIFT^this.window[this.strstart+1]}needsInput(){return this.inputEnd===this.inputOff}setInput(e,t,s){const i=t+s;this.inputBuf=e,this.inputOff=t,this.inputEnd=i}deflate(e,t){let s;do{this.fillWindow();const i=e&&this.inputOff===this.inputEnd;s=this.deflateSlow(i,t)}while(this.pending.isFlushed&&s);return s}deflateSlow(e,t){if(this.lookahead<mc.MIN_LOOKAHEAD&&!e)return!1;for(;this.lookahead>=mc.MIN_LOOKAHEAD||e;){if(0===this.lookahead)return this.prevAvailable&&this.huffman.tallyLit(255&this.window[this.strstart-1]),this.prevAvailable=!1,this.huffman.flushBlock(this.window,this.blockStart,this.strstart-this.blockStart,t),this.blockStart=this.strstart,!1;this.strstart>=2*mc.WSIZE-mc.MIN_LOOKAHEAD&&this.slideWindow();const e=this.matchStart;let s=this.matchLen;if(this.lookahead>=mc.MIN_MATCH){const e=this.insertString();0!==e&&this.strstart-e<=mc.MAX_DIST&&this.findLongestMatch(e)&&this.matchLen===mc.MIN_MATCH&&this.strstart-this.matchStart>bc.TooFar&&(this.matchLen=mc.MIN_MATCH-1)}if(s>=mc.MIN_MATCH&&this.matchLen<=s){this.huffman.tallyDist(this.strstart-1-e,s),s-=2;do{this.strstart++,this.lookahead--,this.lookahead>=mc.MIN_MATCH&&this.insertString()}while(--s>0);this.strstart++,this.lookahead--,this.prevAvailable=!1,this.matchLen=mc.MIN_MATCH-1}else this.prevAvailable&&this.huffman.tallyLit(255&this.window[this.strstart-1]),this.prevAvailable=!0,this.strstart++,this.lookahead--;if(this.huffman.isFull()){let e=this.strstart-this.blockStart;this.prevAvailable&&e--;const s=t&&0===this.lookahead&&!this.prevAvailable;return this.huffman.flushBlock(this.window,this.blockStart,e,s),this.blockStart+=e,!s}}return!0}findLongestMatch(e){let t,s=this.strstart;const i=s+Math.min(mc.MAX_MATCH,this.lookahead)-1,a=Math.max(s-mc.MAX_DIST,0),r=this.window,n=this.prev;let o=this.maxChain;const h=Math.min(this.niceLength,this.lookahead);if(this.matchLen=Math.max(this.matchLen,mc.MIN_MATCH-1),s+this.matchLen>i)return!1;let l=r[s+this.matchLen-1],c=r[s+this.matchLen];this.matchLen>=this.goodLength&&(o>>=2);do{if(t=e,s=this.strstart,r[t+this.matchLen]===c&&r[t+this.matchLen-1]===l&&r[t]===r[s]&&r[++t]===r[++s]){switch((i-s)%8){case 1:if(r[++s]===r[++t])break;break;case 2:if(r[++s]===r[++t]&&r[++s]===r[++t])break;break;case 3:if(r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t])break;break;case 4:if(r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t])break;break;case 5:if(r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t])break;break;case 6:if(r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t])break;break;case 7:if(r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t])break}if(r[s]===r[t])do{if(s===i){++s,++t;break}}while(r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]&&r[++s]===r[++t]);if(s-this.strstart>this.matchLen){if(this.matchStart=e,this.matchLen=s-this.strstart,this.matchLen>=h)break;l=r[s-1],c=r[s]}e=65535&n[e&mc.WMASK]}}while(e>a&&0!=--o);return this.matchLen>=mc.MIN_MATCH}insertString(){const e=(this.insertHashIndex<<mc.HASH_SHIFT^this.window[this.strstart+(mc.MIN_MATCH-1)])&mc.HASH_MASK,t=this.head[e];return this.prev[this.strstart&mc.WMASK]=t,this.head[e]=this.strstart,this.insertHashIndex=e,65535&t}fillWindow(){if(this.strstart>=mc.WSIZE+mc.MAX_DIST&&this.slideWindow(),this.lookahead<mc.MIN_LOOKAHEAD&&this.inputOff<this.inputEnd){let e=2*mc.WSIZE-this.lookahead-this.strstart;e>this.inputEnd-this.inputOff&&(e=this.inputEnd-this.inputOff),this.window.set(this.inputBuf.subarray(this.inputOff,this.inputOff+e),this.strstart+this.lookahead),this.inputCrc.update(this.inputBuf,this.inputOff,e),this.inputOff+=e,this.lookahead+=e}this.lookahead>=mc.MIN_MATCH&&this.updateHash()}slideWindow(){this.window.set(this.window.subarray(mc.WSIZE,mc.WSIZE+mc.WSIZE),0),this.matchStart-=mc.WSIZE,this.strstart-=mc.WSIZE,this.blockStart-=mc.WSIZE;for(let e=0;e<mc.HASH_SIZE;++e){const t=65535&this.head[e];this.head[e]=t>=mc.WSIZE?t-mc.WSIZE:0}for(let e=0;e<mc.WSIZE;e++){const t=65535&this.prev[e];this.prev[e]=t>=mc.WSIZE?t-mc.WSIZE:0}}}bc.TooFar=4096;class Sc{get isFlushed(){return 0===this._end}constructor(e){this._start=0,this._end=0,this._bits=0,this.bitCount=0,this._buffer=new Uint8Array(e)}reset(){this._start=0,this._end=0,this.bitCount=0}writeShortMSB(e){this._buffer[this._end++]=e>>8&255,this._buffer[this._end++]=255&e}writeShort(e){this._buffer[this._end++]=e,this._buffer[this._end++]=e>>8}writeBlock(e,t,s){this._buffer.set(e.subarray(t,t+s),this._end),this._end+=s}flush(e,t,s){return this.bitCount>=8&&(this._buffer[this._end++]=255&this._bits,this._bits>>=8,this.bitCount-=8),s>this._end-this._start?(s=this._end-this._start,e.set(this._buffer.subarray(this._start,this._start+s),t),this._start=0,this._end=0):(e.set(this._buffer.subarray(this._start,this._start+s),t),this._start+=s),s}writeBits(e,t){this._bits|=e<<this.bitCount,this.bitCount+=t,this.bitCount>=16&&(this._buffer[this._end++]=255&this._bits,this._buffer[this._end++]=this._bits>>8&255,this._bits>>=16,this.bitCount-=16)}alignToByte(){this.bitCount>0&&(this._buffer[this._end++]=255&this._bits,this.bitCount>8&&(this._buffer[this._end++]=this._bits>>8&255)),this._bits=0,this.bitCount=0}}class _c{get inputCrc(){return this._engine.inputCrc.value}constructor(){this._state=0,this._pending=new Sc(mc.PENDING_BUF_SIZE),this._engine=new bc(this._pending),this.reset()}get isNeedingInput(){return this._engine.needsInput()}get isFinished(){return this._state===_c.FinishedState&&this._pending.isFlushed}reset(){this._state=_c.BusyState,this._pending.reset(),this._engine.reset()}setInput(e,t,s){this._engine.setInput(e,t,s)}deflate(e,t,s){const i=s;for(;;){const a=this._pending.flush(e,t,s);if(t+=a,0===(s-=a)||this._state===_c.FinishedState)break;if(!this._engine.deflate(!!(this._state&_c.IsFlushing),!!(this._state&_c.IsFinishing)))switch(this._state){case _c.BusyState:return i-s;case _c.FlushingState:let e=8+(7&-this._pending.bitCount);for(;e>0;)this._pending.writeBits(2,10),e-=10;this._state=_c.BusyState;break;case _c.FinishingState:this._pending.alignToByte(),this._state=_c.FinishedState}}return i-s}finish(){this._state|=_c.IsFlushing|_c.IsFinishing}}_c.IsFlushing=4,_c.IsFinishing=8,_c.BusyState=16,_c.FlushingState=20,_c.FinishingState=28,_c.FinishedState=30;class wc{constructor(e,t,s,i,a){this.entry=e,this.crc32=t,this.localHeaderOffset=s,this.compressionMode=i,this.compressedSize=a}}class Bc{constructor(e){this._centralDirectoryHeaders=[],this._deflater=new _c,this._data=e}writeEntry(e){const t=ds.CompressionMethodDeflate,s=lt.empty(),i=this.compress(s,e.data,t),a=s.toArray(),r=new wc(e,i,this._data.bytesWritten,t,s.length);this._centralDirectoryHeaders.push(r),ht.writeInt32LE(this._data,ds.LocalFileHeaderSignature),ht.writeUInt16LE(this._data,10),ht.writeUInt16LE(this._data,2048),ht.writeUInt16LE(this._data,t),ht.writeInt16LE(this._data,0),ht.writeInt16LE(this._data,0),ht.writeInt32LE(this._data,i),ht.writeInt32LE(this._data,a.length),ht.writeInt32LE(this._data,e.data.length),ht.writeInt16LE(this._data,e.fullName.length),ht.writeInt16LE(this._data,0);const n=ht.stringToBytes(e.fullName);this._data.write(n,0,n.length),this._data.write(a,0,a.length)}compress(e,t,s){if(s!==ds.CompressionMethodDeflate){const s=new gc;return s.update(t,0,t.length),e.write(t,0,t.length),s.value}const i=new Uint8Array(512);for(this._deflater.reset(),this._deflater.setInput(t,0,t.length);!this._deflater.isNeedingInput;){const t=this._deflater.deflate(i,0,i.length);if(t<=0)break;e.write(i,0,t)}for(this._deflater.finish();!this._deflater.isFinished;){const t=this._deflater.deflate(i,0,i.length);if(t<=0)break;e.write(i,0,t)}return this._deflater.inputCrc}end(){const e=this._data.bytesWritten;for(const e of this._centralDirectoryHeaders)this.writeCentralDirectoryHeader(e);const t=this._data.bytesWritten;this.writeEndOfCentralDirectoryRecord(e,t)}writeEndOfCentralDirectoryRecord(e,t){ht.writeInt32LE(this._data,ds.EndOfCentralDirSignature),ht.writeInt16LE(this._data,0),ht.writeInt16LE(this._data,0),ht.writeInt16LE(this._data,this._centralDirectoryHeaders.length),ht.writeInt16LE(this._data,this._centralDirectoryHeaders.length),ht.writeInt32LE(this._data,t-e),ht.writeInt32LE(this._data,e),ht.writeInt16LE(this._data,0)}writeCentralDirectoryHeader(e){ht.writeInt32LE(this._data,ds.CentralFileHeaderSignature),ht.writeUInt16LE(this._data,10),ht.writeUInt16LE(this._data,10),ht.writeUInt16LE(this._data,2048),ht.writeUInt16LE(this._data,e.compressionMode),ht.writeInt16LE(this._data,0),ht.writeInt16LE(this._data,0),ht.writeInt32LE(this._data,e.crc32),ht.writeInt32LE(this._data,e.compressedSize),ht.writeInt32LE(this._data,e.entry.data.length),ht.writeInt16LE(this._data,e.entry.fullName.length),ht.writeInt16LE(this._data,0),ht.writeInt16LE(this._data,0),ht.writeInt16LE(this._data,0),ht.writeInt16LE(this._data,0),ht.writeInt32LE(this._data,0),ht.writeInt32LE(this._data,e.localHeaderOffset);const t=ht.stringToBytes(e.entry.fullName);this._data.write(t,0,t.length)}}const kc=Object.freeze(Object.defineProperty({__proto__:null,Gp7Exporter:class extends cc{get name(){return"Guitar Pro 7"}writeScore(e){j.debug(this.name,"Writing data entries");const t=(new pc).writeXml(e),s=yt.writeForScore(e),i=Pt.writeForScore(e),a=ms.writeForScore(e);j.debug(this.name,"Writing ZIP entries");const r=new Bc(this.data);r.writeEntry(new ds("VERSION",ht.stringToBytes("7.0"))),r.writeEntry(new ds("Content/",new Uint8Array(0))),r.writeEntry(new ds("Content/BinaryStylesheet",s)),r.writeEntry(new ds("Content/PartConfiguration",i)),r.writeEntry(new ds("Content/LayoutConfiguration",a)),r.writeEntry(new ds("Content/score.gpif",ht.stringToBytes(t))),r.end()}},ScoreExporter:cc},Symbol.toStringTag,{value:"Module"}));class Tc extends Cs{constructor(){super(0,0,Ot.EndOfTrack)}writeTo(t){throw new qe(e.AlphaTabErrorType.General,"Deprecated event, serialization not supported")}}var Nc,xc,vc;!function(e){e[e.SequenceNumber=0]="SequenceNumber",e[e.TextEvent=1]="TextEvent",e[e.CopyrightNotice=2]="CopyrightNotice",e[e.SequenceOrTrackName=3]="SequenceOrTrackName",e[e.InstrumentName=4]="InstrumentName",e[e.LyricText=5]="LyricText",e[e.MarkerText=6]="MarkerText",e[e.CuePoint=7]="CuePoint",e[e.PatchName=8]="PatchName",e[e.PortName=9]="PortName",e[e.MidiChannel=32]="MidiChannel",e[e.MidiPort=33]="MidiPort",e[e.EndOfTrack=47]="EndOfTrack",e[e.Tempo=81]="Tempo",e[e.SmpteOffset=84]="SmpteOffset",e[e.TimeSignature=88]="TimeSignature",e[e.KeySignature=89]="KeySignature",e[e.SequencerSpecific=127]="SequencerSpecific"}(Nc||(Nc={}));class Pc extends Tc{get metaStatus(){return Nc.EndOfTrack}}!function(e){e[e.SystemExclusive=240]="SystemExclusive",e[e.MtcQuarterFrame=241]="MtcQuarterFrame",e[e.SongPosition=242]="SongPosition",e[e.SongSelect=243]="SongSelect",e[e.TuneRequest=246]="TuneRequest",e[e.SystemExclusive2=247]="SystemExclusive2"}(xc||(xc={}));class Fc extends Tc{}!function(e){e[e.MetronomeTick=0]="MetronomeTick",e[e.Rest=1]="Rest"}(vc||(vc={}));class Cc extends Fc{constructor(){super(...arguments),this.data=new Uint8Array}get isMetronome(){return!1}get metronomeNumerator(){return-1}get metronomeDurationInTicks(){return-1}get metronomeDurationInMilliseconds(){return-1}get isRest(){return!1}get manufacturerId(){return 0}}Cc.AlphaTabManufacturerId=125;const Ec=Object.freeze(Object.defineProperty({__proto__:null,AlphaSynthMidiFileHandler:cr,AlphaTabMetronomeEvent:Ms,AlphaTabRestEvent:Ls,AlphaTabSysExEvent:Ds,get AlphaTabSystemExclusiveEvents(){return vc},BeatTickLookup:gr,BeatTickLookupItem:pr,ControlChangeEvent:Os,get ControllerType(){return Jt},DeprecatedMidiEvent:Tc,EndOfTrackEvent:zs,MasterBarTickLookup:fr,MasterBarTickLookupTempoChange:mr,MetaDataEvent:class extends Pc{constructor(){super(...arguments),this.data=new Uint8Array}},MetaEvent:Pc,get MetaEventType(){return Nc},MetaNumberEvent:class extends Pc{constructor(){super(...arguments),this.value=0}},Midi20PerNotePitchBendEvent:class extends Tc{constructor(){super(...arguments),this.noteKey=0,this.pitch=0}},MidiEvent:Cs,get MidiEventType(){return Ot},MidiFile:Fs,get MidiFileFormat(){return Rt},MidiFileGenerator:Br,MidiTickLookup:br,MidiTickLookupFindBeatResult:yr,get MidiTickLookupFindBeatResultCursorMode(){return es},MidiTrack:Ps,NoteBendEvent:Gs,NoteEvent:As,NoteOffEvent:Rs,NoteOnEvent:Is,PitchBendEvent:Vs,ProgramChangeEvent:Hs,SystemCommonEvent:Fc,get SystemCommonType(){return xc},SystemExclusiveEvent:Cc,TempoChangeEvent:Ws,TimeSignatureEvent:Es},Symbol.toStringTag,{value:"Module"})),Dc=Object.freeze(Object.defineProperty({__proto__:null,get AccentuationType(){return k},get AccidentalType(){return It},Automation:X,get AutomationType(){return f},Bar:z,get BarLineStyle(){return g},BarStyle:G,get BarSubElement(){return p},get BarreShape(){return me},Beat:Ue,get BeatBeamingMode(){return ye},BeatStyle:ze,get BeatSubElement(){return be},BendPoint:J,get BendStyle(){return y},get BendType(){return b},get BracketExtendMode(){return i},get BrushType(){return S},Chord:Ke,get Clef(){return o},Color:tt,get CrescendoType(){return _},get Direction(){return ke},get Duration(){return w},get DynamicValue(){return m},ElementStyle:W,get FadeType(){return pe},Fermata:ct,get FermataType(){return Te},get Fingers(){return T},Font:oa,get FontStyle(){return Yt},get FontWeight(){return $t},get GolpeType(){return ue},GraceGroup:Z,get GraceType(){return B},get HarmonicType(){return N},HeaderFooterStyle:Xe,InstrumentArticulation:Me,JsonConverter:qa,get KeySignature(){return c},get KeySignatureType(){return d},Lyrics:Qe,MasterBar:K,get MusicFontSymbol(){return ne},Note:Re,get NoteAccidentalMode(){return x},get NoteOrnament(){return le},NoteStyle:Ie,get NoteSubElement(){return ce},get Ottavia(){return h},get PickStroke(){return re},PlaybackInformation:st,get Rasgueado(){return fe},RenderStylesheet:O,RepeatGroup:H,Score:Ye,ScoreStyle:Je,get ScoreSubElement(){return Se},Section:Ze,get SimileMark(){return l},get SlideInType(){return v},get SlideOutType(){return P},Staff:at,SustainPedalMarker:V,get SustainPedalMarkerType(){return u},Track:nt,get TrackNameMode(){return r},get TrackNameOrientation(){return n},get TrackNamePolicy(){return a},TrackStyle:rt,get TrackSubElement(){return Be},get TripletFeel(){return A},Tuning:it,TupletGroup:Oe,get VibratoType(){return F},Voice:te,VoiceStyle:ee,get VoiceSubElement(){return I},get WahPedal(){return ge},get WhammyType(){return de}},Symbol.toStringTag,{value:"Module"})),Mc=Object.freeze(Object.defineProperty({__proto__:null,BarBounds:tr,get BeamDirection(){return Ne},BeatBounds:sr,Bounds:ft,BoundsLookup:nr,MasterBarBounds:ir,NoteBounds:ar,RenderFinishedEventArgs:er,ScoreRenderer:or,StaffSystemBounds:rr},Symbol.toStringTag,{value:"Module"})),Lc=Object.freeze(Object.defineProperty({__proto__:null,CssFontSvgCanvas:tn,Cursors:Yr,FontSizeDefinition:Qa,FontSizes:Za,MeasuredText:De,SvgCanvas:en,get TextAlign(){return oe},get TextBaseline(){return he}},Symbol.toStringTag,{value:"Module"})),Ac=Object.freeze(Object.defineProperty({__proto__:null,ActiveBeatsChangedEventArgs:Dr,AlphaSynth:ia,AlphaSynthAudioWorkletOutput:qr,AlphaSynthScriptProcessorOutput:zr,AlphaSynthWebAudioOutputBase:Gr,AlphaSynthWebWorkerApi:Xr,CircularSampleBuffer:Wr,MidiEventsPlayedEventArgs:ta,PlaybackRange:kr,PlaybackRangeChangedEventArgs:sa,get PlayerState(){return Ht},PlayerStateChangedEventArgs:$s,PositionChangedEventArgs:qs},Symbol.toStringTag,{value:"Module"})),Ic=Object.freeze(Object.defineProperty({__proto__:null},Symbol.toStringTag,{value:"Module"}));nc.isRunningInWorker?nc.initializeWorker():nc.isRunningInAudioWorklet?nc.initializeAudioWorklet():nc.initializeMain((t=>{if(nc.webPlatform===e.WebPlatform.NodeJs)throw new qe(e.AlphaTabErrorType.General,"Workers not yet supported in Node.js");if(nc.webPlatform===e.WebPlatform.BrowserModule||nc.isWebPackBundled||nc.isViteBundled){j.debug("AlphaTab","Creating webworker");try{return new nc.alphaTabWorker(new nc.alphaTabUrl("./alphaTab.worker.ts",{}),{type:"module"})}catch(e){j.debug("AlphaTab","ESM webworker construction with direct URL failed",e)}let e="";try{e=new nc.alphaTabUrl("./alphaTab.worker.ts",{});const t=`import ${JSON.stringify(e)}`,s=new Blob([t],{type:"application/javascript"});return new Worker(URL.createObjectURL(s),{type:"module"})}catch(t){j.debug("AlphaTab","ESM webworker construction with blob import failed",e,t)}try{if(!t.core.scriptFile)throw new Error("Could not detect alphaTab script file");e=t.core.scriptFile;const s=`import ${JSON.stringify(t.core.scriptFile)}`,i=new Blob([s],{type:"application/javascript"});return new Worker(URL.createObjectURL(i),{type:"module"})}catch(e){j.debug("AlphaTab","ESM webworker construction with blob import failed",t.core.scriptFile,e)}}if(!t.core.scriptFile)throw new qe(e.AlphaTabErrorType.General,"Could not detect alphaTab script file, cannot initialize renderer");try{j.debug("AlphaTab","Creating Blob worker");const e=`importScripts('${t.core.scriptFile}')`,s=new Blob([e],{type:"application/javascript"});return new Worker(URL.createObjectURL(s))}catch(e){return j.warning("Rendering","Could not create inline worker, fallback to normal worker"),new Worker(t.core.scriptFile)}}),((t,s)=>{if(nc.webPlatform===e.WebPlatform.NodeJs)throw new qe(e.AlphaTabErrorType.General,"Audio Worklets not yet supported in Node.js");if(nc.webPlatform===e.WebPlatform.BrowserModule||nc.isWebPackBundled||nc.isViteBundled){j.debug("AlphaTab","Creating Module worklet");return t.audioWorklet.addModule(new nc.alphaTabUrl("./alphaTab.worklet.ts",{}))}return j.debug("AlphaTab","Creating Script worklet"),t.audioWorklet.addModule(s.core.scriptFile)})),e.AlphaTabApi=Qr,e.AlphaTabApiBase=Lr,e.AlphaTabError=qe,e.ConsoleLogger=q,e.CoreSettings=oc,e.DisplaySettings=la,e.Environment=nc,e.FileLoadError=Ar,e.FormatError=et,e.ImporterSettings=ca,e.Logger=j,e.NotationSettings=Y,e.PlayerSettings=pa,e.ProgressEventArgs=Ur,e.RenderEngineFactory=rc,e.RenderingResources=ha,e.ResizeEventArgs=Er,e.Settings=ka,e.SlidePlaybackSettings=ua,e.VibratoPlaybackSettings=da,e.exporter=kc,e.importer=hc,e.io=lc,e.json=Ic,e.meta=ic,e.midi=Ec,e.model=Dc,e.platform=Lc,e.rendering=Mc,e.synth=Ac,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
